// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TagGenerator.java

package flex.bootstrap;

import java.io.*;
import java.lang.reflect.Method;
import java.util.HashSet;

public class TagGenerator
{
    private static class MethodKey
    {

        public boolean equals(Object obj)
        {
            if(!(obj instanceof MethodKey))
                return false;
            MethodKey other = (MethodKey)obj;
            if(!name.equals(other.name))
                return false;
            if(paramTypes.length != other.paramTypes.length)
                return false;
            for(int i = 0; i < paramTypes.length; i++)
                if(paramTypes[i] != other.paramTypes[i])
                    return false;

            return true;
        }

        public int hashCode()
        {
            int c = name.hashCode();
            for(int i = 0; i < paramTypes.length; i++)
                c ^= paramTypes[i].hashCode();

            return c;
        }

        public String toString()
        {
            return method.toString();
        }

        Method method;
        String name;
        Class paramTypes[];

        public MethodKey(Method method)
        {
            this.method = method;
            name = method.getName();
            paramTypes = method.getParameterTypes();
        }
    }


    public TagGenerator()
    {
    }

    public static void main(String args[])
        throws ClassNotFoundException, IOException
    {
        String destdir;
        int i;
        if(args.length < 2)
        {
            System.err.println("usage: TagGenerator destdir class1 class2 ...");
            System.exit(1);
        }
        destdir = args[0];
        i = 1;
_L2:
        Class api;
        PrintWriter out;
        if(i >= args.length)
            break; /* Loop/switch isn't completed */
        String className = args[i];
        api = Class.forName(className);
        String filename = className.replace('.', '/') + "Impl.java";
        String pkgdir = filename.substring(0, filename.lastIndexOf('/'));
        (new File(destdir, pkgdir)).mkdirs();
        System.out.println("generating " + filename);
        out = new PrintWriter(new FileWriter(new File(destdir, filename)));
        generateTag(api, out);
        out.flush();
        out.close();
        break MISSING_BLOCK_LABEL_179;
        Exception exception;
        exception;
        out.close();
        throw exception;
        i++;
        if(true) goto _L2; else goto _L1
_L1:
    }

    private static void generateTag(Class api, PrintWriter out)
    {
        String implName = api.getName() + "Impl";
        String packageName = implName.substring(0, implName.lastIndexOf('.'));
        String className = implName.substring(implName.lastIndexOf('.') + 1);
        HashSet done = new HashSet();
        Class baseImpl;
        Class baseApi;
        if((javax.servlet.jsp.tagext.BodyTag.class).isAssignableFrom(api))
        {
            baseImpl = flex.bootstrap.BootstrapBodyTag.class;
            baseApi = javax.servlet.jsp.tagext.BodyTag.class;
        } else
        {
            baseImpl = flex.bootstrap.BootstrapTag.class;
            baseApi = javax.servlet.jsp.tagext.Tag.class;
        }
        out.println("package " + packageName + ";");
        out.println("public class " + className + " extends " + baseImpl.getName());
        out.println("   implements " + api.getName());
        out.println("{");
        String tagName = createTagName(api);
        out.println(api.getName() + " " + tagName + " = (" + api.getName() + ") tag;");
        Method methods[] = api.getMethods();
        for(int i = 0; i < methods.length; i++)
        {
            MethodKey key = new MethodKey(methods[i]);
            try
            {
                if(!done.contains(key))
                    baseApi.getMethod(key.name, key.paramTypes);
                continue;
            }
            catch(NoSuchMethodException e)
            {
                generateMethod(out, methods[i], tagName);
            }
            done.add(key);
        }

        out.println("}");
    }

    private static void generateMethod(PrintWriter out, Method method, String tagName)
    {
        out.print("public ");
        Class returnType = method.getReturnType();
        out.print(returnType.getName());
        out.print(" ");
        out.print(method.getName());
        out.print("(");
        Class params[] = method.getParameterTypes();
        for(int i = 0; i < params.length; i++)
        {
            if(i > 0)
                out.print(", ");
            out.print(params[i].getName());
            out.print(" p");
            out.print(i);
        }

        out.println(")");
        Class exceptionTypes[] = method.getExceptionTypes();
        if(exceptionTypes.length > 0)
        {
            out.print(" throws ");
            for(int i = 0; i < exceptionTypes.length; i++)
            {
                if(i > 0)
                    out.print(", ");
                out.print(exceptionTypes[i].getName());
            }

        }
        out.println("{");
        out.println("  Thread thread = Thread.currentThread();");
        out.println("  ClassLoader oldLoader = thread.getContextClassLoader();");
        out.println("  thread.setContextClassLoader(bootstrap);");
        out.println("  try {");
        out.print("    ");
        if(returnType != Void.TYPE)
            out.print("return ");
        out.print(tagName);
        out.print(".");
        out.print(method.getName());
        out.print("(");
        for(int i = 0; i < params.length; i++)
        {
            if(i > 0)
                out.print(", ");
            out.print("p");
            out.print(i);
        }

        out.println(");");
        out.println("  } finally {");
        out.println("    thread.setContextClassLoader(oldLoader);");
        out.println("  }");
        out.println("}");
    }

    private static String createTagName(Class api)
    {
        String name = api.getName();
        StringBuffer b = new StringBuffer(name);
        b.delete(0, name.lastIndexOf('.') + 1);
        b.setCharAt(0, Character.toLowerCase(b.charAt(0)));
        return b.toString();
    }
}
