// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DataDestination.java

package flex.data;

import flex.data.config.AssociationSetting;
import flex.data.config.DataNetworkSettings;
import flex.data.config.MetadataSettings;
import flex.data.messages.DataMessage;
import flex.management.runtime.data.DataDestinationControl;
import flex.messaging.*;
import flex.messaging.config.*;
import flex.messaging.io.*;
import flex.messaging.io.amf.ASObject;
import flex.messaging.services.Service;
import flex.messaging.util.ClassUtil;
import java.util.*;

// Referenced classes of package flex.data:
//            DataServiceException, DataService, SequenceManager

public class DataDestination extends MessageDestination
{
    static class ReferencedIdsKey
    {

        public boolean equals(Object other)
        {
            ReferencedIdsKey otherKey = (ReferencedIdsKey)other;
            return dest.getSequenceManager().compareIdsInItems(otherKey.item, item) && otherKey.dest == dest;
        }

        public int hashCode()
        {
            return dest.getSequenceManager().idHashCode(item) * 13 + dest.hashCode();
        }

        Object item;
        DataDestination dest;

        ReferencedIdsKey(DataDestination dest, Object item)
        {
            this.item = item;
            this.dest = dest;
        }
    }


    public DataDestination(Service service, DestinationSettings settings)
    {
        this(service, settings, service.isManaged());
    }

    public DataDestination(Service service, DestinationSettings settings, boolean enableManagement)
    {
        super(service, settings, enableManagement);
        serializationDescriptorSet = false;
        lazyAssociationsSet = false;
        readOnlyPropertiesSet = false;
        needsReferencedIdsSet = false;
    }

    public static DataDestination getDataDestination(String serverId, String destinationName)
    {
        MessageBroker broker = MessageBroker.getMessageBroker(serverId);
        if(broker == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10163, new Object[] {
                serverId
            });
            throw dse;
        }
        DataService ds = (DataService)broker.getServiceByType("flex.data.DataService");
        if(ds == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10164, new Object[] {
                serverId
            });
            throw dse;
        } else
        {
            return (DataDestination)ds.getDestinationByName(destinationName);
        }
    }

    public static DataDestination getDataDestination(String destinationName)
    {
        MessageBroker broker = FlexContext.getMessageBroker();
        if(broker == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10168);
            throw dse;
        }
        DataService ds = (DataService)broker.getServiceByType("flex.data.DataService");
        if(ds == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10164, new Object[] {
                "(current)"
            });
            throw dse;
        } else
        {
            return (DataDestination)ds.getDestinationByName(destinationName);
        }
    }

    protected void init(DestinationSettings settings)
    {
        dataNetworkSettings = new DataNetworkSettings();
        metadataSettings = new MetadataSettings();
        super.init(settings);
        ConfigMap properties = settings.getProperties();
        configurePaging(properties);
        configureMetadata(properties);
        configurePropertySettings(properties);
        configureItemClass(properties);
        sequenceManager = new SequenceManager(this);
        properties.allowProperty("use-transactions");
        properties.allowProperty("auto-sync-enabled");
    }

    public NetworkSettings getNetworkSettings()
    {
        return dataNetworkSettings;
    }

    public MetadataSettings getPropertySettings()
    {
        return metadataSettings;
    }

    SequenceManager getSequenceManager()
    {
        return sequenceManager;
    }

    SerializationDescriptor getSerializationDescriptor()
    {
        return getSerializationDescriptor(((Map) (new HashMap())));
    }

    public void setCacheItems(boolean ci)
    {
        cacheItems = ci;
    }

    public boolean getCacheItems()
    {
        return cacheItems;
    }

    SerializationDescriptor getSerializationDescriptor(Map pending)
    {
        if(!serializationDescriptorSet)
        {
            boolean hasExcludes = false;
            if(pending.get(getId()) != null)
                return (SerializationDescriptor)pending.get(getId());
            SerializationDescriptor desc = new SerializationDescriptor();
            pending.put(getId(), desc);
            List associations = getPropertySettings().getAssociationSettings();
            List excludes = new ArrayList();
            for(int i = 0; i < associations.size(); i++)
            {
                AssociationSetting assoc = (AssociationSetting)associations.get(i);
                if(assoc.getLazy())
                {
                    hasExcludes = true;
                    excludes.add(assoc.getProperty());
                    continue;
                }
                String nestedDestName = assoc.getDestination();
                DataDestination nestedDestination = getDestination(nestedDestName);
                SerializationDescriptor nestedDesc = nestedDestination.getSerializationDescriptor(pending);
                if(nestedDesc != null)
                {
                    hasExcludes = true;
                    desc.put(assoc.getProperty(), nestedDesc);
                }
            }

            if(hasExcludes)
            {
                desc.setExcludes(excludes);
                serializationDescriptor = desc;
            }
            serializationDescriptorSet = true;
        }
        return serializationDescriptor;
    }

    public AssociationSetting getAssociation(String propertyName)
    {
        List associations = getPropertySettings().getAssociationSettings();
        for(int i = 0; i < associations.size(); i++)
        {
            AssociationSetting assoc = (AssociationSetting)associations.get(i);
            if(assoc.getProperty().equals(propertyName))
                return assoc;
        }

        return null;
    }

    public void addAssociation(AssociationSetting setting)
    {
        if(serializationDescriptorSet || lazyAssociationsSet || readOnlyPropertiesSet || needsReferencedIdsSet)
            serializationDescriptorSet = lazyAssociationsSet = readOnlyPropertiesSet = needsReferencedIdsSet = false;
        getPropertySettings().addAssociationSetting(setting);
        numSequencedAssociations++;
    }

    public List getAssociations()
    {
        return getPropertySettings().getAssociationSettings();
    }

    List getLazyAssociations()
    {
        if(!lazyAssociationsSet)
        {
            List lazyAssocs = null;
            List associations = getPropertySettings().getAssociationSettings();
            int nonlazy = 0;
            for(int i = 0; i < associations.size(); i++)
            {
                AssociationSetting assoc = (AssociationSetting)associations.get(i);
                if(assoc.getLazy())
                {
                    if(lazyAssocs == null)
                        lazyAssocs = new ArrayList();
                    lazyAssocs.add(assoc);
                } else
                {
                    nonlazy++;
                }
                if(assoc.getDestination().equals(getId()))
                    hasSelfAssociations = true;
            }

            lazyAssociations = lazyAssocs;
            lazyAssociationsSet = true;
            numNonLazyAssociations = nonlazy;
        }
        return lazyAssociations;
    }

    int getNumSequencedAssociations()
    {
        return numSequencedAssociations;
    }

    int getNumNonLazyAssociations()
    {
        if(!lazyAssociationsSet)
            getLazyAssociations();
        return numNonLazyAssociations;
    }

    public List getReadOnlyProperties()
    {
        if(!readOnlyPropertiesSet)
        {
            List readOnlyProps = null;
            List associations = getPropertySettings().getAssociationSettings();
            for(int i = 0; i < associations.size(); i++)
            {
                AssociationSetting assoc = (AssociationSetting)associations.get(i);
                if(!assoc.getReadOnly())
                    continue;
                if(readOnlyProps == null)
                    readOnlyProps = new ArrayList();
                readOnlyProps.add(assoc.getProperty());
            }

            readOnlyProperties = readOnlyProps;
            readOnlyPropertiesSet = true;
        }
        return readOnlyProperties;
    }

    public boolean getNeedsReferencedIds()
    {
        if(getLazyAssociations() != null)
            return true;
        if(!needsReferencedIdsSet)
        {
            needsReferencedIds = computeNeedsReferencedIds(new HashMap());
            needsReferencedIdsSet = true;
        }
        return needsReferencedIds;
    }

    public Map getReferencedIds(Object item)
    {
        return getReferencedIds(item, ((Map) (new HashMap(13))));
    }

    public Map getReferencedIds(Object item, Map pendingReferencedIds)
    {
        List assocs = getAssociations();
        if(assocs == null)
            return null;
        ReferencedIdsKey key = new ReferencedIdsKey(this, item);
        Map result = (Map)pendingReferencedIds.get(key);
        if(result != null)
            return result;
        result = new TreeMap();
        pendingReferencedIds.put(key, result);
        for(int i = 0; i < assocs.size(); i++)
        {
            AssociationSetting assoc = (AssociationSetting)assocs.get(i);
            Object propValue = DataService.getPropertyOnClientObject(item, assoc.getProperty());
            DataDestination nestedDest = getDestination(assoc.getDestination());
            if(assoc.getLazy())
            {
                if(assoc.isMulti())
                {
                    if(propValue == null)
                        propValue = new ArrayList();
                    Collection c = (Collection)propValue;
                    Object ids[] = new Object[c.size()];
                    int j = 0;
                    for(Iterator it = c.iterator(); it.hasNext();)
                    {
                        ids[j] = nestedDest.getSequenceManager().getIdentityForInstance(it.next());
                        j++;
                    }

                    result.put(assoc.getProperty(), ((Object) (ids)));
                    continue;
                }
                if(propValue != null)
                    result.put(assoc.getProperty(), nestedDest.getSequenceManager().getIdentityForInstance(propValue));
                continue;
            }
            if(!nestedDest.getNeedsReferencedIds())
                continue;
            if(assoc.isMulti())
            {
                if(propValue == null)
                    propValue = new ArrayList();
                Collection c = (Collection)propValue;
                Object subRefIds[] = new Object[c.size()];
                int j = 0;
                for(Iterator it = c.iterator(); it.hasNext();)
                {
                    subRefIds[j] = nestedDest.getReferencedIds(it.next(), pendingReferencedIds);
                    j++;
                }

                result.put(assoc.getProperty(), ((Object) (subRefIds)));
                continue;
            }
            if(propValue != null)
                result.put(assoc.getProperty(), nestedDest.getReferencedIds(propValue, pendingReferencedIds));
        }

        return result;
    }

    public Object getItemFromAdapter(Map identity)
    {
        DataMessage dmsg = new DataMessage();
        dmsg.setDestination(getId());
        dmsg.setOperation(2);
        dmsg.setIdentity(identity);
        return ((DataService)getService()).sendMessageToAdapter(dmsg);
    }

    public Object getTypedItem(Object item, TypeMarshaller marshaller)
    {
        item = unwrapItem(item);
        if(itemClass != null && item != null && (item instanceof ASObject))
        {
            ((ASObject)item).setType(itemClass.getName());
            item = marshaller.convert(item, itemClass);
        }
        return item;
    }

    public static Object unwrapItem(Object item)
    {
        if(item instanceof PropertyProxy)
            item = ((PropertyProxy)item).getDefaultInstance();
        return item;
    }

    public Object wrapItem(Object item)
    {
        if(item == null)
            return null;
        item = unwrapItem(item);
        SerializationDescriptor desc = getSerializationDescriptor();
        if(desc != null)
        {
            PropertyProxy proxy = PropertyProxyRegistry.getProxyAndRegister(item);
            proxy = (PropertyProxy)proxy.clone();
            proxy.setDefaultInstance(item);
            proxy.setDescriptor(desc);
            return proxy;
        } else
        {
            return item;
        }
    }

    protected void configureMetadata(ConfigMap properties)
    {
        ConfigMap metadata = properties.getPropertyAsMap("metadata", null);
        if(metadata != null)
        {
            List identities = metadata.getPropertyAsList("identity", null);
            if(identities != null)
            {
                Iterator it = identities.iterator();
                boolean usingPropertyTypes = false;
                do
                {
                    if(!it.hasNext())
                        break;
                    Object o = it.next();
                    String identityName = null;
                    String identityType = null;
                    if(o instanceof String)
                        identityName = (String)o;
                    else
                    if(o instanceof ConfigMap)
                    {
                        identityName = ((ConfigMap)o).getPropertyAsString("property", null);
                        identityType = ((ConfigMap)o).getPropertyAsString("type", null);
                    }
                    if(identityName != null)
                    {
                        if(identityName.indexOf(",") != -1)
                        {
                            DataServiceException dse = new DataServiceException();
                            dse.setMessage(10159, new Object[] {
                                identityName
                            });
                            throw dse;
                        }
                        if(identityType == null)
                        {
                            metadataSettings.addIdentityPropertyName(identityName);
                        } else
                        {
                            metadataSettings.addIdentityPropertyNameAndType(identityName, identityType, this);
                            usingPropertyTypes = true;
                        }
                    }
                } while(true);
                if(usingPropertyTypes && metadataSettings.getIdentityPropertyTypes().size() != metadataSettings.getIdentityPropertyNames().size())
                {
                    DataServiceException dse = new DataServiceException();
                    dse.setMessage(10167, new Object[] {
                        id
                    });
                    throw dse;
                }
            }
            if(metadataSettings.getIdentityPropertyNames().size() < 1)
            {
                DataServiceException dse = new DataServiceException();
                dse.setMessage(10157, new Object[] {
                    id
                });
                throw dse;
            }
            configureAssociation(metadata, "one-to-many");
            configureAssociation(metadata, "many-to-many");
            configureAssociation(metadata, "one-to-one");
            configureAssociation(metadata, "many-to-one");
        } else
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10157, new Object[] {
                id
            });
            throw dse;
        }
    }

    protected void configurePropertySettings(ConfigMap properties)
    {
        String cacheItemsStr = properties.getPropertyAsString("cache-items", null);
        if(cacheItemsStr != null)
            setCacheItems(cacheItemsStr.equalsIgnoreCase("true"));
        else
            setCacheItems(true);
    }

    boolean hasSelfAssociations()
    {
        if(!lazyAssociationsSet)
            getLazyAssociations();
        return hasSelfAssociations;
    }

    private DataDestination getDestination(String destName)
    {
        return (DataDestination)((DataService)getService()).getDestinationByName(destName);
    }

    private boolean computeNeedsReferencedIds(Map visited)
    {
        if(getLazyAssociations() != null)
            return true;
        if(visited.get(this) != null)
            return false;
        visited.put(this, Boolean.TRUE);
        List associations;
        int i;
        associations = getPropertySettings().getAssociationSettings();
        i = 0;
_L1:
        boolean flag;
        if(i >= associations.size())
            break MISSING_BLOCK_LABEL_104;
        AssociationSetting assoc = (AssociationSetting)associations.get(i);
        DataDestination nestedDest = getDestination(assoc.getDestination());
        if(!nestedDest.computeNeedsReferencedIds(visited))
            break MISSING_BLOCK_LABEL_98;
        flag = true;
        visited.remove(this);
        return flag;
        i++;
          goto _L1
        visited.remove(this);
        break MISSING_BLOCK_LABEL_128;
        Exception exception;
        exception;
        visited.remove(this);
        throw exception;
        return false;
    }

    private void configureAssociation(ConfigMap metadata, String relationType)
    {
        List references = metadata.getPropertyAsList(relationType, null);
        if(references != null)
        {
            Iterator it = references.iterator();
            do
            {
                if(!it.hasNext())
                    break;
                Object ref = it.next();
                if(ref instanceof ConfigMap)
                {
                    ConfigMap refMap = (ConfigMap)ref;
                    String name = refMap.getPropertyAsString("property", null);
                    String assocDest = refMap.getPropertyAsString("destination", null);
                    if(assocDest == null || name == null)
                    {
                        ConfigurationException cfg = new ConfigurationException();
                        ConfigurationException ex = new ConfigurationException();
                        ex.setMessage(10518, new Object[] {
                            getId(), name, assocDest
                        });
                        throw ex;
                    }
                    boolean lazy = refMap.getPropertyAsBoolean("lazy", false);
                    boolean sequenced = refMap.getPropertyAsBoolean("sequenced", true);
                    boolean readOnly = refMap.getPropertyAsBoolean("read-only", false);
                    boolean cacheReferencedItems = refMap.getPropertyAsBoolean("cache-referenced-items", !lazy);
                    if(name != null && assocDest != null)
                        addAssociation(new AssociationSetting(relationType, name, assocDest, lazy, sequenced, readOnly, cacheReferencedItems));
                }
            } while(true);
        }
    }

    protected void configurePaging(ConfigMap properties)
    {
        ConfigMap network = properties.getPropertyAsMap("network", null);
        if(network != null)
        {
            ConfigMap paging = network.getPropertyAsMap("paging", null);
            if(paging != null)
            {
                boolean pagingEnabled = paging.getPropertyAsBoolean("enabled", false);
                dataNetworkSettings.setPagingEnabled(pagingEnabled);
                if(pagingEnabled)
                {
                    int pageSize = paging.getPropertyAsInt("pageSize", -1);
                    dataNetworkSettings.setPageSize(pageSize);
                } else
                {
                    paging.allowProperty("pageSize");
                }
            }
        }
    }

    public String toString()
    {
        StringBuffer sb = new StringBuffer("DataDestination: ");
        sb.append(metadataSettings.toString());
        sb.append(dataNetworkSettings.toString());
        sb.append(super.toString());
        return sb.toString();
    }

    protected void setupDestinationControl(Service service)
    {
        controller = new DataDestinationControl(getId(), this, service.getControl());
        controller.register();
        setControl(controller);
    }

    protected void configureItemClass(ConfigMap properties)
    {
        String itemClassName = properties.getProperty("item-class");
        if(itemClassName != null)
            itemClass = ClassUtil.createClass(itemClassName);
    }

    private static final String METADATA = "metadata";
    private static final String IDENTITY = "identity";
    private static final String PROPERTY = "property";
    private static final String TYPE = "type";
    private static final String ONE_TO_MANY = "one-to-many";
    private static final String MANY_TO_MANY = "many-to-many";
    private static final String ONE_TO_ONE = "one-to-one";
    private static final String MANY_TO_ONE = "many-to-one";
    private static final String CACHE_ITEMS = "cache-items";
    private static final String DESTINATION = "destination";
    private static final String LAZY = "lazy";
    public static final String USE_TRANSACTIONS = "use-transactions";
    private static final String AUTO_SYNC_ENABLED = "auto-sync-enabled";
    private static final String ITEM_CLASS = "item-class";
    private DataNetworkSettings dataNetworkSettings;
    private MetadataSettings metadataSettings;
    private SequenceManager sequenceManager;
    private DataDestinationControl controller;
    private boolean serializationDescriptorSet;
    private SerializationDescriptor serializationDescriptor;
    private boolean lazyAssociationsSet;
    private List lazyAssociations;
    private int numNonLazyAssociations;
    private boolean readOnlyPropertiesSet;
    private List readOnlyProperties;
    private boolean cacheItems;
    private int numSequencedAssociations;
    private boolean needsReferencedIds;
    private boolean needsReferencedIdsSet;
    private Class itemClass;
    private boolean hasSelfAssociations;
}
