// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DataService.java

package flex.data;

import flex.data.config.AssociationSetting;
import flex.data.messages.DataAssociationMessage;
import flex.data.messages.DataMessage;
import flex.data.messages.SequencedMessage;
import flex.data.messages.UpdateCollectionMessage;
import flex.management.BaseControl;
import flex.management.runtime.data.DataServiceControl;
import flex.messaging.*;
import flex.messaging.cluster.ClusterManager;
import flex.messaging.config.DestinationSettings;
import flex.messaging.config.ServiceSettings;
import flex.messaging.io.PropertyProxy;
import flex.messaging.io.PropertyProxyRegistry;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.*;
import flex.messaging.services.MessageService;
import flex.messaging.services.ServiceAdapter;
import flex.messaging.util.*;
import java.lang.reflect.InvocationTargetException;
import java.util.*;

// Referenced classes of package flex.data:
//            DataDestination, DataServiceTransaction, DataServiceException, MessageBatch, 
//            UpdateCollectionRange, AssociatedItemIndex, SequenceManager

public class DataService extends MessageService
{

    public DataService(MessageBroker broker, ServiceSettings settings)
    {
        this(broker, settings, broker.isManaged());
    }

    public DataService(MessageBroker broker, ServiceSettings settings, boolean enableManagement)
    {
        super(broker, settings, enableManagement);
        serverClientId = null;
        messageIdCounter = 0;
        messageIdSync = new Object();
    }

    public void createDestination(DestinationSettings destSettings)
    {
        DataDestination dest = new DataDestination(this, destSettings);
        destinations.put(dest.getId(), dest);
        dest.initDestination();
        if(isManaged() && dest.isManaged())
            controller.addDestination(dest.getControl().getObjectName());
    }

    public void sendPeerSyncAndPush(List messages)
    {
        if(Log.isDebug())
            Log.getLogger("DataService.General").debug("Sending messages to clustered peer servers: " + messages);
        ClusterManager clm = broker.getClusterManager();
        DataMessage message = (DataMessage)messages.get(0);
        clm.invokeServiceOperation(getClass().getName(), message.getDestination(), "peerSyncAndPush", new Object[] {
            messages
        });
    }

    public void peerSyncAndPush(List messages)
    {
        DataServiceTransaction dtx;
        FlexContext.setMessageFromPeer(true);
        dtx = new DataServiceTransaction(this);
        dtx.setPushFromPeer(true);
        for(int i = 0; i < messages.size(); i++)
        {
            DataMessage message = (DataMessage)messages.get(i);
            DataDestination destination = (DataDestination)getDestination(message);
            if(Log.isDebug())
                Log.getLogger("DataService.General").debug("Received message from clustered peer server.  shared-backend=" + destination.isBackendShared() + " message=" + message);
            if(!destination.isBackendShared())
            {
                List messagesForAdapter = new ArrayList();
                messagesForAdapter.add(message);
                MessageBatch batch = sendBatchToAdapter(messagesForAdapter, message.getHeaders(), message.getClientId(), false, false, dtx);
                dtx.addProcessedBatch(batch);
            } else
            {
                dtx.addProcessedMessage(message);
            }
            if(message instanceof DataAssociationMessage)
                manageAssociations((DataAssociationMessage)message, dtx.getProcessedBatches(), messages, dtx, true);
        }

        dtx.commit();
        FlexContext.setMessageFromPeer(false);
        break MISSING_BLOCK_LABEL_217;
        Exception exception;
        exception;
        dtx.commit();
        FlexContext.setMessageFromPeer(false);
        throw exception;
    }

    public void requestAdapterState(String destinationId, Object requestingAddress)
    {
        Destination destination = getDestinationByName(destinationId);
        ServiceAdapter adapter = destination.getAdapter();
        Object adapterState = adapter.getAdapterState();
        ClusterManager clm = broker.getClusterManager();
        clm.invokePeerToPeerOperation(getClass().getName(), destinationId, "receiveAdapterState", new Object[] {
            destinationId, adapterState
        }, requestingAddress);
    }

    public void receiveAdapterState(String destinationId, Object adapterState, Object senderAddress)
    {
        Destination destination = getDestinationByName(destinationId);
        ServiceAdapter adapter = destination.getAdapter();
        adapter.setAdapterState(adapterState);
    }

    public Object serviceCommand(CommandMessage message)
    {
        incrementMessageCount(true);
        Object commandResult = super.serviceCommonCommands(message);
        if(commandResult == null)
        {
            DataDestination dest = (DataDestination)getDestination(message);
            commandResult = manageSubscriptions(message, false);
            if(message.getOperation() == 1)
                dest.getSequenceManager().unsubscribeClient(message.getClientId());
        }
        return commandResult;
    }

    public Object serviceMessage(Message message)
    {
        AcknowledgeMessage ack;
        DataMessage dmsg;
        DataServiceTransaction dtx;
        ack = null;
        dmsg = (DataMessage)message;
        if(dmsg.getOperation() == 8 || dmsg.getOperation() == 20)
        {
            incrementMessageCount(false);
            DataDestination dest = (DataDestination)getDestination(dmsg);
            SequencedMessage seqAck;
            ack = seqAck = dest.getSequenceManager().getPageFromSequence(dmsg);
            break MISSING_BLOCK_LABEL_1106;
        }
        if(dmsg.getOperation() == 5 || dmsg.getOperation() == 6 || dmsg.getOperation() == 7)
        {
            incrementMessageCount(false);
            ack = serviceTransactedMessage(dmsg);
            break MISSING_BLOCK_LABEL_1106;
        }
        if(dmsg.getOperation() == 2)
        {
            List resultList = new ArrayList(1);
            Object getResult = super.serviceMessage(dmsg);
            if(getResult != null)
            {
                resultList.add(getResult);
                DataDestination dest = (DataDestination)getDestination(dmsg);
                ack = dest.getSequenceManager().manageSequence(dmsg, resultList);
            } else
            {
                ack = new AcknowledgeMessage();
            }
            break MISSING_BLOCK_LABEL_1106;
        }
        if(dmsg.getOperation() != 10)
            break MISSING_BLOCK_LABEL_375;
        dtx = new DataServiceTransaction(this);
        List itemList = null;
        DataDestination dest = (DataDestination)getDestination(dmsg);
        dmsg.setOperation(2);
        Object adapterResult = super.serviceMessage(dmsg);
        if(adapterResult != null)
        {
            itemList = new ArrayList();
            itemList.add(adapterResult);
        } else
        {
            dmsg.setOperation(0);
            fixIncomingDataMessage(dtx, dmsg, null);
            List syncMessageList = (List)super.serviceMessage(dmsg);
            dest.getSequenceManager().manageSequence(dmsg, syncMessageList, dtx);
            if(dest.isClustered())
            {
                ArrayList peerMessages = new ArrayList();
                peerMessages.add(dmsg);
                sendPeerSyncAndPush(peerMessages);
            }
            dmsg.setOperation(2);
            itemList = new ArrayList();
            itemList.add(dmsg.unwrapBody());
        }
        ack = dest.getSequenceManager().manageSequence(dmsg, itemList);
        dtx.commit();
        break MISSING_BLOCK_LABEL_366;
        Exception exception;
        exception;
        dtx.commit();
        throw exception;
        dmsg.setOperation(10);
        break MISSING_BLOCK_LABEL_1106;
        if(dmsg.getOperation() != 1)
            break MISSING_BLOCK_LABEL_495;
        dtx = new DataServiceTransaction(this);
        Collection resultCollection = (Collection)super.serviceMessage(dmsg);
        if(resultCollection == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10520, new Object[] {
                dmsg.unwrapBody(), dmsg.getDestination()
            });
            throw dse;
        }
        DataDestination dest = (DataDestination)getDestination(dmsg);
        ack = dest.getSequenceManager().manageSequence(dmsg, resultCollection);
        SequencedMessage seqAck = (SequencedMessage)ack;
        dtx.commit();
        break MISSING_BLOCK_LABEL_1106;
        Exception exception1;
        exception1;
        dtx.commit();
        throw exception1;
        if(dmsg.getOperation() != 12)
            break MISSING_BLOCK_LABEL_682;
        dtx = new DataServiceTransaction(this);
        DataDestination dest = (DataDestination)getDestination(dmsg);
        if(dmsg.getBody() != null && dmsg.getBody().getClass().isArray())
        {
            dmsg.setOperation(1);
            Collection resultCollection = (Collection)super.serviceMessage(dmsg);
            ack = dest.getSequenceManager().manageSequence(dmsg, resultCollection);
            dmsg.setOperation(12);
        } else
        {
            dmsg.setOperation(2);
            List resultList = new ArrayList(1);
            Object getResult = super.serviceMessage(dmsg);
            if(getResult != null)
            {
                resultList.add(getResult);
                ack = dest.getSequenceManager().manageSequence(dmsg, resultList);
            } else
            {
                SequencedMessage seqAck = new SequencedMessage();
                seqAck.setSequenceId(-1);
                ack = seqAck;
            }
            dmsg.setOperation(12);
        }
        ack.setBody(null);
        dtx.commit();
        break MISSING_BLOCK_LABEL_1106;
        Exception exception2;
        exception2;
        dtx.commit();
        throw exception2;
        if(dmsg.getOperation() == 11)
        {
            dmsg.setOperation(0);
            List syncMessageList = (List)super.serviceMessage(dmsg);
            DataDestination dest = (DataDestination)getDestination(dmsg);
            dest.getSequenceManager().manageSequence(dmsg, syncMessageList);
            if(dest.isClustered())
            {
                ArrayList peerMessages = new ArrayList();
                peerMessages.add(dmsg);
                sendPeerSyncAndPush(peerMessages);
            }
            dmsg.setOperation(2);
            List itemList = new ArrayList();
            itemList.add(dmsg.getBody());
            ack = dest.getSequenceManager().manageSequence(dmsg, itemList);
            dmsg.setOperation(11);
            break MISSING_BLOCK_LABEL_1106;
        }
        if(dmsg.getOperation() == 4)
        {
            List syncMessageList = (List)super.serviceMessage(dmsg);
            DataDestination dest = (DataDestination)getDestination(dmsg);
            ack = dest.getSequenceManager().manageSequence(dmsg, syncMessageList);
            if(dest.isClustered())
            {
                ArrayList peerMessages = new ArrayList();
                peerMessages.add(dmsg);
                sendPeerSyncAndPush(peerMessages);
            }
            break MISSING_BLOCK_LABEL_1106;
        }
        if(dmsg.getOperation() != 9)
            break MISSING_BLOCK_LABEL_935;
        syncMessageList = new DataServiceTransaction(this);
        ack = new AcknowledgeMessage();
        ack.setBody(super.serviceMessage(dmsg));
        syncMessageList.commit();
        break MISSING_BLOCK_LABEL_1106;
        Exception exception3;
        exception3;
        syncMessageList.commit();
        throw exception3;
        if(dmsg.getOperation() == 18)
        {
            DataDestination dest = (DataDestination)getDestination(dmsg);
            Integer sequenceId = (Integer)dmsg.getHeader("sequenceId");
            if(sequenceId != null)
                dest.getSequenceManager().unsubscribeClientFromSequence(dmsg, sequenceId.intValue(), dmsg.unwrapBody(), false);
            ack = new AcknowledgeMessage();
        } else
        if(dmsg.getOperation() == 19)
        {
            DataDestination dest = (DataDestination)getDestination(dmsg);
            Integer sequenceId = (Integer)dmsg.getHeader("sequenceId");
            if(sequenceId != null)
                dest.getSequenceManager().unsubscribeClientFromSequence(dmsg, sequenceId.intValue(), (Map)dmsg.getBody(), true);
            ack = new AcknowledgeMessage();
        } else
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10504, new Object[] {
                new Integer(dmsg.getOperation())
            });
            throw dse;
        }
        if(ack.getBody() != null && (ack.getBody() instanceof List))
            ack.setBody(((Object) (((List)ack.getBody()).toArray())));
        return ack;
    }

    Object sendMessageToAdapter(Message message)
    {
        return super.serviceMessage(message);
    }

    private AcknowledgeMessage serviceTransactedMessage(DataMessage dmsg)
    {
        AcknowledgeMessage ack;
        List currentMessagesForBatch;
        DataServiceTransaction dtx;
        ack = null;
        currentMessagesForBatch = new ArrayList();
        dtx = DataServiceTransaction.begin(this, dmsg.getOperation() == 7);
        dtx.setClientId(dmsg.getClientId());
        dtx.setBatchId(dmsg.getMessageId());
        Map commonHeaders = dmsg.getHeaders();
        Object body = dmsg.getBody();
        Object batchedMessages[];
        if(body instanceof List)
            batchedMessages = ((List)body).toArray();
        else
            batchedMessages = (Object[])(Object[])body;
        String lastDestName = null;
        boolean pendingCreate = false;
        for(int batchIndex = 0; batchIndex <= batchedMessages.length; batchIndex++)
        {
            if(batchIndex == batchedMessages.length)
            {
                if(currentMessagesForBatch.size() > 0)
                {
                    MessageBatch msgBatch = sendBatchToAdapter(currentMessagesForBatch, commonHeaders, dmsg.getClientId(), DataServiceTransaction.getCurrentUserTransaction() != null, true, dtx);
                    dtx.addProcessedBatch(msgBatch);
                    pendingCreate = false;
                }
                continue;
            }
            DataMessage incomingMessage = (DataMessage)batchedMessages[batchIndex];
            int op = incomingMessage.getOperation();
            String msgDestName = incomingMessage.getDestination();
            DataDestination dest = (DataDestination)getDestinationByName(msgDestName);
            if(currentMessagesForBatch.size() > 0 && (lastDestName != null && !msgDestName.equals(lastDestName) || pendingCreate && (op == 3 || op == 4) && dest.hasSelfAssociations()))
            {
                MessageBatch msgBatch = sendBatchToAdapter(currentMessagesForBatch, commonHeaders, dmsg.getClientId(), DataServiceTransaction.getCurrentUserTransaction() != null, true, dtx);
                dtx.addProcessedBatch(msgBatch);
                currentMessagesForBatch = new ArrayList();
                pendingCreate = false;
            }
            fixIncomingDataMessage(dtx, incomingMessage, dtx.getProcessedBatches());
            if(incomingMessage instanceof DataAssociationMessage)
            {
                DataAssociationMessage damsg = (DataAssociationMessage)incomingMessage;
                manageAssociations(damsg, dtx.getProcessedBatches(), currentMessagesForBatch, dtx, false);
            } else
            if(incomingMessage instanceof UpdateCollectionMessage)
                dtx.addClientUpdateCollection((UpdateCollectionMessage)incomingMessage);
            else
            if(op == 0 || op == 11)
                pendingCreate = true;
            currentMessagesForBatch.add(incomingMessage);
            lastDestName = incomingMessage.getDestination();
        }

        List outgoingMessages = dtx.complete();
        ack = new AcknowledgeMessage();
        ack.setBody(((Object) (outgoingMessages.toArray())));
        break MISSING_BLOCK_LABEL_545;
        MessageException mex;
        mex;
        dtx.setRollbackOnly();
        if(mex.getExtendedData() != null && mex.getExtendedData().containsKey("rollbackBatch"))
            dtx.addProcessedBatch((MessageBatch)mex.getExtendedData().get("rollbackBatch"));
        else
            throw mex;
        List outgoingMessages = dtx.complete();
        ack = new AcknowledgeMessage();
        ack.setBody(((Object) (outgoingMessages.toArray())));
        break MISSING_BLOCK_LABEL_545;
        Exception exception;
        exception;
        List outgoingMessages = dtx.complete();
        ack = new AcknowledgeMessage();
        ack.setBody(((Object) (outgoingMessages.toArray())));
        throw exception;
        return ack;
    }

    private void fixIncomingDataMessage(DataServiceTransaction dtx, DataMessage dmsg, List processedBatches)
    {
        switch(dmsg.getOperation())
        {
        case 0: // '\0'
        case 4: // '\004'
        case 11: // '\013'
            dmsg.setBody(wrapItem(dmsg, dmsg.unwrapBody()));
            setLazyProperties(dtx, processedBatches, dmsg.getDestination(), DataDestination.unwrapItem(dmsg.getBody()), (Map)dmsg.getHeader("referencedIds"));
            break;

        case 3: // '\003'
            Object messageBody[] = getUpdateBody(dmsg);
            messageBody[1] = wrapItem(dmsg, messageBody[1]);
            messageBody[2] = wrapItem(dmsg, messageBody[2]);
            setLazyProperties(dtx, processedBatches, dmsg.getDestination(), DataDestination.unwrapItem(messageBody[1]), (Map)dmsg.getHeader("prevReferencedIds"));
            setLazyProperties(dtx, processedBatches, dmsg.getDestination(), DataDestination.unwrapItem(messageBody[2]), (Map)dmsg.getHeader("newReferencedIds"));
            break;
        }
    }

    void fixIdsInUpdateCollection(UpdateCollectionMessage ucmsg, List processedBatches)
    {
        Object ranges[] = (Object[])(Object[])ucmsg.getBody();
        DataDestination dest = (DataDestination)getDestination(ucmsg);
        for(int i = 0; i < ranges.length; i++)
        {
            UpdateCollectionRange range = (UpdateCollectionRange)ranges[i];
            Object ids[] = range.identities;
            for(int j = 0; j < ids.length; j++)
                if(ids[j] instanceof String)
                {
                    DataMessage msg = findMessageInBatch(processedBatches, (String)ids[j]);
                    ids[j] = dest.getSequenceManager().getIdentityForInstance(msg.unwrapBody());
                }

        }

    }

    private void setLazyProperties(DataServiceTransaction dtx, List processedBatches, String destination, Object item, Map referencedIds)
    {
        DataDestination parentDest = (DataDestination)getDestinationByName(destination);
        List lazyAssocs = parentDest.getLazyAssociations();
        if(lazyAssocs == null)
            return;
        if(referencedIds == null)
            return;
        for(int i = 0; i < lazyAssocs.size(); i++)
        {
            AssociationSetting assoc = (AssociationSetting)lazyAssocs.get(i);
            Object idval = referencedIds.get(assoc.getProperty());
            String prop = assoc.getProperty();
            DataDestination childDest = (DataDestination)getDestinationByName(assoc.getDestination());
            if(idval == null)
                continue;
            if(assoc.isMulti())
            {
                Object ids[] = (Object[])(Object[])idval;
                boolean setProperty = false;
                for(int j = 0; j < ids.length; j++)
                {
                    if(!(ids[j] instanceof String))
                        continue;
                    DataMessage msg = findMessageInBatch(processedBatches, (String)ids[j]);
                    if(msg == null)
                    {
                        ArrayList newList = new ArrayList(Arrays.asList(ids));
                        newList.remove(j);
                        ids = newList.toArray();
                        j--;
                        referencedIds.put(assoc.getProperty(), ((Object) (ids)));
                    } else
                    {
                        ids[j] = childDest.getSequenceManager().getIdentityForInstance(msg.unwrapBody());
                    }
                }

                Collection c = (Collection)getPropertyOnClientObject(item, prop);
                if(c == null)
                {
                    setProperty = true;
                    if(item instanceof Map)
                    {
                        c = new ArrayList();
                    } else
                    {
                        PropertyProxy proxy = PropertyProxyRegistry.getProxyAndRegister(item);
                        Class cl = proxy.getType(item, prop);
                        if(cl == (java.util.List.class))
                            cl = java.util.ArrayList.class;
                        else
                        if(cl == (java.util.Set.class))
                            cl = java.util.HashSet.class;
                        try
                        {
                            c = (Collection)cl.newInstance();
                        }
                        catch(Exception exc)
                        {
                            if(Log.isError())
                                Log.getLogger("DataService.General").error("Failed to create collection property: " + cl + StringUtils.NEWLINE + "stack=" + ExceptionUtil.toString(exc));
                        }
                    }
                } else
                {
                    c.clear();
                }
                for(int j = 0; j < ids.length; j++)
                    c.add(dtx.getItemInstance(childDest, (Map)ids[j]));

                if(setProperty)
                    setPropertyOnClientObject(item, prop, c);
                continue;
            }
            if(idval instanceof String)
            {
                DataMessage msg = findMessageInBatch(processedBatches, (String)idval);
                if(msg == null)
                    idval = null;
                else
                    idval = childDest.getSequenceManager().getIdentityForInstance(msg.unwrapBody());
                referencedIds.put(assoc.getProperty(), idval);
            }
            setPropertyOnClientObject(item, prop, dtx.getItemInstance(childDest, (Map)idval));
        }

    }

    private Object wrapItem(DataMessage dmsg, Object item)
    {
        return ((DataDestination)getDestination(dmsg)).wrapItem(item);
    }

    private void manageAssociations(DataAssociationMessage incomingMessage, List processedBatches, List currentBatch, DataServiceTransaction dtx, boolean remote)
    {
        DataDestination parentDestination = (DataDestination)getDestination(incomingMessage);
        SequenceManager parentSequenceManager = parentDestination.getSequenceManager();
        String parentPropertyName = incomingMessage.getParentPropertyName();
        Object parentInstance = null;
        ItemIdentity parentIdentity = null;
        DataMessage parentMessage = null;
        if(incomingMessage.getParentMessageId() != null)
        {
            String parentCreationMsgId = incomingMessage.getParentMessageId();
            parentMessage = findMessageInBatch(processedBatches, parentCreationMsgId);
            if(parentMessage == null)
            {
                int i = 0;
                do
                {
                    if(i >= currentBatch.size())
                        break;
                    parentMessage = (DataMessage)currentBatch.get(i);
                    if(parentMessage.getMessageId().equals(parentCreationMsgId))
                    {
                        parentInstance = parentMessage.unwrapBody();
                        break;
                    }
                    i++;
                } while(true);
            } else
            {
                parentInstance = parentMessage.unwrapBody();
                parentIdentity = parentSequenceManager.getItemIdentityForInstance(parentInstance);
                incomingMessage.setIdentity(parentIdentity);
            }
        } else
        {
            parentIdentity = parentSequenceManager.toItemIdentity(incomingMessage.getIdentity());
        }
        int childSequenceId = incomingMessage.getChildSequenceId();
        AssociationSetting assoc = parentDestination.getAssociation(parentPropertyName);
        DataDestination childDestination = (DataDestination)getDestinationByName(assoc.getDestination());
        SequenceManager childSequenceManager = childDestination.getSequenceManager();
        Sequence childSequence = null;
        if(childSequenceId != -1)
        {
            if(!remote)
                childSequence = childSequenceManager.getSequence(childSequenceId);
        } else
        if(incomingMessage.getChildMessageId() == null || incomingMessage.getOperation() != 13)
            return;
        Object childInstance = null;
        Map childId;
        if(incomingMessage.getChildMessageId() != null)
        {
            String childCreationMsgId = incomingMessage.getChildMessageId();
            DataMessage createMessage = findMessageInBatch(processedBatches, childCreationMsgId);
            childInstance = createMessage.unwrapBody();
            childId = childSequenceManager.getIdentityForInstance(childInstance);
        } else
        {
            childId = (Map)incomingMessage.unwrapBody();
            childInstance = dtx.getItemInstance(childDestination, childId);
        }
        if((remote || childSequence == null) && parentIdentity != null)
        {
            AssociatedItemIndex aii = new AssociatedItemIndex(parentDestination, parentIdentity, parentPropertyName, assoc.getRelation(), assoc.getLazy(), assoc.getCacheReferencedItems());
            childSequence = childSequenceManager.getAssociationSequence(aii);
        }
        if(childInstance == null)
        {
            Log.getLogger("DataService.General").warn("Unable to find childItem in association message.  ChildId: " + childId + " message: " + incomingMessage);
            return;
        }
        if(childSequence != null)
        {
            List oldNodeInstances = dtx.getItemInstances(childDestination, childSequence);
            Object newPropertyValue;
            switch(assoc.getRelation())
            {
            case 1: // '\001'
            case 2: // '\002'
                List newNodeInstances = new ArrayList();
                newNodeInstances.addAll(oldNodeInstances);
                if(incomingMessage.getOperation() == 13)
                {
                    if(incomingMessage.getSequencePosition() == -1)
                        incomingMessage.setSequencePosition(newNodeInstances.size());
                    dtx.addSequenceItemIdentity(childDestination, childSequence, incomingMessage.getSequencePosition(), childId);
                    if(incomingMessage.getSequencePosition() >= newNodeInstances.size())
                        newNodeInstances.add(childInstance);
                    else
                        newNodeInstances.add(incomingMessage.getSequencePosition(), childInstance);
                } else
                {
                    if(incomingMessage.getSequencePosition() == -1)
                        incomingMessage.setSequencePosition(newNodeInstances.indexOf(childInstance));
                    dtx.removeSequenceItemIdentity(childDestination, childSequence, childId);
                    newNodeInstances.remove(childInstance);
                }
                newPropertyValue = newNodeInstances;
                dtx.cacheSequenceItems(childDestination, childSequence, newNodeInstances);
                break;

            case 3: // '\003'
            case 4: // '\004'
                Object oldNodeInstance = null;
                if(oldNodeInstances.size() > 0)
                    oldNodeInstance = oldNodeInstances.get(0);
                if(incomingMessage.getOperation() == 13)
                {
                    newPropertyValue = childInstance;
                    dtx.setOneSequenceItemIdentity(childDestination, childSequence, childId);
                } else
                {
                    newPropertyValue = null;
                    dtx.removeSequenceItemIdentity(childDestination, childSequence, childId);
                }
                dtx.cacheSequenceItems(childDestination, childSequence, newPropertyValue);
                break;

            default:
                DataServiceException dse = new DataServiceException();
                dse.setMessage(10151);
                throw dse;
            }
            if(incomingMessage.getOperation() == 13 && incomingMessage.getChildMessageId() != null && !assoc.getLazy())
                updatePendingMessageForAssociation(parentInstance, parentIdentity, parentPropertyName, currentBatch, newPropertyValue, incomingMessage.getDestination(), parentMessage != null, parentSequenceManager);
        } else
        {
            if(parentIdentity != null && currentBatch.size() > 0)
            {
                DataMessage upd = getLastMessageInBatch(currentBatch, parentIdentity);
                if(upd.getOperation() == 0 || upd.getOperation() == 11 || upd.getOperation() == 4)
                    parentInstance = upd.unwrapBody();
                else
                if(upd.getOperation() == 3)
                {
                    parentInstance = getUpdateBody(upd, 2);
                    if(parentMessage != null)
                    {
                        parentSequenceManager.setIdentityForInstance(parentInstance, parentIdentity);
                        parentSequenceManager.setIdentityForInstance(getUpdateBody(upd, 1), parentIdentity);
                        upd.setIdentity(parentIdentity);
                    }
                }
            }
            if(!assoc.getLazy() && parentInstance != null)
                if(assoc.isMulti())
                {
                    Collection coll = (Collection)getPropertyOnClientObject(parentInstance, parentPropertyName);
                    if(coll instanceof List)
                    {
                        List list = (List)getPropertyOnClientObject(parentInstance, parentPropertyName);
                        list.set(incomingMessage.getSequencePosition(), childInstance);
                    } else
                    {
                        Iterator it = coll.iterator();
                        int pos = incomingMessage.getSequencePosition();
                        for(int i = 0; it.hasNext() && i < pos; i++)
                            it.next();

                        if(it.hasNext())
                        {
                            Object oldChildInstance = it.next();
                            childSequenceManager.copyIdInItem(childInstance, oldChildInstance);
                        }
                    }
                } else
                {
                    setPropertyOnClientObject(parentInstance, parentPropertyName, childInstance);
                }
        }
    }

    private DataMessage getLastMessageInBatch(List currentBatch, Map instIdentity)
    {
        DataMessage msg = null;
        int i = currentBatch.size() - 1;
        do
        {
            if(i < 0)
                break;
            msg = (DataMessage)currentBatch.get(i);
            DataDestination dest = (DataDestination)getDestination(msg);
            if(dest.getSequenceManager().compareIds(msg.getIdentity(), instIdentity))
                break;
            i--;
        } while(true);
        return msg;
    }

    private void updatePendingMessageForAssociation(Object parentInstance, Map parentIdentity, String parentPropertyName, List currentBatch, Object newPropertyValue, String destination, boolean newParent, 
            SequenceManager parentSequenceManager)
    {
        if(parentInstance == null)
            if(newParent)
            {
                DataMessage upd = getLastMessageInBatch(currentBatch, parentIdentity);
                if(upd != null)
                    if(upd.getOperation() == 0 || upd.getOperation() == 11 || upd.getOperation() == 4)
                        parentInstance = upd.unwrapBody();
                    else
                    if(upd.getOperation() == 3)
                    {
                        parentInstance = getUpdateBody(upd, 2);
                        parentSequenceManager.setIdentityForInstance(parentInstance, parentIdentity);
                        parentSequenceManager.setIdentityForInstance(getUpdateBody(upd, 1), parentIdentity);
                        upd.setIdentity(parentIdentity);
                    }
            } else
            {
                DataMessage toUpdate = null;
                int i = 0;
                do
                {
                    if(i >= currentBatch.size())
                        break;
                    toUpdate = (DataMessage)currentBatch.get(i);
                    if(parentSequenceManager.compareIds(toUpdate.getIdentity(), parentIdentity))
                        break;
                    i++;
                } while(true);
                if(toUpdate != null)
                    if(toUpdate.getOperation() == 0 || toUpdate.getOperation() == 11)
                        parentInstance = toUpdate.unwrapBody();
                    else
                        parentInstance = getUpdateBody(toUpdate, 2);
            }
        if(parentInstance != null)
            setPropertyOnClientObject(parentInstance, parentPropertyName, newPropertyValue);
    }

    public static Object getUpdateBody(DataMessage toUpdate, int which)
    {
        return DataDestination.unwrapItem(getUpdateBody(toUpdate)[which]);
    }

    public static Object[] getUpdateBody(DataMessage toUpdate)
    {
        Object body = toUpdate.getBody();
        Object messageBody[];
        if(body instanceof List)
            messageBody = ((List)body).toArray();
        else
            messageBody = (Object[])(Object[])body;
        return messageBody;
    }

    public static void setUpdateBody(DataMessage msg, int which, Object item)
    {
        if(msg.getBody() instanceof List)
            ((List)msg.getBody()).set(which, item);
        else
            ((Object[])(Object[])msg.getBody())[which] = item;
    }

    public static DataMessage findCurrentCreateDataMessage(String messageId)
    {
        DataServiceTransaction dtx = DataServiceTransaction.getCurrentDataServiceTransaction();
        if(dtx == null)
            return null;
        else
            return findMessageInBatch(dtx.getProcessedBatches(), messageId);
    }

    public static Object getPropertyOnClientObject(Object clientObj, String propertyName)
    {
        try
        {
            PropertyProxy proxy = PropertyProxyRegistry.getProxyAndRegister(clientObj);
            return proxy.getValue(clientObj, propertyName);
        }
        catch(Throwable th)
        {
            if(th instanceof InvocationTargetException)
                th = ((InvocationTargetException)th).getCause();
            if(Log.isError())
                Log.getLogger("DataService.General").error("Can't get property on client object: " + clientObj + StringUtils.NEWLINE + " property=" + propertyName + StringUtils.NEWLINE + " exception=" + ExceptionUtil.toString(th));
            if(th instanceof RuntimeException)
                throw (RuntimeException)th;
            else
                return null;
        }
    }

    public static void setPropertyOnClientObject(Object clientObj, String propertyName, Object value)
    {
        try
        {
            PropertyProxy proxy = PropertyProxyRegistry.getProxyAndRegister(clientObj);
            proxy.setValue(clientObj, propertyName, value);
        }
        catch(Throwable th)
        {
            if(th instanceof InvocationTargetException)
                th = ((InvocationTargetException)th).getCause();
            if(Log.isError())
                Log.getLogger("DataService.General").error("Can't set property on client object: " + clientObj + StringUtils.NEWLINE + " property=" + propertyName + StringUtils.NEWLINE + " exception=" + ExceptionUtil.toString(th));
        }
    }

    public static Collection getPropertiesOnClientObject(Object clientObj)
    {
        PropertyProxy proxy = PropertyProxyRegistry.getProxyAndRegister(clientObj);
        List props = proxy.getPropertyNames(clientObj);
        return props;
    }

    private static DataMessage findMessageInBatch(List messageBatches, String messageId)
    {
        DataMessage foundMessage = null;
        for(Iterator batchIter = messageBatches.iterator(); batchIter.hasNext() && foundMessage == null;)
        {
            MessageBatch msgBatch = (MessageBatch)batchIter.next();
            Iterator iter = msgBatch.messagesToPush.iterator();
            while(iter.hasNext() && foundMessage == null) 
            {
                Message message = (Message)iter.next();
                if(message instanceof SequencedMessage)
                    message = ((SequencedMessage)message).getDataMessage();
                if(message instanceof DataMessage)
                {
                    DataMessage processedMessage = (DataMessage)message;
                    if(processedMessage.getMessageId().equals(messageId))
                        foundMessage = processedMessage;
                }
            }
        }

        return foundMessage;
    }

    private MessageBatch sendBatchToAdapter(List messages, Map headers, Object clientId, boolean transactional, boolean broadcastToPeers, DataServiceTransaction dtx)
    {
        DataMessage batchForAdapter = null;
        DataMessage firstMessage = (DataMessage)messages.get(0);
        if(messages.size() == 1 && firstMessage.getOperation() == 5)
        {
            batchForAdapter = firstMessage;
        } else
        {
            batchForAdapter = new DataMessage();
            batchForAdapter.setDestination(firstMessage.getDestination());
            batchForAdapter.setOperation(5);
            batchForAdapter.setBody(messages);
        }
        batchForAdapter.setHeaders(headers);
        batchForAdapter.setClientId(clientId);
        List adapterResult = (List)super.serviceMessage(batchForAdapter);
        List nonErrorMessages = new ArrayList();
        List errorMessages = new ArrayList();
        if(adapterResult != null)
        {
            for(Iterator outIter = adapterResult.iterator(); outIter.hasNext();)
            {
                Message outMessage = (Message)outIter.next();
                if(outMessage instanceof ErrorMessage)
                    errorMessages.add(outMessage);
                else
                    nonErrorMessages.add(outMessage);
            }

        }
        MessageBatch messageBatch = new MessageBatch();
        messageBatch.incomingBatchedMessage = batchForAdapter;
        messageBatch.messagesToPush = nonErrorMessages;
        messageBatch.errorMessages = errorMessages;
        messageBatch.sendMessagesToPeers = dtx.getSendMessagesToPeers();
        if(errorMessages.size() > 0)
        {
            dtx.hasErrors = true;
            if(transactional)
            {
                MessageException mex = new MessageException("");
                Map errorMap = new HashMap();
                errorMap.put("rollbackBatch", messageBatch);
                mex.setExtendedData(errorMap);
                throw mex;
            }
        }
        for(int i = 0; i < nonErrorMessages.size(); i++)
        {
            Message msg = (Message)nonErrorMessages.get(i);
            if(!(msg instanceof DataMessage))
                continue;
            DataMessage dmsg = (DataMessage)msg;
            if(dtx == null)
                continue;
            if(dmsg.getOperation() == 0 || dmsg.getOperation() == 11)
            {
                dtx.addModifiedItem((DataDestination)getDestination(dmsg), dmsg.getIdentity(), dmsg.unwrapBody());
                continue;
            }
            if(dmsg.getOperation() == 3)
                dtx.addModifiedItem((DataDestination)getDestination(dmsg), dmsg.getIdentity(), getUpdateBody(dmsg, 2));
        }

        return messageBatch;
    }

    protected void setupServiceControl(MessageBroker broker)
    {
        controller = new DataServiceControl(getId(), this, broker.getControl());
        controller.register();
        setControl(controller);
    }

    String getServerClientId()
    {
        if(serverClientId == null)
            serverClientId = "srv:" + UUIDUtils.createUUID(false);
        return serverClientId;
    }

    int getMessageIdCounter()
    {
        Object obj = messageIdSync;
        JVM INSTR monitorenter ;
        return messageIdCounter++;
        Exception exception;
        exception;
        throw exception;
    }

    String getNewMessageId()
    {
        return getServerClientId() + ":" + getMessageIdCounter();
    }

    void doManageSubscriptions(CommandMessage msg)
    {
        manageSubscriptions(msg, false);
    }

    public static final String LOG_CATEGORY = "DataService.General";
    static final String DEST_CLIENT_IDS_HEADER = "destClientIds";
    private DataServiceControl controller;
    String serverClientId;
    int messageIdCounter;
    Object messageIdSync;
}
