// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DataServiceTransaction.java

package flex.data;

import flex.data.adapters.AdapterException;
import flex.data.messages.DataMessage;
import flex.data.messages.InternalMessage;
import flex.data.messages.SequencedMessage;
import flex.data.messages.UpdateCollectionMessage;
import flex.messaging.MessageBroker;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.AcknowledgeMessage;
import flex.messaging.services.ServiceAdapter;
import flex.messaging.util.ExceptionUtil;
import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.transaction.*;

// Referenced classes of package flex.data:
//            DataServiceException, DataService, MessageBatch, DataDestination, 
//            ArrayKey, Sequence, UpdateCollectionRange, SequenceManager

public class DataServiceTransaction
{
    static class RefreshFill
    {

        public String toString()
        {
            return " destination=" + destination + " fillParameters=" + fillParameters;
        }

        String destination;
        List fillParameters;

        RefreshFill(String d, List f)
        {
            destination = d;
            fillParameters = f;
        }
    }


    public static DataServiceTransaction getCurrentDataServiceTransaction()
    {
        return (DataServiceTransaction)currentTransaction.get();
    }

    public static UserTransaction getCurrentUserTransaction()
    {
        DataServiceTransaction dtx = getCurrentDataServiceTransaction();
        if(dtx != null && dtx.userTransaction != null)
            return dtx.userTransaction;
        else
            return null;
    }

    private static boolean isInTransaction()
    {
        return currentTransaction.get() != null;
    }

    public static DataServiceTransaction begin(String serverId, boolean useJTA)
    {
        MessageBroker broker = MessageBroker.getMessageBroker(serverId);
        if(broker == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10163, new Object[] {
                serverId
            });
            throw dse;
        }
        DataService ds = (DataService)broker.getServiceByType("flex.data.DataService");
        if(ds == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10164, new Object[] {
                serverId
            });
            throw dse;
        } else
        {
            return begin(ds, useJTA);
        }
    }

    public static DataServiceTransaction begin(boolean useJTA)
    {
        return begin((String)null, useJTA);
    }

    public UserTransaction getUserTransaction()
    {
        return userTransaction;
    }

    public void registerSynchronization(Synchronization synchronization)
    {
        if(synchronizations == null)
            synchronizations = new ArrayList();
        synchronizations.add(synchronization);
    }

    public void setRollbackOnly()
    {
        rollbackOnly = true;
        if(userTransaction != null)
            try
            {
                userTransaction.setRollbackOnly();
            }
            catch(Exception txe)
            {
                if(Log.isDebug())
                    Log.getLogger("DataService.Transaction").debug("setRollbackOnly threw an error: " + txe);
            }
    }

    public void commit()
    {
        if(rollbackOnly)
            rollback();
        else
            doCommit();
    }

    public void rollback()
    {
        completed = true;
        try
        {
            if(userTransaction != null)
                userTransaction.rollback();
        }
        catch(SystemException exc)
        {
            if(Log.isError())
                Log.getLogger("DataService.Transaction").error("Error while rolling back a transaction: " + exc + " stack=" + ExceptionUtil.toString(exc));
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10162);
            dse.setRootCause(exc);
            throw dse;
        }
        clearCurrentTransaction();
        break MISSING_BLOCK_LABEL_106;
        Exception exception;
        exception;
        clearCurrentTransaction();
        throw exception;
    }

    public void updateItem(String destination, Object newVersion, Object previousVersion, String changes[])
    {
        DataMessage dmsg = new DataMessage();
        DataDestination dataDest = getDataDestinationWithError(destination);
        Object updateBody[] = new Object[3];
        updateBody[0] = changes;
        updateBody[2] = dataDest.wrapItem(newVersion);
        updateBody[1] = dataDest.wrapItem(previousVersion);
        dmsg.setOperation(3);
        dmsg.setBody(((Object) (updateBody)));
        dmsg.setDestination(destination);
        dmsg.setClientId(getDataService().getServerClientId());
        dmsg.setIdentity(dataDest.getSequenceManager().getIdentityForInstance(newVersion));
        dmsg.setMessageId(getDataService().getNewMessageId());
        if(dataDest.getLazyAssociations() != null)
        {
            dmsg.setHeader("newReferencedIds", dataDest.getReferencedIds(newVersion));
            if(previousVersion != null)
                dmsg.setHeader("prevReferencedIds", dataDest.getReferencedIds(previousVersion));
        }
        addProcessedMessage(dmsg);
    }

    public void createItem(String destination, Object item)
    {
        DataMessage dmsg = new DataMessage();
        DataDestination dataDest = getDataDestinationWithError(destination);
        dmsg.setOperation(0);
        dmsg.setBody(item);
        dmsg.setDestination(destination);
        dmsg.setClientId(getDataService().getServerClientId());
        dmsg.setIdentity(dataDest.getSequenceManager().getIdentityForInstance(item));
        dmsg.setMessageId(getDataService().getNewMessageId());
        if(dataDest.getLazyAssociations() != null)
            dmsg.setHeader("referencedIds", dataDest.getReferencedIds(item));
        addProcessedMessage(dmsg);
    }

    public void deleteItem(String destination, Object item)
    {
        DataMessage dmsg = new DataMessage();
        DataDestination dataDest = getDataDestinationWithError(destination);
        dmsg.setOperation(4);
        dmsg.setBody(item);
        dmsg.setDestination(destination);
        dmsg.setClientId(getDataService().getServerClientId());
        dmsg.setIdentity(dataDest.getSequenceManager().getIdentityForInstance(item));
        dmsg.setMessageId(getDataService().getNewMessageId());
        if(dataDest.getLazyAssociations() != null)
            dmsg.setHeader("referencedIds", dataDest.getReferencedIds(item));
        addProcessedMessage(dmsg);
    }

    public void deleteItemWithId(String destination, Map identity)
    {
        DataMessage dmsg = new DataMessage();
        DataDestination dataDest = getDataDestinationWithError(destination);
        dmsg.setOperation(4);
        dmsg.setDestination(destination);
        dmsg.setClientId(getDataService().getServerClientId());
        dmsg.setIdentity(identity);
        dmsg.setMessageId(getDataService().getNewMessageId());
        addProcessedMessage(dmsg);
    }

    public void refreshFill(String destination, List fillParameters)
    {
        if(Log.isDebug())
            Log.getLogger("DataService.Transaction").debug("Queuing refresh fill till commit for " + destination + " with parameters: " + fillParameters);
        if(refreshFills == null)
            refreshFills = new ArrayList();
        refreshFills.add(new RefreshFill(destination, fillParameters));
    }

    public void setSendMessagesToPeers(boolean stp)
    {
        sendMessagesToPeers = stp;
    }

    public boolean getSendMessagesToPeers()
    {
        return sendMessagesToPeers;
    }

    public Map getAttributeMap()
    {
        if(attributes == null)
            attributes = new HashMap();
        return attributes;
    }

    static DataServiceTransaction begin(DataService dataService, boolean useJTA)
    {
        if(isInTransaction())
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10165);
            throw dse;
        } else
        {
            DataServiceTransaction dtx = new DataServiceTransaction(dataService);
            dtx.doBegin(useJTA);
            return dtx;
        }
    }

    DataServiceTransaction(DataService ds)
    {
        refill = false;
        sendMessagesToPeers = true;
        pushFromPeer = false;
        instancesByDestination = new HashMap(11);
        newSequenceItemsByDestination = new HashMap(11);
        newSequencesByDestination = new HashMap(11);
        oldSequencesByDestination = new HashMap(11);
        userTransaction = null;
        committed = false;
        completed = false;
        hasErrors = false;
        rollbackOnly = false;
        processedBatches = new ArrayList();
        dataService = ds;
        currentTransaction.set(this);
    }

    void doBegin(boolean useJTA)
    {
        if(completed)
            throw new RuntimeException("Attempt to begin a transaction that was already completed");
        try
        {
            if(useJTA)
            {
                Context ctx = new InitialContext();
                String userTransactionJndi = "java:comp/UserTransaction";
                String userSpecified = System.getProperty("UserTxJndiName");
                if(userSpecified != null)
                    userTransactionJndi = userSpecified;
                userTransaction = (UserTransaction)ctx.lookup(userTransactionJndi);
                if(userTransaction != null)
                {
                    userTransaction.begin();
                    if(Log.isDebug())
                        Log.getLogger("DataService.Transaction").debug("Started transaction using jndi name: " + userTransactionJndi);
                } else
                if(Log.isError())
                    Log.getLogger("DataService.Transaction").error("Unable to lookup transaction for jndi name: " + userTransactionJndi);
            }
        }
        catch(Exception ne)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10150);
            dse.setRootCause(ne);
            throw dse;
        }
    }

    void setClientId(Object clientId)
    {
        this.clientId = clientId;
    }

    Object getClientId()
    {
        if(clientId == null)
            return getDataService().getServerClientId();
        else
            return clientId;
    }

    void setBatchId(String batchId)
    {
        this.batchId = batchId;
    }

    void setPushFromPeer(boolean pfp)
    {
        if(pfp)
            setSendMessagesToPeers(false);
        pushFromPeer = pfp;
    }

    boolean isPushFromPeer()
    {
        return pushFromPeer;
    }

    void setRefill(boolean value)
    {
        refill = value;
    }

    public boolean isRefill()
    {
        return refill;
    }

    void addProcessedBatch(MessageBatch msgBatch)
    {
        processedBatches.add(msgBatch);
    }

    List getProcessedBatches()
    {
        return processedBatches;
    }

    List doCommit()
    {
        try
        {
            if(userTransaction != null)
                userTransaction.commit();
            applySequenceUpdates();
            if(Log.isDebug())
                Log.getLogger("DataService.Transaction").debug("Committed transaction");
            committed = true;
        }
        catch(Exception exc)
        {
            if(Log.isError())
                Log.getLogger("DataService.Transaction").error("Error while committing transaction: " + exc + " stack=" + ExceptionUtil.toString(exc));
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10162);
            dse.setRootCause(exc);
            throw dse;
        }
        clearCurrentTransaction();
        break MISSING_BLOCK_LABEL_123;
        Exception exception;
        exception;
        clearCurrentTransaction();
        throw exception;
        return syncClients();
    }

    List complete()
    {
        if(completed)
            throw new RuntimeException("Attempt to complete a transaction that was already completed.");
        if(userTransaction == null)
            break MISSING_BLOCK_LABEL_367;
        try
        {
            notifyBeforeCompletion();
        }
        catch(Exception exc)
        {
            if(Log.isWarn())
                Log.getLogger("DataService.Transaction").warn("Error notifying before completion handlers: " + exc);
        }
        userTransaction.getStatus();
        JVM INSTR tableswitch 0 9: default 206
    //                   0 128
    //                   1 176
    //                   2 128
    //                   3 206
    //                   4 199
    //                   5 206
    //                   6 206
    //                   7 128
    //                   8 206
    //                   9 199;
           goto _L1 _L2 _L3 _L2 _L1 _L4 _L1 _L1 _L2 _L1 _L4
_L1:
        break; /* Loop/switch isn't completed */
_L2:
        List list = doCommit();
        try
        {
            notifyAfterCompletion();
        }
        catch(Exception exc)
        {
            if(Log.isWarn())
                Log.getLogger("DataService.Transaction").warn("Error notifying after completion handlers: " + exc);
        }
        return list;
_L3:
        rollback();
        if(Log.isDebug())
            Log.getLogger("DataService.Transaction").debug("Rolledback transaction");
        break; /* Loop/switch isn't completed */
_L4:
        clearCurrentTransaction();
        try
        {
            notifyAfterCompletion();
        }
        catch(Exception exc)
        {
            if(Log.isWarn())
                Log.getLogger("DataService.Transaction").warn("Error notifying after completion handlers: " + exc);
        }
        break MISSING_BLOCK_LABEL_380;
        Exception txe;
        txe;
        if(Log.isError())
            Log.getLogger("DataService.Transaction").error("Error while completing transaction: " + txe + " stacktrace=" + ExceptionUtil.toString(txe));
        DataServiceException dse = new DataServiceException();
        dse.setMessage(10162);
        dse.setRootCause(txe);
        throw dse;
        Exception exception;
        exception;
        try
        {
            notifyAfterCompletion();
        }
        catch(Exception exc)
        {
            if(Log.isWarn())
                Log.getLogger("DataService.Transaction").warn("Error notifying after completion handlers: " + exc);
        }
        throw exception;
        applySequenceUpdates();
        clearCurrentTransaction();
        committed = true;
        completed = true;
        return syncClients();
    }

    List syncClients()
    {
        List outgoingMessages = new ArrayList();
        List peerMessages = null;
        if(committed)
            processRefreshFills();
        Iterator iter = processedBatches.iterator();
        do
        {
            if(!iter.hasNext())
                break;
            MessageBatch msgBatch = (MessageBatch)iter.next();
            if(committed && msgBatch.messagesToPush != null && msgBatch.messagesToPush.size() > 0)
            {
                DataDestination dest = (DataDestination)dataService.getDestination(msgBatch.incomingBatchedMessage);
                AcknowledgeMessage sequencedAck = dest.getSequenceManager().manageSequence(msgBatch.incomingBatchedMessage, msgBatch.messagesToPush, this);
                if(dest.isClustered() && msgBatch.sendMessagesToPeers)
                {
                    if(peerMessages == null)
                        peerMessages = new ArrayList(msgBatch.messagesToPush.size());
                    for(int i = 0; i < msgBatch.messagesToPush.size(); i++)
                    {
                        Object m = msgBatch.messagesToPush.get(i);
                        if(m instanceof SequencedMessage)
                            m = ((SequencedMessage)m).getDataMessage();
                        peerMessages.add(m);
                    }

                }
                if(sequencedAck.getBody() != null)
                    outgoingMessages.addAll(Arrays.asList((Object[])(Object[])sequencedAck.getBody()));
            }
            if(msgBatch.errorMessages != null && msgBatch.errorMessages.size() > 0)
                outgoingMessages.addAll(msgBatch.errorMessages);
        } while(true);
        if(committed)
        {
            if(clientUpdateCollections != null && !hasErrors)
            {
                Iterator it = clientUpdateCollections.entrySet().iterator();
                do
                {
                    if(!it.hasNext())
                        break;
                    java.util.Map.Entry entry = (java.util.Map.Entry)it.next();
                    Object collectionId = entry.getKey();
                    Object collectionKey = (collectionId instanceof Object[]) ? ((Object) (new ArrayKey((Object[])(Object[])collectionId))) : collectionId;
                    UpdateCollectionMessage clientUC = (UpdateCollectionMessage)entry.getValue();
                    boolean pushClient = clientUC.getUpdateMode() != 2;
                    UpdateCollectionMessage serverUC;
                    if(serverUpdateCollections != null && (serverUC = (UpdateCollectionMessage)serverUpdateCollections.get(collectionKey)) != null)
                        if(clientUC.isSameUpdate(serverUC))
                        {
                            serverUpdateCollections.remove(collectionKey);
                        } else
                        {
                            pushClient = false;
                            clientUC.setUpdateMode(2);
                            if(peerMessages != null)
                                peerMessages.remove(clientUC);
                        }
                    if(pushClient)
                        pushUpdateCollectionToClients(clientUC);
                } while(true);
            }
            if(serverUpdateCollections != null)
            {
                UpdateCollectionMessage serverUC;
                for(Iterator it = serverUpdateCollections.entrySet().iterator(); it.hasNext(); outgoingMessages.add(serverUC))
                {
                    java.util.Map.Entry entry = (java.util.Map.Entry)it.next();
                    serverUC = (UpdateCollectionMessage)entry.getValue();
                    pushUpdateCollectionToClients(serverUC);
                    DataDestination dest = (DataDestination)dataService.getDestination(serverUC);
                    if(!dest.isClustered() || !sendMessagesToPeers)
                        continue;
                    if(peerMessages == null)
                        peerMessages = new ArrayList();
                    peerMessages.add(serverUC);
                }

            }
            if(peerMessages != null)
                dataService.sendPeerSyncAndPush(peerMessages);
        }
        return outgoingMessages;
    }

    void pushUpdateCollectionToClients(UpdateCollectionMessage ucmsg)
    {
        DataDestination dest = (DataDestination)dataService.getDestination(ucmsg);
        Sequence seq = dest.getSequenceManager().getSequence(null, ucmsg.getCollectionId());
        if(seq != null)
            dataService.pushMessageToClients(dest, new LinkedHashSet(seq.getSubscriberIds()), ucmsg, false);
    }

    void notifyBeforeCompletion()
    {
        if(synchronizations == null)
            return;
        Synchronization s;
        for(Iterator iter = synchronizations.iterator(); iter.hasNext(); s.beforeCompletion())
            s = (Synchronization)iter.next();

    }

    void notifyAfterCompletion()
        throws SystemException
    {
        if(synchronizations == null)
            return;
        int status = userTransaction.getStatus();
        Synchronization s;
        for(Iterator iter = synchronizations.iterator(); iter.hasNext(); s.afterCompletion(status))
            s = (Synchronization)iter.next();

    }

    void addModifiedItem(DataDestination dest, Map id, Object inst)
    {
        Map instMap = (Map)instancesByDestination.get(dest);
        if(instMap == null)
        {
            instMap = new HashMap(11);
            instancesByDestination.put(dest, instMap);
        }
        instMap.put(id, inst);
    }

    List getItemInstances(DataDestination dest, Sequence childSequence)
    {
        Map sequenceItems = (Map)newSequenceItemsByDestination.get(dest);
        Integer seqId = new Integer(childSequence.getSequenceId());
        if(sequenceItems != null)
        {
            Object instances = sequenceItems.get(seqId);
            if(instances != null)
                return (List)instances;
        }
        Map sequences = (Map)newSequencesByDestination.get(dest);
        Map instMap = (Map)instancesByDestination.get(dest);
        List instIds = null;
        if(sequences != null)
            instIds = (List)sequences.get(seqId);
        if(instIds == null)
            instIds = childSequence.getItemIdentities();
        if(instIds == null || instIds.size() == 0)
            return new ArrayList(0);
        ArrayList instances = new ArrayList(instIds.size());
        for(int i = 0; i < instIds.size(); i++)
        {
            Map id = (Map)instIds.get(i);
            Object inst = null;
            if(instMap != null)
                inst = instMap.get(id);
            if(inst == null)
            {
                SequenceManager.Item item = dest.getSequenceManager().getItem(id);
                if(item != null)
                    inst = item.instance;
            }
            if(inst != null)
            {
                instances.add(inst);
                continue;
            }
            try
            {
                instances.add(dest.getItemFromAdapter(id));
            }
            catch(AdapterException exc)
            {
                Log.getLogger("DataService.Transaction").warn("Missing getMethod on adapter - required for destination: " + dest.getId());
            }
        }

        return instances;
    }

    void cacheSequenceItems(DataDestination dest, Sequence seq, Object items)
    {
        if(dest.getNumNonLazyAssociations() == 0)
            return;
        Map itemsMap = (Map)newSequenceItemsByDestination.get(dest);
        Integer seqId = new Integer(seq.getSequenceId());
        if(itemsMap == null)
        {
            itemsMap = new HashMap(11);
            newSequenceItemsByDestination.put(dest, itemsMap);
        }
        if(items instanceof List)
            itemsMap.put(seqId, items);
        else
        if(items == null)
        {
            itemsMap.put(seqId, new ArrayList(0));
        } else
        {
            List l = new ArrayList(1);
            l.add(items);
            itemsMap.put(seqId, l);
        }
    }

    Object getItemInstance(DataDestination dest, Map id)
    {
        Object inst = null;
        Map instMap = (Map)instancesByDestination.get(dest);
        if(instMap != null)
            inst = instMap.get(id);
        if(inst == null)
        {
            SequenceManager.Item item = dest.getSequenceManager().getItem(id);
            if(item != null)
                inst = item.instance;
            if(inst == null)
                inst = dest.getItemFromAdapter(id);
        }
        return inst;
    }

    List getOrCreateItemInstances(DataDestination dest, Sequence seq)
    {
        Map sequences = (Map)newSequencesByDestination.get(dest);
        Integer seqId = new Integer(seq.getSequenceId());
        if(sequences == null)
        {
            sequences = new HashMap(11);
            newSequencesByDestination.put(dest, sequences);
        }
        List seqIds = (List)sequences.get(seqId);
        if(seqIds == null)
        {
            seqIds = cloneItemIdentities(seq.getItemIdentities());
            sequences.put(seqId, seqIds);
        }
        return seqIds;
    }

    List cloneItemIdentities(List src)
    {
        List seqIds = new ArrayList(src.size());
        for(int i = 0; i < src.size(); i++)
            seqIds.add(src.get(i));

        return seqIds;
    }

    void addSequenceItemIdentity(DataDestination dest, Sequence seq, int pos, Map id)
    {
        List l = getOrCreateItemInstances(dest, seq);
        if(pos > l.size())
        {
            Log.getLogger("DataService.General").warn("Increasing size of sequence from " + l.size() + " for position: " + pos);
            l.add(id);
        } else
        {
            l.add(pos, id);
        }
    }

    void removeSequenceItemIdentity(DataDestination dest, Sequence seq, Map id)
    {
        getOrCreateItemInstances(dest, seq).remove(id);
    }

    void setOneSequenceItemIdentity(DataDestination dest, Sequence seq, Map id)
    {
        List seqIds = getOrCreateItemInstances(dest, seq);
        seqIds.clear();
        seqIds.add(id);
    }

    void applySequenceUpdates()
    {
        for(Iterator dit = newSequencesByDestination.entrySet().iterator(); dit.hasNext();)
        {
            java.util.Map.Entry dent = (java.util.Map.Entry)dit.next();
            DataDestination dest = (DataDestination)dent.getKey();
            Map sequences = (Map)dent.getValue();
            Iterator sit = sequences.entrySet().iterator();
            while(sit.hasNext()) 
            {
                java.util.Map.Entry ent = (java.util.Map.Entry)sit.next();
                Integer seqId = (Integer)ent.getKey();
                Sequence seq = dest.getSequenceManager().getSequence(seqId.intValue());
                if(seq != null)
                {
                    List oldIds;
                    synchronized(seq)
                    {
                        oldIds = new ArrayList(seq.getItemIdentities());
                    }
                    if(dest.getNumNonLazyAssociations() > 0)
                        dest.getSequenceManager().createSequence(getItemInstances(dest, seq), seq.getFillParameters(), seq.getAssociatedItemIndex(), null, null, null, null);
                    else
                        dest.getSequenceManager().createSequence((List)ent.getValue(), seq.getFillParameters(), seq.getAssociatedItemIndex(), null, null, null, null, new TreeMap(), true);
                    ent.setValue(oldIds);
                }
            }
        }

    }

    void saveSequenceItemIdentities(DataDestination dd, Sequence seq)
    {
        Integer seqId = new Integer(seq.getSequenceId());
        Map sequences = (Map)oldSequencesByDestination.get(dd);
        List itemIdentities = cloneItemIdentities(seq.getItemIdentities());
        if(sequences == null)
        {
            sequences = new HashMap(11);
            oldSequencesByDestination.put(dd, sequences);
        }
        sequences.put(seqId, itemIdentities);
    }

    void markSequenceItemIdentitiesAsUnchanged(DataDestination dd, Sequence seq)
    {
        Integer seqId = new Integer(seq.getSequenceId());
        Map sequences = (Map)oldSequencesByDestination.get(dd);
        if(sequences == null)
        {
            sequences = new HashMap(11);
            oldSequencesByDestination.put(dd, sequences);
        }
        sequences.put(seqId, seq.getItemIdentities());
    }

    Sequence rebuildSequenceIfNecessary(DataDestination dd, Sequence seq, Object item, DataMessage dmsg)
    {
        Map sequences = (Map)oldSequencesByDestination.get(dd);
        Integer seqId = new Integer(seq.getSequenceId());
        Object clientId = dmsg.getClientId();
        if(sequences != null && sequences.get(seqId) != null)
            return seq;
        if(seq.getFillParameters() != null)
        {
            DataMessage updMessage = InternalMessage.createMessage();
            updMessage.setOperation(16);
            Object args[] = new Object[3];
            args[0] = ((Object) (seq.getFillParameters()));
            args[1] = item;
            args[2] = dmsg.getOperation() != 0 ? ((Object) (Boolean.FALSE)) : ((Object) (Boolean.TRUE));
            updMessage.setBody(((Object) (args)));
            Integer action = (Integer)dd.getAdapter().invoke(updMessage);
            if(action.intValue() == 1)
                seq = refreshSequence(dd, seq.getFillParameters());
            else
            if(action.intValue() == 2)
            {
                ItemIdentity instId = dd.getSequenceManager().getItemIdentityForInstance(item);
                if(!seq.containsItem(instId))
                    dd.getSequenceManager().addItemIdentityToSequence(seq, -1, instId, this);
            } else
            if(action.intValue() == 3)
            {
                ItemIdentity instId = dd.getSequenceManager().getItemIdentityForInstance(item);
                int pos = seq.indexOf(instId);
                if(pos > 0)
                    dd.getSequenceManager().removeItemIdentityFromSequence(seq, pos, instId, this);
            } else
            if(clientUpdateCollections != null)
            {
                UpdateCollectionMessage clientUC = (UpdateCollectionMessage)clientUpdateCollections.get(new ArrayKey(seq.getFillParameters()));
                if(clientUC != null)
                    clientUC.setUpdateMode(2);
            }
        }
        return seq;
    }

    Sequence refreshSequence(DataDestination dd, Object fillParameters[])
    {
        DataServiceTransaction dtx = isInTransaction() ? null : begin(dataService, false);
        Collection itemInstances;
        if(dtx != null)
            dtx.setRefill(true);
        DataMessage fillMessage = InternalMessage.createMessage();
        fillMessage.setOperation(1);
        fillMessage.setBody(((Object) (fillParameters)));
        fillMessage.setClientId(clientId);
        itemInstances = (Collection)dd.getAdapter().invoke(fillMessage);
        if(dtx != null)
            dtx.setRefill(false);
        if(dtx != null)
            dtx.commit();
        break MISSING_BLOCK_LABEL_101;
        Exception exception;
        exception;
        if(dtx != null)
            dtx.commit();
        throw exception;
        return dd.getSequenceManager().createSequence(itemInstances, fillParameters, null, this, null, null, null);
    }

    private void doRefreshFill(RefreshFill fill)
    {
        DataDestination dataDest = getDataDestinationWithError(fill.destination);
        Object fparams[];
        if(fill.fillParameters != null)
            fparams = fill.fillParameters.toArray();
        else
            fparams = null;
        List matches = dataDest.getSequenceManager().getMatchingSequences(fparams);
        if(matches == null)
        {
            if(Log.isDebug())
                Log.getLogger("DataService.Transaction").debug("Refresh fill: " + fill + " matched no sequences currently managed on clients.");
            return;
        }
        for(int i = 0; i < matches.size(); i++)
            refreshSequence(dataDest, ((Sequence)matches.get(i)).getFillParameters());

        if(Log.isDebug())
            Log.getLogger("DataService.Transaction").debug("Refresh fill: " + fill + " refreshed: " + matches.size() + " fills");
    }

    private void processRefreshFills()
    {
        if(refreshFills == null)
            return;
        for(int i = 0; i < refreshFills.size(); i++)
            doRefreshFill((RefreshFill)refreshFills.get(i));

    }

    int getItemIndexInOriginalSequence(DataDestination dd, Sequence seq, Map itemId)
    {
        List itemIds = getItemsInOriginalSequence(dd, seq, itemId);
        return itemIds != null ? itemIds.indexOf(itemId) : -1;
    }

    boolean hasItemInOriginalSequence(DataDestination dd, Sequence seq, Map itemId)
    {
        List itemIds = getItemsInOriginalSequence(dd, seq, itemId);
        return itemIds != null && itemIds.contains(itemId);
    }

    private List getItemsInOriginalSequence(DataDestination dd, Sequence seq, Map itemId)
    {
        Map sequences = (Map)oldSequencesByDestination.get(dd);
        if(sequences == null)
        {
            return null;
        } else
        {
            Integer seqId = new Integer(seq.getSequenceId());
            return (List)sequences.get(seqId);
        }
    }

    void clearCurrentTransaction()
    {
        if(currentTransaction.get() == this)
            currentTransaction.set(null);
        else
            throw new RuntimeException("Internal error - current transaction changed out from underneath the DataServiceTransaction!");
    }

    DataService getDataService()
    {
        return dataService;
    }

    void addProcessedMessage(DataMessage msg)
    {
        MessageBatch newBatch = new MessageBatch();
        newBatch.incomingBatchedMessage = msg;
        newBatch.messagesToPush = new ArrayList(1);
        newBatch.messagesToPush.add(msg);
        newBatch.sendMessagesToPeers = sendMessagesToPeers;
        addProcessedBatch(newBatch);
    }

    DataDestination getDataDestinationWithError(String destination)
    {
        DataDestination dataDest = (DataDestination)dataService.getDestinationByName(destination);
        if(dataDest == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(0);
        }
        return dataDest;
    }

    void addClientUpdateCollection(UpdateCollectionMessage message)
    {
        if(clientUpdateCollections == null)
            clientUpdateCollections = new LinkedHashMap(3);
        Object collectionId = message.getCollectionId();
        Object collectionKey = (collectionId instanceof Object[]) ? ((Object) (new ArrayKey((Object[])(Object[])collectionId))) : collectionId;
        clientUpdateCollections.put(collectionKey, message);
    }

    void addServerUpdateCollection(UpdateCollectionMessage message)
    {
        if(serverUpdateCollections == null)
            serverUpdateCollections = new LinkedHashMap(3);
        Object collectionId = message.getCollectionId();
        Object collectionKey = (collectionId instanceof Object[]) ? ((Object) (new ArrayKey((Object[])(Object[])collectionId))) : collectionId;
        serverUpdateCollections.put(collectionKey, message);
    }

    UpdateCollectionMessage getOrCreateServerUpdateCollection(DataDestination dest, Sequence sequence)
    {
        UpdateCollectionMessage fmsg;
        if(serverUpdateCollections == null || (fmsg = (UpdateCollectionMessage)serverUpdateCollections.get(new ArrayKey(sequence.getFillParameters()))) == null)
        {
            fmsg = new UpdateCollectionMessage();
            fmsg.setClientId(getClientId());
            fmsg.setUpdateMode(1);
            fmsg.setCollectionId(((Object) (sequence.getFillParameters())));
            fmsg.setDestination(dest.getId());
            fmsg.setCorrelationId(batchId);
            fmsg.setMessageId(getDataService().getNewMessageId());
            addServerUpdateCollection(fmsg);
        }
        return fmsg;
    }

    void addItemIdentityToUpdateCollection(DataDestination dest, Sequence sequence, int position, Map itemIdentity)
    {
        UpdateCollectionMessage fmsg = getOrCreateServerUpdateCollection(dest, sequence);
        fmsg.addItemIdentityChange(0, position, itemIdentity);
    }

    void removeItemIdentityFromUpdateCollection(DataDestination dest, Sequence sequence, int position, Map itemIdentity)
    {
        UpdateCollectionMessage fmsg = getOrCreateServerUpdateCollection(dest, sequence);
        fmsg.addItemIdentityChange(1, position, itemIdentity);
    }

    void applyUpdateCollectionMessage(DataDestination dd, Sequence seq, UpdateCollectionMessage ucmsg)
    {
        synchronized(seq)
        {
            saveSequenceItemIdentities(dd, seq);
            Object ranges[] = (Object[])(Object[])ucmsg.getBody();
            for(int i = 0; i < ranges.length; i++)
            {
                UpdateCollectionRange range = (UpdateCollectionRange)ranges[i];
                int p = 0;
                for(int j = 0; j < range.identities.length; j++)
                {
                    ItemIdentity identity = dd.getSequenceManager().toItemIdentity((Map)range.identities[j]);
                    if(range.updateType == 0)
                    {
                        if(!seq.containsItem(identity))
                            dd.getSequenceManager().addItemIdentityToSequence(seq, range.position + p++, identity, null);
                    } else
                    {
                        dd.getSequenceManager().removeItemIdentityFromSequence(seq, range.position, identity, null);
                    }
                }

            }

        }
    }

    public static final String USER_TX_JNDI_NAME = "java:comp/UserTransaction";
    public static final String LOG_CATEGORY = "DataService.Transaction";
    static ThreadLocal currentTransaction = new ThreadLocal();
    DataService dataService;
    boolean refill;
    boolean sendMessagesToPeers;
    boolean pushFromPeer;
    Map instancesByDestination;
    Map newSequenceItemsByDestination;
    Map newSequencesByDestination;
    Map oldSequencesByDestination;
    UserTransaction userTransaction;
    List synchronizations;
    List refreshFills;
    boolean committed;
    boolean completed;
    boolean hasErrors;
    boolean rollbackOnly;
    List processedBatches;
    LinkedHashMap clientUpdateCollections;
    LinkedHashMap serverUpdateCollections;
    Object clientId;
    String batchId;
    Map attributes;

}
