// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ItemIdentity.java

package flex.data;

import flex.data.config.MetadataSettings;
import java.io.Serializable;
import java.util.*;

// Referenced classes of package flex.data:
//            DataServiceException, DataDestination, DataService

public class ItemIdentity
    implements Map, Serializable
{

    private ItemIdentity(Map internal)
    {
        cachedHashCode = 0x7fffffff;
        this.internal = internal;
    }

    public static ItemIdentity getIdentityFor(Object o, DataDestination destination)
    {
        List idPropNames = getIdentityPropertyNamesFor(destination);
        int size = idPropNames.size();
        Map internalMap;
        if(size == 1)
        {
            String propName = idPropNames.get(0).toString();
            Object idValue = getIdentityPropertyValue(propName, o, destination);
            internalMap = Collections.singletonMap(propName, idValue);
        } else
        {
            internalMap = new HashMap(size);
            for(int i = 0; i < idPropNames.size(); i++)
            {
                String propName = idPropNames.get(i).toString();
                Object idValue = getIdentityPropertyValue(propName, o, destination);
                internalMap.put(propName, idValue);
            }

        }
        return new ItemIdentity(internalMap);
    }

    public static ItemIdentity toItemIdentity(Map map, DataDestination destination)
    {
        ItemIdentity result;
        if(map instanceof ItemIdentity)
            result = (ItemIdentity)map;
        else
        if(map != null)
        {
            List idPropNames = getIdentityPropertyNamesFor(destination);
            int size = idPropNames.size();
            Map internalMap;
            if(size == 1)
            {
                String propName = idPropNames.get(0).toString();
                Object idValue = adjustPropertyValue(map.get(propName));
                internalMap = Collections.singletonMap(propName, idValue);
            } else
            {
                internalMap = new HashMap(size);
                for(int i = 0; i < idPropNames.size(); i++)
                {
                    String propName = idPropNames.get(i).toString();
                    Object idValue = adjustPropertyValue(map.get(propName));
                    internalMap.put(propName, idValue);
                }

            }
            result = new ItemIdentity(internalMap);
        } else
        {
            result = null;
        }
        return result;
    }

    private static List getIdentityPropertyNamesFor(DataDestination destination)
    {
        return destination.getPropertySettings().getIdentityPropertyNames();
    }

    private static Object adjustPropertyValue(Object value)
    {
        if(value instanceof Number)
        {
            Class valueType = value.getClass();
            if(valueType != (java.lang.Integer.class) && valueType != (java.lang.Double.class))
                if(valueType == (java.lang.Long.class))
                {
                    Number number = (Number)value;
                    long longValue = number.longValue();
                    if(longValue >= 0x80000000L && longValue <= 0x7fffffffL)
                        value = new Integer(number.intValue());
                } else
                if(valueType == (java.lang.Float.class))
                {
                    Number number = (Number)value;
                    value = new Double(number.doubleValue());
                } else
                {
                    Number number = (Number)value;
                    value = new Integer(number.intValue());
                }
        }
        return value;
    }

    private static Object getIdentityPropertyValue(String propertyName, Object object, DataDestination destination)
    {
        try
        {
            Object value = DataService.getPropertyOnClientObject(object, propertyName);
            return adjustPropertyValue(value);
        }
        catch(RuntimeException e)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10152, new Object[] {
                propertyName, destination.getId()
            });
            dse.setRootCause(e);
            throw dse;
        }
    }

    public int size()
    {
        return internal.size();
    }

    public boolean isEmpty()
    {
        return internal.isEmpty();
    }

    public boolean containsKey(Object key)
    {
        return internal.containsKey(key);
    }

    public boolean containsValue(Object value)
    {
        return internal.containsValue(value);
    }

    public Object get(Object key)
    {
        return internal.get(key);
    }

    public Object put(Object key, Object value)
    {
        throw new UnsupportedOperationException();
    }

    public Object remove(Object key)
    {
        throw new UnsupportedOperationException();
    }

    public void putAll(Map t)
    {
        throw new UnsupportedOperationException();
    }

    public void clear()
    {
        throw new UnsupportedOperationException();
    }

    public Set keySet()
    {
        return internal.keySet();
    }

    public Collection values()
    {
        return internal.values();
    }

    public Set entrySet()
    {
        return internal.entrySet();
    }

    public boolean equals(Object o)
    {
        return internal.equals(o);
    }

    public int hashCode()
    {
        int result = cachedHashCode;
        if(result == 0x7fffffff)
        {
            result = internal.hashCode();
            cachedHashCode = result;
        }
        return result;
    }

    public String toString()
    {
        return internal.toString();
    }

    private Map internal;
    private int cachedHashCode;
}
