// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PagingManager.java

package flex.data;

import flex.data.messages.PagedMessage;
import flex.messaging.messages.Message;
import java.util.*;

// Referenced classes of package flex.data:
//            SequenceManager

public final class PagingManager
{

    public PagingManager(SequenceManager sequenceManager, int pageSize)
    {
        this.sequenceManager = sequenceManager;
        this.pageSize = pageSize;
    }

    public PagedMessage getPagedMessage(Message inMessage, Collection itemIds)
    {
        PagedMessage pagedMessage = new PagedMessage();
        int messagePageSize = pageSize == -1 ? itemIds.size() : pageSize;
        if(inMessage.getHeader("pageSize") != null)
        {
            int msgPageSize = ((Integer)inMessage.getHeader("pageSize")).intValue();
            messagePageSize = msgPageSize != -1 ? msgPageSize : itemIds.size();
        }
        int pageIndex = 0;
        if(inMessage.getHeader("pageIndex") != null)
            pageIndex = ((Integer)inMessage.getHeader("pageIndex")).intValue();
        pagedMessage.setPageIndex(pageIndex);
        int numPages = 0;
        if(messagePageSize > 0)
        {
            numPages = Math.round(itemIds.size() / messagePageSize);
            if(Math.IEEEremainder(itemIds.size(), messagePageSize) != 0.0D)
                numPages++;
        }
        pagedMessage.setPageCount(numPages);
        int itemFirstIndex = pageIndex * messagePageSize;
        int itemLastIndex = itemFirstIndex + messagePageSize <= itemIds.size() ? itemFirstIndex + messagePageSize : itemIds.size();
        List pagedItemIds;
        if(itemIds instanceof List)
        {
            pagedItemIds = ((List)itemIds).subList(itemFirstIndex, itemLastIndex);
        } else
        {
            pagedItemIds = new ArrayList(itemLastIndex - itemFirstIndex);
            Iterator it = itemIds.iterator();
            int i;
            for(i = 0; i < itemFirstIndex && it.hasNext(); i++)
                it.next();

            for(; i < itemLastIndex && it.hasNext(); i++)
                pagedItemIds.add(it.next());

        }
        pagedMessage.setBody(pagedItemIds);
        pagedMessage.setSequenceSize(itemIds.size());
        return pagedMessage;
    }

    private int pageSize;
    private SequenceManager sequenceManager;
    private static final String PAGE_INDEX_HEADER = "pageIndex";
    private static final String PAGE_SIZE_HEADER = "pageSize";
}
