// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Sequence.java

package flex.data;

import edu.emory.mathcs.backport.java.util.concurrent.ConcurrentHashMap;
import java.util.*;

// Referenced classes of package flex.data:
//            BagList, AssociatedItemIndex, ItemIdentity

public final class Sequence
{

    public Sequence()
    {
        subscriberIds = new ConcurrentHashMap();
        itemIds = Collections.synchronizedList(new BagList());
    }

    public AssociatedItemIndex getAssociatedItemIndex()
    {
        return associatedItemIndex;
    }

    public void setAssociatedItemIndex(AssociatedItemIndex index)
    {
        associatedItemIndex = index;
    }

    public Object[] getFillParameters()
    {
        return fillParams;
    }

    public void setFillParameters(Object fillParams[])
    {
        this.fillParams = fillParams;
    }

    public void addItemIdentity(ItemIdentity itemId)
    {
        itemIds.add(itemId);
    }

    public void addItemIdentity(int position, ItemIdentity itemId)
    {
        itemIds.add(position, itemId);
    }

    public void removeItemIdentity(ItemIdentity itemId)
    {
        itemIds.remove(itemId);
    }

    public void removeItemIdentityAt(int index)
    {
        itemIds.remove(index);
    }

    public void clearItemIdentities()
    {
        itemIds.clear();
    }

    public List getItemIdentities()
    {
        return itemIds;
    }

    public int getNumItems()
    {
        return itemIds.size();
    }

    public int getSequenceId()
    {
        return sequenceId;
    }

    public void setSequenceId(int sequenceId)
    {
        this.sequenceId = sequenceId;
    }

    public boolean addSubscriber(Object clientId)
    {
        Integer refCnt = (Integer)subscriberIds.get(clientId);
        Integer newRefCnt;
        if(refCnt == null)
            newRefCnt = new Integer(1);
        else
            newRefCnt = new Integer(refCnt.intValue() + 1);
        subscriberIds.put(clientId, newRefCnt);
        return newRefCnt.intValue() == 1;
    }

    public boolean isSubscriber(Object clientId)
    {
        return subscriberIds.get(clientId) != null;
    }

    public int getSequenceSize()
    {
        return itemIds.size();
    }

    public int getNumSubscribers()
    {
        return subscriberIds.size();
    }

    public boolean removeSubscriber(Object clientId)
    {
        Integer refCnt = (Integer)subscriberIds.get(clientId);
        if(refCnt != null)
        {
            int newRefs = refCnt.intValue() - 1;
            if(newRefs > 0)
            {
                subscriberIds.put(clientId, new Integer(newRefs));
                return false;
            } else
            {
                subscriberIds.remove(clientId);
                return true;
            }
        } else
        {
            return true;
        }
    }

    public void removeAllSubscriberReferences(Object clientId)
    {
        subscriberIds.remove(clientId);
    }

    public Set getSubscriberIds()
    {
        return subscriberIds.keySet();
    }

    public Set getSubscriberEntries()
    {
        return subscriberIds.entrySet();
    }

    public boolean containsItem(ItemIdentity idMap)
    {
        return itemIds.contains(idMap);
    }

    public int indexOf(ItemIdentity idMap)
    {
        return itemIds.indexOf(idMap);
    }

    public String toString()
    {
        StringBuffer sb = new StringBuffer();
        sb.append("[seqId=" + getSequenceId());
        if(getFillParameters() != null)
            sb.append(", fillParams=" + Arrays.asList(getFillParameters()));
        else
        if(getAssociatedItemIndex() != null)
            sb.append(", association=" + getAssociatedItemIndex());
        else
            sb.append(", singleItem");
        if(itemIds == null)
            sb.append(", null ids");
        else
            sb.append(", ids=" + itemIds.toString() + "]");
        return sb.toString();
    }

    private AssociatedItemIndex associatedItemIndex;
    private Object fillParams[];
    private List itemIds;
    private int sequenceId;
    private Map subscriberIds;
}
