// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SequenceManager.java

package flex.data;

import edu.emory.mathcs.backport.java.util.concurrent.ConcurrentHashMap;
import flex.data.adapters.JavaAdapter;
import flex.data.config.AssociationSetting;
import flex.data.config.DataNetworkSettings;
import flex.data.config.MetadataSettings;
import flex.data.messages.DataAssociationMessage;
import flex.data.messages.DataMessage;
import flex.data.messages.SequencedMessage;
import flex.data.messages.UpdateCollectionMessage;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.*;
import flex.messaging.util.ExceptionUtil;
import java.util.*;

// Referenced classes of package flex.data:
//            DataService, PagingManager, Sequence, DataDestination, 
//            AssociatedItemIndex, ArrayKey, ItemIdentity, DataServiceException, 
//            DataServiceTransaction

public class SequenceManager
{
    static class ProxyInfoKey
    {

        public boolean equals(Object other)
        {
            ProxyInfoKey otherKey = (ProxyInfoKey)other;
            return SequenceManager.areEqual(otherKey.identity, identity) && otherKey.dest == dest;
        }

        public int hashCode()
        {
            return identity.hashCode() * 13 + dest.hashCode();
        }

        ItemIdentity identity;
        DataDestination dest;

        ProxyInfoKey(ItemIdentity id, DataDestination dest)
        {
            identity = id;
            this.dest = dest;
        }
    }

    static class Item
    {

        Object instance;
        int proxies[];

        Item()
        {
        }
    }


    public SequenceManager(DataDestination destination)
    {
        itemIdToSequencesIndex = new HashMap();
        fillToSequenceIndex = new ConcurrentHashMap();
        aiiToSequenceIndex = new HashMap();
        subscriberToSequencesIndex = new HashMap();
        nestedClientIdToParentClientIdIndex = new HashMap();
        clientIdToClientIdMapIndex = new HashMap();
        numSMOSequences = 0;
        this.destination = destination;
        dataService = (DataService)destination.getService();
        items = Collections.synchronizedMap(new HashMap());
        sequences = new ArrayList();
        DataNetworkSettings dataNetworkSettings = (DataNetworkSettings)destination.getNetworkSettings();
        pagingManager = new PagingManager(this, dataNetworkSettings.getPageSize());
    }

    public Item getItem(Map itemId)
    {
        return (Item)items.get(toItemIdentity(itemId));
    }

    public Map getIdentityForInstance(Object o)
    {
        return ItemIdentity.getIdentityFor(o, destination);
    }

    final ItemIdentity getItemIdentityForInstance(Object o)
    {
        return toItemIdentity(getIdentityForInstance(o));
    }

    public void setIdentityForInstance(Object o, Map identity)
    {
        List idPropNames = destination.getPropertySettings().getIdentityPropertyNames();
        for(int i = 0; i < idPropNames.size(); i++)
        {
            String idPropName = (String)idPropNames.get(i);
            DataService.setPropertyOnClientObject(o, idPropName, identity.get(idPropName));
        }

    }

    public Sequence getSequence(int sequenceId)
    {
        List list = sequences;
        JVM INSTR monitorenter ;
        if(sequenceId < sequences.size())
            return (Sequence)sequences.get(sequenceId);
        null;
        list;
        JVM INSTR monitorexit ;
        return;
        Exception exception;
        exception;
        throw exception;
    }

    public void addSubscriberToSequence(int sequenceId, Object clientId, Object endpoint)
    {
        if(sequenceId == -1)
            return;
        synchronized(sequences)
        {
            try
            {
                Sequence s = (Sequence)sequences.get(sequenceId);
                if(s == null)
                    Log.getLogger("DataService.General").error("Attempt to subscribe to null sequence: " + sequenceId + " clientId: " + clientId);
                else
                if(s.addSubscriber(clientId))
                {
                    List sequencesForSubscriber = (List)subscriberToSequencesIndex.get(clientId);
                    if(sequencesForSubscriber == null)
                    {
                        if(endpoint != null)
                            subscribeToEndpoint(clientId, endpoint);
                        sequencesForSubscriber = new ArrayList();
                        subscriberToSequencesIndex.put(clientId, sequencesForSubscriber);
                    }
                    sequencesForSubscriber.add(s);
                }
            }
            catch(IndexOutOfBoundsException e)
            {
                Log.getLogger("DataService.General").error("Attempt to subscribe to out of range sequence: " + sequenceId + " clientId: " + clientId);
            }
        }
    }

    public boolean removeSubscriberFromSequence(int sequenceId, Object clientId)
    {
        List list = sequences;
        JVM INSTR monitorenter ;
        Sequence s = null;
        if(sequenceId < sequences.size())
            s = (Sequence)sequences.get(sequenceId);
        if(s == null)
            Log.getLogger("DataService.General").warn("Warning - attempt to remove client: " + clientId + " from sequence: " + sequenceId + " which does not exist");
        else
        if(s.removeSubscriber(clientId))
        {
            List sequencesForSubscriber = (List)subscriberToSequencesIndex.get(clientId);
            if(sequencesForSubscriber == null || !sequencesForSubscriber.remove(s))
            {
                Log.getLogger("DataService.General").warn("Warning - attempt to unsubscribe client not found in subscribers index: " + clientId + " from sequence: " + sequenceId);
            } else
            {
                if(sequencesForSubscriber.size() == 0)
                {
                    subscriberToSequencesIndex.remove(clientId);
                    disassociateClientIdFromClientIdMap(clientId);
                }
                if(s.getNumSubscribers() == 0)
                {
                    removeSequence(sequenceId);
                    return true;
                }
            }
        }
        list;
        JVM INSTR monitorexit ;
          goto _L1
        Exception exception;
        exception;
        throw exception;
_L1:
        return false;
    }

    public void unsubscribeClient(Object clientId)
    {
        List sequencesForSubscriber;
label0:
        {
            if(Log.isDebug())
                logSequenceInfo("Before unsubscribe: " + clientId);
            synchronized(sequences)
            {
                sequencesForSubscriber = (List)subscriberToSequencesIndex.get(clientId);
                if(sequencesForSubscriber != null)
                    break label0;
            }
            return;
        }
        for(int i = 0; i < sequencesForSubscriber.size(); i++)
        {
            Sequence s = (Sequence)sequencesForSubscriber.get(i);
            s.removeAllSubscriberReferences(clientId);
            if(s.getNumSubscribers() == 0)
                removeSequence(s.getSequenceId());
            disassociateClientIdFromClientIdMap(clientId);
        }

        subscriberToSequencesIndex.remove(clientId);
        list;
        JVM INSTR monitorexit ;
          goto _L1
        exception;
        throw exception;
_L1:
        if(Log.isDebug())
            logSequenceInfo("After unsubscribe: " + clientId);
        return;
    }

    public void unsubscribeClientFromSequence(DataMessage dmsg, int sequenceId, Object collectionId, boolean releaseItem)
    {
        Sequence seq;
label0:
        {
            if(Log.isDebug())
                logSequenceInfo("Before unsubscribe client from sequence: " + dmsg.getClientId() + " collectionId: " + collectionId);
            synchronized(sequences)
            {
                seq = null;
                if(sequenceId < sequences.size())
                    seq = (Sequence)sequences.get(sequenceId);
                if(seq != null)
                    break label0;
                Log.getLogger("DataService.General").warn("Warning - attempt to unsubscribe client " + dmsg.getClientId() + " from collectionId: " + collectionId + " for sequence: " + sequenceId + " where sequence is missing.");
            }
            return;
        }
        List itemIds = null;
        synchronized(seq)
        {
            if(destination.getNumSequencedAssociations() > 0)
                itemIds = new ArrayList(seq.getItemIdentities());
            if(!(collectionId instanceof Map) || releaseItem)
                removeSubscriberFromSequence(seq.getSequenceId(), dmsg.getClientId());
        }
        if(destination.getNumSequencedAssociations() > 0)
            unsubscribeClientFromNestedSequences(seq, itemIds, (Map)dmsg.getHeader("destClientIds"), new HashMap());
        list;
        JVM INSTR monitorexit ;
          goto _L1
        exception1;
        throw exception1;
_L1:
        if(Log.isDebug())
            logSequenceInfo("After unsubscribe client from sequence: " + dmsg.getClientId() + " collectionId " + collectionId);
        return;
    }

    public void unsubscribeClientFromNestedSequences(Sequence parentSeq, List itemIds, Map clientIds, Map pendingUnsubs)
    {
        if(Log.isDebug())
        {
            List associationSettings = destination.getPropertySettings().getAssociationSettings();
            Iterator nestedIter = associationSettings.iterator();
            do
            {
                if(!nestedIter.hasNext())
                    break;
                AssociationSetting associationSetting = (AssociationSetting)nestedIter.next();
                if(associationSetting.getSequenced())
                {
                    String nestedDestName = associationSetting.getDestination();
                    DataDestination nestedDestination = (DataDestination)dataService.getDestinationByName(nestedDestName);
                    SequenceManager nestedSequenceManager = nestedDestination.getSequenceManager();
                    Object clientId = clientIds.get(nestedDestName);
                    nestedSequenceManager.logSequenceInfo("Before unsubscribe client from nested sequence: nestedDest=" + nestedDestName + " clientId=" + clientId + " itemIds=" + itemIds);
                }
            } while(true);
        }
label0:
        for(int i = 0; i < itemIds.size(); i++)
        {
            ItemIdentity itemIdentity = toItemIdentity((Map)itemIds.get(i));
            ProxyInfoKey key = new ProxyInfoKey(itemIdentity, destination);
            if(pendingUnsubs.get(key) != null)
                continue;
            pendingUnsubs.put(key, Boolean.TRUE);
            List associationSettings = destination.getPropertySettings().getAssociationSettings();
            Iterator nestedIter = associationSettings.iterator();
            do
            {
                AssociationSetting associationSetting;
                do
                {
                    if(!nestedIter.hasNext())
                        continue label0;
                    associationSetting = (AssociationSetting)nestedIter.next();
                } while(!associationSetting.getSequenced());
                String propName = associationSetting.getProperty();
                String nestedDestName = associationSetting.getDestination();
                DataDestination nestedDestination = (DataDestination)dataService.getDestinationByName(nestedDestName);
                SequenceManager nestedSequenceManager = nestedDestination.getSequenceManager();
                AssociatedItemIndex itemIndex = new AssociatedItemIndex(destination, itemIdentity, propName, associationSetting.getRelation(), associationSetting.getLazy(), associationSetting.getCacheReferencedItems());
                Sequence nestedSequence = (Sequence)nestedSequenceManager.aiiToSequenceIndex.get(itemIndex);
                if(nestedSequence != null)
                {
                    Object clientId = clientIds.get(nestedDestName);
                    List nestedIds = null;
                    synchronized(nestedSequence)
                    {
                        if(nestedDestination.getNumSequencedAssociations() > 0)
                            nestedIds = new ArrayList(nestedSequence.getItemIdentities());
                        nestedSequenceManager.removeSubscriberFromSequence(nestedSequence.getSequenceId(), clientId);
                    }
                    if(!associationSetting.getLazy() && nestedDestination.getNumSequencedAssociations() > 0)
                        nestedSequenceManager.unsubscribeClientFromNestedSequences(nestedSequence, nestedIds, clientIds, pendingUnsubs);
                } else
                if(Log.isDebug() && !associationSetting.getLazy())
                    Log.getLogger("DataService.General").debug("In unsubscribe client from collection.  Could not find child sequence for association: " + itemIndex);
            } while(true);
        }

        if(Log.isDebug())
        {
            List associationSettings = destination.getPropertySettings().getAssociationSettings();
            Iterator nestedIter = associationSettings.iterator();
            do
            {
                if(!nestedIter.hasNext())
                    break;
                AssociationSetting associationSetting = (AssociationSetting)nestedIter.next();
                if(associationSetting.getSequenced())
                {
                    String nestedDestName = associationSetting.getDestination();
                    DataDestination nestedDestination = (DataDestination)dataService.getDestinationByName(nestedDestName);
                    SequenceManager nestedSequenceManager = nestedDestination.getSequenceManager();
                    Object clientId = clientIds.get(nestedDestName);
                    nestedSequenceManager.logSequenceInfo("After unsubscribe client from nested sequence: nestedDest=" + nestedDestName + " clientId=" + clientId);
                }
            } while(true);
        }
    }

    private void removeSequence(int sequenceId)
    {
        Sequence seq;
label0:
        {
            synchronized(sequences)
            {
                seq = (Sequence)sequences.get(sequenceId);
                if(seq != null)
                    break label0;
                Log.getLogger("DataService.General").error("Missing sequence in removeSequence call: " + sequenceId);
            }
            return;
        }
        synchronized(seq)
        {
            if(seq.getFillParameters() != null)
            {
                ArrayKey fillKey = new ArrayKey((Object[])seq.getFillParameters());
                fillToSequenceIndex.remove(fillKey);
            } else
            if(seq.getAssociatedItemIndex() != null)
                aiiToSequenceIndex.remove(seq.getAssociatedItemIndex());
            else
                numSMOSequences--;
            List itemIds = seq.getItemIdentities();
            if(itemIds != null)
            {
                int idx;
                for(; itemIds.size() > 0; removeItemIdentityFromSequence(seq, idx, (ItemIdentity)itemIds.get(idx), null))
                    idx = itemIds.size() - 1;

            }
            sequences.set(sequenceId, null);
        }
        for(int i = sequences.size() - 1; i >= 0 && sequences.get(i) == null; i--)
            sequences.remove(i);

        list;
        JVM INSTR monitorexit ;
          goto _L1
        exception1;
        throw exception1;
_L1:
    }

    public AcknowledgeMessage manageSequence(DataMessage incomingMessage, Collection outgoingResult)
    {
        return manageSequence(incomingMessage, outgoingResult, null);
    }

    public AcknowledgeMessage manageSequence(DataMessage incomingMessage, Collection outgoingResult, DataServiceTransaction dtx)
    {
        if(Log.isDebug())
            logSequenceInfo("Before manage sequence");
        AcknowledgeMessage ack = null;
        if(incomingMessage.getHeader("sync") != null)
            ack = getNoSyncSequencedMessage(incomingMessage, outgoingResult);
        else
        if(incomingMessage.getOperation() == 1)
        {
            Sequence sequence = createSequence(outgoingResult, (Object[])(Object[])incomingMessage.getBody(), null, dtx, incomingMessage.getClientId(), (Map)incomingMessage.getHeader("destClientIds"), incomingMessage.getHeader("DSEndpoint"));
            ack = getSequencedMessage(incomingMessage, sequence);
        } else
        if(incomingMessage.getOperation() == 15)
        {
            Sequence sequence = getSequence(incomingMessage, incomingMessage.getBody());
            ack = getSequencedMessage(incomingMessage, sequence);
        } else
        if(incomingMessage.getOperation() == 2)
        {
            Sequence sequence = createSequence(outgoingResult, null, null, null, incomingMessage.getClientId(), (Map)incomingMessage.getHeader("destClientIds"), incomingMessage.getHeader("DSEndpoint"));
            ack = getSequencedMessage(incomingMessage, sequence);
        } else
        {
            List messagesToPush = (List)outgoingResult;
            processUpdateCollectionMessages(dtx, messagesToPush);
            for(int i = 0; i < messagesToPush.size(); i++)
            {
                Message m = (Message)messagesToPush.get(i);
                if(!(m instanceof DataMessage))
                    continue;
                DataMessage dataMessage = (DataMessage)m;
                int origOp = dataMessage.getOperation();
                if(origOp == 11)
                    dataMessage.setOperation(0);
                if(dataMessage.getOperation() == 0 && destination.getNumSequencedAssociations() > 0)
                {
                    ItemIdentity itemId = getItemIdentityForInstance(dataMessage.unwrapBody());
                    Item item = (Item)this.items.get(itemId);
                    if(item == null)
                    {
                        item = new Item();
                        this.items.put(itemId, item);
                    }
                    Map clientIdMap = null;
                    Object endpoint = null;
                    if(origOp == 11)
                    {
                        clientIdMap = (Map)dataMessage.getHeader("destClientIds");
                        endpoint = dataMessage.getHeader("DSEndpoint");
                    }
                    item.proxies = createProxiesForItem(null, itemId, dataMessage.unwrapBody(), clientIdMap, endpoint, new TreeMap());
                    if(destination.getCacheItems())
                        item.instance = dataMessage.unwrapBody();
                    if(item.proxies != null)
                        dataMessage.setHeader("sequenceProxy", createProxyInfoMap(itemId, dataMessage.unwrapBody(), item.proxies, clientIdMap, endpoint, new HashMap(4)));
                }
                try
                {
                    syncAndPushSequenceChanges(dataMessage, dtx);
                    continue;
                }
                finally
                {
                    if(origOp != dataMessage.getOperation())
                    {
                        dataMessage.setOperation(origOp);
                        if(origOp == 11 && !dtx.isPushFromPeer())
                        {
                            List items = new ArrayList();
                            items.add(dataMessage.unwrapBody());
                            Sequence sequence = createSequence(items, null, null, null, dataMessage.getClientId(), (Map)dataMessage.getHeader("destClientIds"), dataMessage.getHeader("DSEndpoint"));
                            SequencedMessage sm = getSequencedMessage(dataMessage, sequence);
                            sm.setDataMessage(dataMessage);
                            sm.setMessageId(dataMessage.getMessageId());
                            messagesToPush.set(i, sm);
                        }
                    }
                }
            }

            ack = new AcknowledgeMessage();
            ack.setBody(((Object) (outgoingResult.toArray())));
        }
        if(Log.isDebug())
            logSequenceInfo("After manage sequence");
        return ack;
    }

    void processUpdateCollectionMessages(DataServiceTransaction dtx, List messagesToPush)
    {
        for(int i = 0; i < messagesToPush.size(); i++)
        {
            Message m = (Message)messagesToPush.get(i);
            if(!(m instanceof UpdateCollectionMessage))
                continue;
            UpdateCollectionMessage ucmsg = (UpdateCollectionMessage)m;
            dataService.fixIdsInUpdateCollection(ucmsg, dtx.getProcessedBatches());
            flex.messaging.services.ServiceAdapter adapter = destination.getAdapter();
            if(!(adapter instanceof JavaAdapter) || ((JavaAdapter)adapter).fillNeedsAutoRefresh(ucmsg.getCollectionId()))
                continue;
            Sequence seq = getSequence(null, ucmsg.getCollectionId());
            if(seq != null)
                dtx.applyUpdateCollectionMessage(destination, seq, ucmsg);
        }

    }

    public SequencedMessage getPageFromSequence(DataMessage inMessage)
    {
        int sequenceId = -1;
        Integer sequenceHeader = (Integer)inMessage.getHeader("sequenceId");
        if(sequenceHeader != null)
            sequenceId = sequenceHeader.intValue();
        if(sequenceId != -1)
        {
            Object sequence = null;
            synchronized(sequences)
            {
                if(sequenceId < sequences.size())
                    sequence = sequences.get(sequenceId);
            }
            if(sequence == null)
            {
                DataServiceException dse = new DataServiceException();
                dse.setMessage(10154, new Object[] {
                    inMessage.getHeader("sequenceId"), destination.getId()
                });
                throw dse;
            } else
            {
                return getSequencedMessage(inMessage, (Sequence)sequence);
            }
        } else
        {
            return getNoSyncSequencedMessage(inMessage, getItemsFromCollectionId(inMessage.getBody()));
        }
    }

    Collection getItemsFromCollectionId(Object collectionId)
    {
        if(collectionId instanceof Object[])
        {
            Object fillParams[] = (Object[])(Object[])collectionId;
            DataMessage dmsg = new DataMessage();
            dmsg.setDestination(destination.getId());
            dmsg.setBody(((Object) (fillParams)));
            dmsg.setOperation(1);
            return (List)dataService.sendMessageToAdapter(dmsg);
        }
        Map nestedId = (Map)collectionId;
        Map parentIdentity = (Map)nestedId.get("id");
        String parentDestinationName = (String)nestedId.get("parent");
        String propName = (String)nestedId.get("prop");
        DataDestination parentDestination = (DataDestination)dataService.getDestinationByName(parentDestinationName);
        AssociationSetting assoc = parentDestination.getAssociation(propName);
        Object item = parentDestination.getItemFromAdapter(parentIdentity);
        if(item == null)
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10160, new Object[] {
                parentDestinationName, parentIdentity
            });
            throw dse;
        }
        Object pval = DataService.getPropertyOnClientObject(item, propName);
        if(assoc.isMulti())
        {
            return (List)pval;
        } else
        {
            ArrayList l = new ArrayList(1);
            l.add(pval);
            return l;
        }
    }

    List getMatchingSequences(Object fillParams[])
    {
        List matches = null;
        if(fillParams != null)
        {
            Sequence seq = (Sequence)fillToSequenceIndex.get(new ArrayKey(fillParams));
            if(seq != null)
            {
                matches = new ArrayList(1);
                matches.add(seq);
                return matches;
            }
            int i;
            for(i = 0; i < fillParams.length && !(fillParams[i] instanceof Class) && fillParams[i] != null; i++);
            if(i == fillParams.length)
                return null;
        }
        if(fillParams == null)
            return Arrays.asList(fillToSequenceIndex.values().toArray());
        Iterator sequenceItr = fillToSequenceIndex.values().iterator();
        do
        {
            if(!sequenceItr.hasNext())
                break;
            Sequence seq = (Sequence)sequenceItr.next();
            Object seqFillParams[] = seq.getFillParameters();
            if(seqFillParams.length == fillParams.length)
            {
                int j;
                for(j = 0; j < fillParams.length; j++)
                {
                    Object fillParam = fillParams[j];
                    if(fillParam == null)
                        continue;
                    Object seqFillParam = seqFillParams[j];
                    if((fillParam instanceof Class) ? !((Class)fillParam).isInstance(seqFillParam) : !fillParam.equals(seqFillParam))
                        break;
                }

                if(j == fillParams.length)
                {
                    if(matches == null)
                        matches = new ArrayList();
                    matches.add(seq);
                }
            }
        } while(true);
        return matches;
    }

    Sequence getSequence(DataMessage message, Object fillParams)
    {
        if(fillParams != null && fillParams.getClass().isArray())
            return (Sequence)fillToSequenceIndex.get(new ArrayKey((Object[])(Object[])fillParams));
        if(fillParams != null && (fillParams instanceof Map))
        {
            return getSMOSequenceFromId(toItemIdentity((Map)fillParams));
        } else
        {
            Map singleItemIdentity = message.getIdentity();
            return getSMOSequenceFromId(toItemIdentity(singleItemIdentity));
        }
    }

    Sequence getAssociationSequence(AssociatedItemIndex aii)
    {
        List list = sequences;
        JVM INSTR monitorenter ;
        return (Sequence)aiiToSequenceIndex.get(aii);
        Exception exception;
        exception;
        throw exception;
    }

    private Sequence getSMOSequenceFromId(ItemIdentity singleItemIdentity)
    {
        Map map = itemIdToSequencesIndex;
        JVM INSTR monitorenter ;
        List sequenceList;
        sequenceList = (List)itemIdToSequencesIndex.get(singleItemIdentity);
        if(sequenceList == null)
            return null;
        int i = 0;
_L3:
        Sequence seq;
        if(i >= sequenceList.size())
            break MISSING_BLOCK_LABEL_83;
        seq = (Sequence)sequenceList.get(i);
        if(seq.getFillParameters() != null || seq.getAssociatedItemIndex() != null) goto _L2; else goto _L1
_L1:
        seq;
        map;
        JVM INSTR monitorexit ;
        return;
_L2:
        i++;
          goto _L3
        map;
        JVM INSTR monitorexit ;
          goto _L4
        Exception exception;
        exception;
        throw exception;
_L4:
        return null;
    }

    SequencedMessage getNoSyncSequencedMessage(Message incomingMessage, Collection outgoingResult)
    {
        SequencedMessage ack = null;
        int size = outgoingResult.size();
        DataNetworkSettings dataNetworkSettings = (DataNetworkSettings)destination.getNetworkSettings();
        if(dataNetworkSettings.isPagingEnabled())
        {
            ack = pagingManager.getPagedMessage(incomingMessage, outgoingResult);
            outgoingResult = (Collection)ack.getBody();
        } else
        {
            ack = new SequencedMessage();
        }
        ack.setDestination(incomingMessage.getDestination());
        ack.setSequenceId(-1);
        ack.setSequenceSize(size);
        List itemInstances = new ArrayList(outgoingResult.size());
        boolean needsReferencedIds = destination.getNeedsReferencedIds();
        Object referencedIds[];
        if(needsReferencedIds)
            referencedIds = new Object[outgoingResult.size()];
        else
            referencedIds = null;
        int i = 0;
        for(Iterator it = outgoingResult.iterator(); it.hasNext();)
        {
            Object item = it.next();
            itemInstances.add(i, destination.wrapItem(item));
            if(needsReferencedIds)
                referencedIds[i] = destination.getReferencedIds(item);
            i++;
        }

        ack.setBody(((Object) (itemInstances.toArray())));
        if(referencedIds != null)
            ack.setHeader("referencedIds", ((Object) (referencedIds)));
        return ack;
    }

    SequencedMessage getSequencedMessage(DataMessage incomingMessage, Sequence sequence)
    {
        SequencedMessage ack = null;
        List allSequenceIds = null;
        int op = incomingMessage.getOperation();
        Map clientIdMap = (Map)incomingMessage.getHeader("destClientIds");
        Object endpoint = incomingMessage.getHeader("DSEndpoint");
        List pagedItemIds;
        if(op == 20)
        {
            pagedItemIds = toItemIdentities(Arrays.asList((Object[])(Object[])incomingMessage.getHeader("DSids")));
            ack = new SequencedMessage();
            ack.setDestination(incomingMessage.getDestination());
            synchronized(sequence)
            {
                ack.setSequenceId(sequence.getSequenceId());
                ack.setSequenceSize(sequence.getSequenceSize());
                if(clientIdMap != null)
                    allSequenceIds = new ArrayList(sequence.getItemIdentities());
            }
        } else
        {
            synchronized(sequence)
            {
                DataNetworkSettings dataNetworkSettings = (DataNetworkSettings)destination.getNetworkSettings();
                allSequenceIds = sequence.getItemIdentities();
                if(dataNetworkSettings.isPagingEnabled())
                {
                    try
                    {
                        ack = pagingManager.getPagedMessage(incomingMessage, allSequenceIds);
                    }
                    catch(Throwable e)
                    {
                        DataServiceException dse = new DataServiceException();
                        dse.setMessage(10166, new Object[] {
                            incomingMessage.getHeader("sequenceId"), destination.getId()
                        });
                        throw dse;
                    }
                    pagedItemIds = toItemIdentities((List)ack.getBody());
                } else
                {
                    ack = new SequencedMessage();
                    pagedItemIds = allSequenceIds;
                }
                ack.setDestination(incomingMessage.getDestination());
                ack.setSequenceId(sequence.getSequenceId());
                ack.setSequenceSize(sequence.getSequenceSize());
                if(pagedItemIds.size() != allSequenceIds.size())
                    allSequenceIds = new ArrayList(allSequenceIds);
            }
        }
        List itemInstances = new ArrayList(pagedItemIds.size());
        boolean needsReferencedIds = op != 15 && destination.getNeedsReferencedIds();
        Object referencedIds[];
        if(needsReferencedIds)
            referencedIds = new Object[pagedItemIds.size()];
        else
            referencedIds = null;
        Object sequenceProxies[];
        if(op == 15 || destination.getNumSequencedAssociations() <= 0)
            sequenceProxies = null;
        else
            sequenceProxies = new Object[pagedItemIds.size()];
        for(int i = 0; i < pagedItemIds.size(); i++)
        {
            ItemIdentity id = (ItemIdentity)pagedItemIds.get(i);
            if(op == 15)
            {
                itemInstances.add(id);
                continue;
            }
            Object instance = getItemInstance(id);
            if(destination.getNumSequencedAssociations() > 0)
            {
                int proxies[] = getItemProxies(id, instance, clientIdMap, endpoint);
                sequenceProxies[i] = createProxyInfoMap(id, instance, proxies, clientIdMap, endpoint, new HashMap(4));
            }
            itemInstances.add(i, destination.wrapItem(instance));
            if(needsReferencedIds)
                referencedIds[i] = destination.getReferencedIds(instance);
        }

        ack.setBody(((Object) (itemInstances.toArray())));
        ack.setSequenceProxies(sequenceProxies);
        if(referencedIds != null)
            ack.setHeader("referencedIds", ((Object) (referencedIds)));
        if((op == 20 || op == 1) && clientIdMap != null && destination.getNumSequencedAssociations() > 0 && pagedItemIds.size() != allSequenceIds.size())
        {
            for(int i = 0; i < allSequenceIds.size(); i++)
            {
                ItemIdentity identity = (ItemIdentity)allSequenceIds.get(i);
                if(!pagedItemIds.contains(identity))
                {
                    Object instance = getItemInstance(identity);
                    int proxies[] = getItemProxies(identity, instance, clientIdMap, endpoint);
                    createProxyInfoMap(identity, instance, proxies, clientIdMap, endpoint, new HashMap(4));
                }
            }

        }
        return ack;
    }

    private Object getItemInstance(ItemIdentity id)
    {
        Item item = (Item)items.get(id);
        Object instance = null;
        if(item != null)
            instance = item.instance;
        if(instance == null)
        {
            instance = destination.getItemFromAdapter(id);
            if(instance == null)
            {
                DataServiceException dse = new DataServiceException();
                dse.setMessage(10161, new Object[] {
                    id.toString(), destination.getId()
                });
                throw dse;
            }
        } else
        {
            updateNestedItems(instance, new IdentityHashMap());
        }
        return instance;
    }

    private void updateNestedItems(Object instance, Map visited)
    {
        if(visited.containsKey(instance))
            return;
        visited.put(instance, Boolean.TRUE);
        List assocs = destination.getAssociations();
        if(assocs != null && assocs.size() > 0)
        {
label0:
            for(int i = 0; i < assocs.size(); i++)
            {
                AssociationSetting assoc = (AssociationSetting)assocs.get(i);
                if(assoc.getLazy())
                    continue;
                DataDestination nestedDest = (DataDestination)dataService.getDestinationByName(assoc.getDestination());
                SequenceManager nestedSeqMgr = nestedDest.getSequenceManager();
                if(assoc.isMulti())
                {
                    Collection values = (Collection)DataService.getPropertyOnClientObject(instance, assoc.getProperty());
                    if(values == null)
                        continue;
                    Iterator it = values.iterator();
                    do
                    {
                        Object nestedInst;
                        Item newerNestedItem;
                        Map identity;
                        do
                        {
                            if(!it.hasNext())
                                continue label0;
                            nestedInst = it.next();
                            identity = nestedSeqMgr.getIdentityForInstance(nestedInst);
                        } while((newerNestedItem = nestedSeqMgr.getItem(identity)) == null || newerNestedItem == null || newerNestedItem.instance == null);
                        nestedSeqMgr.updatePropertiesOnItems(nestedInst, newerNestedItem.instance, visited);
                    } while(true);
                }
                Object nestedInst = DataService.getPropertyOnClientObject(instance, assoc.getProperty());
                if(nestedInst == null)
                    continue;
                Map identity = nestedSeqMgr.getIdentityForInstance(nestedInst);
                Item newerNestedItem = nestedSeqMgr.getItem(identity);
                if(newerNestedItem != null && newerNestedItem.instance != null)
                    nestedSeqMgr.updatePropertiesOnItems(nestedInst, newerNestedItem.instance, visited);
            }

        }
    }

    private void updatePropertiesOnItems(Object toItem, Object fromItem, Map visited)
    {
        if(toItem == fromItem)
            return;
        updateNestedItems(toItem, visited);
        Collection props = DataService.getPropertiesOnClientObject(toItem);
        Iterator it = props.iterator();
        do
        {
            if(!it.hasNext())
                break;
            String propName = (String)it.next();
            try
            {
                DataService.setPropertyOnClientObject(toItem, propName, DataService.getPropertyOnClientObject(fromItem, propName));
            }
            catch(Exception exc)
            {
                if(Log.isDebug())
                {
                    Log.getLogger("DataService.General").debug("Error occurred trying to update stale nested values.  toItem=" + toItem + " fromItem=" + fromItem + " property=" + propName + " exc=" + exc);
                    Log.getLogger("DataService.General").debug(ExceptionUtil.toString(exc));
                }
            }
        } while(true);
    }

    private int[] getItemProxies(ItemIdentity id, Object instance, Map clientIdMap, Object endpoint)
    {
        Item item = (Item)items.get(id);
        int proxies[];
        if(item == null || item.proxies == null)
            proxies = createProxiesForItem(null, id, instance, clientIdMap, endpoint, new TreeMap());
        else
            proxies = item.proxies;
        return proxies;
    }

    private Map createProxyInfoMap(ItemIdentity id, Object instance, int proxies[], Map clientIdMap, Object endpoint, Map pendingProxyInfos)
    {
        if(destination.getNumSequencedAssociations() > 0)
        {
            List associationSettings = destination.getPropertySettings().getAssociationSettings();
            ProxyInfoKey key = new ProxyInfoKey(id, destination);
            Map proxyInfoMap = (Map)pendingProxyInfos.get(key);
            if(proxyInfoMap != null)
                return proxyInfoMap;
            proxyInfoMap = new TreeMap();
            pendingProxyInfos.put(key, proxyInfoMap);
            int assocNum = 0;
            for(int i = 0; i < associationSettings.size(); i++)
            {
                AssociationSetting assoc = (AssociationSetting)associationSettings.get(i);
                if(!assoc.getSequenced())
                    continue;
                int sequenceId = proxies[assocNum++];
                DataDestination nestedDestination = (DataDestination)dataService.getDestinationByName(assoc.getDestination());
                SequenceManager nestedSeqMgr = nestedDestination.getSequenceManager();
                Sequence nestedSequence = nestedSeqMgr.getSequence(sequenceId);
                if(nestedSequence == null)
                {
                    if(Log.isDebug())
                        Log.getLogger("DataService.General").debug("createProxyInfoMap - sequence proxy id is stale seqId: " + sequenceId + " item id: " + id);
                    Item item = (Item)items.get(id);
                    if(item != null)
                        item.proxies = null;
                    item.proxies = getItemProxies(id, instance, clientIdMap, endpoint);
                }
                int sequenceSize = nestedSequence.getSequenceSize();
                TreeMap assocInfoMap = new TreeMap();
                assocInfoMap.put("sequenceId", new Integer(sequenceId));
                if(!assoc.getLazy() && nestedDestination.getNumSequencedAssociations() > 0)
                {
                    List itemIdentities;
                    synchronized(nestedSequence)
                    {
                        itemIdentities = new ArrayList(nestedSequence.getItemIdentities());
                        sequenceSize = itemIdentities.size();
                    }
                    if(sequenceSize > 0)
                    {
                        Object subProxyInfoMaps[] = new Object[sequenceSize];
                        for(int j = 0; j < sequenceSize; j++)
                        {
                            ItemIdentity nestedId = (ItemIdentity)itemIdentities.get(j);
                            Object nestedInstance = nestedSeqMgr.getItemInstance(nestedId);
                            int nestedProxies[] = nestedSeqMgr.getItemProxies(nestedId, nestedInstance, clientIdMap, endpoint);
                            subProxyInfoMaps[j] = nestedSeqMgr.createProxyInfoMap(nestedId, nestedInstance, nestedProxies, clientIdMap, endpoint, pendingProxyInfos);
                        }

                        assocInfoMap.put("subs", ((Object) (subProxyInfoMaps)));
                    }
                }
                assocInfoMap.put("sequenceSize", new Integer(sequenceSize));
                proxyInfoMap.put(assoc.getProperty(), assocInfoMap);
            }

            return proxyInfoMap;
        } else
        {
            return null;
        }
    }

    Sequence createSequence(Collection itemInstances, Object fillParams[], AssociatedItemIndex associateIndex, DataServiceTransaction dtx, Object clientId, Map clientIdMap, Object endpoint)
    {
        return createSequence(itemInstances, fillParams, associateIndex, dtx, clientId, clientIdMap, endpoint, ((Map) (new TreeMap())), false);
    }

    Sequence createSequence(Collection itemInstances, Object fillParams[], AssociatedItemIndex associateIndex, DataServiceTransaction dtx, Object clientId, Map clientIdMap, Object endpoint, 
            Map pendingSequences, boolean itemsAreJustIds)
    {
        List itemInstanceList = (itemInstances instanceof List) ? (List)itemInstances : Arrays.asList(itemInstances.toArray());
        return createSequence(itemInstanceList, fillParams, associateIndex, dtx, clientId, clientIdMap, endpoint, pendingSequences, itemsAreJustIds);
    }

    Sequence createSequence(List itemInstances, Object fillParams[], AssociatedItemIndex associateIndex, DataServiceTransaction dtx, Object clientId, Map clientIdMap, Object endpoint, 
            Map pendingSequences, boolean itemsAreJustIds)
    {
        boolean newSequence;
        ArrayKey fillKey;
        boolean sequenceChanged;
        List addedIds;
        List removedIds;
        Map removedItemCache;
        ItemIdentity itemIdentities[];
        newSequence = false;
        fillKey = null;
        sequenceChanged = false;
        addedIds = null;
        removedIds = null;
        removedItemCache = null;
        itemIdentities = new ItemIdentity[itemInstances.size()];
        for(int i = 0; i < itemIdentities.length; i++)
        {
            Object itemInstance = itemInstances.get(i);
            ItemIdentity identity;
            if(itemInstance == null)
                identity = null;
            else
            if(itemsAreJustIds)
                identity = toItemIdentity((Map)itemInstance);
            else
                identity = getItemIdentityForInstance(itemInstance);
            itemIdentities[i] = identity;
        }

        List list = sequences;
        JVM INSTR monitorenter ;
        Sequence sequence;
        if(clientIdMap != null)
            associateClientIdToClientIdMap(clientId, clientIdMap);
        if(fillParams != null)
        {
            fillKey = new ArrayKey(fillParams);
            sequence = (Sequence)fillToSequenceIndex.get(fillKey);
        } else
        if(associateIndex != null)
            sequence = (Sequence)aiiToSequenceIndex.get(associateIndex);
        else
            sequence = getSMOSequenceFromId(itemIdentities[0]);
        if(sequence == null)
        {
            sequence = new Sequence();
            newSequence = true;
            if(fillParams != null)
            {
                fillToSequenceIndex.put(fillKey, sequence);
                sequence.setFillParameters(fillParams);
            } else
            if(associateIndex != null)
            {
                sequence.setAssociatedItemIndex(associateIndex);
                aiiToSequenceIndex.put(associateIndex, sequence);
            } else
            {
                numSMOSequences++;
            }
            int firstNull = sequences.indexOf(null);
            int seqId;
            if(firstNull != -1)
            {
                seqId = firstNull;
                sequences.set(seqId, sequence);
            } else
            {
                seqId = sequences.size();
                sequences.add(seqId, sequence);
            }
            sequence.setSequenceId(seqId);
        }
        if(clientId != null)
            addSubscriberToSequence(sequence.getSequenceId(), clientId, endpoint);
        Sequence sequence1 = sequence;
        JVM INSTR monitorenter ;
        String seqKey;
        Sequence pendingSequence;
        seqKey = destination.getId() + ":" + sequence.getSequenceId();
        pendingSequence = (Sequence)pendingSequences.get(seqKey);
        if(pendingSequence != null)
            return pendingSequence;
        boolean needsNonLazySubscribe;
        Iterator subscriberIterator;
        pendingSequences.put(seqKey, sequence);
        needsNonLazySubscribe = !newSequence && sequence.getNumSubscribers() > 0 && destination.getNumSequencedAssociations() > 0 && (associateIndex == null || !associateIndex.getLazy());
        int i = 0;
        int fromSize = itemInstances.size();
        for(i = 0; i < fromSize; i++)
        {
            Object itemInstance = itemInstances.get(i);
            if(itemInstance == null)
            {
                if(associateIndex != null)
                    Log.getLogger("DataService.General").error("Null instance encountered in property on destination: " + destination.getId() + " for association: " + associateIndex);
                else
                    Log.getLogger("DataService.General").error("Null instance encountered in fill on destination: " + destination.getId() + " with fill params: " + fillParams);
                continue;
            }
            ItemIdentity identityMap = itemIdentities[i];
            if(!newSequence)
            {
                List sequenceItemIds = sequence.getItemIdentities();
                ItemIdentity oldId;
                if(i < sequenceItemIds.size())
                    oldId = (ItemIdentity)sequenceItemIds.get(i);
                else
                    oldId = null;
                if(i >= sequenceItemIds.size() || !areEqual(oldId, identityMap))
                {
                    if(i < sequenceItemIds.size())
                    {
                        int j;
                        for(j = i + 1; j < fromSize && !areEqual(oldId, itemIdentities[j]); j++);
                        if(j == fromSize)
                        {
                            if(!sequenceChanged && dtx != null)
                                dtx.saveSequenceItemIdentities(destination, sequence);
                            sequenceChanged = true;
                            if(needsNonLazySubscribe)
                            {
                                if(removedIds == null)
                                {
                                    removedIds = new ArrayList();
                                    removedItemCache = new HashMap();
                                }
                                removedIds.add(oldId);
                                removedItemCache.put(oldId, items.get(oldId));
                            }
                            removeItemIdentityFromSequence(sequence, i, oldId, dtx);
                        }
                    }
                    int k;
                    for(k = i; k < sequenceItemIds.size() && !areEqual(sequenceItemIds.get(k), identityMap); k++);
                    if(k != i || k >= sequenceItemIds.size())
                    {
                        if(!sequenceChanged && dtx != null)
                            dtx.saveSequenceItemIdentities(destination, sequence);
                        sequenceChanged = true;
                        if(k < sequenceItemIds.size())
                        {
                            ItemIdentity toReplaceId = (ItemIdentity)sequenceItemIds.get(k);
                            if(needsNonLazySubscribe)
                            {
                                if(removedIds == null)
                                {
                                    removedIds = new ArrayList();
                                    removedItemCache = new HashMap();
                                }
                                removedIds.add(toReplaceId);
                                removedItemCache.put(toReplaceId, items.get(toReplaceId));
                            }
                            removeItemIdentityFromSequence(sequence, k, toReplaceId, dtx);
                        }
                        addItemIdentityToSequence(sequence, i, identityMap, dtx);
                        if(needsNonLazySubscribe)
                        {
                            if(addedIds == null)
                                addedIds = new ArrayList();
                            addedIds.add(identityMap);
                        }
                    }
                }
            } else
            {
                addItemIdentityToSequence(sequence, -1, identityMap, dtx);
                if(needsNonLazySubscribe)
                {
                    if(addedIds == null)
                        addedIds = new ArrayList();
                    addedIds.add(identityMap);
                }
            }
            if(!itemsAreJustIds && destination.getCacheItems() && (associateIndex == null || associateIndex.getCacheReferencedItems()))
            {
                Item item = new Item();
                item.instance = itemInstance;
                items.put(identityMap, item);
            }
        }

        if(!newSequence)
        {
            ItemIdentity postRemoveId;
            for(List sequenceItemIds = sequence.getItemIdentities(); sequenceItemIds.size() > i; removeItemIdentityFromSequence(sequence, sequenceItemIds.size() - 1, postRemoveId, dtx))
            {
                if(!sequenceChanged && dtx != null)
                    dtx.saveSequenceItemIdentities(destination, sequence);
                sequenceChanged = true;
                postRemoveId = (ItemIdentity)sequenceItemIds.get(sequenceItemIds.size() - 1);
                if(!needsNonLazySubscribe)
                    continue;
                if(removedIds == null)
                {
                    removedIds = new ArrayList();
                    removedItemCache = new HashMap();
                }
                removedIds.add(postRemoveId);
                removedItemCache.put(postRemoveId, items.get(postRemoveId));
            }

            if(!sequenceChanged && dtx != null)
                dtx.markSequenceItemIdentitiesAsUnchanged(destination, sequence);
        }
        if(needsNonLazySubscribe && sequenceChanged)
            subscriberIterator = sequence.getSubscriberEntries().iterator();
        else
            subscriberIterator = null;
        sequence1;
        JVM INSTR monitorexit ;
          goto _L1
        Exception exception;
        exception;
        sequence1;
        JVM INSTR monitorexit ;
        throw exception;
_L1:
        list;
        JVM INSTR monitorexit ;
          goto _L2
        Exception exception1;
        exception1;
        throw exception1;
_L2:
        if(!itemsAreJustIds && (associateIndex == null || associateIndex.getCacheReferencedItems()))
        {
            for(int i = 0; i < itemInstances.size(); i++)
            {
                Object itemInstance = itemInstances.get(i);
                if(itemInstance == null)
                    continue;
                ItemIdentity identityMap = itemIdentities[i];
                Item item = (Item)items.get(identityMap);
                boolean newItem;
                if(item == null)
                {
                    item = new Item();
                    if(destination.getCacheItems())
                        item.instance = itemInstance;
                    newItem = true;
                } else
                {
                    newItem = false;
                }
                if(item.proxies == null)
                {
                    item.proxies = createProxiesForItem(associateIndex, identityMap, itemInstance, associateIndex == null || !associateIndex.getLazy() ? clientIdMap : null, endpoint, pendingSequences);
                    if(newItem)
                        items.put(identityMap, item);
                    continue;
                }
                if((associateIndex == null || !associateIndex.getLazy()) && clientIdMap != null)
                    handleSubscribeForProxies(true, identityMap, item.proxies, null, clientIdMap, 1, null);
            }

        }
        if(needsNonLazySubscribe && sequenceChanged)
        {
            boolean warned = false;
            Iterator subs = subscriberIterator;
            do
            {
                if(!subs.hasNext())
                    break;
                java.util.Map.Entry entry = (java.util.Map.Entry)subs.next();
                Object prevClientId = entry.getKey();
                int refcnt = ((Integer)entry.getValue()).intValue();
                if(prevClientId != clientId)
                {
                    if(addedIds != null)
                    {
                        for(int o = 0; o < addedIds.size(); o++)
                        {
                            ItemIdentity newId = (ItemIdentity)addedIds.get(o);
                            Item newItem = (Item)items.get(newId);
                            if(newItem == null)
                            {
                                if(!warned)
                                {
                                    Log.getLogger("DataService.General").error("Can't find cached proxies to add: " + newId + " on destination: " + destination.getId());
                                    warned = true;
                                }
                            } else
                            {
                                handleSubscribeForProxies(true, newId, newItem.proxies, prevClientId, null, refcnt, null);
                            }
                        }

                    }
                    if(removedIds != null)
                    {
                        int o = 0;
                        while(o < removedIds.size()) 
                        {
                            ItemIdentity oldId = (ItemIdentity)removedIds.get(o);
                            Item oldItem = (Item)items.get(oldId);
                            if(oldItem == null)
                                oldItem = (Item)removedItemCache.get(oldId);
                            if(oldItem == null)
                            {
                                if(!warned)
                                {
                                    Log.getLogger("DataService.General").error("Can't find cached proxies to remove subscription for: " + oldId + " on destination: " + destination.getId());
                                    warned = true;
                                }
                            } else
                            if(handleSubscribeForProxies(false, oldId, oldItem.proxies, prevClientId, null, refcnt, null))
                                oldItem.proxies = null;
                            o++;
                        }
                    }
                }
            } while(true);
        }
        pendingSequences.remove(seqKey);
        return sequence;
    }

    Object mapClientIdToClientIdMap(Object clientId)
    {
        return clientIdToClientIdMapIndex.get(clientId);
    }

    Object mapNestedClientIdToParentClientId(Object nestedClientId)
    {
        return nestedClientIdToParentClientIdIndex.get(nestedClientId);
    }

    void associateClientIdToClientIdMap(Object parentClientId, Map clientIdMap)
    {
        clientIdToClientIdMapIndex.put(parentClientId, clientIdMap);
        Object nestedClientId;
        for(Iterator it = clientIdMap.entrySet().iterator(); it.hasNext(); nestedClientIdToParentClientIdIndex.put(nestedClientId, parentClientId))
        {
            java.util.Map.Entry entry = (java.util.Map.Entry)it.next();
            nestedClientId = entry.getValue();
        }

    }

    void disassociateClientIdFromClientIdMap(Object parentClientId)
    {
        Map clientIdMap = (Map)clientIdToClientIdMapIndex.remove(parentClientId);
        if(clientIdMap != null)
        {
            Iterator it = clientIdMap.entrySet().iterator();
            do
            {
                if(!it.hasNext())
                    break;
                java.util.Map.Entry entry = (java.util.Map.Entry)it.next();
                Object nestedClientId = entry.getValue();
                if(nestedClientIdToParentClientIdIndex.remove(nestedClientId) == null)
                    Log.getLogger("DataService.General").error("nestedClientId not found in nested client id to parent client index." + nestedClientId);
            } while(true);
        }
    }

    boolean handleSubscribeForProxies(boolean subscribe, ItemIdentity identityMap, int proxies[], Object parentClientId, Map clientIdMap, int refcnt, Map pendingSubs)
    {
        if(proxies == null)
            return false;
        boolean clearProxies = false;
        List associationSettings = destination.getPropertySettings().getAssociationSettings();
        if(destination.getNumSequencedAssociations() > 0)
        {
            ProxyInfoKey key = new ProxyInfoKey(identityMap, destination);
            if(pendingSubs == null)
                pendingSubs = new HashMap();
            if(pendingSubs.get(key) != null)
                return clearProxies;
            pendingSubs.put(key, Boolean.TRUE);
            int i = 0;
            Iterator nestedIter = associationSettings.iterator();
            do
            {
                if(!nestedIter.hasNext())
                    break;
                AssociationSetting associationSetting = (AssociationSetting)nestedIter.next();
                if(associationSetting.getSequenced())
                {
                    String nestedDestName = associationSetting.getDestination();
                    DataDestination nestedDestination = (DataDestination)dataService.getDestinationByName(nestedDestName);
                    SequenceManager nestedSeqMgr = nestedDestination.getSequenceManager();
                    int sequenceId = proxies[i++];
                    if(clientIdMap == null)
                        clientIdMap = (Map)clientIdToClientIdMapIndex.get(parentClientId);
                    if(clientIdMap == null)
                    {
                        Log.getLogger("DataService.General").error("clientIdMap not defined for handleSubscription: subscribe=" + subscribe + " on destination: " + nestedDestination.getId());
                    } else
                    {
                        Object nestedClientId = clientIdMap.get(nestedDestination.getId());
                        if(nestedClientId == null)
                        {
                            Log.getLogger("DataService.General").error("No client id for destination: " + nestedDestination.getId() + " in clientIdMap: " + clientIdMap);
                        } else
                        {
                            for(int r = 0; r < refcnt; r++)
                            {
                                if(subscribe)
                                {
                                    nestedSeqMgr.addSubscriberToSequence(sequenceId, nestedClientId, null);
                                    continue;
                                }
                                if(nestedSeqMgr.removeSubscriberFromSequence(sequenceId, nestedClientId))
                                    clearProxies = true;
                            }

                        }
                        if(!associationSetting.getLazy())
                        {
                            Sequence nestedSequence = nestedSeqMgr.getSequence(sequenceId);
                            if(nestedSequence != null && nestedDestination.getNumSequencedAssociations() > 0)
                            {
                                List itemIdentities;
                                synchronized(nestedSequence)
                                {
                                    itemIdentities = new ArrayList(nestedSequence.getItemIdentities());
                                }
                                int j = 0;
                                while(j < itemIdentities.size()) 
                                {
                                    ItemIdentity assocId = (ItemIdentity)itemIdentities.get(j);
                                    Item subItem = nestedSeqMgr.getItem(assocId);
                                    if(subItem == null || subItem.proxies == null)
                                        Log.getLogger("DataService.General").error("Unable to find subItem proxies in handleSubscribe for id: " + assocId + " on destination: " + nestedDestination.getId());
                                    else
                                    if(nestedSeqMgr.handleSubscribeForProxies(subscribe, assocId, subItem.proxies, null, clientIdMap, refcnt, pendingSubs))
                                        subItem.proxies = null;
                                    j++;
                                }
                            }
                        }
                    }
                }
            } while(true);
        }
        return clearProxies;
    }

    void subscribeToEndpoint(Object clientId, Object endpoint)
    {
        CommandMessage subMsg = new CommandMessage();
        subMsg.setOperation(0);
        subMsg.setClientId(clientId);
        subMsg.setDestination(destination.getId());
        subMsg.setHeader("DSEndpoint", endpoint);
        dataService.doManageSubscriptions(subMsg);
    }

    private int[] createProxiesForItem(AssociatedItemIndex associateIndex, ItemIdentity itemIdentity, Object itemInstance, Map clientIdMap, Object endpoint, Map pendingSequences)
    {
        List associationSettings = destination.getPropertySettings().getAssociationSettings();
        if(destination.getNumSequencedAssociations() > 0)
        {
            int proxiesForItem[] = new int[destination.getNumSequencedAssociations()];
            int seqAssocs = 0;
            Iterator nestedIter = associationSettings.iterator();
            do
            {
                if(!nestedIter.hasNext())
                    break;
                AssociationSetting associationSetting = (AssociationSetting)nestedIter.next();
                if(associationSetting.getSequenced())
                {
                    String propName = associationSetting.getProperty();
                    String nestedDestName = associationSetting.getDestination();
                    DataDestination nestedDestination = (DataDestination)dataService.getDestinationByName(nestedDestName);
                    Object nestedValue = null;
                    try
                    {
                        nestedValue = DataService.getPropertyOnClientObject(itemInstance, propName);
                    }
                    catch(Exception e)
                    {
                        DataServiceException dse = new DataServiceException();
                        dse.setMessage(10155, new Object[] {
                            propName, itemInstance.getClass().getName()
                        });
                        throw dse;
                    }
                    Collection nestedInstances;
                    if(nestedValue != null)
                    {
                        if(associationSetting.getRelation() == 1 || associationSetting.getRelation() == 2)
                        {
                            try
                            {
                                nestedInstances = (Collection)nestedValue;
                            }
                            catch(Exception e)
                            {
                                DataServiceException dse = new DataServiceException();
                                dse.setMessage(10156, new Object[] {
                                    destination.getId()
                                });
                                throw dse;
                            }
                        } else
                        {
                            nestedInstances = new ArrayList(1);
                            nestedInstances.add(nestedValue);
                        }
                    } else
                    {
                        nestedInstances = new ArrayList(0);
                    }
                    AssociatedItemIndex itemIndex = new AssociatedItemIndex(destination, itemIdentity, propName, associationSetting.getRelation(), associationSetting.getLazy(), associationSetting.getCacheReferencedItems());
                    Object nestedClientId = null;
                    if(clientIdMap != null)
                        nestedClientId = clientIdMap.get(nestedDestination.getId());
                    Sequence nestedSequence = nestedDestination.getSequenceManager().createSequence(nestedInstances, null, itemIndex, null, nestedClientId, clientIdMap, endpoint, pendingSequences, false);
                    proxiesForItem[seqAssocs++] = nestedSequence.getSequenceId();
                }
            } while(true);
            return proxiesForItem;
        } else
        {
            return null;
        }
    }

    void addItemIdentityToSequence(Sequence sequence, int position, ItemIdentity itemIdentity, DataServiceTransaction dtx)
    {
        synchronized(sequence)
        {
            if(position == -1)
            {
                sequence.addItemIdentity(itemIdentity);
                position = sequence.getItemIdentities().size() - 1;
            } else
            {
                sequence.addItemIdentity(position, itemIdentity);
            }
            synchronized(itemIdToSequencesIndex)
            {
                List sequenceList = (List)itemIdToSequencesIndex.get(itemIdentity);
                if(sequenceList == null)
                {
                    sequenceList = new ArrayList(6);
                    itemIdToSequencesIndex.put(itemIdentity, sequenceList);
                }
                sequenceList.add(sequence);
            }
            if(dtx != null)
                dtx.addItemIdentityToUpdateCollection(destination, sequence, position, itemIdentity);
        }
    }

    void removeItemIdentityFromSequence(Sequence sequence, int position, ItemIdentity itemIdentity, DataServiceTransaction dtx)
    {
        Sequence sequence1 = sequence;
        JVM INSTR monitorenter ;
label0:
        {
            if(position >= sequence.getNumItems())
                break MISSING_BLOCK_LABEL_253;
            List sequenceList;
            synchronized(itemIdToSequencesIndex)
            {
                sequenceList = (List)itemIdToSequencesIndex.get(itemIdentity);
                if(sequenceList != null)
                    break label0;
                if(Log.isDebug())
                    Log.getLogger("DataService.General").debug("Unable to find id in itemIdToSequences index.  seqId: " + sequence.getSequenceId() + " item id: " + itemIdentity);
            }
            return;
        }
        sequenceList.remove(sequence);
        if(sequenceList.size() == 0)
        {
            items.remove(itemIdentity);
            itemIdToSequencesIndex.remove(itemIdentity);
        }
        map;
        JVM INSTR monitorexit ;
        if(sequence.getItemIdentities().get(position).equals(itemIdentity))
        {
            sequence.removeItemIdentityAt(position);
        } else
        {
            if(Log.isDebug())
                Log.getLogger("DataService.General").debug("Item identity: " + itemIdentity + " not at expected position: " + position + " for remove from sequence: " + sequence);
            sequence.removeItemIdentity(itemIdentity);
        }
        if(dtx != null)
            dtx.removeItemIdentityFromUpdateCollection(destination, sequence, position, itemIdentity);
        break MISSING_BLOCK_LABEL_312;
        if(Log.isDebug())
            Log.getLogger("DataService.General").debug("Unable to remove item id: " + itemIdentity + " from sequence: " + sequence + " position: " + position + " is out of range.");
        break MISSING_BLOCK_LABEL_326;
        Exception exception1;
        exception1;
        throw exception1;
    }

    void syncAndPushSequenceChanges(DataMessage message, DataServiceTransaction dtx)
    {
        Set interestedSubscribers;
        ItemIdentity itemId;
        interestedSubscribers = new HashSet();
        itemId = toItemIdentity(message.getIdentity());
        if(message.getOperation() != 0 && message.getOperation() != 3) goto _L2; else goto _L1
_L1:
        boolean processedFills;
        Iterator sequenceItr;
        processedFills = true;
        sequenceItr = fillToSequenceIndex.values().iterator();
_L5:
        Sequence seq;
label0:
        {
            if(!sequenceItr.hasNext())
                break; /* Loop/switch isn't completed */
            seq = (Sequence)sequenceItr.next();
            synchronized(seq)
            {
                if(seq.getNumSubscribers() != 0)
                    break label0;
            }
            continue; /* Loop/switch isn't completed */
        }
        sequence;
        JVM INSTR monitorexit ;
          goto _L3
        exception;
        throw exception;
_L3:
        Object item;
        if(message.getOperation() == 0)
            item = message.unwrapBody();
        else
            item = DataService.getUpdateBody(message, 2);
        Sequence rebuiltSequence = dtx.rebuildSequenceIfNecessary(destination, seq, item, message);
        synchronized(seq)
        {
            if(rebuiltSequence.containsItem(itemId))
                interestedSubscribers.addAll(seq.getSubscriberIds());
            else
            if(message.getOperation() == 3 && dtx.hasItemInOriginalSequence(destination, seq, itemId))
                interestedSubscribers.addAll(seq.getSubscriberIds());
        }
        if(true) goto _L5; else goto _L4
_L2:
        if((message instanceof DataAssociationMessage) || message.getOperation() == 17)
            return;
        processedFills = false;
_L4:
        Object sequenceListArray[];
        synchronized(itemIdToSequencesIndex)
        {
            List sequenceList = (List)itemIdToSequencesIndex.get(itemId);
            if(sequenceList == null)
                sequenceList = Collections.EMPTY_LIST;
            sequenceListArray = sequenceList.toArray();
        }
        Sequence seq;
        int itemIndex;
        for(int i = 0; i < sequenceListArray.length; i++)
        {
label1:
            {
                seq = (Sequence)sequenceListArray[i];
                synchronized(seq)
                {
                    if(seq.getFillParameters() == null || !processedFills)
                        break label1;
                }
            }
        }

        break MISSING_BLOCK_LABEL_471;
        itemIndex = seq.indexOf(itemId);
        if(itemIndex != -1)
        {
            if(message.getOperation() == 4)
                removeItemIdentityFromSequence(seq, itemIndex, itemId, seq.getFillParameters() == null ? null : dtx);
            interestedSubscribers.addAll(seq.getSubscriberIds());
        } else
        if(message.getOperation() == 4 && dtx.hasItemInOriginalSequence(destination, seq, itemId))
            interestedSubscribers.addAll(seq.getSubscriberIds());
        sequence1;
        JVM INSTR monitorexit ;
        continue;
        exception3;
        throw exception3;
        if(message.getOperation() == 4)
        {
            Item item = (Item)items.remove(itemId);
            if(item != null && item.proxies != null)
            {
                List associationSettings = destination.getPropertySettings().getAssociationSettings();
                for(int i = 0; i < associationSettings.size(); i++)
                {
                    AssociationSetting assoc = (AssociationSetting)associationSettings.get(i);
                    if(assoc.getSequenced())
                    {
                        DataDestination childDestination = (DataDestination)dataService.getDestinationByName(assoc.getDestination());
                        SequenceManager childSequenceManager = childDestination.getSequenceManager();
                        childSequenceManager.removeSequence(item.proxies[i]);
                    }
                }

            }
        } else
        if(message.getOperation() == 3)
        {
            Item item = (Item)items.get(itemId);
            if(item != null && destination.getCacheItems())
                item.instance = DataService.getUpdateBody(message, 2);
        }
        dataService.pushMessageToClients(destination, interestedSubscribers, message, false);
        return;
    }

    boolean compareIds(Map id1, Map id2)
    {
        if(id1 == id2)
            return true;
        if(id1 == null || id2 == null)
            return false;
        List idPropNames = destination.getPropertySettings().getIdentityPropertyNames();
        for(int i = 0; i < idPropNames.size(); i++)
        {
            Object idPropName = idPropNames.get(i);
            Object idval1 = id1.get(idPropName);
            Object idval2 = id2.get(idPropName);
            if(idval1 == idval2)
                continue;
            if(idval1 == null || idval2 == null)
                return false;
            if(idval1.equals(idval2))
                continue;
            if(idval1.getClass() != idval2.getClass() && (idval1 instanceof Number) && (idval2 instanceof Number))
            {
                if(((Number)idval1).doubleValue() != ((Number)idval2).doubleValue())
                    return false;
            } else
            {
                return false;
            }
        }

        return true;
    }

    boolean compareIdsInItems(Object id1, Object id2)
    {
        if(id1 == id2)
            return true;
        if(id1 == null || id2 == null)
            return false;
        List idPropNames = destination.getPropertySettings().getIdentityPropertyNames();
        for(int i = 0; i < idPropNames.size(); i++)
        {
            String idPropName = (String)idPropNames.get(i);
            Object idval1 = DataService.getPropertyOnClientObject(id1, idPropName);
            Object idval2 = DataService.getPropertyOnClientObject(id2, idPropName);
            if(idval1 == idval2)
                continue;
            if(idval1 == null)
                return false;
            if(idval2 == null)
                return false;
            if(idval1.equals(idval2))
                continue;
            if((idval1 instanceof Number) && (idval2 instanceof Number))
            {
                if(((Number)idval1).doubleValue() != ((Number)idval2).doubleValue())
                    return false;
            } else
            {
                return false;
            }
        }

        return true;
    }

    void copyIdInItem(Object src, Object dst)
    {
        List idPropNames = destination.getPropertySettings().getIdentityPropertyNames();
        for(int i = 0; i < idPropNames.size(); i++)
        {
            String idPropName = (String)idPropNames.get(i);
            Object srcIdVal = DataService.getPropertyOnClientObject(src, idPropName);
            DataService.setPropertyOnClientObject(dst, idPropName, srcIdVal);
        }

    }

    int idHashCode(Object item)
    {
        if(item == null)
            return 0;
        List idPropNames = destination.getPropertySettings().getIdentityPropertyNames();
        int hc = 0;
        for(int i = 0; i < idPropNames.size(); i++)
        {
            String idPropName = (String)idPropNames.get(i);
            Object idVal = DataService.getPropertyOnClientObject(item, idPropName);
            if(idVal != null)
                hc += idVal.hashCode();
        }

        return hc;
    }

    void logSequenceInfo(String info)
    {
        int numSeq;
        int numClients;
        int numItems;
        int numFills;
        int numAssociations;
        int numNestedClients;
        int numNestedClientIds;
        synchronized(sequences)
        {
            numClients = subscriberToSequencesIndex.size();
            synchronized(itemIdToSequencesIndex)
            {
                numItems = itemIdToSequencesIndex.size();
            }
            numFills = fillToSequenceIndex.size();
            numAssociations = aiiToSequenceIndex.size();
            numSeq = numFills + numAssociations + numSMOSequences;
            numNestedClients = clientIdToClientIdMapIndex.size();
            numNestedClientIds = nestedClientIdToParentClientIdIndex.size();
        }
        if(Log.isDebug())
            Log.getLogger("DataService.General").debug(info + " sequence info for: " + destination.getId() + " numSequences=" + numSeq + " numClients=" + numClients + " numItems=" + numItems + " numFills=" + numFills + " numAssociations=" + numAssociations + " numSMOSequences=" + numSMOSequences + " numNestedClients=" + numNestedClients + " numNestedClientIds=" + numNestedClientIds);
    }

    ItemIdentity toItemIdentity(Map identity)
    {
        return ItemIdentity.toItemIdentity(identity, destination);
    }

    private List toItemIdentities(List identities)
    {
        if(identities == null)
            return null;
        Object itemIdentities[] = identities.toArray();
        for(int i = 0; i < itemIdentities.length; i++)
            itemIdentities[i] = toItemIdentity((Map)itemIdentities[i]);

        return Arrays.asList(itemIdentities);
    }

    private static boolean areEqual(Object o1, Object o2)
    {
        return o1 != null ? o1.equals(o2) : o2 == null;
    }

    private DataService dataService;
    private DataDestination destination;
    private Map items;
    private PagingManager pagingManager;
    private List sequences;
    private Map itemIdToSequencesIndex;
    private Map fillToSequenceIndex;
    private Map aiiToSequenceIndex;
    private Map subscriberToSequencesIndex;
    private Map nestedClientIdToParentClientIdIndex;
    private Map clientIdToClientIdMapIndex;
    private int numSMOSequences;
    public static final String SEQUENCE_POLL_HEADER = "sequenceId";
    public static final String SEQUENCE_PROXY_HEADER = "sequenceProxy";
    public static final String SYNC_HEADER = "sync";

}
