// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ASObjectAdapter.java

package flex.data.adapters;

import flex.data.DataServiceException;
import flex.data.messages.DataMessage;
import flex.management.runtime.data.adapters.ASObjectAdapterControl;
import flex.messaging.Destination;
import flex.messaging.MessageBroker;
import flex.messaging.cluster.ClusterManager;
import flex.messaging.config.ConfigMap;
import flex.messaging.services.Service;
import java.util.*;

// Referenced classes of package flex.data.adapters:
//            JavaAdapter, ASObjectManager, AdapterException, ChangeObjectImpl, 
//            ConflictMode, SecurityConstraintManager

public class ASObjectAdapter extends JavaAdapter
{

    public ASObjectAdapter()
    {
        objectManager = new ASObjectManager();
        stateInitialized = false;
    }

    public Object getAdapterState()
    {
        return objectManager.getObjects();
    }

    public void setAdapterState(Object adapterState)
    {
        if(adapterState != null)
            objectManager.setObjects((Map)adapterState);
    }

    public void initialize()
    {
        if(!stateInitialized && isDestinationClustered(destination))
        {
            ClusterManager clm = service.getMessageBroker().getClusterManager();
            clm.invokePeerToPeerOperation(service.getClass().getName(), destination.getId(), "requestAdapterState", new Object[] {
                destination.getId()
            }, null);
            stateInitialized = true;
        }
    }

    protected void server(ConfigMap properties)
    {
        ConfigMap serverSettings = properties.getPropertyAsMap("server", null);
        if(serverSettings != null)
        {
            String updateConflictModeString = serverSettings.getPropertyAsString("update-conflict-mode", "NONE");
            objectManager.setUpdateConflictMode(ConflictMode.getConflictMode(updateConflictModeString));
            String deleteConflictModeString = serverSettings.getPropertyAsString("delete-conflict-mode", "NONE");
            int deleteConflictMode = ConflictMode.getConflictMode(deleteConflictModeString);
            if(deleteConflictMode == 1)
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10524, new Object[] {
                    destination.getId()
                });
                throw aex;
            }
            objectManager.setDeletConflictMode(deleteConflictMode);
        }
    }

    private boolean isDestinationClustered(Destination destination)
    {
        if(destination.isBackendShared())
        {
            DataServiceException dse = new DataServiceException();
            dse.setMessage(10526);
            throw dse;
        } else
        {
            return destination.isClustered();
        }
    }

    protected Integer invokeCountOperation(DataMessage message, Object assemblerObj)
    {
        constraintManager.assertCountAuthorization(message);
        return new Integer(objectManager.size());
    }

    protected Object invokeGetOperation(DataMessage message, Object assemblerObj)
    {
        constraintManager.assertReadAuthorization(message);
        Object uid = getIdentityFromMessage(message);
        return objectManager.doGet(uid);
    }

    protected Collection invokeFillOperation(DataMessage message, Object assemblerObj)
    {
        constraintManager.assertReadAuthorization(message);
        String query = null;
        if(message.getBody() != null && message.getBody().getClass().isArray())
        {
            Object bodyArgs[] = (Object[])(Object[])message.getBody();
            if(bodyArgs.length == 1)
            {
                if(bodyArgs[0] == null)
                    query = null;
                else
                    query = bodyArgs[0].toString();
            } else
            if(bodyArgs.length > 1)
            {
                AdapterException dse = new AdapterException();
                dse.setMessage(10527);
                throw dse;
            }
        }
        return objectManager.doRead(query);
    }

    protected Integer invokeRefreshFillOperation(DataMessage message, Object assemblerObj)
    {
        Object args[] = (Object[])(Object[])message.getBody();
        List params = getParamsFromClientArray(args[0]);
        Object theTestObj = args[1];
        if(params.size() == 0)
            return APPEND_TO_FILL;
        if(params.size() == 1)
            return objectManager.matchesQuery((String)params.get(0), theTestObj) ? APPEND_TO_FILL : REMOVE_FROM_FILL;
        else
            return EXECUTE_FILL;
    }

    protected synchronized void invokeSyncOperation(Object assemblerObj, List changes)
    {
        Iterator iter = changes.iterator();
        do
        {
            if(!iter.hasNext())
                break;
            ChangeObjectImpl co = (ChangeObjectImpl)iter.next();
            if(co.isCreate())
            {
                constraintManager.assertCreateAuthorization(co.getMessage());
                objectManager.doCreate(co);
            } else
            if(co.isUpdate())
            {
                constraintManager.assertUpdateAuthorization(co.getMessage());
                objectManager.doUpdate(co);
            } else
            if(co.isDelete())
            {
                constraintManager.assertDeleteAuthorization(co.getMessage());
                objectManager.doDelete(co);
            }
        } while(true);
    }

    protected Object getAssemblerObject()
    {
        return objectManager;
    }

    public void setupAdapterControl(Destination destination)
    {
        controller = new ASObjectAdapterControl(getId(), this, destination.getControl());
        controller.register();
        setControl(controller);
    }

    private ASObjectManager objectManager;
    private ASObjectAdapterControl controller;
    private boolean stateInitialized;
}
