// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ASObjectManager.java

package flex.data.adapters;

import flex.data.ChangeObject;
import flex.data.DataSyncException;
import flex.messaging.io.*;
import flex.messaging.messages.AsyncMessage;
import flex.messaging.messages.Message;
import flex.messaging.services.messaging.selector.JMSSelector;
import java.util.*;

// Referenced classes of package flex.data.adapters:
//            AdapterException

public class ASObjectManager
{

    public ASObjectManager()
    {
        objects = Collections.synchronizedMap(new HashMap());
    }

    Map getObjects()
    {
        return objects;
    }

    void setObjects(Map objects)
    {
        this.objects = objects;
    }

    void setUpdateConflictMode(int i)
    {
        updateConflictMode = i;
    }

    void setDeletConflictMode(int i)
    {
        deleteConflictMode = i;
    }

    public Object doGet(Object uid)
    {
        return objects.get(uid);
    }

    public List doRead(String queryString)
    {
        List l = new ArrayList();
        if(queryString != null)
        {
            JMSSelector selector = new JMSSelector(queryString);
            Iterator iter = objects.keySet().iterator();
            do
            {
                if(!iter.hasNext())
                    break;
                Object obj = objects.get(iter.next());
                Message msg = createQueryMessage(obj);
                if(selector.match(msg))
                    l.add(obj);
            } while(true);
        } else
        {
            l.addAll(objects.values());
        }
        return l;
    }

    public boolean matchesQuery(String queryString, Object obj)
    {
        JMSSelector selector = new JMSSelector(queryString);
        Message msg = createQueryMessage(obj);
        return selector.match(msg);
    }

    private Message createQueryMessage(Object obj)
    {
        AsyncMessage msg = new AsyncMessage();
        PropertyProxy proxy = PropertyProxyRegistry.getProxy(obj);
        List propertyNames = proxy.getPropertyNames(obj);
        if(propertyNames != null)
        {
            Iterator it = propertyNames.iterator();
            do
            {
                if(!it.hasNext())
                    break;
                String propName = (String)it.next();
                try
                {
                    msg.setHeader(propName, proxy.getValue(obj, propName));
                }
                catch(Exception e)
                {
                    AdapterException dse = new AdapterException();
                    dse.setMessage(10525);
                    dse.setRootCause(e);
                    throw dse;
                }
            } while(true);
        }
        return msg;
    }

    public synchronized Object doCreate(ChangeObject co)
    {
        Object uid = co.getObjectId();
        if(uid == null || uid != null && uid.toString().length() == 0)
        {
            AdapterException dse = new AdapterException();
            dse.setMessage(10528);
            throw dse;
        } else
        {
            objects.put(co.getObjectId(), co.getNewVersion());
            return co.getNewVersion();
        }
    }

    public synchronized void doUpdate(ChangeObject co)
    {
        Object serverVersion;
        List conflictingPropertyNames;
        Map changedValues;
        PropertyProxy proxy;
        Iterator iter;
        serverVersion = objects.get(co.getObjectId());
        if(serverVersion == null)
            break MISSING_BLOCK_LABEL_384;
        conflictingPropertyNames = new ArrayList();
        changedValues = co.getChangedValues();
        if(updateConflictMode == 0)
            break MISSING_BLOCK_LABEL_235;
        proxy = PropertyProxyRegistry.getProxyAndRegister(serverVersion);
        List propertyNames = proxy.getPropertyNames(serverVersion);
        if(propertyNames == null)
            break MISSING_BLOCK_LABEL_235;
        iter = propertyNames.iterator();
_L1:
        String propName;
        if(!iter.hasNext())
            break MISSING_BLOCK_LABEL_235;
        propName = (String)iter.next();
        Object serverCurrentValue = proxy.getValue(serverVersion, propName);
        Object clientPreviousValue = co.getPreviousValue(propName);
        if((updateConflictMode == 2 || updateConflictMode == 1 && changedValues.containsKey(propName)) && serverCurrentValue != null && clientPreviousValue != null && (serverCurrentValue == null || !serverCurrentValue.equals(clientPreviousValue)))
            conflictingPropertyNames.add(propName);
          goto _L1
        Exception e;
        e;
        if(proxy instanceof MapProxy) goto _L1; else goto _L2
_L2:
        AdapterException dse = new AdapterException();
        dse.setMessage(10529, new Object[] {
            propName, proxy.getAlias(serverVersion)
        });
        throw dse;
        Iterator iter;
        if(conflictingPropertyNames.size() != 0)
            break MISSING_BLOCK_LABEL_361;
        iter = changedValues.keySet().iterator();
_L3:
        String changedPropName;
        PropertyProxy proxy;
        if(!iter.hasNext())
            break MISSING_BLOCK_LABEL_361;
        changedPropName = (String)iter.next();
        proxy = PropertyProxyRegistry.getProxy(serverVersion);
        proxy.setValue(serverVersion, changedPropName, changedValues.get(changedPropName));
          goto _L3
        Exception e;
        e;
        if(proxy instanceof MapProxy) goto _L3; else goto _L4
_L4:
        AdapterException dse = new AdapterException();
        dse.setMessage(10529, new Object[] {
            changedPropName, proxy.getAlias(serverVersion)
        });
        throw dse;
        if(conflictingPropertyNames.size() > 0)
            throw new DataSyncException(co, serverVersion, conflictingPropertyNames);
        else
            return;
        throw new DataSyncException(co);
    }

    public synchronized void doDelete(ChangeObject co)
    {
        Object serverVersion;
        List conflictingPropertyNames;
        PropertyProxy proxy;
        Iterator iter;
        if(deleteConflictMode != 2)
            break MISSING_BLOCK_LABEL_220;
        serverVersion = objects.get(co.getObjectId());
        if(serverVersion == null)
            break MISSING_BLOCK_LABEL_220;
        conflictingPropertyNames = new ArrayList();
        proxy = PropertyProxyRegistry.getProxy(serverVersion);
        List propertyNames = proxy.getPropertyNames(serverVersion);
        if(propertyNames == null)
            break MISSING_BLOCK_LABEL_200;
        iter = propertyNames.iterator();
_L1:
        String propName;
        if(!iter.hasNext())
            break MISSING_BLOCK_LABEL_200;
        propName = (String)iter.next();
        Object serverCurrentValue = proxy.getValue(serverVersion, propName);
        Object clientPreviousValue = co.getPreviousValue(propName);
        if(serverCurrentValue != null && clientPreviousValue != null && (serverCurrentValue == null || !serverCurrentValue.equals(clientPreviousValue)))
            conflictingPropertyNames.add(propName);
          goto _L1
        Exception e;
        e;
        if(proxy instanceof MapProxy) goto _L1; else goto _L2
_L2:
        AdapterException dse = new AdapterException();
        dse.setMessage(10529, new Object[] {
            propName, proxy.getAlias(serverVersion)
        });
        throw dse;
        if(conflictingPropertyNames.size() > 0)
            throw new DataSyncException(co, serverVersion, conflictingPropertyNames);
        objects.remove(co.getObjectId());
        return;
    }

    public int size()
    {
        return objects.size();
    }

    private Map objects;
    private int updateConflictMode;
    private int deleteConflictMode;
}
