// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ChangeObjectImpl.java

package flex.data.adapters;

import flex.data.ChangeObject;
import flex.data.DataService;
import flex.data.messages.DataErrorMessage;
import flex.data.messages.DataMessage;
import flex.messaging.messages.ErrorMessage;
import flex.messaging.util.StringUtils;
import java.util.*;

public class ChangeObjectImpl
    implements ChangeObject
{

    public ChangeObjectImpl(DataMessage message)
    {
        operation = message.getOperation();
        this.message = message;
        status = 0;
    }

    public Object getObjectId()
    {
        return objectId;
    }

    public void setObjectId(Object id)
    {
        objectId = id;
    }

    public Object getPreviousVersion()
    {
        return previousVersion;
    }

    public void setPreviousVersion(Object o)
    {
        previousVersion = o;
    }

    public Object getNewVersion()
    {
        return currentVersion;
    }

    public void setNewVersion(Object o)
    {
        currentVersion = o;
        changedValues = null;
    }

    public boolean isCreate()
    {
        return operation == 0 || operation == 11;
    }

    public boolean isUpdate()
    {
        return operation == 3;
    }

    public boolean isDelete()
    {
        return operation == 4;
    }

    public void setChanges(Object changes[])
    {
        if(changes != null && !(changes instanceof String[]))
        {
            String nchanges[] = new String[changes.length];
            for(int i = 0; i < changes.length; i++)
                nchanges[i] = (String)changes[i];

            this.changes = nchanges;
        } else
        {
            this.changes = (String[])(String[])changes;
        }
        changedValues = null;
    }

    public Object[] getChanges()
    {
        return changes;
    }

    public String[] getChangedPropertyNames()
    {
        return changes;
    }

    public void addChangedPropertyName(String propertyName)
    {
        if(!isUpdate())
            throw new IllegalArgumentException("the addChangedPropertyName only is valid for update operations");
        if(changes == null)
            return;
        for(int i = 0; i < changes.length; i++)
            if(changes[i].equals(propertyName))
                return;

        String nchanges[] = new String[changes.length + 1];
        for(int i = 0; i < changes.length; i++)
            nchanges[i] = changes[i];

        nchanges[changes.length] = propertyName;
        changes = nchanges;
        changedValues = null;
        if(message != null)
            DataService.setUpdateBody(message, 0, nchanges);
    }

    public Map getChangedValues()
    {
        if(changedValues == null)
        {
            if(changes == null || currentVersion == null)
                return null;
            changedValues = new HashMap();
            for(int i = 0; i < changes.length; i++)
            {
                String prop = changes[i];
                changedValues.put(prop, DataService.getPropertyOnClientObject(currentVersion, prop));
            }

        }
        return Collections.unmodifiableMap(changedValues);
    }

    public Object getPreviousValue(String propertyName)
    {
        return DataService.getPropertyOnClientObject(previousVersion, propertyName);
    }

    public DataMessage getMessage()
    {
        return message;
    }

    public void processed()
    {
        status = 1;
    }

    public void fail()
    {
        status = 2;
    }

    public void fail(String description)
    {
        fail();
        failureDescription = description;
    }

    public void conflict(Object serverVersion)
    {
        conflict(serverVersion, false);
    }

    public void conflict(Object serverVersion, boolean conflictOnProperty)
    {
        this.serverVersion = serverVersion;
        status = conflictOnProperty ? 4 : 3;
    }

    public ErrorMessage createErrorMessage()
    {
        ErrorMessage msg = null;
        if(status == 4 || status == 3)
        {
            DataErrorMessage dmsg = new DataErrorMessage();
            dmsg.cause = message;
            dmsg.faultString = failureDescription;
            dmsg.serverObject = serverVersion;
            List conflictingPropertyNames = getConflictingPropertyNames(serverVersion, status == 4);
            dmsg.propertyNames = conflictingPropertyNames.toArray();
            msg = dmsg;
        } else
        if(status == 0)
        {
            msg = new ErrorMessage();
            msg.faultString = "Not processed";
        } else
        if(status != 1)
        {
            msg = new ErrorMessage();
            msg.faultString = failureDescription;
        }
        msg.setCorrelationId(message.getMessageId());
        msg.setDestination(message.getDestination());
        return msg;
    }

    public String toString()
    {
        StringBuffer sb = new StringBuffer();
        sb.append("ChangeObject: ");
        sb.append("   operation=" + DataMessage.operationToString(operation));
        sb.append(StringUtils.NEWLINE);
        sb.append("   objectId=" + getObjectId());
        sb.append(StringUtils.NEWLINE);
        sb.append("   previousObject=" + getPreviousVersion());
        sb.append(StringUtils.NEWLINE);
        sb.append("   newVersion=" + getNewVersion());
        sb.append(StringUtils.NEWLINE);
        sb.append("   changedValues=" + getChangedValues());
        return sb.toString();
    }

    public List getConflictingPropertyNames(Object serverVersion, boolean checkOnlyChangingProps)
    {
        List conflictingPropertyNames = new ArrayList();
        if(checkOnlyChangingProps)
        {
            if(changes == null)
                return conflictingPropertyNames;
            if(serverVersion == null)
            {
                for(int i = 0; i < changes.length; i++)
                    conflictingPropertyNames.add(changes[i]);

            } else
            {
                for(int i = 0; i < changes.length; i++)
                {
                    String propName = changes[i];
                    Object clientOldValue = getPreviousValue(propName);
                    if(serverVersion != null)
                        try
                        {
                            Object serverValue = DataService.getPropertyOnClientObject(serverVersion, propName);
                            if(clientOldValue == null && serverValue != null || clientOldValue != null && !clientOldValue.equals(serverValue))
                                conflictingPropertyNames.add(propName);
                        }
                        catch(Exception e)
                        {
                            conflictingPropertyNames.add(propName);
                        }
                }

            }
        } else
        if(serverVersion == null)
        {
            conflictingPropertyNames.addAll(getOldValuesCollection());
        } else
        {
            Iterator iter = getOldValuesCollection().iterator();
            do
            {
                if(!iter.hasNext())
                    break;
                String propName = (String)iter.next();
                Object clientOldValue = getPreviousValue(propName);
                try
                {
                    Object serverValue = DataService.getPropertyOnClientObject(serverVersion, propName);
                    if(clientOldValue == null && serverValue != null || clientOldValue != null && !clientOldValue.equals(serverValue))
                        conflictingPropertyNames.add(propName);
                }
                catch(Exception e)
                {
                    conflictingPropertyNames.add(propName);
                }
            } while(true);
        }
        return conflictingPropertyNames;
    }

    public void copyFrom(ChangeObjectImpl from)
    {
        setObjectId(from.getObjectId());
        setPreviousVersion(from.getPreviousVersion());
        setNewVersion(from.getNewVersion());
        setServerVersion(from.getServerVersion());
        setChanges(from.getChanges());
        setStatus(from.getStatus());
        setFailureDescription(from.getFailureDescription());
    }

    void setFailureDescription(String fd)
    {
        failureDescription = fd;
    }

    String getFailureDescription()
    {
        return failureDescription;
    }

    int getOperation()
    {
        return operation;
    }

    public Object getServerVersion()
    {
        return serverVersion;
    }

    public void setServerVersion(Object o)
    {
        serverVersion = o;
    }

    int getStatus()
    {
        return status;
    }

    void setStatus(int i)
    {
        status = i;
    }

    Collection getOldValuesCollection()
    {
        return DataService.getPropertiesOnClientObject(previousVersion);
    }

    private static final long serialVersionUID = 0xdc56124bL;
    private Object objectId;
    private Object previousVersion;
    private Object currentVersion;
    private Object serverVersion;
    private String changes[];
    private Map changedValues;
    private int operation;
    private transient DataMessage message;
    private int status;
    private String failureDescription;
    static final int STATUS_UNPROCESSED = 0;
    static final int STATUS_OK = 1;
    static final int STATUS_FAIL = 2;
    static final int STATUS_CONFLICT_OBJECT = 3;
    static final int STATUS_CONFLICT_PROPERTY = 4;
}
