// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   FlexHibernateSessionContext.java

package flex.data.adapters;

import flex.data.DataServiceTransaction;
import java.util.Hashtable;
import java.util.Map;
import javax.transaction.Synchronization;
import javax.transaction.UserTransaction;
import org.hibernate.*;
import org.hibernate.classic.Session;
import org.hibernate.context.CurrentSessionContext;
import org.hibernate.engine.SessionFactoryImplementor;

public class FlexHibernateSessionContext
    implements CurrentSessionContext
{
    protected static class SessionSynch
        implements Synchronization
    {

        public void beforeCompletion()
        {
            Session session = (Session)context.currentSessionMap.get(txn);
            try
            {
                switch(txn.getStatus())
                {
                case 3: // '\003'
                case 4: // '\004'
                case 5: // '\005'
                case 6: // '\006'
                default:
                    break;

                case 0: // '\0'
                case 2: // '\002'
                case 7: // '\007'
                    session.getTransaction().commit();
                    break;

                case 1: // '\001'
                    try
                    {
                        session.getTransaction().rollback();
                    }
                    catch(TransactionException exc) { }
                    break;
                }
            }
            catch(Exception e)
            {
                if(e instanceof RuntimeException)
                    throw (RuntimeException)e;
                if(e.getMessage() == null)
                    throw new RuntimeException(e.getClass().getName(), e);
                else
                    throw new RuntimeException(e.getMessage(), e);
            }
        }

        public void afterCompletion(int i)
        {
            context.currentSessionMap.remove(txn);
        }

        private UserTransaction txn;
        private FlexHibernateSessionContext context;

        public SessionSynch(UserTransaction txn, FlexHibernateSessionContext context)
        {
            this.txn = txn;
            this.context = context;
        }
    }


    public FlexHibernateSessionContext(SessionFactoryImplementor factory)
    {
        currentSessionMap = new Hashtable();
        this.factory = factory;
    }

    public Session currentSession()
        throws HibernateException
    {
        UserTransaction txn = null;
        DataServiceTransaction dtx = null;
        try
        {
            dtx = DataServiceTransaction.getCurrentDataServiceTransaction();
            txn = dtx.getUserTransaction();
        }
        catch(Exception e)
        {
            throw new HibernateException("Unable to locate current UserTransaction");
        }
        Session currentSession = (Session)currentSessionMap.get(txn);
        if(currentSession == null)
        {
            currentSession = factory.openSession(null, true, true, ConnectionReleaseMode.ON_CLOSE);
            try
            {
                dtx.registerSynchronization(new SessionSynch(txn, this));
            }
            catch(Throwable t)
            {
                try
                {
                    currentSession.close();
                }
                catch(Throwable ignore) { }
                throw new HibernateException("Unable to register HibernateAdapter Synchronization with Flex Transaction");
            }
            currentSessionMap.put(txn, currentSession);
        }
        return currentSession;
    }

    protected final SessionFactoryImplementor factory;
    private transient Map currentSessionMap;

}
