// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JavaAdapter.java

package flex.data.adapters;

import flex.data.*;
import flex.data.assemblers.Assembler;
import flex.data.config.MetadataSettings;
import flex.data.messages.*;
import flex.management.runtime.data.adapters.JavaAdapterControl;
import flex.messaging.*;
import flex.messaging.config.*;
import flex.messaging.io.TypeMarshaller;
import flex.messaging.io.amf.ASObject;
import flex.messaging.io.amf.translator.ASTranslator;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.ErrorMessage;
import flex.messaging.messages.Message;
import flex.messaging.security.SecurityException;
import flex.messaging.services.Service;
import flex.messaging.services.ServiceAdapter;
import flex.messaging.util.ExceptionUtil;
import flex.messaging.util.StringUtils;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.*;

// Referenced classes of package flex.data.adapters:
//            SecurityConstraintManager, JavaAdapterMethodFactory, AdapterException, ChangeObjectList, 
//            ChangeObjectImpl, JavaAdapterConstants

public class JavaAdapter extends ServiceAdapter
    implements JavaAdapterConstants
{
    public class FillMethod extends QueryMethod
    {

        public Method fillContains;
        public boolean autoRefresh;
        public boolean ordered;

        public FillMethod()
        {
            super();
        }
    }

    public class GetMethod extends QueryMethod
    {

        public List identityNames;
        public List identityTypes;

        public GetMethod()
        {
            super();
        }
    }

    public class QueryMethod
    {

        public boolean equals(Object o)
        {
            if(o instanceof QueryMethod)
            {
                QueryMethod fm = (QueryMethod)o;
                return fm.name.equals(name) && argumentsMatch(fm.argTypes, argTypes);
            } else
            {
                return false;
            }
        }

        public String toString()
        {
            return "Method definition: " + name + "(" + argTypes + ")" + " -> method: " + method;
        }

        public String name;
        public List argTypes;
        public Method method;

        public QueryMethod()
        {
            super();
            argTypes = new ArrayList();
        }
    }


    public JavaAdapter()
    {
        LOG_CATEGORY = "DataService.General";
        hasReturnedAnything = false;
        hasReturnedWeakTypes = false;
    }

    Service getService()
    {
        return service;
    }

    public void setSettings(Destination destination, AdapterSettings adapterSettings, DestinationSettings destinationSettings)
    {
        super.setSettings(destination, adapterSettings, destinationSettings);
        dataDestination = (DataDestination)destination;
        ConfigMap properties = destinationSettings.getProperties();
        constraints(properties);
        server(properties);
        typeMarshaller = new ASTranslator();
        validateInstanceSettings();
        ConfigMap network = properties.getPropertyAsMap("network", null);
        if(network != null)
        {
            ConfigMap reconnect = network.getPropertyAsMap("reconnect", null);
            if(reconnect != null)
                reconnect.allowProperty("fetch");
        }
    }

    protected void validateInstanceSettings()
    {
        dataDestination.getFactoryInstance();
    }

    protected void constraints(ConfigMap properties)
    {
        constraintManager = new SecurityConstraintManager(service.getMessageBroker());
        ConfigMap serverSettings = properties.getPropertyAsMap("server", null);
        if(serverSettings != null)
            constraintManager.createConstraints(serverSettings);
    }

    protected void server(ConfigMap properties)
    {
        ConfigMap server = properties.getPropertyAsMap("server", null);
        serverProperties = server;
        if(server != null)
        {
            Class assemblerClass = dataDestination.getFactoryInstance().getInstanceClass();
            if(assemblerClass != null)
                initMethodFactory(assemblerClass);
        }
    }

    protected synchronized void initMethodFactory(Class assemblerClass)
    {
        if(methodFactory == null)
        {
            methodFactory = new JavaAdapterMethodFactory(this, assemblerClass);
            if(serverProperties != null)
            {
                countMethods = methodFactory.generateCountMethods(serverProperties);
                fillMethods = methodFactory.generateFillMethods(serverProperties);
                getMethod = methodFactory.generateGetMethod(serverProperties);
                syncMethod = methodFactory.generateSyncMethod(serverProperties);
            }
        }
    }

    public Object invoke(Message message)
    {
        Object result = null;
        Object assemblerObject = getAssemblerObject();
        DataMessage dmsg = (DataMessage)message;
        List messageBatch = null;
        Map commonHeaders = null;
        if(dmsg.getOperation() == 9)
            result = invokeCountOperation(dmsg, assemblerObject);
        else
        if(dmsg.getOperation() == 1)
            result = invokeFillOperation(dmsg, assemblerObject);
        else
        if(dmsg.getOperation() == 16)
            result = invokeRefreshFillOperation(dmsg, assemblerObject);
        else
        if(dmsg.getOperation() == 15)
        {
            result = invokeFillOperation(dmsg, assemblerObject);
            if(result != null)
            {
                List resultList = (List)result;
                ArrayList ids = new ArrayList(resultList.size());
                for(int i = 0; i < resultList.size(); i++)
                    ids.add(getIdentityFromItem(resultList.get(i)));

                result = ids;
            }
        } else
        if(dmsg.getOperation() == 2)
        {
            result = invokeGetOperation(dmsg, assemblerObject);
        } else
        {
            if(dmsg.getOperation() == 5)
            {
                messageBatch = (List)dmsg.getBody();
                commonHeaders = dmsg.getHeaders();
            } else
            {
                messageBatch = new ArrayList();
                messageBatch.add(dmsg);
            }
            result = invokeBatchOperation(messageBatch, assemblerObject, commonHeaders, dmsg.getTimestamp(), dmsg.getClientId());
        }
        return result;
    }

    private List invokeBatchOperation(List batchedMessages, Object assemblerObject, Map commonHeaders, long timestamp, Object clientId)
    {
        List syncMessages = new ArrayList();
        List result = new ArrayList();
        List ucmsgs = null;
        if(syncMethod == null && (assemblerObject instanceof Assembler))
            return invokeAssemblerSync(batchedMessages, (Assembler)assemblerObject, commonHeaders, timestamp, clientId);
        Iterator iter = batchedMessages.iterator();
label0:
        do
        {
            Object o;
            do
            {
                if(!iter.hasNext())
                    break label0;
                o = iter.next();
            } while(o == null);
            DataMessage m = (DataMessage)o;
            if(commonHeaders != null)
                m.setHeaders(commonHeaders);
            if(m.getTimestamp() == 0L)
                m.setTimestamp(timestamp);
            if(m.getClientId() == null)
                m.setClientId(clientId);
            switch(m.getOperation())
            {
            case 5: // '\005'
                result.add(invokeBatchOperation((List)m.getBody(), assemblerObject, m.getHeaders(), timestamp, clientId));
                break;

            case 0: // '\0'
            case 3: // '\003'
            case 4: // '\004'
            case 11: // '\013'
                syncMessages.add(m);
                break;

            case 13: // '\r'
            case 14: // '\016'
            case 17: // '\021'
                if(ucmsgs == null)
                    ucmsgs = new ArrayList();
                ucmsgs.add(m);
                break;

            case 1: // '\001'
            case 2: // '\002'
            case 6: // '\006'
            case 7: // '\007'
            case 8: // '\b'
            case 9: // '\t'
            case 10: // '\n'
            case 12: // '\f'
            case 15: // '\017'
            case 16: // '\020'
            default:
                AdapterException aex = new AdapterException();
                aex.setMessage(10504, new Object[] {
                    new Integer(m.getOperation())
                });
                throw aex;
            }
        } while(true);
        if(syncMessages.size() > 0)
            result.addAll(preprocessSyncOperation(syncMessages, assemblerObject));
        if(ucmsgs != null)
        {
            boolean resultContainsError = false;
            Iterator iter = result.iterator();
            do
            {
                if(!iter.hasNext())
                    break;
                if(!(iter.next() instanceof ErrorMessage))
                    continue;
                resultContainsError = true;
                break;
            } while(true);
            if(!resultContainsError)
            {
                result.addAll(ucmsgs);
            } else
            {
                for(int i = 0; i < ucmsgs.size(); i++)
                {
                    Message m = (Message)ucmsgs.get(i);
                    if(m instanceof DataAssociationMessage)
                        result.add(m);
                }

            }
        }
        return result.size() <= 0 ? null : result;
    }

    private List invokeAssemblerSync(List batchedMessages, Assembler assembler, Map commonHeaders, long timestamp, Object clientId)
    {
        ArrayList result;
        Iterator iter;
        result = new ArrayList(batchedMessages.size());
        iter = batchedMessages.iterator();
_L2:
        DataMessage m;
        Throwable assemblerError;
        if(!iter.hasNext())
            break; /* Loop/switch isn't completed */
        Object o = iter.next();
        m = (DataMessage)o;
        assemblerError = null;
        if(commonHeaders != null)
            m.setHeaders(commonHeaders);
        if(m.getTimestamp() == 0L)
            m.setTimestamp(timestamp);
        if(m.getClientId() == null)
            m.setClientId(clientId);
        switch(m.getOperation())
        {
        case 0: // '\0'
        case 11: // '\013'
            result.add(doCreateItem(assembler, m));
            break;

        case 3: // '\003'
            result.add(doUpdateItem(assembler, m));
            break;

        case 4: // '\004'
            result.add(doDeleteItem(assembler, m));
            break;

        case 13: // '\r'
        case 14: // '\016'
            result.add(m);
            break;

        case 17: // '\021'
            result.add(doUpdateCollection(assembler, (UpdateCollectionMessage)m, batchedMessages));
            break;

        case 1: // '\001'
        case 2: // '\002'
        case 5: // '\005'
        case 6: // '\006'
        case 7: // '\007'
        case 8: // '\b'
        case 9: // '\t'
        case 10: // '\n'
        case 12: // '\f'
        case 15: // '\017'
        case 16: // '\020'
        default:
            AdapterException aex = new AdapterException();
            aex.setMessage(10504, new Object[] {
                new Integer(m.getOperation())
            });
            throw aex;
        }
        if(assemblerError != null)
        {
            if(Log.isDebug())
                Log.getLogger(LOG_CATEGORY).debug("Exception during processing of message: " + m + StringUtils.NEWLINE + ExceptionUtil.toString(assemblerError));
            ErrorMessage msg = new ErrorMessage();
            msg.faultString = assemblerError.toString();
            msg.setCorrelationId(m.getMessageId());
            result.add(msg);
        }
        continue; /* Loop/switch isn't completed */
        DataSyncException e;
        e;
        if(e.getConflictCause() == null)
            e.setConflictCause(m);
        ErrorMessage errMsg = e.createErrorMessage();
        errMsg.setCorrelationId(m.getMessageId());
        errMsg.setDestination(m.getDestination());
        boolean needsReferencedIds = dataDestination.getNeedsReferencedIds();
        if(needsReferencedIds && e.getServerObject() != null)
            errMsg.setHeader("referencedIds", dataDestination.getReferencedIds(e.getServerObject()));
        result.add(errMsg);
        if(Log.isDebug())
            Log.getLogger(LOG_CATEGORY).debug("DataSyncException processing message: " + m + StringUtils.NEWLINE + "   exception: " + ExceptionUtil.toString(e));
        if(assemblerError != null)
        {
            if(Log.isDebug())
                Log.getLogger(LOG_CATEGORY).debug("Exception during processing of message: " + m + StringUtils.NEWLINE + ExceptionUtil.toString(assemblerError));
            ErrorMessage msg = new ErrorMessage();
            msg.faultString = assemblerError.toString();
            msg.setCorrelationId(m.getMessageId());
            result.add(msg);
        }
        continue; /* Loop/switch isn't completed */
        msg;
        ErrorMessage errMsg = msg.createErrorMessage();
        errMsg.setCorrelationId(m.getMessageId());
        result.add(errMsg);
        if(assemblerError != null)
        {
            if(Log.isDebug())
                Log.getLogger(LOG_CATEGORY).debug("Exception during processing of message: " + m + StringUtils.NEWLINE + ExceptionUtil.toString(assemblerError));
            ErrorMessage msg = new ErrorMessage();
            msg.faultString = assemblerError.toString();
            msg.setCorrelationId(m.getMessageId());
            result.add(msg);
        }
        continue; /* Loop/switch isn't completed */
        msg;
        throw msg;
        msg;
        handleAdapterException(m, msg, 10500);
        if(assemblerError != null)
        {
            if(Log.isDebug())
                Log.getLogger(LOG_CATEGORY).debug("Exception during processing of message: " + m + StringUtils.NEWLINE + ExceptionUtil.toString(assemblerError));
            ErrorMessage msg = new ErrorMessage();
            msg.faultString = assemblerError.toString();
            msg.setCorrelationId(m.getMessageId());
            result.add(msg);
        }
        if(true) goto _L2; else goto _L1
        Exception exception;
        exception;
        if(assemblerError != null)
        {
            if(Log.isDebug())
                Log.getLogger(LOG_CATEGORY).debug("Exception during processing of message: " + m + StringUtils.NEWLINE + ExceptionUtil.toString(assemblerError));
            ErrorMessage msg = new ErrorMessage();
            msg.faultString = assemblerError.toString();
            msg.setCorrelationId(m.getMessageId());
            result.add(msg);
        }
        throw exception;
_L1:
        return result.size() <= 0 ? null : result;
    }

    private DataMessage doCreateItem(Assembler assembler, DataMessage m)
    {
        constraintManager.assertCreateAuthorization(m);
        Object itemToCreate = dataDestination.getTypedItem(m.getBody(), typeMarshaller);
        if(!hasCheckedIncomingType)
            checkIncomingType(itemToCreate);
        assembler.createItem(itemToCreate);
        m.setBody(dataDestination.wrapItem(m.getBody()));
        Map identityMap = getIdentityFromItem(m.getBody());
        m.setIdentity(identityMap);
        return m;
    }

    private DataMessage doUpdateItem(Assembler assembler, DataMessage m)
    {
        constraintManager.assertUpdateAuthorization(m);
        Object updateArtifacts[] = DataService.getUpdateBody(m);
        Object changesObj = updateArtifacts[0];
        changesObj = removeReadOnlyPropertiesFromChanges(changesObj);
        List changes = getParamsFromClientArray(changesObj);
        if(changes != null && changes.size() == 0)
            return m;
        Object prevItem = dataDestination.getTypedItem(updateArtifacts[1], typeMarshaller);
        Object newItem = dataDestination.getTypedItem(updateArtifacts[2], typeMarshaller);
        if(!hasCheckedIncomingType)
            checkIncomingType(newItem);
        assembler.updateItem(newItem, prevItem, changes);
        DataService.setUpdateBody(m, 2, dataDestination.wrapItem(newItem));
        DataService.setUpdateBody(m, 1, dataDestination.wrapItem(prevItem));
        DataService.setUpdateBody(m, 0, ((Object) (changes.toArray())));
        return m;
    }

    private DataMessage doDeleteItem(Assembler assembler, DataMessage m)
    {
        constraintManager.assertDeleteAuthorization(m);
        Object item = dataDestination.getTypedItem(m.getBody(), typeMarshaller);
        assembler.deleteItem(item);
        m.setBody(dataDestination.wrapItem(item));
        return m;
    }

    private DataMessage doUpdateCollection(Assembler assembler, UpdateCollectionMessage ucmsg, List currentBatch)
    {
        constraintManager.assertReadAuthorization(ucmsg);
        Object ranges[] = (Object[])(Object[])ucmsg.getBody();
        for(int i = 0; i < ranges.length; i++)
        {
            UpdateCollectionRange range = (UpdateCollectionRange)ranges[i];
            for(int j = 0; j < range.identities.length; j++)
            {
                Object identityObj = range.identities[j];
                if(identityObj instanceof String)
                {
                    DataMessage d = findCreateDataMessage((String)identityObj, currentBatch);
                    if(d != null)
                    {
                        identityObj = getIdentityFromItem(d.getBody());
                    } else
                    {
                        if(Log.isError())
                            Log.getLogger(LOG_CATEGORY).error("Can't find create message for newly created item with message id: " + identityObj);
                        continue;
                    }
                }
                Map identity = (Map)identityObj;
                if(!(ucmsg.getCollectionId() instanceof Object[]))
                    continue;
                List fillParams = Arrays.asList((Object[])(Object[])ucmsg.getCollectionId());
                if(range.updateType == 0)
                    assembler.addItemToFill(fillParams, range.position + j, identity);
                else
                    assembler.removeItemFromFill(fillParams, range.position, identity);
            }

        }

        return ucmsg;
    }

    private DataMessage findCreateDataMessage(String messageId, List currentBatch)
    {
        for(int i = 0; i < currentBatch.size(); i++)
        {
            Object o = currentBatch.get(i);
            if(!(o instanceof DataMessage))
                continue;
            DataMessage m = (DataMessage)o;
            if((m.getOperation() == 0 || m.getOperation() == 11) && m.getMessageId().equals(messageId))
                return m;
        }

        return DataService.findCurrentCreateDataMessage(messageId);
    }

    protected Integer invokeCountOperation(DataMessage message, Object assemblerObj)
    {
        Integer result;
        constraintManager.assertCountAuthorization(message);
        result = new Integer(0);
        List params;
        QueryMethod countMethod;
        List incomingArgTypes;
label0:
        {
            params = getParamsFromClientArray(message.getBody());
            countMethod = null;
            incomingArgTypes = new ArrayList();
            for(int i = 0; i < params.size(); i++)
                incomingArgTypes.add(params.get(i).getClass());

            if(countMethods == null)
                break label0;
            Iterator iter = countMethods.iterator();
            QueryMethod fm;
            do
            {
                if(!iter.hasNext())
                    break label0;
                fm = (QueryMethod)iter.next();
            } while(!argumentsMatch(fm.argTypes, incomingArgTypes));
            countMethod = fm;
        }
        if(countMethod != null)
            break MISSING_BLOCK_LABEL_219;
        try
        {
            if(assemblerObj instanceof Assembler)
                return new Integer(((Assembler)assemblerObj).count(params));
        }
        catch(UnsupportedOperationException exc) { }
        AdapterException aex = new AdapterException();
        aex.setMessage(10508, new Object[] {
            destination.getId(), incomingArgTypes
        });
        throw aex;
        result = (Integer)countMethod.method.invoke(assemblerObj, (Object[])params.toArray());
          goto _L1
        Exception ite;
        ite;
        handleAdapterException(message, ite, 10509);
_L1:
        return result;
    }

    public boolean fillNeedsAutoRefresh(Object args)
    {
        List params = getParamsFromClientArray(args);
        FillMethod fillMethod = findFillMethod(params);
        if(fillMethod == null)
        {
            Object assemblerObject = getAssemblerObject();
            if(assemblerObject instanceof Assembler)
                return ((Assembler)assemblerObject).autoRefreshFill(params);
            else
                return false;
        } else
        {
            return fillMethod.autoRefresh;
        }
    }

    protected Integer invokeRefreshFillOperation(DataMessage message, Object assemblerObj)
    {
        List params;
        Object theTestObj;
        FillMethod fillMethod;
        Object args[] = (Object[])(Object[])message.getBody();
        params = getParamsFromClientArray(args[0]);
        theTestObj = args[1];
        Boolean isCreate = (Boolean)args[2];
        fillMethod = findFillMethod(params);
        if(fillMethod != null)
            break MISSING_BLOCK_LABEL_118;
        if(assemblerObj instanceof Assembler)
            return new Integer(((Assembler)assemblerObj).refreshFill(params, theTestObj, isCreate.booleanValue()));
        AdapterException aex = new AdapterException();
        aex.setMessage(10510, new Object[] {
            destination.getId(), params
        });
        throw aex;
        if(fillMethod.fillContains == null)
            break MISSING_BLOCK_LABEL_253;
        Object fillContainsArgs[] = new Object[2];
        fillContainsArgs[0] = ((Object) (params.toArray()));
        fillContainsArgs[1] = theTestObj;
        Object res = fillMethod.fillContains.invoke(assemblerObj, fillContainsArgs);
        if(!(res instanceof Boolean))
        {
            AdapterException aex = new AdapterException();
            aex.setMessage(10535, new Object[] {
                assemblerObj.getClass(), res != null ? res.getClass().getName() : "null"
            });
            throw aex;
        }
        if(!((Boolean)res).booleanValue())
            break MISSING_BLOCK_LABEL_249;
        if(fillMethod.ordered)
            return EXECUTE_FILL;
        try
        {
            return APPEND_TO_FILL;
        }
        catch(Exception ite)
        {
            handleAdapterException(message, ite, 10536);
        }
        break MISSING_BLOCK_LABEL_279;
        return REMOVE_FROM_FILL;
        if(fillMethod.autoRefresh)
            return EXECUTE_FILL;
        return DO_NOT_EXECUTE_FILL;
        return DO_NOT_EXECUTE_FILL;
    }

    protected Collection invokeFillOperation(DataMessage message, Object assemblerObj)
    {
        constraintManager.assertReadAuthorization(message);
        Collection result = null;
        try
        {
            List params = getParamsFromClientArray(message.getBody());
            FillMethod fillMethod = findFillMethod(params);
            if(fillMethod == null)
                try
                {
                    if(assemblerObj instanceof Assembler)
                    {
                        result = ((Assembler)assemblerObj).fill(params);
                    } else
                    {
                        AdapterException aex = new AdapterException();
                        aex.setMessage(10510, new Object[] {
                            destination.getId(), params
                        });
                        throw aex;
                    }
                }
                catch(UnsupportedOperationException exc)
                {
                    AdapterException aex = new AdapterException();
                    aex.setMessage(10510, new Object[] {
                        destination.getId(), params
                    });
                    throw aex;
                }
            else
                result = (Collection)fillMethod.method.invoke(assemblerObj, (Object[])params.toArray());
        }
        catch(Exception ite)
        {
            handleAdapterException(message, ite, 10511);
        }
        if(!hasReturnedAnything && result != null && result.size() > 0)
        {
            if(result.iterator().next() instanceof Map)
                hasReturnedWeakTypes = true;
            hasReturnedAnything = true;
        }
        return result;
    }

    protected Object invokeGetOperation(DataMessage message, Object assemblerObj)
    {
        constraintManager.assertReadAuthorization(message);
        Object result = null;
        if(getMethod == null)
        {
            if(assemblerObj instanceof Assembler)
            {
                try
                {
                    result = ((Assembler)assemblerObj).getItem(message.getIdentity());
                }
                catch(RuntimeException exc)
                {
                    handleAdapterException(message, exc, 10513);
                }
            } else
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10512, new Object[] {
                    destination.getId()
                });
                throw aex;
            }
        } else
        {
            try
            {
                if(getMethod.identityNames == null)
                {
                    getMethod.identityNames = dataDestination.getPropertySettings().getIdentityPropertyNames();
                    getMethod.identityTypes = dataDestination.getPropertySettings().getIdentityPropertyTypes();
                }
                Map identity = message.getIdentity();
                boolean validateTypes = getMethod.identityTypes.size() > 0;
                List identityTypes = validateTypes ? ((List) (new ArrayList())) : null;
                Iterator iter = getMethod.identityNames.iterator();
                do
                {
                    if(!iter.hasNext())
                        break;
                    String propName = (String)iter.next();
                    if(!identity.containsKey(propName))
                    {
                        AdapterException aex = new AdapterException();
                        aex.setMessage(10546, new Object[] {
                            destination.getId(), propName
                        });
                        throw aex;
                    }
                    if(validateTypes)
                        identityTypes.add(identity.get(propName).getClass());
                } while(true);
                if(validateTypes && !argumentsMatch(getMethod.identityTypes, identityTypes))
                {
                    AdapterException aex = new AdapterException();
                    aex.setMessage(10547, new Object[] {
                        destination.getId(), identityTypes, getMethod.identityTypes
                    });
                    throw aex;
                }
                Object param[] = {
                    identity
                };
                result = getMethod.method.invoke(assemblerObj, param);
            }
            catch(Exception ite)
            {
                handleAdapterException(message, ite, 10513);
            }
        }
        if(result instanceof Map)
            hasReturnedWeakTypes = true;
        hasReturnedAnything = true;
        return result;
    }

    protected void handleAdapterException(DataMessage message, Exception ite, int code)
    {
        Throwable th = ite;
        if(th instanceof InvocationTargetException)
            th = ((InvocationTargetException)ite).getCause();
        if(th instanceof MessageException)
            throw (MessageException)th;
        if(th instanceof SecurityException)
            throw (SecurityException)th;
        if(Log.isError())
            Log.getLogger(LOG_CATEGORY).error("Exception executing assembler operation.  incomingMessage: " + message + StringUtils.NEWLINE + "    exception: " + ExceptionUtil.toString(th));
        AdapterException aex = new AdapterException();
        String errorMsg = null;
        if(th.getMessage() != null)
            errorMsg = th.getClass() + ":" + th.getMessage();
        else
        if(ite.getCause() != null)
            if(ite.getCause().getMessage() != null)
                errorMsg = ite.getCause() + ":" + ite.getCause().getMessage();
            else
                errorMsg = ite.getCause().getClass().getName();
        aex.setMessage(code, new Object[] {
            message == null ? null : message.getDestination(), errorMsg
        });
        aex.setRootCause(th);
        throw aex;
    }

    protected boolean argumentsMatch(List methodParams, List callParams)
    {
        boolean match = false;
        if(methodParams.equals(callParams))
            match = true;
        else
        if(methodParams.size() == callParams.size())
        {
            int i = 0;
            int matches = 0;
            for(; i < methodParams.size(); i++)
            {
                Object callParam = callParams.get(i);
                if(callParam == "null" || methodParams.get(i).equals(callParam))
                {
                    matches++;
                    continue;
                }
                if((callParams.get(i) instanceof Class) && (methodParams.get(i) == Integer.TYPE && (java.lang.Integer.class).isAssignableFrom((Class)callParams.get(i)) || methodParams.get(i) == Double.TYPE && (java.lang.Double.class).isAssignableFrom((Class)callParams.get(i)) || methodParams.get(i) == Long.TYPE && (java.lang.Long.class).isAssignableFrom((Class)callParams.get(i)) || methodParams.get(i) == Boolean.TYPE && (java.lang.Boolean.class).isAssignableFrom((Class)callParams.get(i)) || methodParams.get(i) == Character.TYPE && (java.lang.Character.class).isAssignableFrom((Class)callParams.get(i)) || methodParams.get(i) == Float.TYPE && (java.lang.Float.class).isAssignableFrom((Class)callParams.get(i)) || methodParams.get(i) == Short.TYPE && (java.lang.Short.class).isAssignableFrom((Class)callParams.get(i)) || methodParams.get(i) == Byte.TYPE && (java.lang.Byte.class).isAssignableFrom((Class)callParams.get(i))))
                    matches++;
            }

            if(matches == methodParams.size())
                match = true;
        }
        return match;
    }

    protected List getParamsFromClientArray(Object msgParams)
    {
        List params = new ArrayList();
        if(msgParams instanceof ArrayList)
            params = (ArrayList)msgParams;
        else
        if(msgParams.getClass().isArray())
            params = new ArrayList(Arrays.asList((Object[])(Object[])msgParams));
        else
        if(msgParams instanceof ASObject)
        {
            if(((ASObject)msgParams).size() > 0)
                params.add(msgParams);
        } else
        {
            params.add(msgParams);
        }
        return params;
    }

    protected FillMethod findFillMethod(List params)
    {
        List incomingArgTypes = new ArrayList();
        FillMethod fillMethod = null;
        if(params != null)
        {
            for(int i = 0; i < params.size(); i++)
            {
                Object param = params.get(i);
                if(param == null)
                    incomingArgTypes.add("null");
                else
                    incomingArgTypes.add(param.getClass());
            }

        }
        if(fillMethods != null)
        {
            Iterator iter = fillMethods.iterator();
            do
            {
                if(!iter.hasNext())
                    break;
                FillMethod fm = (FillMethod)iter.next();
                if(argumentsMatch(fm.argTypes, incomingArgTypes))
                {
                    if(fillMethod != null)
                    {
                        AdapterException aex = new AdapterException();
                        aex.setMessage(10549, new Object[] {
                            incomingArgTypes, fm, fillMethod
                        });
                        throw aex;
                    }
                    fillMethod = fm;
                }
            } while(true);
        }
        return fillMethod;
    }

    private List preprocessSyncOperation(List incomingMessages, Object assemblerObj)
    {
        ChangeObjectList changeList;
        ChangeObjectImpl invalidChange;
        MessageException validationError;
        Throwable assemblerError;
        changeList = new ChangeObjectList();
        invalidChange = null;
        validationError = null;
        ChangeObjectImpl co;
        for(Iterator iter = incomingMessages.iterator(); iter.hasNext(); changeList.add(co))
        {
            DataMessage message = (DataMessage)iter.next();
            co = new ChangeObjectImpl(message);
            co.setObjectId(getIdentityFromMessage(message));
            try
            {
                if(co.isCreate())
                    constraintManager.assertCreateAuthorization(message);
                else
                if(co.isUpdate())
                {
                    constraintManager.assertUpdateAuthorization(message);
                    if(co.getObjectId() == null)
                    {
                        validationError = new AdapterException();
                        validationError.setMessage(10505);
                    }
                } else
                if(co.isDelete())
                {
                    constraintManager.assertDeleteAuthorization(message);
                    if(co.getObjectId() == null)
                    {
                        validationError = new AdapterException();
                        validationError.setMessage(10503);
                    }
                } else
                {
                    validationError = new AdapterException();
                    validationError.setMessage(10504, new Object[] {
                        new Integer(message.getOperation())
                    });
                }
            }
            catch(SecurityException securityException)
            {
                validationError = securityException;
            }
            if(validationError != null)
            {
                if(DataServiceTransaction.getCurrentUserTransaction() == null)
                    invalidChange = co;
                else
                    throw validationError;
                break;
            }
            if(co.isCreate())
            {
                co.setNewVersion(dataDestination.getTypedItem(message.getBody(), typeMarshaller));
                if(!hasCheckedIncomingType)
                    checkIncomingType(co.getNewVersion());
                continue;
            }
            if(co.isUpdate())
            {
                Object updateArtifacts[] = DataService.getUpdateBody(message);
                prepareUpdateOperation(message, co, updateArtifacts);
                continue;
            }
            if(co.isDelete())
                co.setPreviousVersion(dataDestination.getTypedItem(message.getBody(), typeMarshaller));
        }

        assemblerError = null;
        changeList.setWriteLock(true);
        if(changeList.size() > 0)
            invokeSyncOperation(assemblerObj, changeList);
        changeList.setWriteLock(false);
        break MISSING_BLOCK_LABEL_468;
        SecurityException e;
        e;
        assemblerError = e;
        changeList.setWriteLock(false);
        break MISSING_BLOCK_LABEL_468;
        e;
        assemblerError = e;
        changeList.setWriteLock(false);
        break MISSING_BLOCK_LABEL_468;
        e;
        assemblerError = e.getCause();
        changeList.setWriteLock(false);
        break MISSING_BLOCK_LABEL_468;
        e;
        assemblerError = e.getCause();
        changeList.setWriteLock(false);
        break MISSING_BLOCK_LABEL_468;
        Exception exception;
        exception;
        changeList.setWriteLock(false);
        throw exception;
        List outgoingMessages;
        Throwable syncError;
        if(assemblerError != null)
        {
            if(Log.isDebug())
                Log.getLogger(LOG_CATEGORY).debug("Exception during sync of: " + assemblerObj.getClass() + StringUtils.NEWLINE + ExceptionUtil.toString(assemblerError));
            syncError = assemblerError;
        } else
        if(validationError != null)
        {
            changeList.add(invalidChange);
            syncError = validationError;
        } else
        {
            syncError = null;
        }
        outgoingMessages = postprocessSyncOperation(changeList, syncError, assemblerObj);
        break MISSING_BLOCK_LABEL_742;
        MessageException messageException;
        messageException;
        throw messageException;
        Exception e;
        e;
        AdapterException aex = new AdapterException();
        String destination = null;
        if(incomingMessages.size() > 0)
        {
            Message msg = (Message)incomingMessages.get(0);
            destination = msg.getDestination();
        }
        if(e.getMessage() != null)
            aex.setMessage(10500, new Object[] {
                destination, e.getMessage()
            });
        else
            aex.setMessage(10500, new Object[] {
                destination, e.toString()
            });
        if(Log.isDebug())
            Log.getLogger(LOG_CATEGORY).debug("Exception during sync of: " + assemblerObj.getClass() + StringUtils.NEWLINE + ExceptionUtil.toString(e));
        aex.setRootCause(e);
        throw aex;
        return outgoingMessages;
    }

    private void checkIncomingType(Object type)
    {
        if(!hasCheckedIncomingType && hasReturnedAnything && !hasReturnedWeakTypes && (type instanceof Map))
        {
            if(Log.isWarn())
                Log.getLogger(LOG_CATEGORY).warn("Your sync, create, or update method is being called with a weak typed object (flex.messaging.io.amf.ASObject - a subclass of java.util.Map) even though you did not return a weak type from your get/fill method.  If you do not define actionscript classes for your java classes and mark them with RemoteClass metadata they will get turned into Maps on the way in.  If you do want to use only anonymous objects on the client and you have no associations you might consider setting an item-class in the destination to have the server convert the Map to your class automatically.");
            hasCheckedIncomingType = true;
        } else
        if(hasReturnedAnything)
            hasCheckedIncomingType = true;
    }

    private Object removeReadOnlyPropertiesFromChanges(Object changes)
    {
        List readOnlyProps = dataDestination.getReadOnlyProperties();
        if(readOnlyProps == null || changes == null)
            return changes;
        List params;
        if(changes instanceof ArrayList)
        {
            params = (List)((ArrayList)changes).clone();
            for(int i = 0; i < readOnlyProps.size(); params.remove(readOnlyProps.get(i)));
        } else
        {
            Object arrParams[] = (Object[])(Object[])changes;
            params = new ArrayList(arrParams.length);
            for(int i = 0; i < arrParams.length; i++)
            {
                int j;
                for(j = 0; j < readOnlyProps.size() && !readOnlyProps.get(j).equals(arrParams[i]); j++);
                if(j == readOnlyProps.size())
                    params.add(arrParams[i]);
            }

        }
        return params;
    }

    private void prepareUpdateOperation(DataMessage message, ChangeObjectImpl co, Object updateArtifacts[])
    {
        Object changesObj = updateArtifacts[0];
        changesObj = removeReadOnlyPropertiesFromChanges(changesObj);
        if(changesObj instanceof List)
            changesObj = ((Object) (((List)changesObj).toArray()));
        Object changes[] = (Object[])(Object[])changesObj;
        co.setChanges(changes);
        Object clientPreviousVersion = dataDestination.getTypedItem(updateArtifacts[1], typeMarshaller);
        Object clientCurrentVersion = dataDestination.getTypedItem(updateArtifacts[2], typeMarshaller);
        if(!hasCheckedIncomingType)
            checkIncomingType(clientCurrentVersion);
        co.setPreviousVersion(clientPreviousVersion);
        co.setNewVersion(clientCurrentVersion);
    }

    protected synchronized void invokeSyncOperation(Object assemblerObj, List changeList)
        throws IllegalArgumentException, IllegalAccessException, InvocationTargetException
    {
        if(syncMethod == null)
        {
            AdapterException aex = new AdapterException();
            aex.setMessage(10501, new Object[] {
                destination.getId()
            });
            throw aex;
        } else
        {
            syncMethod.invoke(assemblerObj, new Object[] {
                changeList
            });
            return;
        }
    }

    private List postprocessSyncOperation(List changeList, Throwable syncError, Object assemblerObj)
    {
        List resultList = new ArrayList();
        Iterator iter = changeList.iterator();
        do
        {
            if(!iter.hasNext())
                break;
            ChangeObjectImpl co = (ChangeObjectImpl)iter.next();
            if(co.getStatus() == 1)
            {
                Message outputMessage = null;
                if(syncError != null && (syncError instanceof DataSyncException))
                {
                    DataSyncException ds = (DataSyncException)syncError;
                    if(ds.getConflictCause().getMessageId().equals(co.getMessage().getMessageId()))
                    {
                        outputMessage = buildSyncErrorMessage((DataSyncException)syncError, co);
                        syncError = null;
                    }
                }
                if(outputMessage == null)
                {
                    outputMessage = co.getMessage();
                    if(co.getNewVersion() != null)
                        if(co.isCreate())
                        {
                            outputMessage.setBody(dataDestination.wrapItem(co.getNewVersion()));
                            Map identityMap = getIdentityFromItem(co.getNewVersion());
                            ((DataMessage)outputMessage).setIdentity(identityMap);
                        } else
                        if(co.isUpdate())
                        {
                            DataService.setUpdateBody((DataMessage)outputMessage, 2, dataDestination.wrapItem(co.getNewVersion()));
                            DataService.setUpdateBody((DataMessage)outputMessage, 1, dataDestination.wrapItem(co.getPreviousVersion()));
                        }
                }
                resultList.add(outputMessage);
                continue;
            }
            if(co.getStatus() == 0)
            {
                if(syncError != null)
                {
                    if(syncError instanceof DataSyncException)
                    {
                        ErrorMessage errMsg = buildSyncErrorMessage((DataSyncException)syncError, co);
                        resultList.add(errMsg);
                    } else
                    if(syncError instanceof SecurityException)
                    {
                        ErrorMessage errMsg = ((SecurityException)syncError).createErrorMessage();
                        resultList.add(errMsg);
                    } else
                    {
                        co.fail(syncError.toString());
                        resultList.add(co.createErrorMessage());
                    }
                    syncError = null;
                    break;
                }
                if(Log.isWarn())
                    if(assemblerObj == null || syncMethod == null)
                        Log.getLogger(LOG_CATEGORY).warn("Adapter class: " + getClass() + " didn't process any changes");
                    else
                        Log.getLogger(LOG_CATEGORY).warn("Sync method " + assemblerObj.getClass().getName() + "." + syncMethod.getName() + " Didn't process any changes. No messages will be processed.");
            } else
            {
                resultList.add(co.createErrorMessage());
            }
        } while(true);
        if(syncError != null)
        {
            if(syncError instanceof MessageException)
                throw (MessageException)syncError;
            else
                throw new MessageException(syncError.getMessage(), syncError);
        } else
        {
            return resultList;
        }
    }

    protected Map getIdentityFromItem(Object item)
    {
        return ItemIdentity.getIdentityFor(item, dataDestination);
    }

    protected ErrorMessage buildSyncErrorMessage(DataSyncException syncError, ChangeObject co)
    {
        ErrorMessage errMsg = syncError.createErrorMessage();
        Message msg = co.getMessage();
        errMsg.setCorrelationId(msg.getMessageId());
        errMsg.setDestination(msg.getDestination());
        boolean needsReferencedIds = dataDestination.getNeedsReferencedIds();
        if(needsReferencedIds && syncError.getServerObject() != null)
            errMsg.setHeader("referencedIds", dataDestination.getReferencedIds(syncError.getServerObject()));
        return errMsg;
    }

    protected Object getAssemblerObject()
    {
        Object assemblerObj = dataDestination.getFactoryInstance().lookup();
        if(methodFactory == null && assemblerObj != null)
            initMethodFactory(assemblerObj.getClass());
        return assemblerObj;
    }

    protected Object getIdentity(DataMessage message)
    {
        return getIdentityFromMessage(message);
    }

    protected Object getIdentityFromMessage(DataMessage message)
    {
        Object uid = null;
        try
        {
            Map identityMap = message.getIdentity();
            if(identityMap.size() > 1)
                uid = identityMap;
            else
                uid = identityMap.get(dataDestination.getPropertySettings().getIdentityPropertyNames().get(0).toString());
        }
        catch(Exception e) { }
        return uid;
    }

    public void setupAdapterControl(Destination destination)
    {
        controller = new JavaAdapterControl(getId(), this, destination.getControl());
        controller.register();
        setControl(controller);
    }

    private JavaAdapterMethodFactory methodFactory;
    private List countMethods;
    private List fillMethods;
    private GetMethod getMethod;
    private Method syncMethod;
    private JavaAdapterControl controller;
    private String LOG_CATEGORY;
    private boolean hasReturnedAnything;
    private boolean hasReturnedWeakTypes;
    private static boolean hasCheckedIncomingType = false;
    private TypeMarshaller typeMarshaller;
    protected DataDestination dataDestination;
    protected SecurityConstraintManager constraintManager;
    protected ConfigMap serverProperties;
    protected static final Integer DO_NOT_EXECUTE_FILL = new Integer(0);
    protected static final Integer EXECUTE_FILL = new Integer(1);
    protected static final Integer APPEND_TO_FILL = new Integer(2);
    protected static final Integer REMOVE_FROM_FILL = new Integer(3);
    private static final String NULL_PARAM_TYPE = "null";

}
