// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JavaAdapterMethodFactory.java

package flex.data.adapters;

import flex.messaging.MessageException;
import flex.messaging.config.ConfigMap;
import flex.messaging.util.ClassUtil;
import java.lang.reflect.Method;
import java.util.*;

// Referenced classes of package flex.data.adapters:
//            AdapterException, JavaAdapterConstants, JavaAdapter

public class JavaAdapterMethodFactory
    implements JavaAdapterConstants
{

    public JavaAdapterMethodFactory(JavaAdapter adapter, Class assemblerClass)
    {
        this.adapter = adapter;
        this.assemblerClass = assemblerClass;
    }

    List generateCountMethods(ConfigMap server)
    {
        List countMethods = null;
        List countSettings = server.getPropertyAsList("count-method", null);
        if(countSettings != null)
        {
            countMethods = new ArrayList();
            int i = 0;
            do
            {
                if(i >= countSettings.size())
                    break;
                ConfigMap countProperties = (ConfigMap)countSettings.get(i);
                JavaAdapter.QueryMethod countMethod = generateQueryMethod(countProperties);
                for(Iterator iter = countMethods.iterator(); iter.hasNext();)
                {
                    JavaAdapter.QueryMethod qm = (JavaAdapter.QueryMethod)iter.next();
                    if(qm.argTypes.equals(countMethod.argTypes))
                    {
                        AdapterException aex = new AdapterException();
                        aex.setMessage(10514);
                        throw aex;
                    }
                }

                countMethods.add(countMethod);
                i++;
            } while(true);
        }
        return countMethods;
    }

    List generateFillMethods(ConfigMap server)
    {
        List fillMethods = null;
        List fillSettings = server.getPropertyAsList("fill-method", null);
        if(fillSettings != null)
        {
            fillMethods = new ArrayList();
            for(int i = 0; i < fillSettings.size(); i++)
            {
                ConfigMap fillProperties = (ConfigMap)fillSettings.get(i);
                fillMethods.add(generateFillMethod(fillProperties));
            }

        }
        return fillMethods;
    }

    JavaAdapter.GetMethod generateGetMethod(ConfigMap server)
    {
        JavaAdapter.GetMethod getMethod = null;
        ConfigMap getProperties = server.getPropertyAsMap("get-method", null);
        if(getProperties != null)
        {
            getProperties.put("params", "java.util.Map");
            getMethod = new JavaAdapter.GetMethod(adapter);
            generateAssemblerMethod(getMethod, getProperties);
        }
        return getMethod;
    }

    private JavaAdapter.QueryMethod generateQueryMethod(ConfigMap methodProperties)
    {
        JavaAdapter.QueryMethod fm = new JavaAdapter.QueryMethod(adapter);
        return generateAssemblerMethod(fm, methodProperties);
    }

    private JavaAdapter.FillMethod generateFillMethod(ConfigMap methodProperties)
    {
        JavaAdapter.FillMethod fm = new JavaAdapter.FillMethod(adapter);
        generateAssemblerMethod(fm, methodProperties);
        fm.autoRefresh = methodProperties.getPropertyAsBoolean("auto-refresh", true);
        fm.ordered = methodProperties.getPropertyAsBoolean("ordered", true);
        ConfigMap fillContainsMap = methodProperties.getPropertyAsMap("fill-contains-method", null);
        if(fillContainsMap != null)
        {
            String fillContainsName = fillContainsMap.getPropertyAsString("name", null);
            if(fillContainsName == null)
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10534, new Object[] {
                    fm.name, assemblerClass.getName()
                });
                throw aex;
            }
            try
            {
                fm.fillContains = assemblerClass.getMethod(fillContainsName, FILL_CONTAINS_ARGS);
            }
            catch(NoSuchMethodException exc)
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10533, new Object[] {
                    fillContainsName, assemblerClass.getName()
                });
                throw aex;
            }
        } else
        if(methodProperties.getPropertyAsString("fill-contains-method", null) != null)
        {
            AdapterException aex = new AdapterException();
            aex.setMessage(10537, new Object[] {
                fm.name, assemblerClass.getName()
            });
            throw aex;
        }
        if(fm.fillContains != null && !fm.autoRefresh)
        {
            AdapterException exception = new AdapterException();
            Object args[] = {
                fm.name, assemblerClass.getName()
            };
            exception.setMessage(10543, args);
            throw exception;
        } else
        {
            return fm;
        }
    }

    private JavaAdapter.QueryMethod generateAssemblerMethod(JavaAdapter.QueryMethod fm, ConfigMap methodProperties)
    {
        fm.name = methodProperties.getPropertyAsString("name", null);
        String typeNames = methodProperties.getPropertyAsString("params", null);
        if(typeNames != null)
        {
            StringTokenizer st = new StringTokenizer(typeNames, ",");
            do
            {
                if(!st.hasMoreTokens())
                    break;
                String typeName = st.nextToken();
                try
                {
                    fm.argTypes.add(getClassForType(typeName));
                }
                catch(MessageException cnf)
                {
                    AdapterException aex = new AdapterException();
                    aex.setMessage(10515, new Object[] {
                        typeName
                    });
                    throw aex;
                }
            } while(true);
        }
        try
        {
            int argCount = fm.argTypes.size();
            Class args[] = (Class[])(Class[])fm.argTypes.toArray(new Class[argCount]);
            fm.method = assemblerClass.getMethod(fm.name, args);
        }
        catch(NoSuchMethodException nsm)
        {
            AdapterException aex = new AdapterException();
            aex.setMessage(10516, new Object[] {
                fm.name, typeNames, assemblerClass.getName()
            });
            throw aex;
        }
        return fm;
    }

    Method generateSyncMethod(ConfigMap server)
    {
        Method syncMethod = getSingleMethod("sync-method", new Class[] {
            java.util.List.class
        }, server, 10517, 10538);
        return syncMethod;
    }

    private Method getSingleMethod(String elementName, Class paramTypes[], ConfigMap server, int errNotFound, int errMultipleFound)
    {
        Method result = null;
        ConfigMap info = server.getPropertyAsMap(elementName, null);
        if(info != null)
        {
            try
            {
                String methodName = info.getProperty("name");
                result = assemblerClass.getMethod(methodName, paramTypes);
            }
            catch(Exception e)
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(errNotFound, new Object[] {
                    info.getProperty("name"), assemblerClass.getName()
                });
                throw aex;
            }
        } else
        {
            List syncPropertiesList = server.getPropertyAsList(elementName, null);
            if(syncPropertiesList != null)
            {
                StringBuffer methodList = null;
                for(int i = 0; i < syncPropertiesList.size(); i++)
                {
                    String methodName = ((ConfigMap)syncPropertiesList.get(i)).getProperty("name");
                    if(methodList == null)
                        methodList = new StringBuffer();
                    else
                        methodList.append(", ");
                    methodList.append(methodName);
                }

                AdapterException aex = new AdapterException();
                aex.setMessage(errMultipleFound, new Object[] {
                    methodList.toString()
                });
                throw aex;
            }
        }
        return result;
    }

    private Class getClassForType(String typeName)
    {
        Class c = null;
        if(typeName.equals("int"))
            c = Integer.TYPE;
        else
        if(typeName.equals("float"))
            c = Float.TYPE;
        else
        if(typeName.equals("double"))
            c = Double.TYPE;
        else
        if(typeName.equals("byte"))
            c = Byte.TYPE;
        else
        if(typeName.equals("char"))
            c = Character.TYPE;
        else
            c = ClassUtil.createClass(typeName);
        return c;
    }

    private JavaAdapter adapter;
    private Class assemblerClass;
    private static final Class FILL_CONTAINS_ARGS[];

    static 
    {
        FILL_CONTAINS_ARGS = (new Class[] {
            ((Object) (new Object[0])).getClass(), java.lang.Object.class
        });
    }
}
