// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SecurityConstraintManager.java

package flex.data.adapters;

import flex.data.DataServiceTransaction;
import flex.messaging.FlexContext;
import flex.messaging.MessageBroker;
import flex.messaging.config.*;
import flex.messaging.messages.Message;
import flex.messaging.security.LoginManager;
import flex.messaging.security.SecurityException;

public final class SecurityConstraintManager
{

    public SecurityConstraintManager(MessageBroker broker)
    {
        loginManager = broker.getLoginManager();
        securitySettings = broker.getSecuritySettings();
    }

    public final void createConstraints(ConfigMap serverSettings)
    {
        ConfigMap count = serverSettings.getPropertyAsMap("count-security-constraint", null);
        if(count != null)
        {
            String ref = count.getPropertyAsString("ref", null);
            if(ref != null)
                countConstraint = securitySettings.getConstraint(ref);
        }
        ConfigMap create = serverSettings.getPropertyAsMap("create-security-constraint", null);
        if(create != null)
        {
            String ref = create.getPropertyAsString("ref", null);
            if(ref != null)
                createConstraint = securitySettings.getConstraint(ref);
        }
        ConfigMap read = serverSettings.getPropertyAsMap("read-security-constraint", null);
        if(read != null)
        {
            String ref = read.getPropertyAsString("ref", null);
            if(ref != null)
                readConstraint = securitySettings.getConstraint(ref);
        }
        ConfigMap update = serverSettings.getPropertyAsMap("update-security-constraint", null);
        if(update != null)
        {
            String ref = update.getPropertyAsString("ref", null);
            if(ref != null)
                updateConstraint = securitySettings.getConstraint(ref);
        }
        ConfigMap delete = serverSettings.getPropertyAsMap("delete-security-constraint", null);
        if(delete != null)
        {
            String ref = delete.getPropertyAsString("ref", null);
            if(ref != null)
                deleteConstraint = securitySettings.getConstraint(ref);
        }
    }

    public final void assertCountAuthorization(Message message)
    {
        checkConstraint(countConstraint, message);
    }

    public final void assertReadAuthorization(Message message)
    {
        DataServiceTransaction dtx = DataServiceTransaction.getCurrentDataServiceTransaction();
        if(dtx != null && dtx.isRefill())
        {
            return;
        } else
        {
            checkConstraint(readConstraint, message);
            return;
        }
    }

    public final void assertCreateAuthorization(Message message)
    {
        checkConstraint(createConstraint, message);
    }

    public final void assertUpdateAuthorization(Message message)
    {
        checkConstraint(updateConstraint, message);
    }

    public final void assertDeleteAuthorization(Message message)
    {
        checkConstraint(deleteConstraint, message);
    }

    private final void checkConstraint(SecurityConstraint constraint, Message message)
    {
        if(constraint != null && !FlexContext.isMessageFromPeer())
            try
            {
                loginManager.checkConstraint(constraint);
            }
            catch(SecurityException e)
            {
                e.setFailingMessage(message);
                throw e;
            }
    }

    private static final String COUNT_SECURITY_CONSTRAINT = "count-security-constraint";
    private static final String CREATE_SECURITY_CONSTRAINT = "create-security-constraint";
    private static final String READ_SECURITY_CONSTRAINT = "read-security-constraint";
    private static final String UPDATE_SECURITY_CONSTRAINT = "update-security-constraint";
    private static final String DELETE_SECURITY_CONSTRAINT = "delete-security-constraint";
    private LoginManager loginManager;
    private SecuritySettings securitySettings;
    private SecurityConstraint countConstraint;
    private SecurityConstraint createConstraint;
    private SecurityConstraint readConstraint;
    private SecurityConstraint updateConstraint;
    private SecurityConstraint deleteConstraint;
}
