// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HibernateAssembler.java

package flex.data.assemblers;

import flex.data.DataDestination;
import flex.data.DataSyncException;
import flex.data.adapters.AdapterException;
import flex.data.adapters.JavaAdapterConstants;
import flex.data.config.AssociationSetting;
import flex.messaging.FlexConfigurable;
import flex.messaging.config.ConfigMap;
import flex.messaging.io.BeanProxy;
import flex.messaging.io.PropertyProxyRegistry;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.util.ExceptionUtil;
import flex.messaging.util.StringUtils;
import java.io.PrintStream;
import java.sql.SQLException;
import java.util.*;
import org.hibernate.*;
import org.hibernate.cfg.Configuration;

// Referenced classes of package flex.data.assemblers:
//            AbstractAssembler, HibernateManager, HibernatePropertyProxy, HibernateType

public class HibernateAssembler extends AbstractAssembler
    implements FlexConfigurable, JavaAdapterConstants
{

    public HibernateAssembler()
    {
    }

    public void initialize(String id, ConfigMap properties)
    {
        String hibernateConfigFile = null;
        destinationId = id;
        dataDestination = DataDestination.getDataDestination(id);
        hibernateConfigFile = properties.getPropertyAsMap("server", null).getPropertyAsString("hibernate-config-file", null);
        boolean useTransactions = properties.getPropertyAsBoolean("use-transactions", true);
        synchronized(hibernateManagers)
        {
            HibernateManager mgr = (HibernateManager)hibernateManagers.get(hibernateConfigFile);
            if(mgr == null)
            {
                Configuration configuration = createHibernateConfiguration(hibernateConfigFile);
                mgr = new HibernateManager(configuration, useTransactions);
                hibernateManagers.put(hibernateConfigFile, mgr);
                PropertyProxyRegistry.getRegistry().register(org.hibernate.proxy.HibernateProxy.class, new HibernatePropertyProxy());
            }
            hibernateManager = mgr;
        }
        ConfigMap serverSettings = properties.getPropertyAsMap("server", null);
        String entityName = serverSettings.getPropertyAsString("hibernate-entity", destinationId);
        hibernateType = new HibernateType(hibernateManager, entityName, dataDestination, serverSettings);
    }

    protected Configuration createHibernateConfiguration(String hibernateConfigFile)
    {
        Configuration hibernateConfig;
        if(hibernateConfigFile == null)
            hibernateConfig = (new Configuration()).configure();
        else
            hibernateConfig = (new Configuration()).configure(hibernateConfigFile);
        return hibernateConfig;
    }

    public int count(List countParams)
    {
        Session session;
        hibernateType.initialize();
        if(countParams.size() != 0)
            break MISSING_BLOCK_LABEL_132;
        session = hibernateManager.getSession(false);
        int i;
        Integer count = (Integer)session.createQuery("select count(*) from " + hibernateType.entityClass.getName()).uniqueResult();
        hibernateManager.commitSession(session, false);
        i = count.intValue();
        hibernateManager.closeSession(session, false);
        return i;
        RuntimeException hex;
        hex;
        handleHibernateException(hex, "count");
        hibernateManager.closeSession(session, false);
        break MISSING_BLOCK_LABEL_159;
        Exception exception;
        exception;
        hibernateManager.closeSession(session, false);
        throw exception;
        throw new UnsupportedOperationException("No count method defined for hibernate adapter: " + countParams);
        return -1;
    }

    public Object getItem(Map identity)
    {
        Object result;
        Object objectId;
        Session session;
        hibernateType.initialize();
        result = null;
        if(identity == null || identity.isEmpty())
            break MISSING_BLOCK_LABEL_144;
        objectId = identity.size() != 1 ? ((Object) (identity)) : identity.values().iterator().next();
        if(objectId == null)
            break MISSING_BLOCK_LABEL_144;
        session = hibernateManager.getSession(false);
        result = hibernateType.getObjectFromServer(objectId, session);
        fetchObjectProperties(result);
        hibernateManager.commitSession(session, false);
        hibernateManager.closeSession(session, false);
        break MISSING_BLOCK_LABEL_144;
        RuntimeException ite;
        ite;
        handleHibernateException(ite, "getItem");
        hibernateManager.closeSession(session, false);
        break MISSING_BLOCK_LABEL_144;
        Exception exception;
        exception;
        hibernateManager.closeSession(session, false);
        throw exception;
        return result;
    }

    public Collection fill(List fillArgs)
    {
        Collection result;
        String expression;
        String queryName;
        Object parameters;
        boolean isNamedQuery;
        Session session;
        hibernateType.initialize();
        result = null;
        expression = null;
        queryName = null;
        parameters = null;
        isNamedQuery = true;
        boolean needsParams = true;
        if(fillArgs == null || fillArgs.size() == 0)
        {
            AdapterException aex = new AdapterException();
            aex.setMessage(10521, new Object[] {
                destinationId
            });
            throw aex;
        }
        queryName = (String)fillArgs.get(0);
        if(hibernateType.allowHQLQueries && queryName != null && queryName.equals("flex:hql"))
        {
            if(fillArgs.size() == 1)
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10531, new Object[] {
                    destinationId
                });
                throw aex;
            }
            if(!(fillArgs.get(1) instanceof String))
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10545, new Object[] {
                    destinationId
                });
                throw aex;
            }
            expression = (String)fillArgs.get(1);
            needsParams = expression.indexOf(":") != -1 || expression.indexOf("?") != -1;
            if(fillArgs.size() == 2)
            {
                if(needsParams)
                {
                    AdapterException aex = new AdapterException();
                    aex.setMessage(10522, new Object[] {
                        destinationId
                    });
                    throw aex;
                }
            } else
            if(fillArgs.size() != 3)
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10532, new Object[] {
                    destinationId
                });
                throw aex;
            }
            isNamedQuery = false;
            if(needsParams)
                parameters = fillArgs.get(2);
            else
                parameters = null;
        } else
        {
            if(fillArgs.size() != 2)
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10544, new Object[] {
                    destinationId
                });
                throw aex;
            }
            parameters = fillArgs.get(1);
        }
        if(needsParams && !(parameters instanceof Map) && !(parameters instanceof List) && !(parameters instanceof Object[]))
        {
            AdapterException aex = new AdapterException();
            aex.setMessage(10545, new Object[] {
                destinationId
            });
            throw aex;
        }
        session = hibernateManager.getSession(false);
        Query query = null;
        if(isNamedQuery)
            query = session.getNamedQuery(queryName);
        else
            query = session.createQuery(expression);
        if(parameters != null)
            if(parameters instanceof Map)
            {
                Map paramMap = (Map)parameters;
                for(Iterator iter = paramMap.keySet().iterator(); iter.hasNext();)
                {
                    String paramName = (String)iter.next();
                    Object paramValue = paramMap.get(paramName);
                    if(paramValue instanceof Integer)
                        query.setInteger(paramName, ((Integer)paramValue).intValue());
                    else
                    if(paramValue instanceof Long)
                        query.setLong(paramName, ((Long)paramValue).longValue());
                    else
                        query.setParameter(paramName, paramValue);
                }

            } else
            {
                if(parameters.getClass().isArray())
                    parameters = Arrays.asList((Object[])(Object[])parameters);
                List paramList = (List)parameters;
                for(int position = 0; position < paramList.size(); position++)
                {
                    Object paramValue = paramList.get(position);
                    if(paramValue instanceof Integer)
                    {
                        query.setInteger(position, ((Integer)paramValue).intValue());
                        continue;
                    }
                    if(paramValue instanceof Long)
                        query.setLong(position, ((Long)paramValue).longValue());
                    else
                        query.setParameter(position, paramValue);
                }

            }
        if(hibernateType.useQueryCache)
            query.setCacheable(true);
        result = query.list();
        if(result != null)
        {
            for(Iterator it = result.iterator(); it.hasNext(); fetchObjectProperties(it.next()));
        }
        hibernateManager.commitSession(session, false);
        hibernateManager.closeSession(session, false);
        break MISSING_BLOCK_LABEL_892;
        RuntimeException ite;
        ite;
        handleHibernateException(ite, "fill");
        hibernateManager.closeSession(session, false);
        break MISSING_BLOCK_LABEL_892;
        Exception exception;
        exception;
        hibernateManager.closeSession(session, false);
        throw exception;
        return result;
    }

    public boolean autoRefreshFill(List fillParameters)
    {
        return true;
    }

    public int refreshFill(List fillParameters, Object item, boolean isCreate)
    {
        return 1;
    }

    protected void handleHibernateException(RuntimeException ite, String type)
    {
        if(ite instanceof JDBCException)
        {
            String sqlError = null;
            JDBCException hjdbcex = (JDBCException)ite;
            if(hjdbcex.getSQLException() != null)
                sqlError = " from SQLException: " + hjdbcex.getSQLException().toString();
            if(Log.isDebug())
                Log.getLogger("DataService.Hibernate").debug("Hibernate jdbc exception on operation=" + type + " error=" + ExceptionUtil.toString(ite) + StringUtils.NEWLINE + " sqlError= " + sqlError);
        }
        throw ite;
    }

    public void createItem(Object item)
    {
        Session session;
        hibernateType.initialize();
        session = hibernateManager.getSession(true);
        try
        {
            session.save(item);
            hibernateManager.commitSession(session, true);
        }
        catch(RuntimeException exc)
        {
            hibernateManager.rollbackSession(session);
            throw exc;
        }
        hibernateManager.closeSession(session, true);
        break MISSING_BLOCK_LABEL_70;
        Exception exception;
        exception;
        hibernateManager.closeSession(session, true);
        throw exception;
    }

    public void updateItem(Object newItem, Object prevItem, List changes)
    {
        Session session;
        hibernateType.initialize();
        session = hibernateManager.getSession(true);
        try
        {
            Object objectId = hibernateType.getIdentityFromItem(newItem);
            List conflictingProperties = null;
            Object serverVersion = hibernateType.getObjectFromServer(objectId, session, LockMode.UPGRADE);
            if(serverVersion == null)
                throw new DataSyncException((Object)null, (List)null);
            BeanProxy serverVersionProxy = new BeanProxy(serverVersion);
            List properties = serverVersionProxy.getPropertyNames(serverVersion);
            if(changes == null)
                changes = properties;
            if(prevItem != null)
            {
                BeanProxy prevVersionProxy = new BeanProxy(prevItem);
                if(hibernateType.updateConflictMode == 2)
                {
                    for(int i = 0; i < properties.size(); i++)
                    {
                        String propName = (String)properties.get(i);
                        Object serverCurrentValue = serverVersionProxy.getValue(propName);
                        Object clientPreviousValue = prevVersionProxy.getValue(propName);
                        if(serverCurrentValue != null && clientPreviousValue != null && (serverCurrentValue == null || !serverCurrentValue.equals(clientPreviousValue)))
                        {
                            if(conflictingProperties == null)
                                conflictingProperties = new ArrayList();
                            conflictingProperties.add(propName);
                        }
                    }

                } else
                if(hibernateType.updateConflictMode == 1)
                {
                    for(int i = 0; i < changes.size(); i++)
                    {
                        String changedPropName = (String)changes.get(i);
                        Object serverCurrentValue = serverVersionProxy.getValue(changedPropName);
                        Object clientPreviousValue = prevVersionProxy.getValue(changedPropName);
                        if(serverCurrentValue == null || clientPreviousValue == null || serverCurrentValue != null && serverCurrentValue.equals(clientPreviousValue))
                            continue;
                        if(conflictingProperties == null)
                            conflictingProperties = new ArrayList();
                        conflictingProperties.add(changedPropName);
                    }

                }
            }
            if(conflictingProperties == null)
            {
                BeanProxy newItemProxy = new BeanProxy(newItem);
label0:
                for(int c = 0; c < changes.size(); c++)
                {
                    String changedPropName = (String)changes.get(c);
                    AssociationSetting assoc = dataDestination.getAssociation(changedPropName);
                    Object newValue = newItemProxy.getValue(changedPropName);
                    if(assoc == null)
                    {
                        serverVersionProxy.setValue(changedPropName, newValue);
                        continue;
                    }
                    HibernateType assocType = HibernateType.getHibernateType(assoc.getDestination());
                    if(assocType == null)
                    {
                        AdapterException aex = new AdapterException();
                        aex.setMessage(10519, new Object[] {
                            destinationId, assoc.getDestination()
                        });
                        throw aex;
                    }
                    if(assoc.isMulti())
                    {
                        Collection toColl = (Collection)serverVersionProxy.getValue(changedPropName);
                        Collection fromColl = (Collection)newValue;
                        List fromList;
                        List toList;
                        boolean isList;
                        if(toColl instanceof List)
                        {
                            toList = (List)toColl;
                            fromList = (List)fromColl;
                            isList = true;
                        } else
                        {
                            toList = new ArrayList(toColl);
                            fromList = Arrays.asList(fromColl.toArray());
                            isList = false;
                        }
                        int i = 0;
                        int fromSize = fromList.size();
                        for(i = 0; i < fromSize; i++)
                        {
                            Object fromItem = fromList.get(i);
                            Object fromId = assocType.getIdentityFromItem(fromItem);
                            Object toItem = null;
                            Object toId = null;
                            if(i < toList.size())
                            {
                                toItem = toList.get(i);
                                if(toItem == null)
                                {
                                    Log.getLogger("DataService.Hibernate").error("Null instance encountered in current property on destination: " + destinationId + " for association: " + assoc.getProperty() + " for index: " + i);
                                    continue;
                                }
                                toId = assocType.getIdentityFromItem(toItem);
                            }
                            if(fromItem == null)
                            {
                                Log.getLogger("DataService.Hibernate").error("Null instance encountered in new version of property on destination: " + destinationId + " for association: " + assoc.getProperty() + " for index: " + i);
                                continue;
                            }
                            if(i < toList.size() && fromId.equals(toId))
                                continue;
                            if(i < toList.size())
                            {
                                int j;
                                for(j = i + 1; j < fromSize && !toId.equals(assocType.getIdentityFromItem(fromList.get(j))); j++);
                                if(j == fromSize)
                                {
                                    toList.remove(i);
                                    if(!isList)
                                        toColl.remove(toItem);
                                }
                            }
                            int k;
                            for(k = i; k < toList.size() && !assocType.getIdentityFromItem(toList.get(i)).equals(fromId); k++);
                            if(k == i && k < toList.size())
                                continue;
                            if(k < toList.size())
                            {
                                if(!isList)
                                    toColl.remove(toList.get(k));
                                toList.remove(k);
                            }
                            Object newItemToAdd = assocType.getObjectFromServer(fromId, session);
                            if(!isList)
                                toColl.add(newItemToAdd);
                            toList.add(i, newItemToAdd);
                        }

                        do
                        {
                            if(toList.size() <= fromList.size())
                                continue label0;
                            int ix = toList.size() - 1;
                            if(!isList && !toColl.remove(toList.get(ix)))
                                System.err.println("*** CAN'T FIND ITEM TO REMOVE");
                            toList.remove(ix);
                        } while(true);
                    }
                    if(newValue == null)
                    {
                        serverVersionProxy.setValue(changedPropName, null);
                    } else
                    {
                        Object referencedId = assocType.getIdentityFromItem(newValue);
                        serverVersionProxy.setValue(changedPropName, assocType.getObjectFromServer(referencedId, session));
                    }
                }

                session.update(serverVersion);
                session.flush();
                hibernateManager.commitSession(session, true);
            } else
            {
                throw new DataSyncException(serverVersion, conflictingProperties);
            }
        }
        catch(RuntimeException exc)
        {
            hibernateManager.rollbackSession(session);
            throw exc;
        }
        hibernateManager.closeSession(session, true);
        break MISSING_BLOCK_LABEL_1220;
        Exception exception;
        exception;
        hibernateManager.closeSession(session, true);
        throw exception;
    }

    public void deleteItem(Object clientVersion)
    {
        Session session;
        hibernateType.initialize();
        session = hibernateManager.getSession(true);
        Object serverVersion;
        Object objectId = hibernateType.getIdentityFromItem(clientVersion);
        serverVersion = hibernateType.getObjectFromServer(objectId, session, LockMode.UPGRADE);
        if(serverVersion == null)
        {
            hibernateManager.closeSession(session, true);
            return;
        }
        try
        {
            List conflictingProperties = new ArrayList();
            BeanProxy serverVersionProxy = new BeanProxy(serverVersion);
            if(hibernateType.deleteConflictMode != 0)
            {
                List properties = serverVersionProxy.getPropertyNames(serverVersion);
                BeanProxy clientVersionProxy = new BeanProxy(clientVersion);
                for(int i = 0; i < properties.size(); i++)
                {
                    String propName = (String)properties.get(i);
                    AssociationSetting assoc = dataDestination.getAssociation(propName);
                    if(assoc != null && assoc.getReadOnly())
                        continue;
                    Object serverCurrentValue = serverVersionProxy.getValue(propName);
                    Object clientPreviousValue = clientVersionProxy.getValue(propName);
                    if(serverCurrentValue != null && clientPreviousValue != null && (serverCurrentValue == null || !serverCurrentValue.equals(clientPreviousValue)))
                        conflictingProperties.add(propName);
                }

            }
            if(conflictingProperties.size() == 0)
            {
                session.delete(serverVersion);
                hibernateManager.commitSession(session, true);
            } else
            {
                throw new DataSyncException(serverVersion, conflictingProperties);
            }
        }
        catch(RuntimeException exc)
        {
            hibernateManager.rollbackSession(session);
            throw exc;
        }
        hibernateManager.closeSession(session, true);
        break MISSING_BLOCK_LABEL_297;
        Exception exception;
        exception;
        hibernateManager.closeSession(session, true);
        throw exception;
    }

    protected void fetchObjectProperties(Object inst)
    {
        if(inst != null)
            fetchObjectProperties(dataDestination, inst, ((Set) (new HashSet())));
    }

    private void fetchObjectProperties(DataDestination dest, Object inst, Set visitedInstances)
    {
        if(inst != null && !visitedInstances.contains(inst))
        {
            visitedInstances.add(inst);
            BeanProxy instProxy = new BeanProxy(inst);
            List properties = instProxy.getPropertyNames(inst);
label0:
            for(int i = 0; i < properties.size(); i++)
            {
                AssociationSetting assoc = null;
                String propName = (String)properties.get(i);
                if(dest != null)
                {
                    assoc = dest.getAssociation(propName);
                    if(assoc != null && !assoc.isMulti() && !assoc.getCacheReferencedItems())
                        continue;
                }
                Object propValue = instProxy.getValue(propName);
                if(propValue == null)
                    continue;
                Collection values;
                if(propValue instanceof Collection)
                    values = (Collection)propValue;
                else
                if(propValue instanceof Object[])
                    values = Arrays.asList((Object[])(Object[])propValue);
                else
                if(propValue instanceof Map)
                {
                    values = ((Map)propValue).values();
                } else
                {
                    if((propValue instanceof Number) || (propValue instanceof String) || (propValue instanceof Date))
                        continue;
                    values = Collections.singletonList(propValue);
                }
                DataDestination assocDest = null;
                if(assoc != null)
                    assocDest = DataDestination.getDataDestination(assoc.getDestination());
                Iterator itr = values.iterator();
                do
                {
                    Object nestedInst;
                    do
                    {
                        if(!itr.hasNext())
                            continue label0;
                        nestedInst = itr.next();
                    } while(assoc != null && !assoc.getCacheReferencedItems());
                    fetchObjectProperties(assocDest, nestedInst, visitedInstances);
                } while(true);
            }

        }
    }

    public static final String LOG_CATEGORY = "DataService.Hibernate";
    private static final String HIBERNATE_ENTITY = "hibernate-entity";
    private static final String HIBERNATE_CONFIG_FILE = "hibernate-config-file";
    private static final String HQL_QUERY_NAME = "flex:hql";
    protected static Map hibernateManagers = Collections.synchronizedMap(new HashMap());
    protected HibernateManager hibernateManager;
    protected HibernateType hibernateType;
    protected String destinationId;
    protected DataDestination dataDestination;

}
