// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HibernateManager.java

package flex.data.assemblers;

import flex.data.DataServiceTransaction;
import org.hibernate.*;
import org.hibernate.cfg.Configuration;

public class HibernateManager
{

    public HibernateManager(Configuration hibernateConfig, boolean useTransactions)
    {
        createSessionFactory(hibernateConfig, useTransactions);
    }

    public void createSessionFactory(Configuration hibernateConfig, boolean useTransactions)
        throws ExceptionInInitializerError
    {
        try
        {
            sessionFactory = hibernateConfig.buildSessionFactory();
            if(useTransactions)
            {
                hibernateConfig.setProperty("hibernate.current_session_context_class", "flex.data.adapters.FlexHibernateSessionContext");
                syncSessionFactory = hibernateConfig.buildSessionFactory();
            }
        }
        catch(Throwable ex)
        {
            throw new ExceptionInInitializerError(ex);
        }
    }

    public SessionFactory getSessionFactory()
    {
        return sessionFactory;
    }

    public Session getSession(boolean syncSession)
        throws HibernateException
    {
        try
        {
            if(!syncSession && DataServiceTransaction.getCurrentUserTransaction() != null)
                syncSession = true;
            Session session;
            if(syncSession && syncSessionFactory != null)
                session = syncSessionFactory.getCurrentSession();
            else
                session = sessionFactory.openSession();
            if(!session.getTransaction().isActive())
                session.beginTransaction();
            return session;
        }
        catch(UnsupportedOperationException unsupportedOperationException)
        {
            throw new HibernateException(unsupportedOperationException);
        }
    }

    public void closeSession(Session session, boolean syncSession)
        throws HibernateException
    {
        if(!syncSession && DataServiceTransaction.getCurrentUserTransaction() != null)
            syncSession = true;
        if(!syncSession || syncSessionFactory == null)
            session.close();
    }

    public void commitSession(Session session, boolean syncSession)
        throws HibernateException
    {
        if(!syncSession && DataServiceTransaction.getCurrentUserTransaction() != null)
            syncSession = true;
        if(!syncSession || syncSessionFactory == null)
            session.getTransaction().commit();
    }

    public void rollbackSession(Session session)
        throws HibernateException
    {
        if(syncSessionFactory == null)
            try
            {
                session.getTransaction().rollback();
            }
            catch(TransactionException txe) { }
    }

    public static final String LOG_CATEGORY = "DataService.Hibernate";
    private SessionFactory sessionFactory;
    private SessionFactory syncSessionFactory;
}
