// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HibernateType.java

package flex.data.assemblers;

import flex.data.DataDestination;
import flex.data.adapters.*;
import flex.messaging.config.ConfigMap;
import flex.messaging.io.BeanProxy;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import java.io.Serializable;
import java.util.*;
import org.hibernate.*;
import org.hibernate.event.LoadEvent;
import org.hibernate.metadata.ClassMetadata;
import org.hibernate.type.IdentifierType;
import org.hibernate.type.Type;

// Referenced classes of package flex.data.assemblers:
//            HibernateManager

public class HibernateType
    implements JavaAdapterConstants
{

    public HibernateType(HibernateManager mgr, String entityName, DataDestination destination, ConfigMap serverSettings)
    {
        updateConflictMode = ConflictMode.getConflictMode("NONE");
        deleteConflictMode = ConflictMode.getConflictMode("NONE");
        initialized = false;
        this.entityName = entityName;
        clazzMeta = mgr.getSessionFactory().getClassMetadata(entityName);
        if(clazzMeta == null)
        {
            AdapterException aex = new AdapterException();
            aex.setMessage(10523, new Object[] {
                entityName, destinationId
            });
            throw aex;
        }
        this.destination = destination;
        hibernateManager = mgr;
        if(destination != null)
            destinationId = destination.getId();
        else
            destinationId = entityName;
        entityClass = clazzMeta.getMappedClass(EntityMode.POJO);
        idType = clazzMeta.getIdentifierType();
        idPropertyName = clazzMeta.getIdentifierPropertyName();
        synchronized(hibernateTypes)
        {
            HibernateType type = (HibernateType)hibernateTypes.get(destinationId);
            if(type == null || serverSettings != null)
            {
                hibernateTypes.put(destinationId, this);
                typesByEntityName.put(entityName, this);
            }
        }
        if(serverSettings != null)
        {
            ConfigMap fillConfig = serverSettings.getPropertyAsMap("fill-configuration", null);
            if(fillConfig != null)
            {
                useQueryCache = fillConfig.getPropertyAsBoolean("use-query-cache", false);
                allowHQLQueries = fillConfig.getPropertyAsBoolean("allow-hql-queries", false);
            }
            String updateConflictModeString = serverSettings.getPropertyAsString("update-conflict-mode", "NONE");
            updateConflictMode = ConflictMode.getConflictMode(updateConflictModeString);
            String deleteConflictModeString = serverSettings.getPropertyAsString("delete-conflict-mode", "NONE");
            deleteConflictMode = ConflictMode.getConflictMode(deleteConflictModeString);
            if(deleteConflictMode == 1)
            {
                AdapterException aex = new AdapterException();
                aex.setMessage(10524, new Object[] {
                    destinationId
                });
                throw aex;
            }
        }
    }

    synchronized void initialize()
    {
        if(initialized)
        {
            return;
        } else
        {
            initialized = true;
            return;
        }
    }

    public static HibernateType getHibernateType(String destinationName)
    {
        return (HibernateType)hibernateTypes.get(destinationName);
    }

    public Object getIdentityFromItem(Object item)
    {
        return (new BeanProxy(item)).getValue(idPropertyName);
    }

    public Object getObjectFromServer(Object id, Session session)
        throws HibernateException
    {
        return getObjectFromServer(id, session, LoadEvent.DEFAULT_LOCK_MODE);
    }

    public Object getObjectFromServer(Object id, Session session, LockMode lockMode)
        throws HibernateException
    {
        if(idType != null && id != null && idType.getReturnedClass() != id.getClass() && (idType instanceof IdentifierType))
        {
            IdentifierType identifierType = (IdentifierType)idType;
            String idImage = id.toString();
            try
            {
                id = identifierType.stringToObject(idImage);
            }
            catch(HibernateException exception)
            {
                throw exception;
            }
            catch(Exception exception)
            {
                throw new HibernateException(exception);
            }
        }
        Object ret = session.get(entityClass, (Serializable)id, lockMode);
        if(Log.isDebug())
            Log.getLogger("DataService.Hibernate").debug("Get object from hibernate with id=" + id + " -> " + ret);
        return ret;
    }

    private static final String FILL_CONFIGURATION = "fill-configuration";
    private static final String USE_QUERY_CACHE = "use-query-cache";
    private static final String ALLOW_HQL_QUERIES = "allow-hql-queries";
    public boolean useQueryCache;
    public boolean allowHQLQueries;
    public int updateConflictMode;
    public int deleteConflictMode;
    public String destinationId;
    public DataDestination destination;
    public Class entityClass;
    String entityName;
    public Type idType;
    public String idPropertyName;
    ClassMetadata clazzMeta;
    boolean initialized;
    protected static Map hibernateTypes = Collections.synchronizedMap(new HashMap());
    protected static Map typesByEntityName = Collections.synchronizedMap(new HashMap());
    HibernateManager hibernateManager;

}
