// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   BaseControl.java

package flex.management;

import flex.messaging.FlexContext;
import java.util.ArrayList;
import java.util.List;
import javax.management.*;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;

// Referenced classes of package flex.management:
//            ManagementException, BaseControlMBean, MBeanServerLocatorFactory, MBeanServerLocator

public abstract class BaseControl
    implements BaseControlMBean, MBeanRegistration
{

    public abstract String getId();

    public abstract String getType();

    public final ObjectName getParent()
    {
        return parent == null ? null : parent.getObjectName();
    }

    public String getApplicationId()
    {
        String id = "";
        ServletConfig config = FlexContext.getServletConfig();
        if(config != null)
            id = config.getServletContext().getServletContextName();
        return id;
    }

    public BaseControl(BaseControl parent)
    {
        registered = false;
        this.parent = parent;
    }

    public final BaseControl getParentControl()
    {
        return parent;
    }

    public final MBeanServer getMBeanServer()
    {
        return server;
    }

    public final void register()
    {
        if(!registered)
        {
            MBeanServer server = MBeanServerLocatorFactory.getMBeanServerLocator().getMBeanServer();
            ObjectName name = getObjectName();
            try
            {
                if(server.isRegistered(name))
                    server.unregisterMBean(name);
                server.registerMBean(this, name);
                registered = true;
            }
            catch(ManagementException me)
            {
                throw me;
            }
            catch(MBeanRegistrationException mre)
            {
                ManagementException me = new ManagementException();
                me.setMessage(10403, new Object[] {
                    name.toString()
                });
                me.setRootCause(mre);
                throw me;
            }
            catch(InstanceAlreadyExistsException iaee)
            {
                ManagementException me = new ManagementException();
                me.setMessage(10404, new Object[] {
                    name.toString()
                });
                throw me;
            }
            catch(NotCompliantMBeanException ncme)
            {
                ManagementException me = new ManagementException();
                me.setMessage(10405, new Object[] {
                    name.toString()
                });
                throw me;
            }
            catch(InstanceNotFoundException infe)
            {
                ManagementException me = new ManagementException();
                me.setMessage(10402, new Object[] {
                    name.toString()
                });
                throw me;
            }
        }
    }

    public final void unregister()
    {
        if(registered)
        {
            ObjectName name = getObjectName();
            try
            {
                if(server.isRegistered(name))
                    server.unregisterMBean(name);
                registered = false;
            }
            catch(ManagementException me)
            {
                throw me;
            }
            catch(MBeanRegistrationException mre)
            {
                ManagementException me = new ManagementException();
                me.setMessage(10401, new Object[] {
                    name.toString()
                });
                if(me.getMessage().indexOf(Integer.toString(10401)) != -1)
                    me.setMessage("The MBean named, '" + name.toString() + "', could not be unregistered because its preDeregister() method threw an exception.");
                me.setRootCause(mre);
                throw me;
            }
            catch(InstanceNotFoundException infe)
            {
                ManagementException me = new ManagementException();
                me.setMessage(10402, new Object[] {
                    name.toString()
                });
                if(me.getMessage().indexOf(Integer.toString(10402)) != -1)
                    me.setMessage("The MBean named, '" + name.toString() + "', could not be unregistered because it is not currently registered.");
                throw me;
            }
        }
    }

    public final ObjectName getObjectName()
    {
        if(objectName == null)
        {
            StringBuffer buffer = new StringBuffer();
            buffer.append("flex.runtime");
            String appId = getApplicationId();
            if(appId.length() > 0)
            {
                buffer.append('.');
                buffer.append(appId);
            }
            buffer.append(":type=");
            List types = new ArrayList();
            List ids = new ArrayList();
            types.add(getType());
            ids.add(getId());
            for(BaseControl ancestor = parent; ancestor != null; ancestor = ancestor.getParentControl())
            {
                types.add(ancestor.getType());
                ids.add(ancestor.getId());
            }

            for(int i = types.size() - 1; i >= 0; i--)
            {
                buffer.append((String)types.get(i));
                if(i > 0)
                    buffer.append('.');
            }

            buffer.append(',');
            for(int i = ids.size() - 1; i >= 1; i--)
            {
                buffer.append((String)types.get(i));
                buffer.append('=');
                buffer.append((String)ids.get(i));
                buffer.append(',');
            }

            buffer.append("id=");
            buffer.append(getId());
            String name = buffer.toString();
            try
            {
                objectName = new ObjectName(name);
            }
            catch(MalformedObjectNameException mone)
            {
                ManagementException me = new ManagementException();
                me.setMessage(10400, new Object[] {
                    name
                });
                throw me;
            }
        }
        return objectName;
    }

    public ObjectName preRegister(MBeanServer server, ObjectName name)
        throws Exception
    {
        this.server = server;
        return name != null ? name : getObjectName();
    }

    public void postRegister(Boolean boolean1)
    {
    }

    public void preDeregister()
        throws Exception
    {
    }

    public void postDeregister()
    {
    }

    protected double differenceInMinutes(long startTime, long endTime)
    {
        double minutes = (double)(endTime - startTime) / 60000D;
        if(minutes > 1.0D)
            return minutes;
        else
            return 1.0D;
    }

    public static final String DOMAIN_PREFIX = "flex.runtime";
    private static final int MALFORMED_OBJECTNAME = 10400;
    private static final int UNREG_EXCEPTION = 10401;
    private static final int UNREG_NOTFOUND = 10402;
    private static final int REG_EXCEPTION = 10403;
    private static final int REG_ALREADYEXISTS = 10404;
    private static final int REG_NOTCOMPLIANT = 10405;
    private BaseControl parent;
    private ObjectName objectName;
    private MBeanServer server;
    private boolean registered;
}
