// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   EndpointControl.java

package flex.management.runtime.messaging.endpoints;

import flex.management.BaseControl;
import flex.management.runtime.messaging.MessageBrokerControl;
import flex.messaging.config.ChannelSettings;
import flex.messaging.config.SecurityConstraint;
import flex.messaging.endpoints.Endpoint;
import java.util.Date;
import java.util.List;

// Referenced classes of package flex.management.runtime.messaging.endpoints:
//            EndpointControlMBean

public abstract class EndpointControl extends BaseControl
    implements EndpointControlMBean
{

    public EndpointControl(String id, Endpoint endpoint, BaseControl parent)
    {
        super(parent);
        this.id = id;
        this.endpoint = endpoint;
        pushStart = System.currentTimeMillis();
        serviceStart = pushStart;
        serviceMessageStart = pushStart;
    }

    public String getId()
    {
        return id;
    }

    public Boolean isRunning()
    {
        return running;
    }

    public void setRunning(Boolean value)
    {
        if(running == null || !running.equals(value))
        {
            running = value;
            if(value.booleanValue())
                startTimestamp = new Date();
        }
    }

    public Date getStartTimestamp()
    {
        return startTimestamp;
    }

    public void setStartTimestamp(Date value)
    {
        startTimestamp = value;
    }

    public Integer getPushCount()
    {
        return new Integer(pushCount);
    }

    public void resetPushCount()
    {
        pushStart = System.currentTimeMillis();
        pushCount = 0;
        lastPushTimeStamp = null;
    }

    public void incrementPushCount()
    {
        pushCount++;
        lastPushTimeStamp = new Date();
    }

    public Date getLastPushTimestamp()
    {
        return lastPushTimeStamp;
    }

    public Double getPushFrequency()
    {
        if(pushCount > 0)
        {
            double runtime = differenceInMinutes(pushStart, System.currentTimeMillis());
            return new Double((double)pushCount / runtime);
        } else
        {
            return new Double(0.0D);
        }
    }

    public Integer getServiceCount()
    {
        return new Integer(serviceCount);
    }

    public void resetServiceCount()
    {
        serviceStart = System.currentTimeMillis();
        serviceCount = 0;
        lastServiceTimestamp = null;
    }

    public void incrementServiceCount()
    {
        serviceCount++;
        lastServiceTimestamp = new Date();
    }

    public Date getLastServiceTimestamp()
    {
        return lastServiceTimestamp;
    }

    public Double getServiceFrequency()
    {
        if(serviceCount > 0)
        {
            double runtime = differenceInMinutes(serviceStart, System.currentTimeMillis());
            return new Double((double)serviceCount / runtime);
        } else
        {
            return new Double(0.0D);
        }
    }

    public Integer getServiceMessageCount()
    {
        return new Integer(serviceMessageCount);
    }

    public void resetServiceMessageCount()
    {
        serviceMessageStart = System.currentTimeMillis();
        serviceMessageCount = 0;
        lastServiceMessageTimestamp = null;
    }

    public void incrementServiceMessageCount()
    {
        serviceMessageCount++;
        lastServiceMessageTimestamp = new Date();
    }

    public Date getLastServiceMessageTimestamp()
    {
        return lastServiceMessageTimestamp;
    }

    public Double getServiceMessageFrequency()
    {
        if(serviceMessageCount > 0)
        {
            double runtime = differenceInMinutes(serviceMessageStart, System.currentTimeMillis());
            return new Double((double)serviceMessageCount / runtime);
        } else
        {
            return new Double(0.0D);
        }
    }

    public void preDeregister()
        throws Exception
    {
        MessageBrokerControl parent = (MessageBrokerControl)getParentControl();
        parent.removeEndpoint(getObjectName());
    }

    public String getURI()
    {
        return getURIOf(endpoint);
    }

    public String getSecurityConstraint()
    {
        return getSecurityConstraintOf(endpoint);
    }

    public static String getURIOf(Endpoint endpoint)
    {
        ChannelSettings settings = endpoint.getSettings();
        return settings != null ? settings.getUri() : "";
    }

    public static String getSecurityConstraintOf(Endpoint endpoint)
    {
        String result = "";
        ChannelSettings channelSettings = endpoint.getSettings();
        if(channelSettings != null)
        {
            SecurityConstraint constraint = channelSettings.getConstraint();
            if(constraint != null)
            {
                String authMethod = constraint.getMethod();
                if(authMethod != null)
                {
                    StringBuffer buffer = new StringBuffer();
                    buffer.append(authMethod);
                    List roles = constraint.getRoles();
                    if(roles != null && !roles.isEmpty())
                    {
                        buffer.append(':');
                        for(int i = 0; i < roles.size(); i++)
                        {
                            if(i > 0)
                                buffer.append(',');
                            buffer.append(' ');
                            buffer.append(roles.get(i));
                        }

                    }
                    result = buffer.toString();
                }
            }
        }
        return result;
    }

    protected Endpoint endpoint;
    private String id;
    private Boolean running;
    private Date startTimestamp;
    private int pushCount;
    private Date lastPushTimeStamp;
    private long pushStart;
    private int serviceCount;
    private Date lastServiceTimestamp;
    private long serviceStart;
    private int serviceMessageCount;
    private Date lastServiceMessageTimestamp;
    private long serviceMessageStart;
}
