// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ServiceControl.java

package flex.management.runtime.messaging.services;

import flex.management.BaseControl;
import flex.management.runtime.messaging.MessageBrokerControl;
import flex.messaging.services.Service;
import java.util.*;
import javax.management.ObjectName;

// Referenced classes of package flex.management.runtime.messaging.services:
//            ServiceControlMBean

public abstract class ServiceControl extends BaseControl
    implements ServiceControlMBean
{

    public ServiceControl(String id, Service service, BaseControl parent)
    {
        super(parent);
        serviceMessageCount = 0;
        serviceCommandCount = 0;
        serviceMessageFromAdapterCount = 0;
        this.id = id;
        this.service = service;
        destinations = new ArrayList();
        serviceMessageStart = System.currentTimeMillis();
        serviceCommandStart = serviceMessageStart;
        serviceMessageFromAdapterStart = serviceMessageStart;
    }

    public String getId()
    {
        return id;
    }

    public Integer getServiceMessageCount()
    {
        return new Integer(serviceMessageCount);
    }

    public void resetServiceMessageCount()
    {
        serviceMessageStart = System.currentTimeMillis();
        serviceMessageCount = 0;
        lastServiceMessageTimestamp = null;
    }

    public void incrementServiceMessageCount()
    {
        serviceMessageCount++;
        lastServiceMessageTimestamp = new Date();
    }

    public Date getLastServiceMessageTimestamp()
    {
        return lastServiceMessageTimestamp;
    }

    public Double getServiceMessageFrequency()
    {
        if(serviceMessageCount > 0)
        {
            double runtime = differenceInMinutes(serviceMessageStart, System.currentTimeMillis());
            return new Double((double)serviceMessageCount / runtime);
        } else
        {
            return new Double(0.0D);
        }
    }

    public Integer getServiceCommandCount()
    {
        return new Integer(serviceCommandCount);
    }

    public void resetServiceCommandCount()
    {
        serviceCommandStart = System.currentTimeMillis();
        serviceCommandCount = 0;
        lastServiceCommandTimestamp = null;
    }

    public void incrementServiceCommandCount()
    {
        serviceCommandCount++;
        lastServiceCommandTimestamp = new Date();
    }

    public Date getLastServiceCommandTimestamp()
    {
        return lastServiceCommandTimestamp;
    }

    public Double getServiceCommandFrequency()
    {
        if(serviceCommandCount > 0)
        {
            double runtime = differenceInMinutes(serviceCommandStart, System.currentTimeMillis());
            return new Double((double)serviceCommandCount / runtime);
        } else
        {
            return new Double(0.0D);
        }
    }

    public Integer getServiceMessageFromAdapterCount()
    {
        return new Integer(serviceMessageFromAdapterCount);
    }

    public void resetServiceMessageFromAdapterCount()
    {
        serviceMessageFromAdapterStart = System.currentTimeMillis();
        serviceMessageFromAdapterCount = 0;
        lastServiceMessageFromAdapterTimestamp = null;
    }

    public void incrementServiceMessageFromAdapterCount()
    {
        serviceMessageFromAdapterCount++;
        lastServiceMessageFromAdapterTimestamp = new Date();
    }

    public Date getLastServiceMessageFromAdapterTimestamp()
    {
        return lastServiceMessageFromAdapterTimestamp;
    }

    public Double getServiceMessageFromAdapterFrequency()
    {
        if(serviceMessageFromAdapterCount > 0)
        {
            double runtime = differenceInMinutes(serviceMessageFromAdapterStart, System.currentTimeMillis());
            return new Double((double)serviceMessageFromAdapterCount / runtime);
        } else
        {
            return new Double(0.0D);
        }
    }

    public ObjectName[] getDestinations()
    {
        int size = destinations.size();
        ObjectName destinationNames[] = new ObjectName[size];
        for(int i = 0; i < size; i++)
            destinationNames[i] = (ObjectName)destinations.get(i);

        return destinationNames;
    }

    public void addDestination(ObjectName value)
    {
        destinations.add(value);
    }

    public void removeDestination(ObjectName value)
    {
        destinations.remove(value);
    }

    public void preDeregister()
        throws Exception
    {
        MessageBrokerControl parent = (MessageBrokerControl)getParentControl();
        parent.removeService(getObjectName());
        super.preDeregister();
    }

    protected Service service;
    private String id;
    private int serviceMessageCount;
    private Date lastServiceMessageTimestamp;
    private long serviceMessageStart;
    private int serviceCommandCount;
    private Date lastServiceCommandTimestamp;
    private long serviceCommandStart;
    private int serviceMessageFromAdapterCount;
    private Date lastServiceMessageFromAdapterTimestamp;
    private long serviceMessageFromAdapterStart;
    private List destinations;
}
