// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Destination.java

package flex.messaging;

import flex.management.BaseControl;
import flex.management.ManageableComponent;
import flex.management.runtime.messaging.DestinationControl;
import flex.messaging.cluster.ClusterException;
import flex.messaging.cluster.ClusterManager;
import flex.messaging.config.AdapterSettings;
import flex.messaging.config.ChannelSettings;
import flex.messaging.config.ConfigMap;
import flex.messaging.config.DestinationSettings;
import flex.messaging.license.LicenseService;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.services.Service;
import flex.messaging.services.ServiceAdapter;
import flex.messaging.util.ClassUtil;
import java.io.Serializable;
import java.util.Iterator;
import java.util.List;

// Referenced classes of package flex.messaging:
//            MessageBroker

public class Destination extends ManageableComponent
    implements Serializable
{

    public Destination(Service service, DestinationSettings settings)
    {
        this(service, settings, true);
    }

    public Destination(Service service, DestinationSettings settings, boolean enableManagement)
    {
        super(enableManagement);
        this.service = service;
        serviceType = service.getClass().getName();
        id = settings.getId();
        this.settings = settings;
        if(isManaged())
            setupDestinationControl(service);
    }

    public void initDestination()
    {
        createCluster();
        if(settings.getAdapterSettings() != null)
            createAdapter(settings.getAdapterSettings());
    }

    protected void createCluster()
    {
        ConfigMap network = settings.getProperties().getPropertyAsMap("network", null);
        if(network != null)
        {
            ConfigMap clusterInfo = network.getPropertyAsMap("cluster", null);
            if(clusterInfo != null)
            {
                if(!service.getMessageBroker().getLicenseService().isClusteringEnabled())
                {
                    network.allowProperty("cluster");
                    clusterInfo.allowProperty("ref");
                    clusterInfo.allowProperty("shared-backend");
                    Log.getLogger("Configuration").warn("Clustering for destination '" + id + "' is disabled. The current license does not support clustering");
                    return;
                }
                String clusterId = clusterInfo.getPropertyAsString("ref", null);
                String coordinatorPolicy = clusterInfo.getPropertyAsString("shared-backend", "false");
                boolean sharedBackend = Boolean.valueOf(coordinatorPolicy).booleanValue();
                List channelSettings = getSettings().getChannelSettings();
                String channelId;
                String endpointUrl;
                int endpointPort;
                for(Iterator iter = channelSettings.iterator(); iter.hasNext(); service.getMessageBroker().getClusterManager().clusterDestinationChannel(clusterId, service.getClass().getName(), id, channelId, endpointUrl, endpointPort, sharedBackend))
                {
                    ChannelSettings cs = (ChannelSettings)iter.next();
                    channelId = cs.getId();
                    endpointUrl = cs.getUri();
                    int tokenStart = endpointUrl.indexOf("{");
                    if(tokenStart != -1)
                    {
                        int tokenEnd = endpointUrl.indexOf("}", tokenStart);
                        if(tokenEnd == -1)
                            tokenEnd = endpointUrl.length();
                        else
                            tokenEnd++;
                        ClusterException ce = new ClusterException();
                        ce.setMessage(10209, new Object[] {
                            id, channelId, endpointUrl.substring(tokenStart, tokenEnd)
                        });
                        throw ce;
                    }
                    endpointPort = cs.getPort();
                }

            }
        }
    }

    public boolean isClustered()
    {
        ClusterManager clm = service.getMessageBroker().getClusterManager();
        boolean clusterReplicated = clm.isDestinationClustered(service.getClass().getName(), id);
        return clusterReplicated;
    }

    public boolean isBackendShared()
    {
        ClusterManager clm = service.getMessageBroker().getClusterManager();
        boolean backendShared = clm.isBackendShared(service.getClass().getName(), id);
        return backendShared;
    }

    public String getId()
    {
        return id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public Service getService()
    {
        return service;
    }

    public String getServiceType()
    {
        return serviceType;
    }

    public void setSettings(DestinationSettings s)
    {
        settings = s;
    }

    public DestinationSettings getSettings()
    {
        return settings;
    }

    public ServiceAdapter getAdapter()
    {
        return adapter;
    }

    public void createAdapter(AdapterSettings adapterSettings)
    {
        String className = adapterSettings.getClassName();
        Class adapterClass = ClassUtil.createClass(className);
        adapter = (ServiceAdapter)ClassUtil.createDefaultInstance(adapterClass, flex.messaging.services.ServiceAdapter.class);
        adapter.setService(service);
        adapter.setSettings(this, adapterSettings, settings);
        if(isManaged())
        {
            adapter.setManaged(true);
            adapter.setupAdapterControl(this);
            if(adapter.getControl() != null)
                ((DestinationControl)getControl()).setAdapter(adapter.getControl().getObjectName());
        }
    }

    protected void setupDestinationControl(Service service1)
    {
    }

    protected ServiceAdapter adapter;
    protected String id;
    protected DestinationSettings settings;
    protected Service service;
    protected String serviceType;
}
