// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   FlexSession.java

package flex.messaging;

import flex.messaging.security.LoginManager;
import java.security.Principal;
import java.util.*;

// Referenced classes of package flex.messaging:
//            FlexSessionListener, FlexRemoteCredentials, LocalizedException, FlexSessionBindingEvent, 
//            FlexSessionAttributeListener, FlexSessionBindingListener, FlexContext, MessageBroker

public abstract class FlexSession
{

    public FlexSession()
    {
    }

    public Principal getUserPrincipal()
    {
        checkValid();
        return userPrincipal;
    }

    public void setUserPrincipal(Principal userPrincipal)
    {
        checkValid();
        this.userPrincipal = userPrincipal;
    }

    public static void addSessionCreatedListener(FlexSessionListener listener)
    {
        if(listener != null)
            synchronized(createdListeners)
            {
                if(!createdListeners.contains(listener))
                    createdListeners.add(listener);
            }
    }

    public static void removeSessionCreatedListener(FlexSessionListener listener)
    {
        if(listener != null)
            synchronized(createdListeners)
            {
                createdListeners.remove(listener);
            }
    }

    public void addSessionAttributeListener(FlexSessionAttributeListener listener)
    {
        checkValid();
        if(listener != null)
            synchronized(this)
            {
                if(attributeListeners == null)
                    attributeListeners = new ArrayList();
                if(!attributeListeners.contains(listener))
                    attributeListeners.add(listener);
            }
    }

    public void addSessionDestroyedListener(FlexSessionListener listener)
    {
        checkValid();
        if(listener != null)
            synchronized(this)
            {
                if(destroyedListeners == null)
                    destroyedListeners = new ArrayList(3);
                if(!destroyedListeners.contains(listener))
                    destroyedListeners.add(listener);
            }
    }

    protected void destroy()
    {
        checkValid();
        ArrayList attributeNames = null;
        ArrayList destListeners = null;
        synchronized(this)
        {
            if(attributes != null && !attributes.isEmpty())
                attributeNames = new ArrayList(attributes.keySet());
            if(destroyedListeners != null)
                destListeners = new ArrayList(destroyedListeners);
        }
        if(attributeNames != null)
        {
            for(int i = 0; i < attributeNames.size(); i++)
                removeAttribute((String)attributeNames.get(i));

        }
        if(destListeners != null)
        {
            for(int i = 0; i < destListeners.size(); i++)
            {
                FlexSessionListener listener = (FlexSessionListener)destListeners.get(i);
                listener.sessionDestroyed(this);
            }

        }
        invalid = true;
        attributes = null;
        attributeListeners = null;
        destroyedListeners = null;
    }

    public Object getAttribute(String name)
    {
        checkValid();
        if(attributes == null)
            return null;
        else
            return attributes.get(name);
    }

    public Enumeration getAttributeNames()
    {
        checkValid();
        if(attributes == null)
            return Collections.enumeration(Collections.EMPTY_LIST);
        else
            return Collections.enumeration(new ArrayList(attributes.keySet()));
    }

    protected void notifyOfCreation()
    {
        if(!creationNotified)
        {
            checkValid();
            ArrayList listeners = null;
            synchronized(createdListeners)
            {
                if(createdListeners.size() > 0)
                    listeners = new ArrayList(createdListeners);
            }
            if(listeners != null)
            {
                for(int i = 0; i < listeners.size(); i++)
                {
                    FlexSessionListener listener = (FlexSessionListener)listeners.get(i);
                    listener.sessionCreated(this);
                }

            }
            creationNotified = true;
        }
    }

    public void removeAttribute(String name)
    {
        checkValid();
        Object value = null;
        synchronized(this)
        {
            value = attributes == null ? null : attributes.remove(name);
        }
        if(value == null)
        {
            return;
        } else
        {
            notifyAttributeUnbound(name, value);
            notifyAttributeRemoved(name, value);
            return;
        }
    }

    public void removeSessionAttributeListener(FlexSessionAttributeListener listener)
    {
        checkValid();
        if(listener != null && attributeListeners != null)
            synchronized(this)
            {
                attributeListeners.remove(listener);
            }
    }

    public void removeSessionDestroyedListener(FlexSessionListener listener)
    {
        checkValid();
        if(listener != null && destroyedListeners != null)
            synchronized(this)
            {
                destroyedListeners.remove(listener);
            }
    }

    public void setAttribute(String name, Object value)
    {
        checkValid();
        Object oldValue;
        synchronized(this)
        {
            if(attributes == null)
                attributes = new HashMap();
            oldValue = attributes.put(name, value);
        }
        if(oldValue == null)
        {
            notifyAttributeBound(name, value);
            notifyAttributeAdded(name, value);
        } else
        {
            notifyAttributeUnbound(name, oldValue);
            notifyAttributeBound(name, value);
            notifyAttributeReplaced(name, oldValue);
        }
    }

    public void putRemoteCredentials(FlexRemoteCredentials creds)
    {
        checkValid();
        synchronized(this)
        {
            if(remoteCredentials == null)
                remoteCredentials = new HashMap(7);
        }
        synchronized(remoteCredentials)
        {
            Map serviceMap = (Map)remoteCredentials.get(creds.getService());
            if(serviceMap == null)
            {
                serviceMap = new HashMap();
                remoteCredentials.put(creds.getService(), serviceMap);
            }
            serviceMap.put(creds.getDestination(), creds);
        }
    }

    public FlexRemoteCredentials getRemoteCredentials(String service, String destination)
    {
        checkValid();
        if(remoteCredentials == null)
            return null;
        Map map = remoteCredentials;
        JVM INSTR monitorenter ;
        Map serviceMap = (Map)remoteCredentials.get(service);
        if(serviceMap != null)
            return (FlexRemoteCredentials)serviceMap.get(destination);
        null;
        map;
        JVM INSTR monitorexit ;
        return;
        Exception exception;
        exception;
        throw exception;
    }

    public void clearRemoteCredentials(String service, String destination)
    {
        if(invalid || remoteCredentials == null)
            return;
        synchronized(remoteCredentials)
        {
            Map serviceMap = (Map)remoteCredentials.get(service);
            if(serviceMap != null)
                serviceMap.put(destination, null);
        }
    }

    public abstract void invalidate();

    public abstract String getId();

    public boolean isUserInRole(String role)
    {
        ArrayList list = new ArrayList();
        list.add(role);
        return FlexContext.getMessageBroker().getLoginManager().checkRoles(userPrincipal, list);
    }

    public boolean isValid()
    {
        return !invalid;
    }

    protected synchronized void checkValid()
    {
        if(invalid)
        {
            LocalizedException e = new LocalizedException();
            e.setMessage(10019);
            throw e;
        } else
        {
            return;
        }
    }

    protected void notifyAttributeAdded(String name, Object value)
    {
        ArrayList listeners = null;
        synchronized(this)
        {
            if(attributeListeners != null && !attributeListeners.isEmpty())
                listeners = new ArrayList(attributeListeners);
        }
        if(listeners != null)
        {
            FlexSessionBindingEvent event = new FlexSessionBindingEvent(this, name, value);
            for(int i = 0; i < listeners.size(); i++)
                ((FlexSessionAttributeListener)listeners.get(i)).attributeAdded(event);

        }
    }

    protected void notifyAttributeBound(String name, Object value)
    {
        if(value != null && (value instanceof FlexSessionBindingListener))
        {
            FlexSessionBindingEvent bindingEvent = new FlexSessionBindingEvent(this, name);
            ((FlexSessionBindingListener)value).valueBound(bindingEvent);
        }
    }

    protected void notifyAttributeRemoved(String name, Object value)
    {
        ArrayList listeners = null;
        synchronized(this)
        {
            if(attributeListeners != null && !attributeListeners.isEmpty())
                listeners = new ArrayList(attributeListeners);
        }
        if(listeners != null)
        {
            FlexSessionBindingEvent event = new FlexSessionBindingEvent(this, name, value);
            for(int i = 0; i < listeners.size(); i++)
                ((FlexSessionAttributeListener)listeners.get(i)).attributeRemoved(event);

        }
    }

    protected void notifyAttributeReplaced(String name, Object value)
    {
        ArrayList listeners = null;
        synchronized(this)
        {
            if(attributeListeners != null && !attributeListeners.isEmpty())
                listeners = new ArrayList(attributeListeners);
        }
        if(listeners != null)
        {
            FlexSessionBindingEvent event = new FlexSessionBindingEvent(this, name, value);
            for(int i = 0; i < listeners.size(); i++)
                ((FlexSessionAttributeListener)listeners.get(i)).attributeReplaced(event);

        }
    }

    protected void notifyAttributeUnbound(String name, Object value)
    {
        if(value != null && (value instanceof FlexSessionBindingListener))
        {
            FlexSessionBindingEvent bindingEvent = new FlexSessionBindingEvent(this, name);
            ((FlexSessionBindingListener)value).valueUnbound(bindingEvent);
        }
    }

    private HashMap attributes;
    private List attributeListeners;
    private static List createdListeners = new ArrayList();
    private boolean creationNotified;
    private List destroyedListeners;
    private boolean invalid;
    private Map remoteCredentials;
    private Principal userPrincipal;

}
