// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HttpFlexSession.java

package flex.messaging;

import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import java.io.*;
import java.security.Principal;
import java.util.*;
import javax.servlet.http.*;

// Referenced classes of package flex.messaging:
//            FlexSession, FlexContext

public class HttpFlexSession extends FlexSession
    implements HttpSessionBindingListener, HttpSessionListener, HttpSessionAttributeListener, Serializable
{

    public HttpFlexSession()
    {
    }

    public void attributeAdded(HttpSessionBindingEvent event)
    {
        if(!event.getName().equals("__flexSession"))
        {
            HttpFlexSession flexSession = (HttpFlexSession)httpSessionToFlexSessionMap.get(event.getSession().getId());
            if(flexSession != null)
            {
                String name = event.getName();
                Object value = event.getValue();
                flexSession.notifyAttributeBound(name, value);
                flexSession.notifyAttributeAdded(name, value);
            }
        }
    }

    public void attributeRemoved(HttpSessionBindingEvent event)
    {
        if(!event.getName().equals("__flexSession"))
        {
            HttpFlexSession flexSession = (HttpFlexSession)httpSessionToFlexSessionMap.get(event.getSession().getId());
            if(flexSession != null)
            {
                String name = event.getName();
                Object value = event.getValue();
                flexSession.notifyAttributeUnbound(name, value);
                flexSession.notifyAttributeRemoved(name, value);
            }
        }
    }

    public void attributeReplaced(HttpSessionBindingEvent event)
    {
        if(!event.getName().equals("__flexSession"))
        {
            HttpFlexSession flexSession = (HttpFlexSession)httpSessionToFlexSessionMap.get(event.getSession().getId());
            if(flexSession != null)
            {
                String name = event.getName();
                Object value = event.getValue();
                Object newValue = flexSession.getAttribute(name);
                flexSession.notifyAttributeUnbound(name, value);
                flexSession.notifyAttributeBound(name, newValue);
                flexSession.notifyAttributeReplaced(name, value);
            }
        }
    }

    public static HttpFlexSession getFlexSession(HttpServletRequest req)
    {
        HttpSession httpSession = req.getSession(true);
        if(!isHttpSessionListener && !warnedNoEventRedispatch)
        {
            warnedNoEventRedispatch = true;
            if(Log.isWarn())
                Log.getLogger(WARN_LOG_CATEGORY).warn("HttpFlexSession has not been registered as a listener in web.xml for this application so no events will be dispatched to FlexSessionAttributeListeners or FlexSessionBindingListeners. To correct this, register flex.messaging.HttpFlexSession as a listener in web.xml.");
        }
        HttpFlexSession flexSession;
        synchronized(httpSession)
        {
            flexSession = (HttpFlexSession)httpSession.getAttribute("__flexSession");
            if(flexSession == null)
            {
                flexSession = new HttpFlexSession();
                FlexContext.setThreadLocalSession(flexSession);
                httpSession.setAttribute("__flexSession", flexSession);
                flexSession.setHttpSession(httpSession);
                flexSession.notifyOfCreation();
            } else
            {
                FlexContext.setThreadLocalSession(flexSession);
                if(flexSession.httpSession == null)
                {
                    flexSession.setHttpSession(httpSession);
                    flexSession.notifyOfCreation();
                }
            }
        }
        return flexSession;
    }

    public Principal getUserPrincipal()
    {
        Principal p = super.getUserPrincipal();
        if(p == null)
        {
            HttpServletRequest req = FlexContext.getHttpRequest();
            if(req != null)
                p = req.getUserPrincipal();
        }
        return p;
    }

    public void invalidate()
    {
        boolean recreate = FlexContext.getFlexSession() == this;
        synchronized(httpSession)
        {
            httpSession.invalidate();
        }
        if(recreate)
        {
            HttpServletRequest req = FlexContext.getHttpRequest();
            FlexContext.setThreadLocalObjects(getFlexSession(req), FlexContext.getMessageBroker(), req, FlexContext.getHttpResponse(), FlexContext.getServletConfig());
        }
    }

    public Object getAttribute(String name)
    {
        return httpSession.getAttribute(name);
    }

    public Enumeration getAttributeNames()
    {
        return httpSession.getAttributeNames();
    }

    public String getId()
    {
        return httpSession.getId();
    }

    public void removeAttribute(String name)
    {
        httpSession.removeAttribute(name);
    }

    public void sessionCreated(HttpSessionEvent event)
    {
        isHttpSessionListener = true;
    }

    public void sessionDestroyed(HttpSessionEvent event)
    {
        HttpFlexSession flexSession = (HttpFlexSession)httpSessionToFlexSessionMap.remove(event.getSession().getId());
        if(flexSession != null)
            flexSession.destroy();
    }

    public void setAttribute(String name, Object value)
    {
        httpSession.setAttribute(name, value);
    }

    public void valueBound(HttpSessionBindingEvent httpsessionbindingevent)
    {
    }

    public void valueUnbound(HttpSessionBindingEvent event)
    {
        if(!isHttpSessionListener)
        {
            HttpFlexSession flexSession = (HttpFlexSession)httpSessionToFlexSessionMap.remove(event.getSession().getId());
            if(flexSession != null)
                flexSession.destroy();
        }
    }

    private void setHttpSession(HttpSession httpSession)
    {
        this.httpSession = httpSession;
        httpSessionToFlexSessionMap.put(httpSession.getId(), this);
    }

    private void writeObject(ObjectOutputStream stream)
    {
        try
        {
            stream.writeObject(super.getUserPrincipal());
        }
        catch(IOException e)
        {
            e.printStackTrace();
        }
    }

    private void readObject(ObjectInputStream stream)
    {
        try
        {
            setUserPrincipal((Principal)stream.readObject());
        }
        catch(Exception e) { }
    }

    private static final long serialVersionUID = 0x6c7abc5dL;
    private static final String SESSION_ATTRIBUTE = "__flexSession";
    private static final Map httpSessionToFlexSessionMap = Collections.synchronizedMap(new HashMap());
    private static boolean isHttpSessionListener;
    private static boolean warnedNoEventRedispatch;
    private static String WARN_LOG_CATEGORY = "Configuration";
    private HttpSession httpSession;

}
