// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MessageBroker.java

package flex.messaging;

import flex.management.BaseControl;
import flex.management.ManageableComponent;
import flex.management.runtime.messaging.MessageBrokerControl;
import flex.messaging.cluster.ClusterManager;
import flex.messaging.config.ChannelSettings;
import flex.messaging.config.ConfigurationException;
import flex.messaging.config.DestinationSettings;
import flex.messaging.config.SecuritySettings;
import flex.messaging.config.SystemSettings;
import flex.messaging.endpoints.Endpoint;
import flex.messaging.factories.JavaFactory;
import flex.messaging.license.LicenseService;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.AbstractMessage;
import flex.messaging.messages.AcknowledgeMessage;
import flex.messaging.messages.AsyncMessage;
import flex.messaging.messages.CommandMessage;
import flex.messaging.messages.Message;
import flex.messaging.security.LoginManager;
import flex.messaging.services.Service;
import flex.messaging.services.ServiceException;
import flex.messaging.util.Base64;
import flex.messaging.util.PrettyPrinter;
import flex.messaging.util.RedeployManager;
import flex.messaging.util.StringUtils;
import java.io.IOException;
import java.io.InputStream;
import java.util.*;

// Referenced classes of package flex.messaging:
//            SessionMetricsTracker, MessageException, FlexFactory, FlexRemoteCredentials, 
//            MessageClient, Destination, FlexContext, FlexSession

public final class MessageBroker extends ManageableComponent
{
    public static interface InternalPathResolver
    {

        public abstract InputStream resolve(String s)
            throws IOException;
    }


    public MessageBroker()
    {
        this(true, null);
    }

    public MessageBroker(boolean enableManagement)
    {
        this(enableManagement, null);
    }

    public MessageBroker(boolean enableManagement, String mbid)
    {
        super(enableManagement);
        endpoints = new HashMap();
        services = new ArrayList();
        factories = new HashMap();
        addFactory("java", new JavaFactory());
        messageBrokerId = mbid;
        log = Log.createLog();
        systemSettings = new SystemSettings();
        systemSettingsThreadLocal.set(systemSettings);
        clusterManager = new ClusterManager(this);
        sessionMetricsTracker = new SessionMetricsTracker(this);
        if(isManaged())
        {
            controller = new MessageBrokerControl(this);
            controller.register();
            controller.setRunning(new Boolean(false));
            setControl(controller);
        }
    }

    public String getId()
    {
        return messageBrokerId;
    }

    public static MessageBroker getMessageBroker(String messageBrokerId)
    {
        if(messageBrokerId == null)
            messageBrokerId = "__default__";
        return (MessageBroker)messageBrokers.get(messageBrokerId);
    }

    public void start()
    {
        registerMessageBroker();
        sessionMetricsTracker.start();
        startServices();
        startEndpoints();
        redeployManager.start();
        if(isManaged())
            controller.setRunning(new Boolean(true));
    }

    public void stop()
    {
        stopServices();
        stopEndpoints();
        sessionMetricsTracker.stop();
        try
        {
            if(redeployManager != null)
                redeployManager.shutdown();
        }
        catch(Throwable t)
        {
            t.printStackTrace();
        }
        clusterManager.destroyClusters();
        if(isManaged())
            controller.setRunning(new Boolean(false));
        unRegisterMessageBroker();
    }

    public void setInternalPathResolver(InternalPathResolver internalPathResolver)
    {
        this.internalPathResolver = internalPathResolver;
    }

    public InputStream resolveInternalPath(String filename)
        throws IOException
    {
        return internalPathResolver.resolve(filename);
    }

    public void setFlexWritePath(String p)
    {
        writePath = p;
    }

    public String getFlexWritePath()
    {
        return writePath;
    }

    public ClusterManager getClusterManager()
    {
        return clusterManager;
    }

    public void addEndpoint(Endpoint endpoint)
    {
        Object endpointId = endpoint.getId();
        if(endpointId == null)
        {
            ConfigurationException ce = new ConfigurationException();
            ce.setMessage(10128, new Object[] {
                endpoint.toString()
            });
            throw ce;
        }
        endpoints.put(endpointId, endpoint);
        if(isManaged() && endpoint.isManaged())
            controller.addEndpoint(endpoint.getControl().getObjectName());
    }

    public Map getEndpoints()
    {
        return endpoints;
    }

    public Endpoint getEndpoint(Object id)
    {
        if(id == null)
        {
            MessageException lme = new MessageException();
            lme.setMessage(10001);
            throw lme;
        }
        if(!endpoints.containsKey(id))
        {
            MessageException lme = new MessageException();
            lme.setMessage(10002, new Object[] {
                id
            });
            throw lme;
        } else
        {
            return (Endpoint)endpoints.get(id);
        }
    }

    public Endpoint getEndpoint(String path, String contextPath, boolean secure)
    {
        for(Iterator iter = endpoints.keySet().iterator(); iter.hasNext();)
        {
            Object id = iter.next();
            Endpoint e = (Endpoint)endpoints.get(id);
            ChannelSettings cs = e.getSettings();
            if(matchEndpoint(path, contextPath, cs) && e.isSecure() == secure)
                return e;
        }

        MessageException lme = new MessageException();
        lme.setMessage(10003, new Object[] {
            path
        });
        throw lme;
    }

    private boolean matchEndpoint(String path, String contextPath, ChannelSettings cs)
    {
        boolean match = false;
        String channelEndpoint = cs.getParsedUri(contextPath);
        if(path.endsWith("/"))
            path = path.substring(0, path.length() - 1);
        if(path.equalsIgnoreCase(channelEndpoint))
            match = true;
        return match;
    }

    public void addFactory(String id, FlexFactory factory)
    {
        factories.put(id, factory);
    }

    public FlexFactory getFactory(String id)
    {
        return (FlexFactory)factories.get(id);
    }

    public void addService(Service service)
    {
        services.add(service);
        if(isManaged() && service.isManaged())
            controller.addService(service.getControl().getObjectName());
    }

    public Service getServiceByType(String serviceType)
    {
        for(Iterator serviceIter = services.iterator(); serviceIter.hasNext();)
        {
            Service svc = (Service)serviceIter.next();
            if(svc.getClass().getName().equals(serviceType))
                return svc;
        }

        return null;
    }

    public Log getLog()
    {
        return log;
    }

    public LoginManager getLoginManager()
    {
        return loginManager;
    }

    public void setLoginManager(LoginManager loginManager)
    {
        this.loginManager = loginManager;
    }

    public LicenseService getLicenseService()
    {
        return licenseService;
    }

    public void setLicenseService(LicenseService licenseService)
    {
        this.licenseService = licenseService;
    }

    public void setRedeployManager(RedeployManager redeployManager)
    {
        this.redeployManager = redeployManager;
    }

    public Map getChannelSettings()
    {
        return channelSettings;
    }

    public void setChannelSettings(Map channelSettings)
    {
        this.channelSettings = channelSettings;
    }

    public SecuritySettings getSecuritySettings()
    {
        return securitySettings;
    }

    public void setSecuritySettings(SecuritySettings securitySettings)
    {
        this.securitySettings = securitySettings;
    }

    public SystemSettings getLocalSystemSettings()
    {
        return systemSettings;
    }

    public static SystemSettings getSystemSettings()
    {
        SystemSettings ss = (SystemSettings)systemSettingsThreadLocal.get();
        if(ss == null)
        {
            ss = new SystemSettings();
            systemSettingsThreadLocal.set(ss);
        }
        return ss;
    }

    public void setSystemSettings(SystemSettings l)
    {
        if(l != null)
        {
            systemSettingsThreadLocal.set(l);
            systemSettings = l;
        }
    }

    public void initThreadLocals()
    {
        setSystemSettings(systemSettings);
    }

    public void startEndpoints()
    {
        Endpoint endpoint;
        for(Iterator iter = endpoints.values().iterator(); iter.hasNext(); endpoint.start())
            endpoint = (Endpoint)iter.next();

    }

    public void stopEndpoints()
    {
        Endpoint endpoint;
        for(Iterator iter = endpoints.values().iterator(); iter.hasNext(); endpoint.stop())
            endpoint = (Endpoint)iter.next();

    }

    public void startServices()
    {
        Service svc;
        for(Iterator iter = services.iterator(); iter.hasNext(); svc.start())
            svc = (Service)iter.next();

    }

    public void stopServices()
    {
        Service svc;
        for(Iterator iter = services.iterator(); iter.hasNext(); svc.stop())
            svc = (Service)iter.next();

    }

    public AcknowledgeMessage routeMessageToService(Message message, Endpoint endpoint)
    {
        Object serviceResult = null;
        boolean serviced = false;
        Service service = null;
        try
        {
            Iterator serviceIter = services.iterator();
            do
            {
                if(!serviceIter.hasNext())
                    break;
                service = (Service)serviceIter.next();
                if(!service.isSupportedMessage(message))
                    continue;
                serviced = true;
                Destination destination = service.getDestination(message);
                inspectOperation(message, destination);
                if(Log.isDebug())
                    Log.getLogger(getLogCategory(message)).debug("Before invoke service: " + service.getId() + StringUtils.NEWLINE + "  incomingMessage: " + message + StringUtils.NEWLINE);
                extractRemoteCredentials(service, message);
                serviceResult = service.serviceMessage(message);
                break;
            } while(true);
            if(!serviced)
            {
                MessageException lme = new MessageException();
                lme.setMessage(10004, new Object[] {
                    message.getClass().getName()
                });
                throw lme;
            }
            if(Log.isDebug())
            {
                String debugServiceResult = Log.getPrettyPrinter().prettify(serviceResult);
                Log.getLogger(getLogCategory(message)).debug("After invoke service: " + service.getId() + StringUtils.NEWLINE + "  reply: " + debugServiceResult + StringUtils.NEWLINE);
            }
            AcknowledgeMessage ack = null;
            if(serviceResult instanceof AcknowledgeMessage)
            {
                ack = (AcknowledgeMessage)serviceResult;
            } else
            {
                ack = new AcknowledgeMessage();
                ack.setBody(serviceResult);
            }
            ack.setCorrelationId(message.getMessageId());
            ack.setClientId(message.getClientId());
            return ack;
        }
        catch(RuntimeException exc)
        {
            Log.getLogger("Message.General").error("Exception when invoking service: " + (service != null ? service.getId() : "(none)") + StringUtils.NEWLINE + "  with message: " + message + StringUtils.NEWLINE + "  exception: " + exc + StringUtils.NEWLINE);
            throw exc;
        }
    }

    public AsyncMessage routeCommandToService(CommandMessage command, Endpoint endpoint)
    {
        AsyncMessage replyMessage;
        Service service;
        Object commandResult;
label0:
        {
            replyMessage = null;
            service = null;
            commandResult = null;
            if(command.getMessageRefType() == null)
                break label0;
            Iterator serviceIter = services.iterator();
            do
            {
                if(!serviceIter.hasNext())
                    break label0;
                service = (Service)serviceIter.next();
            } while(!service.isSupportedMessageType(command.getMessageRefType()));
            try
            {
                extractRemoteCredentials(service, command);
                commandResult = service.serviceCommand(command);
            }
            catch(UnsupportedOperationException e)
            {
                ServiceException se = new ServiceException();
                se.setMessage(10451, new Object[] {
                    service.getClass().getName()
                });
                throw se;
            }
        }
        if(commandResult == null)
            replyMessage = new AcknowledgeMessage();
        else
        if(commandResult instanceof AsyncMessage)
        {
            replyMessage = (AsyncMessage)commandResult;
        } else
        {
            replyMessage = new AcknowledgeMessage();
            replyMessage.setBody(commandResult);
        }
        replyMessage.setCorrelationId(command.getMessageId());
        replyMessage.setClientId(command.getClientId());
        if(replyMessage.getBody() instanceof List)
            replyMessage.setBody(((Object) (((List)replyMessage.getBody()).toArray())));
        if(Log.isDebug())
            Log.getLogger(getLogCategory(command)).debug("Executed command: " + (service != null ? "service=" + service.getId() : "(default service)") + StringUtils.NEWLINE + "  commandMessage: " + command + StringUtils.NEWLINE + "  replyMessage: " + replyMessage + StringUtils.NEWLINE);
        return replyMessage;
    }

    public void routeMessageToClient(MessageClient client, Message message)
    {
        if(Log.isDebug())
            Log.getLogger(getLogCategory(message)).debug("Sending message to client: " + client.getClientId() + StringUtils.NEWLINE + "  message: " + message + StringUtils.NEWLINE);
        Iterator endpointIter = client.getEndpoints().iterator();
        if(endpointIter.hasNext())
        {
            Endpoint endpoint = (Endpoint)endpoints.get(endpointIter.next());
            endpoint.push(message, client);
        }
    }

    public void inspectOperation(Message message, Destination destination)
    {
        inspectChannel(message, destination);
        loginManager.checkConstraint(destination.getSettings().getConstraint());
    }

    public void inspectChannel(Message message, Destination destination)
    {
        if(message.getHeader("DSEndpoint") != null)
        {
            String messageChannel = (String)message.getHeader("DSEndpoint");
            for(Iterator iter = destination.getSettings().getChannelSettings().iterator(); iter.hasNext();)
            {
                ChannelSettings cs = (ChannelSettings)iter.next();
                if(cs.getId().equals(messageChannel))
                    return;
            }

            MessageException lme = new MessageException();
            lme.setMessage(10005, new Object[] {
                destination.getId(), messageChannel
            });
            throw lme;
        } else
        {
            return;
        }
    }

    protected void extractRemoteCredentials(Service service, Message message)
    {
        if(message.headerExists("DSRemoteCredentials"))
        {
            boolean setting = false;
            String username = null;
            Object credentials = null;
            if(message.getHeader("DSRemoteCredentials") instanceof String)
            {
                String encoded = (String)message.getHeader("DSRemoteCredentials");
                if(encoded.length() > 0)
                {
                    setting = true;
                    flex.messaging.util.Base64.Decoder decoder = new flex.messaging.util.Base64.Decoder();
                    decoder.decode(encoded);
                    String decoded = new String(decoder.drain());
                    int colon = decoded.indexOf(":");
                    if(colon > 0 && colon < decoded.length() - 1)
                    {
                        username = decoded.substring(0, colon);
                        credentials = decoded.substring(colon + 1);
                    }
                }
            } else
            {
                MessageException lme = new MessageException();
                lme.setMessage(10020);
                throw lme;
            }
            if(setting)
                FlexContext.getFlexSession().putRemoteCredentials(new FlexRemoteCredentials(service.getId(), message.getDestination(), username, credentials));
            else
                FlexContext.getFlexSession().clearRemoteCredentials(service.getId(), message.getDestination());
        }
    }

    private String getLogCategory(Message message)
    {
        if(message instanceof AbstractMessage)
            return ((AbstractMessage)message).logCategory();
        else
            return "Message.General";
    }

    private void registerMessageBroker()
    {
        String mbid = messageBrokerId;
        if(mbid == null)
            mbid = "__default__";
        synchronized(messageBrokers)
        {
            if(messageBrokers.get(mbid) != null)
            {
                ConfigurationException ce = new ConfigurationException();
                ce.setMessage(10137, new Object[] {
                    messageBrokerId != null ? mbid : "(no value supplied)"
                });
                throw ce;
            }
            messageBrokers.put(mbid, this);
        }
    }

    private void unRegisterMessageBroker()
    {
        String mbid = messageBrokerId;
        if(mbid == null)
            mbid = "__default__";
        synchronized(messageBrokers)
        {
            messageBrokers.remove(mbid);
        }
    }

    public static final String LOG_CATEGORY = "Message";
    private static final int NO_ENDPOINT_ID = 10128;
    private static final int NULL_ENDPOINT_ID = 10001;
    private static final int MISSING_ENDPOINT = 10002;
    private static final int NO_SERVICE_FOR_MSG_TYPE = 10004;
    private static final int SERVICE_CMD_NOT_SUPPORTED = 10451;
    private static final int DESTINATION_UNACCESSIBLE = 10005;
    private static final int UNKNOWN_REMOTE_CREDENTIALS_FORMAT = 10020;
    private InternalPathResolver internalPathResolver;
    private String writePath;
    private Map endpoints;
    private List services;
    private Map factories;
    private ClusterManager clusterManager;
    private LoginManager loginManager;
    private LicenseService licenseService;
    private RedeployManager redeployManager;
    private Map channelSettings;
    private SecuritySettings securitySettings;
    private SessionMetricsTracker sessionMetricsTracker;
    private static ThreadLocal systemSettingsThreadLocal = new ThreadLocal();
    private SystemSettings systemSettings;
    private Log log;
    private String messageBrokerId;
    static final String DEFAULT_BROKER_ID = "__default__";
    static Map messageBrokers = new HashMap();
    private MessageBrokerControl controller;

}
