// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MessageBrokerServlet.java

package flex.messaging;

import flex.license.common.*;
import flex.management.MBeanLifecycleManager;
import flex.messaging.config.ConfigurationException;
import flex.messaging.config.ConfigurationManager;
import flex.messaging.config.MessagingConfiguration;
import flex.messaging.endpoints.Endpoint;
import flex.messaging.license.InputStreamLoader;
import flex.messaging.license.LicenseService;
import flex.messaging.license.LicenseServiceImpl;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.log.ServletLogTarget;
import flex.messaging.services.AuthenticationService;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Referenced classes of package flex.messaging:
//            MessageBroker, FlexContext, VersionInfo, HttpFlexSession

public class MessageBrokerServlet extends HttpServlet
{

    public MessageBrokerServlet()
    {
    }

    public void init(ServletConfig servletConfig)
        throws ServletException
    {
        super.init(servletConfig);
        FlexContext.setThreadLocalObjects(null, null, null, null, servletConfig);
        ServletLogTarget.setServletContext(servletConfig.getServletContext());
        try
        {
            broker = new MessageBroker(true, servletConfig.getInitParameter("messageBrokerId"));
            FlexContext.setThreadLocalObjects(null, broker, null, null, servletConfig);
            MessagingConfiguration config = ConfigurationManager.getMessagingConfiguration(servletConfig);
            setupInternalPathResolver();
            broker.setFlexWritePath(getFlexWritePath(servletConfig));
            String flexdir = servletConfig.getServletContext().getRealPath(FLEXDIR);
            broker.setLicenseService(buildLicenseService(flexdir));
            Logger logger = Log.getLogger("Configuration");
            if(Log.isInfo())
                logger.info(VersionInfo.buildMessage());
            config.configureBroker(broker);
            broker.start();
            config.reportUnusedProperties();
        }
        catch(RuntimeException re)
        {
            destroy();
            throw re;
        }
        FlexContext.clearThreadLocalObjects();
        break MISSING_BLOCK_LABEL_162;
        Exception exception;
        exception;
        FlexContext.clearThreadLocalObjects();
        throw exception;
    }

    private void setupInternalPathResolver()
    {
        broker.setInternalPathResolver(new MessageBroker.InternalPathResolver() {

            public InputStream resolve(String filename)
            {
                InputStream is = getServletContext().getResourceAsStream(MessageBrokerServlet.FLEXDIR + filename);
                return is;
            }

            
            {
                super();
            }
        }
);
    }

    private LicenseService buildLicenseService(String flexdir)
    {
        LicenseLoader loader;
        InputStream is;
        loader = null;
        try
        {
            loader = (LicenseLoader)Class.forName("flex.messaging.oem.OEMLicenseLoader").newInstance();
        }
        catch(Throwable t) { }
        if(loader != null)
            break MISSING_BLOCK_LABEL_167;
        try
        {
            SecurityManager security = System.getSecurityManager();
            if(security != null)
                security.checkRead(flexdir);
        }
        catch(SecurityException se)
        {
            flexdir = null;
        }
        if(flexdir != null)
            break MISSING_BLOCK_LABEL_158;
        is = getServletContext().getResourceAsStream(FLEXDIR + LICENSE_FILE);
        if(is == null)
            break MISSING_BLOCK_LABEL_144;
        loader = new InputStreamLoader(is);
        IOException ioe;
        try
        {
            is.close();
        }
        // Misplaced declaration of an exception variable
        catch(IOException ioe) { }
        break MISSING_BLOCK_LABEL_167;
        ioe;
        loader = new InMemoryLoader(null, null, null);
        try
        {
            is.close();
        }
        // Misplaced declaration of an exception variable
        catch(IOException ioe) { }
        break MISSING_BLOCK_LABEL_167;
        Exception exception;
        exception;
        try
        {
            is.close();
        }
        catch(IOException ioe) { }
        throw exception;
        loader = new InMemoryLoader(null, null, null);
        break MISSING_BLOCK_LABEL_167;
        loader = new DirectoryLoader(flexdir);
        LicenseServiceImpl licenseService = new LicenseServiceImpl(loader, Log.getLogger("Configuration"));
        licenseService.init();
        return licenseService;
    }

    protected String getFlexWritePath(ServletConfig servletConfig)
    {
        String resolved = null;
        String path = FLEXDIR;
        if(servletConfig != null)
        {
            String p = servletConfig.getInitParameter("flex.write.path");
            if(p != null)
                path = p.trim();
        }
        if(path.startsWith("/"))
        {
            String realPath = servletConfig.getServletContext().getRealPath(path);
            File f = new File(realPath);
            try
            {
                if(f != null && f.exists() && f.isAbsolute())
                    resolved = realPath;
            }
            catch(Throwable t) { }
        }
        boolean isWindows = File.separator.equals("\\");
        if(resolved == null && (!isWindows || !path.startsWith("/")))
            try
            {
                File f = new File(path);
                if(f != null && f.exists() && f.isAbsolute())
                    resolved = path;
            }
            catch(Throwable t) { }
        if(resolved == null)
        {
            ConfigurationException cx = new ConfigurationException();
            cx.setMessage(11105);
            throw cx;
        } else
        {
            return resolved;
        }
    }

    public void destroy()
    {
        if(broker != null)
        {
            broker.stop();
            if(broker.isManaged())
                MBeanLifecycleManager.unregisterRuntimeMBeans(broker);
        }
    }

    public void service(HttpServletRequest req, HttpServletResponse res)
    {
        broker.initThreadLocals();
        FlexContext.setThreadLocalObjects(null, broker, req, res, getServletConfig());
        HttpFlexSession fs = HttpFlexSession.getFlexSession(req);
        if(fs.getUserPrincipal() == null && req.getHeader("Authorization") != null)
        {
            String encoded = req.getHeader("Authorization");
            if(encoded.indexOf("Basic") > -1)
            {
                encoded = encoded.substring(6);
                try
                {
                    AuthenticationService.decodeAndLogin(encoded, broker.getLoginManager());
                }
                catch(Exception e) { }
            }
        }
        String contextPath = req.getContextPath();
        String endpointPath = req.getServletPath() + req.getPathInfo();
        Endpoint endpoint = broker.getEndpoint(endpointPath, contextPath, req.isSecure());
        if(endpoint != null)
            try
            {
                if(Log.isInfo())
                    Log.getLogger("Endpoint.General").info("Channel endpoint {0} received request.", new Object[] {
                        endpoint.getId()
                    });
                endpoint.service(req, res);
            }
            catch(UnsupportedOperationException ue)
            {
                try
                {
                    res.sendError(405);
                }
                catch(IOException e) { }
            }
        else
            try
            {
                res.sendError(403);
            }
            catch(IOException e) { }
        FlexContext.clearThreadLocalObjects();
        break MISSING_BLOCK_LABEL_242;
        Exception exception;
        exception;
        FlexContext.clearThreadLocalObjects();
        throw exception;
    }

    private MessageBroker broker;
    private static String FLEXDIR = "/WEB-INF/flex/";
    private static String LICENSE_FILE = "license.properties";


}
