// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MessageClient.java

package flex.messaging;

import flex.messaging.config.ChannelSettings;
import flex.messaging.endpoints.Endpoint;
import flex.messaging.messages.CommandMessage;
import flex.messaging.services.MessageService;
import flex.messaging.services.Service;
import flex.messaging.services.messaging.SubscriptionManager;
import flex.messaging.util.TimeoutAbstractObject;
import java.io.Serializable;
import java.util.*;

// Referenced classes of package flex.messaging:
//            FlexSessionListener, MessageDestination, MessageBroker, FlexContext, 
//            FlexSession

public class MessageClient
    implements FlexSessionListener, Serializable
{

    public MessageClient(Object clientId, MessageDestination destination)
    {
        valid = true;
        this.clientId = clientId;
        this.destination = destination;
        endpoints = new ArrayList(1);
        updateLastUse();
    }

    public MessageDestination getDestination()
    {
        return destination;
    }

    public void setDestination(MessageDestination destination)
    {
        this.destination = destination;
    }

    public Object getClientId()
    {
        return clientId;
    }

    public void setClientId(Object clientId)
    {
        this.clientId = clientId;
    }

    public List getEndpoints()
    {
        return endpoints;
    }

    public void addEndpoint(String endpoint)
    {
        if(!endpoints.contains(endpoint))
            endpoints.add(endpoint);
    }

    public void removeEndpoint(String endpoint)
    {
        endpoints.remove(endpoint);
    }

    public long getLastUse()
    {
        return lastUse;
    }

    public void updateLastUse()
    {
        lastUse = System.currentTimeMillis();
    }

    public Object getProperty(String propName)
    {
        if(properties == null)
            return null;
        else
            return properties.get(propName);
    }

    public void setProperty(String propName, Object propValue)
    {
        if(properties == null)
            synchronized(this)
            {
                if(properties == null)
                    properties = new TreeMap();
            }
        properties.put(propName, propValue);
    }

    public boolean isListeningOnFlexSession()
    {
        return listeningOnFlexSession;
    }

    public boolean isTimingOut()
    {
        return willTimeout;
    }

    public void setTimingOut(boolean value)
    {
        willTimeout = value;
    }

    public boolean isValid()
    {
        return valid;
    }

    public TimeoutAbstractObject getDestroyTimer()
    {
        return destroyTimer;
    }

    public void setDestroyTimer(TimeoutAbstractObject destroyTimeout)
    {
        destroyTimer = destroyTimeout;
    }

    public boolean equals(Object o)
    {
        if(o instanceof MessageClient)
        {
            MessageClient c = (MessageClient)o;
            if(c != null && c.getClientId().equals(clientId))
                return true;
        }
        return false;
    }

    public void invalidate()
    {
        if(valid)
        {
            valid = false;
            CommandMessage msg = new CommandMessage();
            msg.setDestination(destination.getId());
            msg.setClientId(clientId);
            msg.setOperation(10);
            Set subscriberIds = new TreeSet();
            subscriberIds.add(clientId);
            ((MessageService)destination.getService()).pushMessageToClients(destination, null, subscriberIds, msg, false);
        }
    }

    public void destroy()
    {
        if(!destroyed)
        {
            destroyed = true;
            if(destroyTimer != null)
            {
                destroyTimer.cancelTimeout();
                destroyTimer = null;
            }
            CommandMessage unsubMessage = new CommandMessage();
            unsubMessage.setDestination(destination.getId());
            unsubMessage.setClientId(clientId);
            unsubMessage.setOperation(1);
            unsubMessage.setHeader("DSSessionInvalidated", new Boolean(true));
            destination.getService().serviceCommand(unsubMessage);
        }
    }

    public void scheduleDestroy()
    {
        if(!destroyScheduled)
        {
            MessageBroker broker = destination.getService().getMessageBroker();
            int maxPollingInterval = 0;
            Iterator iter = endpoints.iterator();
            do
            {
                if(!iter.hasNext())
                    break;
                Endpoint endpoint = broker.getEndpoint((String)iter.next());
                ChannelSettings settings = endpoint.getSettings();
                if(settings.getPropertyAsBoolean("polling-enabled", false))
                {
                    int interval = settings.getPropertyAsInt("polling-interval-seconds", 0);
                    if(interval > maxPollingInterval)
                        maxPollingInterval = interval;
                }
            } while(true);
            if(maxPollingInterval == 0)
                destroy();
            else
                destination.getSubscriptionManager().scheduleSubscriberDestroy(this, (long)maxPollingInterval * 2L);
            destroyScheduled = true;
        }
    }

    public void listenOnFlexSession()
    {
        if(!listeningOnFlexSession)
        {
            willTimeout = true;
            FlexContext.getFlexSession().addSessionDestroyedListener(this);
        }
    }

    public void sessionCreated(FlexSession flexsession)
    {
    }

    public void sessionDestroyed(FlexSession session)
    {
        invalidate();
    }

    private static final String POLLING_ENABLED_ELEMENT = "polling-enabled";
    private static final String POLLING_INTERVAL_SECONDS_ELEMENT = "polling-interval-seconds";
    private MessageDestination destination;
    private Object clientId;
    private boolean destroyScheduled;
    private boolean destroyed;
    private List endpoints;
    private long lastUse;
    private Map properties;
    private boolean listeningOnFlexSession;
    private boolean willTimeout;
    private boolean valid;
    private TimeoutAbstractObject destroyTimer;
}
