// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MessageDestination.java

package flex.messaging;

import flex.management.runtime.messaging.MessageDestinationControl;
import flex.management.runtime.messaging.services.messaging.SubscriptionManagerControl;
import flex.management.runtime.messaging.services.messaging.ThrottleManagerControl;
import flex.messaging.config.ConfigMap;
import flex.messaging.config.ConfigurationException;
import flex.messaging.config.DestinationSettings;
import flex.messaging.config.NetworkSettings;
import flex.messaging.config.ServerSettings;
import flex.messaging.config.ThrottleSettings;
import flex.messaging.durability.MessageCache;
import flex.messaging.services.Service;
import flex.messaging.services.messaging.SubscriptionManager;
import flex.messaging.services.messaging.ThrottleManager;

// Referenced classes of package flex.messaging:
//            FactoryDestination, Destination

public class MessageDestination extends FactoryDestination
{

    public MessageDestination(Service service, DestinationSettings settings)
    {
        this(service, settings, service.isManaged());
    }

    public MessageDestination(Service service, DestinationSettings settings, boolean enableManagement)
    {
        super(service, settings, enableManagement);
        init(settings);
    }

    protected void init(DestinationSettings settings)
    {
        networkSettings = new NetworkSettings();
        serverSettings = new ServerSettings();
        ConfigMap properties = settings.getProperties();
        network(properties);
        server(properties);
        throttleManager = new ThrottleManager(networkSettings.getThrottleSettings());
        subscriptionManager = new SubscriptionManager(this);
        if(isManaged())
        {
            MessageDestinationControl destinationControl = (MessageDestinationControl)getControl();
            ThrottleManagerControl throttleManagerControl = new ThrottleManagerControl(throttleManager, destinationControl);
            throttleManagerControl.register();
            throttleManager.setControl(throttleManagerControl);
            throttleManager.setManaged(true);
            destinationControl.setThrottleManager(throttleManagerControl.getObjectName());
            SubscriptionManagerControl subscriptionManagerControl = new SubscriptionManagerControl(subscriptionManager, destinationControl);
            subscriptionManagerControl.register();
            subscriptionManager.setControl(subscriptionManagerControl);
            subscriptionManager.setManaged(true);
            destinationControl.setSubscriptionManager(subscriptionManagerControl.getObjectName());
        }
    }

    protected void network(ConfigMap properties)
    {
        ConfigMap network = properties.getPropertyAsMap("network", null);
        if(network != null)
        {
            NetworkSettings ns = getNetworkSettings();
            int subscriberTimeout = network.getPropertyAsInt("session-timeout", 20);
            ns.setSessionTimeout(subscriberTimeout);
            throttle(ns.getThrottleSettings(), network);
        }
    }

    protected void throttle(ThrottleSettings ts, ConfigMap network)
    {
        ConfigMap inbound = network.getPropertyAsMap("throttle-inbound", null);
        if(inbound != null)
        {
            int policy = getPolicyFromThrottleSettings(inbound, "NONE");
            ts.setInboundPolicy(policy);
            int destFreq = inbound.getPropertyAsInt("max-frequency", 0);
            ts.setIncomingDestinationFrequency(destFreq);
            int clientFreq = inbound.getPropertyAsInt("max-client-frequency", 0);
            ts.setIncomingClientFrequency(clientFreq);
        }
        ConfigMap outbound = network.getPropertyAsMap("throttle-outbound", null);
        if(outbound != null)
        {
            int policy = getPolicyFromThrottleSettings(outbound, "NONE");
            ts.setOutboundPolicy(policy);
            int destFreq = outbound.getPropertyAsInt("max-frequency", 0);
            ts.setOutgoingDestinationFrequency(destFreq);
            int clientFreq = outbound.getPropertyAsInt("max-client-frequency", 0);
            ts.setOutgoingClientFrequency(clientFreq);
        }
    }

    private int getPolicyFromThrottleSettings(ConfigMap settings, String defaultPolicy)
    {
        String policy = settings.getPropertyAsString("policy", defaultPolicy);
        if(policy.equals("NONE"))
            return 0;
        if(policy.equals("ERROR"))
            return 1;
        if(policy.equals("IGNORE"))
            return 2;
        if(policy.equals("REPLACE"))
        {
            return 3;
        } else
        {
            ConfigurationException ce = new ConfigurationException();
            ce.setMessage(10124, new Object[] {
                getId(), policy
            });
            throw ce;
        }
    }

    protected void server(ConfigMap properties)
    {
        ConfigMap server = properties.getPropertyAsMap("server", null);
        if(server != null)
        {
            int max = server.getPropertyAsInt("max-cache-size", 0);
            serverSettings.setMaxCacheSize(max);
            long ttl = server.getPropertyAsLong("message-time-to-live", -1L);
            serverSettings.setMessageTTL(ttl);
            boolean durable = server.getPropertyAsBoolean("durable", false);
            serverSettings.setDurable(durable);
            String durableStoreManager = server.getPropertyAsString("durable-store-manager", "flex.messaging.durability.FileStoreManager");
            serverSettings.setDurableStoreManager(durableStoreManager);
            String storeRoot = server.getPropertyAsString("file-store-root", null);
            serverSettings.setFileStoreRoot(storeRoot);
            String maxFile = server.getPropertyAsString("max-file-size", "200K");
            serverSettings.setMaxFileSize(maxFile);
            int batchSize = server.getPropertyAsInt("batch-write-size", 0);
            serverSettings.setBatchWriteSize(batchSize);
            boolean allowSubtopics = server.getPropertyAsBoolean("allow-subtopics", false);
            serverSettings.setAllowSubtopics(allowSubtopics);
            String subtopicSeparator = server.getPropertyAsString("subtopic-separator", ".");
            serverSettings.setSubtopicSeparator(subtopicSeparator);
        }
    }

    public ThrottleManager getThrottleManager()
    {
        return throttleManager;
    }

    public SubscriptionManager getSubscriptionManager()
    {
        return subscriptionManager;
    }

    public MessageCache getMessageStore()
    {
        return messageStore;
    }

    public void setMessageStore(MessageCache messageStore)
    {
        this.messageStore = messageStore;
    }

    public ServerSettings getServerSettings()
    {
        return serverSettings;
    }

    public NetworkSettings getNetworkSettings()
    {
        return networkSettings;
    }

    public boolean equals(Object o)
    {
        if(o instanceof Destination)
        {
            Destination d = (Destination)o;
            if(d != null && d.getServiceType().equals(serviceType) && d.getId().equals(id))
                return true;
        }
        return false;
    }

    public int hashCode()
    {
        return (serviceType != null ? serviceType.hashCode() : 0) * 0x186a3 + (id != null ? id.hashCode() : 0);
    }

    public String toString()
    {
        return serviceType + "#" + id;
    }

    protected void setupDestinationControl(Service service)
    {
        controller = new MessageDestinationControl(getId(), this, service.getControl());
        controller.register();
        setControl(controller);
    }

    private static final int UNSUPPORTED_POLICY = 10124;
    private MessageCache messageStore;
    private SubscriptionManager subscriptionManager;
    private ThrottleManager throttleManager;
    private NetworkSettings networkSettings;
    private ServerSettings serverSettings;
    private MessageDestinationControl controller;
}
