// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ClusterManager.java

package flex.messaging.cluster;

import flex.messaging.MessageBroker;
import flex.messaging.config.ClusterSettings;
import flex.messaging.util.ClassUtil;
import java.lang.reflect.Constructor;
import java.util.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

// Referenced classes of package flex.messaging.cluster:
//            ClusterException, Cluster

public class ClusterManager
{

    public ClusterManager(MessageBroker broker)
    {
        this.broker = broker;
        clusters = new HashMap();
        clusterConfig = new HashMap();
        clustersForDestination = new HashMap();
        backendSharedForDestination = new HashMap();
    }

    public MessageBroker getMessageBroker()
    {
        return broker;
    }

    public void invokeServiceOperation(String serviceType, String destinationName, String operationName, Object params[])
    {
        Cluster c = getCluster(serviceType, destinationName);
        ArrayList newParams = new ArrayList(Arrays.asList(params));
        newParams.add(0, serviceType);
        newParams.add(1, destinationName);
        c.broadcastServiceOperation(operationName, newParams.toArray());
    }

    public void invokePeerToPeerOperation(String serviceType, String destinationName, String operationName, Object params[], Object targetAddress)
    {
        Cluster c = getCluster(serviceType, destinationName);
        ArrayList newParams = new ArrayList(Arrays.asList(params));
        newParams.add(0, serviceType);
        newParams.add(1, destinationName);
        c.sendPointToPointServiceOperation(operationName, newParams.toArray(), targetAddress);
    }

    public boolean isDestinationClustered(String serviceType, String destinationName)
    {
        return getCluster(serviceType, destinationName) != null;
    }

    public boolean isBackendShared(String serviceType, String destinationName)
    {
        String destKey = Cluster.getClusterDestinationKey(serviceType, destinationName);
        Boolean shared = (Boolean)backendSharedForDestination.get(destKey);
        if(shared == null)
            return false;
        else
            return shared.booleanValue();
    }

    public void prepareCluster(ClusterSettings settings)
    {
        if(settings.getPropsFileName() == null)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10201, new Object[] {
                settings.getClusterName(), settings.getPropsFileName()
            });
            throw cx;
        }
        java.io.InputStream propsFile;
        try
        {
            propsFile = broker.resolveInternalPath(settings.getPropsFileName());
        }
        catch(Throwable t)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10208, new Object[] {
                settings.getPropsFileName()
            });
            cx.setRootCause(t);
            throw cx;
        }
        if(propsFile == null)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10208, new Object[] {
                settings.getPropsFileName()
            });
            throw cx;
        }
        try
        {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            factory.setNamespaceAware(false);
            factory.setValidating(false);
            DocumentBuilder builder = factory.newDocumentBuilder();
            Document doc = builder.parse(propsFile);
            clusterConfig.put(settings.getClusterName(), doc.getDocumentElement());
        }
        catch(Exception ex)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10213);
            cx.setRootCause(ex);
            throw cx;
        }
    }

    public Cluster getClusterById(String clusterId)
    {
        return (Cluster)clusters.get(clusterId);
    }

    public Cluster getCluster(String serviceType, String destinationName)
    {
        Cluster cluster = null;
        try
        {
            String destKey = Cluster.getClusterDestinationKey(serviceType, destinationName);
            return (Cluster)clustersForDestination.get(destKey);
        }
        catch(NoClassDefFoundError nex)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10202, new Object[] {
                destinationName
            });
            cx.setRootCause(nex);
            throw cx;
        }
    }

    public void destroyClusters()
    {
        for(Iterator iter = clusters.keySet().iterator(); iter.hasNext(); iter.remove())
        {
            Cluster cluster = (Cluster)clusters.get(iter.next());
            cluster.destroy();
        }

    }

    public void clusterDestinationChannel(String clusterId, String serviceType, String destinationName, String channelId, String endpointUrl, int endpointPort, boolean sharedBackend)
    {
        Cluster cluster = getClusterById(clusterId);
        String destKey = Cluster.getClusterDestinationKey(serviceType, destinationName);
        if(cluster == null)
        {
            if(!clusterConfig.containsKey(clusterId))
            {
                ClusterException cx = new ClusterException();
                cx.setMessage(10207, new Object[] {
                    destinationName, clusterId
                });
                throw cx;
            }
            cluster = createCluster(clusterId, serviceType, destinationName);
        } else
        {
            clustersForDestination.put(destKey, cluster);
        }
        backendSharedForDestination.put(destKey, sharedBackend ? ((Object) (Boolean.TRUE)) : ((Object) (Boolean.FALSE)));
        cluster.addLocalEndpointForChannel(serviceType, destinationName, channelId, endpointUrl, endpointPort);
    }

    public List getEndpointsForDestination(String serviceType, String destinationName)
    {
        Cluster c = getCluster(serviceType, destinationName);
        if(c != null)
            return c.getAllEndpoints(serviceType, destinationName);
        else
            return null;
    }

    private Cluster createCluster(String clusterId, String serviceType, String destinationName)
    {
        String destKey = Cluster.getClusterDestinationKey(serviceType, destinationName);
        Element propsFile = (Element)clusterConfig.get(clusterId);
        Cluster cluster = null;
        Class clusterClass = ClassUtil.createClass("flex.messaging.cluster.JGroupsCluster");
        Constructor clusterConstructor = null;
        try
        {
            clusterConstructor = clusterClass.getConstructor(new Class[] {
                flex.messaging.cluster.ClusterManager.class, java.lang.String.class, org.w3c.dom.Element.class
            });
        }
        catch(Exception e)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10210);
            cx.setRootCause(e);
            throw cx;
        }
        try
        {
            cluster = (Cluster)clusterConstructor.newInstance(new Object[] {
                this, clusterId, propsFile
            });
        }
        catch(Exception e)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10211);
            cx.setRootCause(e);
            throw cx;
        }
        clustersForDestination.put(destKey, cluster);
        clusters.put(clusterId, cluster);
        return cluster;
    }

    private MessageBroker broker;
    private Map clusters;
    private Map clustersForDestination;
    private Map clusterConfig;
    private Map backendSharedForDestination;
}
