// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JGroupsCluster.java

package flex.messaging.cluster;

import flex.messaging.MessageBroker;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.util.ExceptionUtil;
import flex.messaging.util.StringUtils;
import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.*;
import org.jgroups.*;
import org.jgroups.blocks.MessageDispatcher;
import org.jgroups.blocks.RequestHandler;
import org.w3c.dom.Element;

// Referenced classes of package flex.messaging.cluster:
//            Cluster, ClusterMembershipListener, ClusterException, ClusterNode, 
//            BroadcastHandler, ClusterManager

public class JGroupsCluster extends Cluster
    implements RequestHandler
{
    class ServiceOperationHandler
        implements BroadcastHandler
    {

        public void handleBroadcast(Address sender, List params)
        {
            try
            {
                String serviceType = (String)params.get(1);
                String destName = (String)params.get(2);
                flex.messaging.services.Service svc = clusterManager.getMessageBroker().getServiceByType(serviceType);
                if(svc != null)
                {
                    String methodName = (String)params.get(0);
                    Object paramValues[] = params.subList(3, params.size()).toArray();
                    Method svcMethods[] = svc.getClass().getMethods();
                    int i = 0;
                    do
                    {
                        if(i >= svcMethods.length)
                            break;
                        if(svcMethods[i].getName().equals(methodName))
                        {
                            svcMethods[i].invoke(svc, paramValues);
                            break;
                        }
                        i++;
                    } while(true);
                }
            }
            catch(InvocationTargetException ite)
            {
                Throwable th = ite.getCause();
                if(Log.isError())
                {
                    Log.getLogger("Service.Cluster").error("Error handling message pushed from cluster: " + th);
                    Log.getLogger("Service.Cluster").error("Exception=" + ExceptionUtil.toString(th));
                }
                ClusterException cx = new ClusterException();
                cx.setMessage(10205, new Object[] {
                    clusterId
                });
                cx.setRootCause(th);
                throw cx;
            }
            catch(Exception e)
            {
                e.printStackTrace();
                ClusterException cx = new ClusterException();
                cx.setMessage(10205, new Object[] {
                    clusterId
                });
                cx.setRootCause(e);
                throw cx;
            }
        }

        public boolean isSupportedOperation(String name)
        {
            for(int i = 0; i < supportedOperations.length; i++)
                if(name.equals(supportedOperations[i]))
                    return true;

            return false;
        }

        String supportedOperations[] = {
            "pushMessageFromPeer", "peerSyncAndPush", "requestAdapterState", "receiveAdapterState"
        };

        ServiceOperationHandler()
        {
            super();
        }
    }

    class RemoteEndpointHandler
        implements BroadcastHandler
    {

        public void handleBroadcast(Address sender, List params)
        {
            addEndpointForChannel(sender, (String)params.get(1), (String)params.get(2), (String)params.get(3), (String)params.get(4));
        }

        public boolean isSupportedOperation(String name)
        {
            return name.equals("addEndpointForChannel");
        }

        RemoteEndpointHandler()
        {
            super();
        }
    }


    public JGroupsCluster(ClusterManager clusterManager, String clusterId, Element props)
    {
        this.clusterManager = clusterManager;
        this.clusterId = clusterId;
        if(Log.isDebug())
            Log.getLogger("Service.Cluster").debug("Creating new cluster with id: " + clusterId);
        configureBroadcastHandlers();
        try
        {
            JChannelFactory channelFactory = new JChannelFactory(props);
            clusterChannel = (JChannel)channelFactory.createChannel();
            clusterChannel.setOpt(3, Boolean.FALSE);
            broadcastDispatcher = new MessageDispatcher(clusterChannel, null, clusterMembershipListener, this);
            clusterChannel.connect(clusterId);
        }
        catch(ChannelException cex)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10200, new Object[] {
                clusterId, props
            });
            cx.setRootCause(cex);
            throw cx;
        }
    }

    public List getAllEndpoints(String serviceType, String destName)
    {
        List channelToEndpointMaps = new ArrayList();
        synchronized(clusterNodes)
        {
            Iterator iter = clusterNodes.keySet().iterator();
            do
            {
                if(!iter.hasNext())
                    break;
                Address addr = (Address)iter.next();
                if(!clusterMembershipListener.isZombie(addr))
                {
                    ClusterNode node = (ClusterNode)clusterNodes.get(addr);
                    Map nodeEndpoints = node.getEndpoints(serviceType, destName);
                    if(nodeEndpoints.size() > 0)
                        channelToEndpointMaps.add(nodeEndpoints);
                }
            } while(true);
        }
        return channelToEndpointMaps;
    }

    public void destroy()
    {
        try
        {
            clusterChannel.close();
        }
        catch(Exception e) { }
    }

    void configureBroadcastHandlers()
    {
        broadcastHandlers.add(new RemoteEndpointHandler());
        broadcastHandlers.add(new ServiceOperationHandler());
    }

    void addClusterNode(Address address)
    {
        if(Log.isDebug())
            Log.getLogger("Service.Cluster").debug("Cluster node from address " + address + " joined the cluster for " + clusterId);
    }

    void removeClusterNode(Address address)
    {
        clusterNodes.remove(address);
        if(Log.isDebug())
            Log.getLogger("Service.Cluster").debug("Cluster node from address " + address + " abandoned the cluster for " + clusterId);
    }

    Address getLocalAddress()
    {
        return clusterChannel.getLocalAddress();
    }

    void addLocalEndpointForChannel(String serviceType, String destName, String channelId, String endpointUrl, int endpointPort)
    {
        if(Log.isDebug())
            Log.getLogger("Service.Cluster").debug("Adding clustered destination endpoint. cluster-id=" + clusterId + " destination=" + destName + " channelId=" + channelId + " endpoint url=" + endpointUrl + " endpointPort=" + endpointPort);
        Address myAddr = getLocalAddress();
        ClusterNode myNode = getNodeForAddress(myAddr);
        endpointUrl = canonicalizeUrl(channelId, endpointUrl, endpointPort, myNode);
        myNode.addEndpoint(serviceType, destName, channelId, endpointUrl);
        broadcastClusterOperation("addEndpointForChannel", serviceType, destName, channelId, endpointUrl, null);
    }

    void addEndpointForChannel(Address address, String serviceType, String destName, String channelId, String endpointUrl)
    {
        ClusterNode node = getNodeForAddress(address);
        if(!node.containsEndpoint(serviceType, destName, channelId, endpointUrl))
        {
            node.addEndpoint(serviceType, destName, channelId, endpointUrl);
            broadcastMyEndpoints(address);
        }
    }

    void broadcastMyEndpoints(Address address)
    {
        Vector destination = new Vector();
        destination.add(address);
        ClusterNode myNode = getNodeForAddress(clusterChannel.getLocalAddress());
        Map destKeyToChannelMap = myNode.getDestKeyToChannelMap();
        synchronized(destKeyToChannelMap)
        {
            for(Iterator destIt = destKeyToChannelMap.keySet().iterator(); destIt.hasNext();)
            {
                String destKey = (String)destIt.next();
                int ix = destKey.indexOf(":");
                String serviceType = destKey.substring(0, ix);
                String destName = destKey.substring(ix + 1);
                Map channelEndpoints = myNode.getEndpoints(serviceType, destName);
                Iterator iter = channelEndpoints.keySet().iterator();
                while(iter.hasNext()) 
                {
                    String channelId = (String)iter.next();
                    String endpointUrl = (String)channelEndpoints.get(channelId);
                    broadcastClusterOperation("addEndpointForChannel", serviceType, destName, channelId, endpointUrl, destination);
                }
            }

        }
    }

    void broadcastClusterOperation(String clusterOperation, String serviceType, String destName, String channelId, String endpointUrl, Vector destinations)
    {
        List operationInfo = new ArrayList();
        operationInfo.add(serviceType);
        operationInfo.add(destName);
        operationInfo.add(channelId);
        operationInfo.add(endpointUrl);
        broadcastOperation((flex.messaging.cluster.JGroupsCluster$RemoteEndpointHandler.class).getName(), clusterOperation, operationInfo, destinations);
    }

    void broadcastServiceOperation(String serviceOperation, Object params[])
    {
        ArrayList operationInfo = new ArrayList();
        operationInfo.addAll(Arrays.asList(params));
        broadcastOperation((flex.messaging.cluster.JGroupsCluster$ServiceOperationHandler.class).getName(), serviceOperation, operationInfo, null);
    }

    void sendPointToPointServiceOperation(String serviceOperation, Object params[], Object targetAddress)
    {
        ArrayList operationInfo = new ArrayList();
        operationInfo.addAll(Arrays.asList(params));
        operationInfo.add(getLocalAddress());
        Vector targetDestination = new Vector();
        if(targetAddress != null)
        {
            targetDestination.add(targetAddress);
        } else
        {
            int i = 0;
            do
            {
                if(i >= clusterChannel.getView().getMembers().size())
                    break;
                Address a = (Address)clusterChannel.getView().getMembers().get(i);
                if(!a.equals(getLocalAddress()))
                {
                    targetDestination.add(a);
                    break;
                }
                i++;
            } while(true);
        }
        broadcastOperation((flex.messaging.cluster.JGroupsCluster$ServiceOperationHandler.class).getName(), serviceOperation, operationInfo, targetDestination);
    }

    private void broadcastOperation(String handlerClass, String operationName, List operationParams, Vector destinations)
    {
        try
        {
            operationParams.add(0, handlerClass);
            operationParams.add(1, operationName);
            Message operationMessage = new Message(null, getLocalAddress(), (Serializable)operationParams);
            broadcastDispatcher.castMessage(destinations, operationMessage, 6, 0L);
        }
        catch(IllegalArgumentException iae)
        {
            String message = iae.getMessage();
            String notSerializableType = null;
            if(message != null && message.startsWith("java.io.NotSerializableException"))
                notSerializableType = message.substring(message.indexOf(": ") + 2);
            if(notSerializableType != null)
            {
                ClusterException cx = new ClusterException();
                cx.setMessage(10212, new Object[] {
                    clusterId, notSerializableType
                });
                cx.setRootCause(iae);
                throw cx;
            } else
            {
                ClusterException cx = new ClusterException();
                cx.setMessage(10204, new Object[] {
                    clusterId
                });
                cx.setRootCause(iae);
                throw cx;
            }
        }
        catch(Exception e)
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10204, new Object[] {
                clusterId
            });
            cx.setRootCause(e);
            throw cx;
        }
    }

    public Object handle(Message msg)
    {
label0:
        {
            if(msg.getSrc() == getLocalAddress())
                break label0;
            List operationInfo = (List)msg.getObject();
            String handlerClass = (String)operationInfo.get(0);
            String operationName = (String)operationInfo.get(1);
            Iterator iter = broadcastHandlers.iterator();
            BroadcastHandler handler;
            do
            {
                if(!iter.hasNext())
                    break label0;
                handler = (BroadcastHandler)iter.next();
            } while(!handler.getClass().getName().equals(handlerClass) || !handler.isSupportedOperation(operationName));
            handler.handleBroadcast(msg.getSrc(), operationInfo.subList(1, operationInfo.size()));
        }
        return null;
    }

    private ClusterNode getNodeForAddress(Address addr)
    {
        Map map = clusterNodes;
        JVM INSTR monitorenter ;
        ClusterNode node = (ClusterNode)clusterNodes.get(addr);
        if(node == null)
        {
            node = new ClusterNode(addr);
            clusterNodes.put(addr, node);
        }
        return node;
        Exception exception;
        exception;
        throw exception;
    }

    private String canonicalizeUrl(String channelId, String endpointUrl, int endpointPort, ClusterNode myNode)
    {
        if(endpointUrl.startsWith("/"))
        {
            ClusterException cx = new ClusterException();
            cx.setMessage(10203, new Object[] {
                channelId
            });
            throw cx;
        }
        if(endpointUrl.indexOf(":///") != -1)
            endpointUrl = StringUtils.substitute(endpointUrl, ":///", "://" + myNode.getHost() + "/");
        if(endpointUrl.indexOf("" + endpointPort) == -1)
        {
            StringBuffer sb = new StringBuffer(endpointUrl);
            sb.insert(endpointUrl.indexOf("/", endpointUrl.indexOf("://") + 3), ":" + endpointPort);
            endpointUrl = sb.toString();
        }
        return endpointUrl;
    }

    private final MessageDispatcher broadcastDispatcher;
    private final List broadcastHandlers = new ArrayList();
    private final JChannel clusterChannel;
    private final ClusterManager clusterManager;
    private final ClusterMembershipListener clusterMembershipListener = new ClusterMembershipListener(this);
    private final Map clusterNodes = Collections.synchronizedMap(new HashMap());
    private final String clusterId;


}
