// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ConfigurationManager.java

package flex.messaging.config;

import flex.messaging.LocalizedException;
import flex.messaging.util.Trace;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;

// Referenced classes of package flex.messaging.config:
//            MessagingConfiguration, ServletResourceResolver, ConfigurationParser, ConfigurationException, 
//            SecuritySettings, SystemSettings

public class ConfigurationManager
{

    private ConfigurationManager()
    {
    }

    public static MessagingConfiguration getMessagingConfiguration(ServletConfig servletConfig)
    {
        MessagingConfiguration config = new MessagingConfiguration();
        if(servletConfig != null)
        {
            String serverInfo = servletConfig.getServletContext().getServerInfo();
            config.getSecuritySettings().setServerInfo(serverInfo);
        }
        verifyMinimumJavaVersion();
        ConfigurationParser parser = getConfigurationParser(servletConfig);
        if(parser == null)
        {
            LocalizedException lme = new LocalizedException();
            lme.setMessage(10138);
            throw lme;
        }
        String path = getConfigurationPath(servletConfig);
        parser.parse(path, new ServletResourceResolver(servletConfig.getServletContext()), config);
        if(servletConfig != null)
            config.getSystemSettings().setPaths(servletConfig.getServletContext());
        return config;
    }

    static ConfigurationParser getConfigurationParser(ServletConfig servletConfig)
    {
        ConfigurationParser parser = null;
        Class parserClass = null;
        String className = null;
        if(servletConfig != null)
        {
            String p = servletConfig.getInitParameter("services.configuration.parser");
            if(p != null)
            {
                className = p.trim();
                try
                {
                    parserClass = Class.forName(className);
                    parser = (ConfigurationParser)parserClass.newInstance();
                }
                catch(Throwable t)
                {
                    if(Trace.config)
                        Trace.trace("Could not load configuration parser as: " + className);
                }
            }
        }
        if(parser == null)
            try
            {
                className = "flex.messaging.config.XPathServerConfigurationParser";
                parserClass = Class.forName(className);
                Class.forName("javax.xml.xpath.XPathExpressionException");
                parser = (ConfigurationParser)parserClass.newInstance();
            }
            catch(Throwable t)
            {
                if(Trace.config)
                    Trace.trace("Could not load configuration parser as: " + className);
            }
        if(parser == null)
            try
            {
                className = "flex.messaging.config.ApacheXPathServerConfigurationParser";
                parserClass = Class.forName(className);
                parser = (ConfigurationParser)parserClass.newInstance();
            }
            catch(Throwable t)
            {
                if(Trace.config)
                    Trace.trace("Could not load configuration parser as: " + className);
            }
        if(Trace.config && parser != null)
            Trace.trace("Services Configuration Parser: " + parser.getClass().getName());
        return parser;
    }

    static String getConfigurationPath(ServletConfig servletConfig)
    {
        String path = "/WEB-INF/flex/services-config.xml";
        if(servletConfig != null)
        {
            String p = servletConfig.getInitParameter("services.configuration.file");
            if(p != null)
                path = p.trim();
        }
        return path;
    }

    public static void verifyMinimumJavaVersion()
        throws ConfigurationException
    {
        try
        {
            boolean minimum = false;
            String version = System.getProperty("java.version");
            String vendor = System.getProperty("java.vendor");
            version = version.replace('.', ':');
            version = version.replace('_', ':');
            String split[] = version.split(":");
            int first = Integer.parseInt(split[0]);
            if(first > 1)
                minimum = true;
            else
            if(first == 1)
            {
                int second = Integer.parseInt(split[1]);
                if(second > 4)
                    minimum = true;
                else
                if(second == 4)
                {
                    int third = Integer.parseInt(split[2]);
                    if(third > 2)
                        minimum = true;
                    else
                    if(third == 2)
                        if(vendor != null && vendor.indexOf("Sun") != -1)
                        {
                            int fourth = Integer.parseInt(split[3]);
                            if(fourth >= 6)
                                minimum = true;
                        } else
                        {
                            minimum = true;
                        }
                }
            }
            if(!minimum)
            {
                ConfigurationException cx = new ConfigurationException();
                if(vendor != null && vendor.indexOf("Sun") != -1)
                    cx.setMessage(10139, new Object[] {
                        System.getProperty("java.version")
                    });
                else
                    cx.setMessage(10140, new Object[] {
                        System.getProperty("java.version")
                    });
                throw cx;
            }
        }
        catch(Throwable t)
        {
            if(t instanceof ConfigurationException)
                throw (ConfigurationException)t;
            if(Trace.config)
                Trace.trace("Could not verified required java version. version=" + System.getProperty("java.version"));
        }
    }

    public static final String LOG_CATEGORY = "Configuration";
}
