// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MessagingConfiguration.java

package flex.messaging.config;

import flex.management.runtime.messaging.endpoints.EndpointControl;
import flex.messaging.MessageBroker;
import flex.messaging.MessageException;
import flex.messaging.cluster.ClusterManager;
import flex.messaging.endpoints.Endpoint;
import flex.messaging.license.LicenseService;
import flex.messaging.log.*;
import flex.messaging.security.LoginManager;
import flex.messaging.services.AbstractService;
import flex.messaging.services.AuthenticationService;
import flex.messaging.util.*;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.*;

// Referenced classes of package flex.messaging.config:
//            SecuritySettings, FactorySettings, ChannelSettings, ConfigurationException, 
//            ServiceSettings, TargetSettings, ClusterSettings, DestinationSettings, 
//            ServicesConfiguration, LoggingSettings, ConfigMap, AdapterSettings, 
//            PropertiesSettings, SystemSettings

public class MessagingConfiguration
    implements ServicesConfiguration
{

    public MessagingConfiguration()
    {
    }

    public void configureBroker(MessageBroker broker)
    {
        broker.setChannelSettings(channelSettings);
        broker.setSecuritySettings(securitySettings);
        broker.setSystemSettings(systemSettings);
        createAuthorizationManager(broker);
        createRedeployManager(broker);
        createFactories(broker);
        createEndpoints(broker);
        prepareClusters(broker);
        createServices(broker);
    }

    private void createFactories(MessageBroker broker)
    {
        String id;
        FactorySettings factorySetting;
        for(Iterator iter = factorySettings.entrySet().iterator(); iter.hasNext(); broker.addFactory(id, factorySetting.createFactory()))
        {
            java.util.Map.Entry entry = (java.util.Map.Entry)iter.next();
            id = (String)entry.getKey();
            factorySetting = (FactorySettings)entry.getValue();
        }

    }

    private void createRedeployManager(MessageBroker broker)
    {
        RedeployManager redeployManager = new RedeployManager();
        redeployManager.init(systemSettings);
        broker.setRedeployManager(redeployManager);
    }

    private void createAuthorizationManager(MessageBroker broker)
    {
        LoginManager loginManager = new LoginManager();
        loginManager.init(securitySettings);
        broker.setLoginManager(loginManager);
    }

    private void createEndpoints(MessageBroker broker)
    {
        Class endpointConstructorAPI[] = {
            flex.messaging.MessageBroker.class, flex.messaging.config.ChannelSettings.class
        };
        Iterator iter = channelSettings.keySet().iterator();
        do
        {
            if(!iter.hasNext())
                break;
            String endpointId = (String)iter.next();
            ChannelSettings chanSettings = (ChannelSettings)channelSettings.get(endpointId);
            Endpoint endpoint = null;
            String endpointClass = chanSettings.getEndpointType();
            try
            {
                Class c = ClassUtil.createClass(endpointClass);
                Constructor constructor = c.getConstructor(endpointConstructorAPI);
                endpoint = (Endpoint)constructor.newInstance(new Object[] {
                    broker, chanSettings
                });
            }
            catch(Throwable t)
            {
                if(t instanceof InvocationTargetException)
                    t = ((InvocationTargetException)t).getCause();
                if(t instanceof MessageException)
                {
                    throw (MessageException)t;
                } else
                {
                    ConfigurationException cx = new ConfigurationException();
                    cx.setMessage(10125, new Object[] {
                        endpointClass, endpointId
                    });
                    cx.setRootCause(t);
                    throw cx;
                }
            }
            if(endpoint != null)
            {
                broker.addEndpoint(endpoint);
                if(Log.isInfo())
                {
                    String endpointURI = EndpointControl.getURIOf(endpoint);
                    String endpointSecurity = EndpointControl.getSecurityConstraintOf(endpoint);
                    if(StringUtils.isEmpty(endpointSecurity))
                        endpointSecurity = "None";
                    Log.getLogger("Configuration").info("Endpoint " + endpointId + " created with security: " + endpointSecurity + StringUtils.NEWLINE + "at URI: " + endpointURI);
                }
            }
        } while(true);
    }

    private void createServices(MessageBroker broker)
    {
        broker.addService(new AuthenticationService(broker, AuthenticationService.settings));
        Iterator iter = serviceSettings.keySet().iterator();
        do
        {
            if(!iter.hasNext())
                break;
            String serviceType = (String)iter.next();
            ServiceSettings svcSettings = (ServiceSettings)serviceSettings.get(serviceType);
            String className = svcSettings.getClassName();
            try
            {
                Class svcClass = ClassUtil.createClass(className);
                Constructor svcConstructor = svcClass.getConstructor(new Class[] {
                    flex.messaging.MessageBroker.class, flex.messaging.config.ServiceSettings.class
                });
                AbstractService service = (AbstractService)svcConstructor.newInstance(new Object[] {
                    broker, svcSettings
                });
                broker.addService(service);
                service.createDestinations();
            }
            catch(Throwable t)
            {
                if(t instanceof InvocationTargetException)
                    if(t.getCause() != null)
                        t = ((InvocationTargetException)t).getCause();
                    else
                    if(((InvocationTargetException)t).getTargetException() != null)
                        t = ((InvocationTargetException)t).getTargetException();
                if((t instanceof ExceptionInInitializerError) && t.getCause() != null)
                    t = ((ExceptionInInitializerError)t).getCause();
                ConfigurationException cx = new ConfigurationException();
                if(t instanceof NoClassDefFoundError)
                {
                    if(t.getMessage() != null && t.getMessage().indexOf("org/apache/commons/logging") != -1)
                        cx.setMessage(10453, new Object[] {
                            className, serviceType
                        });
                    else
                        cx.setMessage(10452, new Object[] {
                            className, serviceType, t.getMessage()
                        });
                } else
                {
                    String msg = t.getMessage() == null ? t.getClass().getName() : t.getMessage();
                    cx.setMessage(10450, new Object[] {
                        className, serviceType, msg
                    });
                }
                cx.setRootCause(t);
                throw cx;
            }
        } while(true);
    }

    private void createLogger()
    {
        ConfigMap properties = loggingSettings.getProperties();
        if(properties.getPropertyAsString("pretty-printer", null) == null)
            properties.put("pretty-printer", (flex.messaging.util.ToStringPrettyPrinter.class).getName());
        Log.init(properties);
        List targets = loggingSettings.getTargets();
        Iterator it = targets.iterator();
        do
        {
            if(!it.hasNext())
                break;
            TargetSettings targetSettings = (TargetSettings)it.next();
            String className = targetSettings.getClassName();
            Class c = ClassUtil.createClass(className);
            try
            {
                Constructor con = c.getConstructor(new Class[] {
                    flex.messaging.config.TargetSettings.class
                });
                Target target = (Target)con.newInstance(new Object[] {
                    targetSettings
                });
                target.setLevel(Log.readLevel(targetSettings.getLevel()));
                target.setFilters(targetSettings.getFilters());
                Log.addTarget(target);
            }
            catch(Throwable t)
            {
                t.printStackTrace();
                if(t instanceof InvocationTargetException)
                    t = ((InvocationTargetException)t).getCause();
                ConfigurationException cx = new ConfigurationException();
                cx.setMessage(10126, new Object[] {
                    className
                });
                cx.setRootCause(t);
                throw cx;
            }
        } while(true);
    }

    private void prepareClusters(MessageBroker broker)
    {
        ClusterManager clusterManager = broker.getClusterManager();
        Iterator iter = clusterSettings.keySet().iterator();
        do
        {
            if(!iter.hasNext())
                break;
            if(!broker.getLicenseService().isClusteringEnabled())
            {
                Log.getLogger("Service.Cluster").warn("The current license does not support clustering; clustering for all destinations is disabled.");
                break;
            }
            String clusterId = (String)iter.next();
            ClusterSettings cs = (ClusterSettings)clusterSettings.get(clusterId);
            clusterManager.prepareCluster(cs);
        } while(true);
    }

    public void addChannelSettings(String id, ChannelSettings settings)
    {
        channelSettings.put(id, settings);
    }

    public ChannelSettings getChannelSettings(String ref)
    {
        return (ChannelSettings)channelSettings.get(ref);
    }

    public Map getAllChannelSettings()
    {
        return channelSettings;
    }

    public SecuritySettings getSecuritySettings()
    {
        return securitySettings;
    }

    public void addServiceSettings(ServiceSettings settings)
    {
        serviceSettings.put(settings.getId(), settings);
    }

    public ServiceSettings getServiceSettings(String id)
    {
        if(serviceSettings.containsKey(id))
            return (ServiceSettings)serviceSettings.get(id);
        else
            return null;
    }

    public Map getAllServiceSettings()
    {
        return serviceSettings;
    }

    public LoggingSettings getLoggingSettings()
    {
        return loggingSettings;
    }

    public void setLoggingSettings(LoggingSettings loggingSettings)
    {
        this.loggingSettings = loggingSettings;
        createLogger();
    }

    public void setSystemSettings(SystemSettings ss)
    {
        systemSettings = ss;
    }

    public SystemSettings getSystemSettings()
    {
        return systemSettings;
    }

    public void addClusterSettings(ClusterSettings settings)
    {
        if(clusterSettings.containsKey(settings.getClusterName()))
        {
            ConfigurationException cx = new ConfigurationException();
            cx.setMessage(10206, new Object[] {
                settings.getClusterName()
            });
            throw cx;
        } else
        {
            clusterSettings.put(settings.getClusterName(), settings);
            return;
        }
    }

    public void addFactorySettings(String id, FactorySettings settings)
    {
        factorySettings.put(id, settings);
    }

    public void reportUnusedProperties()
    {
        ArrayList findings = new ArrayList();
        for(Iterator serviceItr = this.serviceSettings.values().iterator(); serviceItr.hasNext();)
        {
            ServiceSettings serviceSettings = (ServiceSettings)serviceItr.next();
            gatherUnusedProperties(serviceSettings.getId(), serviceSettings.getSourceFile(), "service", serviceSettings, findings);
            Iterator destinationItr = serviceSettings.getDestinationSettings().values().iterator();
            while(destinationItr.hasNext()) 
            {
                DestinationSettings destinationSettings = (DestinationSettings)destinationItr.next();
                gatherUnusedProperties(destinationSettings.getId(), destinationSettings.getSourceFile(), "destination", destinationSettings, findings);
                AdapterSettings adapterSettings = destinationSettings.getAdapterSettings();
                if(adapterSettings != null)
                    gatherUnusedProperties(adapterSettings.getId(), adapterSettings.getSourceFile(), "adapter", adapterSettings, findings);
            }
        }

        ChannelSettings channelSettings;
        for(Iterator channelItr = this.channelSettings.values().iterator(); channelItr.hasNext(); gatherUnusedProperties(channelSettings.getId(), channelSettings.getSourceFile(), "channel", channelSettings, findings))
            channelSettings = (ChannelSettings)channelItr.next();

        if(!findings.isEmpty())
        {
            int errorNumber = 10149;
            ConfigurationException exception = new ConfigurationException();
            StringBuffer allDetails = new StringBuffer();
            for(int i = 0; i < findings.size(); i++)
            {
                allDetails.append(StringUtils.NEWLINE);
                allDetails.append("  ");
                exception.setDetails(errorNumber, "pattern", (Object[])(Object[])findings.get(i));
                allDetails.append(exception.getDetails());
                exception.setDetails(null);
            }

            exception.setMessage(errorNumber, new Object[] {
                allDetails
            });
            throw exception;
        } else
        {
            return;
        }
    }

    private void gatherUnusedProperties(String settingsId, String settingsSource, String settingsType, PropertiesSettings settings, Collection result)
    {
        List unusedProperties = settings.getProperties().findAllUnusedProperties();
        int size = unusedProperties.size();
        if(size > 0)
        {
            for(int i = 0; i < size; i++)
            {
                String path = (String)unusedProperties.get(i);
                result.add(((Object) (new Object[] {
                    path, settingsType, settingsId, settingsSource
                })));
            }

        }
    }

    private final Map channelSettings = new HashMap();
    private final SecuritySettings securitySettings = new SecuritySettings();
    private final Map serviceSettings = new HashMap();
    private LoggingSettings loggingSettings;
    private SystemSettings systemSettings;
    private final Map clusterSettings = new HashMap();
    private final Map factorySettings = new HashMap();
}
