// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SystemSettings.java

package flex.messaging.config;

import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.util.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;
import javax.servlet.ServletContext;

public class SystemSettings
{

    public SystemSettings()
    {
        resourceLoader = new PropertyStringResourceLoader();
        watches = new ArrayList();
        touches = new ArrayList();
    }

    public void setDefaultLocale(Locale locale)
    {
        defaultLocale = locale;
        resourceLoader.setDefaultLocale(defaultLocale);
    }

    public Locale getDefaultLocale()
    {
        return defaultLocale;
    }

    public ResourceLoader getResourceLoader()
    {
        return resourceLoader;
    }

    public void setResourceLoader(ResourceLoader resourceLoader)
    {
        this.resourceLoader = resourceLoader;
    }

    public void setRedeployEnabled(String enabled)
    {
        enabled = enabled.toLowerCase();
        if(enabled.startsWith("t"))
            redeployEnabled = true;
        else
            redeployEnabled = false;
    }

    public boolean getRedeployEnabled()
    {
        return redeployEnabled;
    }

    public void setWatchInterval(String interval)
    {
        watchInterval = Integer.parseInt(interval);
    }

    public int getWatchInterval()
    {
        return watchInterval;
    }

    public void addWatchFile(String watch)
    {
        watches.add(watch);
    }

    public List getWatchFiles()
    {
        return watches;
    }

    public void addTouchFile(String touch)
    {
        touches.add(touch);
    }

    public List getTouchFiles()
    {
        return touches;
    }

    public void setPaths(ServletContext context)
    {
        if(redeployEnabled)
        {
            List resolvedWatches = new ArrayList();
            for(int i = 0; i < watches.size(); i++)
            {
                String path = (String)watches.get(i);
                String resolvedPath = null;
                Logger logger;
                if(path.startsWith("{context.root}") || path.startsWith("{context-root}"))
                {
                    path = path.substring(14);
                    resolvedPath = context.getRealPath(path);
                    if(resolvedPath != null)
                    {
                        try
                        {
                            resolvedWatches.add(new WatchedObject(resolvedPath));
                            continue;
                        }
                        catch(FileNotFoundException fnfe)
                        {
                            logger = Log.getLogger("Configuration");
                            if(logger != null)
                                logger.warn("The watch-file, " + path + ", could not be found and will be ignored.");
                        }
                    } else
                    {
                        Logger logger = Log.getLogger("Configuration");
                        logger.warn("The watch-file, " + path + ", could not be resolved to a path and will be ignored.");
                    }
                    continue;
                }
                try
                {
                    resolvedWatches.add(new WatchedObject(path));
                    continue;
                }
                catch(FileNotFoundException fnfe)
                {
                    logger = Log.getLogger("Configuration");
                }
                if(logger != null)
                    logger.warn("The watch-file, " + path + ", could not be found and will be ignored.");
            }

            watches = resolvedWatches;
            List resolvedTouches = new ArrayList();
            for(int i = 0; i < touches.size(); i++)
            {
                String path = (String)touches.get(i);
                String resolvedPath = null;
                Logger logger;
                if(path.startsWith("{context.root}") || path.startsWith("{context-root}"))
                {
                    path = path.substring(14);
                    resolvedPath = context.getRealPath(path);
                    if(resolvedPath != null)
                    {
                        File file = new File(resolvedPath);
                        if(!file.exists() || !file.isFile() && !file.isDirectory() || !file.isAbsolute())
                        {
                            logger = Log.getLogger("Configuration");
                            logger.warn("The touch-file, " + path + ", could not be found and will be ignored.");
                        } else
                        {
                            resolvedTouches.add(resolvedPath);
                        }
                    } else
                    {
                        Logger logger = Log.getLogger("Configuration");
                        logger.warn("The touch-file, " + path + ", could not be resolved to a path and will be ignored.");
                    }
                    continue;
                }
                try
                {
                    resolvedWatches.add(new WatchedObject(path));
                    continue;
                }
                catch(FileNotFoundException fnfe)
                {
                    logger = Log.getLogger("Configuration");
                }
                if(logger != null)
                    logger.warn("The touch-file, " + path + ", could not be found and will be ignored.");
            }

            touches = resolvedTouches;
        }
    }

    private ResourceLoader resourceLoader;
    private Locale defaultLocale;
    private boolean redeployEnabled;
    private int watchInterval;
    private List watches;
    private List touches;
}
