// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AbstractEndpoint.java

package flex.messaging.endpoints;

import flex.management.ManageableComponent;
import flex.management.runtime.messaging.endpoints.EndpointControl;
import flex.messaging.MessageBroker;
import flex.messaging.MessageClient;
import flex.messaging.config.*;
import flex.messaging.io.*;
import flex.messaging.io.amf.serializers.CustomDeserializer;
import flex.messaging.io.amf.serializers.CustomSerializer;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.CommandMessage;
import flex.messaging.messages.Message;
import flex.messaging.security.LoginManager;
import flex.messaging.util.ClassUtil;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

// Referenced classes of package flex.messaging.endpoints:
//            Endpoint

public abstract class AbstractEndpoint extends ManageableComponent
    implements Endpoint
{

    public AbstractEndpoint(MessageBroker broker, ChannelSettings cs)
    {
        this(broker, cs, broker.isManaged());
    }

    public AbstractEndpoint(MessageBroker broker, ChannelSettings cs, boolean enableManagement)
    {
        super(enableManagement);
        this.broker = broker;
        settings = cs;
        id = cs.getId();
        log = Log.getLogger("Endpoint.General");
        serializationContext = new SerializationContext();
        properties();
    }

    protected void properties()
    {
        ConfigMap properties = settings.getProperties();
        if(properties != null)
        {
            properties.allowProperty("connect-timeout-seconds");
            ConfigMap serialization = properties.getPropertyAsMap("serialization", null);
            if(serialization != null)
            {
                List deserializers = serialization.getPropertyAsList("custom-deserializer", null);
                if(deserializers != null)
                {
                    for(int i = 0; i < deserializers.size(); i++)
                    {
                        Object map = deserializers.get(i);
                        if(!(map instanceof ConfigMap))
                            continue;
                        ConfigMap dsProps = (ConfigMap)map;
                        String dsType = dsProps.getPropertyAsString("type", null);
                        String dsClassName = dsProps.getPropertyAsString("class", null);
                        if(dsType == null || dsClassName == null)
                            continue;
                        try
                        {
                            Class c = ClassUtil.createClass(dsClassName);
                            CustomDeserializer ds = (CustomDeserializer)ClassUtil.createDefaultInstance(c, flex.messaging.io.amf.serializers.CustomDeserializer.class);
                            serializationContext.addCustomDeserializer(dsType, ds);
                        }
                        catch(Throwable t)
                        {
                            log.warn("Cannot register custom-deserializer for type {0}, class {1}", new Object[] {
                                dsType, dsClassName
                            }, t);
                        }
                    }

                }
                List serializers = serialization.getPropertyAsList("custom-serializer", null);
                if(serializers != null)
                {
                    for(int i = 0; i < serializers.size(); i++)
                    {
                        Object map = serializers.get(i);
                        if(!(map instanceof ConfigMap))
                            continue;
                        ConfigMap sProps = (ConfigMap)map;
                        String sType = sProps.getPropertyAsString("type", null);
                        String sClassName = sProps.getPropertyAsString("class", null);
                        if(sType == null || sClassName == null)
                            continue;
                        try
                        {
                            Class c = ClassUtil.createClass(sClassName);
                            CustomSerializer ds = (CustomSerializer)ClassUtil.createDefaultInstance(c, flex.messaging.io.amf.serializers.CustomSerializer.class);
                            serializationContext.addCustomSerializer(sType, ds);
                        }
                        catch(Throwable t)
                        {
                            log.warn("Cannot register custom serializer for type {0}, class {1}", new Object[] {
                                sType, sClassName
                            }, t);
                        }
                    }

                }
                String typeMarshallerClassName = serialization.getPropertyAsString("type-marshaller", null);
                if(typeMarshallerClassName != null && typeMarshallerClassName.length() > 0)
                    try
                    {
                        Class tmc = ClassUtil.createClass(typeMarshallerClassName);
                        typeMarshaller = (TypeMarshaller)ClassUtil.createDefaultInstance(tmc, flex.messaging.io.TypeMarshaller.class);
                    }
                    catch(Throwable t)
                    {
                        log.warn("Cannot register custom type marshaller for type {0}", new Object[] {
                            typeMarshallerClassName
                        }, t);
                    }
                serializationContext.instantiateTypes = serialization.getPropertyAsBoolean("instantiate-types", true);
                serializationContext.supportRemoteClass = serialization.getPropertyAsBoolean("support-remote-class", false);
                serializationContext.legacyCollection = serialization.getPropertyAsBoolean("legacy-collection", false);
                serializationContext.legacyMap = serialization.getPropertyAsBoolean("legacy-map", false);
                serializationContext.legacyXMLDocument = serialization.getPropertyAsBoolean("legacy-xml", false);
                serializationContext.legacyThrowable = serialization.getPropertyAsBoolean("legacy-throwable", false);
                serializationContext.showStacktraces = serialization.getPropertyAsBoolean("show-stacktraces", false);
                serializationContext.restoreReferences = serialization.getPropertyAsBoolean("restore-references", false);
                serializationContext.logPropertyErrors = serialization.getPropertyAsBoolean("log-property-errors", false);
                serializationContext.ignorePropertyErrors = serialization.getPropertyAsBoolean("ignore-property-errors", true);
            }
        }
        securityConstraint = settings.getConstraint();
    }

    public String getId()
    {
        return id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public MessageBroker getMessageBroker()
    {
        return broker;
    }

    public ChannelSettings getSettings()
    {
        return settings;
    }

    public void start()
    {
        if(isManaged())
            ((EndpointControl)getControl()).setRunning(new Boolean(true));
    }

    public void stop()
    {
        broker = null;
        if(isManaged())
            ((EndpointControl)getControl()).setRunning(new Boolean(false));
    }

    public void push(Message message, MessageClient client)
    {
        throw new UnsupportedOperationException();
    }

    public void service(HttpServletRequest req, HttpServletResponse res)
    {
        throw new UnsupportedOperationException();
    }

    public Message serviceMessage(Message message)
    {
        if(isManaged())
            ((EndpointControl)getControl()).incrementServiceMessageCount();
        Message ack = null;
        if(message.getTimestamp() == 0L)
            message.setTimestamp(System.currentTimeMillis());
        if(message.headerExists("DSEndpoint") && message.getHeader("DSEndpoint") != null)
            message.setHeader("DSEndpoint", getId());
        checkSecurityConstraint(message);
        if(message instanceof CommandMessage)
            ack = broker.routeCommandToService((CommandMessage)message, this);
        else
            ack = broker.routeMessageToService(message, this);
        return ack;
    }

    protected void checkSecurityConstraint(Message message)
    {
        if(securityConstraint != null)
            broker.getLoginManager().checkConstraint(securityConstraint);
    }

    protected void setThreadLocals()
    {
        if(serializationContext != null)
            SerializationContext.setSerializationContext((SerializationContext)serializationContext.clone());
        if(typeMarshaller != null)
            TypeMarshallingContext.setTypeMarshaller(typeMarshaller);
    }

    protected void clearThreadLocals()
    {
        SerializationContext.setSerializationContext(null);
        TypeMarshallingContext.setTypeMarshaller(null);
    }

    public static void addNoCacheHeaders(HttpServletRequest req, HttpServletResponse res)
    {
        res.setHeader("Cache-Control", "no-cache");
        res.setDateHeader("Expires", 0x46c32800L);
        String userAgent = req.getHeader("User-Agent");
        if(!req.isSecure() || userAgent == null || userAgent.indexOf("MSIE") == -1)
            res.setHeader("Pragma", "no-cache");
    }

    public boolean isSecure()
    {
        return false;
    }

    private static final String SERIALIZATION = "serialization";
    private static final String CUSTOM_DESERIALIZER = "custom-deserializer";
    private static final String TYPE = "type";
    private static final String CLASS = "class";
    private static final String CUSTOM_SERIALIZER = "custom-serializer";
    private static final String TYPE_MARSHALLER = "type-marshaller";
    private static final String RESTORE_REFERENCES = "restore-references";
    private static final String INSTANTIATE_TYPES = "instantiate-types";
    private static final String SUPPORT_REMOTE_CLASS = "support-remote-class";
    private static final String LEGACY_COLLECTION = "legacy-collection";
    private static final String LEGACY_MAP = "legacy-map";
    private static final String LEGACY_XML = "legacy-xml";
    private static final String LEGACY_THROWABLE = "legacy-throwable";
    private static final String LOG_PROPERTY_ERRORS = "log-property-errors";
    private static final String IGNORE_PROPERTY_ERRORS = "ignore-property-errors";
    private static final String CONNECT_TIMEOUT_SECONDS = "connect-timeout-seconds";
    private static final String SHOW_STACKTRACES = "show-stacktraces";
    protected String id;
    protected MessageBroker broker;
    protected ChannelSettings settings;
    protected SerializationContext serializationContext;
    protected TypeMarshaller typeMarshaller;
    private SecurityConstraint securityConstraint;
    private Logger log;
}
