// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HTTPEndpoint.java

package flex.messaging.endpoints;

import flex.management.runtime.messaging.endpoints.HTTPEndpointControl;
import flex.messaging.MessageBroker;
import flex.messaging.config.*;
import flex.messaging.endpoints.amf.AMFFilter;
import flex.messaging.endpoints.amf.BatchProcessFilter;
import flex.messaging.endpoints.amf.MessageBrokerFilter;
import flex.messaging.endpoints.amf.SerializationFilter;
import flex.messaging.endpoints.amf.SessionFilter;
import flex.messaging.io.amf.ActionContext;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.services.http.SettingsReplaceUtil;
import java.io.ByteArrayOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

// Referenced classes of package flex.messaging.endpoints:
//            AbstractEndpoint

public class HTTPEndpoint extends AbstractEndpoint
{

    public HTTPEndpoint(MessageBroker broker, ChannelSettings cs)
    {
        this(broker, cs, broker.isManaged());
    }

    public HTTPEndpoint(MessageBroker broker, ChannelSettings cs, boolean enableManagement)
    {
        super(broker, cs, enableManagement);
        if(isManaged())
        {
            controller = new HTTPEndpointControl(getId(), this, broker.getControl());
            controller.register();
            setControl(controller);
        }
        log = Log.getLogger("Endpoint.HTTP");
    }

    protected void properties()
    {
        super.properties();
        ConfigMap properties = settings.getProperties();
        if(properties != null)
        {
            addNoCacheHeaders = properties.getPropertyAsBoolean("add-no-cache-headers", true);
            redirectURL = properties.getPropertyAsString("redirect-url", null);
            properties.allowProperty("polling-enabled");
            properties.allowProperty("polling-interval-seconds");
        }
        validateEndpointProtocol();
    }

    protected void validateEndpointProtocol()
    {
        String uri = settings.getUri();
        if(isSecure() && !uri.startsWith("https:"))
        {
            ConfigurationException ce = new ConfigurationException();
            ce.setMessage(11100, new Object[] {
                uri, "https"
            });
            throw ce;
        }
        if(!isSecure() && !uri.startsWith("http:"))
        {
            ConfigurationException ce = new ConfigurationException();
            ce.setMessage(11100, new Object[] {
                uri, "http"
            });
            throw ce;
        } else
        {
            return;
        }
    }

    public void service(HttpServletRequest req, HttpServletResponse res)
    {
        ActionContext context;
        if(isManaged())
            controller.incrementServiceCount();
        setThreadLocals();
        context = new ActionContext();
        context.setContentType(req.getContentType());
        filterChain.invoke(context);
        if(context.getStatus() != 2)
        {
            if(addNoCacheHeaders)
                addNoCacheHeaders(req, res);
            ByteArrayOutputStream outBuffer = context.getResponseOutput();
            res.setContentType("application/xml");
            res.setContentLength(outBuffer.size());
            outBuffer.writeTo(res.getOutputStream());
            res.flushBuffer();
        } else
        if(redirectURL != null)
            try
            {
                redirectURL = SettingsReplaceUtil.replaceContextPath(redirectURL, req.getContextPath());
                res.sendRedirect(redirectURL);
            }
            catch(IllegalStateException alreadyFlushed) { }
        clearThreadLocals();
        break MISSING_BLOCK_LABEL_187;
        Throwable t;
        t;
        log.error(t.getMessage(), t);
        clearThreadLocals();
        break MISSING_BLOCK_LABEL_187;
        Exception exception;
        exception;
        clearThreadLocals();
        throw exception;
    }

    public void start()
    {
        filterChain = createFilterChain();
        if(isManaged())
            controller.setRunning(new Boolean(true));
    }

    public void stop()
    {
        super.stop();
        if(isManaged())
            controller.setRunning(new Boolean(false));
    }

    public AMFFilter createFilterChain()
    {
        AMFFilter serializationFilter = new SerializationFilter();
        AMFFilter batchFilter = new BatchProcessFilter();
        AMFFilter sessionFilter = new SessionFilter();
        AMFFilter messageBrokerFilter = new MessageBrokerFilter(this);
        serializationFilter.setNext(batchFilter);
        batchFilter.setNext(sessionFilter);
        sessionFilter.setNext(messageBrokerFilter);
        return serializationFilter;
    }

    private static final String ADD_NO_CACHE_HEADERS = "add-no-cache-headers";
    private static final String REDIRECT_URL = "redirect-url";
    private AMFFilter filterChain;
    private HTTPEndpointControl controller;
    private boolean addNoCacheHeaders;
    private String redirectURL;
    private Logger log;
}
