// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   RTMPEndpoint.java

package flex.messaging.endpoints;

import flex.management.BaseControl;
import flex.management.runtime.messaging.endpoints.RTMPEndpointControl;
import flex.messaging.*;
import flex.messaging.config.ChannelSettings;
import flex.messaging.config.ConfigurationException;
import flex.messaging.endpoints.rtmp.AbstractRTMPServer;
import flex.messaging.endpoints.rtmp.NIORTMPServer;
import flex.messaging.messages.Message;
import flex.messaging.util.Trace;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

// Referenced classes of package flex.messaging.endpoints:
//            AbstractEndpoint

public class RTMPEndpoint extends AbstractEndpoint
{

    public RTMPEndpoint(MessageBroker broker, ChannelSettings cs)
    {
        this(broker, cs, broker.isManaged());
    }

    public RTMPEndpoint(MessageBroker broker, ChannelSettings cs, boolean enableManagement)
    {
        super(broker, cs, enableManagement);
        if(isManaged())
        {
            controller = new RTMPEndpointControl(getId(), this, broker.getControl());
            controller.register();
            setControl(controller);
        }
    }

    protected void properties()
    {
        super.properties();
        flex.messaging.config.ConfigMap properties = settings.getProperties();
        if(properties != null)
        {
            String clientMax = settings.getPropertyAsString("client-to-server-maxbps", "200k");
            clientToServerBps = getBitsPerSecond(clientMax);
            String serverMax = settings.getPropertyAsString("server-to-client-maxbps", "200k");
            serverToClientsBps = getBitsPerSecond(serverMax);
        }
        validateEndpointProtocol();
        createServer();
    }

    protected void validateEndpointProtocol()
    {
        String uri = settings.getUri();
        if(isSecure() && !uri.startsWith("rtmps:"))
        {
            ConfigurationException ce = new ConfigurationException();
            ce.setMessage(11100, new Object[] {
                uri, "rtmps"
            });
            throw ce;
        }
        if(!isSecure() && !uri.startsWith("rtmp:"))
        {
            ConfigurationException ce = new ConfigurationException();
            ce.setMessage(11100, new Object[] {
                uri, "rtmp"
            });
            throw ce;
        } else
        {
            return;
        }
    }

    public boolean isSecure()
    {
        return false;
    }

    protected void createServer()
    {
        try
        {
            Class.forName("com.ibm.websphere.asynchbeans.WorkManager");
            Class websphereServerClass = Class.forName("flex.messaging.endpoints.rtmp.WebSphereNIORTMPServer");
            Constructor constructor = websphereServerClass.getConstructor(new Class[] {
                flex.messaging.config.ChannelSettings.class
            });
            rtmpServer = (AbstractRTMPServer)constructor.newInstance(new Object[] {
                settings
            });
            if(Trace.rtmp)
                Trace.trace("using the WebSphere RTMP Server");
        }
        catch(InvocationTargetException ite)
        {
            Throwable t = ite.getCause();
            if(t != null && (t instanceof MessageException))
                throw (MessageException)t;
            if(Trace.rtmp)
                Trace.trace("using the standard RTMP Server");
            rtmpServer = new NIORTMPServer(settings);
        }
        catch(Throwable t)
        {
            if(Trace.rtmp)
                Trace.trace("using the standard RTMP Server");
            rtmpServer = new NIORTMPServer(settings);
        }
    }

    public void start()
    {
        rtmpServer.setServerEndpoint(this);
        rtmpServer.setSerializationContext(serializationContext);
        rtmpServer.setTypeMarshaller(typeMarshaller);
        rtmpServer.setSecurityConstraint(getSettings().getConstraint());
        rtmpServer.startServer();
        if(isManaged())
            controller.setRunning(new Boolean(true));
    }

    public void stop()
    {
        if(rtmpServer != null)
        {
            rtmpServer.stopServer();
            if(isManaged())
            {
                controller.setRunning(new Boolean(false));
                if(rtmpServer.isManaged())
                    rtmpServer.getControl().unregister();
            }
            rtmpServer = null;
        }
    }

    public void push(Message message, MessageClient client)
    {
        if(isManaged())
            controller.incrementPushCount();
        rtmpServer.push(message, client.getClientId());
    }

    protected void checkSecurityConstraint(Message message1)
    {
    }

    private static long getBitsPerSecond(String s)
    {
        int multiplier = 1;
        int value = 200;
        if(s.endsWith("k") || s.endsWith("K"))
        {
            s = s.substring(0, s.length() - 1);
            multiplier = 1024;
        }
        try
        {
            value = Integer.parseInt(s);
        }
        catch(Exception ex)
        {
            multiplier = 1024;
        }
        return (long)(value * multiplier);
    }

    private static final String CLIENT_TO_SERVER_MAXBPS = "client-to-server-maxbps";
    private static final String SERVER_TO_CLIENT_MAXBPS = "server-to-client-maxbps";
    protected AbstractRTMPServer rtmpServer;
    private RTMPEndpointControl controller;
    private long clientToServerBps;
    private long serverToClientsBps;
}
