// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SecureRTMPEndpoint.java

package flex.messaging.endpoints;

import flex.messaging.MessageBroker;
import flex.messaging.MessageException;
import flex.messaging.config.ChannelSettings;
import flex.messaging.config.ConfigurationException;
import flex.messaging.endpoints.rtmp.BaseLegacyRTMPServer;
import flex.messaging.endpoints.rtmp.BaseNIORTMPServer;
import flex.messaging.endpoints.rtmps.LegacyRTMPSServer;
import flex.messaging.util.Trace;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

// Referenced classes of package flex.messaging.endpoints:
//            RTMPEndpoint

public class SecureRTMPEndpoint extends RTMPEndpoint
{

    public SecureRTMPEndpoint(MessageBroker broker, ChannelSettings cs)
    {
        this(broker, cs, broker.isManaged());
    }

    public SecureRTMPEndpoint(MessageBroker broker, ChannelSettings cs, boolean enableManagement)
    {
        super(broker, cs, enableManagement);
    }

    protected void createServer()
    {
        try
        {
            Class.forName("com.ibm.websphere.asynchbeans.WorkManager");
            Class secureWebsphereServerClass = Class.forName("flex.messaging.endpoints.rtmps.WebSphereLegacyRTMPSServer");
            Constructor constructor = secureWebsphereServerClass.getConstructor(new Class[] {
                flex.messaging.config.ChannelSettings.class
            });
            rtmpServer = (BaseLegacyRTMPServer)constructor.newInstance(new Object[] {
                settings
            });
            if(Trace.rtmp)
                Trace.trace("using the WebSphere Legacy RTMPS Server");
        }
        catch(InvocationTargetException ite)
        {
            Throwable t = ite.getCause();
            if(t != null && (t instanceof MessageException))
                throw (MessageException)t;
            if(System.getProperty("java.version").startsWith("1.5"))
                createNIORTMPSServer(settings);
            else
                createLegacyServer(settings);
        }
        catch(Throwable t)
        {
            if(System.getProperty("java.version").startsWith("1.5"))
                createNIORTMPSServer(settings);
            else
                createLegacyServer(settings);
        }
    }

    protected void createNIORTMPSServer(ChannelSettings settings)
    {
        try
        {
            Class.forName("javax.net.ssl.SSLEngine");
            Class secureServerClass = Class.forName("flex.messaging.endpoints.rtmps.NIORTMPSServer");
            Constructor constructor = secureServerClass.getConstructor(new Class[] {
                flex.messaging.config.ChannelSettings.class
            });
            rtmpServer = (BaseNIORTMPServer)constructor.newInstance(new Object[] {
                settings
            });
            if(Trace.rtmp)
                Trace.trace("using the standard RTMPS Server");
        }
        catch(InvocationTargetException ite)
        {
            Throwable t = ite.getCause();
            if(t != null && (t instanceof MessageException))
                throw (MessageException)t;
            ConfigurationException ce = new ConfigurationException();
            String errorMsg = null;
            if(t.getMessage() != null)
                errorMsg = t.getClass() + ":" + t.getMessage();
            else
            if(t.getCause() != null)
                if(t.getCause().getMessage() != null)
                    errorMsg = t.getCause() + ":" + t.getCause().getMessage();
                else
                    errorMsg = t.getCause().getClass().getName();
            ce.setMessage(10145, new Object[] {
                errorMsg
            });
            throw ce;
        }
        catch(Throwable t)
        {
            ConfigurationException ce = new ConfigurationException();
            ce.setMessage(10135);
            throw ce;
        }
    }

    protected void createLegacyServer(ChannelSettings settings)
    {
        if(Trace.rtmp)
            Trace.trace("using the standard Legacy RTMPS Server");
        rtmpServer = new LegacyRTMPSServer(settings);
    }

    public boolean isSecure()
    {
        return true;
    }
}
