// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   LegacyFilter.java

package flex.messaging.endpoints.amf;

import flex.messaging.MessageBroker;
import flex.messaging.endpoints.AMFEndpoint;
import flex.messaging.io.amf.*;
import flex.messaging.messages.*;
import flex.messaging.security.LoginManager;
import java.lang.reflect.Array;
import java.util.*;

// Referenced classes of package flex.messaging.endpoints.amf:
//            AMFFilter

public class LegacyFilter extends AMFFilter
{

    public LegacyFilter(AMFEndpoint endpoint)
    {
        this.endpoint = endpoint;
    }

    public void invoke(ActionContext context)
    {
        MessageBody requestBody = context.getRequestMessageBody();
        context.setLegacy(true);
        Object data = requestBody.getData();
        List newParams = null;
        if(data != null)
            if(data.getClass().isArray())
            {
                int paramLength = Array.getLength(data);
                if(paramLength == 1)
                {
                    Object obj = Array.get(data, 0);
                    if(obj != null && (obj instanceof Message))
                    {
                        context.setLegacy(false);
                        newParams = new ArrayList();
                        newParams.add(obj);
                    }
                }
                if(newParams == null)
                {
                    newParams = new ArrayList();
                    for(int i = 0; i < paramLength; i++)
                        try
                        {
                            newParams.add(Array.get(data, i));
                        }
                        catch(Throwable t) { }

                }
            } else
            if(data instanceof List)
            {
                List paramList = (List)data;
                if(paramList.size() == 1)
                {
                    Object obj = paramList.get(0);
                    if(obj != null && (obj instanceof Message))
                    {
                        context.setLegacy(false);
                        newParams = new ArrayList();
                        newParams.add(obj);
                    }
                }
                if(newParams == null)
                    newParams = (List)data;
            }
        if(newParams == null)
        {
            newParams = new ArrayList();
            newParams.add(data);
        }
        if(context.isLegacy())
            newParams = legacyRequest(context, newParams);
        requestBody.setData(newParams);
        next.invoke(context);
        if(context.isLegacy())
        {
            MessageBody responseBody = context.getResponseMessageBody();
            Object response = responseBody.getData();
            if(response instanceof ErrorMessage)
            {
                ErrorMessage error = (ErrorMessage)response;
                ASObject aso = new ASObject();
                aso.put("message", error.faultString);
                aso.put("code", error.faultCode);
                aso.put("details", error.faultDetail);
                aso.put("rootCause", error.rootCause);
                response = aso;
            } else
            if(response instanceof Message)
                response = ((Message)response).getBody();
            responseBody.setData(response);
        }
    }

    private List legacyRequest(ActionContext context, List oldParams)
    {
        List newParams = new ArrayList(1);
        Map headerMap = new HashMap();
        Object body = oldParams;
        Message message = null;
        MessageBody requestBody = context.getRequestMessageBody();
        List packetHeaders = context.getRequestMessage().getHeaders();
        packetCredentials(packetHeaders, headerMap);
        if(oldParams.size() == 1)
        {
            Object obj = oldParams.get(0);
            if(obj != null && (obj instanceof ASObject))
            {
                ASObject aso = (ASObject)obj;
                if(isEnvelope(aso))
                {
                    body = aso.get("data");
                    Object h = aso.get("headers");
                    if(h != null && (h instanceof List))
                    {
                        readEnvelopeHeaders((List)h, headerMap);
                        envelopeCredentials(headerMap);
                    }
                }
            }
        }
        message = createMessage(requestBody, body, headerMap);
        newParams.add(message);
        return newParams;
    }

    private boolean isEnvelope(ASObject aso)
    {
        String flag = null;
        Object f = aso.get("_flag");
        if(f != null && (f instanceof String))
            flag = (String)f;
        return flag != null && flag.equalsIgnoreCase("Envelope");
    }

    private RemotingMessage createMessage(MessageBody messageBody, Object body, Map headerMap)
    {
        RemotingMessage remotingMessage = new RemotingMessage();
        remotingMessage.setBody(body);
        remotingMessage.setHeaders(headerMap);
        String targetURI = messageBody.getTargetURI();
        int dotIndex = targetURI.lastIndexOf(".");
        if(dotIndex > 0)
        {
            String destination = targetURI.substring(0, dotIndex);
            remotingMessage.setDestination(destination);
        }
        if(targetURI.length() > dotIndex)
        {
            String operation = targetURI.substring(dotIndex + 1);
            remotingMessage.setOperation(operation);
        }
        return remotingMessage;
    }

    private Map readEnvelopeHeaders(List headers, Map headerMap)
    {
        int count = headers.size();
        for(int i = 0; i < count; i++)
        {
            Object obj = headers.get(i);
            if(obj == null || !(obj instanceof List))
                continue;
            List h = (List)obj;
            Object name = null;
            Object data = null;
            int numFields = h.size();
            if(numFields != 3)
                continue;
            name = h.get(0);
            if(name != null && (name instanceof String))
            {
                data = h.get(2);
                headerMap.put(name, data);
            }
        }

        return headerMap;
    }

    private void envelopeCredentials(Map headers)
    {
        Object obj = headers.get("Credentials");
        if(obj != null && (obj instanceof ASObject))
        {
            ASObject header = (ASObject)obj;
            String principal = (String)header.get("userid");
            Object credentials = header.get("password");
            endpoint.getMessageBroker().getLoginManager().login(principal, credentials.toString());
        }
        headers.remove("Credentials");
    }

    private void packetCredentials(List packetHeaders, Map headers)
    {
label0:
        {
            if(packetHeaders.size() <= 0)
                break label0;
            Iterator iter = packetHeaders.iterator();
            MessageHeader header;
            do
            {
                if(!iter.hasNext())
                    break label0;
                header = (MessageHeader)iter.next();
            } while(!header.getName().equals("Credentials"));
            Map loginInfo = (Map)header.getData();
            String principal = loginInfo.get("userid").toString();
            Object credentials = loginInfo.get("password");
            endpoint.getMessageBroker().getLoginManager().login(principal, credentials.toString());
        }
    }

    public static final String LEGACY_ENVELOPE_FLAG_KEY = "_flag";
    public static final String LEGACY_ENVELOPE_FLAG_VALUE = "Envelope";
    public static final String LEGACY_SECURITY_HEADER_NAME = "Credentials";
    public static final String LEGACY_SECURITY_PRINCIPAL = "userid";
    public static final String LEGACY_SECURITY_CREDENTIALS = "password";
    private AMFEndpoint endpoint;
}
