// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AbstractRTMPServer.java

package flex.messaging.endpoints.rtmp;

import edu.emory.mathcs.backport.java.util.concurrent.ConcurrentHashMap;
import flex.management.BaseControl;
import flex.management.Manageable;
import flex.management.runtime.messaging.endpoints.RTMPEndpointControl;
import flex.management.runtime.messaging.endpoints.rtmp.RTMPServerControl;
import flex.messaging.*;
import flex.messaging.config.*;
import flex.messaging.endpoints.RTMPEndpoint;
import flex.messaging.io.*;
import flex.messaging.io.amf.ActionContext;
import flex.messaging.io.tcchunk.TCCommand;
import flex.messaging.io.tcchunk.TCMessage;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.ErrorMessage;
import flex.messaging.messages.Message;
import flex.messaging.security.LoginManager;
import flex.messaging.security.SecurityException;
import flex.messaging.util.*;
import java.net.*;
import java.util.*;
import java.util.regex.*;

// Referenced classes of package flex.messaging.endpoints.rtmp:
//            RTMPConnection

public abstract class AbstractRTMPServer
    implements Runnable, Manageable
{
    class IPv4PatternAccessRule
        implements AccessRule
    {

        public boolean execute(InetAddress addressToTest)
        {
            byte address[] = addressToTest.getAddress();
            int n = address.length;
            int dotLimit = n - 1;
            StringBuffer buf = new StringBuffer();
            for(int i = 0; i < n; i++)
            {
                if(address[i] < 0)
                    buf.append(address[i] + 256);
                else
                    buf.append(address[i]);
                if(i < dotLimit)
                    buf.append('.');
            }

            return ipPattern.matcher(buf.toString()).matches();
        }

        public String toString()
        {
            return "[ip-pattern: '" + ipPattern.toString() + "']";
        }

        private Pattern ipPattern;

        public IPv4PatternAccessRule(String ipPatternToMatch)
            throws PatternSyntaxException
        {
            super();
            ipPattern = Pattern.compile(ipPatternToMatch);
        }
    }

    class IPv4AccessRule
        implements AccessRule
    {

        public boolean execute(InetAddress addressToTest)
        {
            byte address[] = addressToTest.getAddress();
            int n = address.length;
            if(n != ipToMatch.length)
                return false;
            for(int i = 0; i < n; i++)
            {
                if(address[i] < 0)
                {
                    if(address[i] + 256 != ipToMatch[i])
                        return false;
                    continue;
                }
                if(ipToMatch[i] != -1 && address[i] != ipToMatch[i])
                    return false;
            }

            return true;
        }

        public String toString()
        {
            return "[ip: '" + ipStringToMatch + "']";
        }

        private int ipToMatch[];
        private String ipStringToMatch;

        public IPv4AccessRule(String ipStringToMatch)
            throws UnknownHostException
        {
            super();
            String bytesAsStrings[] = ipStringToMatch.split("\\.");
            if(bytesAsStrings.length == 4)
            {
                ipToMatch = new int[4];
                int i = 0;
                do
                {
                    if(i >= 4)
                        break;
                    if(bytesAsStrings[i].equals("*"))
                    {
                        ipToMatch[i++] = -1;
                        continue;
                    }
                    int b = Integer.parseInt(bytesAsStrings[i]);
                    if(b < 0 || b > 255)
                        break;
                    ipToMatch[i++] = b;
                } while(true);
                if(i != 4)
                {
                    throw new UnknownHostException();
                } else
                {
                    this.ipStringToMatch = ipStringToMatch;
                    return;
                }
            } else
            {
                throw new UnknownHostException();
            }
        }
    }

    static interface AccessRule
    {

        public abstract boolean execute(InetAddress inetaddress);
    }


    public AbstractRTMPServer(ChannelSettings settings)
    {
        acceptBacklog = 0;
        clientTimeout = 0L;
        setServerPort(settings.getPort());
        ConfigMap properties = settings.getProperties();
        String timeoutString = properties.getPropertyAsString("idle-timeout-minutes", "0");
        setClientTimeout(Integer.parseInt(timeoutString) * 60 * 1000);
        String bindAddressString = properties.getPropertyAsString("bind-address", null);
        if(bindAddressString != null)
            processBindAddressString(bindAddressString);
        String backlogString = properties.getPropertyAsString("accept-backlog", "0");
        setAcceptBacklog(Integer.parseInt(backlogString));
        ConfigMap whitelistConfig = properties.getPropertyAsMap("whitelist", null);
        if(whitelistConfig != null)
            whitelistRules = buildAccessRules("whitelist", whitelistConfig);
        ConfigMap blacklistConfig = properties.getPropertyAsMap("blacklist", null);
        if(blacklistConfig != null)
            blacklistRules = buildAccessRules("blacklist", blacklistConfig);
        maxWorkerThreads = properties.getPropertyAsInt("max-worker-threads", 0);
        connections = new ConcurrentHashMap();
        clientIdConnectionMap = new ConcurrentHashMap();
        binaryMessageCache = new ConcurrentHashMap();
    }

    public int getAcceptBacklog()
    {
        return acceptBacklog;
    }

    protected void setAcceptBacklog(int value)
    {
        acceptBacklog = value;
    }

    public InetAddress getBindAddress()
    {
        return bindAddress;
    }

    protected void setBindAddress(InetAddress value)
    {
        bindAddress = value;
    }

    public long getClientTimeout()
    {
        return clientTimeout;
    }

    protected void setClientTimeout(long value)
    {
        clientTimeout = value;
    }

    public int getConnectionCount()
    {
        return connections.size();
    }

    public Object[] getConnectionIds()
    {
        return connections.keySet().toArray();
    }

    public BaseControl getControl()
    {
        return controller;
    }

    public void setControl(BaseControl value)
    {
        if(value instanceof RTMPServerControl)
            controller = (RTMPServerControl)value;
    }

    public boolean isManaged()
    {
        return managed;
    }

    public void setManaged(boolean value)
    {
        managed = value;
    }

    public boolean isRunning()
    {
        return running;
    }

    protected void setRunning(boolean value)
    {
        running = value;
    }

    public SerializationContext getSerializationContext()
    {
        return serializationContext;
    }

    public void setSerializationContext(SerializationContext value)
    {
        serializationContext = value;
    }

    public TypeMarshaller getTypeMarshaller()
    {
        return typeMarshaller;
    }

    public void setTypeMarshaller(TypeMarshaller marshaller)
    {
        typeMarshaller = marshaller;
    }

    private void setThreadLocals()
    {
        if(serializationContext != null)
            SerializationContext.setSerializationContext(serializationContext);
        if(typeMarshaller != null)
            TypeMarshallingContext.setTypeMarshaller(typeMarshaller);
    }

    public SecurityConstraint getSecurityConstraint()
    {
        return securityConstraint;
    }

    public void setSecurityConstraint(SecurityConstraint value)
    {
        securityConstraint = value;
    }

    public RTMPEndpoint getServerEndpoint()
    {
        return endpoint;
    }

    public void setServerEndpoint(RTMPEndpoint value)
    {
        endpoint = value;
        endpoint.getMessageBroker().initThreadLocals();
        isDebug = Log.isDebug();
        if(endpoint.isManaged())
        {
            if(isManaged())
                controller.unregister();
            controller = new RTMPServerControl(this, endpoint.getControl());
            controller.register();
            ((RTMPEndpointControl)endpoint.getControl()).setRTMPServer(controller.getObjectName());
            managed = true;
        }
    }

    public String getServerName()
    {
        return "RTMP-Server";
    }

    public int getServerPort()
    {
        return serverPort;
    }

    protected void setServerPort(int value)
    {
        serverPort = value;
    }

    protected String getWorkerName()
    {
        return "RTMP-Worker";
    }

    public boolean dispatchMessage(RTMPConnection connection, TCMessage pMsg)
    {
        boolean bHandled;
        TCCommand cmdObj;
        Integer trxID;
        Object outMessage;
        Object o;
        Message inMessage;
        boolean sessionSet;
        bHandled = false;
        byte messageType = pMsg.getMsgID();
        if(messageType != 20 && messageType != 17)
            break MISSING_BLOCK_LABEL_1044;
        cmdObj = new TCCommand(pMsg);
        setThreadLocals();
        ActionContext context = connection.getActionContext();
        cmdObj.readMessage(context);
        if(Trace.rtmp)
            Trace.trace("Got command: " + cmdObj);
        String strCommand = cmdObj.getMethodName();
        trxID = new Integer(0);
        if(cmdObj.getTrxID() != null)
            trxID = new Integer(((Number)cmdObj.getTrxID()).intValue());
        if(trxID.intValue() == 1)
        {
            boolean success = true;
            boolean loggedIn = false;
            Object cmdData = cmdObj.getCmdData();
            checkObjectEncoding(cmdData, connection);
            FlexContext.setThreadLocalObjects(connection.getFlexSession(), getServerEndpoint().getMessageBroker());
            LoginManager lm = getServerEndpoint().getMessageBroker().getLoginManager();
            if(cmdObj.getNumArgs() == 1)
            {
                flex.messaging.util.Base64.Decoder decoder = new flex.messaging.util.Base64.Decoder();
                decoder.decode((String)cmdObj.getArg(0));
                String decoded = new String(decoder.drain());
                int colon = decoded.indexOf(":");
                if(colon > 0 && colon < decoded.length() - 1)
                {
                    String username = decoded.substring(0, colon);
                    String password = decoded.substring(colon + 1);
                    try
                    {
                        lm.login(username, password);
                        loggedIn = true;
                    }
                    catch(SecurityException e)
                    {
                        Log.getLogger("Endpoint.RTMP").info("Authentication failed.");
                    }
                }
            }
            if(getSecurityConstraint() != null)
            {
                success = false;
                if(loggedIn)
                    try
                    {
                        lm.checkConstraint(getSecurityConstraint());
                        success = true;
                    }
                    catch(SecurityException e) { }
            }
            if(success)
            {
                connection.accept();
            } else
            {
                Log.getLogger("Endpoint.RTMP").info("Connection rejected due to not passing security constraint");
                connection.reject();
            }
            FlexContext.clearThreadLocalObjects();
            bHandled = true;
            break MISSING_BLOCK_LABEL_868;
        }
        if(trxID.intValue() == 0 && strCommand != null && strCommand.equalsIgnoreCase("close"))
        {
            connection.startClosing();
            bHandled = true;
            break MISSING_BLOCK_LABEL_868;
        }
        outMessage = null;
        if(cmdObj.getArg(0) == null)
            break MISSING_BLOCK_LABEL_866;
        o = cmdObj.getArg(0);
        if(o == null || (o instanceof RecoverableSerializationException))
            break MISSING_BLOCK_LABEL_764;
        inMessage = (Message)o;
        sessionSet = false;
        Object messageClientId = inMessage.getClientId();
        if(messageClientId == null)
        {
            messageClientId = UUIDUtils.createUUID(false);
            inMessage.setClientId(messageClientId);
        }
        connection.registerClientId(messageClientId);
        FlexContext.setThreadLocalObjects(connection.getFlexSession(), getServerEndpoint().getMessageBroker());
        sessionSet = true;
        outMessage = getServerEndpoint().serviceMessage(inMessage);
        if(sessionSet)
            FlexContext.clearThreadLocalObjects();
        break MISSING_BLOCK_LABEL_797;
        MessageException mxe;
        mxe;
        outMessage = mxe.createErrorMessage();
        if(((ErrorMessage)outMessage).getCorrelationId() == null)
        {
            ((ErrorMessage)outMessage).setCorrelationId(inMessage.getMessageId());
            ((ErrorMessage)outMessage).setDestination(inMessage.getDestination());
        }
        if(Log.isDebug())
        {
            Log.getLogger("Message.General").debug("Error handling rtmp message: " + mxe.toString() + StringUtils.NEWLINE + "    incomingMessage: " + inMessage + StringUtils.NEWLINE + "    errorReply: " + outMessage);
            if(mxe.getRootCause() != null)
                Log.getLogger("Message.General").debug("cause=" + mxe.getRootCause() + " type=" + mxe.getRootCause().getClass() + StringUtils.NEWLINE + ExceptionUtil.toString(mxe.getRootCause()));
        }
        if(Trace.rtmp)
        {
            Trace.trace(mxe.getMessage());
            mxe.printStackTrace();
        }
        if(sessionSet)
            FlexContext.clearThreadLocalObjects();
        break MISSING_BLOCK_LABEL_797;
        Exception exception;
        exception;
        if(sessionSet)
            FlexContext.clearThreadLocalObjects();
        throw exception;
        MessageException mxe = (MessageException)o;
        outMessage = mxe.createErrorMessage();
        if(Trace.rtmp)
        {
            Trace.trace(mxe.getMessage());
            mxe.printStackTrace();
        }
        TCCommand response = new TCCommand();
        response.setTrxID(trxID);
        if(outMessage instanceof ErrorMessage)
            response.setResponseFailure();
        else
            response.setResponseSuccess();
        response.setUserArg(outMessage);
        ActionContext context = connection.getActionContext();
        TCMessage rMsg = response.getCommandResponse(context);
        connection.send(rMsg);
        bHandled = true;
        if(!bHandled && Trace.rtmp)
        {
            Trace.trace("Unhandled command message");
            Trace.trace("method = " + cmdObj.getMethodName());
            Trace.trace("trxid = " + cmdObj.getTrxID());
            Trace.trace("cmdData = " + cmdObj.getCmdData());
            Trace.trace("numArgs = " + cmdObj.getNumArgs());
            for(int i = 0; i < cmdObj.getNumArgs(); i++)
                Trace.trace("arg[" + i + "] = " + cmdObj.getArg(i));

        }
        return true;
    }

    public void doPreStartServer()
    {
    }

    public void doPreStopServer()
    {
    }

    public void doStartServer()
    {
    }

    public void doStopServer()
    {
    }

    public void doPostStartServer()
    {
        if(isManaged())
            controller.setRunning(new Boolean(true));
    }

    public void doPostStopServer()
    {
        if(isManaged())
            controller.setRunning(new Boolean(false));
    }

    public void push(Message message, Object clientId)
    {
        boolean pushed = false;
        RTMPConnection connection;
        if((connection = (RTMPConnection)clientIdConnectionMap.get(clientId)) != null && connection.isConnected())
        {
            TCMessage binaryMessage = null;
            boolean setHeader = false;
            if(connection.getNumClientIds() > 1)
            {
                message = (Message)message.clone();
                message.setHeader("DSDstClientId", clientId);
                setHeader = true;
            }
            if(connections.size() > 40 && !setHeader)
            {
                Object o = binaryMessageCache.get(message.getMessageId());
                if(o != null)
                    binaryMessage = (TCMessage)o;
            }
            if(binaryMessage == null)
            {
                TCCommand command = new TCCommand();
                command.setMethodName("receive");
                command.setUserArg(message);
                ActionContext context = connection.getActionContext();
                context.isPush = true;
                binaryMessage = command.getCommandResponse(context);
                if(connections.size() > 40)
                {
                    if(binaryMessageCache.size() >= 15)
                        binaryMessageCache.clear();
                    binaryMessageCache.put(message.getMessageId(), binaryMessage);
                }
            }
            connection.send(binaryMessage);
            pushed = true;
        }
        if(!pushed)
        {
            if(Log.isDebug())
                Log.getLogger("Endpoint.RTMP").debug("No client with id: " + clientId + " found for message: " + message);
            throw new MessageException("RTMP Client Unknown or Unreachable");
        } else
        {
            return;
        }
    }

    public void registerClientIdForConnection(RTMPConnection conn, Object clientId)
    {
        if(clientIdConnectionMap.put(clientId, conn) != null)
            Log.getLogger("Endpoint.RTMP").warn("Duplicate client for id.");
    }

    public void removeClientIdForConnection(RTMPConnection conn, Object clientId)
    {
        if(clientIdConnectionMap.remove(clientId) != conn)
            Log.getLogger("Endpoint.RTMP").warn("Can't find clientId: " + clientId + " to remove for connection: " + conn.getId());
    }

    public void removeConnection(RTMPConnection rtmpConnection)
    {
        Object conId = rtmpConnection.getId();
        if(connections.remove(conId) == null)
            Log.getLogger("Endpoint.RTMP").error("Internal Error: unable to find connection to remove.");
    }

    public abstract void run();

    public void shutdownConnection(Object connectionId)
    {
        RTMPConnection connection = (RTMPConnection)connections.get(connectionId);
        if(connection != null)
        {
            TCCommand command = new TCCommand();
            command.setMethodName("onstatus");
            command.setInfoObj("status", "NetConnection.Connect.Closed", "Connection Force Closed");
            ActionContext context = connection.getActionContext();
            connection.sendAndClose(command.getCommandResponse(context));
        }
    }

    public final void startServer()
    {
        doPreStartServer();
        doStartServer();
        doPostStartServer();
    }

    public final void stopServer()
    {
        doPreStopServer();
        doStopServer();
        doPostStopServer();
    }

    protected boolean screenRemoteAddress(SocketAddress remoteAddress)
    {
        InetAddress address = ((InetSocketAddress)remoteAddress).getAddress();
        if(blacklistRules != null)
        {
            int n = blacklistRules.length;
            for(int i = 0; i < n; i++)
                if(blacklistRules[i].execute(address))
                    return true;

        }
        if(whitelistRules != null)
        {
            int n2 = whitelistRules.length;
            for(int i = 0; i < n2; i++)
                if(whitelistRules[i].execute(address))
                    return false;

            if(n2 > 0)
                return true;
        }
        return false;
    }

    private AccessRule[] buildAccessRules(String listName, ConfigMap config)
    {
        List ipAddresses = config.getPropertyAsList("ip-address", null);
        List ipPatterns = config.getPropertyAsList("ip-address-pattern", null);
        int count = ipAddresses == null ? 0 : ipAddresses.size();
        count += ipPatterns == null ? 0 : ipPatterns.size();
        AccessRule rules[] = new AccessRule[count];
        int i = 0;
        if(ipAddresses != null)
        {
            Iterator iter = ipAddresses.iterator();
            do
            {
                if(!iter.hasNext())
                    break;
                String ip = (String)iter.next();
                try
                {
                    IPv4AccessRule rule = new IPv4AccessRule(ip);
                    rules[i++] = rule;
                }
                catch(Exception e)
                {
                    ConfigurationException ce = new ConfigurationException();
                    if(listName.equals("whitelist"))
                        ce.setMessage(10146, new Object[] {
                            ip
                        });
                    else
                    if(listName.equals("blacklist"))
                        ce.setMessage(10147, new Object[] {
                            ip
                        });
                    throw ce;
                }
            } while(true);
        }
        if(ipPatterns != null)
        {
            Iterator iter = ipPatterns.iterator();
            do
            {
                if(!iter.hasNext())
                    break;
                String ip = (String)iter.next();
                try
                {
                    IPv4PatternAccessRule rule = new IPv4PatternAccessRule(ip);
                    rules[i++] = rule;
                }
                catch(PatternSyntaxException pse)
                {
                    ConfigurationException ce = new ConfigurationException();
                    if(listName.equals("whitelist"))
                        ce.setMessage(10146, "pattern", new Object[] {
                            ip
                        });
                    else
                    if(listName.equals("blacklist"))
                        ce.setMessage(10147, "pattern", new Object[] {
                            ip
                        });
                    ce.setRootCause(pse);
                    throw ce;
                }
            } while(true);
        }
        return rules;
    }

    private void checkObjectEncoding(Object cmdData, RTMPConnection connection)
    {
        if(cmdData != null && (cmdData instanceof Map))
        {
            Map cmdDataMap = (Map)cmdData;
            Object objectEncoding = cmdDataMap.get("objectEncoding");
            if(objectEncoding != null && (objectEncoding instanceof Number))
            {
                int encodingFormat = ((Number)objectEncoding).intValue();
                if(encodingFormat == 3)
                    connection.setDataFormat((byte)0);
            }
        }
    }

    private void processBindAddressString(String bindAddressString)
    {
        try
        {
            bindAddress = InetAddress.getByName(bindAddressString);
        }
        catch(UnknownHostException uhe)
        {
            ConfigurationException ce = new ConfigurationException();
            ce.setMessage(10144, new Object[] {
                bindAddressString
            });
            throw ce;
        }
        Enumeration interfaces = NetworkInterface.getNetworkInterfaces();
_L2:
        Enumeration addresses;
        if(!interfaces.hasMoreElements())
            break; /* Loop/switch isn't completed */
        addresses = ((NetworkInterface)interfaces.nextElement()).getInetAddresses();
        while(addresses.hasMoreElements()) 
        {
            InetAddress potential = (InetAddress)addresses.nextElement();
            if(potential.equals(bindAddress))
                return;
        }
        continue; /* Loop/switch isn't completed */
        SocketException se;
        se;
        break; /* Loop/switch isn't completed */
        if(true) goto _L2; else goto _L1
_L1:
        ConfigurationException ce = new ConfigurationException();
        ce.setMessage(10144, new Object[] {
            bindAddressString
        });
        throw ce;
    }

    protected static final String LOG_CATEGORY = "Endpoint.RTMP";
    private static final String SERVER_NAME = "RTMP-Server";
    private static final String WORKER_NAME = "RTMP-Worker";
    private static final String WHITELIST = "whitelist";
    private static final String BLACKLIST = "blacklist";
    private static final String IDLE_TIMEOUT_MINUTES = "idle-timeout-minutes";
    private static final String BIND_ADDRESS = "bind-address";
    private static final String ACCEPT_BACKLOG = "accept-backlog";
    private static final String IP_ADDRESS = "ip-address";
    private static final String IP_ADDRESS_PATTERN = "ip-address-pattern";
    private static final String MAX_WORKER_THREADS = "max-worker-threads";
    protected Map binaryMessageCache;
    protected Map connections;
    protected boolean isDebug;
    protected int maxWorkerThreads;
    private AccessRule blacklistRules[];
    private Map clientIdConnectionMap;
    private AccessRule whitelistRules[];
    private int acceptBacklog;
    private InetAddress bindAddress;
    private long clientTimeout;
    protected RTMPServerControl controller;
    private boolean managed;
    private boolean running;
    private SerializationContext serializationContext;
    private TypeMarshaller typeMarshaller;
    private SecurityConstraint securityConstraint;
    private RTMPEndpoint endpoint;
    private int serverPort;
}
