// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   BaseLegacyRTMPServer.java

package flex.messaging.endpoints.rtmp;

import flex.messaging.MessageBroker;
import flex.messaging.config.ChannelSettings;
import flex.messaging.endpoints.RTMPEndpoint;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import java.io.IOException;
import java.net.*;
import java.util.Map;

// Referenced classes of package flex.messaging.endpoints.rtmp:
//            AbstractRTMPServer, RTMPException, LegacyRTMPConnection

public abstract class BaseLegacyRTMPServer extends AbstractRTMPServer
{

    public BaseLegacyRTMPServer(ChannelSettings settings)
    {
        super(settings);
    }

    public void doStopServer()
    {
        super.doStopServer();
        setRunning(false);
    }

    public abstract void executeThread(Runnable runnable);

    public void removeConnection(LegacyRTMPConnection rtmpConnection)
    {
        Object conId = rtmpConnection.getId();
        if(connections.remove(conId) == null)
            Log.getLogger("Endpoint.RTMP").error("Internal Error: unable to find connection to remove.");
    }

    public void run()
    {
        getServerEndpoint().getMessageBroker().initThreadLocals();
        acceptSocket = buildAcceptSocket();
        Log.getLogger("Endpoint.RTMP").info(getServerName() + " listening on port:" + getServerPort());
_L2:
        if(!isRunning())
            break; /* Loop/switch isn't completed */
        Socket clientSocket = null;
        try
        {
            clientSocket = acceptSocket.accept();
        }
        catch(IOException ioe)
        {
            if(isRunning())
            {
                stopServer();
                RTMPException re = new RTMPException();
                re.setMessage(10851, new Object[] {
                    ioe.getMessage()
                });
                re.setRootCause(ioe);
                throw re;
            }
            break; /* Loop/switch isn't completed */
        }
        IOException ioe;
        if(screenRemoteAddress(clientSocket.getRemoteSocketAddress()))
        {
            if(Log.isInfo())
                Log.getLogger("Endpoint.RTMP").info(getServerName() + " blocked access from client with remote address: " + clientSocket.getRemoteSocketAddress());
            clientSocket.close();
            continue; /* Loop/switch isn't completed */
        }
        try
        {
            LegacyRTMPConnection connection = new LegacyRTMPConnection(this, clientSocket, getClientTimeout());
            connection.setDebug(isDebug);
            connections.put(connection.getId(), connection);
            scheduleTimeout(connection);
            executeThread(connection);
        }
        catch(SocketException se)
        {
            Log.getLogger("Endpoint.RTMP").info(getServerName() + " socket for accepting client connections closed.");
        }
        // Misplaced declaration of an exception variable
        catch(IOException ioe)
        {
            Log.getLogger("Endpoint.RTMP").debug(getServerName() + ": Client closed connection before it was fully established.");
        }
        if(true) goto _L2; else goto _L1
        ioe;
        Log.getLogger("Endpoint.RTMP").error(getServerName() + " failed to start up: " + ioe.toString());
        RTMPException re = new RTMPException();
        re.setMessage(10850, new Object[] {
            ioe.getMessage()
        });
        re.setRootCause(ioe);
        throw re;
_L1:
    }

    public abstract void scheduleTimeout(LegacyRTMPConnection legacyrtmpconnection);

    protected ServerSocket buildAcceptSocket()
        throws IOException
    {
        return new ServerSocket(getServerPort(), getAcceptBacklog(), getBindAddress());
    }

    protected ServerSocket acceptSocket;
}
