// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   BaseNIORTMPServer.java

package flex.messaging.endpoints.rtmp;

import edu.emory.mathcs.backport.java.util.Queue;
import edu.emory.mathcs.backport.java.util.concurrent.ConcurrentLinkedQueue;
import flex.messaging.MessageBroker;
import flex.messaging.config.ChannelSettings;
import flex.messaging.endpoints.RTMPEndpoint;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import java.io.IOException;
import java.net.*;
import java.nio.channels.*;
import java.util.*;

// Referenced classes of package flex.messaging.endpoints.rtmp:
//            AbstractRTMPServer, NIORTMPConnection, RTMPException, ChannelIO

public abstract class BaseNIORTMPServer extends AbstractRTMPServer
{
    static class UpdatedInterestOps
    {

        public static final String AND = "&";
        public static final String OR = "|";
        public SelectionKey key;
        public int ops;
        public boolean overwrite;
        public String bitwiseOp;

        public UpdatedInterestOps(SelectionKey key, int ops, boolean overwrite, String bitwiseOp)
        {
            this.key = key;
            this.ops = ops;
            this.overwrite = overwrite;
            this.bitwiseOp = bitwiseOp;
        }
    }


    public BaseNIORTMPServer(ChannelSettings settings)
    {
        super(settings);
        interestOpUpdates = new ConcurrentLinkedQueue();
    }

    public void doStopServer()
    {
        setRunning(false);
        if(rtmpSelector != null)
            rtmpSelector.wakeup();
        while(connections.size() > 0) 
        {
            Iterator iter = connections.keySet().iterator();
            while(iter.hasNext()) 
            {
                NIORTMPConnection conn = (NIORTMPConnection)connections.remove(iter.next());
                if(conn != null && !conn.isClosing())
                    conn.close();
            }
        }
        try
        {
            if(rtmpSelector != null)
                rtmpSelector.close();
        }
        catch(IOException ioException)
        {
            Log.getLogger("Endpoint.RTMP").warn(getServerName() + " failed to close NIO selector: " + ioException.toString());
        }
        try
        {
            if(serverSocketChannel != null)
                serverSocketChannel.close();
        }
        catch(IOException ioException)
        {
            Log.getLogger("Endpoint.RTMP").warn(getServerName() + " failed to close server socket: " + ioException.toString());
        }
    }

    public abstract void executeThread(Runnable runnable);

    public void run()
    {
        getServerEndpoint().getMessageBroker().initThreadLocals();
        rtmpSelector = Selector.open();
        serverSocketChannel = ServerSocketChannel.open();
        serverSocketChannel.configureBlocking(false);
        InetSocketAddress address = null;
        if(getBindAddress() != null)
            address = new InetSocketAddress(getBindAddress(), getServerPort());
        else
            address = new InetSocketAddress(getServerPort());
        if(getAcceptBacklog() > 0)
            serverSocketChannel.socket().bind(address, getAcceptBacklog());
        else
            serverSocketChannel.socket().bind(address);
        serverSocketChannel.register(rtmpSelector, 16);
        Log.getLogger("Endpoint.RTMP").info(getServerName() + " listening on port:" + getServerPort());
_L4:
        Iterator readyIterator;
        do
        {
            if(!isRunning())
                break MISSING_BLOCK_LABEL_858;
            int n = interestOpUpdates.size();
            do
            {
                if(n-- <= 0)
                    break;
                UpdatedInterestOps update = (UpdatedInterestOps)interestOpUpdates.poll();
                if(update != null && update.key != null && update.key.isValid())
                    try
                    {
                        if(update.overwrite)
                            update.key.interestOps(update.ops);
                        else
                        if(update.bitwiseOp == "|")
                            update.key.interestOps(update.key.interestOps() | update.ops);
                        else
                        if(update.bitwiseOp == "&")
                            update.key.interestOps(update.key.interestOps() & update.ops);
                    }
                    catch(CancelledKeyException cke) { }
            } while(true);
        } while(rtmpSelector.select() <= 0);
        readyIterator = rtmpSelector.selectedKeys().iterator();
        do
        {
            if(!readyIterator.hasNext())
                break;
            try
            {
                SelectionKey key = (SelectionKey)readyIterator.next();
                if(key.isWritable())
                {
                    readyIterator.remove();
                    SocketChannel channel = (SocketChannel)key.channel();
                    NIORTMPConnection connection = (NIORTMPConnection)key.attachment();
                    if(connection.isClosing() || !channel.isConnected())
                    {
                        connection.close();
                    } else
                    {
                        connection.unscheduleWrite();
                        executeThread(connection.getWriter());
                    }
                }
            }
            catch(CancelledKeyException exc) { }
        } while(true);
        readyIterator = rtmpSelector.selectedKeys().iterator();
        do
        {
            if(!readyIterator.hasNext())
                break;
            try
            {
                SelectionKey key = (SelectionKey)readyIterator.next();
                if(key.isReadable())
                {
                    readyIterator.remove();
                    SocketChannel channel = (SocketChannel)key.channel();
                    NIORTMPConnection connection = (NIORTMPConnection)key.attachment();
                    if(connection.isClosing() || !channel.isConnected())
                    {
                        connection.close();
                    } else
                    {
                        connection.unscheduleRead();
                        executeThread(connection.getReader());
                    }
                }
            }
            catch(CancelledKeyException exc) { }
        } while(true);
        readyIterator = rtmpSelector.selectedKeys().iterator();
_L2:
        if(!readyIterator.hasNext())
            break; /* Loop/switch isn't completed */
        SocketChannel socketChannel;
        SelectionKey key = (SelectionKey)readyIterator.next();
        if(!key.isAcceptable())
            continue; /* Loop/switch isn't completed */
        readyIterator.remove();
        ServerSocketChannel server = (ServerSocketChannel)key.channel();
        socketChannel = server.accept();
        if(screenRemoteAddress(socketChannel.socket().getRemoteSocketAddress()))
        {
            if(Log.isInfo())
                Log.getLogger("Endpoint.RTMP").info(getServerName() + " blocked access from client with remote address: " + socketChannel.socket().getRemoteSocketAddress());
            socketChannel.close();
            continue; /* Loop/switch isn't completed */
        }
        try
        {
            if(socketChannel != null)
            {
                ChannelIO channelIO = buildChannelIO(socketChannel);
                SelectionKey socketKey = socketChannel.register(rtmpSelector, 1);
                NIORTMPConnection connection = new NIORTMPConnection(this, socketKey, getClientTimeout());
                connection.connect(channelIO);
                connection.setDebug(isDebug);
                connections.put(connection.getId(), connection);
                socketKey.attach(connection);
                scheduleTimeout(connection);
            }
        }
        catch(CancelledKeyException exc) { }
        if(true) goto _L2; else goto _L1
_L1:
        if(true) goto _L4; else goto _L3
_L3:
        ClosedSelectorException closedSelectorException;
        closedSelectorException;
        break MISSING_BLOCK_LABEL_858;
        IOException ioe;
        ioe;
        Log.getLogger("Endpoint.RTMP").error(getServerName() + " failed to start up: " + ioe.toString());
        RTMPException re = new RTMPException();
        re.setMessage(10850, new Object[] {
            ioe.getMessage()
        });
        re.setRootCause(ioe);
        throw re;
    }

    public abstract void scheduleTimeout(NIORTMPConnection niortmpconnection);

    public void updateInterestOps(SelectionKey key, int ops, boolean overwrite, String bitwiseOp)
    {
        UpdatedInterestOps update = new UpdatedInterestOps(key, ops, overwrite, bitwiseOp);
        interestOpUpdates.add(update);
    }

    protected ChannelIO buildChannelIO(SocketChannel socketChannel)
        throws IOException
    {
        return ChannelIO.getInstance(socketChannel);
    }

    private Queue interestOpUpdates;
    private Selector rtmpSelector;
    private ServerSocketChannel serverSocketChannel;
}
