// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   LegacyRTMPServer.java

package flex.messaging.endpoints.rtmp;

import edu.emory.mathcs.backport.java.util.concurrent.*;
import flex.messaging.config.ChannelSettings;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.util.TimeoutManager;
import java.io.IOException;
import java.net.ServerSocket;
import java.util.*;

// Referenced classes of package flex.messaging.endpoints.rtmp:
//            BaseLegacyRTMPServer, RTMPConnection, LegacyRTMPConnection

public class LegacyRTMPServer extends BaseLegacyRTMPServer
{
    class RTMPWorkerFactory
        implements ThreadFactory
    {

        public Thread newThread(Runnable worker)
        {
            Thread t = new Thread(worker);
            t.setDaemon(true);
            t.setName(getWorkerName() + "-" + LegacyRTMPServer.workerCount++);
            if(Log.isDebug())
                Log.getLogger("Endpoint.RTMP").debug("Created worker thread: " + t.getName());
            return t;
        }

        RTMPWorkerFactory()
        {
            super();
        }
    }


    public LegacyRTMPServer(ChannelSettings settings)
    {
        super(settings);
        ThreadFactory workerFactory = new RTMPWorkerFactory();
        timeoutManager = new TimeoutManager(workerFactory);
        if(maxWorkerThreads > 0)
            workerPool = Executors.newFixedThreadPool(maxWorkerThreads, workerFactory);
        else
            workerPool = Executors.newCachedThreadPool(workerFactory);
    }

    public String getServerName()
    {
        return "Legacy-RTMP-Server";
    }

    protected String getWorkerName()
    {
        return "Legacy-RTMP-Worker";
    }

    public void doStartServer()
    {
        super.doStartServer();
        Thread t = new Thread(this);
        t.setName(getServerName());
        t.setDaemon(true);
        setRunning(true);
        t.start();
    }

    public void doStopServer()
    {
        super.doStopServer();
        setRunning(false);
        try
        {
            ServerSocket socket = acceptSocket;
            acceptSocket = null;
            if(socket != null)
                socket.close();
        }
        catch(IOException ioe) { }
        while(connections.size() > 0) 
        {
            Iterator iter = connections.keySet().iterator();
            while(iter.hasNext()) 
            {
                RTMPConnection conn = (RTMPConnection)connections.remove(iter.next());
                if(conn != null && !conn.isClosing())
                    conn.close();
            }
        }
    }

    public void executeThread(Runnable r)
    {
        workerPool.execute(r);
    }

    public void scheduleTimeout(LegacyRTMPConnection connection)
    {
        timeoutManager.scheduleTimeout(connection);
    }

    private static final String SERVER_NAME = "Legacy-RTMP-Server";
    private static final String WORKER_NAME = "Legacy-RTMP-Worker";
    private TimeoutManager timeoutManager;
    private ExecutorService workerPool;
    static int workerCount = 0;

}
