// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   NIORTMPServer.java

package flex.messaging.endpoints.rtmp;

import edu.emory.mathcs.backport.java.util.concurrent.*;
import flex.messaging.config.ChannelSettings;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.util.TimeoutManager;

// Referenced classes of package flex.messaging.endpoints.rtmp:
//            BaseNIORTMPServer, NIORTMPConnection

public class NIORTMPServer extends BaseNIORTMPServer
{
    class RTMPWorkerFactory
        implements ThreadFactory
    {

        public Thread newThread(Runnable worker)
        {
            Thread t = new Thread(worker);
            t.setDaemon(true);
            t.setName(getWorkerName() + "-" + NIORTMPServer.workerCount++);
            if(Log.isDebug())
                Log.getLogger("Endpoint.RTMP").debug("Created worker thread: " + t.getName());
            return t;
        }

        RTMPWorkerFactory()
        {
            super();
        }
    }


    public NIORTMPServer(ChannelSettings settings)
    {
        super(settings);
        ThreadFactory tf = new RTMPWorkerFactory();
        if(maxWorkerThreads > 0)
            workerPool = Executors.newFixedThreadPool(maxWorkerThreads, tf);
        else
            workerPool = Executors.newCachedThreadPool(tf);
        timeoutManager = new TimeoutManager(tf);
    }

    public void doStartServer()
    {
        super.doStartServer();
        Thread t = new Thread(this);
        t.setName(getServerName());
        t.setDaemon(true);
        setRunning(true);
        t.start();
    }

    public void doStopServer()
    {
        super.doStopServer();
        try
        {
            workerPool.shutdown();
            timeoutManager.shutdown();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public void executeThread(Runnable r)
    {
        workerPool.execute(r);
    }

    public void scheduleTimeout(NIORTMPConnection connection)
    {
        timeoutManager.scheduleTimeout(connection);
    }

    private TimeoutManager timeoutManager;
    private ExecutorService workerPool;
    static int workerCount = 0;

}
