// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ChannelIOSecure.java

package flex.messaging.endpoints.rtmps;

import flex.messaging.endpoints.rtmp.ChannelIO;
import flex.messaging.endpoints.rtmp.RTMPActionRequest;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.SocketChannel;
import javax.net.ssl.*;

public class ChannelIOSecure extends ChannelIO
{

    protected ChannelIOSecure(SocketChannel sc, SSLContext sslc)
        throws IOException
    {
        super(sc);
        shutdown = false;
        sslEngine = sslc.createSSLEngine();
        sslEngine.setUseClientMode(false);
        initialHSStatus = javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_UNWRAP;
        initialHSComplete = false;
        netBBSize = sslEngine.getSession().getPacketBufferSize();
        inNetBB = ByteBuffer.allocate(netBBSize);
        outNetBB = ByteBuffer.allocate(netBBSize);
        outNetBB.position(0);
        outNetBB.limit(0);
    }

    public static ChannelIOSecure getInstance(SocketChannel sc, SSLContext sslc)
        throws IOException
    {
        ChannelIOSecure cio = new ChannelIOSecure(sc, sslc);
        cio.appBBSize = cio.sslEngine.getSession().getApplicationBufferSize();
        cio.requestBB = ByteBuffer.allocate(cio.appBBSize);
        return cio;
    }

    protected void resizeRequestBB()
    {
        resizeRequestBB(appBBSize);
    }

    private boolean tryFlush(ByteBuffer bb)
        throws IOException
    {
        super.write(bb);
        return !bb.hasRemaining();
    }

    public synchronized boolean doHandshake(SelectionKey sk, RTMPActionRequest actionRequest)
        throws IOException
    {
        if(initialHSComplete)
            return initialHSComplete;
        if(outNetBB.hasRemaining())
        {
            if(!tryFlush(outNetBB))
                return false;
            if(initialHSStatus == javax.net.ssl.SSLEngineResult.HandshakeStatus.FINISHED)
                initialHSComplete = true;
            return initialHSComplete;
        }
        static class _cls1
        {

            static final int $SwitchMap$javax$net$ssl$SSLEngineResult$HandshakeStatus[];
            static final int $SwitchMap$javax$net$ssl$SSLEngineResult$Status[];

            static 
            {
                $SwitchMap$javax$net$ssl$SSLEngineResult$Status = new int[javax.net.ssl.SSLEngineResult.Status.values().length];
                try
                {
                    $SwitchMap$javax$net$ssl$SSLEngineResult$Status[javax.net.ssl.SSLEngineResult.Status.OK.ordinal()] = 1;
                }
                catch(NoSuchFieldError ex) { }
                try
                {
                    $SwitchMap$javax$net$ssl$SSLEngineResult$Status[javax.net.ssl.SSLEngineResult.Status.BUFFER_UNDERFLOW.ordinal()] = 2;
                }
                catch(NoSuchFieldError ex) { }
                $SwitchMap$javax$net$ssl$SSLEngineResult$HandshakeStatus = new int[javax.net.ssl.SSLEngineResult.HandshakeStatus.values().length];
                try
                {
                    $SwitchMap$javax$net$ssl$SSLEngineResult$HandshakeStatus[javax.net.ssl.SSLEngineResult.HandshakeStatus.NOT_HANDSHAKING.ordinal()] = 1;
                }
                catch(NoSuchFieldError ex) { }
                try
                {
                    $SwitchMap$javax$net$ssl$SSLEngineResult$HandshakeStatus[javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_TASK.ordinal()] = 2;
                }
                catch(NoSuchFieldError ex) { }
                try
                {
                    $SwitchMap$javax$net$ssl$SSLEngineResult$HandshakeStatus[javax.net.ssl.SSLEngineResult.HandshakeStatus.FINISHED.ordinal()] = 3;
                }
                catch(NoSuchFieldError ex) { }
                try
                {
                    $SwitchMap$javax$net$ssl$SSLEngineResult$HandshakeStatus[javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_UNWRAP.ordinal()] = 4;
                }
                catch(NoSuchFieldError ex) { }
                try
                {
                    $SwitchMap$javax$net$ssl$SSLEngineResult$HandshakeStatus[javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_WRAP.ordinal()] = 5;
                }
                catch(NoSuchFieldError ex) { }
            }
        }

        switch(_cls1..SwitchMap.javax.net.ssl.SSLEngineResult.HandshakeStatus[initialHSStatus.ordinal()])
        {
        case 4: // '\004'
            if(sc.read(inNetBB) == -1)
            {
                sslEngine.closeInbound();
                return initialHSComplete;
            }
            do
            {
                if(initialHSStatus != javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_UNWRAP)
                    break;
                inNetBB.flip();
                SSLEngineResult result = sslEngine.unwrap(inNetBB, requestBB);
                inNetBB.compact();
                initialHSStatus = result.getHandshakeStatus();
                switch(_cls1..SwitchMap.javax.net.ssl.SSLEngineResult.Status[result.getStatus().ordinal()])
                {
                case 1: // '\001'
                    switch(_cls1..SwitchMap.javax.net.ssl.SSLEngineResult.HandshakeStatus[initialHSStatus.ordinal()])
                    {
                    default:
                        continue;

                    case 1: // '\001'
                        throw new IOException("Not handshaking during initial handshake");

                    case 2: // '\002'
                        initialHSStatus = doTasks();
                        continue;

                    case 3: // '\003'
                        initialHSComplete = true;
                        break;
                    }
                    break;

                case 2: // '\002'
                    break;

                default:
                    throw new IOException((new StringBuilder()).append("Received ").append(result.getStatus()).append(" during initial handshaking").toString());
                }
                break;
            } while(true);
            if(initialHSStatus != javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_WRAP)
                break;
            // fall through

        case 5: // '\005'
            outNetBB.clear();
            SSLEngineResult result = sslEngine.wrap(hsBB, outNetBB);
            outNetBB.flip();
            initialHSStatus = result.getHandshakeStatus();
            switch(_cls1..SwitchMap.javax.net.ssl.SSLEngineResult.Status[result.getStatus().ordinal()])
            {
            case 1: // '\001'
                if(initialHSStatus == javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_TASK)
                    initialHSStatus = doTasks();
                actionRequest.shouldScheduleWrite = true;
                break;

            default:
                throw new IOException((new StringBuilder()).append("Received ").append(result.getStatus()).append(" during initial handshaking").toString());
            }
            break;

        default:
            throw new RuntimeException((new StringBuilder()).append("Invalid Handshaking State ").append(initialHSStatus).toString());
        }
        return initialHSComplete;
    }

    public synchronized boolean isHandshakeComplete()
    {
        return initialHSComplete;
    }

    private javax.net.ssl.SSLEngineResult.HandshakeStatus doTasks()
    {
        Runnable runnable;
        while((runnable = sslEngine.getDelegatedTask()) != null) 
            runnable.run();
        return sslEngine.getHandshakeStatus();
    }

    public synchronized int read()
        throws IOException
    {
        if(!initialHSComplete)
            throw new IllegalStateException();
        int pos = requestBB.position();
        if(sc.read(inNetBB) == -1)
        {
            sslEngine.closeInbound();
            return -1;
        }
        SSLEngineResult result;
        do
        {
            resizeRequestBB();
            inNetBB.flip();
            result = sslEngine.unwrap(inNetBB, requestBB);
            inNetBB.compact();
            switch(_cls1..SwitchMap.javax.net.ssl.SSLEngineResult.Status[result.getStatus().ordinal()])
            {
            case 1: // '\001'
            case 2: // '\002'
                if(result.getHandshakeStatus() == javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_TASK)
                    doTasks();
                break;

            default:
                throw new IOException((new StringBuilder()).append("sslEngine error during data read: ").append(result.getStatus()).toString());
            }
        } while(inNetBB.position() != 0 && result.getStatus() != javax.net.ssl.SSLEngineResult.Status.BUFFER_UNDERFLOW);
        return requestBB.position() - pos;
    }

    public synchronized int write(ByteBuffer src)
        throws IOException
    {
        if(!initialHSComplete)
            throw new IllegalStateException();
        else
            return doWrite(src);
    }

    private int doWrite(ByteBuffer src)
        throws IOException
    {
        int retValue = 0;
        if(outNetBB.hasRemaining() && !tryFlush(outNetBB))
            return retValue;
        outNetBB.clear();
        SSLEngineResult result = sslEngine.wrap(src, outNetBB);
        retValue = result.bytesConsumed();
        outNetBB.flip();
        switch(_cls1..SwitchMap.javax.net.ssl.SSLEngineResult.Status[result.getStatus().ordinal()])
        {
        case 1: // '\001'
            if(result.getHandshakeStatus() == javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_TASK)
                doTasks();
            break;

        default:
            throw new IOException((new StringBuilder()).append("sslEngine error during data write: ").append(result.getStatus()).toString());
        }
        if(outNetBB.hasRemaining())
            tryFlush(outNetBB);
        return retValue;
    }

    public synchronized boolean shutdown()
        throws IOException
    {
        if(!shutdown)
        {
            sslEngine.closeOutbound();
            shutdown = true;
        }
        if(outNetBB.hasRemaining() && tryFlush(outNetBB))
            return false;
        outNetBB.clear();
        SSLEngineResult result = sslEngine.wrap(hsBB, outNetBB);
        if(result.getStatus() != javax.net.ssl.SSLEngineResult.Status.CLOSED)
            throw new SSLException("Improper close state");
        outNetBB.flip();
        if(outNetBB.hasRemaining())
            tryFlush(outNetBB);
        return !outNetBB.hasRemaining() && result.getHandshakeStatus() != javax.net.ssl.SSLEngineResult.HandshakeStatus.NEED_WRAP;
    }

    private SSLEngine sslEngine;
    private int appBBSize;
    private int netBBSize;
    private ByteBuffer inNetBB;
    private ByteBuffer outNetBB;
    private static ByteBuffer hsBB = ByteBuffer.allocate(0);
    private javax.net.ssl.SSLEngineResult.HandshakeStatus initialHSStatus;
    private boolean initialHSComplete;
    private boolean shutdown;

}
