// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SSLContextBuilder.java

package flex.messaging.endpoints.rtmps;

import flex.messaging.FlexContext;
import flex.messaging.config.ChannelSettings;
import flex.messaging.config.ConfigMap;
import flex.messaging.services.http.SettingsReplaceUtil;
import java.io.*;
import java.security.*;
import java.security.cert.CertificateException;
import javax.net.ssl.*;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;

// Referenced classes of package flex.messaging.endpoints.rtmps:
//            RTMPSException

public class SSLContextBuilder
{

    public SSLContextBuilder()
    {
    }

    public static SSLContext buildSSLContext(ChannelSettings settings)
    {
        ConfigMap properties = settings.getProperties();
        String keystoreFile = properties.getPropertyAsString("keystore-file", null);
        if(keystoreFile != null)
        {
            keystoreFile = getRealPath(keystoreFile);
        } else
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10761);
            throw ce;
        }
        char password[] = properties.getPropertyAsString("keystore-password", "").toCharArray();
        if(password.length == 0)
        {
            String keystorePasswordFile = properties.getPropertyAsString("keystore-password-file", null);
            if(keystorePasswordFile != null)
            {
                keystorePasswordFile = getRealPath(keystorePasswordFile);
                try
                {
                    BufferedReader reader = new BufferedReader(new FileReader(keystorePasswordFile));
                    password = reader.readLine().toCharArray();
                }
                catch(FileNotFoundException fnfe)
                {
                    RTMPSException ce = new RTMPSException();
                    ce.setMessage(10759, new Object[] {
                        keystorePasswordFile
                    });
                    ce.setRootCause(fnfe);
                    throw ce;
                }
                catch(IOException ioe)
                {
                    RTMPSException ce = new RTMPSException();
                    ce.setMessage(10760, new Object[] {
                        keystorePasswordFile
                    });
                    ce.setRootCause(ioe);
                    throw ce;
                }
            } else
            {
                RTMPSException ce = new RTMPSException();
                ce.setMessage(10762);
                throw ce;
            }
        }
        String keystoreType = properties.getPropertyAsString("keystore-type", "JKS");
        KeyStore ks;
        try
        {
            ks = KeyStore.getInstance(keystoreType);
        }
        catch(KeyStoreException kse)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10750, new Object[] {
                keystoreType
            });
            ce.setRootCause(kse);
            throw ce;
        }
        try
        {
            ks.load(new FileInputStream(keystoreFile), password);
        }
        catch(IOException ioe)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10751);
            ce.setRootCause(ioe);
            throw ce;
        }
        catch(NoSuchAlgorithmException nsae)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10752);
            ce.setRootCause(nsae);
            throw ce;
        }
        catch(CertificateException ce)
        {
            RTMPSException cex = new RTMPSException();
            cex.setMessage(10753);
            cex.setRootCause(ce);
            throw cex;
        }
        String algorithm = properties.getPropertyAsString("algorithm", "DEFAULT");
        KeyManagerFactory kmf;
        try
        {
            if(algorithm.equalsIgnoreCase("DEFAULT"))
                kmf = KeyManagerFactory.getInstance(KeyManagerFactory.getDefaultAlgorithm());
            else
                kmf = KeyManagerFactory.getInstance(algorithm);
        }
        catch(NoSuchAlgorithmException nsae)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10754, new Object[] {
                algorithm
            });
            ce.setRootCause(nsae);
            throw ce;
        }
        try
        {
            kmf.init(ks, password);
        }
        catch(UnrecoverableKeyException uke)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10755);
            ce.setRootCause(uke);
            throw ce;
        }
        catch(NoSuchAlgorithmException nsae)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10754, new Object[] {
                algorithm
            });
            ce.setRootCause(nsae);
            throw ce;
        }
        catch(KeyStoreException kse)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10756, new Object[] {
                algorithm
            });
            ce.setRootCause(kse);
            throw ce;
        }
        TrustManagerFactory tmf;
        try
        {
            if(algorithm.equalsIgnoreCase("DEFAULT"))
                tmf = TrustManagerFactory.getInstance(TrustManagerFactory.getDefaultAlgorithm());
            else
                tmf = TrustManagerFactory.getInstance(algorithm);
        }
        catch(NoSuchAlgorithmException nsae)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10754, new Object[] {
                algorithm
            });
            ce.setRootCause(nsae);
            throw ce;
        }
        try
        {
            tmf.init(ks);
        }
        catch(KeyStoreException kse)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10757);
            ce.setRootCause(kse);
            throw ce;
        }
        String protocol = properties.getPropertyAsString("protocol", "TLS");
        SSLContext sslContext = null;
        try
        {
            sslContext = SSLContext.getInstance(protocol);
        }
        catch(NoSuchAlgorithmException nsae)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10758, new Object[] {
                protocol
            });
            ce.setRootCause(nsae);
            throw ce;
        }
        try
        {
            sslContext.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);
        }
        catch(KeyManagementException kme)
        {
            RTMPSException ce = new RTMPSException();
            ce.setMessage(10758, new Object[] {
                protocol
            });
            ce.setRootCause(kme);
            throw ce;
        }
        return sslContext;
    }

    public static String getRealPath(String path)
    {
        int tokenIndex = path.indexOf("{context");
        if(tokenIndex != -1)
        {
            path = SettingsReplaceUtil.replaceContextPath(path, "");
            return FlexContext.getServletConfig().getServletContext().getRealPath(path);
        } else
        {
            return path;
        }
    }

    public static final String KEYSTORE_TYPE = "keystore-type";
    public static final String KEYSTORE_FILE = "keystore-file";
    public static final String KEYSTORE_PASSWORD = "keystore-password";
    public static final String KEYSTORE_PASSWORD_FILE = "keystore-password-file";
    public static final String ALGORITHM = "algorithm";
    public static final String PROTOCOL = "protocol";
    public static final String DEFAULT_ALGORITHM = "DEFAULT";
}
