// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JavaFactory.java

package flex.messaging.factories;

import flex.messaging.*;
import flex.messaging.config.ConfigMap;
import flex.messaging.config.ConfigurationException;
import flex.messaging.services.ServiceException;
import flex.messaging.util.ClassUtil;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;

public class JavaFactory
    implements FlexFactory
{
    static class JavaFactoryInstance extends FactoryInstance
    {

        public void setAttributeId(String attributeId)
        {
            this.attributeId = attributeId;
        }

        public String getAttributeId()
        {
            return attributeId;
        }

        public void operationComplete(Object instance)
        {
            if(getScope().equals("session"))
            {
                FlexSession session = FlexContext.getFlexSession();
                if(session != null && session.isValid())
                    session.setAttribute(getAttributeId(), instance);
            }
        }

        public String toString()
        {
            return "JavaFactory instance for id=" + getId() + " source=" + getSource() + " scope=" + getScope();
        }

        public Class getInstanceClass()
        {
            if(javaClass == null)
                javaClass = ClassUtil.createClass(getSource());
            return javaClass;
        }

        Object createInstance()
        {
            Object inst = ClassUtil.createDefaultInstance(getInstanceClass(), null);
            if(inst instanceof FlexConfigurable)
                ((FlexConfigurable)inst).initialize(getId(), getProperties());
            return inst;
        }

        Object applicationInstance;
        Class javaClass;
        String attributeId;

        JavaFactoryInstance(JavaFactory factory, String id, ConfigMap properties)
        {
            super(factory, id, properties);
            applicationInstance = null;
            javaClass = null;
        }
    }


    public JavaFactory()
    {
    }

    public void initialize(String s, ConfigMap configmap)
    {
    }

    public FactoryInstance createFactoryInstance(String id, ConfigMap properties)
    {
        JavaFactoryInstance instance = new JavaFactoryInstance(this, id, properties);
        instance.setSource(properties.getPropertyAsString("source", instance.getId()));
        instance.setScope(properties.getPropertyAsString("scope", "request"));
        instance.setAttributeId(properties.getPropertyAsString("attribute-id", id));
        if(instance.getScope().equals("application"))
            try
            {
                ServletContext ctx = FlexContext.getServletConfig().getServletContext();
                synchronized(ctx)
                {
                    Object inst = ctx.getAttribute(instance.getAttributeId());
                    if(inst == null)
                    {
                        inst = instance.createInstance();
                        ctx.setAttribute(instance.getAttributeId(), inst);
                    } else
                    {
                        Class configuredClass = instance.getInstanceClass();
                        Class instClass = inst.getClass();
                        if(configuredClass != instClass && !configuredClass.isAssignableFrom(instClass))
                        {
                            ServiceException e = new ServiceException();
                            e.setMessage(10654, new Object[] {
                                instance.getAttributeId(), "application", instance.getId(), instance.getInstanceClass(), inst.getClass()
                            });
                            e.setCode("Server.Processing");
                            throw e;
                        }
                    }
                    instance.applicationInstance = inst;
                }
            }
            catch(Throwable t)
            {
                ConfigurationException ex = new ConfigurationException();
                ex.setMessage(10656, new Object[] {
                    instance.getSource(), id
                });
                ex.setRootCause(t);
                throw ex;
            }
        return instance;
    }

    public Object lookup(FactoryInstance inst)
    {
        JavaFactoryInstance factoryInstance = (JavaFactoryInstance)inst;
        Object instance;
        if(factoryInstance.getScope().equals("application"))
            instance = factoryInstance.applicationInstance;
        else
        if(factoryInstance.getScope().equals("session"))
        {
            FlexSession session = FlexContext.getFlexSession();
            if(session != null)
            {
                instance = session.getAttribute(factoryInstance.getAttributeId());
                if(instance != null)
                {
                    Class configuredClass = factoryInstance.getInstanceClass();
                    Class instClass = instance.getClass();
                    if(configuredClass != instClass && !configuredClass.isAssignableFrom(instClass))
                    {
                        ServiceException e = new ServiceException();
                        e.setMessage(10654, new Object[] {
                            factoryInstance.getAttributeId(), "session", factoryInstance.getId(), factoryInstance.getInstanceClass(), instance.getClass()
                        });
                        e.setCode("Server.Processing");
                        throw e;
                    }
                } else
                {
                    instance = factoryInstance.createInstance();
                    session.setAttribute(factoryInstance.getAttributeId(), instance);
                }
            } else
            {
                instance = null;
            }
            if(instance == null)
            {
                ServiceException e = new ServiceException();
                e.setMessage(10652, new Object[] {
                    factoryInstance.getId()
                });
                e.setCode("Server.Processing");
                throw e;
            }
        } else
        {
            instance = factoryInstance.createInstance();
        }
        return instance;
    }

    private static final String SCOPE = "scope";
    private static final String SOURCE = "source";
    private static final String ATTRIBUTE_ID = "attribute-id";
    private static final int SINGLETON_ERROR = 10656;
    private static final int SESSION_NOT_FOUND = 10652;
    private static final int INVALID_CLASS_FOUND = 10654;
}
