// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   BeanProxy.java

package flex.messaging.io;

import flex.messaging.MessageException;
import flex.messaging.io.amf.ASObject;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import java.beans.*;
import java.lang.reflect.*;
import java.util.*;

// Referenced classes of package flex.messaging.io:
//            AbstractProxy, SerializationDescriptor, PropertyProxy, PropertyProxyRegistry, 
//            TypeMarshallingContext, TypeMarshaller, SerializationContext

public class BeanProxy extends AbstractProxy
{
    protected class BeanProperty
    {

        public String getName()
        {
            return name;
        }

        public Class getType()
        {
            return type;
        }

        public boolean isWrite()
        {
            return writeMethod != null || field != null;
        }

        public boolean isRead()
        {
            return readMethod != null || field != null;
        }

        public Class getReadDeclaringClass()
        {
            if(readMethod != null)
                return readMethod.getDeclaringClass();
            if(field != null)
                return field.getDeclaringClass();
            else
                return null;
        }

        public Class getReadType()
        {
            if(readMethod != null)
                return readMethod.getReturnType();
            if(field != null)
                return field.getType();
            else
                return null;
        }

        public String getWriteName()
        {
            if(writeMethod != null)
                return "method " + writeMethod.getName();
            if(field != null)
                return "field " + field.getName();
            else
                return null;
        }

        public void set(Object bean, Object value)
            throws IllegalAccessException, InvocationTargetException
        {
            if(writeMethod != null)
                writeMethod.invoke(bean, new Object[] {
                    value
                });
            else
            if(field != null)
                field.set(bean, value);
            else
                throw new MessageException("Setter not found for property " + name);
        }

        public Object get(Object bean)
            throws IllegalAccessException, InvocationTargetException
        {
            Object obj = null;
            if(readMethod != null)
                obj = readMethod.invoke(bean, null);
            else
            if(field != null)
                obj = field.get(bean);
            return obj;
        }

        private String name;
        private Class type;
        private Method readMethod;
        private Method writeMethod;
        private Field field;

        protected BeanProperty(String name, Class type, Method read, Method write, Field field)
        {
            super();
            this.name = name;
            this.type = type;
            writeMethod = write;
            readMethod = read;
            this.field = field;
        }
    }


    public BeanProxy()
    {
        this(null);
    }

    public BeanProxy(Object defaultInstance)
    {
        super(defaultInstance);
        cacheProperties = true;
        cachePropertiesDescriptors = true;
        stopClass = java.lang.Object.class;
        if(defaultInstance != null)
            alias = getClassName(defaultInstance);
    }

    public String getAlias(Object instance)
    {
        return getClassName(instance);
    }

    public List getPropertyNames(Object instance)
    {
        if(instance == null)
            return null;
        Class c = instance.getClass();
        List propertyNames = null;
        Map properties = null;
        if(descriptor == null)
            propertyNames = (List)propertyNamesCache.get(c);
        if(propertyNames != null)
            return propertyNames;
        properties = getBeanProperties(instance);
        propertyNames = new ArrayList(properties.size());
        for(Iterator it = properties.keySet().iterator(); it.hasNext(); propertyNames.add(it.next().toString()));
        if(cacheProperties && descriptor == null)
            synchronized(propertyNamesCache)
            {
                List propertyNames2 = (List)propertyNamesCache.get(c);
                if(propertyNames2 == null)
                    propertyNamesCache.put(c, propertyNames);
                else
                    propertyNames = propertyNames2;
            }
        return propertyNames;
    }

    public Class getType(Object instance, String propertyName)
    {
        if(instance == null || propertyName == null)
            return null;
        Map beanProperties = getBeanProperties(instance);
        BeanProperty bp = (BeanProperty)beanProperties.get(propertyName);
        if(bp != null)
            return bp.getType();
        else
            return null;
    }

    public Object getValue(Object instance, String propertyName)
    {
        if(instance == null || propertyName == null)
            return null;
        Map beanProperties = getBeanProperties(instance);
        BeanProperty bp = (BeanProperty)beanProperties.get(propertyName);
        if(bp != null)
        {
            if(bp.isRead())
            {
                try
                {
                    Object value = bp.get(instance);
                    if(value != null && descriptor != null)
                    {
                        SerializationDescriptor subDescriptor = (SerializationDescriptor)descriptor.get(propertyName);
                        if(subDescriptor != null)
                        {
                            PropertyProxy subProxy = PropertyProxyRegistry.getProxyAndRegister(value);
                            subProxy = (PropertyProxy)subProxy.clone();
                            subProxy.setDescriptor(subDescriptor);
                            subProxy.setDefaultInstance(value);
                            value = subProxy;
                        }
                    }
                    return value;
                }
                catch(Exception e)
                {
                    SerializationContext context = getSerializationContext();
                    if(Log.isWarn() && logPropertyErrors(context))
                    {
                        Logger log = Log.getLogger("Endpoint.Type");
                        log.warn("Failed to get property {0} on type {1}.", new Object[] {
                            propertyName, getAlias(instance)
                        }, e);
                    }
                    if(!ignorePropertyErrors(context))
                    {
                        MessageException ex = new MessageException();
                        ex.setMessage(10021, new Object[] {
                            propertyName, getAlias(instance)
                        });
                        ex.setRootCause(e);
                        throw ex;
                    }
                }
            } else
            {
                SerializationContext context = getSerializationContext();
                if(!ignorePropertyErrors(context))
                {
                    MessageException ex = new MessageException();
                    ex.setMessage(10023, new Object[] {
                        propertyName, getAlias(instance)
                    });
                    throw ex;
                }
            }
        } else
        {
            SerializationContext context = getSerializationContext();
            if(!ignorePropertyErrors(context))
            {
                MessageException ex = new MessageException();
                ex.setMessage(10025, new Object[] {
                    propertyName, getAlias(instance)
                });
                throw ex;
            }
        }
        return null;
    }

    public void setValue(Object instance, String propertyName, Object value)
    {
        Map props = getBeanProperties(instance);
        BeanProperty bp = (BeanProperty)props.get(propertyName);
        if(bp != null)
        {
            if(bp.isWrite())
            {
                try
                {
                    Class desiredPropClass = bp.getType();
                    TypeMarshaller marshaller = TypeMarshallingContext.getTypeMarshaller();
                    value = marshaller.convert(value, desiredPropClass);
                    bp.set(instance, value);
                }
                catch(Exception e)
                {
                    SerializationContext context = getSerializationContext();
                    if(Log.isWarn() && logPropertyErrors(context))
                    {
                        Logger log = Log.getLogger("Endpoint.Type");
                        log.warn("Failed to set property {0} on type {1}.", new Object[] {
                            propertyName, getAlias(instance)
                        }, e);
                    }
                    if(!ignorePropertyErrors(context))
                    {
                        MessageException ex = new MessageException();
                        ex.setMessage(10022, new Object[] {
                            propertyName, getAlias(instance)
                        });
                        ex.setRootCause(e);
                        throw ex;
                    }
                }
            } else
            {
                SerializationContext context = getSerializationContext();
                if(Log.isWarn() && logPropertyErrors(context))
                {
                    Logger log = Log.getLogger("Endpoint.Type");
                    log.warn("Property {0} not writable on class {1}", new Object[] {
                        propertyName, getAlias(instance)
                    });
                }
                if(!ignorePropertyErrors(context))
                {
                    MessageException ex = new MessageException();
                    ex.setMessage(10024, new Object[] {
                        propertyName, getAlias(instance)
                    });
                    throw ex;
                }
            }
        } else
        {
            SerializationContext context = getSerializationContext();
            if(Log.isWarn() && logPropertyErrors(context))
            {
                Logger log = Log.getLogger("Endpoint.Type");
                log.warn("Ignoring set property {0} for type {1} as a setter could not be found.", new Object[] {
                    propertyName, getAlias(instance)
                });
            }
            if(!ignorePropertyErrors(context))
            {
                MessageException ex = new MessageException();
                ex.setMessage(10025, new Object[] {
                    propertyName, getAlias(instance)
                });
                throw ex;
            }
        }
    }

    protected boolean ignorePropertyErrors(SerializationContext context)
    {
        return context.ignorePropertyErrors;
    }

    protected boolean logPropertyErrors(SerializationContext context)
    {
        return context.logPropertyErrors;
    }

    protected String getClassName(Object instance)
    {
        String className = null;
        if(instance instanceof ASObject)
            className = ((ASObject)instance).getType();
        else
            className = instance.getClass().getName();
        return className;
    }

    protected Map getBeanProperties(Object instance)
    {
        Class c = instance.getClass();
        Map props;
        if(descriptor == null)
        {
            props = (Map)beanPropertyCache.get(c);
            if(props != null)
                return props;
        }
        props = new HashMap();
        PropertyDescriptor pds[] = (PropertyDescriptor[])(PropertyDescriptor[])propertyDescriptorCache.get(c);
        try
        {
            if(pds == null)
            {
                BeanInfo beanInfo = Introspector.getBeanInfo(c, stopClass);
                pds = beanInfo.getPropertyDescriptors();
                if(cachePropertiesDescriptors)
                    synchronized(propertyDescriptorCache)
                    {
                        PropertyDescriptor pds2[] = (PropertyDescriptor[])(PropertyDescriptor[])propertyDescriptorCache.get(c);
                        if(pds2 == null)
                            propertyDescriptorCache.put(c, pds);
                        else
                            pds = pds2;
                    }
            }
        }
        catch(IntrospectionException ex)
        {
            return null;
        }
        List excludes = null;
        if(descriptor != null)
            excludes = descriptor.getExcludes();
        for(int i = 0; i < pds.length; i++)
        {
            PropertyDescriptor pd = pds[i];
            String propertyName = pd.getName();
            Method readMethod = pd.getReadMethod();
            Method writeMethod = pd.getWriteMethod();
            if(readMethod != null && isPublicAccessor(readMethod.getModifiers()) && (includeReadOnly || writeMethod != null) && (excludes == null || !excludes.contains(propertyName)) && !isPropertyIgnored(c, propertyName))
                props.put(pd.getName(), new BeanProperty(pd.getName(), pd.getPropertyType(), readMethod, writeMethod, null));
        }

        Field fields[] = instance.getClass().getFields();
        for(int i = 0; i < fields.length; i++)
        {
            Field field = fields[i];
            String propertyName = field.getName();
            int modifiers = field.getModifiers();
            if(isPublicField(modifiers) && !props.containsKey(propertyName) && (excludes == null || !excludes.contains(propertyName)) && !isPropertyIgnored(c, propertyName))
                props.put(field.getName(), new BeanProperty(propertyName, field.getType(), null, null, field));
        }

        if(descriptor == null && cacheProperties)
            synchronized(beanPropertyCache)
            {
                Map props2 = (Map)beanPropertyCache.get(c);
                if(props2 == null)
                    beanPropertyCache.put(c, props);
                else
                    props = props2;
            }
        return props;
    }

    public static boolean isPropertyIgnored(Class c, String propertyName)
    {
        boolean result = false;
        Set propertyOwners = (Set)ignoreProperties.get(propertyName);
        if(propertyOwners != null)
            do
            {
                if(c == null)
                    break;
                if(propertyOwners.contains(c))
                {
                    result = true;
                    break;
                }
                c = c.getSuperclass();
            } while(true);
        return result;
    }

    public static void addIgnoreProperty(Class c, String propertyName)
    {
        synchronized(ignoreProperties)
        {
            Set propertyOwners = (Set)ignoreProperties.get(propertyName);
            if(propertyOwners == null)
            {
                propertyOwners = new HashSet();
                ignoreProperties.put(propertyName, propertyOwners);
            }
            propertyOwners.add(c);
        }
    }

    public static boolean isPublicField(int modifiers)
    {
        return Modifier.isPublic(modifiers) && !Modifier.isFinal(modifiers) && !Modifier.isStatic(modifiers) && !Modifier.isTransient(modifiers);
    }

    public static boolean isPublicAccessor(int modifiers)
    {
        return Modifier.isPublic(modifiers) && !Modifier.isStatic(modifiers);
    }

    public Object clone()
    {
        BeanProxy proxy = new BeanProxy();
        proxy.setCloneFieldsFrom(this);
        return proxy;
    }

    protected static final String LOG_CATEGORY = "Endpoint.Type";
    private static final int FAILED_PROPERTY_READ_ERROR = 10021;
    private static final int FAILED_PROPERTY_WRITE_ERROR = 10022;
    private static final int NON_READABLE_PROPERTY_ERROR = 10023;
    private static final int NON_WRITABLE_PROPERTY_ERROR = 10024;
    private static final int UNKNOWN_PROPERTY_ERROR = 10025;
    protected static final Map propertyNamesCache = new IdentityHashMap();
    protected static final Map beanPropertyCache = new IdentityHashMap();
    protected static final Map propertyDescriptorCache = new IdentityHashMap();
    protected boolean cacheProperties;
    protected boolean cachePropertiesDescriptors;
    protected Class stopClass;
    protected static final Map ignoreProperties = new HashMap();

    static 
    {
        addIgnoreProperty(java.util.AbstractMap.class, "empty");
        addIgnoreProperty(java.util.AbstractCollection.class, "empty");
        addIgnoreProperty(flex.messaging.io.amf.ASObject.class, "type");
        addIgnoreProperty(java.lang.Throwable.class, "stackTrace");
        addIgnoreProperty(java.io.File.class, "parentFile");
        addIgnoreProperty(java.io.File.class, "canonicalFile");
        addIgnoreProperty(java.io.File.class, "absoluteFile");
    }
}
