// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PagedRowSet.java

package flex.messaging.io;

import flex.messaging.util.UUIDUtils;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.*;
import javax.sql.RowSet;

// Referenced classes of package flex.messaging.io:
//            ArrayList, PageableRowSet

public class PagedRowSet
    implements PageableRowSet
{

    public PagedRowSet(RowSet r, int p)
    {
        pageSize = 50;
        colCount = 0;
        rowCount = 0;
        id = null;
        serviceName = null;
        serviceName = "PageableRowSetCache";
        rowSet = r;
        pageSize = p;
        id = UUIDUtils.createUUID(false);
        init();
    }

    public PagedRowSet(RowSet r, int p, boolean createID)
    {
        pageSize = 50;
        colCount = 0;
        rowCount = 0;
        id = null;
        serviceName = null;
        serviceName = "PageableRowSetCache";
        rowSet = r;
        pageSize = p;
        if(createID)
            id = UUIDUtils.createUUID(false);
        init();
    }

    private void init()
    {
        if(rowSet != null)
        {
            initColumns();
            initRecords();
        } else
        {
            colNames = new String[0];
        }
    }

    private synchronized void initColumns()
    {
        try
        {
            ResultSetMetaData rsmd = rowSet.getMetaData();
            if(rsmd != null)
                colCount = rsmd.getColumnCount();
        }
        catch(SQLException ex)
        {
            colCount = 0;
        }
    }

    private synchronized void initRecords()
    {
        if(rowSet != null)
            try
            {
                int currentIndex = rowSet.getRow();
                if(rowSet.last())
                    rowCount = rowSet.getRow();
                if(currentIndex > 0)
                    rowSet.absolute(currentIndex);
                else
                    rowSet.beforeFirst();
            }
            catch(SQLException ex)
            {
                try
                {
                    rowSet.first();
                }
                catch(SQLException se) { }
            }
    }

    public String[] getColumnNames()
        throws SQLException
    {
        if(colNames == null)
            try
            {
                if(colCount == 0)
                    initColumns();
                colNames = new String[colCount];
                for(int i = 0; i < colCount; i++)
                    colNames[i] = rowSet.getMetaData().getColumnName(i + 1);

            }
            catch(SQLException ex)
            {
                colNames = new String[0];
            }
        return colNames;
    }

    public synchronized Map getRecords(int startIndex, int count)
        throws SQLException
    {
        List aRecords = new ArrayList();
        if(colCount == 0)
            initColumns();
        try
        {
            if(startIndex < 1)
                startIndex = 1;
            if(rowSet.absolute(startIndex))
            {
                int i = 0;
                do
                {
                    if(i >= count)
                        break;
                    boolean hasNext = true;
                    List row;
                    if(colCount > 0)
                    {
                        row = new ArrayList(rowCount + 1);
                        for(int j = 1; j <= colCount; j++)
                            row.add(rowSet.getObject(j));

                    } else
                    {
                        row = new ArrayList();
                        try
                        {
                            int j = 1;
                            do
                            {
                                if(j > 50)
                                    break;
                                Object o = rowSet.getObject(j);
                                if(o == null)
                                    break;
                                row.add(o);
                                j++;
                            } while(true);
                        }
                        catch(SQLException ex) { }
                    }
                    aRecords.add(((Object) (row.toArray())));
                    hasNext = rowSet.next();
                    if(!hasNext)
                        break;
                    i++;
                } while(true);
            }
        }
        catch(SQLException ex)
        {
            throw ex;
        }
        Map result = new HashMap(2);
        result.put("Page", ((Object) (aRecords.toArray())));
        result.put("Cursor", new Integer(startIndex));
        return result;
    }

    public int getRowCount()
    {
        return rowCount;
    }

    public int getInitialDownloadCount()
    {
        return pageSize;
    }

    public String getID()
    {
        return id;
    }

    public String getServiceName()
    {
        return serviceName;
    }

    public void setServicename(String serviceName)
    {
        this.serviceName = serviceName;
    }

    private RowSet rowSet;
    private String colNames[];
    private int pageSize;
    private int colCount;
    private int rowCount;
    private String id;
    private String serviceName;
    public static final boolean CF_BACKWARDS_COMPATIBLE_UUID = false;
    public static final String DEFAULT_PAGING_SERVICE_NAME = "PageableRowSetCache";
}
