// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PropertyProxyRegistry.java

package flex.messaging.io;

import java.util.*;
import javax.sql.RowSet;

// Referenced classes of package flex.messaging.io:
//            ThrowableProxy, MapProxy, PropertyProxy, PageableRowSet, 
//            PageableRowSetProxy, DictionaryProxy, BeanProxy

public class PropertyProxyRegistry
{

    public PropertyProxyRegistry()
    {
        classRegistry = new IdentityHashMap();
    }

    public static PropertyProxyRegistry getRegistry()
    {
        if(!preregistered)
        {
            preRegister();
            preregistered = true;
        }
        return registry;
    }

    private static void preRegister()
    {
        ThrowableProxy proxy = new ThrowableProxy();
        registry.register(flex.messaging.MessageException.class, proxy);
        registry.register(flex.messaging.LocalizedException.class, proxy);
        registry.register(java.lang.Throwable.class, proxy);
        MapProxy mapProxy = new MapProxy();
        registry.register(flex.messaging.io.amf.ASObject.class, mapProxy);
        registry.register(java.util.HashMap.class, mapProxy);
        registry.register(java.util.AbstractMap.class, mapProxy);
        registry.register(java.util.Map.class, mapProxy);
    }

    public static PropertyProxy getProxyAndRegister(Object instance)
    {
        if(instance instanceof PropertyProxy)
            return (PropertyProxy)instance;
        Class c = instance.getClass();
        PropertyProxy proxy = getRegistry().getProxyAndRegister(c);
        if(proxy == null)
        {
            proxy = guessProxy(instance);
            getRegistry().register(c, proxy);
        }
        return proxy;
    }

    public static PropertyProxy getProxy(Object instance)
    {
        if(instance instanceof PropertyProxy)
            return (PropertyProxy)instance;
        Class c = instance.getClass();
        PropertyProxy proxy = getRegistry().getProxy(c);
        if(proxy == null)
            proxy = guessProxy(instance);
        proxy = (PropertyProxy)proxy.clone();
        proxy.setDefaultInstance(instance);
        return proxy;
    }

    private static PropertyProxy guessProxy(Object instance)
    {
        PropertyProxy proxy;
        if(instance instanceof Map)
            proxy = new MapProxy();
        else
        if(instance instanceof Throwable)
            proxy = new ThrowableProxy();
        else
        if((instance instanceof PageableRowSet) || (instance instanceof RowSet))
            proxy = new PageableRowSetProxy();
        else
        if(instance instanceof Dictionary)
            proxy = new DictionaryProxy();
        else
            proxy = new BeanProxy();
        return proxy;
    }

    public PropertyProxy getProxy(Class c)
    {
        return getProxy(c, true, false);
    }

    public PropertyProxy getProxyAndRegister(Class c)
    {
        return getProxy(c, true, true);
    }

    public PropertyProxy getProxy(Class c, boolean searchHierarchy, boolean autoRegister)
    {
        if(c == null)
            return null;
        if(c.isArray())
            c = c.getComponentType();
        PropertyProxy s = (PropertyProxy)classRegistry.get(c);
        if(s == null && searchHierarchy)
        {
            Class interfaces[] = c.getInterfaces();
            int i = 0;
            do
            {
                if(i >= interfaces.length)
                    break;
                Class interfaceClass = interfaces[i];
                s = (PropertyProxy)classRegistry.get(interfaceClass);
                if(s != null && autoRegister)
                {
                    register(c, s);
                    break;
                }
                s = getProxy(interfaceClass, searchHierarchy, autoRegister);
                if(s != null)
                    break;
                i++;
            } while(true);
        }
        if(s == null && searchHierarchy)
        {
            Class superclass = c.getSuperclass();
            if(superclass != null)
            {
                s = getProxy(superclass, searchHierarchy, autoRegister);
                if(s != null && autoRegister)
                    register(c, s);
            }
        }
        return s;
    }

    public void clear()
    {
        synchronized(classRegistry)
        {
            classRegistry.clear();
        }
    }

    public void register(Class c, PropertyProxy s)
    {
        synchronized(classRegistry)
        {
            classRegistry.put(c, s);
        }
    }

    public void unregister(Class c)
    {
        synchronized(classRegistry)
        {
            classRegistry.remove(c);
        }
    }

    private Map classRegistry;
    private static final PropertyProxyRegistry registry = new PropertyProxyRegistry();
    private static boolean preregistered = false;

}
