// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Amf0Input.java

package flex.messaging.io.amf;

import flex.messaging.io.*;
import flex.messaging.io.amf.serializers.CustomDeserializer;
import java.io.*;
import java.util.*;

// Referenced classes of package flex.messaging.io.amf:
//            AbstractAmfInput, Amf3Input, AmfTypes, ActionMessageInput, 
//            AmfTrace

public class Amf0Input extends AbstractAmfInput
    implements AmfTypes
{

    public Amf0Input(SerializationContext context)
    {
        super(context);
        objectsTable = new ArrayList(64);
    }

    public void reset()
    {
        super.reset();
        objectsTable.clear();
        if(avmPlusInput != null)
            avmPlusInput.reset();
    }

    public Object readObject()
        throws ClassNotFoundException, IOException
    {
        int type = in.readByte();
        Object value = readObjectValue(type);
        return value;
    }

    private Object readObjectValue(int type)
        throws ClassNotFoundException, IOException
    {
        Object value = null;
        switch(type)
        {
        case 0: // '\0'
            double d = readDouble();
            if(isDebug)
                trace.write(d);
            value = new Double(d);
            break;

        case 1: // '\001'
            value = new Boolean(readBoolean());
            if(isDebug)
                trace.write(value);
            break;

        case 2: // '\002'
            value = readString();
            break;

        case 17: // '\021'
            if(avmPlusInput == null)
            {
                avmPlusInput = new Amf3Input(context);
                avmPlusInput.setDebugTrace(trace);
                avmPlusInput.setInputStream(in);
            }
            value = avmPlusInput.readObject();
            break;

        case 10: // '\n'
            value = readArrayValue();
            break;

        case 16: // '\020'
            String typeName = in.readUTF();
            value = readObjectValue(typeName);
            break;

        case 12: // '\f'
            value = readLongUTF();
            if(isDebug)
                trace.writeString((String)value);
            break;

        case 3: // '\003'
            value = readObjectValue(((String) (null)));
            break;

        case 15: // '\017'
            value = readXml();
            break;

        case 5: // '\005'
            if(isDebug)
                trace.writeNull();
            break;

        case 11: // '\013'
            value = readDate();
            break;

        case 8: // '\b'
            value = readECMAArrayValue();
            break;

        case 7: // '\007'
            int refNum = in.readUnsignedShort();
            if(isDebug)
                trace.writeRef(refNum);
            value = objectsTable.get(refNum);
            break;

        case 6: // '\006'
            if(isDebug)
                trace.writeUndefined();
            break;

        case 13: // '\r'
            if(isDebug)
                trace.write("UNSUPPORTED");
            UnknownTypeException ex = new UnknownTypeException();
            ex.setMessage(10302);
            throw ex;

        case 9: // '\t'
            if(isDebug)
                trace.write("UNEXPECTED OBJECT END");
            UnknownTypeException ex1 = new UnknownTypeException();
            ex1.setMessage(10303);
            throw ex1;

        case 14: // '\016'
            if(isDebug)
                trace.write("UNEXPECTED RECORDSET");
            UnknownTypeException ex2 = new UnknownTypeException();
            ex2.setMessage(10304);
            throw ex2;

        case 4: // '\004'
        default:
            if(isDebug)
                trace.write("UNKNOWN TYPE");
            UnknownTypeException ex3 = new UnknownTypeException();
            ex3.setMessage(10301, new Object[] {
                new Integer(type)
            });
            throw ex3;
        }
        return value;
    }

    private Date readDate()
        throws IOException
    {
        long time = (long)in.readDouble();
        in.readShort();
        Date d = new Date(time);
        if(isDebug)
            trace.write(d.toString());
        return d;
    }

    private Map readECMAArrayValue()
        throws ClassNotFoundException, IOException
    {
        int size = in.readInt();
        HashMap h;
        if(size == 0)
            h = new HashMap();
        else
            h = new HashMap(size);
        rememberObject(h);
        if(isDebug)
            trace.startECMAArray(objectsTable.size() - 1);
        String name = in.readUTF();
        for(int type = in.readByte(); type != 9; type = in.readByte())
        {
            if(type != 9)
            {
                if(isDebug)
                    trace.namedElement(name);
                Object value = readObjectValue(type);
                h.put(name, value);
            }
            name = in.readUTF();
        }

        if(isDebug)
            trace.endAMFArray();
        return h;
    }

    private String readString()
        throws IOException
    {
        String s = readUTF();
        if(isDebug)
            trace.writeString(s);
        return s;
    }

    private Object readArrayValue()
        throws ClassNotFoundException, IOException
    {
        int size = in.readInt();
        ArrayList l = new ArrayList(size);
        rememberObject(l);
        if(isDebug)
            trace.startAMFArray(objectsTable.size() - 1);
        for(int i = 0; i < size; i++)
        {
            int type = in.readByte();
            if(isDebug)
                trace.arrayElement(i);
            l.add(readObjectValue(type));
        }

        if(isDebug)
            trace.endAMFArray();
        if(context.legacyCollection)
            return l;
        else
            return ((Object) (l.toArray()));
    }

    private Object readObjectValue(String typeName)
        throws ClassNotFoundException, IOException
    {
        Object object = beanProxy.createInstance(typeName);
        PropertyProxy proxy = PropertyProxyRegistry.getProxyAndRegister(object);
        rememberObject(object);
        if(isDebug)
            trace.startAMFObject(typeName, objectsTable.size() - 1);
        String propertyName = in.readUTF();
        for(int type = in.readByte(); type != 9; type = in.readByte())
        {
            if(isDebug)
                trace.namedElement(propertyName);
            Object value = readObjectValue(type);
            proxy.setValue(object, propertyName, value);
            propertyName = in.readUTF();
        }

        if(isDebug)
            trace.endAMFObject();
        return object;
    }

    private String readLongUTF()
        throws IOException
    {
        int utflen = in.readInt();
        char charr[] = getTempCharArray(utflen);
        byte bytearr[] = getTempByteArray(utflen);
        int count = 0;
        int chCount = 0;
        in.readFully(bytearr, 0, utflen);
        while(count < utflen) 
        {
            int c = bytearr[count] & 0xff;
            switch(c >> 4)
            {
            case 0: // '\0'
            case 1: // '\001'
            case 2: // '\002'
            case 3: // '\003'
            case 4: // '\004'
            case 5: // '\005'
            case 6: // '\006'
            case 7: // '\007'
            {
                count++;
                charr[chCount] = (char)c;
                break;
            }

            case 12: // '\f'
            case 13: // '\r'
            {
                if((count += 2) > utflen)
                    throw new UTFDataFormatException();
                int char2 = bytearr[count - 1];
                if((char2 & 0xc0) != 128)
                    throw new UTFDataFormatException();
                charr[chCount] = (char)((c & 0x1f) << 6 | char2 & 0x3f);
                break;
            }

            case 14: // '\016'
            {
                if((count += 3) > utflen)
                    throw new UTFDataFormatException();
                int char2 = bytearr[count - 2];
                int char3 = bytearr[count - 1];
                if((char2 & 0xc0) != 128 || (char3 & 0xc0) != 128)
                    throw new UTFDataFormatException();
                charr[chCount] = (char)((c & 0xf) << 12 | (char2 & 0x3f) << 6 | (char3 & 0x3f) << 0);
                break;
            }

            case 8: // '\b'
            case 9: // '\t'
            case 10: // '\n'
            case 11: // '\013'
            default:
            {
                throw new UTFDataFormatException();
            }
            }
            chCount++;
        }
        return new String(charr, 0, chCount);
    }

    private String readXmlAsString()
        throws IOException
    {
        String str = readLongUTF();
        if(isDebug)
            trace.write(str);
        return str;
    }

    private Object readXml()
        throws IOException
    {
        String xml = readXmlAsString();
        return xmlDeserializer.createObject(null, xml);
    }

    private void rememberObject(Object obj)
    {
        objectsTable.add(obj);
    }

    private ActionMessageInput avmPlusInput;
    private List objectsTable;
}
