// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Amf0Output.java

package flex.messaging.io.amf;

import flex.messaging.io.*;
import flex.messaging.io.amf.serializers.CustomSerializer;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.reflect.Array;
import java.util.*;
import javax.sql.RowSet;
import org.w3c.dom.Document;

// Referenced classes of package flex.messaging.io.amf:
//            AbstractAmfOutput, Amf3Output, ASObject, TraitsInfo, 
//            AmfTypes, AmfTrace

public class Amf0Output extends AbstractAmfOutput
    implements AmfTypes
{

    public Amf0Output(SerializationContext context)
    {
        super(context);
        serializedObjectCount = 0;
        context.supportDatesByReference = false;
        serializedObjects = new IdentityHashMap(64);
    }

    public void setAvmPlus(boolean a)
    {
        avmPlus = a;
    }

    public void reset()
    {
        super.reset();
        serializedObjects.clear();
        serializedObjectCount = 0;
        if(avmPlusOutput != null)
            avmPlusOutput.reset();
    }

    public void writeObject(Object o)
        throws IOException
    {
        if(o == null)
        {
            writeAMFNull();
            return;
        }
        if(o instanceof String)
            writeAMFString((String)o);
        else
        if(o instanceof Number)
            writeAMFDouble(((Number)o).doubleValue());
        else
        if(o instanceof Boolean)
            writeAMFBoolean(((Boolean)o).booleanValue());
        else
        if(o instanceof Character)
        {
            String s = o.toString();
            writeAMFString(s);
        } else
        if(o instanceof Date)
            writeAMFDate((Date)o);
        else
        if(o instanceof Calendar)
            writeAMFDate(((Calendar)o).getTime());
        else
        if(avmPlus)
        {
            if(avmPlusOutput == null)
            {
                avmPlusOutput = new Amf3Output(context);
                avmPlusOutput.setOutputStream(out);
                avmPlusOutput.setDebugTrace(trace);
            }
            out.writeByte(17);
            avmPlusOutput.writeObject(o);
        } else
        {
            Class cls = o.getClass();
            if(cls.isArray())
                writeAMFArray(o, cls.getComponentType());
            else
            if((o instanceof Map) && context.legacyMap && !(o instanceof ASObject))
                writeMapAsECMAArray((Map)o);
            else
            if(o instanceof Collection)
            {
                if(context.legacyCollection)
                    writeCollection((Collection)o, null);
                else
                    writeArrayCollection((Collection)o, null);
            } else
            if(o instanceof Document)
            {
                out.write(15);
                documentSerializer.writeObject(this, o);
            } else
            {
                if(o instanceof RowSet)
                    o = new PagedRowSet((RowSet)o, 0x7fffffff, false);
                else
                if((o instanceof Throwable) && context.legacyThrowable)
                    o = new StatusInfoProxy((Throwable)o);
                writeCustomObject(o);
            }
        }
    }

    public void writeObjectTraits(TraitsInfo traits)
        throws IOException
    {
        String className = null;
        if(traits != null)
            className = traits.getClassName();
        if(isDebug)
            trace.startAMFObject(className, serializedObjectCount - 1);
        if(className == null || className.length() == 0)
        {
            out.write(3);
        } else
        {
            out.write(16);
            out.writeUTF(className);
        }
    }

    public void writeObjectProperty(String name, Object value)
        throws IOException
    {
        if(isDebug)
            trace.namedElement(name);
        out.writeUTF(name);
        writeObject(value);
    }

    public void writeObjectEnd()
        throws IOException
    {
        out.write(OBJECT_END_MARKER, 0, OBJECT_END_MARKER.length);
        if(isDebug)
            trace.endAMFObject();
    }

    private void writeAMFBoolean(boolean b)
        throws IOException
    {
        if(isDebug)
            trace.write(b);
        out.write(1);
        out.writeBoolean(b);
    }

    private void writeAMFDouble(double d)
        throws IOException
    {
        if(isDebug)
            trace.write(d);
        out.write(0);
        out.writeDouble(d);
    }

    private void writeAMFDate(Date d)
        throws IOException
    {
        if(isDebug)
            trace.write(d);
        out.write(11);
        out.writeDouble(d.getTime());
        int nCurrentTimezoneOffset = TimeZone.getDefault().getRawOffset();
        out.writeShort(nCurrentTimezoneOffset / 60000);
    }

    private void writeAMFArray(Object o, Class componentType)
        throws IOException
    {
        if(componentType.isPrimitive())
            writePrimitiveArray(o);
        else
        if(componentType.equals(java.lang.Character.class))
            writeCharArrayAsString((Character[])(Character[])o);
        else
            writeObjectArray((Object[])(Object[])o, null);
    }

    private void writeArrayCollection(Collection col, SerializationDescriptor desc)
        throws IOException
    {
        if(!serializeAsReference(col))
        {
            ArrayCollection ac;
            if(col instanceof ArrayCollection)
            {
                ac = (ArrayCollection)col;
            } else
            {
                ac = new ArrayCollection(col);
                if(desc != null)
                    ac.setDescriptor(desc);
            }
            PropertyProxy proxy = PropertyProxyRegistry.getProxy(ac);
            writePropertyProxy(proxy, ac);
        }
    }

    private void writeCustomObject(Object o)
        throws IOException
    {
        PropertyProxy proxy = null;
        if(o instanceof PropertyProxy)
        {
            proxy = (PropertyProxy)o;
            o = proxy.getDefaultInstance();
            if(o == null)
            {
                writeAMFNull();
                return;
            }
            if(o instanceof Collection)
            {
                if(context.legacyCollection)
                    writeCollection((Collection)o, proxy.getDescriptor());
                else
                    writeArrayCollection((Collection)o, proxy.getDescriptor());
                return;
            }
            if(o.getClass().isArray())
            {
                writeObjectArray((Object[])(Object[])o, proxy.getDescriptor());
                return;
            }
            if(context.legacyMap && (o instanceof Map) && !(o instanceof ASObject))
            {
                writeMapAsECMAArray((Map)o);
                return;
            }
        }
        if(!serializeAsReference(o))
        {
            if(proxy == null)
                proxy = PropertyProxyRegistry.getProxyAndRegister(o);
            writePropertyProxy(proxy, o);
        }
    }

    private void writePropertyProxy(PropertyProxy pp, Object instance)
        throws IOException
    {
        boolean externalizable = false;
        List propertyNames = pp.getPropertyNames(instance);
        TraitsInfo ti = new TraitsInfo(pp.getAlias(instance), pp.isDynamic(), externalizable, propertyNames);
        writeObjectTraits(ti);
        if(propertyNames != null)
        {
            String propName;
            Object value;
            for(Iterator it = propertyNames.iterator(); it.hasNext(); writeObjectProperty(propName, value))
            {
                propName = (String)it.next();
                value = pp.getValue(instance, propName);
            }

        }
        writeObjectEnd();
    }

    private void writeMapAsECMAArray(Map m)
        throws IOException
    {
        if(!serializeAsReference(m))
        {
            if(isDebug)
                trace.startECMAArray(serializedObjectCount - 1);
            out.write(8);
            out.writeInt(0);
            Object key;
            Object value;
            for(Iterator it = m.keySet().iterator(); it.hasNext(); writeObjectProperty(key.toString(), value))
            {
                key = it.next();
                value = m.get(key);
            }

            writeObjectEnd();
        }
    }

    private void writeAMFNull()
        throws IOException
    {
        if(isDebug)
            trace.writeNull();
        out.write(5);
    }

    private void writeAMFString(String str)
        throws IOException
    {
        if(isDebug)
            trace.writeString(str);
        writeUTF(str, false, true);
    }

    public void writeStringAsXML(String str)
        throws IOException
    {
        if(isDebug)
            trace.write(str);
        writeUTF(str, true, false);
    }

    private void writeObjectArray(Object values[], SerializationDescriptor descriptor)
        throws IOException
    {
        if(!serializeAsReference(((Object) (values))))
        {
            if(isDebug)
                trace.startAMFArray(serializedObjectCount - 1);
            out.write(10);
            out.writeInt(values.length);
            for(int i = 0; i < values.length; i++)
            {
                if(isDebug)
                    trace.arrayElement(i);
                Object item = values[i];
                if(item != null && descriptor != null && !(item instanceof String) && !(item instanceof Number) && !(item instanceof Boolean) && !(item instanceof Character))
                {
                    PropertyProxy proxy = PropertyProxyRegistry.getProxy(item);
                    proxy = (PropertyProxy)proxy.clone();
                    proxy.setDescriptor(descriptor);
                    item = proxy;
                }
                writeObject(item);
            }

            if(isDebug)
                trace.endAMFArray();
        }
    }

    private void writeCollection(Collection c, SerializationDescriptor descriptor)
        throws IOException
    {
        if(!serializeAsReference(c))
        {
            if(isDebug)
                trace.startAMFArray(serializedObjectCount - 1);
            out.write(10);
            out.writeInt(c.size());
            Iterator it = c.iterator();
            int i = 0;
            Object item;
            for(; it.hasNext(); writeObject(item))
            {
                if(isDebug)
                    trace.arrayElement(i);
                item = it.next();
                if(item != null && descriptor != null && !(item instanceof String) && !(item instanceof Number) && !(item instanceof Boolean) && !(item instanceof Character))
                {
                    PropertyProxy proxy = PropertyProxyRegistry.getProxy(item);
                    proxy = (PropertyProxy)proxy.clone();
                    proxy.setDescriptor(descriptor);
                    item = proxy;
                }
            }

            i++;
            if(isDebug)
                trace.endAMFArray();
        }
    }

    private void writePrimitiveArray(Object obj)
        throws IOException
    {
        Class aType = obj.getClass().getComponentType();
        if(aType.equals(Character.TYPE))
        {
            char c[] = (char[])(char[])obj;
            writeCharArrayAsString(c);
        } else
        if(!serializeAsReference(obj))
            if(aType.equals(Boolean.TYPE))
            {
                out.write(10);
                boolean b[] = (boolean[])(boolean[])obj;
                out.writeInt(b.length);
                if(isDebug)
                {
                    trace.startAMFArray(serializedObjectCount - 1);
                    for(int i = 0; i < b.length; i++)
                    {
                        trace.arrayElement(i);
                        writeAMFBoolean(b[i]);
                    }

                    trace.endAMFArray();
                } else
                {
                    for(int i = 0; i < b.length; i++)
                        writeAMFBoolean(b[i]);

                }
            } else
            {
                out.write(10);
                int length = Array.getLength(obj);
                out.writeInt(length);
                if(isDebug)
                {
                    trace.startAMFArray(serializedObjectCount - 1);
                    for(int i = 0; i < length; i++)
                    {
                        trace.arrayElement(i);
                        double v = Array.getDouble(obj, i);
                        writeAMFDouble(v);
                    }

                    trace.endAMFArray();
                } else
                {
                    for(int i = 0; i < length; i++)
                    {
                        double v = Array.getDouble(obj, i);
                        writeAMFDouble(v);
                    }

                }
            }
    }

    private void writeCharArrayAsString(Character ca[])
        throws IOException
    {
        int length = ca.length;
        char chars[] = new char[length];
        for(int i = 0; i < length; i++)
        {
            Character c = ca[i];
            if(c == null)
                chars[i] = '\0';
            else
                chars[i] = ca[i].charValue();
        }

        writeCharArrayAsString(chars);
    }

    private void writeCharArrayAsString(char ca[])
        throws IOException
    {
        writeAMFString(new String(ca));
    }

    private void writeUTF(String str, boolean forceLong, boolean writeType)
        throws IOException
    {
        int strlen = str.length();
        int utflen = 0;
        int count = 0;
        char charr[] = getTempCharArray(strlen);
        str.getChars(0, strlen, charr, 0);
        for(int i = 0; i < strlen; i++)
        {
            int c = charr[i];
            if(c <= 127)
            {
                utflen++;
                continue;
            }
            if(c > 2047)
                utflen += 3;
            else
                utflen += 2;
        }

        int type;
        if(forceLong)
            type = 12;
        else
        if(utflen <= 65535)
            type = 2;
        else
            type = 12;
        byte bytearr[];
        if(writeType)
        {
            bytearr = getTempByteArray(utflen + (type != 2 ? 5 : 3));
            bytearr[count++] = (byte)type;
        } else
        {
            bytearr = getTempByteArray(utflen + (type != 2 ? 4 : 2));
        }
        if(type == 12)
        {
            bytearr[count++] = (byte)(utflen >>> 24 & 0xff);
            bytearr[count++] = (byte)(utflen >>> 16 & 0xff);
        }
        bytearr[count++] = (byte)(utflen >>> 8 & 0xff);
        bytearr[count++] = (byte)(utflen >>> 0 & 0xff);
        for(int i = 0; i < strlen; i++)
        {
            int c = charr[i];
            if(c <= 127)
            {
                bytearr[count++] = (byte)c;
                continue;
            }
            if(c > 2047)
            {
                bytearr[count++] = (byte)(0xe0 | c >> 12 & 0xf);
                bytearr[count++] = (byte)(0x80 | c >> 6 & 0x3f);
                bytearr[count++] = (byte)(0x80 | c >> 0 & 0x3f);
            } else
            {
                bytearr[count++] = (byte)(0xc0 | c >> 6 & 0x1f);
                bytearr[count++] = (byte)(0x80 | c >> 0 & 0x3f);
            }
        }

        out.write(bytearr, 0, count);
    }

    private void rememberObjectReference(Object obj)
    {
        serializedObjects.put(obj, new Integer(serializedObjectCount++));
    }

    private boolean serializeAsReference(Object obj)
        throws IOException
    {
        Object ref = serializedObjects.get(obj);
        if(ref != null)
            try
            {
                int refNum = ((Integer)ref).intValue();
                out.write(7);
                out.writeShort(refNum);
                if(isDebug)
                    trace.writeRef(refNum);
            }
            catch(ClassCastException e)
            {
                throw new IOException("Object reference value is not an Integer");
            }
        else
            rememberObjectReference(obj);
        return ref != null;
    }

    private static final byte OBJECT_END_MARKER[] = {
        0, 0, 9
    };
    private IdentityHashMap serializedObjects;
    private int serializedObjectCount;
    protected boolean avmPlus;
    private Amf3Output avmPlusOutput;

}
