// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Amf3Input.java

package flex.messaging.io.amf;

import flex.messaging.io.*;
import flex.messaging.io.amf.serializers.CustomDeserializer;
import flex.messaging.util.Trace;
import java.io.*;
import java.util.*;

// Referenced classes of package flex.messaging.io.amf:
//            AbstractAmfInput, TraitsInfo, Amf3Types, AmfTrace

public class Amf3Input extends AbstractAmfInput
    implements Amf3Types
{

    public Amf3Input(SerializationContext context)
    {
        super(context);
        stringTable = new ArrayList(64);
        objectTable = new ArrayList(64);
        traitsTable = new ArrayList(10);
    }

    public void reset()
    {
        super.reset();
        stringTable.clear();
        objectTable.clear();
        traitsTable.clear();
    }

    public Object saveObjectTable()
    {
        Object table = objectTable;
        objectTable = new ArrayList(64);
        return table;
    }

    public void restoreObjectTable(Object table)
    {
        objectTable = (ArrayList)table;
    }

    public Object saveTraitsTable()
    {
        Object table = traitsTable;
        traitsTable = new ArrayList(10);
        return table;
    }

    public void restoreTraitsTable(Object table)
    {
        traitsTable = (ArrayList)table;
    }

    public Object saveStringTable()
    {
        Object table = stringTable;
        stringTable = new ArrayList(64);
        return table;
    }

    public void restoreStringTable(Object table)
    {
        stringTable = (ArrayList)table;
    }

    public Object readObject()
        throws ClassNotFoundException, IOException
    {
        int type = in.readByte();
        Object value = readObjectValue(type);
        return value;
    }

    private Object readObjectValue(int type)
        throws ClassNotFoundException, IOException
    {
        Object value = null;
        switch(type)
        {
        case 6: // '\006'
            value = readString();
            if(isDebug)
                trace.writeString((String)value);
            break;

        case 10: // '\n'
            value = readScriptObject();
            break;

        case 9: // '\t'
            value = readArray();
            break;

        case 2: // '\002'
            value = Boolean.FALSE;
            if(isDebug)
                trace.write(value);
            break;

        case 3: // '\003'
            value = Boolean.TRUE;
            if(isDebug)
                trace.write(value);
            break;

        case 4: // '\004'
            int i = readUInt29();
            i = (i << 3) >> 3;
            value = new Integer(i);
            if(isDebug)
                trace.write(value);
            break;

        case 5: // '\005'
            value = new Double(in.readDouble());
            if(isDebug)
                trace.write(value);
            break;

        case 0: // '\0'
            if(isDebug)
                trace.writeUndefined();
            break;

        case 1: // '\001'
            if(isDebug)
                trace.writeNull();
            break;

        case 7: // '\007'
        case 11: // '\013'
            value = readXml();
            break;

        case 8: // '\b'
            value = readDate();
            if(isDebug)
                trace.write(value.toString());
            break;

        case 12: // '\f'
            value = readByteArray();
            break;

        default:
            UnknownTypeException ex = new UnknownTypeException();
            ex.setMessage(10301, new Object[] {
                new Integer(type)
            });
            throw ex;
        }
        return value;
    }

    private String readString()
        throws IOException
    {
        int ref = readUInt29();
        if((ref & 1) == 0)
            return getStringReference(ref >> 1);
        int len = ref >> 1;
        if(0 == len)
        {
            return "";
        } else
        {
            String str = readUTF(len);
            stringTable.add(str);
            return str;
        }
    }

    private Date readDate()
        throws IOException
    {
        int ref = readUInt29();
        if((ref & 1) == 0)
            return (Date)getObjectReference(ref >> 1);
        long time = (long)in.readDouble();
        Date d = new Date(time);
        objectTable.add(d);
        if(isDebug)
            trace.write(d);
        return d;
    }

    private Object readArray()
        throws ClassNotFoundException, IOException
    {
        int ref = readUInt29();
        if((ref & 1) == 0)
            return ((Object) (((List)getObjectReference(ref >> 1)).toArray()));
        int len = ref >> 1;
        Object array = null;
        Map map = null;
        do
        {
            String name = readString();
            if(name == null || name.length() == 0)
                break;
            if(map == null)
            {
                map = new HashMap();
                array = map;
                objectTable.add(array);
                if(isDebug)
                    trace.startECMAArray(objectTable.size() - 1);
            }
            Object value = readObject();
            map.put(name, value);
        } while(true);
        if(map == null)
        {
            List list = new ArrayList(len);
            array = list;
            objectTable.add(array);
            if(isDebug)
                trace.startAMFArray(objectTable.size() - 1);
            for(int i = 0; i < len; i++)
            {
                if(isDebug)
                    trace.arrayElement(i);
                Object item = readObject();
                list.add(i, item);
            }

        } else
        {
            for(int i = 0; i < len; i++)
            {
                if(isDebug)
                    trace.arrayElement(i);
                Object item = readObject();
                map.put(Integer.toString(i), item);
            }

        }
        if(isDebug)
            trace.endAMFArray();
        if(!context.legacyCollection && (array instanceof List))
            return ((Object) (((List)array).toArray()));
        else
            return array;
    }

    private Object readScriptObject()
        throws ClassNotFoundException, IOException
    {
        int ref = readUInt29();
        if((ref & 1) == 0)
            return getObjectReference(ref >> 1);
        TraitsInfo ti = readTraits(ref);
        String className = ti.getClassName();
        boolean externalizable = ti.isExternalizable();
        Object object = beanProxy.createInstance(className);
        PropertyProxy proxy = PropertyProxyRegistry.getProxyAndRegister(object);
        objectTable.add(object);
        if(externalizable)
        {
            readExternalizable(className, object);
        } else
        {
            if(isDebug)
                trace.startAMFObject(className, objectTable.size() - 1);
            int len = ti.getProperties().size();
            for(int i = 0; i < len; i++)
            {
                String propName = ti.getProperty(i);
                if(isDebug)
                    trace.namedElement(propName);
                Object value = readObject();
                proxy.setValue(object, propName, value);
            }

            if(ti.isDynamic())
                do
                {
                    String name = readString();
                    if(name == null || name.length() == 0)
                        break;
                    if(isDebug)
                        trace.namedElement(name);
                    Object value = readObject();
                    proxy.setValue(object, name, value);
                } while(true);
        }
        if(isDebug)
            trace.endAMFObject();
        return object;
    }

    private void readExternalizable(String className, Object object)
        throws ClassNotFoundException, IOException
    {
        if(object instanceof Externalizable)
        {
            if(isDebug)
                trace.startExternalizableObject(className, objectTable.size() - 1);
            ((Externalizable)object).readExternal(this);
        } else
        {
            SerializationException ex = new SerializationException();
            ex.setMessage(10305, new Object[] {
                object.getClass().getName()
            });
            throw ex;
        }
    }

    private byte[] readByteArray()
        throws IOException
    {
        int ref = readUInt29();
        if((ref & 1) == 0)
            return (byte[])(byte[])getObjectReference(ref >> 1);
        int len = ref >> 1;
        byte ba[] = new byte[len];
        objectTable.add(ba);
        in.readFully(ba, 0, len);
        if(isDebug)
            trace.startByteArray(objectTable.size() - 1, len);
        return ba;
    }

    private TraitsInfo readTraits(int ref)
        throws IOException
    {
        if((ref & 3) == 1)
            return getTraitReference(ref >> 2);
        boolean externalizable = (ref & 4) == 4;
        boolean dynamic = (ref & 8) == 8;
        int count = ref >> 4;
        String className = readString();
        TraitsInfo ti = new TraitsInfo(className, dynamic, externalizable, count);
        traitsTable.add(ti);
        for(int i = 0; i < count; i++)
        {
            String propName = readString();
            ti.addProperty(propName);
        }

        return ti;
    }

    private String readUTF(int utflen)
        throws IOException
    {
        char charr[] = getTempCharArray(utflen);
        byte bytearr[] = getTempByteArray(utflen);
        int count = 0;
        int chCount = 0;
        in.readFully(bytearr, 0, utflen);
        while(count < utflen) 
        {
            int c = bytearr[count] & 0xff;
            switch(c >> 4)
            {
            case 0: // '\0'
            case 1: // '\001'
            case 2: // '\002'
            case 3: // '\003'
            case 4: // '\004'
            case 5: // '\005'
            case 6: // '\006'
            case 7: // '\007'
            {
                count++;
                charr[chCount] = (char)c;
                break;
            }

            case 12: // '\f'
            case 13: // '\r'
            {
                if((count += 2) > utflen)
                    throw new UTFDataFormatException();
                int char2 = bytearr[count - 1];
                if((char2 & 0xc0) != 128)
                    throw new UTFDataFormatException();
                charr[chCount] = (char)((c & 0x1f) << 6 | char2 & 0x3f);
                break;
            }

            case 14: // '\016'
            {
                if((count += 3) > utflen)
                    throw new UTFDataFormatException();
                int char2 = bytearr[count - 2];
                int char3 = bytearr[count - 1];
                if((char2 & 0xc0) != 128 || (char3 & 0xc0) != 128)
                    throw new UTFDataFormatException();
                charr[chCount] = (char)((c & 0xf) << 12 | (char2 & 0x3f) << 6 | (char3 & 0x3f) << 0);
                break;
            }

            case 8: // '\b'
            case 9: // '\t'
            case 10: // '\n'
            case 11: // '\013'
            default:
            {
                throw new UTFDataFormatException();
            }
            }
            chCount++;
        }
        return new String(charr, 0, chCount);
    }

    private int readUInt29()
        throws IOException
    {
        int b = in.readByte() & 0xff;
        if(b < 128)
            return b;
        int value = (b & 0x7f) << 7;
        b = in.readByte() & 0xff;
        if(b < 128)
            return value | b;
        value = (value | b & 0x7f) << 7;
        b = in.readByte() & 0xff;
        if(b < 128)
        {
            return value | b;
        } else
        {
            value = (value | b & 0x7f) << 8;
            b = in.readByte() & 0xff;
            return value | b;
        }
    }

    private Object readXml()
        throws IOException
    {
        String xml = readXmlString();
        return xmlDeserializer.createObject(null, xml);
    }

    private String readXmlString()
        throws IOException
    {
        int ref = readUInt29();
        if((ref & 1) == 0)
            return (String)getObjectReference(ref >> 1);
        int len = ref >> 1;
        if(0 == len)
            return "";
        String str = readUTF(len);
        objectTable.add(str);
        if(isDebug)
            trace.write(str);
        return str;
    }

    private Object getObjectReference(int ref)
    {
        if(isDebug)
            trace.writeRef(ref);
        return objectTable.get(ref);
    }

    private String getStringReference(int ref)
    {
        String str = (String)stringTable.get(ref);
        if(Trace.amf && isDebug)
            trace.writeStringRef(ref);
        return str;
    }

    private TraitsInfo getTraitReference(int ref)
    {
        if(Trace.amf && isDebug)
            trace.writeTraitsInfoRef(ref);
        return (TraitsInfo)traitsTable.get(ref);
    }

    private List objectTable;
    private List stringTable;
    private List traitsTable;
}
