// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Amf3Output.java

package flex.messaging.io.amf;

import flex.messaging.MessageException;
import flex.messaging.io.*;
import flex.messaging.io.amf.serializers.CustomSerializer;
import flex.messaging.util.Trace;
import java.io.*;
import java.lang.reflect.Array;
import java.util.*;
import javax.sql.RowSet;
import org.w3c.dom.Document;

// Referenced classes of package flex.messaging.io.amf:
//            AbstractAmfOutput, ASObject, TraitsInfo, Amf3Types, 
//            AmfTrace

public class Amf3Output extends AbstractAmfOutput
    implements Amf3Types
{

    public Amf3Output(SerializationContext context)
    {
        super(context);
        objectTable = new IdentityHashMap(64);
        traitsTable = new HashMap(10);
        stringTable = new HashMap(64);
        context.supportDatesByReference = true;
    }

    public void reset()
    {
        super.reset();
        objectTable.clear();
        traitsTable.clear();
        stringTable.clear();
    }

    public void writeObject(Object o)
        throws IOException
    {
        if(o == null)
        {
            writeAMFNull();
            return;
        }
        if((o instanceof String) || (o instanceof Character))
        {
            String s = o.toString();
            writeAMFString(s);
        } else
        if(o instanceof Number)
        {
            if((o instanceof Integer) || (o instanceof Short) || (o instanceof Byte))
            {
                int i = ((Number)o).intValue();
                writeAMFInt(i);
            } else
            {
                double d = ((Number)o).doubleValue();
                writeAMFDouble(d);
            }
        } else
        if(o instanceof Boolean)
            writeAMFBoolean(((Boolean)o).booleanValue());
        else
        if(o instanceof Date)
            writeAMFDate((Date)o);
        else
        if(o instanceof Calendar)
            writeAMFDate(((Calendar)o).getTime());
        else
        if(o instanceof Document)
        {
            if(context.legacyXMLDocument)
                out.write(7);
            else
                out.write(11);
            documentSerializer.writeObject(this, o);
        } else
        {
            Class cls = o.getClass();
            if((o instanceof Map) && context.legacyMap && !(o instanceof ASObject))
                writeMapAsECMAArray((Map)o);
            else
            if(o instanceof Collection)
            {
                if(context.legacyCollection)
                    writeCollection((Collection)o, null);
                else
                    writeArrayCollection((Collection)o, null);
            } else
            if(cls.isArray())
            {
                writeAMFArray(o, cls.getComponentType());
            } else
            {
                if(o instanceof RowSet)
                    o = new PagedRowSet((RowSet)o, 0x7fffffff, false);
                else
                if((o instanceof Throwable) && context.legacyThrowable)
                    o = new StatusInfoProxy((Throwable)o);
                writeCustomObject(o);
            }
        }
    }

    public void writeObjectTraits(TraitsInfo ti)
        throws IOException
    {
        String className = ti.getClassName();
        if(isDebug)
            if(ti.isExternalizable())
                trace.startExternalizableObject(className, objectTable.size() - 1);
            else
                trace.startAMFObject(className, objectTable.size() - 1);
        if(!byReference(ti))
        {
            int count = 0;
            List propertyNames = null;
            boolean externalizable = ti.isExternalizable();
            if(!externalizable)
            {
                propertyNames = ti.getProperties();
                if(propertyNames != null)
                    count = propertyNames.size();
            }
            boolean dynamic = ti.isDynamic();
            writeUInt29(3 | (externalizable ? 4 : 0) | (dynamic ? 8 : 0) | count << 4);
            writeStringWithoutType(className);
            if(!externalizable && propertyNames != null)
            {
                for(int i = 0; i < count; i++)
                {
                    String propName = ti.getProperty(i);
                    writeStringWithoutType(propName);
                }

            }
        }
    }

    public void writeObjectProperty(String name, Object value)
        throws IOException
    {
        if(isDebug)
            trace.namedElement(name);
        writeObject(value);
    }

    public void writeObjectEnd()
        throws IOException
    {
        if(isDebug)
            trace.endAMFObject();
    }

    private void writeAMFBoolean(boolean b)
        throws IOException
    {
        if(isDebug)
            trace.write(b);
        if(b)
            out.write(3);
        else
            out.write(2);
    }

    private void writeAMFDate(Date d)
        throws IOException
    {
        out.write(8);
        if(!byReference(d))
        {
            if(isDebug)
                trace.write(d);
            writeUInt29(1);
            out.writeDouble(d.getTime());
        }
    }

    private void writeAMFDouble(double d)
        throws IOException
    {
        if(isDebug)
            trace.write(d);
        out.write(5);
        out.writeDouble(d);
    }

    private void writeAMFInt(int i)
        throws IOException
    {
        if(i >= 0xf0000000 && i <= 0xfffffff)
        {
            if(isDebug)
                trace.write(i);
            i &= 0x1fffffff;
            out.write(4);
            writeUInt29(i);
        } else
        {
            writeAMFDouble(i);
        }
    }

    private void writeMapAsECMAArray(Map map)
        throws IOException
    {
        out.write(9);
        if(!byReference(map))
        {
            if(isDebug)
                trace.startECMAArray(objectTable.size() - 1);
            writeUInt29(1);
            Iterator it = map.keySet().iterator();
            do
            {
                if(!it.hasNext())
                    break;
                Object key = it.next();
                if(key != null)
                {
                    String propName = key.toString();
                    writeStringWithoutType(propName);
                    if(isDebug)
                        trace.namedElement(propName);
                    writeObject(map.get(key));
                }
            } while(true);
            writeStringWithoutType("");
            if(isDebug)
                trace.endAMFArray();
        }
    }

    private void writeAMFNull()
        throws IOException
    {
        if(isDebug)
            trace.writeNull();
        out.write(1);
    }

    private void writeAMFString(String s)
        throws IOException
    {
        out.write(6);
        writeStringWithoutType(s);
        if(isDebug)
            trace.writeString(s);
    }

    private void writeStringWithoutType(String s)
        throws IOException
    {
        if(s.length() == 0)
        {
            writeUInt29(1);
            return;
        }
        if(!byReference(s))
        {
            writeAMFUTF(s);
            return;
        } else
        {
            return;
        }
    }

    public void writeStringAsXML(String str)
        throws IOException
    {
        if(isDebug)
            trace.write(str);
        writeAMFUTF(str);
    }

    private void writeAMFArray(Object o, Class componentType)
        throws IOException
    {
        if(componentType.isPrimitive())
            writePrimitiveArray(o);
        else
        if(componentType.equals(java.lang.Byte.class))
            writeAMFByteArray((Byte[])(Byte[])o);
        else
        if(componentType.equals(java.lang.Character.class))
            writeCharArrayAsString((Character[])(Character[])o);
        else
            writeObjectArray((Object[])(Object[])o, null);
    }

    private void writeArrayCollection(Collection col, SerializationDescriptor desc)
        throws IOException
    {
        out.write(10);
        if(!byReference(col))
        {
            ArrayCollection ac;
            if(col instanceof ArrayCollection)
            {
                ac = (ArrayCollection)col;
            } else
            {
                ac = new ArrayCollection(col);
                if(desc != null)
                    ac.setDescriptor(desc);
            }
            PropertyProxy proxy = PropertyProxyRegistry.getProxy(ac);
            writePropertyProxy(proxy, ac);
        }
    }

    private void writeCustomObject(Object o)
        throws IOException
    {
        PropertyProxy proxy = null;
        if(o instanceof PropertyProxy)
        {
            proxy = (PropertyProxy)o;
            o = proxy.getDefaultInstance();
            if(o == null)
            {
                writeAMFNull();
                return;
            }
            if(o instanceof Collection)
            {
                if(context.legacyCollection)
                    writeCollection((Collection)o, proxy.getDescriptor());
                else
                    writeArrayCollection((Collection)o, proxy.getDescriptor());
                return;
            }
            if(o.getClass().isArray())
            {
                writeObjectArray((Object[])(Object[])o, proxy.getDescriptor());
                return;
            }
            if(context.legacyMap && (o instanceof Map) && !(o instanceof ASObject))
            {
                writeMapAsECMAArray((Map)o);
                return;
            }
        }
        out.write(10);
        if(!byReference(o))
        {
            if(proxy == null)
                proxy = PropertyProxyRegistry.getProxyAndRegister(o);
            writePropertyProxy(proxy, o);
        }
    }

    private void writePropertyProxy(PropertyProxy proxy, Object instance)
        throws IOException
    {
        List propertyNames = null;
        boolean externalizable = proxy.isExternalizable(instance);
        if(!externalizable)
            propertyNames = proxy.getPropertyNames(instance);
        TraitsInfo ti = new TraitsInfo(proxy.getAlias(instance), proxy.isDynamic(), externalizable, propertyNames);
        writeObjectTraits(ti);
        if(externalizable)
            ((Externalizable)instance).writeExternal(this);
        else
        if(propertyNames != null)
        {
            String propName;
            Object value;
            for(Iterator it = propertyNames.iterator(); it.hasNext(); writeObjectProperty(propName, value))
            {
                propName = (String)it.next();
                value = null;
                value = proxy.getValue(instance, propName);
            }

        }
        writeObjectEnd();
    }

    private void writePrimitiveArray(Object obj)
        throws IOException
    {
        Class aType = obj.getClass().getComponentType();
        if(aType.equals(Character.TYPE))
        {
            char c[] = (char[])(char[])obj;
            writeCharArrayAsString(c);
        } else
        if(aType.equals(Byte.TYPE))
        {
            writeAMFByteArray((byte[])(byte[])obj);
        } else
        {
            out.write(9);
            if(!byReference(obj))
                if(aType.equals(Boolean.TYPE))
                {
                    boolean b[] = (boolean[])(boolean[])obj;
                    writeUInt29(b.length << 1 | 1);
                    writeStringWithoutType("");
                    if(isDebug)
                    {
                        trace.startAMFArray(objectTable.size() - 1);
                        for(int i = 0; i < b.length; i++)
                        {
                            trace.arrayElement(i);
                            writeAMFBoolean(b[i]);
                        }

                        trace.endAMFArray();
                    } else
                    {
                        for(int i = 0; i < b.length; i++)
                            writeAMFBoolean(b[i]);

                    }
                } else
                if(aType.equals(Integer.TYPE) || aType.equals(Short.TYPE))
                {
                    int length = Array.getLength(obj);
                    writeUInt29(length << 1 | 1);
                    writeStringWithoutType("");
                    if(isDebug)
                    {
                        trace.startAMFArray(objectTable.size() - 1);
                        for(int i = 0; i < length; i++)
                        {
                            trace.arrayElement(i);
                            int v = Array.getInt(obj, i);
                            writeAMFInt(v);
                        }

                        trace.endAMFArray();
                    } else
                    {
                        for(int i = 0; i < length; i++)
                        {
                            int v = Array.getInt(obj, i);
                            writeAMFInt(v);
                        }

                    }
                } else
                {
                    int length = Array.getLength(obj);
                    writeUInt29(length << 1 | 1);
                    writeStringWithoutType("");
                    if(isDebug)
                    {
                        trace.startAMFArray(objectTable.size() - 1);
                        for(int i = 0; i < length; i++)
                        {
                            trace.arrayElement(i);
                            double v = Array.getDouble(obj, i);
                            writeAMFDouble(v);
                        }

                        trace.endAMFArray();
                    } else
                    {
                        for(int i = 0; i < length; i++)
                        {
                            double v = Array.getDouble(obj, i);
                            writeAMFDouble(v);
                        }

                    }
                }
        }
    }

    private void writeAMFByteArray(byte ba[])
        throws IOException
    {
        out.write(12);
        if(!byReference(ba))
        {
            int length = ba.length;
            writeUInt29(length << 1 | 1);
            if(isDebug)
                trace.startByteArray(objectTable.size() - 1, length);
            out.write(ba, 0, length);
        }
    }

    private void writeAMFByteArray(Byte ba[])
        throws IOException
    {
        out.write(12);
        if(!byReference(ba))
        {
            int length = ba.length;
            writeUInt29(length << 1 | 1);
            if(isDebug)
                trace.startByteArray(objectTable.size() - 1, length);
            for(int i = 0; i < ba.length; i++)
            {
                Byte b = ba[i];
                if(b == null)
                    out.write(0);
                else
                    out.write(b.byteValue());
            }

        }
    }

    private void writeCharArrayAsString(Character ca[])
        throws IOException
    {
        int length = ca.length;
        char chars[] = new char[length];
        for(int i = 0; i < length; i++)
        {
            Character c = ca[i];
            if(c == null)
                chars[i] = '\0';
            else
                chars[i] = ca[i].charValue();
        }

        writeCharArrayAsString(chars);
    }

    private void writeCharArrayAsString(char ca[])
        throws IOException
    {
        String str = new String(ca);
        writeAMFString(str);
    }

    private void writeObjectArray(Object values[], SerializationDescriptor descriptor)
        throws IOException
    {
        out.write(9);
        if(!byReference(((Object) (values))))
        {
            if(isDebug)
                trace.startAMFArray(objectTable.size() - 1);
            writeUInt29(values.length << 1 | 1);
            writeStringWithoutType("");
            for(int i = 0; i < values.length; i++)
            {
                if(isDebug)
                    trace.arrayElement(i);
                Object item = values[i];
                if(item != null && descriptor != null && !(item instanceof String) && !(item instanceof Number) && !(item instanceof Boolean) && !(item instanceof Character))
                {
                    PropertyProxy proxy = PropertyProxyRegistry.getProxy(item);
                    proxy = (PropertyProxy)proxy.clone();
                    proxy.setDescriptor(descriptor);
                    proxy.setDefaultInstance(item);
                    item = proxy;
                }
                writeObject(item);
            }

            if(isDebug)
                trace.endAMFArray();
        }
    }

    private void writeCollection(Collection c, SerializationDescriptor descriptor)
        throws IOException
    {
        out.write(9);
        if(!byReference(c))
        {
            if(isDebug)
                trace.startAMFArray(objectTable.size() - 1);
            writeUInt29(c.size() << 1 | 1);
            writeStringWithoutType("");
            Iterator it = c.iterator();
            for(int i = 0; it.hasNext(); i++)
            {
                if(isDebug)
                    trace.arrayElement(i);
                Object item = it.next();
                if(item != null && descriptor != null && !(item instanceof String) && !(item instanceof Number) && !(item instanceof Boolean) && !(item instanceof Character))
                {
                    PropertyProxy proxy = PropertyProxyRegistry.getProxy(item);
                    proxy = (PropertyProxy)proxy.clone();
                    proxy.setDescriptor(descriptor);
                    proxy.setDefaultInstance(item);
                    item = proxy;
                }
                writeObject(item);
            }

            if(isDebug)
                trace.endAMFArray();
        }
    }

    private void writeUInt29(int ref)
        throws IOException
    {
        if(ref < 128)
            out.writeByte(ref);
        else
        if(ref < 16384)
        {
            out.writeByte(ref >> 7 & 0x7f | 0x80);
            out.writeByte(ref & 0x7f);
        } else
        if(ref < 0x200000)
        {
            out.writeByte(ref >> 14 & 0x7f | 0x80);
            out.writeByte(ref >> 7 & 0x7f | 0x80);
            out.writeByte(ref & 0x7f);
        } else
        if(ref < 0x40000000)
        {
            out.writeByte(ref >> 22 & 0x7f | 0x80);
            out.writeByte(ref >> 15 & 0x7f | 0x80);
            out.writeByte(ref >> 8 & 0x7f | 0x80);
            out.writeByte(ref & 0xff);
        } else
        {
            throw new MessageException("Integer out of range: " + ref);
        }
    }

    public void writeAMFUTF(String s)
        throws IOException
    {
        int strlen = s.length();
        int utflen = 0;
        int count = 0;
        char charr[] = getTempCharArray(strlen);
        s.getChars(0, strlen, charr, 0);
        for(int i = 0; i < strlen; i++)
        {
            int c = charr[i];
            if(c <= 127)
            {
                utflen++;
                continue;
            }
            if(c > 2047)
                utflen += 3;
            else
                utflen += 2;
        }

        writeUInt29(utflen << 1 | 1);
        byte bytearr[] = getTempByteArray(utflen);
        for(int i = 0; i < strlen; i++)
        {
            int c = charr[i];
            if(c <= 127)
            {
                bytearr[count++] = (byte)c;
                continue;
            }
            if(c > 2047)
            {
                bytearr[count++] = (byte)(0xe0 | c >> 12 & 0xf);
                bytearr[count++] = (byte)(0x80 | c >> 6 & 0x3f);
                bytearr[count++] = (byte)(0x80 | c >> 0 & 0x3f);
            } else
            {
                bytearr[count++] = (byte)(0xc0 | c >> 6 & 0x1f);
                bytearr[count++] = (byte)(0x80 | c >> 0 & 0x3f);
            }
        }

        out.write(bytearr, 0, utflen);
    }

    private boolean byReference(Object o)
        throws IOException
    {
        Object ref = objectTable.get(o);
        if(ref != null)
            try
            {
                int refNum = ((Integer)ref).intValue();
                if(isDebug)
                    trace.writeRef(refNum);
                writeUInt29(refNum << 1);
            }
            catch(ClassCastException e)
            {
                throw new IOException("Object reference is not an Integer");
            }
        else
            objectTable.put(o, new Integer(objectTable.size()));
        return ref != null;
    }

    public void addObjectReference(Object o)
        throws IOException
    {
        byReference(o);
    }

    private boolean byReference(String s)
        throws IOException
    {
        Object ref = stringTable.get(s);
        if(ref != null)
            try
            {
                int refNum = ((Integer)ref).intValue();
                writeUInt29(refNum << 1);
                if(Trace.amf && isDebug)
                    trace.writeStringRef(refNum);
            }
            catch(ClassCastException e)
            {
                throw new IOException("String reference is not an Integer");
            }
        else
            stringTable.put(s, new Integer(stringTable.size()));
        return ref != null;
    }

    private boolean byReference(TraitsInfo ti)
        throws IOException
    {
        Object ref = traitsTable.get(ti);
        if(ref != null)
            try
            {
                int refNum = ((Integer)ref).intValue();
                writeUInt29(refNum << 2 | 1);
                if(Trace.amf && isDebug)
                    trace.writeTraitsInfoRef(refNum);
            }
            catch(ClassCastException e)
            {
                throw new IOException("TraitsInfo reference is not an Integer");
            }
        else
            traitsTable.put(ti, new Integer(traitsTable.size()));
        return ref != null;
    }

    private IdentityHashMap objectTable;
    private HashMap traitsTable;
    private HashMap stringTable;
}
