// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AmfMessageDeserializer.java

package flex.messaging.io.amf;

import flex.messaging.MessageException;
import flex.messaging.io.*;
import java.io.*;

// Referenced classes of package flex.messaging.io.amf:
//            Amf0Input, MessageHeader, MessageBody, AmfTrace, 
//            ActionMessageInput, ActionMessage, ActionContext

public class AmfMessageDeserializer
    implements MessageDeserializer
{

    public AmfMessageDeserializer(SerializationContext context)
    {
        amfIn = new Amf0Input(context);
    }

    public void setDebugTrace(AmfTrace trace)
    {
        debugTrace = trace;
        isDebug = debugTrace != null;
    }

    public void setInputStream(InputStream in)
    {
        this.in = new DataInputStream(in);
    }

    public void readMessage(ActionMessage m, ActionContext context)
        throws ClassNotFoundException, IOException
    {
        if(isDebug)
            debugTrace.startRequest("Deserializing AMF/HTTP request");
        amfIn.setInputStream(in);
        amfIn.setDebugTrace(debugTrace);
        int version = in.readUnsignedShort();
        if(version != 0 && version != 3)
        {
            MessageException ex = new MessageException();
            ex.setMessage(10310, new Object[] {
                new Integer(version)
            });
            ex.setCode("VersionMismatch");
            throw ex;
        }
        m.setVersion(version);
        context.setVersion(version);
        if(isDebug)
            debugTrace.version(version);
        int headerCount = in.readUnsignedShort();
        for(int i = 0; i < headerCount; i++)
        {
            MessageHeader header = new MessageHeader();
            m.addHeader(header);
            readHeader(header, i);
        }

        int bodyCount = in.readUnsignedShort();
        for(int i = 0; i < bodyCount; i++)
        {
            MessageBody body = new MessageBody();
            m.addBody(body);
            readBody(body, i);
        }

    }

    public void readHeader(MessageHeader header, int index)
        throws ClassNotFoundException, IOException
    {
        String name = in.readUTF();
        header.setName(name);
        boolean mustUnderstand = in.readBoolean();
        header.setMustUnderstand(mustUnderstand);
        in.readInt();
        amfIn.reset();
        Object data = null;
        if(isDebug)
            debugTrace.startHeader(name, mustUnderstand, index);
        try
        {
            data = amfIn.readObject();
        }
        catch(RecoverableSerializationException ex)
        {
            ex.setCode("Client.Header.Encoding");
            data = ex;
        }
        catch(MessageException ex)
        {
            ex.setCode("Client.Header.Encoding");
            throw ex;
        }
        header.setData(data);
        if(isDebug)
            debugTrace.endHeader();
    }

    public void readBody(MessageBody body, int index)
        throws ClassNotFoundException, IOException
    {
        String targetURI = in.readUTF();
        body.setTargetURI(targetURI);
        String responseURI = in.readUTF();
        body.setResponseURI(responseURI);
        in.readInt();
        amfIn.reset();
        Object data = null;
        if(isDebug)
            debugTrace.startMessage(targetURI, responseURI, index);
        try
        {
            data = amfIn.readObject();
        }
        catch(RecoverableSerializationException ex)
        {
            ex.setCode("Client.Message.Encoding");
            data = ex;
        }
        catch(MessageException ex)
        {
            ex.setCode("Client.Message.Encoding");
            throw ex;
        }
        body.setData(data);
        if(isDebug)
            debugTrace.endMessage();
    }

    private static final int UNSUPPORTED_AMF_VERSION = 10310;
    private DataInputStream in;
    private ActionMessageInput amfIn;
    private AmfTrace debugTrace;
    private boolean isDebug;
}
