// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AmfMessageSerializer.java

package flex.messaging.io.amf;

import flex.messaging.io.MessageSerializer;
import flex.messaging.io.SerializationContext;
import java.io.*;

// Referenced classes of package flex.messaging.io.amf:
//            Amf0Output, AmfTrace, ActionMessage, MessageHeader, 
//            MessageBody

public class AmfMessageSerializer
    implements MessageSerializer
{

    public void setDebugBuffer(AmfTrace debugBuffer)
    {
        this.debugBuffer = debugBuffer;
        isDebug = debugBuffer != null;
    }

    public AmfMessageSerializer(SerializationContext context)
    {
        amfOut = new Amf0Output(context);
    }

    public void setOutputStream(OutputStream out)
    {
        dataOut = new DataOutputStream(out);
    }

    public void writeMessage(ActionMessage m)
        throws IOException
    {
        if(isDebug)
            debugBuffer.startResponse("Serializing AMF/HTTP response");
        int version = m.getVersion();
        amfOut.setOutputStream(dataOut);
        amfOut.setDebugTrace(debugBuffer);
        amfOut.setAvmPlus(version > 0);
        dataOut.writeShort(version);
        if(isDebug)
            debugBuffer.version(version);
        int headerCount = m.getHeaderCount();
        dataOut.writeShort(headerCount);
        for(int i = 0; i < headerCount; i++)
        {
            MessageHeader header = m.getHeader(i);
            if(isDebug)
                debugBuffer.startHeader(header.getName(), header.getMustUnderstand(), i);
            writeHeader(header);
            if(isDebug)
                debugBuffer.endHeader();
        }

        int bodyCount = m.getBodyCount();
        dataOut.writeShort(bodyCount);
        for(int i = 0; i < bodyCount; i++)
        {
            MessageBody body = m.getBody(i);
            if(isDebug)
                debugBuffer.startMessage(body.getTargetURI(), body.getResponseURI(), i);
            writeBody(body);
            if(isDebug)
                debugBuffer.endMessage();
        }

    }

    public void writeHeader(MessageHeader h)
        throws IOException
    {
        dataOut.writeUTF(h.getName());
        dataOut.writeBoolean(h.getMustUnderstand());
        dataOut.writeInt(-1);
        amfOut.reset();
        amfOut.writeObject(h.getData());
    }

    public void writeBody(MessageBody b)
        throws IOException
    {
        if(b.getTargetURI() == null)
            dataOut.writeUTF("null");
        else
            dataOut.writeUTF(b.getTargetURI());
        if(b.getResponseURI() == null)
            dataOut.writeUTF("null");
        else
            dataOut.writeUTF(b.getResponseURI());
        dataOut.writeInt(-1);
        amfOut.reset();
        Object data = b.getData();
        amfOut.writeObject(data);
    }

    private static final int UNKNOWN_CONTENT_LENGTH = -1;
    private DataOutputStream dataOut;
    private Amf0Output amfOut;
    private boolean isDebug;
    private AmfTrace debugBuffer;
}
