// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TraitsInfo.java

package flex.messaging.io.amf;

import java.util.*;

public class TraitsInfo
{

    public TraitsInfo(String className)
    {
        this(className, false, false, 10);
    }

    public TraitsInfo(String className, int initialCount)
    {
        this(className, false, false, initialCount);
    }

    public TraitsInfo(String className, boolean dynamic, boolean externalizable, int initialCount)
    {
        this(className, dynamic, externalizable, ((List) (new ArrayList(initialCount))));
    }

    public TraitsInfo(String className, boolean dynamic, boolean externalizable, List properties)
    {
        if(className == null)
            className = "";
        this.className = className;
        if(properties == null)
            properties = new ArrayList();
        this.properties = properties;
        this.dynamic = dynamic;
        this.externalizable = externalizable;
    }

    public boolean isDynamic()
    {
        return dynamic;
    }

    public boolean isExternalizable()
    {
        return externalizable;
    }

    public int length()
    {
        return properties.size();
    }

    public String getClassName()
    {
        return className;
    }

    public void addProperty(String name)
    {
        properties.add(name);
    }

    public void addAllProperties(Collection props)
    {
        properties.addAll(props);
    }

    public String getProperty(int i)
    {
        return (String)properties.get(i);
    }

    public List getProperties()
    {
        return properties;
    }

    public boolean equals(Object obj)
    {
        if(obj == this)
            return true;
        if(obj instanceof TraitsInfo)
        {
            TraitsInfo other = (TraitsInfo)obj;
            if(!className.equals(other.className))
                return false;
            if(dynamic != other.dynamic)
                return false;
            List thisProperties = properties;
            List otherProperties = other.properties;
            int thisCount = thisProperties.size();
            int otherCount = otherProperties.size();
            if(thisCount != otherCount)
                return false;
            for(int i = 0; i < thisCount; i++)
            {
                Object thisProp = thisProperties.get(i);
                Object otherProp = otherProperties.get(i);
                if(thisProp != null && otherProp != null && !thisProp.equals(otherProp))
                    return false;
            }

            return true;
        } else
        {
            return false;
        }
    }

    public int hashCode()
    {
        int c = className.hashCode();
        c = dynamic ? c << 2 : c << 1;
        c |= properties.size() << 24;
        return c;
    }

    private final String className;
    private final boolean dynamic;
    private final boolean externalizable;
    private List properties;
}
