// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DecoderFactory.java

package flex.messaging.io.amf.translator.decoder;

import flex.messaging.io.TypeMarshallingContext;
import flex.messaging.io.amf.ASObject;
import flex.messaging.io.amf.translator.TranslationException;
import java.util.Date;

// Referenced classes of package flex.messaging.io.amf.translator.decoder:
//            NativeDecoder, NullDecoder, NumberDecoder, StringDecoder, 
//            BooleanDecoder, CharacterDecoder, DateDecoder, CalendarDecoder, 
//            ArrayDecoder, MapDecoder, CollectionDecoder, TypedObjectDecoder, 
//            ReferenceAwareArrayDecoder, ReferenceAwareMapDecoder, ReferenceAwareCollectionDecoder, ReferenceAwareTypedObjectDecoder, 
//            ActionScriptDecoder

public class DecoderFactory
{

    public DecoderFactory()
    {
    }

    public static ActionScriptDecoder getDecoderForShell(Class desiredClass)
    {
        if(desiredClass == null)
            return nullDecoder;
        if((java.util.Collection.class).isAssignableFrom(desiredClass))
            return collectionDecoder;
        if((java.util.Map.class).isAssignableFrom(desiredClass))
            return mapDecoder;
        if(desiredClass.isArray())
            return arrayDecoder;
        else
            return nativeDecoder;
    }

    public static ActionScriptDecoder getDecoder(Object encodedObject, Class desiredClass)
    {
        if(encodedObject != null)
        {
            if(desiredClass.isAssignableFrom(encodedObject.getClass()))
                return nativeDecoder;
            if((java.lang.String.class).equals(desiredClass))
                return stringDecoder;
            if(isNumber(desiredClass))
                return numberDecoder;
            if(isBoolean(desiredClass))
                return booleanDecoder;
            if((java.util.Collection.class).isAssignableFrom(desiredClass))
                return collectionDecoder;
            if((java.util.Map.class).isAssignableFrom(desiredClass))
                return mapDecoder;
            if(desiredClass.isArray())
                return arrayDecoder;
            if(isTypedObject(encodedObject))
                return typedObjectDecoder;
            if((java.util.Date.class).isAssignableFrom(desiredClass))
                return dateDecoder;
            if((java.util.Calendar.class).isAssignableFrom(desiredClass))
                return calendarDecoder;
        }
        if(isNumber(desiredClass))
            return numberDecoder;
        if(isBoolean(desiredClass))
            return booleanDecoder;
        if(isCharacter(desiredClass))
            return characterDecoder;
        if(encodedObject == null)
        {
            return nullDecoder;
        } else
        {
            invalidType(encodedObject, desiredClass);
            return nativeDecoder;
        }
    }

    public static ActionScriptDecoder getReferenceAwareDecoder(Object encodedObject, Class desiredClass)
    {
        if(encodedObject != null)
        {
            if((java.lang.String.class).equals(desiredClass))
                return stringDecoder;
            if(isNumber(desiredClass))
                return numberDecoder;
            if(isBoolean(desiredClass))
                return booleanDecoder;
            if((java.util.Collection.class).isAssignableFrom(desiredClass))
                return deepCollectionDecoder;
            if((java.util.Map.class).isAssignableFrom(desiredClass))
                return deepMapDecoder;
            if(desiredClass.isArray())
                return deepArrayDecoder;
            if(isTypedObject(encodedObject))
                return deepTypedObjectDecoder;
            if((java.util.Date.class).isAssignableFrom(desiredClass))
                return dateDecoder;
            if((java.util.Calendar.class).isAssignableFrom(desiredClass))
                return calendarDecoder;
            if(isCharacter(desiredClass))
                return characterDecoder;
            if(desiredClass.isAssignableFrom(encodedObject.getClass()))
                return nativeDecoder;
        }
        if(isNumber(desiredClass))
            return numberDecoder;
        if(isBoolean(desiredClass))
            return booleanDecoder;
        if(isCharacter(desiredClass))
            return characterDecoder;
        if(encodedObject == null)
        {
            return nullDecoder;
        } else
        {
            invalidType(encodedObject, desiredClass);
            return nativeDecoder;
        }
    }

    public static boolean isNumber(Class desiredClass)
    {
        boolean isNum = false;
        if(desiredClass.isPrimitive())
        {
            if(desiredClass.equals(Integer.TYPE) || desiredClass.equals(Double.TYPE) || desiredClass.equals(Long.TYPE) || desiredClass.equals(Float.TYPE) || desiredClass.equals(Short.TYPE) || desiredClass.equals(Byte.TYPE))
                isNum = true;
        } else
        if((java.lang.Number.class).isAssignableFrom(desiredClass))
            isNum = true;
        return isNum;
    }

    public static boolean isCharacter(Class desiredClass)
    {
        boolean isChar = false;
        if(desiredClass.isPrimitive() && desiredClass.equals(Character.TYPE))
            isChar = true;
        else
        if(desiredClass.equals(java.lang.Character.class))
            isChar = true;
        return isChar;
    }

    public static boolean isBoolean(Class desiredClass)
    {
        boolean isBool = false;
        if(desiredClass.isPrimitive() && desiredClass.equals(Boolean.TYPE))
            isBool = true;
        else
        if(desiredClass.equals(java.lang.Boolean.class))
            isBool = true;
        return isBool;
    }

    public static boolean isCharArray(Class desiredClass)
    {
        boolean isCharArray = false;
        if(desiredClass.isArray())
        {
            Class type = desiredClass.getComponentType();
            if(type != null && type.equals(Character.TYPE))
                isCharArray = true;
        }
        return isCharArray;
    }

    public static boolean isTypedObject(Object encodedObject)
    {
        boolean typed = false;
        if(encodedObject instanceof ASObject)
            typed = TypeMarshallingContext.getType((ASObject)encodedObject) != null;
        return typed;
    }

    public static void invalidType(Object object, Class desiredClass)
    {
        String inputType = null;
        if(object != null)
            inputType = object.getClass().getName();
        StringBuffer message = new StringBuffer("Cannot convert ");
        if(inputType != null)
            message.append("type ").append(inputType).append(" ");
        if(object != null && ((object instanceof String) || (object instanceof Number) || (object instanceof Boolean) || (object instanceof Date)))
            message.append("with value '").append(object.toString()).append("' ");
        else
        if(object instanceof ASObject)
        {
            ASObject aso = (ASObject)object;
            message.append("with remote type specified as '").append(aso.getType()).append("' ");
        }
        message.append("to an instance of ").append(desiredClass.toString());
        TranslationException ex = new TranslationException(message.toString());
        ex.setCode("Client.Message.Deserialize.InvalidType");
        throw ex;
    }

    private static final NativeDecoder nativeDecoder = new NativeDecoder();
    private static final NullDecoder nullDecoder = new NullDecoder();
    private static final NumberDecoder numberDecoder = new NumberDecoder();
    private static final StringDecoder stringDecoder = new StringDecoder();
    private static final BooleanDecoder booleanDecoder = new BooleanDecoder();
    private static final CharacterDecoder characterDecoder = new CharacterDecoder();
    private static final DateDecoder dateDecoder = new DateDecoder();
    private static final CalendarDecoder calendarDecoder = new CalendarDecoder();
    private static final ArrayDecoder arrayDecoder = new ArrayDecoder();
    private static final MapDecoder mapDecoder = new MapDecoder();
    private static final CollectionDecoder collectionDecoder = new CollectionDecoder();
    private static final TypedObjectDecoder typedObjectDecoder = new TypedObjectDecoder();
    private static final ArrayDecoder deepArrayDecoder = new ReferenceAwareArrayDecoder();
    private static final MapDecoder deepMapDecoder = new ReferenceAwareMapDecoder();
    private static final CollectionDecoder deepCollectionDecoder = new ReferenceAwareCollectionDecoder();
    private static final TypedObjectDecoder deepTypedObjectDecoder = new ReferenceAwareTypedObjectDecoder();

}
