// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AmfxMessageDeserializer.java

package flex.messaging.io.amfx;

import flex.messaging.MessageException;
import flex.messaging.io.MessageDeserializer;
import flex.messaging.io.SerializationContext;
import flex.messaging.io.amf.*;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

// Referenced classes of package flex.messaging.io.amfx:
//            AmfxInput

public class AmfxMessageDeserializer extends DefaultHandler
    implements MessageDeserializer
{

    public AmfxMessageDeserializer(SerializationContext context)
    {
        amfxIn = new AmfxInput(context);
    }

    public void setInputStream(InputStream in)
    {
        this.in = in;
    }

    public void setDebugTrace(AmfTrace trace)
    {
        debugTrace = trace;
        isDebug = debugTrace != null;
    }

    public void readMessage(ActionMessage m, ActionContext context)
        throws IOException
    {
        if(isDebug)
            debugTrace.startRequest("Deserializing AMFX/HTTP request");
        amfxIn.reset();
        amfxIn.setDebugTrace(debugTrace);
        amfxIn.setActionMessage(m);
        parse(m);
        context.setVersion(m.getVersion());
    }

    private void parse(ActionMessage m)
    {
        try
        {
            SAXParserFactory factory = SAXParserFactory.newInstance();
            factory.setValidating(false);
            factory.setNamespaceAware(true);
            SAXParser parser = factory.newSAXParser();
            parser.parse(in, this);
        }
        catch(MessageException ex)
        {
            clientMessageEncodingException(m, ex);
        }
        catch(SAXParseException e)
        {
            if(e.getException() != null)
                clientMessageEncodingException(m, e.getException());
            else
                clientMessageEncodingException(m, e);
        }
        catch(Exception ex)
        {
            clientMessageEncodingException(m, ex);
        }
    }

    private void clientMessageEncodingException(ActionMessage m, Throwable t)
    {
        MessageException me;
        if(t instanceof MessageException)
            me = (MessageException)t;
        else
            me = new MessageException("Error occurred parsing AMFX: " + t.getMessage());
        me.setCode("Client.Message.Encoding");
        MessageBody body = new MessageBody();
        body.setData(me);
        m.addBody(body);
    }

    public void startElement(String uri, String localName, String qName, Attributes attributes)
        throws SAXException
    {
        try
        {
            String methodName = "start_" + localName;
            Method method = amfxIn.getClass().getMethod(methodName, attribArr);
            method.invoke(amfxIn, new Object[] {
                attributes
            });
        }
        catch(NoSuchMethodException e)
        {
            fatalError(new SAXParseException("Unknown type: " + qName, locator));
        }
        catch(IllegalAccessException e)
        {
            fatalError(new SAXParseException(e.getMessage(), locator, e));
        }
        catch(InvocationTargetException e)
        {
            Throwable t = e.getTargetException();
            if(t instanceof SAXException)
                throw (SAXException)t;
            if(t instanceof Exception)
                fatalError(new SAXParseException(t.getMessage(), locator, (Exception)t));
            else
                fatalError(new SAXParseException(e.getMessage(), locator, e));
        }
    }

    public void endElement(String uri, String localName, String qName)
        throws SAXException
    {
        try
        {
            String methodName = "end_" + localName;
            Method method = amfxIn.getClass().getMethod(methodName, new Class[0]);
            method.invoke(amfxIn, new Object[0]);
        }
        catch(NoSuchMethodException e)
        {
            fatalError(new SAXParseException("Unfinished type: " + qName, locator));
        }
        catch(IllegalAccessException e)
        {
            fatalError(new SAXParseException(e.getMessage(), locator, e));
        }
        catch(InvocationTargetException e)
        {
            Throwable t = e.getTargetException();
            if(t instanceof SAXException)
                throw (SAXException)t;
            if(t instanceof Error)
                throw (Error)t;
            fatalError(new SAXParseException(t.getMessage(), locator));
        }
    }

    public void characters(char ch[], int start, int length)
        throws SAXException
    {
        String chars = new String(ch, start, length);
        if(chars.length() > 0)
            amfxIn.text(chars);
    }

    public void setDocumentLocator(Locator l)
    {
        locator = l;
    }

    public void error(SAXParseException exception)
        throws SAXException
    {
        throw new MessageException(exception.getMessage());
    }

    public void fatalError(SAXParseException exception)
        throws SAXException
    {
        if(exception.getException() != null && (exception.getException() instanceof MessageException))
            throw (MessageException)exception.getException();
        else
            throw new MessageException(exception.getMessage());
    }

    public void warning(SAXParseException exception)
        throws SAXException
    {
        throw new MessageException(exception.getMessage());
    }

    static Class _mthclass$(String x0)
    {
        try
        {
            return Class.forName(x0);
        }
        catch(ClassNotFoundException x1)
        {
            throw (new NoClassDefFoundError()).initCause(x1);
        }
    }

    private InputStream in;
    private Locator locator;
    private static Class attribArr[];
    private AmfxInput amfxIn;
    private AmfTrace debugTrace;
    private boolean isDebug;

    static 
    {
        attribArr = (new Class[] {
            org.xml.sax.Attributes.class
        });
    }
}
