// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AmfxMessageSerializer.java

package flex.messaging.io.amfx;

import flex.messaging.io.MessageSerializer;
import flex.messaging.io.SerializationContext;
import flex.messaging.io.amf.*;
import java.io.IOException;
import java.io.OutputStream;

// Referenced classes of package flex.messaging.io.amfx:
//            AmfxOutput, AmfxTypes

public class AmfxMessageSerializer
    implements MessageSerializer, AmfxTypes
{

    public AmfxMessageSerializer(SerializationContext context)
    {
        amfxOut = new AmfxOutput(context);
    }

    public void setOutputStream(OutputStream out)
    {
        this.out = out;
    }

    public void setDebugBuffer(AmfTrace debugBuffer)
    {
        this.debugBuffer = debugBuffer;
        isDebug = debugBuffer != null;
    }

    public void writeMessage(ActionMessage m)
        throws IOException
    {
        if(isDebug)
            debugBuffer.startResponse("Serializing AMFX/HTTP response");
        amfxOut.setOutputStream(out);
        amfxOut.setDebugTrace(debugBuffer);
        amfxOut.writeUTF("<?xml version=\"1.0\" encoding=\"utf-8\"?>\r\n");
        int version = m.getVersion();
        writeOpenAMFX(version);
        if(isDebug)
            debugBuffer.version(version);
        int headerCount = m.getHeaderCount();
        for(int i = 0; i < headerCount; i++)
        {
            MessageHeader header = m.getHeader(i);
            if(isDebug)
                debugBuffer.startHeader(header.getName(), header.getMustUnderstand(), i);
            writeHeader(header);
            if(isDebug)
                debugBuffer.endHeader();
        }

        int bodyCount = m.getBodyCount();
        for(int i = 0; i < bodyCount; i++)
        {
            MessageBody body = m.getBody(i);
            if(isDebug)
                debugBuffer.startMessage(body.getTargetURI(), body.getResponseURI(), i);
            writeBody(body);
            if(isDebug)
                debugBuffer.endMessage();
        }

        writeCloseAMFX();
        if(isDebug)
            debugBuffer.endMessage();
    }

    private void writeOpenAMFX(int version)
        throws IOException
    {
        int buflen = 14;
        StringBuffer sb = new StringBuffer(buflen);
        sb.append("<").append("amfx").append(" ver=\"");
        sb.append(version);
        sb.append("\">");
        amfxOut.writeUTF(sb);
    }

    private void writeCloseAMFX()
        throws IOException
    {
        amfxOut.writeUTF("</amfx>");
    }

    private void writeHeader(MessageHeader h)
        throws IOException
    {
        int buflen = 127;
        StringBuffer sb = new StringBuffer(buflen);
        sb.append("<").append("header").append(" name=\"");
        sb.append(h.getName());
        sb.append("\"");
        if(h.getMustUnderstand())
        {
            sb.append(" mustUnderstand=\"");
            sb.append(h.getMustUnderstand());
            sb.append("\"");
        }
        sb.append(">");
        amfxOut.writeUTF(sb);
        amfxOut.writeObject(h.getData());
        amfxOut.writeUTF("</header>");
    }

    private void writeBody(MessageBody b)
        throws IOException
    {
        if(b.getTargetURI() == null && b.getResponseURI() == null)
        {
            amfxOut.writeUTF("<body>");
        } else
        {
            int buflen = 127;
            StringBuffer sb = new StringBuffer(buflen);
            sb.append("<").append("body");
            if(b.getTargetURI() != null)
                sb.append(" targetURI=\"").append(b.getTargetURI()).append("\"");
            if(b.getResponseURI() != null)
                sb.append(" responseURI=\"").append(b.getResponseURI()).append("\"");
            sb.append(">");
            amfxOut.writeUTF(sb);
        }
        Object data = b.getData();
        amfxOut.writeObject(data);
        amfxOut.writeUTF("</body>");
    }

    private OutputStream out;
    private AmfxOutput amfxOut;
    private boolean isDebug;
    private AmfTrace debugBuffer;
    private static final String XML_DIRECTIVE = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\r\n";
}
