// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TCChunkInputStream.java

package flex.messaging.io.tcchunk;

import flex.messaging.endpoints.rtmp.RTMPConnection;
import flex.messaging.util.Assert;
import flex.messaging.util.Trace;
import java.nio.ByteBuffer;
import java.util.Arrays;

// Referenced classes of package flex.messaging.io.tcchunk:
//            ChunkCommon, TChunkIOState, TChunkInFlowCtl, TChunkContext, 
//            TCMessage

public class TCChunkInputStream extends ChunkCommon
{

    public TCChunkInputStream()
    {
        fpContexts = null;
        fpActive = null;
        fReadContext = null;
        fState = new TChunkIOState();
        fVersionByte = 0;
        fAckState = new TChunkInFlowCtl();
        fbHadError = false;
        fState.fStage = 1;
    }

    public void setCallbacks(RTMPConnection readProc, Object context)
    {
        fReadContext = context;
    }

    public TCMessage readMessage(boolean pbBytesRemaining[], ByteBuffer inbuf)
    {
        if(fbHadError)
            return null;
        TCMessage retval = null;
        byte fVersionByteBuf[] = new byte[1];
        int inset[] = {
            0
        };
        int bytesNeeded[] = {
            1
        };
        pbBytesRemaining[0] = true;
        boolean bContinue[] = {
            true
        };
        do
        {
            if(retval != null || !bContinue[0])
                break;
            if(fVersionByte == 0)
            {
                inset[0] = 0;
                bytesNeeded[0] = 1;
                fVersionByteBuf[0] = fVersionByte;
                boolean readret = read(inbuf, fVersionByteBuf, inset, bytesNeeded, pbBytesRemaining, bContinue);
                fVersionByte = fVersionByteBuf[0];
                if(readret)
                {
                    Assert.testAssertion(fVersionByte <= 3);
                    if(fVersionByte > 3)
                    {
                        fbHadError = true;
                        return null;
                    }
                    if(fVersionByte < 3)
                    {
                        fAckState.fpAckNotify.onAck(fAckState.fpContext, 6, fVersionByteBuf, null);
                        fAckState.fboolEnableAck = false;
                        fAckState.fpAckNotify.onAck(fAckState.fpContext, 3, null, null);
                    } else
                    {
                        fAckState.fpAckNotify.onAck(fAckState.fpContext, 6, fVersionByteBuf, null);
                    }
                }
            } else
            if(fVersionByte >= 3 && fAckState.fuPingSize > 0)
            {
                if(fAckState.fuPingSize > 1536)
                {
                    bytesNeeded[0] = fAckState.fuPingSize - 1536;
                    inset[0] = 1536 - bytesNeeded[0];
                    if(inset[0] == 0)
                        fAckState.fuReadTime = GETTIME();
                    if(read(inbuf, fAckState.fpPingBuffer, inset, bytesNeeded, pbBytesRemaining, bContinue))
                    {
                        fAckState.fuReadTime = GETTIME() - fAckState.fuReadTime;
                        fAckState.fpAckNotify.onAck(fAckState.fpContext, 7, fAckState.fpPingBuffer, new Long(fAckState.fuReadTime));
                        fAckState.fuPingSize = 1536;
                    } else
                    {
                        fAckState.fuPingSize = 3072 - inset[0];
                    }
                } else
                {
                    inset[0] = 1536 - fAckState.fuPingSize;
                    int pfuPingSize[] = {
                        fAckState.fuPingSize
                    };
                    boolean readret = read(inbuf, fAckState.fpPingBuffer, inset, pfuPingSize, pbBytesRemaining, bContinue);
                    fAckState.fuPingSize = pfuPingSize[0];
                    if(readret)
                    {
                        fAckState.fpAckNotify.onAck(fAckState.fpContext, 8, fAckState.fpPingBuffer, null);
                        fAckState.fpPingBuffer = null;
                    }
                }
            } else
            if(fState.fStage == 1)
            {
                Assert.testAssertion(fpActive == null);
                if(fpActive != null)
                {
                    fbHadError = true;
                    return null;
                }
                inset[0] = 0;
                bytesNeeded[0] = 1;
                Arrays.fill(fState.fControlData, (byte)0);
                if(read(inbuf, fState.fControlData, inset, bytesNeeded, pbBytesRemaining, bContinue))
                {
                    fState.fInset = 1;
                    fState.fStage = 2;
                    fState.fBytesNeeded = 0;
                    int streamId = fState.fControlData[0] & 0x3f;
                    if(streamId == 0)
                        fState.fBytesNeeded = 1;
                    if(streamId == 1)
                        fState.fBytesNeeded = 2;
                }
            } else
            if(fState.fStage == 2)
            {
                inset[0] = fState.fInset;
                bytesNeeded[0] = fState.fBytesNeeded;
                boolean readret = read(inbuf, fState.fControlData, inset, bytesNeeded, pbBytesRemaining, bContinue);
                fState.fInset = inset[0];
                fState.fBytesNeeded = bytesNeeded[0];
                if(readret)
                {
                    int streamId = fState.fControlData[0] & 0x3f;
                    if(streamId == 0 || streamId == 1)
                        streamId = 64 + S2U(fState.fControlData[1]) + 256 * S2U(fState.fControlData[2]);
                    TChunkContext i = fpContexts;
                    do
                    {
                        if(i == null)
                            break;
                        if(i.fChunkStreamId == streamId)
                        {
                            fpActive = i;
                            break;
                        }
                        i = i.fpNext;
                    } while(true);
                    if(fpActive == null)
                    {
                        fpActive = new TChunkContext();
                        fpActive.fChunkStreamId = streamId;
                        fpActive.fpNext = fpContexts;
                        fpContexts = fpActive;
                    }
                    int controlType = fState.fControlData[0] & 0xc0;
                    fState.fInset = 0;
                    fState.fStage = 3;
                    fState.fBytesNeeded = fpActive.getHeaderSize(controlType);
                    if(controlType == 0)
                        fpActive.fMsgTime = 0L;
                }
            } else
            if(fState.fStage == 3)
            {
                inset[0] = fState.fInset;
                bytesNeeded[0] = fState.fBytesNeeded;
                boolean readret = read(inbuf, fpActive.fHeader, inset, bytesNeeded, pbBytesRemaining, bContinue);
                fState.fInset = inset[0];
                fState.fBytesNeeded = bytesNeeded[0];
                if(readret)
                {
                    fState.fInset = 0;
                    fState.fStage = 4;
                    fState.fBytesNeeded = fpActive.hasExtendedTimestamp() ? 4 : 0;
                }
            } else
            if(fState.fStage == 4)
            {
                inset[0] = fState.fInset;
                bytesNeeded[0] = fState.fBytesNeeded;
                boolean readret = read(inbuf, fpActive.fExtendedTimestamp, inset, bytesNeeded, pbBytesRemaining, bContinue);
                fState.fInset = inset[0];
                fState.fBytesNeeded = bytesNeeded[0];
                if(readret)
                {
                    if(fpActive.fpMsg == null)
                    {
                        fpActive.fpMsg = new TCMessage();
                        fpActive.fMsgTime += fpActive.getMsgDelta();
                        fpActive.fMsgInset = 0;
                        fpActive.fpMsg.setMsgID(fpActive.getMsgTypeId());
                        fpActive.fpMsg.setMsgTime(fpActive.fMsgTime);
                        fpActive.fpMsg.setStreamID(fpActive.getMsgStreamId());
                        int newMsgLen = fpActive.getMsgLen();
                        if(newMsgLen > 0xa00000)
                        {
                            fbHadError = true;
                            return null;
                        }
                        if(newMsgLen < 0x10000)
                        {
                            fpActive.fpMsg.setSize(newMsgLen);
                        } else
                        {
                            fpActive.fpMsg.setSize(0x10000);
                            fpActive.fpMsg.setMsgLen(newMsgLen);
                        }
                    }
                    fState.fStage = 5;
                    int messageBytesLeft = fpActive.getMsgLen() - fpActive.fMsgInset;
                    if(messageBytesLeft < 0)
                    {
                        fbHadError = true;
                        return null;
                    }
                    fState.fBytesNeeded = coreMin(fState.fMaxChunkSize, messageBytesLeft);
                    fState.fInset = 0;
                }
            } else
            if(fState.fStage != 0)
            {
                int bufferByteSize = fpActive.fpMsg.getBufferSize();
                int bufferSizeNeeded = fpActive.fMsgInset + fState.fBytesNeeded;
                if(bufferByteSize < bufferSizeNeeded)
                {
                    int sizeToAlloc = coreMax(bufferByteSize + bufferByteSize, bufferSizeNeeded);
                    sizeToAlloc = coreMin(sizeToAlloc, fpActive.getMsgLen());
                    if(!fpActive.fpMsg.reallocBuffer(sizeToAlloc))
                    {
                        fbHadError = true;
                        return null;
                    }
                }
                inset[0] = fState.fInset;
                bytesNeeded[0] = fState.fBytesNeeded;
                boolean readret = read(inbuf, fpActive.fpMsg.getMsgBuffer(), fpActive.fMsgInset, inset, bytesNeeded, pbBytesRemaining, bContinue);
                fState.fInset = inset[0];
                fState.fBytesNeeded = bytesNeeded[0];
                if(readret)
                {
                    fpActive.fMsgInset += fState.fInset;
                    if(fpActive.fMsgInset == fpActive.getMsgLen())
                    {
                        if(fpActive.fChunkStreamId == 2)
                            applyProtocolMsg(fpActive.fpMsg);
                        else
                            retval = fpActive.fpMsg;
                        fpActive.fpMsg = null;
                    }
                    fState.fStage = 1;
                    fpActive = null;
                }
            }
        } while(true);
        return retval;
    }

    public void reset()
    {
        fpActive = null;
        fpContexts = null;
    }

    public boolean hadError()
    {
        return fbHadError;
    }

    public TChunkInFlowCtl getAckContext()
    {
        return fAckState;
    }

    public void triggerAck()
    {
        triggerAck(1);
    }

    public void triggerAck(int uEvery)
    {
        if(fAckState.fboolEnableAck && fAckState.fuInReadSeq - fAckState.fuLastAckSeq > fAckState.fuAckWindow >> uEvery)
        {
            if(fAckState.fuInReadSeq > 0xefffffffL)
            {
                fAckState.fuInReadSeq = fAckState.fuInReadSeq - fAckState.fuLastAckSeq;
                fAckState.fuLastAckSeq = fAckState.fuInReadSeq;
            }
            fAckState.fuLastAckSeq = fAckState.fuInReadSeq;
            TCMessage pMsg = new TCMessage();
            byte data[] = new byte[4];
            data[0] = (byte)(int)(fAckState.fuLastAckSeq >> 24);
            data[1] = (byte)(int)(fAckState.fuLastAckSeq >> 16);
            data[2] = (byte)(int)(fAckState.fuLastAckSeq >> 8);
            data[3] = (byte)(int)fAckState.fuLastAckSeq;
            pMsg.write(data);
            fAckState.fpAckNotify.onAck(fAckState.fpContext, 1, pMsg, null);
        }
    }

    private boolean read(ByteBuffer inbuf, byte buffer[], int pInset[], int pBytesNeeded[], boolean pbBytesRemaining[], boolean pbContinue[])
    {
        return read(inbuf, buffer, 0, pInset, pBytesNeeded, pbBytesRemaining, pbContinue);
    }

    private boolean read(ByteBuffer inbuf, byte buffer[], int offset, int pInset[], int pBytesNeeded[], boolean pbBytesRemaining[], boolean pbContinue[])
    {
        if(pBytesNeeded[0] != 0)
        {
            int bytesRead = doRead(inbuf, fReadContext, buffer, pInset[0] + offset, pBytesNeeded[0], pbBytesRemaining);
            pBytesNeeded[0] -= bytesRead;
            pInset[0] += bytesRead;
            Assert.testAssertion(pBytesNeeded[0] >= 0);
            if(pBytesNeeded[0] < 0)
                fbHadError = true;
            fAckState.fuInReadSeq += bytesRead;
        }
        pbContinue[0] = pBytesNeeded[0] == 0;
        return pbContinue[0];
    }

    private int doRead(ByteBuffer inbuf, Object context, byte buffer[], int offset, int length, boolean pbBytesRemaining[])
    {
        int nbytes = ChunkCommon.coreMin(inbuf.limit() - inbuf.position(), length);
        pbBytesRemaining[0] = length - nbytes > 0;
        if(Trace.rtmp)
            Trace.trace(Thread.currentThread() + " Getting " + nbytes + " from inbuf " + inbuf);
        inbuf.get(buffer, offset, nbytes);
        return nbytes;
    }

    private void applyProtocolMsg(TCMessage pMsg)
    {
label0:
        switch(pMsg.getMsgID())
        {
        case 1: // '\001'
        {
            byte msgBuffer[] = pMsg.getMsgBuffer();
            fState.fMaxChunkSize = get4ByteInt(msgBuffer, 0);
            break;
        }

        case 3: // '\003'
        case 4: // '\004'
        case 6: // '\006'
            break;

        case 2: // '\002'
        {
            byte msgBuffer[] = pMsg.getMsgBuffer();
            int chunkStreamId = get4ByteInt(msgBuffer, 0);
            TChunkContext i = fpContexts;
            do
            {
                if(i == null)
                    break label0;
                if(i.fChunkStreamId == chunkStreamId)
                    i.fpMsg = null;
                i = i.fpNext;
            } while(true);
        }

        case 5: // '\005'
        {
            byte msgBuffer[] = pMsg.getMsgBuffer();
            fAckState.fuAckWindow = get4ByteInt(msgBuffer, 0);
            triggerAck();
            break;
        }

        default:
        {
            Assert.testAssertion(false);
            fbHadError = true;
            break;
        }
        }
    }

    private TChunkContext fpContexts;
    private TChunkContext fpActive;
    private Object fReadContext;
    private TChunkIOState fState;
    private byte fVersionByte;
    private TChunkInFlowCtl fAckState;
    private boolean fbHadError;
}
