// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TCChunkOutputStream.java

package flex.messaging.io.tcchunk;

import flex.messaging.endpoints.rtmp.RTMPActionRequest;
import flex.messaging.util.Assert;
import flex.messaging.util.Trace;
import java.nio.ByteBuffer;
import java.util.Arrays;

// Referenced classes of package flex.messaging.io.tcchunk:
//            ChunkCommon, TChunkIOState, TChunkOutFlowCtl, TChunkContext, 
//            TCMessage, TMsgList, TCMessageProcessor

public class TCChunkOutputStream extends ChunkCommon
    implements TCMessageProcessor
{

    public TCChunkOutputStream()
    {
        fpContexts = null;
        fpActive = null;
        fScheduleHistory = new byte[100];
        fPriorityTotal = 0;
        fState = new TChunkIOState();
        fpProtocolQueue = null;
        fpUserCtlMsgQueue = null;
        fbSentVersionByte = false;
        fTimeBasis = 0;
        outputStalled = false;
        fAckState = new TChunkOutFlowCtl();
        fState.fStage = 2;
        clearSchedule();
        TChunkContext pProtocolMsgContext = new TChunkContext();
        pProtocolMsgContext.fChunkStreamId = 2;
        pProtocolMsgContext.setCallbacks(this, this);
        register(pProtocolMsgContext, 1000, 0);
    }

    public void release()
    {
        handleUnregistration();
        Assert.testAssertion(fpContexts.fChunkStreamId == 2);
        Assert.testAssertion(fpContexts.fpNext == null);
        fpContexts.release();
        fpContexts = null;
        reset();
    }

    public synchronized TCMessage getMessage(Object context, int priority, int pStreamID[], long pTimeStamp[])
    {
        TCMessage result = null;
        if(fpProtocolQueue != null)
        {
            result = fpProtocolQueue.fpMsg;
            TMsgList kill = fpProtocolQueue;
            fpProtocolQueue = fpProtocolQueue.fpNext;
            kill.Release();
            pStreamID[0] = result.getStreamID();
            pTimeStamp[0] = result.getMsgTime();
        }
        if(result == null && fpUserCtlMsgQueue != null)
        {
            result = fpUserCtlMsgQueue.fpMsg;
            TMsgList kill = fpUserCtlMsgQueue;
            fpUserCtlMsgQueue = fpUserCtlMsgQueue.fpNext;
            kill.Release();
            pStreamID[0] = result.getStreamID();
            pTimeStamp[0] = result.getMsgTime();
        }
        return result;
    }

    public void setTimeBasis(int timeBasis)
    {
        fTimeBasis = timeBasis;
    }

    public synchronized TCMessage writeMessage(boolean pbDidWrite[], ByteBuffer outbuf)
    {
        pbDidWrite[0] = false;
        int pInset[] = new int[1];
        int pBytesNeeded[] = new int[1];
        if(Trace.rtmp)
            Trace.trace("TCChunkOutputStream.WriteMessage: fAckState = " + fAckState.fbState);
        if(fAckState.fbState != 3)
        {
            if(fAckState.fbState == 1)
            {
                pbDidWrite[0] = doConnectAck(outbuf, fAckState.fbVersion);
                if(TINCAN_SERVER)
                {
                    if(fAckState.fbVersion == 3)
                        fAckState.fbState = 2;
                    else
                        fAckState.fbState = 3;
                } else
                {
                    fAckState.fbState = 2;
                }
            } else
            if(fAckState.fbState == 2 && fAckState.fpPingBuffer != null)
            {
                pInset[0] = 1536 - fAckState.fuPingSize;
                pBytesNeeded[0] = fAckState.fuPingSize;
                boolean writeret = write(outbuf, fAckState.fpPingBuffer, pInset, pBytesNeeded, pbDidWrite);
                fAckState.fuPingSize = pBytesNeeded[0];
                if(writeret)
                {
                    fAckState.fpPingBuffer = null;
                    fAckState.fbState = 3;
                }
            }
            return null;
        }
        if(fAckState.fboolEnableAck && !fAckState.fboolSendAck && fAckState.fuOutSeq > fAckState.fuWinLimit + (long)(fAckState.fuAckWindow * 10))
        {
            outputStalled = true;
            return null;
        }
        TCMessage retval = null;
        if(fpActive == null)
        {
            boolean bNewMsg[] = {
                false
            };
            fpActive = selectContext(bNewMsg);
            if(fpActive != null)
            {
                fState.fBytesNeeded = 0;
                fState.fInset = 0;
                int msgDelta = (int)(fpActive.fOutMsgTime - fpActive.fMsgTime);
                Assert.testAssertion(fpActive.fChunkStreamId >= 2 && fpActive.fChunkStreamId < 0x10040);
                if(fpActive.fChunkStreamId < 64)
                {
                    fState.fControlData[0] = (byte)fpActive.fChunkStreamId;
                    fState.fBytesNeeded = 1;
                } else
                if(fpActive.fChunkStreamId < 320)
                {
                    fState.fControlData[0] = 0;
                    fState.fControlData[1] = (byte)(fpActive.fChunkStreamId - 64);
                    fState.fBytesNeeded = 2;
                } else
                {
                    fState.fControlData[0] = 1;
                    fState.fControlData[1] = (byte)((fpActive.fChunkStreamId - 64) % 256);
                    fState.fControlData[2] = (byte)((fpActive.fChunkStreamId - 64) / 256);
                    fState.fBytesNeeded = 3;
                }
                fState.fStage = 2;
                boolean bDone = false;
                if(bNewMsg[0])
                {
                    fpActive.fMsgInset = 0;
                    boolean bNewMsgStreamId = fpActive.getMsgStreamId() != fpActive.fOutStreamId;
                    if(bNewMsgStreamId || fpActive.fMsgTime == 0L || msgDelta < 0)
                    {
                        fState.fControlData[0] |= 0;
                        fpActive.setMsgTypeId(fpActive.fpMsg.getMsgID());
                        fpActive.setMsgStreamId(fpActive.fOutStreamId);
                        fpActive.setMsgLen(fpActive.fpMsg.getMsgLen());
                        fpActive.setMsgDelta((int)fpActive.fOutMsgTime);
                        bDone = true;
                    } else
                    if(fpActive.getMsgLen() != fpActive.fpMsg.getMsgLen() || fpActive.getMsgTypeId() != fpActive.fpMsg.getMsgID())
                    {
                        fState.fControlData[0] |= 0x40;
                        fpActive.setMsgTypeId(fpActive.fpMsg.getMsgID());
                        fpActive.setMsgLen(fpActive.fpMsg.getMsgLen());
                        fpActive.setMsgDelta(msgDelta);
                        bDone = true;
                    } else
                    if(fpActive.getMsgDelta() != msgDelta)
                    {
                        fState.fControlData[0] |= 0x80;
                        fpActive.setMsgDelta(msgDelta);
                        bDone = true;
                    }
                }
                if(!bDone)
                    fState.fControlData[0] |= 0xc0;
            }
        }
        if(fpActive != null && fState.fStage == 2)
        {
            pInset[0] = fState.fInset;
            pBytesNeeded[0] = fState.fBytesNeeded;
            boolean writeret = write(outbuf, fState.fControlData, pInset, pBytesNeeded, pbDidWrite);
            fState.fBytesNeeded = pBytesNeeded[0];
            fState.fInset = pInset[0];
            if(writeret)
            {
                fState.fStage = 3;
                fState.fInset = 0;
                fState.fBytesNeeded = fpActive.getHeaderSize(fState.fControlData[0] & 0xc0);
            }
        }
        if(fpActive != null && fState.fStage == 3)
        {
            pInset[0] = fState.fInset;
            pBytesNeeded[0] = fState.fBytesNeeded;
            boolean writeret = write(outbuf, fpActive.fHeader, pInset, pBytesNeeded, pbDidWrite);
            fState.fBytesNeeded = pBytesNeeded[0];
            fState.fInset = pInset[0];
            if(writeret)
            {
                fState.fStage = 4;
                fState.fInset = 0;
                fState.fBytesNeeded = fpActive.hasExtendedTimestamp() ? 4 : 0;
            }
        }
        if(fpActive != null && fState.fStage == 4)
        {
            pInset[0] = fState.fInset;
            pBytesNeeded[0] = fState.fBytesNeeded;
            boolean writeret = write(outbuf, fpActive.fExtendedTimestamp, pInset, pBytesNeeded, pbDidWrite);
            fState.fBytesNeeded = pBytesNeeded[0];
            fState.fInset = pInset[0];
            if(writeret)
            {
                fState.fStage = 5;
                int messageBytesLeft = fpActive.getMsgLen() - fpActive.fMsgInset;
                fState.fBytesNeeded = coreMin(fState.fMaxChunkSize, messageBytesLeft);
                fState.fInset = 0;
            }
        }
        if(fpActive != null && fState.fStage == 5)
        {
            pInset[0] = fState.fInset + fpActive.fMsgInset;
            pBytesNeeded[0] = fState.fBytesNeeded;
            boolean writeret = write(outbuf, fpActive.fpMsg.getMsgBuffer(), pInset, pBytesNeeded, pbDidWrite);
            fState.fBytesNeeded = pBytesNeeded[0];
            fState.fInset = pInset[0] - fpActive.fMsgInset;
            if(writeret)
            {
                fpActive.fMsgInset += fState.fInset;
                if(fpActive.fMsgInset == fpActive.getMsgLen())
                {
                    fpActive.fMsgTime = fpActive.fOutMsgTime;
                    if(fpActive.fChunkStreamId == 2)
                        applyProtocolMsg(fpActive.fpMsg);
                    else
                        retval = fpActive.fpMsg;
                    fpActive.fpMsg = null;
                } else
                if(fpActive.fpMsg.getMsgSlot() == 0)
                {
                    int newMaxChunkSize = coreMin(fpActive.fpMsg.getMsgLen(), 1024);
                    if(fState.fMaxChunkSize < newMaxChunkSize)
                        setMaxChunkSize(newMaxChunkSize);
                }
                fpActive = null;
            }
        }
        return retval;
    }

    public synchronized void reset()
    {
        fpActive = null;
        fpProtocolQueue = null;
        fpUserCtlMsgQueue = null;
        clearSchedule();
    }

    public synchronized void register(TChunkContext pChunkContext, int priority, int iQueueID)
    {
        pChunkContext.fQueueID = iQueueID;
        pChunkContext.fPriority = priority;
        if(pChunkContext.fChunkStreamId == 2)
        {
            pChunkContext.fpNext = fpContexts;
            fpContexts = pChunkContext;
        } else
        {
            int chunkStreamId = 3;
            if(fpContexts == null)
            {
                fpContexts = pChunkContext;
            } else
            {
                TChunkContext i = fpContexts;
                TChunkContext pi = fpContexts;
                do
                {
                    if(i == null || i.fChunkStreamId > chunkStreamId)
                    {
                        pChunkContext.fChunkStreamId = chunkStreamId;
                        pChunkContext.fpNext = i;
                        pi.fpNext = pChunkContext;
                        break;
                    }
                    chunkStreamId = i.fChunkStreamId + 1;
                    pi = i;
                    i = i.fpNext;
                } while(true);
            }
        }
        clearSchedule();
        fPriorityTotal += pChunkContext.fPriority;
    }

    public synchronized void unregister(TChunkContext pChunkContext)
    {
        pChunkContext.fbUnregister = true;
    }

    public void setMaxChunkSize(int maxChunkSize)
    {
        TCMessage pMsg = new TCMessage();
        pMsg.setMsgID(1);
        byte data[] = new byte[4];
        data[0] = (byte)(maxChunkSize >> 24);
        data[1] = (byte)(maxChunkSize >> 16);
        data[2] = (byte)(maxChunkSize >> 8);
        data[3] = (byte)maxChunkSize;
        pMsg.write(data);
        queueProtocolMsg(pMsg);
    }

    public void sendUserCtrlMsg(byte pBytes[], int iSize)
    {
        TCMessage pMsg = new TCMessage();
        pMsg.setMsgID(4);
        pMsg.write(pBytes, iSize);
        queueUserCtlMsg(pMsg);
    }

    public boolean handleFlowControlEvent(int iEvent, Object pArg1, Object pArg2, RTMPActionRequest actionRequest)
    {
        switch(iEvent)
        {
        case 6: // '\006'
            return handleConnectReq(((byte[])(byte[])pArg1)[0]);

        case 7: // '\007'
            return handleConnectAck((byte[])(byte[])pArg1, ((Long)pArg2).longValue());

        case 8: // '\b'
            return handleConnectAckRecv((byte[])(byte[])pArg1);

        case 9: // '\t'
            byte msgBuffer[] = ((TCMessage)pArg1).getMsgBuffer();
            int uNewBW = get4ByteInt(msgBuffer, 0);
            short uType = msgBuffer[4];
            return setBWLimit(uNewBW, 0L, uType);

        case 10: // '\n'
            fAckState.fuDownStrmBW = (int)((Long)pArg1).longValue();
            return true;

        case 1: // '\001'
            ((TCMessage)pArg1).setMsgID(3);
            queueProtocolMsg((TCMessage)pArg1);
            fAckState.fboolSendAck = true;
            clearOutputStalled(actionRequest);
            return true;

        case 2: // '\002'
            handleWinAckRecv(((TCMessage)pArg1).getMsgBuffer(), actionRequest);
            return true;

        case 3: // '\003'
        case 4: // '\004'
        case 5: // '\005'
        default:
            return false;
        }
    }

    private boolean handleWinAckRecv(byte msgBuffer[], RTMPActionRequest actionRequest)
    {
        long uTime = GETTIME();
        long uCurrBW = 0L;
        long uSendRate = 0L;
        long uTimeDiff;
        long lBytesSent;
        synchronized(this)
        {
            long uLastSeq = fAckState.fuLastAckSeq;
            lBytesSent = fAckState.fuOutSeq - fAckState.fuLastWinStart;
            fAckState.fuLastWinStart = fAckState.fuOutSeq;
            fAckState.fuLastAckSeq = get4ByteInt(msgBuffer, 0);
            if(fAckState.fuLastAckSeq < uLastSeq)
            {
                fAckState.fuOutSeq = fAckState.fuOutSeq - uLastSeq;
                fAckState.fuWinLimit = 0L;
            }
            long uRange = (long)fAckState.fuAckWindow - (fAckState.fuOutSeq - fAckState.fuLastAckSeq);
            uTimeDiff = uTime - fAckState.fuWindowStart;
            fAckState.fuWindowStart = uTime;
            long uExcess = ((long)fAckState.fuAckWindow * uTimeDiff) / 1000L;
            if(lBytesSent <= uExcess)
                uExcess = 0L;
            else
                uExcess = lBytesSent - uExcess;
            if(uRange < 0L)
                fAckState.fuWinLimit = 0L;
            else
                fAckState.fuWinLimit = coreMax((long)fAckState.fuAckWindow - uExcess, (uRange - (long)(fAckState.fuAckWindow >> 1)) + 1L);
            fAckState.fuWinLimit += fAckState.fuOutSeq;
        }
        clearOutputStalled(actionRequest);
        if(uTimeDiff != 0L)
            uSendRate = (1000L * lBytesSent) / uTimeDiff;
        return true;
    }

    public boolean setBWLimit(long uUpBytes, long uDownBytes, short uType)
    {
        if(uUpBytes > 0L)
        {
            uUpBytes = coreMax(1000L, uUpBytes);
            synchronized(this)
            {
                int uOldWindow = fAckState.fuAckWindow;
                if(uType == 0 || uType == 1)
                {
                    fAckState.fuUserUpBWLimit = (int)uUpBytes;
                    fAckState.fbOverRide = uType == 0;
                    if(fAckState.fbOverRide)
                        fAckState.fuAckWindow = (int)uUpBytes;
                    else
                    if((long)fAckState.fuAckWindow > uUpBytes)
                        fAckState.fuAckWindow = (int)uUpBytes;
                } else
                if(fAckState.fbOverRide && (long)fAckState.fuAckWindow != uUpBytes)
                    fAckState.fuAckWindow = (int)uUpBytes;
                if(uOldWindow != fAckState.fuAckWindow)
                {
                    fAckState.fuWinLimit += fAckState.fuAckWindow;
                    setPeerWindow(fAckState.fuAckWindow);
                }
            }
        }
        if(uDownBytes > 0L)
        {
            uDownBytes = coreMax(1000L, uDownBytes);
            TCMessage pMsg = new TCMessage();
            byte data[] = new byte[5];
            data[0] = (byte)(int)(uDownBytes >> 24);
            data[1] = (byte)(int)(uDownBytes >> 16);
            data[2] = (byte)(int)(uDownBytes >> 8);
            data[3] = (byte)(int)uDownBytes;
            data[4] = (byte)uType;
            pMsg.write(data, 5);
            pMsg.setMsgID(6);
            queueProtocolMsg(pMsg);
        }
        return true;
    }

    public int getMeasuredBW()
    {
        return fAckState.fuMeasuredBW;
    }

    public int getUpStrmBW()
    {
        return fAckState.fuAckWindow;
    }

    public int getDownStrmBW()
    {
        return fAckState.fuDownStrmBW;
    }

    public int getLatency()
    {
        return fAckState.fuUpRTT >> 1;
    }

    public synchronized void setDefBandwidth(long uUpBytes, long uDownBytes)
    {
        if(uUpBytes > 1000L)
            fAckState.fuDefUpBW = (int)uUpBytes;
        if(uDownBytes > 1000L)
            fAckState.fuDefDownBW = (int)uDownBytes;
        fAckState.fuDownStrmBW = fAckState.fuDefDownBW;
        setBWLimit(fAckState.fuDefUpBW, fAckState.fuDefDownBW, (short)2);
    }

    public synchronized boolean setClientMode()
    {
        fAckState.fbClientMode = true;
        fAckState.fbState = 1;
        return true;
    }

    private TChunkContext selectContext(boolean pbNewMsg[])
    {
        TChunkContext result = null;
        pbNewMsg[0] = false;
        if(fpContexts != null)
        {
            handleUnregistration();
            for(TChunkContext i = fpContexts; i != null; i = i.fpNext)
                i.fbEmpty = false;

            do
            {
                if(result != null)
                    break;
                for(TChunkContext i = fpContexts; i != null; i = i.fpNext)
                    if(!i.fbEmpty && (result == null || i.scheduleStatus(fPriorityTotal) < result.scheduleStatus(fPriorityTotal)))
                        result = i;

                if(result == null)
                    break;
                if(result.fpMsg == null)
                {
                    result.fpMsg = result.getNextMessage();
                    if(result.fpMsg != null)
                    {
                        pbNewMsg[0] = true;
                        result.fOutMsgTime -= fTimeBasis;
                    }
                }
                if(result.fpMsg == null)
                {
                    result.fbEmpty = true;
                    result = null;
                } else
                {
                    result.fCount++;
                    TChunkContext i = fpContexts;
                    do
                    {
                        if(i == null)
                            break;
                        if(i.fChunkStreamId == fScheduleHistory[fScheduleIndex])
                        {
                            i.fCount--;
                            break;
                        }
                        i = i.fpNext;
                    } while(true);
                    Assert.testAssertion(result.fChunkStreamId != 0);
                    fScheduleHistory[fScheduleIndex] = (byte)result.fChunkStreamId;
                    fScheduleIndex++;
                    fScheduleIndex %= 100;
                }
            } while(true);
        }
        return result;
    }

    private void clearSchedule()
    {
        for(TChunkContext i = fpContexts; i != null; i = i.fpNext)
            i.fCount = 0;

        Arrays.fill(fScheduleHistory, (byte)0);
        fScheduleIndex = 0;
    }

    private boolean write(ByteBuffer outbuf, byte buffer[], int pInset[], int pBytesNeeded[], boolean pbDidWrite[])
    {
        if(pBytesNeeded[0] != 0)
        {
            int bytesWritten = doWrite(outbuf, buffer, pInset[0], pBytesNeeded[0]);
            pInset[0] += bytesWritten;
            pBytesNeeded[0] -= bytesWritten;
            pbDidWrite[0] = true;
            fAckState.fuOutSeq += bytesWritten;
        }
        return pBytesNeeded[0] == 0;
    }

    private int doWrite(ByteBuffer outbuf, byte buffer[], int offset, int length)
    {
        int nbytes = ChunkCommon.coreMin(outbuf.limit() - outbuf.position(), length);
        outbuf.put(buffer, offset, nbytes);
        if(Trace.rtmp)
            Trace.trace(Thread.currentThread() + " Putting " + nbytes + " into outbuf " + outbuf);
        return nbytes;
    }

    private synchronized void queueProtocolMsg(TCMessage pMsg)
    {
        if(fpProtocolQueue == null)
        {
            fpProtocolQueue = new TMsgList(pMsg);
        } else
        {
            TMsgList pCur = fpProtocolQueue;
            for(TMsgList pNext = fpProtocolQueue; pNext != null; pNext = pNext.fpNext)
                pCur = pNext;

            pCur.fpNext = new TMsgList(pMsg);
        }
    }

    private synchronized void queueUserCtlMsg(TCMessage pMsg)
    {
        if(fpUserCtlMsgQueue == null)
        {
            fpUserCtlMsgQueue = new TMsgList(pMsg);
        } else
        {
            TMsgList pCur = fpUserCtlMsgQueue;
            for(TMsgList pNext = fpUserCtlMsgQueue; pNext != null; pNext = pNext.fpNext)
                pCur = pNext;

            pCur.fpNext = new TMsgList(pMsg);
        }
    }

    private void applyProtocolMsg(TCMessage pMsg)
    {
        switch(pMsg.getMsgID())
        {
        case 1: // '\001'
            byte msgBuffer[] = pMsg.getMsgBuffer();
            fState.fMaxChunkSize = get4ByteInt(msgBuffer, 0);
            break;

        case 3: // '\003'
            fAckState.fboolSendAck = false;
            break;

        default:
            Assert.testAssertion(false);
            break;

        case 2: // '\002'
        case 4: // '\004'
        case 5: // '\005'
        case 6: // '\006'
            break;
        }
    }

    private static TCMessage getNextMessage(Object context, int iPriority, int iStreamID[], int iTimeStamp[])
    {
        TCChunkOutputStream s = (TCChunkOutputStream)context;
        TCChunkOutputStream tcchunkoutputstream = s;
        JVM INSTR monitorenter ;
        TCMessage result = null;
        if(s.fpProtocolQueue != null)
        {
            result = s.fpProtocolQueue.fpMsg;
            TMsgList kill = s.fpProtocolQueue;
            s.fpProtocolQueue = s.fpProtocolQueue.fpNext;
            kill.Release();
            iStreamID[0] = result.getStreamID();
            iTimeStamp[0] = (int)result.getMsgTime();
        }
        if(result == null && s.fpUserCtlMsgQueue != null)
        {
            result = s.fpUserCtlMsgQueue.fpMsg;
            TMsgList kill = s.fpUserCtlMsgQueue;
            s.fpUserCtlMsgQueue = s.fpUserCtlMsgQueue.fpNext;
            kill.Release();
            iStreamID[0] = result.getStreamID();
            iTimeStamp[0] = (int)result.getMsgTime();
        }
        return result;
        Exception exception;
        exception;
        throw exception;
    }

    private void handleUnregistration()
    {
        boolean bDidUnregister = false;
        TChunkContext i = fpContexts;
        do
        {
            if(i == null)
                break;
            if(i.fbUnregister)
            {
                if(i.fpMsg != null)
                {
                    TCMessage pMsg = new TCMessage();
                    pMsg.setMsgID(2);
                    byte data[] = new byte[4];
                    data[0] = (byte)(i.fChunkStreamId >> 24);
                    data[1] = (byte)(i.fChunkStreamId >> 16);
                    data[2] = (byte)(i.fChunkStreamId >> 8);
                    data[3] = (byte)i.fChunkStreamId;
                    pMsg.write(data);
                    queueProtocolMsg(pMsg);
                }
                TChunkContext kill = i;
                fPriorityTotal -= kill.fPriority;
                bDidUnregister = true;
                i = i.fpNext;
                kill.release();
                if(kill == fpContexts)
                    fpContexts = null;
            } else
            {
                i = i.fpNext;
            }
        } while(true);
        if(bDidUnregister)
            clearSchedule();
    }

    private boolean doConnectAck(ByteBuffer outbuf, byte fbVersion)
    {
        if(!fbSentVersionByte)
        {
            byte versionByte[] = {
                fbVersion
            };
            int pInset[] = {
                0
            };
            int pBytesNeeded[] = {
                1
            };
            boolean bDidWrite[] = {
                false
            };
            fbSentVersionByte = write(outbuf, versionByte, pInset, pBytesNeeded, bDidWrite);
            Assert.testAssertion(fbSentVersionByte);
            if(!fbSentVersionByte)
                return false;
            if(fbVersion >= 3)
            {
                byte data[] = new byte[1536];
                long uTime = GETTIME();
                data[0] = (byte)(int)(uTime >> 24);
                data[1] = (byte)(int)(uTime >> 16);
                data[2] = (byte)(int)(uTime >> 8);
                data[3] = (byte)(int)uTime;
                data[4] = data[5] = data[6] = data[7] = 0;
                byte lastVal = (byte)(int)uTime;
                for(int i = 8; i < data.length; i += 2)
                {
                    data[i] = (byte)((lastVal * 0xb8cd75 + 1) % 256);
                    lastVal = data[i];
                }

                pInset[0] = 0;
                pBytesNeeded[0] = data.length;
                fbSentVersionByte = write(outbuf, data, pInset, pBytesNeeded, bDidWrite);
                if(!fbSentVersionByte)
                    return false;
            }
        }
        return fbSentVersionByte;
    }

    private void setPeerWindow(int uSize)
    {
        TCMessage pMsg = new TCMessage();
        byte data[] = new byte[4];
        data[0] = (byte)(uSize >> 24);
        data[1] = (byte)(uSize >> 16);
        data[2] = (byte)(uSize >> 8);
        data[3] = (byte)uSize;
        pMsg.write(data, 4);
        pMsg.setMsgID(5);
        queueProtocolMsg(pMsg);
    }

    private boolean handleConnectReq(byte bVersion)
    {
        if(!TINCAN_SERVER)
            break MISSING_BLOCK_LABEL_61;
        TCChunkOutputStream tcchunkoutputstream = this;
        JVM INSTR monitorenter ;
        if(!fAckState.fbClientMode)
        {
            fAckState.fbVersion = bVersion;
            fAckState.fbState = 1;
        } else
        if(bVersion < 3)
            return false;
        tcchunkoutputstream;
        JVM INSTR monitorexit ;
        break MISSING_BLOCK_LABEL_68;
        Exception exception;
        exception;
        throw exception;
        if(bVersion < 3)
            return false;
        return true;
    }

    private synchronized boolean handleConnectAck(byte pAckData[], long uReadTime)
    {
        fAckState.fpPingBuffer = new byte[1536];
        System.arraycopy(pAckData, 0, fAckState.fpPingBuffer, 0, 1536);
        fAckState.fpPingBuffer[4] = (byte)(int)(uReadTime >> 24);
        fAckState.fpPingBuffer[5] = (byte)(int)(uReadTime >> 16);
        fAckState.fpPingBuffer[6] = (byte)(int)(uReadTime >> 8);
        fAckState.fpPingBuffer[7] = (byte)(int)uReadTime;
        return true;
    }

    private boolean handleConnectAckRecv(byte pAckData[])
    {
        long u1;
        long u2;
        byte pVal[] = pAckData;
        u1 = S2U(get4ByteInt(pVal[0], pVal[1], pVal[2], pVal[3]));
        u2 = S2U(get4ByteInt(pVal[4], pVal[5], pVal[6], pVal[7]));
        long u3 = GETTIME();
        TCChunkOutputStream tcchunkoutputstream = this;
        JVM INSTR monitorenter ;
        fAckState.fuUpRTT = (int)(u3 - u1 - u2);
        long uRate = 0x7a12000L;
        if(u2 > 0L)
            uRate = (int)((1536D / (double)u2) * 1000D);
        fAckState.fuMeasuredBW = (int)(uRate + (uRate / 1000L) * (long)(fAckState.fuUpRTT >> 2));
        fAckState.fuMeasuredBW = coreMax(1000, fAckState.fuMeasuredBW);
        if(TINCAN_SERVER)
            setBWLimit(fAckState.fuMeasuredBW <= fAckState.fuDefUpBW ? fAckState.fuDefUpBW : fAckState.fuMeasuredBW, fAckState.fuDefDownBW, (short)2);
        return true;
        Exception exception;
        exception;
        throw exception;
    }

    public boolean pendingData()
    {
        return fpActive != null || fpProtocolQueue != null;
    }

    public boolean outputStalled()
    {
        return outputStalled;
    }

    private void clearOutputStalled(RTMPActionRequest actionRequest)
    {
        outputStalled = false;
        actionRequest.shouldScheduleWrite = true;
    }

    TChunkContext fpContexts;
    TChunkContext fpActive;
    byte fScheduleHistory[];
    int fScheduleIndex;
    int fPriorityTotal;
    TChunkIOState fState;
    TMsgList fpProtocolQueue;
    TMsgList fpUserCtlMsgQueue;
    boolean fbSentVersionByte;
    int fTimeBasis;
    boolean outputStalled;
    TChunkOutFlowCtl fAckState;
}
