// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TCContainerMsg.java

package flex.messaging.io.tcchunk;


// Referenced classes of package flex.messaging.io.tcchunk:
//            ChunkCommon, TCDataParser, TCMessage

public class TCContainerMsg extends ChunkCommon
{

    public TCContainerMsg(TCMessage pMsg)
    {
        containerEnd = currEventPos = firstEventPos = -1;
        containerVersion = -1L;
        buffer = pMsg.getMsgBuffer();
        bufferLen = pMsg.getMsgLen();
        if(bufferLen > 0)
        {
            TCDataParser parser = new TCDataParser(buffer, bufferLen);
            containerEnd = parser.getPos() + bufferLen;
            containerName = parser.getString();
            containerVersion = (long)parser.getDWord() & 0xffffffffL;
            uFlags = parser.getDWord();
            uMagicNum = parser.getDWord();
            currEventPos = firstEventPos = parser.getPos();
        }
    }

    public String getContainerName()
    {
        return containerName;
    }

    public long getVersion()
    {
        return containerVersion;
    }

    public int getFlags()
    {
        return uFlags;
    }

    public int getMagicNum()
    {
        return uMagicNum;
    }

    public int getFirstEventType()
    {
        int result = 255;
        TCDataParser parser = new TCDataParser(buffer, bufferLen);
        parser.setPos(firstEventPos);
        result = parser.getByte() & 0xff;
        int size = parser.getDWord();
        currEventPos = firstEventPos;
        return result;
    }

    public int getNextEventType()
    {
        int result = 255;
        TCDataParser parser = new TCDataParser(buffer, bufferLen);
        if(currEventPos < containerEnd)
        {
            parser.setPos(currEventPos);
            parser.getByte();
            currEventPos = parser.getDWord();
            currEventPos += parser.getPos();
            parser.setPos(currEventPos);
            if(currEventPos < containerEnd)
                result = parser.getByte();
        }
        return result;
    }

    public int getNumSlots()
    {
        int result = 0;
        TCDataParser parser = new TCDataParser(buffer, bufferLen);
        parser.setPos(firstEventPos);
        int eventSize;
        for(; parser.getPos() < containerEnd; parser.setPos(parser.getPos() + eventSize))
        {
            int eventType = parser.getPos();
            eventSize = parser.getDWord();
            result++;
        }

        return result;
    }

    public String getSlotName(int iSlot)
    {
        TCDataParser parser = new TCDataParser(buffer, bufferLen);
        int slotCount = 0;
        parser.setPos(firstEventPos);
        if(iSlot < 0)
        {
            parser.setPos(currEventPos);
            parser.getByte();
            parser.getDWord();
            return parser.getString();
        }
        int eventSize;
        for(; parser.getPos() < containerEnd; parser.setPos(parser.getPos() + eventSize))
        {
            int eventType = parser.getPos();
            eventSize = parser.getDWord();
            if(slotCount == iSlot)
                return parser.getString();
            slotCount++;
        }

        return null;
    }

    public byte[] getSlotBlob(int iSlot)
    {
        int range[] = getSlotBlobRange(iSlot);
        if(range != null)
        {
            byte blob[] = new byte[range[1]];
            System.arraycopy(buffer, range[1], blob, 0, blob.length);
            return blob;
        } else
        {
            return null;
        }
    }

    public int getSlotBlobOffset(int iSlot)
    {
        int range[] = getSlotBlobRange(iSlot);
        if(range != null)
            return range[0];
        else
            return -1;
    }

    public long getSlotBlobSize(int iSlot)
    {
        int range[] = getSlotBlobRange(iSlot);
        if(range != null)
            return (long)range[1];
        else
            return 0L;
    }

    public int[] getSlotBlobRange(int iSlot)
    {
        TCDataParser parser = new TCDataParser(buffer, bufferLen);
        int slotCount = 0;
        if(iSlot < 0)
        {
            parser.setPos(currEventPos);
            int eventType = parser.getByte();
            int bufPos = parser.getPos();
            int eventSize = parser.getDWord();
            return (new int[] {
                bufPos, eventSize + 4
            });
        }
        parser.setPos(firstEventPos);
        int eventSize;
        for(; parser.getPos() < containerEnd; parser.setPos(parser.getPos() + eventSize))
        {
            int eventType = parser.getByte();
            int bufPos = parser.getPos();
            eventSize = parser.getDWord();
            if(slotCount == iSlot)
                return (new int[] {
                    bufPos, eventSize + 4
                });
            slotCount++;
        }

        return null;
    }

    public static void updateProxyMsg(TCMessage pMsg, int uFlag, int uMagic)
    {
        TCDataParser parser = new TCDataParser(pMsg.getMsgBuffer(), pMsg.getMsgLen());
        parser.skipString();
        parser.getDWord();
        set4ByteInt(parser.getBuf(), parser.getPos(), uFlag);
        parser.getDWord();
        set4ByteInt(parser.getBuf(), parser.getPos(), uMagic);
    }

    public static void updateVersion(TCMessage pMsg, long uVersion)
    {
        TCDataParser parser = new TCDataParser(pMsg.getMsgBuffer(), pMsg.getMsgLen());
        parser.skipString();
        set4ByteInt(parser.getBuf(), parser.getPos(), (int)uVersion);
    }

    private byte buffer[];
    private int bufferLen;
    private int containerEnd;
    private int firstEventPos;
    private int currEventPos;
    private String containerName;
    private long containerVersion;
    private int uFlags;
    private int uMagicNum;
}
