// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TCDataParser.java

package flex.messaging.io.tcchunk;

import flex.messaging.io.amf.AmfTypes;
import flex.messaging.util.Assert;
import flex.messaging.util.DoubleUtil;
import java.io.UnsupportedEncodingException;

// Referenced classes of package flex.messaging.io.tcchunk:
//            ChunkCommon

public class TCDataParser extends ChunkCommon
    implements AmfTypes
{

    public TCDataParser()
    {
        buf = null;
        len = 0;
        size = 0;
        tagCode = 0;
        tagPos = 0;
        tagLen = 0;
        tagIsBig = false;
        underFlow = false;
        isStoring = false;
        isStoring = true;
    }

    public TCDataParser(byte data[], int dataLen)
    {
        buf = null;
        len = 0;
        size = 0;
        tagCode = 0;
        tagPos = 0;
        tagLen = 0;
        tagIsBig = false;
        underFlow = false;
        isStoring = false;
        buf = data;
        size = dataLen;
    }

    public void startTag(int code, boolean isBig)
    {
        Assert.testAssertion(tagCode == 0);
        Assert.testAssertion(isStoring);
        tagCode = code;
        tagPos = len;
        tagIsBig = isBig;
        putWord((short)0);
        if(isBig)
            putDWord(0);
    }

    public void finishTag()
    {
        Assert.testAssertion(isStoring);
        int pos = len;
        int iTagLen = pos - tagPos - (tagIsBig ? 6 : 2);
        Assert.testAssertion(iTagLen >= 0);
        len = tagPos;
        if(tagIsBig)
        {
            putWord((short)(tagCode << 6 | 0x3f));
            putDWord(iTagLen);
        } else
        {
            Assert.testAssertion(iTagLen < 63);
            putWord((short)(tagCode << 6 | iTagLen));
        }
        len = pos;
        tagCode = 0;
    }

    public int getTag(int tagLen[])
    {
        int iTagCode = getWord() & 0xffff;
        if(underFlow)
            return -1;
        tagLen[0] = iTagCode & 0x3f;
        if(tagLen[0] == 63)
            tagLen[0] = getDWord();
        return iTagCode >> 6;
    }

    public byte[] getBuf()
    {
        return buf;
    }

    public int getPos()
    {
        return len;
    }

    public int getSize()
    {
        return size;
    }

    public void setPos(int pos)
    {
        len = pos;
    }

    public void putByte(byte b)
    {
        Assert.testAssertion(isStoring);
        if(checkBufferSize(1))
            buf[len++] = b;
    }

    public byte getByte()
    {
        Assert.testAssertion(!isStoring);
        Assert.testAssertion(len < size);
        if(len >= size)
        {
            underFlow = true;
            len++;
            return 0;
        } else
        {
            return buf[len++];
        }
    }

    public void putDouble(double d)
    {
        Assert.testAssertion(isStoring);
        if(checkBufferSize(8))
        {
            long bits = DoubleUtil.doubleToRawLongBits(d);
            putDWord((int)(bits >> 32));
            putDWord((int)bits);
        }
    }

    public double getDouble()
    {
        Assert.testAssertion(!isStoring);
        Assert.testAssertion(len + 8 <= size);
        if(len + 8 > size)
        {
            underFlow = true;
            len += 8;
            return 0.0D;
        } else
        {
            long bits = 0L;
            bits |= (long)getDWord() << 32;
            bits |= (long)getDWord() & 0xffffffffL;
            return Double.longBitsToDouble(bits);
        }
    }

    public void putWord(short d)
    {
        Assert.testAssertion(isStoring);
        if(checkBufferSize(2))
        {
            buf[len++] = (byte)(d >> 8);
            buf[len++] = (byte)d;
        }
    }

    public short getWord()
    {
        Assert.testAssertion(!isStoring);
        Assert.testAssertion(len + 2 <= size);
        if(len + 2 > size)
        {
            underFlow = true;
            len += 2;
            return 0;
        } else
        {
            short result = (short)(buf[len++] << 8 & 0xff00);
            result |= (short)(buf[len++] & 0xff);
            return result;
        }
    }

    public void putDWord(int d)
    {
        Assert.testAssertion(isStoring);
        if(checkBufferSize(4))
        {
            buf[len++] = (byte)(d >> 24);
            buf[len++] = (byte)(d >> 16);
            buf[len++] = (byte)(d >> 8);
            buf[len++] = (byte)d;
        }
    }

    public int getDWord()
    {
        Assert.testAssertion(!isStoring);
        Assert.testAssertion(len + 4 <= size);
        if(len + 4 > size)
        {
            underFlow = true;
            len += 4;
            return 0;
        } else
        {
            int result = buf[len++] << 24 & 0xff000000;
            result |= buf[len++] << 16 & 0xff0000;
            result |= buf[len++] << 8 & 0xff00;
            result |= buf[len++] & 0xff;
            return result;
        }
    }

    public void putString(String string)
    {
        putString(string, 2);
    }

    public void putString(String string, int type)
    {
        try
        {
            Assert.testAssertion(isStoring);
            byte sbytes[] = string.getBytes("UTF8");
            int count = sbytes.length;
            Assert.testAssertion(type != 2 || count <= 65535);
            if(type == 12)
            {
                if(checkBufferSize(count + 4))
                {
                    putDWord(count);
                    System.arraycopy(sbytes, 0, buf, len, count);
                    len += count;
                }
            } else
            if(type == 2)
            {
                if(checkBufferSize(count + 2))
                {
                    putWord((short)count);
                    System.arraycopy(sbytes, 0, buf, len, count);
                    len += count;
                }
            } else
            {
                Assert.testAssertion(false);
            }
        }
        catch(UnsupportedEncodingException uex)
        {
            uex.printStackTrace();
            Assert.testAssertion(false);
        }
    }

    public String getString()
    {
        return getString(2);
    }

    public String getString(int type)
    {
        int count;
        Assert.testAssertion(!isStoring);
        count = type != 2 ? getDWord() : ((int) (getWord()));
        Assert.testAssertion(len + count <= size);
        if(len + count > size)
        {
            underFlow = true;
            len += count;
            return "";
        }
        String s = new String(buf, len, count, "UTF8");
        len += count;
        return s;
        UnsupportedEncodingException uex;
        uex;
        String s1;
        uex.printStackTrace();
        Assert.testAssertion(false);
        s1 = null;
        len += count;
        return s1;
        Exception exception;
        exception;
        len += count;
        throw exception;
    }

    public boolean skipString()
    {
        return skipString(2);
    }

    public boolean skipString(int type)
    {
        Assert.testAssertion(!isStoring);
        int count = type != 2 ? getDWord() : ((int) (getWord()));
        Assert.testAssertion(len + count <= size);
        if(len + count > size)
        {
            underFlow = true;
            len += count;
            return false;
        } else
        {
            len += count;
            return true;
        }
    }

    public void putData(byte data[], int count)
    {
        Assert.testAssertion(isStoring);
        if(checkBufferSize(count))
        {
            System.arraycopy(data, 0, buf, len, count);
            len += count;
        }
    }

    public byte[] getData(int count)
    {
        Assert.testAssertion(!isStoring);
        Assert.testAssertion(len + count <= size);
        if(len + count > size)
        {
            underFlow = true;
            len += count;
            return null;
        } else
        {
            byte bytes[] = new byte[count];
            System.arraycopy(buf, len, bytes, 0, count);
            len += count;
            return bytes;
        }
    }

    private boolean checkBufferSize(int requestSize)
    {
        Assert.testAssertion(isStoring);
        requestSize += len;
        if(requestSize > size)
        {
            int newSize = size <= 0x10000 ? size * 2 : size + 0x10000;
            if(newSize < 256)
                newSize = 256;
            if(newSize < requestSize)
                newSize = requestSize + 1024;
            byte newBuf[] = new byte[newSize];
            if(buf != null)
                System.arraycopy(buf, 0, newBuf, 0, len);
            buf = newBuf;
            size = newSize;
            return true;
        } else
        {
            return true;
        }
    }

    protected byte buf[];
    private int len;
    private int size;
    private int tagCode;
    private int tagPos;
    private int tagLen;
    private boolean tagIsBig;
    protected boolean underFlow;
    protected boolean isStoring;
}
