// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TCJavaSerializer.java

package flex.messaging.io.tcchunk;

import flex.messaging.util.Assert;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Array;
import java.lang.reflect.Field;
import java.util.*;

// Referenced classes of package flex.messaging.io.tcchunk:
//            TCDataParser

public class TCJavaSerializer extends TCDataParser
{

    public TCJavaSerializer()
    {
        refTable = new HashMap();
        refIndex = new HashMap();
        boolCheckECMA = false;
        serializeId = 0;
        iArgIndex = 0;
    }

    public TCJavaSerializer(boolean boolCheckEcma)
    {
        refTable = new HashMap();
        refIndex = new HashMap();
        boolCheckECMA = false;
        serializeId = 0;
        iArgIndex = 0;
        boolCheckECMA = boolCheckEcma;
    }

    public TCJavaSerializer(byte data[], int dataLen)
    {
        super(data, dataLen);
        refTable = new HashMap();
        refIndex = new HashMap();
        boolCheckECMA = false;
        serializeId = 0;
        iArgIndex = 0;
    }

    public void encodeVar(String name, Object v, boolean clearTable)
    {
        processScriptObject(new Object[] {
            v
        }, new String[] {
            name
        });
        if(clearTable)
            cleanDirtyFlags();
    }

    public void encodeVar(Object v, boolean clearTable)
    {
        encodeVar(null, v, clearTable);
    }

    public Object decodeVar(boolean clearTable)
    {
        return decodeVar(null, clearTable);
    }

    public Object decodeVar(String strName[], boolean clearTable)
    {
        Assert.testAssertion(!isStoring);
        Object v[] = new Object[1];
        if(processScriptObject(v, strName) == 9)
            v[0] = END_MARKER;
        if(clearTable)
            cleanDirtyFlags();
        return v[0];
    }

    public int skipVar()
    {
        if(getPos() >= getSize())
            return 9;
        int varType = getByte();
        switch(varType)
        {
        case 5: // '\005'
        case 6: // '\006'
        case 9: // '\t'
        case 13: // '\r'
        case 14: // '\016'
        case 15: // '\017'
        default:
            break;

        case 0: // '\0'
        {
            setPos(getPos() + 8);
            break;
        }

        case 1: // '\001'
        case 7: // '\007'
        {
            setPos(getPos() + 1);
            break;
        }

        case 2: // '\002'
        case 4: // '\004'
        {
            int iSize = getWord();
            setPos(getPos() + iSize);
            break;
        }

        case 12: // '\f'
        {
            int iSize = getDWord();
            setPos(getPos() + iSize);
            break;
        }

        case 11: // '\013'
        {
            setPos(getPos() + 10);
            break;
        }

        case 16: // '\020'
        {
            int iSize = getWord();
            setPos(getPos() + iSize);
            // fall through
        }

        case 3: // '\003'
        {
            do
            {
                int iSize = getWord();
                setPos(getPos() + iSize);
            } while(skipVar() != 9);
            break;
        }

        case 8: // '\b'
        {
            int length = getDWord();
            do
            {
                int iSize = getWord();
                setPos(getPos() + iSize);
            } while(skipVar() != 9);
            break;
        }

        case 10: // '\n'
        {
            int length = getDWord();
            for(int i = 0; i < length; i++)
                skipVar();

            break;
        }
        }
        return varType;
    }

    private void addObjectToTable(Object object, int index)
    {
        Integer iIndex = new Integer(index);
        refTable.put(iIndex, object);
        refIndex.put(object, iIndex);
    }

    private void cleanDirtyFlags()
    {
        refTable.clear();
        refIndex.clear();
        serializeId = 0;
    }

    private void processName(String strName[])
    {
        if(isStoring)
            putString(strName[0]);
        else
            strName[0] = getString();
    }

    private void processNumberType(Object v[])
    {
        if(isStoring)
            putDouble(((Number)v[0]).doubleValue());
        else
            v[0] = new Double(getDouble());
    }

    private void processBooleanType(Object v[])
    {
        if(isStoring)
            putByte((byte)(((Boolean)v[0]).booleanValue() ? 1 : 0));
        else
            v[0] = getByte() == 0 ? ((Object) (Boolean.FALSE)) : ((Object) (Boolean.TRUE));
    }

    private void processStringType(Object v[], int type)
    {
        if(isStoring)
            putString((String)v[0], type);
        else
            v[0] = getString();
    }

    private void processDateType(Object v[])
    {
        if(isStoring)
        {
            Calendar cal = Calendar.getInstance();
            cal.setTime((Date)v[0]);
            putDouble(cal.getTime().getTime());
            putWord((short)(cal.get(15) + cal.get(16)));
        } else
        {
            double dateValue = getDouble();
            double offset = getWord();
            v[0] = new Date((long)dateValue);
        }
    }

    private void processObjectType(Object v[], int iType)
    {
        if(isStoring)
        {
            addObjectToTable(v[0], serializeId++);
            if(iType != 16);
            Field fields[] = v[0].getClass().getFields();
            for(int i = 0; i < fields.length; i++)
                try
                {
                    if(9 == processScriptObject(new Object[] {
    fields[i].get(v[0])
}, new String[] {
    fields[i].getName()
}))
                        break;
                }
                catch(IllegalAccessException iax) { }

            putString("");
            putByte((byte)9);
        } else
        {
            Object vv[] = new Object[1];
            String strName[] = new String[1];
            if(iType == 16)
            {
                String clsname = getString();
                Class cls = null;
                if(cls != null)
                    try
                    {
                        v[0] = cls.newInstance();
                        while(processScriptObject(vv, strName) != 9) 
                            try
                            {
                                cls.getField(strName[0]).set(v[0], vv[0]);
                            }
                            catch(NoSuchFieldException nsfx) { }
                            catch(SecurityException sx) { }
                    }
                    catch(InstantiationException ix)
                    {
                        iType = 3;
                    }
                    catch(IllegalAccessException iax)
                    {
                        iType = 3;
                    }
                else
                    iType = 3;
            }
            if(iType == 3)
            {
                v[0] = new HashMap();
                addObjectToTable(v[0], serializeId++);
                for(; processScriptObject(vv, strName) != 9; ((Map)v[0]).put(strName[0], vv[0]));
            }
        }
    }

    private void processStrictArrayType(Object v[])
    {
        if(isStoring)
        {
            addObjectToTable(v[0], serializeId++);
            int iLen = Array.getLength(v[0]);
            putDWord(iLen);
            Object vv[] = new Object[1];
            int i = 0;
            do
            {
                if(i >= iLen)
                    break;
                vv[0] = Array.get(v[0], i);
                if(9 == processScriptObject(vv, null))
                    break;
                i++;
            } while(true);
        } else
        {
            int length = getDWord();
            Class elemcls = null;
            Object vv[] = new Object[1];
            Object tmpArray[] = new Object[length];
            for(int i = 0; i < length && 9 != processScriptObject(vv, null); i++)
            {
                tmpArray[i] = vv[0];
                if(vv[0] != null && elemcls == null)
                {
                    elemcls = vv[0].getClass();
                    continue;
                }
                if(elemcls != vv[0].getClass())
                    elemcls = java.lang.Object.class;
            }

            if(elemcls == null || elemcls == (java.lang.Object.class))
                v[0] = ((Object) (tmpArray));
            else
            if(elemcls == (java.lang.Boolean.class))
            {
                boolean boolArray[] = (boolean[])(boolean[])Array.newInstance(Boolean.TYPE, length);
                for(int i = 0; i < length; i++)
                    boolArray[i] = ((Boolean)tmpArray[i]).booleanValue();

                v[0] = boolArray;
            } else
            if(elemcls == (java.lang.Double.class))
            {
                double dblArray[] = (double[])(double[])Array.newInstance(Double.TYPE, length);
                for(int i = 0; i < length; i++)
                    dblArray[i] = ((Double)tmpArray[i]).doubleValue();

                v[0] = dblArray;
            } else
            if(elemcls == (java.lang.String.class))
            {
                String strArray[] = (String[])(String[])Array.newInstance(java.lang.String.class, length);
                for(int i = 0; i < length; i++)
                    strArray[i] = (String)tmpArray[i];

                v[0] = strArray;
            } else
            if(elemcls == (java.util.Date.class))
            {
                Date dateArray[] = (Date[])(Date[])Array.newInstance(java.util.Date.class, length);
                for(int i = 0; i < length; i++)
                    dateArray[i] = (Date)tmpArray[i];

            } else
            {
                v[0] = ((Object) (tmpArray));
            }
            addObjectToTable(v[0], serializeId++);
        }
    }

    private void processECMAArrayType(Object v[])
    {
        if(isStoring)
        {
            Map map = (Map)v[0];
            addObjectToTable(map, serializeId++);
            putDWord(map.size());
            Iterator it = map.entrySet().iterator();
            String strName[];
            Object vv[];
            do
            {
                if(!it.hasNext())
                    break;
                java.util.Map.Entry me = (java.util.Map.Entry)it.next();
                strName = (new String[] {
                    me.getKey().toString()
                });
                vv = (new Object[] {
                    me.getValue()
                });
            } while(9 != processScriptObject(vv, strName));
            putString("");
            putByte((byte)9);
        } else
        {
            Map map = new HashMap();
            v[0] = map;
            addObjectToTable(map, serializeId++);
            int length = getDWord();
            String strName[] = new String[1];
            for(Object objValue[] = new Object[1]; processScriptObject(objValue, strName) != 9; map.put(strName[0], objValue[0]));
        }
    }

    private void processMovieClipType(Object aobj[])
    {
    }

    private void processNullType(Object v[])
    {
        if(!isStoring)
            v[0] = null;
    }

    private void processUndefinedType(Object v[])
    {
        if(!isStoring)
            v[0] = null;
    }

    private void processReferenceType(Object v[])
    {
        if(isStoring)
        {
            Assert.testAssertion(refIndex.containsKey(v[0]));
            putWord((short)getRefId(v[0]));
        } else
        {
            int id = getWord();
            v[0] = refTable.get(new Integer(id));
        }
    }

    private int processScriptObject(Object v[], String strName[])
    {
        int iPos = -1;
        int varType = 9;
        if(isStoring)
        {
            iPos = getPos();
            varType = processScriptVar(v, strName);
        } else
        {
            varType = processScriptVar(v, strName);
            if(underFlow)
                return 9;
        }
        return varType;
    }

    private int processScriptVar(Object v[], String strName[])
    {
        int stringSize = 0;
        int varType;
        if(isStoring)
        {
            if(v[0] == null)
                varType = 5;
            else
            if(v[0] instanceof String)
            {
                String jStr = (String)v[0];
                byte sbytes[];
                try
                {
                    sbytes = jStr.getBytes("UTF8");
                }
                catch(UnsupportedEncodingException uex)
                {
                    uex.printStackTrace();
                    Assert.testAssertion(false);
                    sbytes = new byte[0];
                }
                if(sbytes.length > 65535)
                    varType = 12;
                else
                    varType = 2;
            } else
            if(v[0] instanceof Number)
                varType = 0;
            else
            if(v[0] instanceof Boolean)
                varType = 1;
            else
            if(isReference(v[0]))
                varType = 7;
            else
            if(v[0].getClass().isArray())
                varType = 10;
            else
            if(v[0] instanceof Date)
                varType = 11;
            else
            if(v[0] instanceof Map)
                varType = 8;
            else
            if(v[0] instanceof Object)
                varType = 3;
            else
                varType = 13;
            if(strName != null && strName[0] != null)
                processName(strName);
            putByte((byte)varType);
        } else
        {
            if(strName != null)
                processName(strName);
            varType = getByte();
        }
        switch(varType)
        {
        case 0: // '\0'
            processNumberType(v);
            break;

        case 1: // '\001'
            processBooleanType(v);
            break;

        case 2: // '\002'
        case 12: // '\f'
            processStringType(v, varType);
            break;

        case 3: // '\003'
        case 16: // '\020'
            processObjectType(v, varType);
            break;

        case 10: // '\n'
            processStrictArrayType(v);
            break;

        case 8: // '\b'
            processECMAArrayType(v);
            break;

        case 4: // '\004'
            processStringType(v, 2);
            break;

        case 5: // '\005'
            processNullType(v);
            break;

        case 6: // '\006'
        case 13: // '\r'
            processUndefinedType(v);
            break;

        case 7: // '\007'
            processReferenceType(v);
            break;

        case 11: // '\013'
            processDateType(v);
            break;

        case 14: // '\016'
        case 15: // '\017'
        default:
            Assert.testAssertion(false);
            break;

        case 9: // '\t'
            break;
        }
        return varType;
    }

    private boolean isReference(Object obj)
    {
        return refIndex.containsKey(obj);
    }

    private int getRefId(Object obj)
    {
        if(refIndex.containsKey(obj))
            return ((Integer)refIndex.get(obj)).intValue();
        else
            return -1;
    }

    public static final Object END_MARKER = new Object();
    private Map refTable;
    private Map refIndex;
    private boolean boolCheckECMA;
    private int serializeId;
    private int iArgIndex;

}
