// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TCMessage.java

package flex.messaging.io.tcchunk;

import flex.messaging.MessageException;
import flex.messaging.util.URLEncoderUtil;
import java.io.UnsupportedEncodingException;
import java.util.Arrays;

// Referenced classes of package flex.messaging.io.tcchunk:
//            ChunkCommon

public class TCMessage extends ChunkCommon
    implements Cloneable
{

    public TCMessage()
    {
        header = new byte[11];
        data = new byte[0];
        format = 0;
        setStreamID(0);
    }

    public int getType()
    {
        return getMsgID();
    }

    public double getTime()
    {
        return (double)getMsgTime() / 1000D;
    }

    public byte[] getData()
    {
        return getMsgBuffer();
    }

    public void setType(int type)
    {
        setMsgID(type);
    }

    public void setTime(double time)
    {
        setMsgTime((long)(time * 1000D));
    }

    public void setData(byte buf[])
    {
        data = buf;
    }

    public byte getMsgID()
    {
        return header[0];
    }

    public int getMsgLen()
    {
        return getMsgLen(header);
    }

    public static int getMsgLen(byte head[])
    {
        return head[1] << 16 & 0xff0000 | head[2] << 8 & 0xff00 | head[3] & 0xff;
    }

    public long getMsgTime()
    {
        return getMsgTime(header);
    }

    public static long getMsgTime(byte header[])
    {
        return (long)(header[7] << 24 & 0xff000000 | header[4] << 16 & 0xff0000 | header[5] << 8 & 0xff00 | header[6] & 0xff);
    }

    public int getStreamID()
    {
        return header[8] << 16 & 0xff0000 | header[9] << 8 & 0xff00 | header[10] & 0xff;
    }

    public void setMsgID(int iMsg)
    {
        header[0] = (byte)iMsg;
    }

    public void setMsgLen(int uSize)
    {
        header[1] = (byte)(uSize >> 16);
        header[2] = (byte)(uSize >> 8);
        header[3] = (byte)uSize;
    }

    public void setMsgTime(long uTime)
    {
        header[7] = (byte)(int)(uTime >> 24);
        header[4] = (byte)(int)(uTime >> 16);
        header[5] = (byte)(int)(uTime >> 8);
        header[6] = (byte)(int)uTime;
    }

    public void setStreamID(int uStreamID)
    {
        header[8] = (byte)(uStreamID >> 16);
        header[9] = (byte)(uStreamID >> 8);
        header[10] = (byte)uStreamID;
    }

    public int getMsgSlot()
    {
        int id = getMsgID();
        if(id == 9)
            return 1;
        if(id == 8)
            return 0;
        return !ChunkCommon.TINCAN_SERVER || id != 19 ? 2 : 3;
    }

    public byte[] getMsgHdr()
    {
        return header;
    }

    public int getHdrLen()
    {
        return 11;
    }

    public byte[] getMsgBuffer()
    {
        return data;
    }

    public boolean setSize(int s)
    {
        if(data.length < s && !reallocBuffer(s))
        {
            return false;
        } else
        {
            setMsgLen(s);
            return true;
        }
    }

    public boolean write(byte bytes[])
    {
        return write(bytes, 0, bytes.length);
    }

    public boolean write(byte bytes[], int length)
    {
        return write(bytes, 0, length);
    }

    public boolean write(byte bytes[], int offset, int length)
    {
        if(!setSize(getMsgLen() + length))
        {
            return false;
        } else
        {
            System.arraycopy(bytes, offset, data, getMsgLen() - length, length);
            return true;
        }
    }

    public void writeString(String s)
    {
        try
        {
            write(s.getBytes("UTF8"));
        }
        catch(UnsupportedEncodingException uee)
        {
            throw new MessageException(uee.getMessage(), uee);
        }
    }

    public void encodeString(String s)
    {
        try
        {
            String es = URLEncoderUtil.encode(s, "UTF8");
            writeString(es);
        }
        catch(UnsupportedEncodingException uee)
        {
            throw new MessageException(uee.getMessage(), uee);
        }
    }

    public void terminateString()
    {
        if(data.length > 0 && data[data.length - 1] != 0)
            write(new byte[] {
                0
            });
    }

    public boolean reallocBuffer(int uSize)
    {
        byte d[] = new byte[uSize];
        System.arraycopy(data, 0, d, 0, d.length >= data.length ? data.length : d.length);
        data = d;
        return true;
    }

    public int getBufferSize()
    {
        return data == null ? 0 : data.length;
    }

    public void clearHeader()
    {
        Arrays.fill(header, (byte)0);
    }

    public void copyHeader(byte head[])
    {
        System.arraycopy(head, 0, header, 0, head.length);
    }

    public String toString()
    {
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append("TCMessage [ Type: ");
        switch(getType())
        {
        case 8: // '\b'
            stringBuffer.append("MsgAudio");
            break;

        case 9: // '\t'
            stringBuffer.append("MsgVideo");
            break;

        case 18: // '\022'
            stringBuffer.append("MsgData");
            break;

        case 19: // '\023'
            stringBuffer.append("MsgContainer");
            break;

        case 20: // '\024'
            stringBuffer.append("MsgCmd");
            break;

        case 15: // '\017'
            stringBuffer.append("MsgDataEx");
            break;

        case 16: // '\020'
            stringBuffer.append("MsgContainerEx");
            break;

        case 17: // '\021'
            stringBuffer.append("MsgCmdEx");
            break;

        case 21: // '\025'
            stringBuffer.append("MsgMax");
            break;

        case 0: // '\0'
        case 1: // '\001'
        case 2: // '\002'
        case 3: // '\003'
        case 4: // '\004'
        case 5: // '\005'
        case 6: // '\006'
        case 7: // '\007'
        case 10: // '\n'
        case 11: // '\013'
        case 12: // '\f'
        case 13: // '\r'
        case 14: // '\016'
        default:
            stringBuffer.append("MsgUnknown");
            break;
        }
        stringBuffer.append(", Stream ID: ");
        stringBuffer.append(getStreamID());
        stringBuffer.append("]");
        return stringBuffer.toString();
    }

    public static final int TYPE_AUDIO = 8;
    public static final int TYPE_VIDEO = 9;
    public static final int TYPE_DATA = 18;
    final int TYPE_COMMAND = 20;
    public static final int HDR_LENGTH = 11;
    public static final int BUF_ALLOC_LEN = 1024;
    private byte header[];
    private byte data[];
    private byte format;
}
