// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TChunkContext.java

package flex.messaging.io.tcchunk;

import java.util.Arrays;

// Referenced classes of package flex.messaging.io.tcchunk:
//            ChunkCommon, TCMessageProcessor, TCMessage

public class TChunkContext extends ChunkCommon
{

    public TChunkContext()
    {
        fpNext = null;
        fGetMsg = null;
        fGetMsgContext = null;
        fQueueID = 0;
        fPriority = 1;
        fCount = 0;
        fbEmpty = false;
        fbUnregister = false;
        fbWasEmptyOnRequest = false;
        fpMsg = null;
        fOutStreamId = 0;
        fOutMsgTime = 0L;
        fMsgInset = 0;
        fChunkStreamId = 0;
        fMsgTime = 0L;
    }

    public void release()
    {
    }

    public void setCallbacks(TCMessageProcessor getMsg, Object context)
    {
        fGetMsg = getMsg;
        fGetMsgContext = context;
    }

    public TCMessage getNextMessage()
    {
        int fOutStreamIdReturn[] = {
            fOutStreamId
        };
        long fOutMsgTimeReturn[] = {
            fOutMsgTime
        };
        TCMessage result = fGetMsg.getMessage(fGetMsgContext, fQueueID, fOutStreamIdReturn, fOutMsgTimeReturn);
        fOutStreamId = fOutStreamIdReturn[0];
        fOutMsgTime = fOutMsgTimeReturn[0];
        if(result == null)
            synchronized(this)
            {
                fbWasEmptyOnRequest = true;
            }
        return result;
    }

    public float scheduleStatus(int priorityTotal)
    {
        return (float)fCount / ((float)fPriority / (float)priorityTotal);
    }

    public synchronized void resetEmptyOnRequest()
    {
        fbWasEmptyOnRequest = false;
    }

    public synchronized boolean wasEmptyOnRequest()
    {
        return fbWasEmptyOnRequest;
    }

    public boolean hasExtendedTimestamp()
    {
        int basicTimeStamp = get3ByteInt(fHeader, 0);
        return basicTimeStamp == 0xffffff;
    }

    int getHeaderSize(int controlType)
    {
        int size = 0;
        switch(controlType)
        {
        case 0: // '\0'
            size = 11;
            break;

        case 64: // '@'
            size = 7;
            break;

        case 128: 
            size = 3;
            break;
        }
        return size;
    }

    int getMsgDelta()
    {
        int delta = get3ByteInt(fHeader, 0);
        if(delta == 0xffffff)
            delta = fExtendedTimestamp[0] << 24 & 0xff000000 | fExtendedTimestamp[1] << 16 & 0xff0000 | fExtendedTimestamp[2] << 8 & 0xff00 | fExtendedTimestamp[3] << 0 & 0xff;
        return delta;
    }

    int getMsgLen()
    {
        return get3ByteInt(fHeader, 3);
    }

    byte getMsgTypeId()
    {
        return fHeader[6];
    }

    int getMsgStreamId()
    {
        return fHeader[7] << 0 & 0xff | fHeader[8] << 8 & 0xff00 | fHeader[9] << 16 & 0xff0000 | fHeader[10] << 24 & 0xff000000;
    }

    void setMsgDelta(int delta)
    {
        if(delta < 0xffffff)
        {
            set3ByteInt(fHeader, 0, delta);
            Arrays.fill(fExtendedTimestamp, (byte)0);
        } else
        {
            set3ByteInt(fHeader, 0, 0xffffff);
            fExtendedTimestamp[0] = (byte)(delta >> 24);
            fExtendedTimestamp[1] = (byte)(delta >> 16);
            fExtendedTimestamp[2] = (byte)(delta >> 8);
            fExtendedTimestamp[3] = (byte)delta;
        }
    }

    void setMsgLen(int len)
    {
        set3ByteInt(fHeader, 3, len);
    }

    void setMsgTypeId(byte typeId)
    {
        fHeader[6] = typeId;
    }

    void setMsgStreamId(int streamId)
    {
        fHeader[7] = (byte)(streamId >> 0);
        fHeader[8] = (byte)(streamId >> 8);
        fHeader[9] = (byte)(streamId >> 16);
        fHeader[10] = (byte)(streamId >> 24);
    }

    TChunkContext fpNext;
    TCMessageProcessor fGetMsg;
    Object fGetMsgContext;
    int fQueueID;
    int fPriority;
    int fCount;
    boolean fbEmpty;
    boolean fbUnregister;
    boolean fbWasEmptyOnRequest;
    TCMessage fpMsg;
    int fOutStreamId;
    long fOutMsgTime;
    int fMsgInset;
    int fChunkStreamId;
    long fMsgTime;
    byte fHeader[] = {
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0
    };
    byte fExtendedTimestamp[] = {
        0, 0, 0, 0
    };
}
