// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   LicenseServiceImpl.java

package flex.messaging.license;

import flex.license.common.LicenseLoader;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import java.io.*;
import java.text.DateFormat;
import java.util.*;

// Referenced classes of package flex.messaging.license:
//            StandardLicense, InvalidLicenseException, LicenseService, License

public final class LicenseServiceImpl
    implements LicenseService
{

    public LicenseServiceImpl(LicenseLoader loader, Logger logger)
    {
        licenseKey = null;
        evalCode = 0L;
        hiddenFile = null;
        betaRelease = false;
        betaPeriodDays = 152;
        betaStartsYear = 2006;
        betaStartsMonth = 3;
        betaStartsDay = 1;
        props = null;
        hiddenProps = null;
        this.loader = loader;
        this.logger = logger;
    }

    public String getLicenseKey()
    {
        return licenseKey;
    }

    public void setLicenseKey(String key)
    {
        licenseKey = key;
    }

    public boolean installLicense(String key)
    {
        loadEvalCode();
        if(key != null)
        {
            key = key.trim();
            if(key.length() == 0)
                key = null;
        }
        licenseKey = key;
        boolean success = validateLicense();
        success = success && updateEvalCode();
        if(success)
            success = updateLicenseFile();
        return success;
    }

    public boolean updateLicenseFile()
    {
        boolean success;
        FileOutputStream out;
        success = false;
        if(props == null)
            props = new Properties();
        if(hiddenProps == null)
            hiddenProps = new Properties();
        if(!betaRelease)
            try
            {
                hiddenProps.put("22", Long.toString(evalCode));
                loader.storeHiddenProperties(hiddenProps);
            }
            catch(Exception e)
            {
                props.put("22", Long.toString(evalCode));
            }
        out = null;
        if(licenseKey != null)
            props.put("fds", licenseKey);
        loader.storeProperties(props);
        success = true;
        Exception ex;
        if(out != null)
            try
            {
                out.close();
            }
            // Misplaced declaration of an exception variable
            catch(Exception ex) { }
        break MISSING_BLOCK_LABEL_218;
        ex;
        if(Log.isError())
            logger.error("License Service: Unable to update license file - " + ex.getMessage());
        if(out != null)
            try
            {
                out.close();
            }
            // Misplaced declaration of an exception variable
            catch(Exception ex) { }
        break MISSING_BLOCK_LABEL_218;
        Exception exception;
        exception;
        if(out != null)
            try
            {
                out.close();
            }
            catch(IOException ex) { }
        throw exception;
        return success;
    }

    private void loadEvalCode()
    {
        String evalCodeStr = null;
        hiddenProps = loader.loadHiddenProperties();
        if(hiddenProps != null)
        {
            evalCodeStr = hiddenProps.getProperty("22");
            if(evalCodeStr == null)
                try
                {
                    props = loader.loadProperties();
                    evalCodeStr = props.getProperty("22");
                }
                catch(Exception e) { }
            if(evalCodeStr != null)
            {
                evalCodeStr = evalCodeStr.trim();
                if(evalCodeStr.length() == 0)
                    evalCodeStr = null;
                if(evalCodeStr != null)
                    evalCode = Long.parseLong(evalCodeStr);
            }
        }
    }

    private void load()
    {
        try
        {
            props = loader.loadProperties();
            licenseKey = props.getProperty("fds");
            if(licenseKey != null)
                licenseKey = licenseKey.trim();
            if(licenseKey == null || licenseKey == "")
                licenseKey = null;
        }
        catch(FileNotFoundException ex)
        {
            if(Log.isWarn())
                logger.warn("License Service: Unable to open license file - " + ex.getMessage());
        }
        catch(Exception ex)
        {
            if(Log.isWarn())
                logger.warn("License Service: Unable to open license file - " + ex.getMessage());
        }
        loadEvalCode();
    }

    private boolean validateLicense()
    {
        license = new StandardLicense(licenseKey, evalCode, betaRelease);
        if(licenseKey != null && licenseKey.length() > 0 && !license.isValid())
        {
            InvalidLicenseException ile = new InvalidLicenseException();
            ile.setMessage(11150);
            throw ile;
        } else
        {
            return license.isValid();
        }
    }

    private boolean updateEvalCode()
    {
        boolean success = false;
        if(license.isTrial())
        {
            long effectiveEvalCode = ((StandardLicense)license).getEvalCode();
            if(evalCode == 0L && effectiveEvalCode != 0L)
            {
                evalCode = effectiveEvalCode;
                if(updateLicenseFile())
                    success = true;
            } else
            {
                success = true;
            }
        } else
        {
            success = true;
        }
        return success;
    }

    public void init()
    {
        license = null;
        load();
        validateLicense();
        updateEvalCode();
        if(isBetaExpired())
        {
            if(Log.isInfo())
                logger.info(expiredMessage());
            InvalidLicenseException ile = new InvalidLicenseException();
            ile.setMessage(11151);
            throw ile;
        }
        if(Log.isInfo())
        {
            String message = "Starting " + license.getEdition();
            if(betaRelease)
            {
                Calendar c = betaExpires();
                message = message + " (beta period ends " + DateFormat.getDateInstance().format(c.getTime()) + ")";
            }
            logger.info(message);
        }
        if(!betaRelease || isBetaExpired())
        {
            String warning = license.getLastWarningMessage();
            if(warning != null && Log.isWarn())
                logger.warn("License Service: " + warning);
        }
        if(license.isExpired() && Log.isWarn())
            logger.warn("License Service: The evaluation period has expired; switching to " + license.getExpressEdition());
    }

    public boolean isClusteringEnabled()
    {
        return license.isClusteringEnabled();
    }

    public boolean isConnectionLimited()
    {
        return license.isConnectionLimited();
    }

    public boolean isMxmlCompileEnabled()
    {
        return license.isMxmlCompileEnabled();
    }

    public boolean isValid()
    {
        return license.isValid();
    }

    public int getMajorVersion()
    {
        return license.getMajorVersion();
    }

    public Date getExpirationDate()
    {
        return license.getExpirationDate();
    }

    public int getEvalDays()
    {
        return license.getEvalDays();
    }

    public long getEvalDaysLeft()
    {
        return license.getEvalDaysLeft();
    }

    public boolean isExpired()
    {
        return license.isExpired();
    }

    public String getEdition()
    {
        return license.getEdition();
    }

    public String getLastWarningMessage()
    {
        return license.getLastWarningMessage();
    }

    private Calendar betaExpires()
    {
        if(!betaRelease)
        {
            return null;
        } else
        {
            Calendar expires = Calendar.getInstance();
            expires.clear();
            expires.set(11, 0);
            expires.set(12, 0);
            expires.set(13, 0);
            expires.set(1, betaStartsYear);
            expires.set(2, betaStartsMonth - 1);
            expires.set(5, betaStartsDay);
            expires.add(5, betaPeriodDays);
            return expires;
        }
    }

    public boolean isBetaExpired()
    {
        if(!betaRelease)
        {
            return false;
        } else
        {
            Calendar now = Calendar.getInstance();
            Calendar expires = betaExpires();
            return now.after(expires);
        }
    }

    public String expiredMessage()
    {
        String message = null;
        if(isBetaExpired())
            message = getEdition() + ": beta license expired!";
        return message;
    }

    private License license;
    private String licenseKey;
    private long evalCode;
    File hiddenFile;
    private boolean betaRelease;
    private int betaPeriodDays;
    private int betaStartsYear;
    private int betaStartsMonth;
    private int betaStartsDay;
    private LicenseLoader loader;
    private Logger logger;
    private Properties props;
    private Properties hiddenProps;
}
