// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   StandardLicense.java

package flex.messaging.license;

import flex.messaging.VersionInfo;
import java.util.Calendar;
import java.util.Date;

// Referenced classes of package flex.messaging.license:
//            AsnDecoder, License

public final class StandardLicense
    implements License
{

    public StandardLicense(String key, long evalCode, boolean betaRelease)
    {
        edition = 1;
        decoder = new AsnDecoder(key, betaRelease);
        setEdition();
        if(decoder.isTrial())
        {
            Calendar c = Calendar.getInstance();
            if(evalCode == 0L)
            {
                c.set(11, 0);
                c.set(12, 0);
                c.set(13, 0);
                evalCode = encodeDate(c.getTime().getTime());
            } else
            {
                Date evalDate = decodeDate(evalCode);
                c.setTime(evalDate);
            }
            if(c.after(Calendar.getInstance()))
            {
                expDate = new Date();
                evalDays = 0;
                warningMessage = "Flex has detected an installation in the future; evaluation license disabled.";
            } else
            {
                evalDays = decoder.getEvalDays();
                c.add(5, evalDays);
                expDate = c.getTime();
                if(getEvalDaysLeft() > 0L)
                    warningMessage = "The " + getEdition() + " evaluation period will expire in " + getEvalDaysLeft() + " days.";
            }
        } else
        {
            expDate = UNLIMITED_EXPIRATION;
        }
        this.evalCode = evalCode;
    }

    public long getEvalCode()
    {
        return evalCode;
    }

    public boolean isTrial()
    {
        return decoder.isTrial();
    }

    public boolean isValid()
    {
        return decoder.isValid();
    }

    public int getMajorVersion()
    {
        return VersionInfo.FLEX_MAJOR_VERSION;
    }

    public Date getExpirationDate()
    {
        return expDate;
    }

    public int getEvalDays()
    {
        return decoder.getEvalDays();
    }

    public long getEvalDaysLeft()
    {
        long diffDays = 0L;
        if(expDate != UNLIMITED_EXPIRATION)
        {
            int millisecToDays = 0x5265c00;
            long today = (new Date()).getTime() / 0x5265c00L;
            long expDay = expDate.getTime() / 0x5265c00L;
            diffDays = Math.max(0L, expDay - today);
        }
        return diffDays;
    }

    public boolean isExpired()
    {
        return expDate != null && getEvalDaysLeft() == 0L;
    }

    public String getExpressEdition()
    {
        return "Adobe Flex Data Services Express";
    }

    public String getEdition()
    {
        StringBuffer s = new StringBuffer("Adobe Flex Data Services ");
        s.append(VersionInfo.FLEX_MAJOR_VERSION);
        if(edition == 0)
            s.append(" Enterprise (Trial)");
        else
        if(edition == 1)
            s.append(" Express");
        else
        if(edition == 2)
            s.append(" Departmental");
        else
        if(edition == 3)
            s.append(" Departmental (Education)");
        else
        if(edition == 4)
            s.append(" Enterprise");
        else
        if(edition == 5)
            s.append(" Enterprise (Education)");
        else
            s.append(" Express");
        return s.toString();
    }

    void setEdition()
    {
        if(!decoder.isValid())
            edition = 1;
        else
        if(decoder.isTrial())
            edition = 0;
        else
        if(decoder.isEducation() && decoder.isDepartment())
            edition = 3;
        else
        if(decoder.isDepartment())
            edition = 2;
        else
        if(decoder.isEducation() && !decoder.isDepartment())
            edition = 5;
        else
        if(decoder.isValid() && !decoder.isTrial() && !decoder.isDepartment() && !decoder.isEducation())
            edition = 4;
        else
            edition = 1;
    }

    public String getLastWarningMessage()
    {
        return warningMessage;
    }

    static final Date decodeDate(long code)
    {
        Date d = null;
        if(code != 0L)
        {
            code = 0xcafebabeL ^ code;
            long time = code << 32 | code >>> 32;
            d = new Date(time);
        }
        return d;
    }

    static long encodeDate(long time)
    {
        return 0xcafebabeL ^ (time >>> 32 | time << 32);
    }

    public boolean isClusteringEnabled()
    {
        boolean enabled = true;
        if(!decoder.isValid())
            enabled = false;
        else
        if(decoder.isTrial() && isExpired())
            enabled = false;
        else
        if(edition == 1)
            enabled = false;
        return enabled;
    }

    public boolean isConnectionLimited()
    {
        boolean limited = false;
        if(decoder.isValid() && decoder.isDepartment())
            limited = true;
        return limited;
    }

    public boolean isMxmlCompileEnabled()
    {
        return true;
    }

    private static final int TRIAL_EDITION = 0;
    private static final int EXPRESS_EDITION = 1;
    private static final int DEPARTMENTAL_EDITION = 2;
    private static final int DEPARTMENTAL_EDU_EDITION = 3;
    private static final int FULL_EDITION = 4;
    private static final int FULL_EDU_EDITION = 5;
    private int edition;
    public static final Date UNLIMITED_EXPIRATION = null;
    private static final long MAGIC = 0xcafebabeL;
    private long evalCode;
    private Date expDate;
    private int evalDays;
    private String warningMessage;
    private AsnDecoder decoder;

}
