// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AbstractMessage.java

package flex.messaging.messages;

import flex.messaging.util.StringUtils;
import java.util.*;

// Referenced classes of package flex.messaging.messages:
//            Message

public abstract class AbstractMessage
    implements Message, Cloneable
{

    public AbstractMessage()
    {
    }

    public Object getClientId()
    {
        return clientId;
    }

    public void setClientId(Object clientId)
    {
        this.clientId = clientId;
    }

    public String getMessageId()
    {
        return messageId;
    }

    public void setMessageId(String messageId)
    {
        this.messageId = messageId;
    }

    public long getTimestamp()
    {
        return timestamp;
    }

    public void setTimestamp(long timestamp)
    {
        this.timestamp = timestamp;
    }

    public long getTimeToLive()
    {
        return timeToLive;
    }

    public void setTimeToLive(long timeToLive)
    {
        this.timeToLive = timeToLive;
    }

    public Object getBody()
    {
        return body;
    }

    public void setBody(Object body)
    {
        this.body = body;
    }

    public String getDestination()
    {
        return destination;
    }

    public void setDestination(String destination)
    {
        this.destination = destination;
    }

    public Map getHeaders()
    {
        if(headers == null)
            headers = new HashMap();
        return headers;
    }

    public void setHeaders(Map newHeaders)
    {
        String propName;
        for(Iterator iter = newHeaders.keySet().iterator(); iter.hasNext(); setHeader(propName, newHeaders.get(propName)))
            propName = (String)iter.next();

    }

    public Object getHeader(String headerName)
    {
        if(headers == null)
            headers = new HashMap();
        return headers.get(headerName);
    }

    public void setHeader(String headerName, Object value)
    {
        if(headers == null)
            headers = new HashMap();
        if(value == null)
            headers.remove(headerName);
        else
            headers.put(headerName, value);
    }

    public boolean headerExists(String headerName)
    {
        return headers != null && headers.containsKey(headerName);
    }

    public boolean equals(Object o)
    {
        if(o instanceof Message)
        {
            Message m = (Message)o;
            if(m.getMessageId().equals(getMessageId()))
                return true;
        }
        return false;
    }

    public String toString()
    {
        return toString(1);
    }

    public String toString(int indent)
    {
        return toStringHeader(indent) + toStringFields(indent + 1);
    }

    public Object clone()
    {
        AbstractMessage m = null;
        try
        {
            m = (AbstractMessage)super.clone();
        }
        catch(CloneNotSupportedException exc) { }
        if(headers != null)
            m.headers = (HashMap)((HashMap)headers).clone();
        return m;
    }

    protected String getIndent(int indentLevel)
    {
        if(indentLevel < indentLevels.length)
            return indentLevels[indentLevel];
        StringBuffer sb = new StringBuffer();
        sb.append(indentLevels[indentLevels.length - 1]);
        indentLevel -= indentLevels.length - 1;
        for(int i = 0; i < indentLevel; i++)
            sb.append("  ");

        return sb.toString();
    }

    protected String getFieldSeparator(int indentLevel)
    {
        String indStr = getIndent(indentLevel);
        if(indentLevel > 0)
            indStr = StringUtils.NEWLINE + indStr;
        else
            indStr = " ";
        return indStr;
    }

    protected String toStringHeader(int indentLevel)
    {
        String s = "Flex Message";
        s = s + " (" + getClass().getName() + ") ";
        return s;
    }

    protected String toStringFields(int indentLevel)
    {
        if(headers != null)
        {
            String sep = getFieldSeparator(indentLevel);
            String s = "";
            for(Iterator i = headers.entrySet().iterator(); i.hasNext();)
            {
                java.util.Map.Entry e = (java.util.Map.Entry)i.next();
                s = s + sep + "hdr(" + e.getKey() + ") = " + bodyToString(e.getValue(), indentLevel + 1);
            }

            return s;
        } else
        {
            return "";
        }
    }

    protected final String bodyToString(Object body, int indentLevel)
    {
        indentLevel++;
        if(indentLevel > 18)
            return StringUtils.NEWLINE + getFieldSeparator(indentLevel) + "<..max-depth-reached..>";
        else
            return internalBodyToString(body, indentLevel);
    }

    protected String internalBodyToString(Object body, int indentLevel)
    {
        if(body instanceof Object[])
        {
            String sep = getFieldSeparator(indentLevel);
            StringBuffer sb = new StringBuffer();
            Object arr[] = (Object[])(Object[])body;
            sb.append(getFieldSeparator(indentLevel - 1));
            sb.append("[");
            sb.append(sep);
            for(int i = 0; i < arr.length; i++)
            {
                if(i != 0)
                {
                    sb.append(",");
                    sb.append(sep);
                }
                sb.append(bodyToString(arr[i], indentLevel));
            }

            sb.append(getFieldSeparator(indentLevel - 1));
            sb.append("]");
            return sb.toString();
        }
        if(body instanceof Map)
        {
            Map bodyMap = (Map)body;
            StringBuffer buf = new StringBuffer();
            buf.append("{");
            Iterator it = bodyMap.entrySet().iterator();
            do
            {
                if(!it.hasNext())
                    break;
                java.util.Map.Entry e = (java.util.Map.Entry)it.next();
                Object key = e.getKey();
                Object value = e.getValue();
                buf.append((key != this ? key : "(recursive Map as key)") + "=" + (value != this ? bodyToString(value, indentLevel + 1) : "(recursive Map as value)"));
                if(it.hasNext())
                    buf.append(", ");
            } while(true);
            buf.append("}");
            return buf.toString();
        }
        if(body instanceof AbstractMessage)
            return ((AbstractMessage)body).toString(indentLevel);
        if(body != null)
            return body.toString();
        else
            return "null";
    }

    public String logCategory()
    {
        return "Message.General";
    }

    private static final long serialVersionUID = 0x38953307L;
    protected Object clientId;
    protected String destination;
    protected String messageId;
    protected long timestamp;
    protected long timeToLive;
    protected Map headers;
    protected Object body;
    static final String indentLevels[] = {
        "", "  ", "    ", "      ", "        ", "          "
    };

}
