// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   LoginManager.java

package flex.messaging.security;

import flex.messaging.FlexContext;
import flex.messaging.FlexSession;
import flex.messaging.config.SecurityConstraint;
import flex.messaging.config.SecuritySettings;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.util.ClassUtil;
import java.security.Principal;
import java.util.*;
import javax.servlet.http.HttpServletResponse;

// Referenced classes of package flex.messaging.security:
//            SecurityException, LoginCommand

public class LoginManager
{

    public LoginManager()
    {
        logger = Log.getLogger("Security");
    }

    public void init(SecuritySettings settings)
    {
label0:
        {
            Map loginCommands = settings.getLoginCommands();
            String loginClass = (String)loginCommands.get("all");
            if(loginClass != null)
            {
                loginCommand = createLoginCommand(loginClass);
                break label0;
            }
            String serverInfo = settings.getServerInfo();
            loginClass = (String)loginCommands.get(serverInfo);
            if(loginClass != null)
            {
                loginCommand = createLoginCommand(loginClass);
                break label0;
            }
            serverInfo = serverInfo.toLowerCase();
            Iterator iterator = loginCommands.keySet().iterator();
            String serverMatch;
            do
            {
                if(!iterator.hasNext())
                    break label0;
                serverMatch = (String)iterator.next();
                loginClass = (String)loginCommands.get(serverMatch);
            } while(serverInfo.indexOf(serverMatch.toLowerCase()) == -1);
            loginCommands.put(serverInfo, loginClass);
            loginCommand = createLoginCommand(loginClass);
        }
    }

    public void login(String username, Object credentials)
    {
        if(getCurrentPrincipal() == null)
        {
            if(loginCommand != null)
            {
                if(username != null && credentials != null)
                {
                    Principal authenticated = loginCommand.doAuthentication(username, credentials);
                    if(authenticated == null)
                    {
                        SecurityException se = new SecurityException();
                        se.setMessage(10050);
                        se.setCode("Client.Authentication");
                        throw se;
                    }
                    setCurrentPrincipal(authenticated);
                } else
                {
                    SecurityException se = new SecurityException();
                    se.setMessage(10051);
                    se.setCode("Client.Authentication");
                    throw se;
                }
            } else
            {
                SecurityException se = new SecurityException();
                se.setMessage(10053);
                se.setCode("Server.Authentication");
                throw se;
            }
        } else
        if(username != null && !username.equals(getCurrentPrincipal().getName()))
        {
            SecurityException se = new SecurityException();
            se.setMessage(10054);
            se.setCode("Client.Authentication");
            throw se;
        }
    }

    public void logout()
    {
        if(loginCommand != null)
        {
            loginCommand.logout(getCurrentPrincipal());
            FlexContext.getFlexSession().invalidate();
        } else
        {
            FlexContext.getFlexSession().invalidate();
            SecurityException se = new SecurityException();
            se.setMessage(10053);
            se.setCode("Server.Authorization");
            throw se;
        }
    }

    public void checkConstraint(SecurityConstraint constraint)
    {
        if(constraint != null)
        {
            Principal currentPrincipal = getCurrentPrincipal();
            if(currentPrincipal != null)
            {
                List roles = constraint.getRoles();
                boolean authorized = roles == null || checkRoles(currentPrincipal, roles);
                if(!authorized)
                {
                    SecurityException se = new SecurityException();
                    se.setMessage(10055);
                    se.setCode("Client.Authorization");
                    throw se;
                }
            } else
            {
                SecurityException se;
                if(!useCustomAuth(constraint))
                {
                    if(FlexContext.getHttpResponse() == null)
                    {
                        se = new SecurityException();
                        se.setMessage(10057);
                        se.setCode("Client.Authorization");
                        throw se;
                    }
                    FlexContext.getHttpResponse().setStatus(401);
                    FlexContext.getHttpResponse().addHeader("WWW-Authenticate", "Basic realm=\"default\"");
                }
                se = new SecurityException();
                se.setMessage(10056);
                se.setCode("Client.Authentication");
                throw se;
            }
        }
    }

    public boolean checkRoles(Principal principal, List roles)
    {
        return loginCommand.doAuthorization(principal, roles);
    }

    private boolean useCustomAuth(SecurityConstraint constraint)
    {
        return "Custom".equals(constraint.getMethod());
    }

    private Principal getCurrentPrincipal()
    {
        return FlexContext.getFlexSession().getUserPrincipal();
    }

    private void setCurrentPrincipal(Principal p)
    {
        FlexContext.getFlexSession().setUserPrincipal(p);
    }

    private static LoginCommand createLoginCommand(String loginClass)
    {
        Class c = ClassUtil.createClass(loginClass);
        return (LoginCommand)ClassUtil.createDefaultInstance(c, flex.messaging.security.LoginCommand.class);
    }

    private LoginCommand loginCommand;
    private Logger logger;
    public static final String LOG_CATEGORY = "Security";
    public static final String SERVER_MATCH_OVERRIDE = "all";
    private static final int INVALID_LOGIN = 10050;
    private static final int LOGIN_REQ = 10051;
    private static final int NO_LOGIN_COMMAND = 10053;
    private static final int CANNOT_REAUTH = 10054;
    private static final int ACCESS_DENIED = 10055;
    private static final int LOGIN_REQ_FOR_AUTH = 10056;
    private static final int RTMP_NO_BASIC_SECURITY = 10057;
}
