// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AbstractService.java

package flex.messaging.services;

import flex.management.BaseControl;
import flex.management.ManageableComponent;
import flex.management.runtime.messaging.services.ServiceControl;
import flex.messaging.*;
import flex.messaging.cluster.ClusterManager;
import flex.messaging.config.DestinationSettings;
import flex.messaging.config.ServiceSettings;
import flex.messaging.messages.CommandMessage;
import flex.messaging.messages.Message;
import java.util.*;

// Referenced classes of package flex.messaging.services:
//            Service, ServiceAdapter

public abstract class AbstractService extends ManageableComponent
    implements Service
{

    public AbstractService(MessageBroker broker, ServiceSettings settings)
    {
        this(broker, settings, broker.isManaged());
    }

    public AbstractService(MessageBroker broker, ServiceSettings settings, boolean enableManagement)
    {
        super(enableManagement);
        this.settings = settings;
        this.broker = broker;
        destinations = new HashMap();
        id = settings.getId();
        supportedMessageTypes = settings.getMessageTypes();
        if(isManaged())
            setupServiceControl(broker);
    }

    public void createDestinations()
    {
        Map destinationSettings = settings.getDestinationSettings();
        DestinationSettings destSettings;
        for(Iterator destSettingsIter = destinationSettings.keySet().iterator(); destSettingsIter.hasNext(); createDestination(destSettings))
        {
            String destName = (String)destSettingsIter.next();
            destSettings = (DestinationSettings)destinationSettings.get(destName);
        }

    }

    public String getId()
    {
        return id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public MessageBroker getMessageBroker()
    {
        return broker;
    }

    public ServiceSettings getSettings()
    {
        return settings;
    }

    public boolean isSupportedMessage(Message message)
    {
        return isSupportedMessageType(message.getClass().getName());
    }

    public boolean isSupportedMessageType(String messageClassName)
    {
        return supportedMessageTypes.contains(messageClassName);
    }

    public void createDestination(DestinationSettings destSettings)
    {
        Destination dest = new Destination(this, destSettings);
        destinations.put(dest.getId(), dest);
        dest.initDestination();
        if(isManaged() && dest.isManaged())
            ((ServiceControl)getControl()).addDestination(dest.getControl().getObjectName());
    }

    public Destination getDestination(Message message)
    {
        return getDestinationByName(message.getDestination());
    }

    public Destination getDestinationByName(String destinationName)
    {
        if(!destinations.containsKey(destinationName))
            throw new MessageException("No destination '" + destinationName + "' exists in service " + getClass().getName());
        else
            return (Destination)destinations.get(destinationName);
    }

    public Object serviceMessage(Message message)
    {
        throw new UnsupportedOperationException();
    }

    public Object serviceCommand(CommandMessage message)
    {
        Object result = serviceCommonCommands(message);
        if(result != null)
        {
            if(isManaged())
                ((ServiceControl)getControl()).incrementServiceCommandCount();
            return result;
        } else
        {
            throw new MessageException("Service Does Not Support Command Type " + message.getOperation());
        }
    }

    protected Object serviceCommonCommands(CommandMessage message)
    {
        Object commandResult = null;
        if(message.getOperation() == 5)
            commandResult = new Boolean(true);
        else
        if(message.getOperation() == 7)
        {
            ClusterManager clusterManager = broker.getClusterManager();
            String serviceType = getClass().getName();
            String destinationName = message.getDestination();
            if(clusterManager.isDestinationClustered(serviceType, destinationName))
                commandResult = clusterManager.getEndpointsForDestination(serviceType, destinationName);
            else
                commandResult = new Boolean(false);
        }
        return commandResult;
    }

    public void start()
    {
        Iterator iter = destinations.values().iterator();
        do
        {
            if(!iter.hasNext())
                break;
            Destination destination = (Destination)iter.next();
            if(destination.getAdapter() != null)
                destination.getAdapter().initialize();
        } while(true);
    }

    public final void stop()
    {
        Iterator iter = destinations.values().iterator();
        do
        {
            if(!iter.hasNext())
                break;
            Destination destination = (Destination)iter.next();
            if(destination.getAdapter() != null)
                destination.getAdapter().stop();
        } while(true);
    }

    protected abstract void setupServiceControl(MessageBroker messagebroker);

    protected ServiceSettings settings;
    protected MessageBroker broker;
    protected List supportedMessageTypes;
    protected Map destinations;
    private String id;
}
