// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HTTPProxyService.java

package flex.messaging.services;

import flex.management.BaseControl;
import flex.management.runtime.messaging.services.HTTPProxyServiceControl;
import flex.messaging.*;
import flex.messaging.config.DestinationSettings;
import flex.messaging.config.ServiceSettings;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.*;
import flex.messaging.services.http.HTTPProxyDestination;
import flex.messaging.services.http.proxy.ProxyException;
import flex.messaging.util.StringUtils;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;

// Referenced classes of package flex.messaging.services:
//            AbstractService, ServiceAdapter

public class HTTPProxyService extends AbstractService
{

    public HTTPProxyService(MessageBroker broker, ServiceSettings settings)
    {
        this(broker, settings, broker.isManaged());
    }

    public HTTPProxyService(MessageBroker broker, ServiceSettings settings, boolean enableManagement)
    {
        super(broker, settings, enableManagement);
    }

    public void createDestination(DestinationSettings destSettings)
    {
        HTTPProxyDestination dest = new HTTPProxyDestination(this, destSettings);
        destinations.put(dest.getId(), dest);
        dest.initDestination();
        if(isManaged() && dest.isManaged())
            controller.addDestination(dest.getControl().getObjectName());
    }

    public Object serviceMessage(Message msg)
    {
        HTTPMessage message = (HTTPMessage)msg;
        String destination = message.getDestination();
        HTTPProxyDestination dest = (HTTPProxyDestination)destinations.get(destination);
        FlexRemoteCredentials remoteCredentials = FlexContext.getFlexSession().getRemoteCredentials(getId(), destination);
        if(remoteCredentials != null)
        {
            message.setRemoteUsername(remoteCredentials.getUsername());
            message.setRemotePassword((String)remoteCredentials.getCredentials());
        } else
        if(dest.getRemoteUsername() != null && dest.getRemotePassword() != null)
        {
            message.setRemoteUsername(dest.getRemoteUsername());
            message.setRemotePassword(dest.getRemotePassword());
        }
        ServiceAdapter adapter = dest.getAdapter();
        Object result;
        if(message instanceof SOAPMessage)
            result = invokeSoap(adapter, (SOAPMessage)message, dest);
        else
            result = invokeHttp(adapter, message, dest);
        if(Log.isDebug())
        {
            String debugResult = StringUtils.prettifyString(String.valueOf(result));
            Log.getLogger("Service.HTTP").debug("HTTP request: " + message + StringUtils.NEWLINE + "  response: " + StringUtils.NEWLINE + debugResult + StringUtils.NEWLINE);
        }
        return result;
    }

    protected Object invokeSoap(ServiceAdapter adapter, SOAPMessage message, HTTPProxyDestination destination)
    {
        if(isManaged())
            controller.incrementInvokeSOAPCount();
        String dynamicUrl = message.getUrl();
        String contextPath = null;
        String serverName = null;
        String serverPort = null;
        String protocol = null;
        HttpServletRequest req = FlexContext.getHttpRequest();
        if(req != null)
        {
            contextPath = req.getContextPath();
            protocol = req.getScheme();
            serverName = req.getServerName();
            int port = req.getServerPort();
            if(port != 0)
                serverPort = (new Integer(req.getServerPort())).toString();
        }
        if(dynamicUrl != null && dynamicUrl.length() > 0)
            checkUrl(dynamicUrl, contextPath, destination, serverName, serverPort, protocol, message.getRemoteUsername() != null);
        else
            throw new MessageException("A SOAP endpoint was not provided.");
        return adapter.invoke(message);
    }

    protected Object invokeHttp(ServiceAdapter adapter, HTTPMessage message, HTTPProxyDestination destination)
    {
        if(isManaged())
            controller.incrementInvokeHTTPCount();
        String dynamicUrl = message.getUrl();
        String contextPath = null;
        String serverName = null;
        String serverPort = null;
        String protocol = null;
        HttpServletRequest req = FlexContext.getHttpRequest();
        if(req != null)
        {
            contextPath = req.getContextPath();
            protocol = req.getScheme();
            serverName = req.getServerName();
            int port = req.getServerPort();
            if(port != 0)
                serverPort = Integer.toString(req.getServerPort());
        }
        if(dynamicUrl != null && !"".equals(dynamicUrl))
        {
            checkUrl(dynamicUrl, contextPath, destination, serverName, serverPort, protocol, message.getRemoteUsername() != null);
        } else
        {
            String url = destination.getParsedDefaultUrl(contextPath, serverName, serverPort, protocol);
            message.setUrl(url);
        }
        return adapter.invoke(message);
    }

    protected void checkUrl(String url, String contextPath, HTTPProxyDestination destination, String serverName, String serverPort, String serverProtocol, boolean authSupplied)
    {
        String defaultUrl = destination.getParsedDefaultUrl(contextPath, serverName, serverPort, serverProtocol);
        List dynamicUrls = destination.getParsedDynamicUrls(contextPath);
        for(int i = url.indexOf("/.."); i != -1; i = url.indexOf("/..", i + 1))
            if(i == url.length() - 3 || url.charAt(i + 3) == '/')
                throw new ProxyException(10700);

        url = url.toLowerCase();
        if(defaultUrl != null && defaultUrl.toLowerCase().equals(url))
            return;
        char urlChars[] = url.toCharArray();
        for(int i = 0; i < dynamicUrls.size(); i++)
        {
            char pattern[] = (char[])(char[])dynamicUrls.get(i);
            boolean matches = StringUtils.findMatchWithWildcard(urlChars, pattern);
            if(matches)
                if(!authSupplied || destination.allowsDynamicAuthentication())
                    return;
                else
                    throw new ProxyException(10701);
        }

        ProxyException exception = new ProxyException();
        exception.setMessage(10702, new Object[] {
            url, destination.getId()
        });
        throw exception;
    }

    protected void setupServiceControl(MessageBroker broker)
    {
        controller = new HTTPProxyServiceControl(getId(), this, broker.getControl());
        controller.register();
        setControl(controller);
    }

    public static final String LOG_CATEGORY = "Service.HTTP";
    private static final int DOT_DOT_NOT_ALLOWED = 10700;
    private static final int MULTIPLE_DOMAIN_PORT = 10701;
    private static final int DYNAMIC_NOT_CONFIGURED = 10702;
    private HTTPProxyServiceControl controller;
}
