// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MessageService.java

package flex.messaging.services;

import flex.management.BaseControl;
import flex.management.runtime.messaging.services.MessageServiceControl;
import flex.messaging.*;
import flex.messaging.cluster.ClusterManager;
import flex.messaging.config.*;
import flex.messaging.durability.MessageCache;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.*;
import flex.messaging.services.messaging.MessagingConstants;
import flex.messaging.services.messaging.SubscriptionManager;
import flex.messaging.services.messaging.Subtopic;
import flex.messaging.services.messaging.ThrottleManager;
import flex.messaging.services.messaging.adapters.MessagingAdapter;
import flex.messaging.services.messaging.selector.JMSSelector;
import flex.messaging.services.messaging.selector.JMSSelectorException;
import flex.messaging.util.StringUtils;
import java.util.*;

// Referenced classes of package flex.messaging.services:
//            AbstractService, ServiceException, ServiceAdapter

public class MessageService extends AbstractService
    implements MessagingConstants
{

    public MessageService(MessageBroker broker, ServiceSettings settings)
    {
        this(broker, settings, broker.isManaged());
    }

    public MessageService(MessageBroker broker, ServiceSettings settings, boolean enableManagement)
    {
        super(broker, settings, enableManagement);
    }

    public void createDestination(DestinationSettings destSettings)
    {
        MessageDestination dest = new MessageDestination(this, destSettings);
        destinations.put(dest.getId(), dest);
        dest.initDestination();
        if(isManaged() && dest.isManaged())
            controller.addDestination(dest.getControl().getObjectName());
    }

    public Object serviceMessage(Message message)
    {
        Object result = null;
        incrementMessageCount(false);
        MessageDestination dest = (MessageDestination)getDestination(message);
        int throttleResult = dest.getThrottleManager().throttleIncomingMessage(message);
        if(throttleResult != 1)
        {
            String subtopicString = (String)message.getHeader("DSSubtopic");
            if(subtopicString != null && subtopicString.length() > 0)
            {
                Subtopic subtopic = new Subtopic(subtopicString, dest.getServerSettings().getSubtopicSeparator());
                if(subtopic.containsSubtopicWildcard())
                {
                    ServiceException se = new ServiceException();
                    se.setMessage(10556, new Object[] {
                        subtopicString
                    });
                    throw se;
                }
            }
            ServerSettings destServerSettings = dest.getServerSettings();
            if(destServerSettings.getMessageTTL() >= 0L)
                message.setTimeToLive(destServerSettings.getMessageTTL());
            result = dest.getAdapter().invoke(message);
        }
        return result;
    }

    public Object serviceCommand(CommandMessage message)
    {
        incrementMessageCount(true);
        Object commandResult = super.serviceCommonCommands(message);
        if(commandResult == null)
            commandResult = manageSubscriptions(message, true);
        return commandResult;
    }

    public void serviceMessageFromAdapter(Message message, boolean sendToAllSubscribers)
    {
        if(isManaged())
            ((MessageServiceControl)getControl()).incrementServiceMessageFromAdapterCount();
        if(sendToAllSubscribers)
        {
            pushMessageToClients(message, false);
            sendPushMessageFromPeer(message, false);
        } else
        {
            Set subscriberIds = new TreeSet();
            subscriberIds.add(message.getClientId());
            pushMessageToClients(subscriberIds, message, false);
        }
    }

    public void sendPushMessageFromPeer(Message message, boolean evalSelector)
    {
        MessageDestination destination = (MessageDestination)getDestination(message);
        if(destination.isClustered())
        {
            ClusterManager clm = broker.getClusterManager();
            clm.invokeServiceOperation(getClass().getName(), message.getDestination(), "pushMessageFromPeer", new Object[] {
                message, new Boolean(evalSelector)
            });
        }
    }

    public void pushMessageFromPeer(AsyncMessage message, Boolean evalSelector)
    {
        FlexContext.setMessageFromPeer(true);
        pushMessageToClients(message, evalSelector.booleanValue());
        FlexContext.setMessageFromPeer(false);
    }

    public void pushMessageToClients(Message message, boolean evalSelector)
    {
        MessageDestination destination = (MessageDestination)getDestination(message);
        SubscriptionManager subscriptionManager = destination.getSubscriptionManager();
        String subtopicString = (String)message.getHeader("DSSubtopic");
        Set subscriberIds = null;
        Subtopic subtopic = null;
        if(subtopicString != null && subtopicString.length() > 0)
        {
            if(!destination.getServerSettings().getAllowSubtopics())
            {
                ServiceException se = new ServiceException();
                se.setMessage(10553, new Object[] {
                    subtopicString, destination.getId()
                });
                throw se;
            }
            subtopic = new Subtopic(subtopicString, destination.getServerSettings().getSubtopicSeparator());
            ServiceAdapter adapter = destination.getAdapter();
            if((adapter instanceof MessagingAdapter) && !((MessagingAdapter)adapter).allowSend(subtopic))
            {
                ServiceException se = new ServiceException();
                se.setMessage(10558, new Object[] {
                    subtopicString
                });
                throw se;
            }
            subscriberIds = subscriptionManager.getSubscriberIds(subtopic);
        } else
        {
            subscriberIds = subscriptionManager.getSubscriberIds();
        }
        if(subscriberIds != null && !subscriberIds.isEmpty())
            pushMessageToClients(destination, subtopic, subscriberIds, message, evalSelector);
    }

    public void pushMessageToClients(Set subscriberIds, Message message, boolean evalSelector)
    {
        MessageDestination destination = (MessageDestination)getDestination(message);
        pushMessageToClients(destination, null, subscriberIds, message, evalSelector);
    }

    public void pushMessageToClients(MessageDestination destination, Set subscriberIds, Message message, boolean evalSelector)
    {
        pushMessageToClients(destination, null, subscriberIds, message, evalSelector);
    }

    public void pushMessageToClients(MessageDestination destination, Subtopic subtopic, Set subscriberIds, Message message, boolean evalSelector)
    {
        if(subscriberIds != null)
        {
            int throttleResult = destination.getThrottleManager().throttleOutgoingMessage(message, null);
            if(throttleResult != 1)
            {
                SubscriptionManager subscriptionManager = destination.getSubscriptionManager();
                Iterator clientIter = subscriberIds.iterator();
                do
                {
                    if(!clientIter.hasNext())
                        break;
                    Object clientId = clientIter.next();
                    Object clientObj = null;
                    if(subtopic != null)
                        clientObj = subscriptionManager.getSubscriber(clientId, subtopic);
                    else
                        clientObj = subscriptionManager.getSubscriber(clientId);
                    if(clientObj == null)
                        continue;
                    MessageClient client = (MessageClient)clientObj;
                    if(!client.isValid() && !(message instanceof CommandMessage))
                        continue;
                    if(evalSelector && client.getProperty("DSSelector") != null)
                    {
                        String selectorExpr = (String)client.getProperty("DSSelector");
                        JMSSelector selector = new JMSSelector(selectorExpr);
                        try
                        {
                            if(!selector.match(message))
                                continue;
                        }
                        catch(JMSSelectorException jmse)
                        {
                            if(Log.isWarn())
                                Log.getLogger("MessageSelector").debug("Error processing message selector: " + jmse.toString() + StringUtils.NEWLINE + "  incomingMessage: " + message + StringUtils.NEWLINE + "  selector: " + selectorExpr + StringUtils.NEWLINE + "  clientId: " + client.getClientId());
                            continue;
                        }
                    }
                    if(throttleResult == 0)
                        try
                        {
                            throttleResult = destination.getThrottleManager().throttleOutgoingMessage(message, clientId);
                        }
                        catch(MessageException e)
                        {
                            Log.getLogger("Service.Message").error(e.getMessage(), e);
                        }
                    if(throttleResult != 1)
                        try
                        {
                            broker.routeMessageToClient(client, message);
                            if(client.isValid())
                            {
                                if(!(message instanceof CommandMessage))
                                    client.updateLastUse();
                            } else
                            {
                                client.destroy();
                            }
                        }
                        catch(UnsupportedOperationException ue)
                        {
                            boolean replace = throttleResult == 2;
                            if(destination.getMessageStore() == null)
                                synchronized(this)
                                {
                                    if(destination.getMessageStore() == null)
                                        destination.setMessageStore(new MessageCache(destination));
                                }
                            destination.getMessageStore().putMessage(message, clientId, replace);
                            if(!client.isValid())
                                client.scheduleDestroy();
                        }
                        catch(MessageException me)
                        {
                            if(!(message instanceof CommandMessage) || (message instanceof CommandMessage) && ((CommandMessage)message).getOperation() != 10)
                            {
                                boolean isDurable = destination.getServerSettings().isDurable();
                                if(isDurable)
                                {
                                    boolean replace = throttleResult == 2;
                                    if(destination.getMessageStore() == null)
                                        synchronized(this)
                                        {
                                            if(destination.getMessageStore() == null)
                                                destination.setMessageStore(new MessageCache(destination));
                                        }
                                    destination.getMessageStore().putMessage(message, clientId, replace);
                                }
                            }
                            if(!client.isValid())
                                client.destroy();
                        }
                } while(true);
            }
        }
    }

    protected void incrementMessageCount(boolean commandMessage)
    {
        if(isManaged())
            if(commandMessage)
                ((MessageServiceControl)getControl()).incrementServiceCommandCount();
            else
                ((MessageServiceControl)getControl()).incrementServiceMessageCount();
    }

    protected Message manageSubscriptions(CommandMessage command, boolean useAdapter)
    {
        Message replyMessage = null;
        MessageDestination destination = (MessageDestination)getDestination(command);
        Object clientId = command.getClientId();
        String subtopicString = (String)command.getHeader("DSSubtopic");
        MessageClient client = null;
        Subtopic subtopic = null;
        if(subtopicString != null && subtopicString.length() > 0)
        {
            subtopic = new Subtopic(subtopicString, destination.getServerSettings().getSubtopicSeparator());
            client = destination.getSubscriptionManager().getSubscriber(clientId, subtopic);
        } else
        {
            client = destination.getSubscriptionManager().getSubscriber(clientId);
        }
        ServiceAdapter adapter = destination.getAdapter();
        if(command.getOperation() == 0)
        {
            if(client != null)
            {
                client.updateLastUse();
                if(!useAdapter && client.getProperty("DSSelector") != command.getHeader("DSSelector"))
                {
                    client.setProperty("DSSelector", command.getHeader("DSSelector"));
                } else
                {
                    broker.inspectChannel(command, destination);
                    for(Iterator endpointIter = client.getEndpoints().iterator(); endpointIter.hasNext(); endpointIter.remove())
                        endpointIter.next();

                    if(command.getHeader("DSSelector") != null && client.getProperty("DSSelector") != command.getHeader("DSSelector"))
                        if(useAdapter && adapter.handlesSubscriptions())
                        {
                            adapter.manage(command);
                        } else
                        {
                            String selectorExpr = (String)command.getHeader("DSSelector");
                            testSelector(selectorExpr, command);
                            client.setProperty("DSSelector", selectorExpr);
                        }
                    client.addEndpoint((String)command.getHeader("DSEndpoint"));
                    replyMessage = new AcknowledgeMessage();
                }
            } else
            {
                broker.inspectOperation(command, destination);
                if((adapter instanceof MessagingAdapter) && subtopic != null && !((MessagingAdapter)adapter).allowSubscribe(subtopic))
                {
                    ServiceException se = new ServiceException();
                    se.setMessage(10557, new Object[] {
                        subtopicString
                    });
                    throw se;
                }
                client = new MessageClient(clientId, destination);
                if(useAdapter && adapter.handlesSubscriptions())
                {
                    adapter.manage(command);
                } else
                {
                    String selectorExpr = (String)command.getHeader("DSSelector");
                    if(selectorExpr != null)
                    {
                        testSelector(selectorExpr, command);
                        client.setProperty("DSSelector", selectorExpr);
                    }
                }
                client.addEndpoint((String)command.getHeader("DSEndpoint"));
                if(subtopic != null)
                {
                    if(!destination.getServerSettings().getAllowSubtopics())
                    {
                        ServiceException se = new ServiceException();
                        se.setMessage(10553, new Object[] {
                            subtopicString, destination.getId()
                        });
                        throw se;
                    }
                    destination.getSubscriptionManager().addSubscriber(client, subtopic);
                } else
                {
                    destination.getSubscriptionManager().addSubscriber(client);
                }
                client.updateLastUse();
                replyMessage = new AcknowledgeMessage();
            }
        } else
        if(command.getOperation() == 1)
        {
            if(client != null)
            {
                for(Iterator endpointIter = client.getEndpoints().iterator(); endpointIter.hasNext(); endpointIter.remove())
                    endpointIter.next();

                if(subtopic != null)
                {
                    if(!destination.getServerSettings().getAllowSubtopics())
                    {
                        ServiceException se = new ServiceException();
                        se.setMessage(10553, new Object[] {
                            subtopicString, destination.getId()
                        });
                        throw se;
                    }
                    destination.getSubscriptionManager().removeSubscriber(client, subtopic);
                } else
                {
                    destination.getSubscriptionManager().removeSubscriber(client);
                }
                if(useAdapter && adapter.handlesSubscriptions())
                    adapter.manage(command);
                replyMessage = new AcknowledgeMessage();
            } else
            {
                ServiceException se = new ServiceException();
                se.setMessage(10551, new Object[] {
                    destination.getId()
                });
                throw se;
            }
        } else
        if(command.getOperation() == 2)
        {
            if(client != null)
            {
                List missedMessages = null;
                if(useAdapter && adapter.handlesSubscriptions())
                    missedMessages = (List)adapter.manage(command);
                List unpushedMessages = null;
                if(destination.getMessageStore() != null)
                    unpushedMessages = destination.getMessageStore().getMessages(command.getTimestamp(), clientId);
                if(unpushedMessages != null)
                    if(missedMessages != null)
                        missedMessages.addAll(unpushedMessages);
                    else
                        missedMessages = unpushedMessages;
                if(missedMessages != null)
                {
                    replyMessage = new CommandMessage(4);
                    replyMessage.setBody(((Object) (missedMessages.toArray())));
                } else
                {
                    replyMessage = new AcknowledgeMessage();
                }
                if(!client.isValid())
                    client.destroy();
            } else
            {
                ServiceException se = new ServiceException();
                se.setMessage(10551, new Object[] {
                    destination.getId()
                });
                throw se;
            }
        } else
        {
            ServiceException se = new ServiceException();
            se.setMessage(10552, new Object[] {
                new Integer(command.getOperation())
            });
            throw se;
        }
        return replyMessage;
    }

    protected void setupServiceControl(MessageBroker broker)
    {
        controller = new MessageServiceControl(getId(), this, broker.getControl());
        controller.register();
        setControl(controller);
    }

    private void testSelector(String selectorExpression, Message msg)
    {
        try
        {
            JMSSelector selector = new JMSSelector(selectorExpression);
            selector.match(msg);
        }
        catch(Exception e)
        {
            ServiceException se = new ServiceException();
            se.setMessage(10550, new Object[] {
                selectorExpression
            });
            se.setRootCause(e);
            throw se;
        }
    }

    public static final String LOG_CATEGORY = "Service.Message";
    private static final int BAD_SELECTOR = 10550;
    private static final int NOT_SUBSCRIBED = 10551;
    private static final int UNKNOWN_COMMAND = 10552;
    private static final int SUBTOPICS_NOT_SUPPORTED = 10553;
    private MessageServiceControl controller;
}
