// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   RemotingService.java

package flex.messaging.services;

import flex.management.BaseControl;
import flex.management.runtime.messaging.services.RemotingServiceControl;
import flex.messaging.MessageBroker;
import flex.messaging.MessageException;
import flex.messaging.config.DestinationSettings;
import flex.messaging.config.ServiceSettings;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.Message;
import flex.messaging.messages.RemotingMessage;
import flex.messaging.services.remoting.RemotingDestination;
import flex.messaging.util.MethodMatcher;
import java.util.Map;

// Referenced classes of package flex.messaging.services:
//            AbstractService, ServiceException, ServiceAdapter

public class RemotingService extends AbstractService
{

    public RemotingService(MessageBroker broker, ServiceSettings settings)
    {
        this(broker, settings, broker.isManaged());
    }

    public RemotingService(MessageBroker broker, ServiceSettings settings, boolean enableManagement)
    {
        super(broker, settings, enableManagement);
    }

    public void createDestination(DestinationSettings destSettings)
    {
        RemotingDestination dest = new RemotingDestination(this, destSettings);
        destinations.put(dest.getId(), dest);
        dest.initDestination();
        if(isManaged() && dest.isManaged())
            controller.addDestination(dest.getControl().getObjectName());
        dest.setMethodMatcher(getMethodMatcher());
    }

    public Object serviceMessage(Message msg)
    {
        if(isManaged())
            controller.incrementServiceMessageCount();
        if(msg instanceof RemotingMessage)
        {
            RemotingMessage message = (RemotingMessage)msg;
            RemotingDestination destination = (RemotingDestination)getDestination(msg);
            if(destination != null)
            {
                ServiceAdapter adapter = destination.getAdapter();
                try
                {
                    Object result = adapter.invoke(message);
                    if(Log.isDebug())
                    {
                        Log.getLogger("Service.Remoting").debug("Adapter '{0}' called '{1}.{2}({3})'", new Object[] {
                            adapter.getId(), message.getSource(), message.getOperation(), message.getParameters()
                        });
                        Log.getLogger("Service.Remoting").debug("Result: '{0}'", new Object[] {
                            result
                        });
                    }
                    return result;
                }
                catch(MessageException ex)
                {
                    throw ex;
                }
                catch(Throwable t)
                {
                    throw new MessageException(t.getMessage(), t);
                }
            } else
            {
                ServiceException e = new ServiceException();
                e.setMessage(10650, new Object[] {
                    msg.getDestination()
                });
                throw e;
            }
        } else
        {
            ServiceException e = new ServiceException();
            e.setMessage(10651);
            throw e;
        }
    }

    public MethodMatcher getMethodMatcher()
    {
        if(methodMatcher == null)
            methodMatcher = new MethodMatcher();
        return methodMatcher;
    }

    protected void setupServiceControl(MessageBroker broker)
    {
        controller = new RemotingServiceControl(getId(), this, broker.getControl());
        controller.register();
        setControl(controller);
    }

    public static final String LOG_CATEGORY = "Service.Remoting";
    public static final int UNKNOWN_DESTINATION = 10650;
    public static final int UNKNOWN_MESSAGE_TYPE = 10651;
    private RemotingServiceControl controller;
    private MethodMatcher methodMatcher;
}
