// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HTTPProxyAdapter.java

package flex.messaging.services.http;

import flex.management.runtime.messaging.services.http.HTTPProxyAdapterControl;
import flex.messaging.*;
import flex.messaging.config.*;
import flex.messaging.messages.*;
import flex.messaging.services.Service;
import flex.messaging.services.ServiceAdapter;
import flex.messaging.services.http.proxy.AccessFilter;
import flex.messaging.services.http.proxy.ErrorFilter;
import flex.messaging.services.http.proxy.ProxyContext;
import flex.messaging.services.http.proxy.ProxyContextFilter;
import flex.messaging.services.http.proxy.ProxyFilter;
import flex.messaging.services.http.proxy.RequestFilter;
import flex.messaging.services.http.proxy.ResponseFilter;
import flex.messaging.services.http.proxy.SecurityFilter;
import flex.messaging.services.http.proxy.Target;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Iterator;
import java.util.List;
import org.apache.commons.httpclient.*;
import org.apache.commons.httpclient.params.HttpConnectionManagerParams;

// Referenced classes of package flex.messaging.services.http:
//            HTTPProxyDestination, ExternalProxySettings

public class HTTPProxyAdapter extends ServiceAdapter
{

    public HTTPProxyAdapter()
    {
        cookieLimit = 200;
        createFilterChain();
        connectionParams = new HttpConnectionManagerParams();
    }

    public void setService(Service service)
    {
        super.setService(service);
        PropertiesSettings properties = service.getSettings();
        properties(properties);
    }

    public void setSettings(Destination destination, AdapterSettings adapterSettings, DestinationSettings destinationSettings)
    {
        super.setSettings(destination, adapterSettings, destinationSettings);
        PropertiesSettings properties = adapterSettings;
        properties(properties);
        properties = destinationSettings;
        properties(properties);
    }

    public Object invoke(Message msg)
    {
        HTTPMessage message = (HTTPMessage)msg;
        ProxyContext context = new ProxyContext();
        if(message instanceof SOAPMessage)
            context.setSoapRequest(true);
        else
            context.setSoapRequest(false);
        setupContext(context, message);
        Object response;
        try
        {
            filterChain.invoke(context);
            response = context.getResponse();
            if(context.getRecordHeaders())
            {
                AcknowledgeMessage ack = new AcknowledgeMessage();
                ack.setBody(response);
                ack.setHeader("requestHeaders", context.getRequestHeaders());
                ack.setHeader("responseHeaders", context.getResponseHeaders());
                return ack;
            }
        }
        catch(MessageException ex)
        {
            throw ex;
        }
        catch(Throwable t)
        {
            t.printStackTrace();
            throw new MessageException(t.toString());
        }
        return response;
    }

    protected void setupContext(ProxyContext context, HTTPMessage message)
    {
        Target target = new Target();
        context.setTarget(target);
        context.setExternalProxySettings(externalProxy);
        context.setProxyCredentials(proxyCredentials);
        context.setConnectionManager(connectionManager);
        context.setAllowLaxSSL(allowLaxSSL);
        context.setContentChunked(contentChunked);
        context.setRecordHeaders(message.getRecordHeaders());
        context.setCookieLimit(cookieLimit);
        context.setHttpRequest(FlexContext.getHttpRequest() != null);
        String url = message.getUrl();
        context.setUrl(url);
        java.util.Map httpHeaders = message.getHttpHeaders();
        context.setHeaders(httpHeaders);
        String method = message.getMethod();
        context.setMethod(method);
        String contentType = message.getContentType();
        context.setContentType(contentType);
        Object body = message.getBody();
        context.setBody(body);
        target.setRemoteUsername(message.getRemoteUsername());
        target.setRemotePassword(message.getRemotePassword());
        target.setUseCustomAuthentication(((HTTPProxyDestination)destination).useCustomAuthentication());
    }

    public void allowLaxSSL(boolean allow)
    {
        allowLaxSSL = allow;
    }

    public void contentChunked(boolean value)
    {
        contentChunked = value;
    }

    public void initExternalProxy(ExternalProxySettings ep)
    {
        externalProxy = ep;
        if(externalProxy != null)
        {
            String proxyServer = externalProxy.getProxyServer();
            String proxyUsername = externalProxy.getUsername();
            if(proxyUsername != null)
            {
                String proxyPassword = externalProxy.getPassword();
                String proxyDomain = externalProxy.getNTDomain();
                if(proxyDomain != null)
                    proxyCredentials = new NTCredentials(proxyUsername, proxyPassword, proxyServer, proxyDomain);
                else
                    proxyCredentials = new UsernamePasswordCredentials(proxyUsername, proxyPassword);
            }
        }
    }

    public ProxyFilter createFilterChain()
    {
        if(filterChain == null)
        {
            ErrorFilter errorFilter = new ErrorFilter();
            AccessFilter accessFilter = new AccessFilter();
            ProxyContextFilter contextFilter = new ProxyContextFilter();
            ResponseFilter responseFilter = new ResponseFilter();
            SecurityFilter securityFilter = new SecurityFilter();
            RequestFilter requestFilter = new RequestFilter();
            errorFilter.setNext(accessFilter);
            accessFilter.setNext(contextFilter);
            contextFilter.setNext(responseFilter);
            responseFilter.setNext(securityFilter);
            securityFilter.setNext(requestFilter);
            filterChain = errorFilter;
        }
        return filterChain;
    }

    public void setupAdapterControl(Destination destination)
    {
        controller = new HTTPProxyAdapterControl(getId(), this, destination.getControl());
        controller.register();
        setControl(controller);
    }

    private void properties(PropertiesSettings propertiesSettings)
    {
        ConfigMap properties = propertiesSettings.getProperties();
        if(properties == null || properties.size() == 0)
            return;
        ConfigMap conn = properties.getPropertyAsMap("connection-manager", null);
        if(conn != null)
        {
            int defaultMaxConnsPerHost = 2;
            if(conn.getProperty("max-total-connections") != null)
            {
                int maxTotal = conn.getPropertyAsInt("max-total-connections", 20);
                connectionParams.setMaxTotalConnections(maxTotal);
            }
            if(conn.getProperty("default-max-connections-per-host") != null)
            {
                defaultMaxConnsPerHost = conn.getPropertyAsInt("default-max-connections-per-host", 2);
                connectionParams.setDefaultMaxConnectionsPerHost(defaultMaxConnsPerHost);
            }
            if(conn.getProperty("connection-timeout") != null)
            {
                int timeout = conn.getPropertyAsInt("connection-timeout", 0);
                if(timeout >= 0)
                    connectionParams.setConnectionTimeout(timeout);
            }
            if(conn.getProperty("socket-timeout") != null)
            {
                int timeout = conn.getPropertyAsInt("socket-timeout", 0);
                if(timeout >= 0)
                    connectionParams.setSoTimeout(timeout);
            }
            if(conn.getProperty("stale-checking-enabled") != null)
            {
                boolean staleCheck = conn.getPropertyAsBoolean("stale-checking-enabled", true);
                connectionParams.setStaleCheckingEnabled(staleCheck);
            }
            if(conn.getProperty("send-buffer-size") != null)
            {
                int bufferSize = conn.getPropertyAsInt("send-buffer-size", 0);
                if(bufferSize > 0)
                    connectionParams.setSendBufferSize(bufferSize);
            }
            if(conn.getProperty("receive-buffer-size") != null)
            {
                int bufferSize = conn.getPropertyAsInt("receive-buffer-size", 0);
                if(bufferSize > 0)
                    connectionParams.setReceiveBufferSize(bufferSize);
            }
            if(conn.getProperty("tcp-no-delay") != null)
            {
                boolean noNagel = conn.getPropertyAsBoolean("tcp-no-delay", false);
                connectionParams.setTcpNoDelay(noNagel);
            }
            if(conn.getProperty("linger") != null)
            {
                int linger = conn.getPropertyAsInt("linger", -1);
                connectionParams.setLinger(linger);
            }
            List hosts = conn.getPropertyAsList("max-per-host", null);
            if(hosts != null)
            {
                HostConfiguration hostConfig;
                int maxConn;
                for(Iterator it = hosts.iterator(); it.hasNext(); connectionParams.setMaxConnectionsPerHost(hostConfig, maxConn))
                {
                    ConfigMap maxPerHost = (ConfigMap)it.next();
                    hostConfig = new HostConfiguration();
                    maxConn = defaultMaxConnsPerHost;
                    if(maxPerHost.getProperty("max-connections") != null)
                        maxConn = maxPerHost.getPropertyAsInt("max-connections", 2);
                    if(maxPerHost.getProperty("host") != null)
                    {
                        String host = maxPerHost.getPropertyAsString("host", null);
                        hostConfig.setHost(host);
                    }
                    if(maxPerHost.getProperty("proxy") != null)
                    {
                        ConfigMap proxy = maxPerHost.getPropertyAsMap("proxy", null);
                        if(proxy != null)
                        {
                            String proxyHost = proxy.getPropertyAsString("host", null);
                            if(proxyHost != null)
                            {
                                int port = proxy.getPropertyAsInt("port", 0);
                                hostConfig.setProxy(proxyHost, port);
                            }
                        }
                    }
                    if(maxPerHost.getProperty("local-address") == null)
                        continue;
                    String localAddress = maxPerHost.getPropertyAsString("local-address", null);
                    try
                    {
                        InetAddress addr = InetAddress.getByName(localAddress);
                        hostConfig.setLocalAddress(addr);
                    }
                    catch(UnknownHostException ex) { }
                }

            }
            connectionManager = new MultiThreadedHttpConnectionManager();
            connectionManager.setParams(connectionParams);
        }
        if(propertiesSettings.getProperty("cookie-limit") != null)
            cookieLimit = properties.getPropertyAsInt("cookie-limit", 200);
        if(propertiesSettings.getProperty("allow-lax-ssl") != null)
        {
            boolean lax = properties.getPropertyAsBoolean("allow-lax-ssl", false);
            allowLaxSSL(lax);
        }
        if(propertiesSettings.getProperty("content-chunked") != null)
        {
            boolean ch = properties.getPropertyAsBoolean("content-chunked", false);
            contentChunked(ch);
        }
        ConfigMap extern = properties.getPropertyAsMap("external-proxy", null);
        if(extern != null)
        {
            ExternalProxySettings proxy = new ExternalProxySettings();
            String proxyServer = extern.getPropertyAsString("server", null);
            proxy.setProxyServer(proxyServer);
            int proxyPort = extern.getPropertyAsInt("port", 80);
            proxy.setProxyPort(proxyPort);
            String ntdomain = extern.getPropertyAsString("nt-domain", null);
            proxy.setNTDomain(ntdomain);
            String username = extern.getPropertyAsString("username", null);
            proxy.setUsername(username);
            String password = extern.getPropertyAsString("password", null);
            proxy.setPassword(password);
            initExternalProxy(proxy);
        }
    }

    public static final String CONTENT_TYPE_XML = "application/xml";
    public static final String CONTENT_TYPE_FORM = "application/x-www-form-urlencoded";
    public static final int DEFAULT_COOKIE_LIMIT = 200;
    private static final String CONNECTION_MANAGER = "connection-manager";
    private static final String MAX_TOTAL_CONNECTIONS = "max-total-connections";
    private static final String DEFAULT_MAX_CONNECTIONS_PER_HOST = "default-max-connections-per-host";
    private static final String CONNECTION_TIMEOUT = "connection-timeout";
    private static final String SOCKET_TIMEOUT = "socket-timeout";
    private static final String STALE_CHECKING_ENABLED = "stale-checking-enabled";
    private static final String SEND_BUFFER_SIZE = "send-buffer-size";
    private static final String RECEIVE_BUFFER_SIZE = "receive-buffer-size";
    private static final String TCP_NO_DELAY = "tcp-no-delay";
    private static final String LINGER = "linger";
    private static final String MAX_PER_HOST = "max-per-host";
    private static final String MAX_CONNECTIONS = "max-connections";
    private static final String HOST = "host";
    private static final String PROXY = "proxy";
    private static final String PORT = "port";
    private static final String LOCAL_ADDRESS = "local-address";
    private static final String COOKIE_LIMIT = "cookie-limit";
    private static final String ALLOW_LAX_SSL = "allow-lax-ssl";
    private static final String CONTENT_CHUNKED = "content-chunked";
    private static final String EXTERNAL_PROXY = "external-proxy";
    private static final String SERVER = "server";
    private static final String NT_DOMAIN = "nt-domain";
    private static final String USERNAME = "username";
    private static final String PASSWORD = "password";
    protected ProxyFilter filterChain;
    protected ExternalProxySettings externalProxy;
    protected int cookieLimit;
    protected boolean allowLaxSSL;
    protected boolean contentChunked;
    protected boolean dumpTraffic;
    protected HttpConnectionManager connectionManager;
    protected HttpConnectionManagerParams connectionParams;
    protected UsernamePasswordCredentials proxyCredentials;
    private HTTPProxyAdapterControl controller;
}
