// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HTTPProxyDestination.java

package flex.messaging.services.http;

import flex.management.runtime.messaging.services.http.HTTPProxyDestinationControl;
import flex.messaging.Destination;
import flex.messaging.config.ConfigMap;
import flex.messaging.config.DestinationSettings;
import flex.messaging.services.Service;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.*;

// Referenced classes of package flex.messaging.services.http:
//            SettingsReplaceUtil

public class HTTPProxyDestination extends Destination
{

    public HTTPProxyDestination(Service service, DestinationSettings settings)
    {
        this(service, settings, service.isManaged());
    }

    public HTTPProxyDestination(Service service, DestinationSettings settings, boolean enableManagement)
    {
        super(service, settings, enableManagement);
        dynamicUrls = new ArrayList();
        init(settings);
    }

    private void init(DestinationSettings settings)
    {
        ConfigMap properties = settings.getProperties();
        defaultUrl = properties.getPropertyAsString("url", null);
        if(defaultUrl == null)
            defaultUrl = properties.getPropertyAsString("wsdl", null);
        else
            properties.allowProperty("wsdl");
        List dynUrls = properties.getPropertyAsList("dynamic-url", null);
        if(dynUrls != null)
            dynamicUrls.addAll(dynUrls);
        List soapUrls = properties.getPropertyAsList("soap", new ArrayList());
        if(soapUrls != null)
            dynamicUrls.addAll(soapUrls);
        remoteUsername = properties.getPropertyAsString("remote-username", null);
        remotePassword = properties.getPropertyAsString("remote-password", null);
        useCustomAuthentication = properties.getPropertyAsBoolean("use-custom-auth", true);
    }

    public String getRemotePassword()
    {
        return remotePassword;
    }

    public String getRemoteUsername()
    {
        return remoteUsername;
    }

    public boolean useCustomAuthentication()
    {
        return useCustomAuthentication;
    }

    public String getParsedDefaultUrl(String contextPath, String serverName, String serverPort, String serverProtocol)
    {
        if(defaultUrl != null)
            parsedDefaultUrl = SettingsReplaceUtil.replaceAllTokensGivenServerName(defaultUrl, contextPath, serverName, serverPort, serverProtocol);
        return parsedDefaultUrl;
    }

    public List getDynamicUrls()
    {
        return dynamicUrls;
    }

    public List getParsedDynamicUrls(String contextPath)
    {
        if(!dynamicParsed || parsedDynamicUrls == null)
            parseDynamicUrls(this, contextPath);
        return parsedDynamicUrls;
    }

    public void addDynamicUrl(String u)
    {
        if(u != null)
        {
            dynamicUrls.add(u);
            dynamicParsed = false;
        }
    }

    private static void parseDynamicUrls(HTTPProxyDestination dest, String contextPath)
    {
        List dynamicUrls = dest.getDynamicUrls();
        dest.parsedDynamicUrls = new ArrayList();
        dest.allowsDynamicAuthentication = true;
        String lastDomainAndPort = null;
        boolean computeAuth = true;
        Set parsedUrls = SettingsReplaceUtil.replaceAllTokensCalculateServerName(dynamicUrls, contextPath);
        Iterator iter = parsedUrls.iterator();
        do
        {
            if(!iter.hasNext())
                break;
            String url = (String)iter.next();
            dest.parsedDynamicUrls.add(url.toCharArray());
            if(computeAuth)
            {
                boolean fail = false;
                try
                {
                    URL urlObj = new URL(url);
                    String host = urlObj.getHost();
                    if(host.indexOf("*") > -1)
                    {
                        fail = true;
                    } else
                    {
                        String domainAndPort = host + ":" + urlObj.getPort();
                        if(lastDomainAndPort != null && !lastDomainAndPort.equalsIgnoreCase(domainAndPort))
                            fail = true;
                        lastDomainAndPort = domainAndPort;
                    }
                }
                catch(MalformedURLException e)
                {
                    fail = true;
                }
                if(fail)
                {
                    computeAuth = false;
                    dest.allowsDynamicAuthentication = false;
                }
            }
        } while(true);
        dest.dynamicParsed = true;
    }

    public boolean allowsDynamicAuthentication()
    {
        if(!dynamicParsed)
            throw new RuntimeException("Cannot compute authentication if dynamic urls aren't parsed");
        else
            return allowsDynamicAuthentication;
    }

    protected void setupDestinationControl(Service service)
    {
        controller = new HTTPProxyDestinationControl(getId(), this, service.getControl());
        controller.register();
        setControl(controller);
    }

    private static final String URL = "url";
    private static final String WSDL = "wsdl";
    private static final String DYNAMIC_URL = "dynamic-url";
    private static final String SOAP = "soap";
    private static final String REMOTE_USERNAME = "remote-username";
    private static final String REMOTE_PASSWORD = "remote-password";
    private static final String USE_CUSTOM_AUTH = "use-custom-auth";
    protected boolean dynamicParsed;
    protected final List dynamicUrls;
    protected List parsedDynamicUrls;
    protected String parsedDefaultUrl;
    protected String defaultUrl;
    protected String remoteUsername;
    protected String remotePassword;
    protected boolean useCustomAuthentication;
    protected boolean allowsDynamicAuthentication;
    private HTTPProxyDestinationControl controller;
}
