// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   EasyX509TrustManager.java

package flex.messaging.services.http.httpclient;

import com.sun.net.ssl.TrustManagerFactory;
import com.sun.net.ssl.X509TrustManager;
import flex.messaging.util.Trace;
import java.security.*;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

public class EasyX509TrustManager
    implements X509TrustManager
{

    public EasyX509TrustManager(KeyStore keystore)
        throws NoSuchAlgorithmException, KeyStoreException
    {
        standardTrustManager = null;
        TrustManagerFactory factory = TrustManagerFactory.getInstance("SunX509");
        factory.init(keystore);
        com.sun.net.ssl.TrustManager trustmanagers[] = factory.getTrustManagers();
        if(trustmanagers.length == 0)
        {
            throw new NoSuchAlgorithmException("SunX509 trust manager not supported");
        } else
        {
            standardTrustManager = (X509TrustManager)trustmanagers[0];
            trustStore = System.getProperty("flex.trustStore") != null;
            return;
        }
    }

    public boolean isClientTrusted(X509Certificate certificates[])
    {
        if(trustStore)
            return true;
        else
            return standardTrustManager.isClientTrusted(certificates);
    }

    public boolean isServerTrusted(X509Certificate certificates[])
    {
        if(trustStore)
            return true;
        if(certificates != null && Trace.ssl)
        {
            Trace.trace("Server certificate chain:");
            for(int i = 0; i < certificates.length; i++)
                Trace.trace("X509Certificate[" + i + "]=" + certificates[i]);

        }
        if(certificates != null && certificates.length == 1)
        {
            X509Certificate certificate = certificates[0];
            try
            {
                certificate.checkValidity();
            }
            catch(CertificateException e)
            {
                if(Trace.ssl)
                    Trace.trace(e.toString());
                return false;
            }
            return true;
        } else
        {
            return standardTrustManager.isServerTrusted(certificates);
        }
    }

    public X509Certificate[] getAcceptedIssuers()
    {
        return standardTrustManager.getAcceptedIssuers();
    }

    private X509TrustManager standardTrustManager;
    private boolean trustStore;
}
