// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ProxyContextFilter.java

package flex.messaging.services.http.proxy;

import flex.messaging.FlexContext;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.services.http.httpclient.EasySSLProtocolSocketFactory;
import java.net.MalformedURLException;
import java.net.URL;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.httpclient.HostConfiguration;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.protocol.Protocol;

// Referenced classes of package flex.messaging.services.http.proxy:
//            ProxyFilter, ProxyException, ProxyContext, Target

public class ProxyContextFilter extends ProxyFilter
{

    public ProxyContextFilter()
    {
        myhttps = new Protocol("https", new EasySSLProtocolSocketFactory(), 443);
    }

    public void invoke(ProxyContext context)
    {
        setupInitialProperties(context);
        setupTarget(context);
        logInfo(context);
        if(next != null)
            next.invoke(context);
    }

    protected void setupInitialProperties(ProxyContext context)
    {
        HttpServletRequest clientRequest = FlexContext.getHttpRequest();
        if(clientRequest != null)
        {
            String reqURL = clientRequest.getRequestURL().toString();
            int idx = reqURL.indexOf(':');
            String reqProto = reqURL.substring(0, idx);
            context.setClientHttps(reqProto.equalsIgnoreCase("https"));
            String userAgent = clientRequest.getHeader("User-Agent");
            context.setDisableCaching(context.isClientHttps() && userAgent != null && userAgent.indexOf("MSIE") != -1);
        }
    }

    protected void setupTarget(ProxyContext context)
    {
        Target target = context.getTarget();
        context.setTarget(target);
        String source = context.getUrl();
        HttpServletRequest clientRequest = FlexContext.getHttpRequest();
        try
        {
            target.setUrl(new URL(source));
        }
        catch(MalformedURLException e)
        {
            try
            {
                if(clientRequest != null)
                {
                    String baseurl = "http" + (clientRequest.isSecure() ? "s" : "") + "://" + clientRequest.getServerName() + ":" + clientRequest.getServerPort();
                    target.setUrl(new URL(baseurl + source));
                } else
                {
                    ProxyException pe = new ProxyException();
                    pe.setMessage(10704, new Object[] {
                        source
                    });
                    throw pe;
                }
            }
            catch(MalformedURLException ex)
            {
                target.setUrl(null);
            }
        }
        if(target.getUrl() == null)
        {
            ProxyException pe = new ProxyException();
            pe.setMessage(10705, new Object[] {
                source
            });
            throw pe;
        }
        target.setHTTPS(target.getUrl().getProtocol().equalsIgnoreCase("https"));
        target.setEncodedPath(target.getUrl().getPath());
        String queryStr = target.getUrl().getQuery();
        if(queryStr != null)
            target.setEncodedPath(target.getEncodedPath() + "?" + queryStr);
        target.setHostConfig(new HostConfiguration());
        String targetHost = target.getUrl().getHost();
        int targetPort = target.getUrl().getPort();
        String targetProtocol = target.getUrl().getProtocol();
        if(target.isHTTPS() && context.allowLaxSSL())
            target.getHostConfig().setHost(targetHost, targetPort, myhttps);
        else
            target.getHostConfig().setHost(targetHost, targetPort, targetProtocol);
        if(context.getConnectionManager() != null)
            context.setHttpClient(new HttpClient(context.getConnectionManager()));
        else
            context.setHttpClient(new HttpClient());
        boolean localDomain = false;
        boolean localPort = false;
        if(clientRequest != null)
        {
            String proxyDomain = clientRequest.getServerName();
            if(proxyDomain.equalsIgnoreCase(targetHost))
            {
                localDomain = true;
                int proxyPort = clientRequest.getServerPort();
                localPort = proxyPort == targetPort;
            }
        }
        context.setLocalDomain(localDomain);
        context.setLocalPort(localPort);
    }

    protected void logInfo(ProxyContext context)
    {
        if(Log.isInfo())
        {
            Target target = context.getTarget();
            String prefix = "-- " + context.getMethod() + " : ";
            int targetPort = target.getUrl().getPort();
            String targetURL = target.getUrl().getProtocol() + "://" + target.getUrl().getHost() + (targetPort != -1 ? ":" + targetPort : "") + target.getEncodedPath();
            Log.getLogger("Service.HTTP").info(prefix + targetURL);
        }
    }

    private static final int RELATIVE_NOT_SUPPORTED = 10704;
    private static final int INVALID_TARGET = 10705;
    private Protocol myhttps;
}
