// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   RequestFilter.java

package flex.messaging.services.http.proxy;

import flex.messaging.FlexContext;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.services.http.ExternalProxySettings;
import flex.messaging.services.http.httpclient.FlexGetMethod;
import flex.messaging.services.http.httpclient.FlexPostMethod;
import flex.messaging.util.StringUtils;
import flex.messaging.util.URLEncoder;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.httpclient.Cookie;
import org.apache.commons.httpclient.Header;
import org.apache.commons.httpclient.HostConfiguration;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpMethodBase;
import org.apache.commons.httpclient.HttpState;
import org.apache.commons.httpclient.methods.ByteArrayRequestEntity;
import org.apache.commons.httpclient.methods.DeleteMethod;
import org.apache.commons.httpclient.methods.EntityEnclosingMethod;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.HeadMethod;
import org.apache.commons.httpclient.methods.InputStreamRequestEntity;
import org.apache.commons.httpclient.methods.OptionsMethod;
import org.apache.commons.httpclient.methods.PutMethod;
import org.apache.commons.httpclient.methods.StringRequestEntity;
import org.apache.commons.httpclient.methods.TraceMethod;

// Referenced classes of package flex.messaging.services.http.proxy:
//            ProxyFilter, ProxyException, CookieInfo, ProxyContext, 
//            Target, ProxyUtil, RequestUtil

public class RequestFilter extends ProxyFilter
{

    public RequestFilter()
    {
    }

    public void invoke(ProxyContext context)
    {
        setupRequest(context);
        copyCookiesToEndpoint(context);
        copyHeadersToEndpoint(context);
        addCustomHeaders(context);
        recordRequestHeaders(context);
        sendRequest(context);
        if(next != null)
            next.invoke(context);
    }

    protected void setupRequest(ProxyContext context)
    {
        ExternalProxySettings externalProxy = context.getExternalProxySettings();
        if(externalProxy != null)
        {
            String proxyServer = externalProxy.getProxyServer();
            if(proxyServer != null)
            {
                context.getTarget().getHostConfig().setProxy(proxyServer, externalProxy.getProxyPort());
                if(context.getProxyCredentials() != null)
                    context.getHttpClient().getState().setProxyCredentials(ProxyUtil.getDefaultAuthScope(), context.getProxyCredentials());
            }
        }
        String method = context.getMethod();
        String encodedPath = context.getTarget().getEncodedPath();
        if("POST".equals(method))
        {
            FlexPostMethod postMethod = new FlexPostMethod(encodedPath);
            context.setHttpMethod(postMethod);
            if(context.hasAuthorization())
                postMethod.setConnectionForced(true);
        } else
        if("GET".equals(method))
        {
            FlexGetMethod getMethod = new FlexGetMethod(context.getTarget().getEncodedPath());
            context.setHttpMethod(getMethod);
            if(context.hasAuthorization())
                getMethod.setConnectionForced(true);
        } else
        if("HEAD".equals(method))
        {
            HeadMethod headMethod = new HeadMethod(encodedPath);
            context.setHttpMethod(headMethod);
        } else
        if("PUT".equals(method))
        {
            PutMethod putMethod = new PutMethod(encodedPath);
            context.setHttpMethod(putMethod);
        } else
        if("OPTIONS".equals(method))
        {
            OptionsMethod optionsMethod = new OptionsMethod(encodedPath);
            context.setHttpMethod(optionsMethod);
        } else
        if("DELETE".equals(method))
        {
            DeleteMethod deleteMethod = new DeleteMethod(encodedPath);
            context.setHttpMethod(deleteMethod);
        } else
        if("TRACE".equals(method))
        {
            TraceMethod traceMethod = new TraceMethod(encodedPath);
            context.setHttpMethod(traceMethod);
        } else
        {
            ProxyException pe = new ProxyException(10719);
            pe.setDetails(10719, "1", new Object[] {
                method
            });
            throw pe;
        }
        HttpMethodBase httpMethod = context.getHttpMethod();
        if(httpMethod instanceof EntityEnclosingMethod)
            ((EntityEnclosingMethod)httpMethod).setContentChunked(context.getContentChunked());
    }

    public static void copyCookiesToEndpoint(ProxyContext context)
    {
        HttpServletRequest clientRequest = FlexContext.getHttpRequest();
        if(clientRequest != null)
        {
            javax.servlet.http.Cookie cookies[] = clientRequest.getCookies();
            HttpState initState = context.getHttpClient().getState();
            if(cookies != null)
            {
                TreeMap cookieMap = new TreeMap();
                for(int i = 0; i < cookies.length; i++)
                {
                    javax.servlet.http.Cookie cookie = cookies[i];
                    CookieInfo origCookie = new CookieInfo(cookie.getName(), cookie.getDomain(), cookie.getName(), cookie.getValue(), cookie.getPath(), cookie.getMaxAge(), null, cookie.getSecure());
                    CookieInfo newCookie = RequestUtil.createCookie(origCookie, context, context.getTarget().getUrl().getHost(), context.getTarget().getUrl().getPath());
                    if(newCookie == null)
                        continue;
                    Integer pathInt = new Integer(0 - newCookie.path.length());
                    ArrayList list = (ArrayList)cookieMap.get(pathInt);
                    if(list == null)
                    {
                        list = new ArrayList();
                        cookieMap.put(pathInt, list);
                    }
                    list.add(newCookie);
                }

                for(Iterator iterator = cookieMap.values().iterator(); iterator.hasNext();)
                {
                    ArrayList list = (ArrayList)iterator.next();
                    Iterator iterator2 = list.iterator();
                    while(iterator2.hasNext()) 
                    {
                        CookieInfo cookieInfo = (CookieInfo)iterator2.next();
                        if(Log.isInfo())
                        {
                            String str = "-- Cookie in request: " + cookieInfo;
                            Log.getLogger("Service.HTTP").debug(str);
                        }
                        Cookie cookie = new Cookie(cookieInfo.domain, cookieInfo.name, cookieInfo.value, cookieInfo.path, cookieInfo.maxAge, cookieInfo.secure);
                        initState.addCookie(cookie);
                    }
                }

            }
        }
    }

    public static void copyHeadersToEndpoint(ProxyContext context)
    {
        HttpServletRequest clientRequest = FlexContext.getHttpRequest();
        if(clientRequest != null)
        {
            for(Enumeration headerNames = clientRequest.getHeaderNames(); headerNames.hasMoreElements();)
            {
                String headerName = (String)headerNames.nextElement();
                if(!RequestUtil.ignoreHeader(headerName, context))
                {
                    Enumeration headers = clientRequest.getHeaders(headerName);
                    while(headers.hasMoreElements()) 
                    {
                        String value = (String)headers.nextElement();
                        context.getHttpMethod().addRequestHeader(headerName, value);
                        if(Log.isInfo())
                            Log.getLogger("Service.HTTP").debug("-- Header in request: " + headerName + " : " + value);
                    }
                }
            }

        }
    }

    protected void addCustomHeaders(ProxyContext context)
    {
        HttpMethodBase httpMethod = context.getHttpMethod();
        String contentType = context.getContentType();
        if(contentType != null)
            httpMethod.setRequestHeader("Content-Type", contentType);
        Map customHeaders = context.getHeaders();
        if(customHeaders != null)
        {
            String name;
            String value;
            for(Iterator it = customHeaders.keySet().iterator(); it.hasNext(); httpMethod.setRequestHeader(name, value))
            {
                name = (String)it.next();
                value = (String)customHeaders.get(name);
                if(value == null)
                    value = "";
            }

        }
        if(context.isSoapRequest())
        {
            context.getHttpMethod().setRequestHeader("Content-Type", "text/xml; charset=utf-8");
            String soapAction = null;
            Header header = context.getHttpMethod().getRequestHeader("SOAPAction");
            if(header != null)
                soapAction = header.getValue();
            if(soapAction == null)
            {
                HttpServletRequest clientRequest = FlexContext.getHttpRequest();
                if(clientRequest != null)
                    soapAction = clientRequest.getHeader("SOAPAction");
                if(soapAction != null && !soapAction.startsWith("\"") && !soapAction.endsWith("\""))
                    soapAction = "\"" + soapAction + "\"";
                context.getHttpMethod().setRequestHeader("SOAPAction", soapAction);
            }
        }
    }

    protected void recordRequestHeaders(ProxyContext context)
    {
        if(context.getRecordHeaders())
        {
            Header headers[] = context.getHttpMethod().getRequestHeaders();
            if(headers != null)
            {
                HashMap recordedHeaders = new HashMap();
                for(int i = 0; i < headers.length; i++)
                {
                    Header h = headers[i];
                    recordedHeaders.put(h.getName(), h.getValue());
                }

                context.setRequestHeaders(recordedHeaders);
            }
        }
    }

    protected void sendRequest(ProxyContext context)
    {
        Target target = context.getTarget();
        String method = context.getMethod();
        org.apache.commons.httpclient.HttpMethod httpMethod = context.getHttpMethod();
        if(httpMethod instanceof EntityEnclosingMethod)
        {
            Object data = processBody(context);
            Class dataClass = data.getClass();
            if(data instanceof String)
            {
                String requestString = (String)data;
                if(Log.isInfo())
                {
                    Logger logger = Log.getLogger("Service.HTTP");
                    logger.debug("-- Begin " + method + " request --");
                    logger.debug(StringUtils.prettifyString(requestString));
                    logger.debug("-- End " + method + " request --");
                }
                try
                {
                    StringRequestEntity requestEntity = new StringRequestEntity(requestString, null, "UTF-8");
                    ((EntityEnclosingMethod)httpMethod).setRequestEntity(requestEntity);
                }
                catch(UnsupportedEncodingException ex)
                {
                    ProxyException pe = new ProxyException(10706);
                    pe.setDetails(10706, "1", new Object[] {
                        ex
                    });
                    throw pe;
                }
            } else
            if(dataClass.isArray() && Byte.TYPE.equals(dataClass.getComponentType()))
            {
                byte dataBytes[] = (byte[])(byte[])data;
                ByteArrayRequestEntity requestEntity = new ByteArrayRequestEntity(dataBytes, context.getContentType());
                ((EntityEnclosingMethod)httpMethod).setRequestEntity(requestEntity);
            } else
            if(data instanceof InputStream)
            {
                InputStreamRequestEntity requestEntity = new InputStreamRequestEntity((InputStream)data, context.getContentType());
                ((EntityEnclosingMethod)httpMethod).setRequestEntity(requestEntity);
            }
        } else
        if(httpMethod instanceof GetMethod)
        {
            Object req = processBody(context);
            if(req instanceof String)
            {
                String requestString = (String)req;
                if(Log.isInfo())
                {
                    Logger logger = Log.getLogger("Service.HTTP");
                    logger.debug("-- Begin " + method + " request --");
                    logger.debug(StringUtils.prettifyString(requestString));
                    logger.debug("-- End " + method + " request --");
                }
                if(!"".equals(requestString))
                {
                    String query = context.getHttpMethod().getQueryString();
                    if(query != null)
                        query = query + "&" + requestString;
                    else
                        query = requestString;
                    context.getHttpMethod().setQueryString(query);
                }
            }
        }
        context.getHttpClient().setHostConfiguration(target.getHostConfig());
        try
        {
            context.getHttpClient().executeMethod(context.getHttpMethod());
        }
        catch(UnknownHostException uhex)
        {
            ProxyException pe = new ProxyException();
            pe.setMessage(10707, new Object[] {
                uhex.getMessage()
            });
            pe.setCode("Server.Proxy.Request.Failed");
            throw pe;
        }
        catch(Exception ex)
        {
            ProxyException pe = new ProxyException(10706);
            pe.setDetails(10706, "1", new Object[] {
                ex.getMessage()
            });
            pe.setCode("Server.Proxy.Request.Failed");
            throw pe;
        }
    }

    protected Object processBody(ProxyContext context)
    {
        Object body = context.getBody();
        if(body == null)
            return "";
        if(body instanceof String)
            return (String)body;
        if(body instanceof Map)
        {
            Map params = (Map)body;
            StringBuffer postData = new StringBuffer();
            boolean formValues = false;
label0:
            do
            {
                String name;
                Object vals;
label1:
                do
                {
                    String val;
                    for(Iterator iter = params.keySet().iterator(); iter.hasNext(); encodeParam(postData, name, val))
                    {
                        name = (String)iter.next();
                        if(!formValues)
                            formValues = true;
                        else
                            postData.append("&");
                        vals = params.get(name);
                        if(vals == null)
                            encodeParam(postData, name, "");
                        if(!(vals instanceof String))
                            continue label1;
                        val = (String)vals;
                    }

                    break label0;
                } while(!(vals instanceof List));
                List valLists = (List)vals;
                int i = 0;
                while(i < valLists.size()) 
                {
                    Object o = valLists.get(i);
                    String val = "";
                    if(o != null)
                        val = o.toString();
                    encodeParam(postData, name, val);
                    i++;
                }
            } while(true);
            return postData.toString();
        }
        if(body.getClass().isArray())
            return body;
        if(body instanceof InputStream)
            return body;
        else
            return body.toString();
    }

    protected void encodeParam(StringBuffer buf, String name, String val)
    {
        name = URLEncoder.encode(name);
        val = URLEncoder.encode(val);
        buf.append(name);
        buf.append("=");
        buf.append(val);
    }

    private static final int CAUGHT_ERROR = 10706;
    private static final int UNKNOWN_HOST = 10707;
    private static final int INVALID_METHOD = 10719;
}
