// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ResponseFilter.java

package flex.messaging.services.http.proxy;

import flex.messaging.FlexContext;
import flex.messaging.io.ArrayList;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.httpclient.Header;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpMethodBase;
import org.apache.commons.httpclient.HttpState;
import org.apache.commons.httpclient.StatusLine;
import org.apache.commons.httpclient.methods.OptionsMethod;

// Referenced classes of package flex.messaging.services.http.proxy:
//            ProxyFilter, ProxyException, ProxyContext, ResponseUtil

public class ResponseFilter extends ProxyFilter
{

    public ResponseFilter()
    {
    }

    public void invoke(ProxyContext context)
    {
        if(next != null)
            next.invoke(context);
        checkStatusCode(context);
        copyCookiesFromEndpoint(context);
        copyHeadersFromEndpoint(context);
        recordResponseHeaders(context);
        setupResponse(context);
    }

    protected void checkStatusCode(ProxyContext context)
    {
        int statusCode = context.getStatusCode();
        if(statusCode >= 400 && (statusCode != 401) & (statusCode != 403) && !context.isSoapRequest())
        {
            StatusLine statusLine = context.getHttpMethod().getStatusLine();
            String reason = null;
            if(statusLine != null)
                reason = statusLine.toString();
            if(reason == null || "".equals(reason))
                reason = "" + statusCode;
            ProxyException pe = new ProxyException();
            pe.setMessage(10708, new Object[] {
                reason
            });
            pe.setCode("Server.Proxy.Request.Failed");
            pe.setDetails(10708, "1", new Object[] {
                reason
            });
            throw pe;
        } else
        {
            return;
        }
    }

    protected void copyCookiesFromEndpoint(ProxyContext context)
    {
        HttpServletResponse clientResponse = FlexContext.getHttpResponse();
        if(clientResponse != null)
        {
            org.apache.commons.httpclient.Cookie cookies[] = context.getHttpClient().getState().getCookies();
            for(int i = 0; i < cookies.length; i++)
            {
                String domain = cookies[i].getDomain();
                String path = cookies[i].getPath();
                String name = cookies[i].getName();
                String value = cookies[i].getValue();
                String clientName = ResponseUtil.getCookieName(context, path, name, domain);
                if(Log.isInfo())
                {
                    String str = "-- Cookie in response: domain = '" + domain + "', path = '" + path + "', client name = '" + clientName + "', endpoint name = '" + name + "', value = '" + value;
                    Log.getLogger("Service.HTTP").debug(str);
                }
                Cookie cookie = new Cookie(clientName, value);
                Date expiry = cookies[i].getExpiryDate();
                if(expiry != null)
                {
                    int maxAge = (int)((expiry.getTime() - System.currentTimeMillis()) / 1000L);
                    cookie.setMaxAge(maxAge);
                }
                cookie.setSecure(cookies[i].getSecure());
                cookie.setPath("/");
                clientResponse.addCookie(cookie);
            }

        }
    }

    protected void copyHeadersFromEndpoint(ProxyContext context)
    {
        HttpServletResponse clientResponse = FlexContext.getHttpResponse();
        if(clientResponse != null)
        {
            Header headers[] = context.getHttpMethod().getResponseHeaders();
            for(int i = 0; i < headers.length; i++)
            {
                Header header = headers[i];
                String name = header.getName();
                String value = header.getValue();
                if(ResponseUtil.ignoreHeader(name, context) || name == null || value == null)
                    continue;
                clientResponse.addHeader(name, value);
                if(Log.isInfo())
                    Log.getLogger("Service.HTTP").debug("-- Header in response: " + name + " : " + value);
            }

            clientResponse.setHeader("Pragma", "public");
        }
    }

    protected void recordResponseHeaders(ProxyContext context)
    {
        String method = context.getMethod();
        if(context.getRecordHeaders() || "HEAD".equals(method))
        {
            Header headers[] = context.getHttpMethod().getResponseHeaders();
            HashMap responseHeaders = new HashMap();
            for(int i = 0; i < headers.length; i++)
            {
                Header header = headers[i];
                responseHeaders.put(header.getName(), header.getValue());
            }

            context.setResponseHeaders(responseHeaders);
        }
    }

    protected void setupResponse(ProxyContext context)
    {
        String method = context.getMethod();
        HttpMethodBase httpMethod = context.getHttpMethod();
        if("POST".equals(method))
            writeResponse(context);
        else
        if("GET".equals(method))
            writeResponse(context);
        else
        if("OPTIONS".equals(method))
        {
            OptionsMethod optionsMethod = (OptionsMethod)httpMethod;
            Enumeration options = optionsMethod.getAllowedMethods();
            if(options != null)
            {
                List ops = new ArrayList();
                Object option;
                for(; options.hasMoreElements(); ops.add(option))
                    option = options.nextElement();

                Object o[] = ops.toArray();
                context.setResponse(((Object) (o)));
            }
        } else
        if("TRACE".equals(method))
            writeResponse(context);
        else
        if(!"DELETE".equals(method))
            if("HEAD".equals(method))
                context.setResponse(context.getResponseHeaders());
            else
            if(!"PUT".equals(method));
    }

    protected void writeResponse(ProxyContext context)
    {
        try
        {
            InputStream in = context.getHttpMethod().getResponseBodyAsStream();
            if(in == null)
                throw new ProxyException(10709);
            int length = (int)context.getHttpMethod().getResponseContentLength();
            if(context.streamResponseToClient())
            {
                HttpServletResponse clientResponse = FlexContext.getHttpResponse();
                if(clientResponse != null)
                {
                    OutputStream out = clientResponse.getOutputStream();
                    if(length != -1)
                        clientResponse.setContentLength(length);
                    writeStreamedResponse(in, out, context);
                } else
                {
                    throw new ProxyException(10710);
                }
            } else
            {
                writeResponseAsString(in, length, context);
            }
        }
        catch(IOException ioe)
        {
            ProxyException pe = new ProxyException();
            pe.setMessage(10711, new Object[] {
                ioe.getMessage()
            });
            throw pe;
        }
    }

    protected void writeStreamedResponse(InputStream inStream, OutputStream out, ProxyContext context)
        throws IOException
    {
        byte tmp[] = new byte[RESPONSE_CHUNK];
        for(int i = 0; (i = inStream.read(tmp)) >= 0;)
            out.write(tmp, 0, i);

    }

    protected void writeResponseAsString(InputStream inStream, int length, ProxyContext context)
        throws IOException
    {
        byte tmp[] = new byte[RESPONSE_CHUNK];
        int i = 0;
        StringBuffer sb = new StringBuffer(length >= 0 ? length : 16);
        String charset = context.getHttpMethod().getResponseCharSet();
        byte bom[] = new byte[3];
        int read = inStream.read(bom, 0, 3);
        if(read > 0 && (bom[0] != 239 || bom[1] != 187 || bom[2] != 191) && ((bom[0] & 0xff) != 239 || (bom[1] & 0xff) != 187 || (bom[2] & 0xff) != 191))
            sb.append(new String(bom, 0, 3, charset));
        while((i = inStream.read(tmp)) >= 0) 
            sb.append(new String(tmp, 0, i, context.getHttpMethod().getResponseCharSet()));
        context.setResponse(sb.toString());
    }

    public static int RESPONSE_CHUNK = 4096;
    private static final int STATUS_ERROR = 10708;
    private static final int NULL_RESPONSE_STREAM = 10709;
    private static final int CANNOT_STREAM_NOT_HTTP = 10710;
    private static final int ERROR_WRITING_RESPONSE = 10711;

}
