// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SecurityFilter.java

package flex.messaging.services.http.proxy;

import flex.messaging.FlexContext;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.util.Base64;
import java.net.URL;
import java.util.Enumeration;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.httpclient.*;

// Referenced classes of package flex.messaging.services.http.proxy:
//            ProxyFilter, ProxyException, ProxyContext, Target, 
//            ProxyConstants, ProxyUtil

public class SecurityFilter extends ProxyFilter
{

    public SecurityFilter()
    {
    }

    public void invoke(ProxyContext context)
    {
        checkURL(context);
        setCredentials(context);
        if(next != null)
            next.invoke(context);
        sendSecurityInfo(context);
    }

    private void checkURL(ProxyContext context)
    {
        Target target = context.getTarget();
        if(!context.getTarget().getUrl().getProtocol().equalsIgnoreCase("http") && !target.isHTTPS())
        {
            Log.getLogger("Service.HTTP").warn("PROXY SECURITY : Invalid URL - only HTTP or HTTPS URLs allowed");
            throw new ProxyException(10712);
        }
        if(target.isHTTPS() && !context.isClientHttps())
        {
            Log.getLogger("Service.HTTP").warn("PROXY SECURITY : Invalid URL - can't access HTTPS URLs when accessing proxy via HTTP.");
            throw new ProxyException(10713);
        } else
        {
            return;
        }
    }

    private void setCredentials(ProxyContext context)
    {
        String user = null;
        String password = null;
        user = context.getTarget().getRemoteUsername();
        password = context.getTarget().getRemotePassword();
        String fromRequest = null;
        HttpServletRequest clientRequest = FlexContext.getHttpRequest();
        if(clientRequest != null)
            fromRequest = clientRequest.getHeader(ProxyConstants.HEADER_CREDENTIALS);
        if(fromRequest == null)
            fromRequest = context.getCredentialsHeader();
        if(fromRequest != null)
        {
            flex.messaging.util.Base64.Decoder decoder = new flex.messaging.util.Base64.Decoder();
            decoder.decode(fromRequest);
            String decoded = new String(decoder.drain());
            int colonIdx = decoded.indexOf(":");
            if(colonIdx != -1)
                user = decoded.substring(0, colonIdx);
            password = decoded.substring(colonIdx + 1);
        }
        if(clientRequest != null)
        {
            Enumeration headers = clientRequest.getHeaders("Authorization");
            if(headers != null)
                do
                {
                    if(!headers.hasMoreElements())
                        break;
                    String value = (String)headers.nextElement();
                    if(value.startsWith("Basic"))
                        if(!context.isLocalDomainAndPort())
                        {
                            if(Log.isInfo())
                                Log.getLogger("Service.HTTP").debug("Not sending on Authentication header. Proxy domain:port of " + clientRequest.getServerName() + ":" + clientRequest.getServerPort() + " does not match target domain:port of " + context.getTarget().getUrl().getHost() + ":" + context.getTarget().getUrl().getPort());
                        } else
                        {
                            flex.messaging.util.Base64.Decoder decoder = new flex.messaging.util.Base64.Decoder();
                            String encoded = value.substring(6);
                            decoder.decode(encoded);
                            String decoded = new String(decoder.drain());
                            int colonIdx = decoded.indexOf(":");
                            user = decoded.substring(0, colonIdx);
                            password = decoded.substring(colonIdx + 1);
                        }
                } while(true);
        }
        if(user != null)
        {
            UsernamePasswordCredentials cred = new UsernamePasswordCredentials(user, password);
            context.getHttpClient().getState().setCredentials(ProxyUtil.getDefaultAuthScope(), cred);
            context.setAuthorization(true);
            if(Log.isInfo())
                Log.getLogger("Service.HTTP").info("-- Authentication header being sent for " + user);
        }
    }

    private void sendSecurityInfo(ProxyContext context)
    {
        Target target = context.getTarget();
        String targetHost = target.getUrl().getHost();
        int statusCode = 200;
        boolean customAuth = target.useCustomAuthentication();
        StatusLine statusLine = context.getHttpMethod().getStatusLine();
        if(statusLine != null)
            statusCode = statusLine.getStatusCode();
        context.setStatusCode(statusCode);
        if(statusCode == 401 || statusCode == 403)
            if(!customAuth)
            {
                if(!context.isHttpRequest())
                    throw new ProxyException(10714);
                if(context.isSoapRequest())
                    throw new ProxyException(10715);
                if(!context.isLocalDomainAndPort())
                {
                    HttpServletRequest clientRequest = FlexContext.getHttpRequest();
                    String errorMessage = "The Flex proxy and the specified endpoint do not have the same domain, and so basic authentication cannot be used.  Please specify use-custom-authentication or run-as for services not located on the same domain as the Flex proxy. . The proxy domain:port is " + clientRequest.getServerName() + ":" + clientRequest.getServerPort() + " and the target domain:port is " + targetHost + ":" + target.getUrl().getPort();
                    Log.getLogger("Service.HTTP").error(errorMessage);
                    throw new ProxyException(10716);
                }
                HttpServletResponse clientResponse = FlexContext.getHttpResponse();
                clientResponse.setStatus(statusCode);
            } else
            {
                String message = null;
                if(statusLine != null)
                    message = statusLine.toString();
                ProxyException se;
                if(statusCode == 401)
                {
                    se = new ProxyException();
                    se.setCode("Client.Authentication");
                    if(message == null)
                        se.setMessage(10717);
                    else
                        se.setMessage(10708, new Object[] {
                            message
                        });
                    Header header = context.getHttpMethod().getResponseHeader(ProxyConstants.HEADER_AUTHENTICATE);
                    if(header != null)
                        se.setDetails(header.getValue());
                    throw se;
                }
                se = new ProxyException();
                se.setCode("Client.Authentication");
                if(message == null)
                    se.setMessage(10718);
                else
                    se.setMessage(10708, new Object[] {
                        message
                    });
                throw se;
            }
    }

    private static final int EMPTY_ERROR = 10708;
    private static final int ONLY_HTTP_HTTPS = 10712;
    private static final int NO_HTTPS_VIA_HTTP = 10713;
    private static final int NO_BASIC_NOT_HTTP = 10714;
    private static final int NO_BASIC_FOR_SOAP = 10715;
    private static final int DOMAIN_ERROR = 10716;
    private static final int LOGIN_REQUIRED = 10717;
    private static final int UNAUTHORIZED_ERROR = 10718;
}
