// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SubscriptionManager.java

package flex.messaging.services.messaging;

import edu.emory.mathcs.backport.java.util.concurrent.ConcurrentHashMap;
import flex.management.ManageableComponent;
import flex.messaging.*;
import flex.messaging.config.NetworkSettings;
import flex.messaging.util.*;
import java.util.*;

// Referenced classes of package flex.messaging.services.messaging:
//            Subtopic, ThrottleManager

public class SubscriptionManager extends ManageableComponent
{
    class SubscriberDestroyObject extends TimeoutAbstractObject
    {

        public long getLastUse()
        {
            return 0L;
        }

        public void timeout()
        {
            client.destroy();
        }

        MessageClient client;

        SubscriberDestroyObject(MessageClient client, long timeoutPeriod)
        {
            super();
            this.client = client;
            this.client.setDestroyTimer(this);
            setTimeoutPeriod(timeoutPeriod);
        }
    }

    class SubscriberTimeoutObject extends TimeoutAbstractObject
    {

        public long getLastUse()
        {
            return client.getLastUse();
        }

        public void timeout()
        {
            client.invalidate();
        }

        public boolean equals(Object o)
        {
            return (o instanceof SubscriberTimeoutObject) && ((SubscriberTimeoutObject)o).client.getClientId().equals(client.getClientId());
        }

        MessageClient client;

        SubscriberTimeoutObject(MessageClient client, long timeoutPeriod)
        {
            super();
            this.client = client;
            setTimeoutPeriod(timeoutPeriod);
        }
    }


    public SubscriptionManager(MessageDestination destination)
    {
        this(destination, false);
    }

    public SubscriptionManager(MessageDestination destination, boolean enableManagement)
    {
        super(enableManagement);
        this.destination = destination;
        long sessionConfigValue = destination.getNetworkSettings().getSessionTimeout();
        sessionDuration = sessionConfigValue * 1000L * 60L;
        if(sessionDuration > 0L)
            subscriberSessionManager = new TimeoutManager();
        subscribers = new ConcurrentHashMap();
        subscriberSessions = new ConcurrentHashMap();
        subscriberSubtopic = new ConcurrentHashMap();
        subtopicSubscribers = new ConcurrentHashMap();
    }

    public Set getSubscriberIds()
    {
        return subscribers.keySet();
    }

    public Set getSubscriberIds(Subtopic subtopic)
    {
        LinkedHashSet allSubscriberIds = new LinkedHashSet();
        Set subtopics = subtopicSubscribers.keySet();
        Set subscriberIds = null;
        Iterator iter = subtopics.iterator();
        do
        {
            if(!iter.hasNext())
                break;
            Subtopic st = (Subtopic)iter.next();
            if(st.matches(subtopic))
            {
                subscriberIds = ((Map)subtopicSubscribers.get(st)).keySet();
                allSubscriberIds.addAll(subscriberIds);
            }
        } while(true);
        return allSubscriberIds;
    }

    public MessageClient getSubscriber(Object clientId)
    {
        MessageClient client = (MessageClient)subscribers.get(clientId);
        if(client != null && !client.isTimingOut())
            monitorTimeout(client);
        return client;
    }

    public MessageClient getSubscriber(Object clientId, Subtopic subtopic)
    {
        MessageClient client = null;
        Subtopic subscribedSubtopic = (Subtopic)subscriberSubtopic.get(clientId);
        if(subscribedSubtopic != null && subscribedSubtopic.matches(subtopic))
        {
            Map subscribers = (Map)subtopicSubscribers.get(subscribedSubtopic);
            if(subscribers != null && subscribers.containsKey(clientId))
            {
                client = (MessageClient)subscribers.get(clientId);
                if(client != null && !client.isTimingOut())
                    monitorTimeout(client);
            }
        }
        return client;
    }

    public void addSubscriber(MessageClient client)
    {
        Object clientId = client.getClientId();
        if(subscribers.containsKey(clientId))
        {
            throw new MessageException("Already subscribed to " + destination.getId());
        } else
        {
            subscribers.put(clientId, client);
            monitorTimeout(client);
            return;
        }
    }

    public void addSubscriber(MessageClient client, Subtopic subtopic)
    {
        Object clientId = client.getClientId();
        Map subscribers = (Map)subtopicSubscribers.get(subtopic);
        if(subscribers == null)
            synchronized(this)
            {
                subscribers = (Map)subtopicSubscribers.get(subtopic);
                if(subscribers == null)
                {
                    subscribers = new ConcurrentHashMap();
                    subtopicSubscribers.put(subtopic, subscribers);
                }
            }
        if(subscribers.containsKey(clientId))
        {
            throw new MessageException("Already subscribed to " + destination.getId());
        } else
        {
            subscribers.put(clientId, client);
            subscriberSubtopic.put(clientId, subtopic);
            monitorTimeout(client);
            return;
        }
    }

    public void removeSubscriber(MessageClient client)
    {
        Object clientId = client.getClientId();
        Object o = null;
        if(subscribers != null)
            o = subscribers.remove(clientId);
        if(o == null)
            throw new MessageException("Not subscribed to " + destination.getId());
        TimeoutCapable t = (TimeoutCapable)subscriberSessions.remove(clientId);
        if(t != null)
            t.cancelTimeout();
        if(destination.getThrottleManager() != null)
            destination.getThrottleManager().removeClientThrottleMark(clientId);
    }

    public void removeSubscriber(MessageClient client, Subtopic subtopic)
    {
        Object clientId = client.getClientId();
        Object o = null;
        Map subscribers = (Map)subtopicSubscribers.get(subtopic);
        if(subscribers != null)
        {
            o = subscribers.remove(clientId);
            if(o == null)
                throw new MessageException("Not subscribed to " + destination.getId());
            if(subscribers.isEmpty())
                synchronized(this)
                {
                    subscribers = (Map)subtopicSubscribers.get(subtopic);
                    if(subscribers.isEmpty())
                        subtopicSubscribers.remove(subtopic);
                }
        }
        subscriberSubtopic.remove(clientId);
        TimeoutCapable t = (TimeoutCapable)subscriberSessions.remove(clientId);
        if(t != null)
            t.cancelTimeout();
        if(destination.getThrottleManager() != null)
            destination.getThrottleManager().removeClientThrottleMark(clientId);
    }

    public void scheduleSubscriberDestroy(MessageClient client, long timeout)
    {
        if(subscriberSessionManager != null)
        {
            SubscriberDestroyObject s = new SubscriberDestroyObject(client, timeout);
            subscriberSessionManager.scheduleTimeout(s);
        }
    }

    private void monitorTimeout(MessageClient client)
    {
        Object clientId = client.getClientId();
        if(subscriberSessionManager != null && subscriberSessions.get(clientId) == null)
        {
            SubscriberTimeoutObject s = new SubscriberTimeoutObject(client, sessionDuration);
            subscriberSessionManager.scheduleTimeout(s);
            subscriberSessions.put(clientId, s);
            client.setTimingOut(true);
        } else
        if(!client.isListeningOnFlexSession())
            client.listenOnFlexSession();
    }

    private final MessageDestination destination;
    private final long sessionDuration;
    private final Map subscribers;
    private final Map subscriberSessions;
    private final Map subscriberSubtopic;
    private final Map subtopicSubscribers;
    private TimeoutManager subscriberSessionManager;
}
