// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ThrottleManager.java

package flex.messaging.services.messaging;

import flex.management.ManageableComponent;
import flex.management.runtime.messaging.services.messaging.ThrottleManagerControl;
import flex.messaging.MessageException;
import flex.messaging.config.ThrottleSettings;
import flex.messaging.messages.Message;
import java.util.HashMap;
import java.util.Map;

public class ThrottleManager extends ManageableComponent
{
    class ThrottleMark
    {

        void assertValid(Message msg, int frequency)
        {
            if(frequency > 0)
            {
                int len = lastMessageTimes.length;
                if(messageCount >= len)
                {
                    long interval = msg.getTimestamp() - lastMessageTimes[(messageCount - len) % len];
                    long rate = (long)(1000 * len) / interval;
                    if(rate > (long)frequency)
                        throw new RuntimeException("actual frequency=" + rate + " max frequency=" + frequency);
                }
                lastMessageId = msg.getMessageId();
                lastMessageTimes[messageCount++ % len] = msg.getTimestamp();
            }
        }

        Object id;
        int messageCount;
        String lastMessageId;
        long lastMessageTimes[];

        ThrottleMark(Object identifier)
        {
            super();
            id = identifier;
            messageCount = 0;
            lastMessageId = "-1";
            lastMessageTimes = new long[15];
        }
    }


    public ThrottleManager(ThrottleSettings throttleSettings)
    {
        this(throttleSettings, false);
    }

    public ThrottleManager(ThrottleSettings throttleSettings, boolean enableManagement)
    {
        super(enableManagement);
        settings = throttleSettings;
        if(settings.isDestinationThrottleEnabled())
        {
            inboundDestinationMark = new ThrottleMark(settings.getDestinationName());
            outboundDestinationMark = new ThrottleMark(settings.getDestinationName());
        }
        if(settings.isClientThrottleEnabled())
        {
            inboundClientMarks = new HashMap();
            outboundClientMarks = new HashMap();
        }
    }

    public int throttleIncomingMessage(Message msg)
    {
        int n = 0;
        if(settings.getInboundPolicy() != 0)
        {
            n = throttleDestinationLevel(msg, true);
            if(n == 0)
            {
                n = throttleClientLevel(msg, msg.getClientId(), true);
                if(n != 0 && isManaged())
                    ((ThrottleManagerControl)getControl()).incrementClientIncomingMessageThrottleCount();
            } else
            if(isManaged())
                ((ThrottleManagerControl)getControl()).incrementDestinationIncomingMessageThrottleCount();
        }
        return n;
    }

    public int throttleOutgoingMessage(Message msg, Object clientId)
    {
        int n = 0;
        if(settings.getOutboundPolicy() != 0)
            if(clientId == null)
            {
                n = throttleDestinationLevel(msg, false);
                if(n != 0 && isManaged())
                    ((ThrottleManagerControl)getControl()).incrementDestinationOutgoingMessageThrottleCount();
            } else
            {
                n = throttleClientLevel(msg, clientId, false);
                if(n != 0 && isManaged())
                    ((ThrottleManagerControl)getControl()).incrementClientOutgoingMessageThrottleCount();
            }
        return n;
    }

    private int throttleDestinationLevel(Message msg, boolean incoming)
    {
        int throttleResult = 0;
        if(settings.isDestinationThrottleEnabled())
            if(incoming)
            {
                if(inboundDestinationMark.lastMessageId.equals(msg.getMessageId()))
                    throw new MessageException("Already processed message " + msg.getMessageId());
                try
                {
                    inboundDestinationMark.assertValid(msg, settings.getIncomingDestinationFrequency());
                }
                catch(RuntimeException e)
                {
                    String s = "Message throttled: Too many messages sent to destination " + inboundDestinationMark.id + " in too small of a time interval.  " + e.getMessage();
                    MessageException me = new MessageException(s);
                    throttleResult = handleError(settings.getInboundPolicy(), me);
                }
            } else
            {
                try
                {
                    outboundDestinationMark.assertValid(msg, settings.getOutgoingDestinationFrequency());
                }
                catch(RuntimeException e)
                {
                    String s = "Message throttled: Too many messages routed by destination " + outboundDestinationMark.id + " in too small of a time interval";
                    MessageException me = new MessageException(s);
                    throttleResult = handleError(settings.getOutboundPolicy(), me);
                }
            }
        return throttleResult;
    }

    private int throttleClientLevel(Message msg, Object clientId, boolean incoming)
    {
        int throttleResult;
        ThrottleMark clientLevelMark;
        throttleResult = 0;
        if(!settings.isClientThrottleEnabled())
            break MISSING_BLOCK_LABEL_341;
        clientLevelMark = null;
        if(!incoming)
            break MISSING_BLOCK_LABEL_182;
        if(inboundClientMarks.get(clientId) != null)
            clientLevelMark = (ThrottleMark)inboundClientMarks.get(clientId);
        else
            clientLevelMark = new ThrottleMark(clientId);
        clientLevelMark.assertValid(msg, settings.getIncomingClientFrequency());
        inboundClientMarks.put(clientId, clientLevelMark);
        break MISSING_BLOCK_LABEL_341;
        RuntimeException e;
        e;
        String s = "Message throttled: Too many messages sent by client " + clientId + " in too small of a time interval";
        MessageException me = new MessageException(s);
        throttleResult = handleError(settings.getOutboundPolicy(), me);
        inboundClientMarks.put(clientId, clientLevelMark);
        break MISSING_BLOCK_LABEL_341;
        Exception exception;
        exception;
        inboundClientMarks.put(clientId, clientLevelMark);
        throw exception;
        if(outboundClientMarks.get(clientId) != null)
            clientLevelMark = (ThrottleMark)outboundClientMarks.get(clientId);
        else
            clientLevelMark = new ThrottleMark(clientId);
        clientLevelMark.assertValid(msg, settings.getOutgoingClientFrequency());
        outboundClientMarks.put(clientId, clientLevelMark);
        break MISSING_BLOCK_LABEL_341;
        e;
        String s = "Message throttled: Too many messages sent to client " + clientId + " in too small of a time interval";
        MessageException me = new MessageException(s);
        throttleResult = handleError(settings.getOutboundPolicy(), me);
        outboundClientMarks.put(clientId, clientLevelMark);
        break MISSING_BLOCK_LABEL_341;
        Exception exception1;
        exception1;
        outboundClientMarks.put(clientId, clientLevelMark);
        throw exception1;
        return throttleResult;
    }

    private int handleError(int policy, MessageException e)
    {
        int n = 0;
        switch(policy)
        {
        case 2: // '\002'
            n = 1;
            break;

        case 3: // '\003'
            n = 2;
            break;

        case 1: // '\001'
            throw e;
        }
        return n;
    }

    public void removeClientThrottleMark(Object clientId)
    {
        if(inboundClientMarks != null)
            inboundClientMarks.remove(clientId);
        if(outboundClientMarks != null)
            outboundClientMarks.remove(clientId);
    }

    private Map inboundClientMarks;
    private Map outboundClientMarks;
    private ThrottleMark inboundDestinationMark;
    private ThrottleMark outboundDestinationMark;
    private ThrottleSettings settings;
    public static final int RESULT_OK = 0;
    public static final int RESULT_IGNORE = 1;
    public static final int RESULT_REPLACE = 2;
    static final int MESSAGE_HISTORY_SIZE = 15;
}
