// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JMSAdapter.java

package flex.messaging.services.messaging.adapters;

import flex.management.runtime.messaging.services.messaging.adapters.JMSAdapterControl;
import flex.messaging.Destination;
import flex.messaging.MessageDestination;
import flex.messaging.MessageException;
import flex.messaging.config.AdapterSettings;
import flex.messaging.config.ConfigMap;
import flex.messaging.config.DestinationSettings;
import flex.messaging.config.ServerSettings;
import flex.messaging.messages.AsyncMessage;
import flex.messaging.messages.CommandMessage;
import flex.messaging.messages.Message;
import flex.messaging.services.MessageService;
import flex.messaging.services.ServiceAdapter;
import flex.messaging.util.Trace;
import java.lang.reflect.Field;
import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.TextMessage;
import javax.naming.NamingException;

// Referenced classes of package flex.messaging.services.messaging.adapters:
//            JMSSettings, JMSTopicProducer, JMSProducer, JMSQueueProducer, 
//            JMSConsumer, JMSTopicConsumer, JMSQueueConsumer, JMSConfigConstants, 
//            JMSProxy

public class JMSAdapter extends ServiceAdapter
    implements JMSConfigConstants
{

    public JMSAdapter()
    {
        topicProducers = new LinkedList();
        topicConsumers = Collections.synchronizedMap(new HashMap());
        queueProducers = new LinkedList();
        queueConsumers = Collections.synchronizedMap(new HashMap());
        settings = new JMSSettings();
    }

    public void setSettings(Destination destination, AdapterSettings adapterSettings, DestinationSettings destinationSettings)
    {
        super.setSettings(destination, adapterSettings, destinationSettings);
        ConfigMap properties = destinationSettings.getProperties();
        jms(properties);
    }

    private void jms(ConfigMap properties)
    {
        ConfigMap jms = properties.getPropertyAsMap("jms", null);
        if(jms != null)
        {
            String destType = jms.getPropertyAsString("destination-type", "Topic");
            settings.setDestinationType(destType);
            String msgType = jms.getPropertyAsString("message-type", null);
            settings.setMessageType(msgType);
            String factory = jms.getPropertyAsString("connection-factory", null);
            settings.setConnectionFactory(factory);
            String destJNDI = jms.getPropertyAsString("destination-jndi-name", null);
            settings.setDestinationJNDIName(destJNDI);
            String dest = jms.getPropertyAsString("destination-name", null);
            settings.setDestinationName(dest);
            boolean durable = (destination instanceof MessageDestination) ? ((MessageDestination)destination).getServerSettings().isDurable() : false;
            settings.setDurableConsumers(durable);
            String deliveryMode = jms.getPropertyAsString("delivery-mode", null);
            settings.setDeliveryMode(deliveryMode);
            String defPriority = jms.getPropertyAsString("message-priority", null);
            int priority = 4;
            if(defPriority != null && !defPriority.equals("DEFAULT_PRIORITY"))
                priority = jms.getPropertyAsInt("message-priority", priority);
            settings.setMessagePriority(priority);
            String ackMode = jms.getPropertyAsString("acknowledge-mode", null);
            settings.setAcknowledgeMode(ackMode);
            boolean transMode = jms.getPropertyAsBoolean("transacted-sessions", false);
            settings.setTransactionMode(transMode);
            ConfigMap env = jms.getPropertyAsMap("initial-context-environment", null);
            if(env != null)
            {
                List props = env.getPropertyAsList("property", null);
                if(props != null)
                {
                    Class contextClass = javax.naming.Context.class;
                    Hashtable envProps = new Hashtable();
                    for(Iterator iter = props.iterator(); iter.hasNext(); settings.setInitialContextEnvironment(envProps))
                    {
                        Object prop = iter.next();
                        if(prop instanceof ConfigMap)
                        {
                            ConfigMap pair = (ConfigMap)prop;
                            String name = pair.getProperty("name");
                            String value = pair.getProperty("value");
                            if(name == null || value == null)
                            {
                                MessageException me = new MessageException();
                                me.setMessage(10800, new Object[] {
                                    destination.getId()
                                });
                                throw me;
                            }
                            if(name.startsWith("Context."))
                            {
                                String fieldName = name.substring(name.indexOf(".") + 1);
                                Field field = null;
                                try
                                {
                                    field = contextClass.getDeclaredField(fieldName);
                                }
                                catch(NoSuchFieldException nsfe)
                                {
                                    MessageException me = new MessageException();
                                    me.setMessage(10801, new Object[] {
                                        destination.getId(), fieldName
                                    });
                                    throw me;
                                }
                                String fieldValue = null;
                                try
                                {
                                    fieldValue = (String)field.get(null);
                                }
                                catch(IllegalAccessException iae)
                                {
                                    MessageException me = new MessageException();
                                    me.setMessage(10802, new Object[] {
                                        destination.getId(), fieldName
                                    });
                                    throw me;
                                }
                                envProps.put(fieldValue, value);
                            } else
                            {
                                envProps.put(name, value);
                            }
                        } else
                        {
                            MessageException me = new MessageException();
                            me.setMessage(10800, new Object[] {
                                destination.getId()
                            });
                            throw me;
                        }
                    }

                } else
                {
                    MessageException me = new MessageException();
                    me.setMessage(10803, new Object[] {
                        destination.getId()
                    });
                    throw me;
                }
            }
        }
    }

    public Object invoke(Message message)
    {
        JMSProducer producer = null;
        Map msgProps = message.getHeaders();
        msgProps.put("timeToLive", new Long(message.getTimeToLive()));
        if(getDestinationType() == null)
        {
            MessageException me = new MessageException();
            me.setMessage(10804, new Object[] {
                message.getDestination()
            });
            throw me;
        }
        if(getDestinationType().equalsIgnoreCase("Topic"))
            synchronized(topicProducers)
            {
                if(topicProducers.size() < 1)
                {
                    producer = new JMSTopicProducer(this, settings);
                    try
                    {
                        producer.start(message.getDestination(), msgProps);
                    }
                    catch(Exception e)
                    {
                        throw new MessageException(e.getMessage(), e);
                    }
                } else
                {
                    producer = (JMSProducer)topicProducers.removeFirst();
                }
            }
        else
        if(getDestinationType().equalsIgnoreCase("Queue"))
        {
            synchronized(queueProducers)
            {
                if(queueProducers.size() < 1)
                {
                    producer = new JMSQueueProducer(this, settings);
                    try
                    {
                        producer.start(message.getDestination(), msgProps);
                    }
                    catch(Exception e)
                    {
                        throw new MessageException(e.getMessage(), e);
                    }
                } else
                {
                    producer = (JMSProducer)queueProducers.removeFirst();
                }
            }
        } else
        {
            MessageException me = new MessageException();
            me.setMessage(10805);
            throw me;
        }
        try
        {
            producer.sendMessage(message);
        }
        catch(JMSException jmsEx)
        {
            try
            {
                producer.start(message.getDestination(), msgProps);
                producer.sendMessage(message);
            }
            catch(Exception e)
            {
                throw new MessageException(e.getMessage(), e);
            }
        }
        if(getDestinationType().equalsIgnoreCase("Topic"))
            synchronized(topicProducers)
            {
                topicProducers.addLast(producer);
            }
        else
            synchronized(queueProducers)
            {
                queueProducers.addLast(producer);
            }
        return null;
    }

    public Object manage(CommandMessage commandMessage)
    {
        Object commandResponse = null;
        JMSConsumer consumer = null;
        Object clientId = commandMessage.getClientId();
        try
        {
            if(commandMessage.getOperation() == 0)
            {
                if(getDestinationType() == null)
                    throw new MessageException("JMS Adapter destination, " + commandMessage.getDestination() + ", not defined");
                if(getDestinationType().equalsIgnoreCase("Topic"))
                {
                    if(topicConsumers.containsKey(clientId))
                    {
                        consumer = (JMSConsumer)topicConsumers.get(clientId);
                        consumer.stop(true);
                    }
                    consumer = new JMSTopicConsumer(this, settings, clientId);
                    consumer.start(commandMessage.getDestination(), commandMessage.getHeaders());
                    topicConsumers.put(clientId, consumer);
                } else
                if(getDestinationType().equalsIgnoreCase("Queue"))
                {
                    if(queueConsumers.containsKey(clientId))
                    {
                        consumer = (JMSConsumer)queueConsumers.get(clientId);
                        consumer.stop();
                    }
                    consumer = new JMSQueueConsumer(this, settings, clientId);
                    consumer.start(commandMessage.getDestination(), commandMessage.getHeaders());
                    queueConsumers.put(clientId, consumer);
                } else
                {
                    MessageException me = new MessageException();
                    me.setMessage(10805);
                    throw me;
                }
                try
                {
                    consumer.asyncReceive();
                }
                catch(JMSException jmsEx)
                {
                    if(topicConsumers.containsKey(clientId))
                        topicConsumers.remove(clientId);
                    else
                    if(queueConsumers.containsKey(clientId))
                        queueConsumers.remove(clientId);
                    throw new MessageException(jmsEx.getMessage(), jmsEx);
                }
            } else
            if(commandMessage.getOperation() == 1)
            {
                if(topicConsumers.containsKey(clientId))
                    consumer = (JMSConsumer)topicConsumers.remove(clientId);
                else
                if(queueConsumers.containsKey(clientId))
                    consumer = (JMSConsumer)queueConsumers.remove(clientId);
                if(consumer != null)
                {
                    if(commandMessage.getHeader("DSSessionInvalidated") != null && ((Boolean)commandMessage.getHeader("DSSessionInvalidated")).booleanValue())
                        consumer.stop(false);
                    else
                        consumer.stop(true);
                } else
                {
                    MessageException me = new MessageException();
                    me.setMessage(10806);
                    throw me;
                }
            } else
            if(commandMessage.getOperation() == 2)
            {
                if(topicConsumers.containsKey(clientId))
                    consumer = (JMSConsumer)topicConsumers.get(clientId);
                else
                if(queueConsumers.containsKey(clientId))
                {
                    consumer = (JMSConsumer)queueConsumers.get(clientId);
                } else
                {
                    MessageException me = new MessageException();
                    me.setMessage(10806);
                    throw me;
                }
                commandResponse = consumer.syncReceive();
            }
        }
        catch(JMSException jmsEx)
        {
            throw new MessageException(jmsEx.getMessage(), jmsEx);
        }
        catch(NamingException jndiEx)
        {
            throw new MessageException(jndiEx.getMessage(), jndiEx);
        }
        return commandResponse;
    }

    public boolean handlesSubscriptions()
    {
        return true;
    }

    public void onMessage(javax.jms.Message jmsMessage, JMSConsumer consumer)
    {
        AsyncMessage flexMessage = convertToFlexMessage(jmsMessage, consumer);
        if(flexMessage != null)
            ((MessageService)service).serviceMessageFromAdapter(flexMessage, false);
    }

    public AsyncMessage convertToFlexMessage(javax.jms.Message jmsMessage, JMSConsumer consumer)
    {
        AsyncMessage flexMessage = null;
        try
        {
            flexMessage = new AsyncMessage();
            flexMessage.setClientId(consumer.getClientId());
            flexMessage.setMessageId(jmsMessage.getJMSMessageID());
            flexMessage.setDestination(consumer.getFlexDestinationName());
            if(jmsMessage instanceof TextMessage)
            {
                TextMessage textMessage = (TextMessage)jmsMessage;
                flexMessage.setBody(textMessage.getText());
            } else
            if(jmsMessage instanceof ObjectMessage)
            {
                ObjectMessage objMessage = (ObjectMessage)jmsMessage;
                flexMessage.setBody(objMessage.getObject());
            }
            flexMessage.setTimestamp(jmsMessage.getJMSTimestamp());
            Enumeration propEnum = jmsMessage.getPropertyNames();
            do
            {
                if(!propEnum.hasMoreElements())
                    break;
                String propName = (String)propEnum.nextElement();
                try
                {
                    flexMessage.setHeader(propName, jmsMessage.getObjectProperty(propName));
                }
                catch(Exception e)
                {
                    if(Trace.message)
                        Trace.trace(e.getMessage());
                }
            } while(true);
        }
        catch(JMSException jmsEx)
        {
            if(Trace.message)
                Trace.trace(jmsEx.getMessage());
        }
        return flexMessage;
    }

    public void onJmsConnectionException(JMSException e, JMSProxy jmsProxy)
    {
        if(jmsProxy instanceof JMSTopicConsumer)
        {
            JMSTopicConsumer consumer = (JMSTopicConsumer)jmsProxy;
            topicConsumers.remove(consumer.getClientId());
        } else
        if(jmsProxy instanceof JMSQueueConsumer)
        {
            JMSQueueConsumer consumer = (JMSQueueConsumer)jmsProxy;
            queueConsumers.remove(consumer.getClientId());
        }
    }

    private String getDestinationType()
    {
        return settings.getDestinationType();
    }

    public void setupAdapterControl(Destination destination)
    {
        controller = new JMSAdapterControl(getId(), this, destination.getControl());
        controller.register();
        setControl(controller);
    }

    public int getTopicProducerCount()
    {
        return topicProducers.size();
    }

    public int getTopicConsumerCount()
    {
        return topicConsumers.size();
    }

    public String[] getTopicConsumerIds()
    {
        Set consumerIds = topicConsumers.keySet();
        if(consumerIds != null)
        {
            String ids[] = new String[consumerIds.size()];
            return (String[])(String[])consumerIds.toArray(ids);
        } else
        {
            return new String[0];
        }
    }

    public int getQueueProducerCount()
    {
        return queueProducers.size();
    }

    public int getQueueConsumerCount()
    {
        return queueConsumers.size();
    }

    public String[] getQueueConsumerIds()
    {
        Set consumerIds = queueConsumers.keySet();
        if(consumerIds != null)
        {
            String ids[] = new String[consumerIds.size()];
            return (String[])(String[])consumerIds.toArray(ids);
        } else
        {
            return new String[0];
        }
    }

    public void removeConsumer(String clientId)
    {
        JMSConsumer consumer = null;
        if(topicConsumers.containsKey(clientId))
            consumer = (JMSConsumer)topicConsumers.remove(clientId);
        else
        if(queueConsumers.containsKey(clientId))
            consumer = (JMSConsumer)queueConsumers.remove(clientId);
        if(consumer != null)
            consumer.stop(true);
    }

    public void stop()
    {
        stopConsumers(topicConsumers.values());
        stopConsumers(queueConsumers.values());
    }

    private void stopConsumers(Collection consumers)
    {
        JMSConsumer consumer;
        for(Iterator itr = consumers.iterator(); itr.hasNext(); consumer.stop())
            consumer = (JMSConsumer)itr.next();

    }

    private static final String JMS = "jms";
    private static final String INITIAL_CONTEXT_ENVIRONMENT = "initial-context-environment";
    private static final String PROPERTY = "property";
    private static final String NAME = "name";
    private static final String VALUE = "value";
    private LinkedList topicProducers;
    private Map topicConsumers;
    private LinkedList queueProducers;
    private Map queueConsumers;
    private JMSSettings settings;
    private JMSAdapterControl controller;
}
