// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JMSConsumer.java

package flex.messaging.services.messaging.adapters;

import flex.messaging.util.Trace;
import java.util.ArrayList;
import java.util.List;
import javax.jms.*;

// Referenced classes of package flex.messaging.services.messaging.adapters:
//            JMSProxy, ListeningMessageReceiver, PollingMessageReceiver, MessageReceiver, 
//            JMSAdapter, JMSSettings

public abstract class JMSConsumer extends JMSProxy
{

    public JMSConsumer(JMSAdapter jmsAdapter, JMSSettings settings, Object clientId)
    {
        super(jmsAdapter, settings);
        receiverAdapter = null;
        this.clientId = clientId;
    }

    public Object getClientId()
    {
        return clientId;
    }

    void stop()
    {
        if(receiverAdapter != null)
            receiverAdapter.stopReceive();
        try
        {
            consumer.close();
        }
        catch(Exception e) { }
        super.stop();
    }

    void stop(boolean unsubscribe)
    {
        stop();
    }

    void asyncReceive()
        throws JMSException
    {
        receiverAdapter().startAsyncReceive();
        connection.start();
    }

    Object syncReceive()
        throws JMSException
    {
        try
        {
            connection.start();
        }
        catch(Exception e) { }
        List messages = new ArrayList();
        receiverAdapter().receiveFlexMessages(messages);
        return messages.isEmpty() ? null : messages;
    }

    private void acknowledgeMessage(Message message)
    {
        if(getAcknowledgeMode() == 2)
            try
            {
                message.acknowledge();
            }
            catch(JMSException jmsEx)
            {
                if(Trace.message)
                    Trace.trace("Error in client ack " + jmsEx.getMessage());
            }
    }

    Message receiveNoWait()
        throws JMSException
    {
        return consumer.receiveNoWait();
    }

    void getFlexMessages(List result)
        throws JMSException
    {
        do
        {
            Message message = receiveNoWait();
            if(message != null)
            {
                acknowledgeMessage(message);
                result.add(jmsAdapter.convertToFlexMessage(message, this));
            } else
            {
                return;
            }
        } while(true);
    }

    void acknowledgeAndDispatch(Message jmsMessage)
    {
        acknowledgeMessage(jmsMessage);
        jmsAdapter.onMessage(jmsMessage, this);
    }

    MessageListener setMessageListener(MessageListener listener)
        throws JMSException
    {
        MessageListener oldListener = consumer.getMessageListener();
        consumer.setMessageListener(listener);
        return oldListener;
    }

    private MessageReceiver receiverAdapter()
    {
        if(receiverAdapter == null)
            try
            {
                consumer.getMessageListener();
                receiverAdapter = new ListeningMessageReceiver(this);
            }
            catch(JMSException jmsException)
            {
                receiverAdapter = new PollingMessageReceiver(this);
            }
        return receiverAdapter;
    }

    protected MessageConsumer consumer;
    protected Object clientId;
    private MessageReceiver receiverAdapter;
}
