// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JMSProducer.java

package flex.messaging.services.messaging.adapters;

import flex.messaging.MessageException;
import flex.messaging.messages.Message;
import java.io.Serializable;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import javax.jms.JMSException;
import javax.jms.MessageProducer;

// Referenced classes of package flex.messaging.services.messaging.adapters:
//            JMSProxy, JMSSettings, JMSAdapter

public abstract class JMSProducer extends JMSProxy
{

    public JMSProducer(JMSAdapter jmsAdapter, JMSSettings jmsSettings)
    {
        super(jmsAdapter, jmsSettings);
    }

    void sendMessage(Message flexMessage)
        throws JMSException
    {
        try
        {
            String jmsMessageType = settings.getMessageType();
            if(jmsMessageType.equals("javax.jms.TextMessage"))
                sendTextMessage(flexMessage.getBody().toString(), flexMessage.getHeaders());
            else
            if(jmsMessageType.equals("javax.jms.ObjectMessage"))
            {
                try
                {
                    sendObjectMessage((Serializable)flexMessage.getBody(), flexMessage.getHeaders());
                }
                catch(ClassCastException ce)
                {
                    MessageException me = new MessageException();
                    me.setMessage(10810);
                    throw me;
                }
            } else
            {
                MessageException me = new MessageException();
                me.setMessage(10811, new Object[] {
                    jmsMessageType
                });
                throw me;
            }
        }
        catch(NullPointerException ne)
        {
            MessageException me = new MessageException();
            me.setMessage(10812, new Object[] {
                "message-type"
            });
            throw me;
        }
    }

    void stop()
    {
        try
        {
            if(producer != null)
                producer.close();
        }
        catch(Exception e) { }
        super.stop();
    }

    abstract void sendTextMessage(String s, Map map)
        throws JMSException;

    abstract void sendObjectMessage(Serializable serializable, Map map)
        throws JMSException;

    protected void copyHeadersToProperties(Map properties, javax.jms.Message message)
        throws JMSException
    {
        Iterator iter = properties.keySet().iterator();
        do
        {
            if(!iter.hasNext())
                break;
            String propName = (String)iter.next();
            Object propValue = properties.get(propName);
            if(!propName.equals("timeToLive") && propValue != null)
                message.setObjectProperty(propName, propValue);
        } while(true);
    }

    protected long getTimeToLive(Map properties)
        throws JMSException
    {
        long timeToLive = producer.getTimeToLive();
        if(properties.containsKey("timeToLive"))
        {
            long l = ((Long)properties.get("timeToLive")).longValue();
            if(l != 0L)
                timeToLive = l;
        }
        return timeToLive;
    }

    protected MessageProducer producer;
}
