// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JMSProxy.java

package flex.messaging.services.messaging.adapters;

import flex.messaging.MessageException;
import java.util.Hashtable;
import java.util.Map;
import javax.jms.*;
import javax.naming.*;

// Referenced classes of package flex.messaging.services.messaging.adapters:
//            JMSAdapter, JMSSettings

public abstract class JMSProxy
    implements ExceptionListener
{

    public JMSProxy(JMSAdapter adapter, JMSSettings jmsSettings)
    {
        jmsAdapter = adapter;
        settings = jmsSettings;
        ackMode = -1;
        priority = -1;
        deliveryMode = -1;
        timeToLive = -1L;
    }

    abstract void start(String s, Map map)
        throws NamingException, JMSException;

    void stop()
    {
        try
        {
            session.close();
        }
        catch(Exception e) { }
        try
        {
            connection.close();
        }
        catch(Exception e) { }
        try
        {
            if(jndiContext != null)
                jndiContext.close();
        }
        catch(Exception e) { }
    }

    public void onException(JMSException exception)
    {
        jmsAdapter.onJmsConnectionException(exception, this);
    }

    protected Context getJndiContext(Map messageProps)
        throws NamingException
    {
        if(jndiContext != null)
            try
            {
                stop();
            }
            catch(Exception e) { }
        Hashtable env = getIntialContextEnvironment();
        if(env != null)
            jndiContext = new InitialContext(env);
        else
            jndiContext = new InitialContext();
        return jndiContext;
    }

    public String getDestinationJndiName()
    {
        if(destinationJndiName == null)
        {
            destinationJndiName = settings.getDestinationJNDIName();
            if(destinationJndiName == null)
            {
                MessageException me = new MessageException();
                me.setMessage(10807);
                throw me;
            }
        }
        return destinationJndiName;
    }

    public String getDestinationName(String flexDestinationName)
    {
        if(destinationName == null)
        {
            String destName = settings.getDestinationName();
            if(destName == null)
                destName = flexDestinationName;
            destinationName = destName;
        }
        if(this.flexDestinationName == null)
            this.flexDestinationName = flexDestinationName;
        return destinationName;
    }

    public String getFlexDestinationName()
    {
        return flexDestinationName;
    }

    protected ConnectionFactory getConnectionFactory()
        throws NamingException
    {
        if(connectionFactory == null)
        {
            String conFactoryName = settings.getConnectionFactory();
            connectionFactory = (ConnectionFactory)jndiContext.lookup(conFactoryName);
        }
        return connectionFactory;
    }

    protected Destination getDestination(String flexDestinationName)
        throws NamingException
    {
        getDestinationName(flexDestinationName);
        if(destination == null)
            try
            {
                destination = (Destination)jndiContext.lookup(getDestinationJndiName());
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        return destination;
    }

    protected boolean isTransactedSession()
    {
        return settings.isTransactionMode();
    }

    protected int getAcknowledgeMode()
    {
        if(ackMode < 0)
            if(settings.getAcknowledgeMode() != null)
            {
                String ackString = settings.getAcknowledgeMode();
                if(ackString.equalsIgnoreCase("AUTO_ACKNOWLEDGE"))
                    ackMode = 1;
                else
                if(ackString.equalsIgnoreCase("CLIENT_ACKNOWLEDGE"))
                    ackMode = 2;
                else
                if(ackString.equalsIgnoreCase("DUPS_OK_ACKNOWLEDGE"))
                {
                    ackMode = 3;
                } else
                {
                    MessageException me = new MessageException();
                    me.setMessage(10808, new Object[] {
                        ackString, destinationName
                    });
                    throw me;
                }
            } else
            {
                ackMode = 1;
            }
        return ackMode;
    }

    public int getPriority()
    {
        if(priority < 0)
            priority = settings.getMessagePriority();
        return priority;
    }

    public int getDeliveryMode()
    {
        if(deliveryMode < 0)
            if(settings.getDeliveryMode() != null)
            {
                String deliveryString = settings.getDeliveryMode();
                if(deliveryString.equalsIgnoreCase("DEFAULT_DELIVERY_MODE"))
                    deliveryMode = 2;
                else
                if(deliveryString.equalsIgnoreCase("PERSISTENT"))
                    deliveryMode = 2;
                else
                if(deliveryString.equalsIgnoreCase("NON_PERSISTENT"))
                {
                    deliveryMode = 1;
                } else
                {
                    MessageException me = new MessageException();
                    me.setMessage(10809, new Object[] {
                        deliveryString, destinationName
                    });
                    throw me;
                }
            } else
            {
                deliveryMode = 2;
            }
        return deliveryMode;
    }

    public Hashtable getIntialContextEnvironment()
    {
        return settings.getInitialContextEnvironment();
    }

    protected JMSAdapter jmsAdapter;
    protected JMSSettings settings;
    protected Context jndiContext;
    protected Connection connection;
    protected Session session;
    private Destination destination;
    private String destinationName;
    private String flexDestinationName;
    private String destinationJndiName;
    private ConnectionFactory connectionFactory;
    private int ackMode;
    private int priority;
    private int deliveryMode;
    private long timeToLive;
}
