// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JMSQueueProducer.java

package flex.messaging.services.messaging.adapters;

import flex.messaging.MessageException;
import java.io.Serializable;
import java.util.Map;
import javax.jms.*;
import javax.naming.NamingException;

// Referenced classes of package flex.messaging.services.messaging.adapters:
//            JMSProducer, JMSAdapter, JMSSettings

public class JMSQueueProducer extends JMSProducer
{

    public JMSQueueProducer(JMSAdapter jmsAdapter, JMSSettings settings)
    {
        super(jmsAdapter, settings);
    }

    void start(String flexDestinationName, Map messageProps)
        throws NamingException, JMSException
    {
        getJndiContext(messageProps);
        Queue queue = null;
        javax.jms.Destination dest = getDestination(flexDestinationName);
        try
        {
            queue = (Queue)dest;
        }
        catch(ClassCastException cce)
        {
            MessageException me = new MessageException();
            me.setMessage(10813, new Object[] {
                dest.getClass().getName()
            });
            throw me;
        }
        javax.jms.ConnectionFactory factory = getConnectionFactory();
        try
        {
            QueueConnectionFactory queueFactory = (QueueConnectionFactory)factory;
            connection = queueFactory.createQueueConnection();
        }
        catch(ClassCastException cce)
        {
            MessageException me = new MessageException();
            me.setMessage(10814, new Object[] {
                factory.getClass().getName()
            });
            throw me;
        }
        QueueConnection queueConnection = (QueueConnection)connection;
        session = queueConnection.createQueueSession(false, getAcknowledgeMode());
        QueueSession queueSession = (QueueSession)session;
        sender = queueSession.createSender(queue);
        producer = sender;
        connection.start();
    }

    void sendTextMessage(String text, Map properties)
        throws JMSException
    {
        if(text != null)
        {
            TextMessage message = session.createTextMessage();
            message.setText(text);
            copyHeadersToProperties(properties, message);
            long timeToLive = getTimeToLive(properties);
            sender.send(message, getDeliveryMode(), getPriority(), timeToLive);
        }
    }

    void sendObjectMessage(Serializable obj, Map properties)
        throws JMSException
    {
        if(obj != null)
        {
            ObjectMessage message = session.createObjectMessage();
            message.setObject(obj);
            copyHeadersToProperties(properties, message);
            long timeToLive = getTimeToLive(properties);
            sender.send(message, getDeliveryMode(), getPriority(), timeToLive);
        }
    }

    private QueueSender sender;
}
