// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JMSTopicConsumer.java

package flex.messaging.services.messaging.adapters;

import flex.messaging.MessageException;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import java.util.Map;
import javax.jms.*;
import javax.naming.NamingException;

// Referenced classes of package flex.messaging.services.messaging.adapters:
//            JMSConsumer, JMSSettings, JMSAdapter

public class JMSTopicConsumer extends JMSConsumer
{
    class ClientIdSetterThread extends Thread
    {

        public TopicConnection getTopicConnection()
        {
            return topicConnection;
        }

        public void run()
        {
            try
            {
                topicConnection = topicFactory.createTopicConnection();
                topicConnection.setClientID(clientId);
            }
            catch(Exception e)
            {
                if(Log.isWarn())
                    Log.getLogger("SERVICE.MESSAGE.JMS").warn("The proxied durable JMS subscription with name, " + buildSubscriptionName(clientId) + " could not set its client Id " + "on the topic connection : " + e.toString());
            }
        }

        private TopicConnectionFactory topicFactory;
        private TopicConnection topicConnection;
        private String clientId;

        public ClientIdSetterThread(TopicConnectionFactory topicFactory, String clientId)
        {
            super();
            this.topicFactory = topicFactory;
            this.clientId = clientId;
        }
    }


    public JMSTopicConsumer(JMSAdapter jmsAdapter, JMSSettings settings, Object clientId)
    {
        super(jmsAdapter, settings, clientId);
    }

    void start(String flexDestinationName, Map messageProps)
        throws NamingException, JMSException
    {
        getJndiContext(messageProps);
        Topic topic = null;
        javax.jms.Destination dest = getDestination(flexDestinationName);
        try
        {
            topic = (Topic)dest;
        }
        catch(ClassCastException cce)
        {
            MessageException me = new MessageException();
            me.setMessage(10815, new Object[] {
                dest.getClass().getName()
            });
            throw me;
        }
        javax.jms.ConnectionFactory factory = getConnectionFactory();
        TopicConnectionFactory topicFactory;
        try
        {
            topicFactory = (TopicConnectionFactory)getConnectionFactory();
            connection = topicFactory.createTopicConnection();
        }
        catch(ClassCastException cce)
        {
            MessageException me = new MessageException();
            me.setMessage(10816, new Object[] {
                factory.getClass().getName()
            });
            throw me;
        }
        TopicConnection topicConnection = (TopicConnection)connection;
        if(settings.useDurableConsumers())
            try
            {
                topicConnection.setClientID(clientId.toString());
            }
            catch(Exception e)
            {
                ClientIdSetterThread helperThread = new ClientIdSetterThread(topicFactory, clientId.toString());
                helperThread.setDaemon(true);
                helperThread.start();
                try
                {
                    helperThread.join();
                    connection = helperThread.getTopicConnection();
                    topicConnection = (TopicConnection)connection;
                }
                catch(InterruptedException ie)
                {
                    if(Log.isWarn())
                        Log.getLogger("SERVICE.MESSAGE.JMS").warn("The proxied durable JMS subscription with name, " + buildSubscriptionName(clientId) + " could not set its client Id " + "on the topic connection because it was interrupted: " + ie.toString());
                }
            }
        session = topicConnection.createTopicSession(false, getAcknowledgeMode());
        TopicSession topicSession = (TopicSession)session;
        String subscriptionName = null;
        if(settings.useDurableConsumers())
            subscriptionName = buildSubscriptionName(clientId);
        if(messageProps.get("DSSelector") != null)
        {
            String selectorExpression = (String)messageProps.get("DSSelector");
            if(subscriptionName != null)
                consumer = topicSession.createDurableSubscriber(topic, subscriptionName, selectorExpression, false);
            else
                consumer = topicSession.createSubscriber(topic, selectorExpression, false);
        } else
        if(subscriptionName != null)
            consumer = topicSession.createDurableSubscriber(topic, subscriptionName);
        else
            consumer = topicSession.createSubscriber(topic);
    }

    void stop(boolean unsubscribe)
    {
        if(unsubscribe)
        {
            try
            {
                consumer.close();
            }
            catch(Exception e) { }
            if(settings.useDurableConsumers())
                try
                {
                    TopicSession topicSession = (TopicSession)session;
                    topicSession.unsubscribe(buildSubscriptionName(clientId));
                }
                catch(Exception e)
                {
                    if(Log.isWarn())
                        Log.getLogger("SERVICE.MESSAGE.JMS").warn("The proxied durable JMS subscription with name, " + buildSubscriptionName(clientId) + " failed to unsubscribe : " + e.toString());
                }
            super.stop();
        } else
        {
            stop();
        }
    }

    void stop()
    {
        try
        {
            consumer.close();
        }
        catch(Exception e) { }
        super.stop();
    }

    private String buildSubscriptionName(Object clientId)
    {
        return "DS" + clientId.toString();
    }

    private static final String DURABLE_SUBSCRIBER_NAME_PREFIX = "DS";
    private static final String LOG_CATEGORY = "SERVICE.MESSAGE.JMS";

}
