// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JMSTopicProducer.java

package flex.messaging.services.messaging.adapters;

import flex.messaging.MessageException;
import java.io.Serializable;
import java.util.Map;
import javax.jms.*;
import javax.naming.NamingException;

// Referenced classes of package flex.messaging.services.messaging.adapters:
//            JMSProducer, JMSAdapter, JMSSettings

public class JMSTopicProducer extends JMSProducer
{

    public JMSTopicProducer(JMSAdapter jmsAdapter, JMSSettings jmsSettings)
    {
        super(jmsAdapter, jmsSettings);
    }

    void start(String flexDestinationName, Map messageProps)
        throws NamingException, JMSException
    {
        getJndiContext(messageProps);
        Topic topic = null;
        javax.jms.Destination dest = getDestination(flexDestinationName);
        try
        {
            topic = (Topic)dest;
        }
        catch(ClassCastException cce)
        {
            MessageException me = new MessageException();
            me.setMessage(10815, new Object[] {
                dest.getClass().getName()
            });
            throw me;
        }
        javax.jms.ConnectionFactory factory = getConnectionFactory();
        try
        {
            TopicConnectionFactory topicFactory = (TopicConnectionFactory)getConnectionFactory();
            connection = topicFactory.createTopicConnection();
        }
        catch(ClassCastException cce)
        {
            MessageException me = new MessageException();
            me.setMessage(10816, new Object[] {
                factory.getClass().getName()
            });
            throw me;
        }
        TopicConnection topicConnection = (TopicConnection)connection;
        session = topicConnection.createTopicSession(isTransactedSession(), getAcknowledgeMode());
        TopicSession topicSession = (TopicSession)session;
        publisher = topicSession.createPublisher(topic);
        producer = publisher;
        connection.start();
    }

    void sendTextMessage(String text, Map properties)
        throws JMSException
    {
        if(text != null)
        {
            TextMessage message = session.createTextMessage();
            message.setText(text);
            copyHeadersToProperties(properties, message);
            long timeToLive = getTimeToLive(properties);
            publisher.publish(message, getDeliveryMode(), getPriority(), timeToLive);
        }
    }

    void sendObjectMessage(Serializable obj, Map properties)
        throws JMSException
    {
        if(obj != null)
        {
            ObjectMessage message = session.createObjectMessage();
            message.setObject(obj);
            copyHeadersToProperties(properties, message);
            long timeToLive = getTimeToLive(properties);
            publisher.publish(message, getDeliveryMode(), getPriority(), timeToLive);
        }
    }

    private TopicPublisher publisher;
}
