// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JavaAdapter.java

package flex.messaging.services.remoting.adapters;

import flex.management.runtime.messaging.services.remoting.adapters.JavaAdapterControl;
import flex.messaging.*;
import flex.messaging.config.*;
import flex.messaging.log.Log;
import flex.messaging.log.Logger;
import flex.messaging.messages.Message;
import flex.messaging.messages.RemotingMessage;
import flex.messaging.services.Service;
import flex.messaging.services.ServiceAdapter;
import flex.messaging.services.remoting.RemotingDestination;
import flex.messaging.util.*;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.security.AccessController;
import java.util.List;

public class JavaAdapter extends ServiceAdapter
{

    public JavaAdapter()
    {
    }

    public void setService(Service service)
    {
        super.setService(service);
        PropertiesSettings properties = service.getSettings();
        properties(properties);
    }

    public void setSettings(Destination destination, AdapterSettings adapterSettings, DestinationSettings destinationSettings)
    {
        super.setSettings(destination, adapterSettings, destinationSettings);
        PropertiesSettings properties = adapterSettings;
        properties(properties);
        properties = destinationSettings;
        properties(properties);
    }

    public void initialize()
    {
        validateInstanceSettings();
    }

    protected void properties(PropertiesSettings propertiesSettings)
    {
        ConfigMap properties = propertiesSettings.getProperties();
        if(properties == null || properties.size() == 0)
            return;
        else
            return;
    }

    public Object invoke(Message message)
    {
        RemotingDestination remotingDestination = (RemotingDestination)destination;
        RemotingMessage remotingMessage = (RemotingMessage)message;
        FactoryInstance factoryInstance = remotingDestination.getFactoryInstance();
        String className = factoryInstance.getSource();
        remotingMessage.setSource(className);
        String methodName = remotingMessage.getOperation();
        List parameters = remotingMessage.getParameters();
        Object result = null;
        try
        {
            Object instance = createInstance(factoryInstance.getInstanceClass());
            if(instance == null)
            {
                MessageException me = new MessageException("Null instance returned from: " + factoryInstance);
                me.setCode("Server.Processing");
                throw me;
            }
            Class c = instance.getClass();
            MethodMatcher methodMatcher = remotingDestination.getMethodMatcher();
            Method method = methodMatcher.getMethod(c, methodName, parameters);
            result = method.invoke(instance, parameters.toArray());
            saveInstance(instance);
        }
        catch(InvocationTargetException ex)
        {
            Throwable cause = ex.getCause();
            if(cause != null && (cause instanceof MessageException))
                throw (MessageException)cause;
            if(cause != null)
            {
                if(Log.isError())
                    Log.getLogger("Message.Remoting").error("Error processing remote invocation: " + cause.toString() + StringUtils.NEWLINE + "  incomingMessage: " + message + StringUtils.NEWLINE + ExceptionUtil.toString(cause));
                MessageException me = new MessageException(cause.getClass().getName() + " : " + cause.getMessage());
                me.setCode("Server.Processing");
                me.setRootCause(cause);
                throw me;
            } else
            {
                MessageException me = new MessageException(ex.getMessage());
                me.setCode("Server.Processing");
                throw me;
            }
        }
        catch(IllegalAccessException ex)
        {
            MessageException me = new MessageException(ex.getMessage());
            me.setCode("Server.Processing");
            throw me;
        }
        return result;
    }

    protected Object createInstance(Class cl)
    {
        RemotingDestination remotingDestination = (RemotingDestination)destination;
        FactoryInstance factoryInstance = remotingDestination.getFactoryInstance();
        Object instance = factoryInstance.lookup();
        return instance;
    }

    protected void saveInstance(Object instance)
    {
        RemotingDestination remotingDestination = (RemotingDestination)destination;
        FactoryInstance factoryInstance = remotingDestination.getFactoryInstance();
        factoryInstance.operationComplete(instance);
    }

    protected void assertAccess(String serviceClass)
    {
        SecurityManager sm = System.getSecurityManager();
        if(sm != null)
        {
            if(serviceClass.indexOf(".") != -1)
            {
                StringBuffer permissionData = new StringBuffer("accessClassInPackage.");
                permissionData.append(serviceClass.substring(0, serviceClass.lastIndexOf(".")));
                RuntimePermission perm = new RuntimePermission(permissionData.toString());
                AccessController.checkPermission(perm);
            }
        } else
        {
            for(int i = 0; i < PROTECTED_PACKAGES.length; i++)
                if(serviceClass.startsWith(PROTECTED_PACKAGES[i]))
                {
                    StringBuffer permissionData = new StringBuffer("accessClassInPackage.");
                    permissionData.append(PROTECTED_PACKAGES[i].substring(0, PROTECTED_PACKAGES[i].length()));
                    RuntimePermission perm = new RuntimePermission(permissionData.toString());
                    AccessController.checkPermission(perm);
                }

        }
    }

    protected void validateInstanceSettings()
    {
        RemotingDestination remotingDestination = (RemotingDestination)destination;
        remotingDestination.getFactoryInstance();
    }

    public void setupAdapterControl(Destination destination)
    {
        controller = new JavaAdapterControl(getId(), this, destination.getControl());
        controller.register();
        setControl(controller);
    }

    private JavaAdapterControl controller;
    static final String LOG_CATEGORY = "Message.Remoting";
    public static final String PROTECTED_PACKAGES[] = {
        "jrun", "jrunx", "macromedia", "flex", "flex2", "coldfusion", "allaire", "com.allaire", "com.macromedia"
    };

}
