// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Base64.java

package flex.messaging.util;

import java.io.PrintStream;

public class Base64
{
    public static class Encoder
    {

        private void encodeBlock()
        {
            output.append(Base64.alphabet[(work[0] & 0xff) >> 2]);
            output.append(Base64.alphabet[(work[0] & 3) << 4 | (work[1] & 0xf0) >> 4]);
            if(count > 1)
                output.append(Base64.alphabet[(work[1] & 0xf) << 2 | (work[2] & 0xc0) >> 6]);
            else
                output.append('=');
            if(count > 2)
                output.append(Base64.alphabet[work[2] & 0x3f]);
            else
                output.append('=');
            if((line += 4) == 76)
            {
                output.append('\n');
                line = 0;
            }
        }

        public void encode(byte data[])
        {
            encode(data, 0, data.length);
        }

        public void encode(byte data[], int offset, int length)
        {
            for(int plainIndex = offset; plainIndex < offset + length; plainIndex++)
            {
                work[count] = data[plainIndex];
                count++;
                if(count == work.length || (offset + length) - plainIndex == 1)
                {
                    encodeBlock();
                    count = 0;
                    work[0] = 0;
                    work[1] = 0;
                    work[2] = 0;
                }
            }

        }

        public String drain()
        {
            String r = output.toString();
            output.setLength(0);
            return r;
        }

        public String flush()
        {
            if(count > 0)
                encodeBlock();
            String r = drain();
            count = 0;
            line = 0;
            work[0] = 0;
            work[1] = 0;
            work[2] = 0;
            return r;
        }

        private int work[] = {
            0, 0, 0
        };
        private int count;
        private int line;
        private StringBuffer output;

        public Encoder(int size)
        {
            count = 0;
            line = 0;
            output = new StringBuffer(size);
        }
    }

    public static class Decoder
    {

        public void decode(String encoded)
        {
            int estimate = 1 + (encoded.length() * 3) / 4;
            if(filled + estimate > data.length)
            {
                int length;
                for(length = data.length * 2; length < filled + estimate; length *= 2);
                byte newdata[] = new byte[length];
                System.arraycopy(data, 0, newdata, 0, filled);
                data = newdata;
            }
            for(int i = 0; i < encoded.length(); i++)
            {
                char c = encoded.charAt(i);
                if(c == '=')
                {
                    work[count++] = -1;
                } else
                {
                    if(Base64.inverse[c] == 64)
                        continue;
                    work[count++] = Base64.inverse[c];
                }
                if(count != 4)
                    continue;
                count = 0;
                data[filled++] = (byte)(work[0] << 2 | (work[1] & 0xff) >> 4);
                if(work[2] == -1)
                    break;
                data[filled++] = (byte)(work[1] << 4 | (work[2] & 0xff) >> 2);
                if(work[3] == -1)
                    break;
                data[filled++] = (byte)(work[2] << 6 | work[3]);
            }

        }

        public byte[] drain()
        {
            byte r[] = new byte[filled];
            System.arraycopy(data, 0, r, 0, filled);
            filled = 0;
            return r;
        }

        public byte[] flush()
            throws IllegalStateException
        {
            if(count > 0)
                throw new IllegalStateException("a partial block (" + count + " of 4 bytes) was dropped, decoded data is probably truncated!");
            else
                return drain();
        }

        public void reset()
        {
            count = 0;
            filled = 0;
        }

        private int filled;
        private byte data[];
        private int count;
        private int work[] = {
            0, 0, 0, 0
        };

        public Decoder()
        {
            filled = 0;
            count = 0;
            data = new byte[256];
        }
    }


    public Base64()
    {
    }

    public static void main(String args[])
    {
        boolean printData = false;
        int randomLimit = 500;
        byte raw[] = new byte[(int)(Math.random() * (double)randomLimit)];
        for(int i = 0; i < raw.length; i++)
            if(i % 1024 < 256)
                raw[i] = (byte)(i % 1024);
            else
                raw[i] = (byte)((int)(Math.random() * 255D) - 128);

        Encoder encoder = new Encoder(100);
        encoder.encode(raw);
        String encoded = encoder.drain();
        Decoder decoder = new Decoder();
        decoder.decode(encoded);
        byte check[] = decoder.flush();
        String mesg = "Success!";
        if(check.length != raw.length)
        {
            mesg = "***** length mismatch!";
        } else
        {
            int i = 0;
            do
            {
                if(i >= check.length)
                    break;
                if(check[i] != raw[i])
                {
                    mesg = "***** data mismatch!";
                    break;
                }
                i++;
            } while(true);
        }
        System.out.println(mesg);
        if(printData)
        {
            System.out.println("Decoded: " + new String(raw));
            System.out.println("Encoded: " + encoded);
            System.out.println("Decoded: " + new String(check));
        }
    }

    private static final char alphabet[] = {
        'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 
        'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 
        'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 
        'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 
        'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 
        'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', 
        '8', '9', '+', '/'
    };
    private static final int inverse[] = {
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 62, 64, 64, 64, 63, 52, 53, 
        54, 55, 56, 57, 58, 59, 60, 61, 64, 64, 
        64, 64, 64, 64, 64, 0, 1, 2, 3, 4, 
        5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 
        15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 
        25, 64, 64, 64, 64, 64, 64, 26, 27, 28, 
        29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 
        39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 
        49, 50, 51, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 
        64, 64, 64, 64, 64, 64
    };



}
