// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ExceptionUtil.java

package flex.messaging.util;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.NoSuchElementException;
import java.util.StringTokenizer;

public class ExceptionUtil
{

    public ExceptionUtil()
    {
    }

    public static Throwable wrappedException(Throwable t)
    {
        if(t instanceof InvocationTargetException)
            return ((InvocationTargetException)t).getTargetException();
        else
            return getRootCauseWithReflection(t);
    }

    public static Throwable baseException(Throwable t)
    {
        Throwable wrapped = wrappedException(t);
        if(wrapped != null)
            return baseException(wrapped);
        else
            return t;
    }

    public static String toString(Throwable t)
    {
        StringWriter strWrt = new StringWriter();
        t.printStackTrace(new PrintWriter(strWrt));
        return strWrt.toString();
    }

    public static String getStackTraceUpTo(Throwable t, String prefix)
    {
        StringTokenizer tokens = new StringTokenizer(toString(t), "\n\r");
        StringBuffer trace = new StringBuffer();
        boolean done = false;
        String lookingFor = "at " + prefix;
        for(; !done && tokens.hasMoreElements(); trace.append("\n"))
        {
            String token = tokens.nextToken();
            if(token.indexOf(lookingFor) == -1)
                trace.append(token);
            else
                done = true;
        }

        return trace.toString();
    }

    public static String getStackTraceLines(Throwable t, int numLines)
    {
        StringTokenizer tokens = new StringTokenizer(toString(t), "\n\r");
        StringBuffer trace = new StringBuffer();
        for(int i = 0; i < numLines; i++)
        {
            String token = tokens.nextToken();
            trace.append(token);
            trace.append("\n");
        }

        return trace.toString();
    }

    public static String getCallAt(Throwable t, int nth)
    {
        StringTokenizer tokens = new StringTokenizer(toString(t), "\n\r");
        try
        {
            for(int i = 0; i <= nth; i++)
                tokens.nextToken();

            String token = tokens.nextToken();
            int index1 = token.indexOf(' ');
            int index2 = token.indexOf('(');
            StringBuffer call = new StringBuffer();
            call.append(token.substring(index1 >= 0 ? index1 + 1 : 0, index2 >= 0 ? index2 : call.length()));
            int index3 = token.indexOf(':', index2 >= 0 ? index2 : 0);
            if(index3 >= 0)
            {
                int index4 = token.indexOf(')', index3);
                call.append(token.substring(index3, index4 >= 0 ? index4 : token.length()));
            }
            return call.toString();
        }
        catch(NoSuchElementException e)
        {
            return "unknown";
        }
    }

    public static String exceptionToString(Throwable t)
    {
        StringWriter sw = new StringWriter();
        PrintWriter out = new PrintWriter(sw);
        printExceptionStack(t, out, 0);
        return sw.toString();
    }

    protected static void printExceptionStack(Throwable th, PrintWriter out, int depth)
    {
        boolean printStackDepth = depth > 0;
        Throwable wrappedException = wrappedException(th);
        if(wrappedException != null)
        {
            printStackDepth = true;
            printExceptionStack(wrappedException, out, depth + 1);
        }
        if(printStackDepth)
            out.write("[" + depth + "]");
        th.printStackTrace(out);
    }

    private static Throwable getRootCauseWithReflection(Throwable t)
    {
        for(int i = 0; i < unwrapMethods.length;)
        {
            Method m = null;
            try
            {
                m = t.getClass().getMethod(unwrapMethods[i], null);
                return (Throwable)m.invoke(t, null);
            }
            catch(Exception nsme)
            {
                i++;
            }
        }

        return null;
    }

    public static String unwrapMethods[] = {
        "getRootCause", "getTargetException", "getTargetError", "getException", "getCausedByException", "getLinkedException"
    };

}
