// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Hex.java

package flex.messaging.util;

import java.io.PrintStream;

public class Hex
{
    public static class Encoder
    {

        private void encodeBlock(byte work)
        {
            output.append(Hex.digits[(work & 0xf0) >>> 4]);
            output.append(Hex.digits[work & 0xf]);
        }

        public void encode(byte data[])
        {
            encode(data, 0, data.length);
        }

        public void encode(byte data[], int offset, int length)
        {
            for(int plainIndex = offset; plainIndex < offset + length; plainIndex++)
                encodeBlock(data[plainIndex]);

        }

        public String drain()
        {
            String r = output.toString();
            output.setLength(0);
            return r;
        }

        public String flush()
        {
            return drain();
        }

        private StringBuffer output;

        public Encoder(int size)
        {
            output = new StringBuffer(size * 2);
        }
    }

    public static class Decoder
    {

        public void decode(String encoded)
        {
            int estimate = 1 + encoded.length() / 2;
            if(filled + estimate > data.length)
            {
                int length;
                for(length = data.length * 2; length < filled + estimate; length *= 2);
                byte newdata[] = new byte[length];
                System.arraycopy(data, 0, newdata, 0, filled);
                data = newdata;
            }
            for(int i = 0; i < encoded.length(); i++)
            {
                work[0] = Character.digit(encoded.charAt(i), 16);
                i++;
                work[1] = Character.digit(encoded.charAt(i), 16);
                data[filled++] = (byte)((work[0] << 4 | work[1]) & 0xff);
            }

        }

        public byte[] drain()
        {
            byte r[] = new byte[filled];
            System.arraycopy(data, 0, r, 0, filled);
            filled = 0;
            return r;
        }

        public byte[] flush()
            throws IllegalStateException
        {
            return drain();
        }

        public void reset()
        {
            filled = 0;
        }

        private int filled;
        private byte data[];
        private int work[] = {
            0, 0
        };

        public Decoder()
        {
            filled = 0;
            data = new byte[256];
        }
    }


    public Hex()
    {
    }

    public static void main(String args[])
    {
        boolean printData = false;
        int randomLimit = 500;
        for(int myCount = 0; myCount < 10000; myCount++)
        {
            byte raw[] = new byte[(int)(Math.random() * (double)randomLimit)];
            for(int i = 0; i < raw.length; i++)
                if(i % 1024 < 256)
                    raw[i] = (byte)(i % 1024);
                else
                    raw[i] = (byte)((int)(Math.random() * 255D) - 128);

            Encoder encoder = new Encoder(100);
            encoder.encode(raw);
            String encoded = encoder.drain();
            Decoder decoder = new Decoder();
            decoder.decode(encoded);
            byte check[] = decoder.flush();
            String mesg = "Success!";
            if(check.length != raw.length)
            {
                mesg = "***** length mismatch!";
            } else
            {
                int i = 0;
                do
                {
                    if(i >= check.length)
                        break;
                    if(check[i] != raw[i])
                    {
                        mesg = "***** data mismatch!";
                        break;
                    }
                    i++;
                } while(true);
            }
            if(mesg.indexOf("Success") == -1)
            {
                System.out.println(mesg + myCount);
                break;
            }
            if(printData)
            {
                System.out.println("Decoded: " + new String(raw));
                System.out.println("Encoded: " + encoded);
                System.out.println("Decoded: " + new String(check));
            }
        }

    }

    private static final char digits[] = {
        '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
        'A', 'B', 'C', 'D', 'E', 'F'
    };


}
