// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MethodMatcher.java

package flex.messaging.util;

import flex.messaging.MessageException;
import flex.messaging.io.TypeMarshaller;
import flex.messaging.io.TypeMarshallingContext;
import java.lang.reflect.Method;
import java.util.*;

// Referenced classes of package flex.messaging.util:
//            MethodKey

public class MethodMatcher
{
    public static class Match
    {

        public boolean matchedExactlyByName()
        {
            if(matchedMethodName != null)
                return matchedMethodName.equals(methodName);
            else
                return false;
        }

        public boolean matchedLooselyByName()
        {
            if(matchedMethodName != null)
                return !matchedExactlyByName() && matchedMethodName.equalsIgnoreCase(methodName);
            else
                return false;
        }

        public String listExpectedTypes()
        {
            return listTypes(methodParamTypes);
        }

        public String listConvertedTypes()
        {
            return listTypes(convertedSuppliedTypes);
        }

        public String listTypes(Class types[])
        {
            if(types != null && types.length > 0)
            {
                StringBuffer sb = new StringBuffer();
                for(int i = 0; i < types.length; i++)
                {
                    if(i > 0)
                        sb.append(", ");
                    Class c = types[i];
                    if(c != null)
                    {
                        if(c.isArray())
                        {
                            c = c.getComponentType();
                            sb.append(c.getName()).append("[]");
                        } else
                        {
                            sb.append(c.getName());
                        }
                    } else
                    {
                        sb.append("null");
                    }
                }

                return sb.toString();
            } else
            {
                return null;
            }
        }

        final String methodName;
        String matchedMethodName;
        boolean matchedByNumberOfParams;
        int matchedParamCount;
        Class methodParamTypes[];
        Class convertedSuppliedTypes[];
        Exception paramTypeConversionFailure;

        public Match(String name)
        {
            methodName = name;
        }
    }


    public MethodMatcher()
    {
    }

    public Method getMethod(Class c, String methodName, List parameters)
    {
        Method method = null;
        Match bestMatch = new Match(methodName);
        Class suppliedParamTypes[] = paramTypes(parameters);
        MethodKey methodKey = new MethodKey(c, methodName, suppliedParamTypes);
        if(methodCache.containsKey(methodKey))
        {
            method = (Method)methodCache.get(methodKey);
            String thisMethodName = method.getName();
            bestMatch.matchedMethodName = thisMethodName;
            Class desiredParamTypes[] = method.getParameterTypes();
            bestMatch.methodParamTypes = desiredParamTypes;
            convertParams(parameters, desiredParamTypes, bestMatch);
        } else
        {
            Method methods[] = c.getMethods();
            for(int i = 0; i < methods.length; i++)
            {
                Method thisMethod = methods[i];
                String thisMethodName = thisMethod.getName();
                if(!thisMethodName.equalsIgnoreCase(methodName))
                    continue;
                Match currentMatch = new Match(methodName);
                currentMatch.matchedMethodName = thisMethodName;
                if(bestMatch.matchedMethodName == null)
                    bestMatch = currentMatch;
                Class desiredParamTypes[] = thisMethod.getParameterTypes();
                currentMatch.methodParamTypes = desiredParamTypes;
                if(desiredParamTypes.length != suppliedParamTypes.length)
                    continue;
                currentMatch.matchedByNumberOfParams = true;
                if(!bestMatch.matchedByNumberOfParams && bestMatch.matchedParamCount == 0)
                    bestMatch = currentMatch;
                convertParams(parameters, desiredParamTypes, currentMatch);
                if(currentMatch.matchedParamCount >= bestMatch.matchedParamCount)
                    bestMatch = currentMatch;
                if(currentMatch.matchedParamCount != desiredParamTypes.length)
                    continue;
                method = thisMethod;
                bestMatch = currentMatch;
                synchronized(methodCache)
                {
                    Method method2 = (Method)methodCache.get(methodKey);
                    if(method2 == null)
                        methodCache.put(methodKey, method);
                    else
                        method = method2;
                }
                break;
            }

        }
        if(method == null)
            methodNotFound(methodName, suppliedParamTypes, bestMatch);
        else
        if(bestMatch.paramTypeConversionFailure != null)
        {
            MessageException me = new MessageException();
            me.setMessage(10006);
            me.setCode("Server.Processing");
            me.setRootCause(bestMatch.paramTypeConversionFailure);
            throw me;
        }
        return method;
    }

    public static void convertParams(List parameters, Class desiredParamTypes[], Match currentMatch)
    {
        int matchCount = 0;
        currentMatch.matchedParamCount = 0;
        currentMatch.convertedSuppliedTypes = new Class[desiredParamTypes.length];
        TypeMarshaller marshaller = TypeMarshallingContext.getTypeMarshaller();
        for(int i = 0; i < desiredParamTypes.length; i++)
        {
            Object param = parameters.get(i);
            if(param != null)
            {
                Object obj = null;
                if(marshaller != null)
                    try
                    {
                        obj = marshaller.convert(param, desiredParamTypes[i]);
                    }
                    catch(MessageException ex)
                    {
                        currentMatch.paramTypeConversionFailure = ex;
                        break;
                    }
                else
                    obj = param;
                currentMatch.convertedSuppliedTypes[i] = obj == null ? null : obj.getClass();
                if(!desiredParamTypes[i].isAssignableFrom(obj.getClass()) && (desiredParamTypes[i] != Integer.TYPE || !(java.lang.Integer.class).isAssignableFrom(obj.getClass())) && (desiredParamTypes[i] != Double.TYPE || !(java.lang.Double.class).isAssignableFrom(obj.getClass())) && (desiredParamTypes[i] != Long.TYPE || !(java.lang.Long.class).isAssignableFrom(obj.getClass())) && (desiredParamTypes[i] != Boolean.TYPE || !(java.lang.Boolean.class).isAssignableFrom(obj.getClass())) && (desiredParamTypes[i] != Character.TYPE || !(java.lang.Character.class).isAssignableFrom(obj.getClass())) && (desiredParamTypes[i] != Float.TYPE || !(java.lang.Float.class).isAssignableFrom(obj.getClass())) && (desiredParamTypes[i] != Short.TYPE || !(java.lang.Short.class).isAssignableFrom(obj.getClass())) && (desiredParamTypes[i] != Byte.TYPE || !(java.lang.Byte.class).isAssignableFrom(obj.getClass())))
                    break;
                parameters.set(i, obj);
                matchCount++;
            } else
            {
                matchCount++;
            }
        }

        currentMatch.matchedParamCount = matchCount;
    }

    public static Class[] paramTypes(List parameters)
    {
        Class paramTypes[] = new Class[parameters.size()];
        for(int i = 0; i < paramTypes.length; i++)
        {
            Object p = parameters.get(i);
            paramTypes[i] = p != null ? p.getClass() : java.lang.Object.class;
        }

        return paramTypes;
    }

    public static void methodNotFound(String methodName, Class suppliedParamTypes[], Match bestMatch)
    {
        int errorCode = 10007;
        Object errorParams[] = {
            methodName
        };
        String errorDetailVariant = "0";
        Object errorDetailParams[] = {
            methodName
        };
        if(bestMatch.matchedMethodName != null)
        {
            errorCode = 10007;
            errorParams = (new Object[] {
                bestMatch.matchedMethodName
            });
            int suppliedParamCount = suppliedParamTypes.length;
            int expectedParamCount = bestMatch.methodParamTypes == null ? 0 : bestMatch.methodParamTypes.length;
            if(suppliedParamCount != expectedParamCount)
            {
                errorDetailVariant = "1";
                errorDetailParams = (new Object[] {
                    new Integer(suppliedParamCount), new Integer(expectedParamCount)
                });
            } else
            {
                String suppliedTypes = bestMatch.listTypes(suppliedParamTypes);
                String convertedTypes = bestMatch.listConvertedTypes();
                String expectedTypes = bestMatch.listExpectedTypes();
                if(expectedTypes != null)
                {
                    if(suppliedTypes != null)
                    {
                        if(convertedTypes != null)
                        {
                            errorDetailVariant = "2";
                            errorDetailParams = (new Object[] {
                                expectedTypes, suppliedTypes, convertedTypes
                            });
                        } else
                        {
                            errorDetailVariant = "3";
                            errorDetailParams = (new Object[] {
                                expectedTypes, suppliedTypes
                            });
                        }
                    } else
                    {
                        errorDetailVariant = "4";
                        errorDetailParams = (new Object[] {
                            expectedTypes
                        });
                    }
                } else
                {
                    errorDetailVariant = "5";
                    errorDetailParams = (new Object[] {
                        suppliedTypes
                    });
                }
            }
        }
        MessageException ex = new MessageException();
        ex.setMessage(errorCode, errorParams);
        ex.setCode("Server.ResourceUnavailable");
        if(errorDetailVariant != null)
            ex.setDetails(errorCode, errorDetailVariant, errorDetailParams);
        if(bestMatch.paramTypeConversionFailure != null)
            ex.setRootCause(bestMatch.paramTypeConversionFailure);
        throw ex;
    }

    private final Map methodCache = new HashMap();
    private static final int ARGUMENT_CONVERSION_ERROR = 10006;
    private static final int CANNOT_INVOKE_METHOD = 10007;
}
