// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ChannelSettings.java

package flex.messaging.config;

import flex.messaging.util.StringUtils;

// Referenced classes of package flex.messaging.config:
//            PropertiesSettings, SecurityConstraint

public class ChannelSettings extends PropertiesSettings
{

    public ChannelSettings(String id)
    {
        this.id = id;
    }

    public String getClientType()
    {
        return clientType;
    }

    public void setClientType(String type)
    {
        clientType = type;
    }

    public String getId()
    {
        return id;
    }

    String getSourceFile()
    {
        return sourceFile;
    }

    void setSourceFile(String sourceFile)
    {
        this.sourceFile = sourceFile;
    }

    public int getPort()
    {
        return port;
    }

    public String getUri()
    {
        return uri;
    }

    public void setUri(String uri)
    {
        this.uri = uri;
        port = parsePort(uri);
        contextParsed = false;
        clientContextParsed = false;
    }

    public String getParsedUri(String contextPath)
    {
        if(!contextParsed)
            parseUri(this, contextPath);
        return parsedUri;
    }

    public String getClientParsedUri(String contextPath)
    {
        if(!clientContextParsed)
            parseClientUri(this, contextPath);
        return parsedClientUri;
    }

    public String getEndpointType()
    {
        return endpointType;
    }

    public void setEndpointType(String type)
    {
        endpointType = type;
    }

    public SecurityConstraint getConstraint()
    {
        return constraint;
    }

    public void setConstraint(SecurityConstraint constraint)
    {
        this.constraint = constraint;
    }

    private static void parseUri(ChannelSettings cs, String contextPath)
    {
        if(!cs.contextParsed)
        {
            String channelEndpoint = cs.getUri().toLowerCase().trim();
            if(channelEndpoint.startsWith("http://") || channelEndpoint.startsWith("https://"))
            {
                int nextSlash = channelEndpoint.indexOf('/', 8);
                if(nextSlash > 0)
                    channelEndpoint = channelEndpoint.substring(nextSlash);
            }
            channelEndpoint = StringUtils.substitute(channelEndpoint, "{context-root}", "{context.root}");
            if(channelEndpoint.startsWith("{context.root}"))
                channelEndpoint = channelEndpoint.substring("{context.root}".length());
            else
            if(channelEndpoint.startsWith("/{context.root}"))
                channelEndpoint = channelEndpoint.substring("/{context.root}".length());
            else
            if(contextPath.length() > 0 && channelEndpoint.startsWith(contextPath.toLowerCase()))
                channelEndpoint = channelEndpoint.substring(contextPath.length());
            if(channelEndpoint.endsWith("/"))
                channelEndpoint = channelEndpoint.substring(0, channelEndpoint.length() - 1);
            cs.parsedUri = channelEndpoint;
            cs.contextParsed = true;
        }
    }

    private static void parseClientUri(ChannelSettings cs, String contextPath)
    {
        if(!cs.clientContextParsed)
        {
            if(contextPath == null)
                contextPath = "";
            String channelEndpoint = cs.getUri().trim();
            channelEndpoint = StringUtils.substitute(channelEndpoint, "{context-root}", "{context.root}");
            if(channelEndpoint.indexOf("/{context.root}") != -1)
            {
                if("/".equals(contextPath) && !"/{context.root}".equals(channelEndpoint))
                    contextPath = "";
                channelEndpoint = StringUtils.substitute(channelEndpoint, "/{context.root}", contextPath);
            } else
            {
                if("/".equals(contextPath) && !"{context.root}".equals(channelEndpoint))
                    contextPath = "";
                channelEndpoint = StringUtils.substitute(channelEndpoint, "{context.root}", contextPath);
            }
            cs.parsedClientUri = channelEndpoint;
            cs.clientContextParsed = true;
        }
    }

    private static int parsePort(String url)
    {
        int port = 0;
        int start = url.indexOf(":/");
        if(start > 0)
        {
            start += 3;
            int end = url.indexOf('/', start);
            String snp = end != -1 ? url.substring(start, end) : url.substring(start);
            int colon = snp.indexOf(':');
            if(colon > 0)
                try
                {
                    int p = Integer.parseInt(snp.substring(colon + 1));
                    if(p > 0)
                        port = p;
                }
                catch(Throwable t) { }
        }
        return port;
    }

    protected String id;
    private String sourceFile;
    protected SecurityConstraint constraint;
    protected String uri;
    protected int port;
    protected String endpointType;
    protected String clientType;
    protected String parsedUri;
    protected boolean contextParsed;
    protected String parsedClientUri;
    protected boolean clientContextParsed;
}
