// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ClientConfigurationParser.java

package flex.messaging.config;

import java.util.*;
import org.w3c.dom.*;

// Referenced classes of package flex.messaging.config:
//            AbstractConfigurationParser, ChannelSettings, ConfigurationException, LocalFileResolver, 
//            ClientConfiguration, ServiceSettings, DestinationSettings, ServicesConfiguration, 
//            ConfigurationFileResolver

public abstract class ClientConfigurationParser extends AbstractConfigurationParser
{

    public ClientConfigurationParser()
    {
    }

    protected void parseTopLevelConfig(Document doc)
    {
        Node root = selectSingleNode(doc, "/services-config");
        if(root != null)
        {
            allowedChildElements(root, SERVICES_CONFIG_CHILDREN);
            channelsSection(root);
            services(root);
        }
    }

    private void channelsSection(Node root)
    {
        Node channelsNode = selectSingleNode(root, "channels");
        if(channelsNode != null)
        {
            allowedAttributesOrElements(channelsNode, CHANNELS_CHILDREN);
            NodeList channels = selectNodeList(channelsNode, "channel-definition");
            for(int i = 0; i < channels.getLength(); i++)
            {
                Node channel = channels.item(i);
                channelDefinition(channel);
            }

        }
    }

    private void channelDefinition(Node channel)
    {
        requiredAttributesOrElements(channel, CHANNEL_DEFINITION_REQ_CHILDREN);
        allowedAttributesOrElements(channel, CHANNEL_DEFINITION_CHILDREN);
        String id = getAttributeOrChildElement(channel, "id").toString().trim();
        if(isValidID(id))
        {
            ChannelSettings channelSettings = new ChannelSettings(id);
            String clientType = getAttributeOrChildElement(channel, "class");
            channelSettings.setClientType(clientType);
            Node endpoint = selectSingleNode(channel, "endpoint");
            if(endpoint != null)
            {
                allowedAttributesOrElements(endpoint, ENDPOINT_REQ_CHILDREN);
                String uri = getAttributeOrChildElement(endpoint, "uri");
                channelSettings.setUri(uri);
                config.addChannelSettings(id, channelSettings);
            }
            NodeList properties = selectNodeList(channel, "properties/polling-enabled");
            if(properties.getLength() > 0)
            {
                ConfigMap map = properties(properties);
                channelSettings.addProperties(map);
            }
            properties = selectNodeList(channel, "properties/polling-interval-seconds");
            if(properties.getLength() > 0)
            {
                ConfigMap map = properties(properties);
                channelSettings.addProperties(map);
            }
            properties = selectNodeList(channel, "properties/connect-timeout-seconds");
            if(properties.getLength() > 0)
            {
                ConfigMap map = properties(properties);
                channelSettings.addProperties(map);
            }
        } else
        {
            ConfigurationException ex = new ConfigurationException();
            ex.setMessage(10110, new Object[] {
                "channel-definition", id
            });
            String details = "An id must be non-empty and not contain any list delimiter characters, i.e. commas, semi-colons or colons.";
            ex.setDetails(details);
            throw ex;
        }
    }

    private void services(Node root)
    {
        Node servicesNode = selectSingleNode(root, "services");
        if(servicesNode != null)
        {
            allowedChildElements(servicesNode, SERVICES_CHILDREN);
            NodeList services = selectNodeList(servicesNode, "service-include");
            for(int i = 0; i < services.getLength(); i++)
            {
                Node service = services.item(i);
                serviceInclude(service);
            }

            services = selectNodeList(servicesNode, "service");
            for(int i = 0; i < services.getLength(); i++)
            {
                Node service = services.item(i);
                service(service);
            }

        }
    }

    private void serviceInclude(Node serviceInclude)
    {
        requiredAttributesOrElements(serviceInclude, SERVICE_INCLUDE_CHILDREN);
        String src = getAttributeOrChildElement(serviceInclude, "file-path");
        if(src.length() > 0)
        {
            Document doc = loadDocument(src, fileResolver.getIncludedFile(src));
            if(fileResolver instanceof LocalFileResolver)
            {
                LocalFileResolver local = (LocalFileResolver)fileResolver;
                ((ClientConfiguration)config).addConfigPath(local.getIncludedPath(src), local.getIncludedLastModified(src));
            }
            doc.getDocumentElement().normalize();
            Node service = selectSingleNode(doc, "/service");
            if(service != null)
            {
                service(service);
                fileResolver.popIncludedFile();
            } else
            {
                ConfigurationException ex = new ConfigurationException();
                ex.setMessage(10112, new Object[] {
                    "service"
                });
                throw ex;
            }
        }
    }

    private void service(Node service)
    {
        requiredAttributesOrElements(service, SERVICE_REQ_CHILDREN);
        allowedAttributesOrElements(service, SERVICE_CHILDREN);
        String id = getAttributeOrChildElement(service, "id");
        if(isValidID(id))
        {
            ServiceSettings serviceSettings = config.getServiceSettings(id);
            if(serviceSettings == null)
            {
                serviceSettings = new ServiceSettings(id);
                config.addServiceSettings(serviceSettings);
            } else
            {
                ConfigurationException e = new ConfigurationException();
                e.setMessage(10113, new Object[] {
                    id
                });
                throw e;
            }
            String messageTypesList = getAttributeOrChildElement(service, "messageTypes");
            if(messageTypesList.length() > 0)
            {
                StringTokenizer tokenizer = new StringTokenizer(messageTypesList, ",;:");
                do
                {
                    if(!tokenizer.hasMoreTokens())
                        break;
                    String messageType = tokenizer.nextToken().trim();
                    if(messageType.length() > 0)
                        serviceSettings.addMessageType(messageType);
                } while(true);
            } else
            {
                ConfigurationException ex = new ConfigurationException();
                ex.setMessage(10115, new Object[] {
                    "service", id
                });
                throw ex;
            }
            Node defaultChannels = selectSingleNode(service, "default-channels");
            if(defaultChannels != null)
            {
                allowedChildElements(defaultChannels, DEFAULT_CHANNELS_CHILDREN);
                NodeList channels = selectNodeList(defaultChannels, "channel");
                for(int c = 0; c < channels.getLength(); c++)
                {
                    Node chan = channels.item(c);
                    defaultChannel(chan, serviceSettings);
                }

            }
            NodeList list = selectNodeList(service, "destination");
            for(int i = 0; i < list.getLength(); i++)
            {
                Node dest = list.item(i);
                destination(dest, serviceSettings);
            }

            list = selectNodeList(service, "destination-include");
            for(int i = 0; i < list.getLength(); i++)
            {
                Node dest = list.item(i);
                destinationInclude(dest, serviceSettings);
            }

        } else
        {
            ConfigurationException ex = new ConfigurationException();
            ex.setMessage(10110, new Object[] {
                "service", id
            });
            throw ex;
        }
    }

    private void defaultChannel(Node chan, ServiceSettings serviceSettings)
    {
        String ref = getAttributeOrChildElement(chan, "ref").toString().trim();
        if(ref.length() > 0)
        {
            ChannelSettings channel = config.getChannelSettings(ref);
            if(channel != null)
            {
                serviceSettings.addDefaultChannel(channel);
            } else
            {
                ConfigurationException e = new ConfigurationException();
                e.setMessage(10109, new Object[] {
                    "channel", ref
                });
                throw e;
            }
        } else
        {
            ConfigurationException ex = new ConfigurationException();
            ex.setMessage(10116, new Object[] {
                serviceSettings.getId()
            });
            throw ex;
        }
    }

    private void destinationInclude(Node destInclude, ServiceSettings serviceSettings)
    {
        requiredAttributesOrElements(destInclude, DESTINATION_INCLUDE_CHILDREN);
        String src = getAttributeOrChildElement(destInclude, "file-path");
        if(src.length() > 0)
        {
            Document doc = loadDocument(src, fileResolver.getIncludedFile(src));
            if(fileResolver instanceof LocalFileResolver)
            {
                LocalFileResolver local = (LocalFileResolver)fileResolver;
                ((ClientConfiguration)config).addConfigPath(local.getIncludedPath(src), local.getIncludedLastModified(src));
            }
            doc.getDocumentElement().normalize();
            Node dest = selectSingleNode(doc, "/destination");
            if(dest != null)
            {
                destination(dest, serviceSettings);
                fileResolver.popIncludedFile();
            } else
            {
                ConfigurationException ex = new ConfigurationException();
                ex.setMessage(10118, new Object[] {
                    "destination"
                });
                throw ex;
            }
        }
    }

    private void destination(Node dest, ServiceSettings serviceSettings)
    {
        requiredAttributesOrElements(dest, DESTINATION_REQ_CHILDREN);
        allowedAttributes(dest, DESTINATION_ATTR);
        allowedChildElements(dest, DESTINATION_CHILDREN);
        String serviceId = serviceSettings.getId();
        DestinationSettings destinationSettings = null;
        String id = getAttributeOrChildElement(dest, "id");
        if(isValidID(id))
        {
            destinationSettings = (DestinationSettings)serviceSettings.getDestinationSettings().get(id);
            if(destinationSettings != null)
            {
                ConfigurationException e = new ConfigurationException();
                e.setMessage(10122, new Object[] {
                    id, serviceId
                });
                throw e;
            }
            destinationSettings = new DestinationSettings(id);
            serviceSettings.addDestinationSettings(destinationSettings);
        } else
        {
            ConfigurationException ex = new ConfigurationException();
            ex.setMessage(10119, new Object[] {
                "destination", id, serviceId
            });
            throw ex;
        }
        NodeList properties = selectNodeList(dest, "properties/*");
        if(properties.getLength() > 0)
        {
            ConfigMap map = properties(properties);
            destinationSettings.addProperties(map);
        }
        destinationChannels(dest, destinationSettings, serviceSettings);
    }

    private void destinationChannels(Node dest, DestinationSettings destinationSettings, ServiceSettings serviceSettings)
    {
        String destId = destinationSettings.getId();
        String channelsList = evaluateExpression(dest, "@channels").toString().trim();
        if(channelsList.length() > 0)
        {
            for(StringTokenizer st = new StringTokenizer(channelsList, ",;:"); st.hasMoreTokens();)
            {
                String ref = st.nextToken();
                ChannelSettings channel = config.getChannelSettings(ref);
                if(channel != null)
                {
                    destinationSettings.addChannelSettings(channel);
                } else
                {
                    ConfigurationException ex = new ConfigurationException();
                    ex.setMessage(10120, new Object[] {
                        "channel", ref, destId
                    });
                    throw ex;
                }
            }

        } else
        {
            Node channelsNode = selectSingleNode(dest, "channels");
            if(channelsNode != null)
            {
                allowedChildElements(channelsNode, DESTINATION_CHANNELS_CHILDREN);
                NodeList channels = selectNodeList(channelsNode, "channel");
                if(channels.getLength() > 0)
                {
                    for(int c = 0; c < channels.getLength(); c++)
                    {
                        Node chan = channels.item(c);
                        requiredAttributesOrElements(chan, DESTINATION_CHANNEL_REQ_CHILDREN);
                        String ref = getAttributeOrChildElement(chan, "ref").toString().trim();
                        if(ref.length() > 0)
                        {
                            ChannelSettings channel = config.getChannelSettings(ref);
                            if(channel != null)
                            {
                                destinationSettings.addChannelSettings(channel);
                            } else
                            {
                                ConfigurationException ex = new ConfigurationException();
                                ex.setMessage(10120, new Object[] {
                                    "channel", ref, destId
                                });
                                throw ex;
                            }
                        } else
                        {
                            ConfigurationException ex = new ConfigurationException();
                            ex.setMessage(10121, new Object[] {
                                "channel", ref, destId
                            });
                            throw ex;
                        }
                    }

                }
            } else
            {
                List defaultChannels = serviceSettings.getDefaultChannels();
                ChannelSettings channel;
                for(Iterator it = defaultChannels.iterator(); it.hasNext(); destinationSettings.addChannelSettings(channel))
                    channel = (ChannelSettings)it.next();

            }
        }
        if(destinationSettings.getChannelSettings().size() <= 0)
        {
            ConfigurationException ex = new ConfigurationException();
            ex.setMessage(10123, new Object[] {
                destId
            });
            throw ex;
        } else
        {
            return;
        }
    }
}
