// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ConfigMap.java

package flex.messaging.config;

import java.util.*;

// Referenced classes of package flex.messaging.config:
//            ConfigurationException

public class ConfigMap extends HashMap
{
    private static class ValueList extends ArrayList
    {

        private ValueList()
        {
        }

    }


    public ConfigMap()
    {
        accessedKeys = new HashSet();
    }

    public ConfigMap(int initialCapacity)
    {
        super(initialCapacity);
        accessedKeys = new HashSet();
    }

    public ConfigMap(ConfigMap m)
    {
        this();
        addProperties(m);
    }

    public void addProperties(ConfigMap p)
    {
        for(Iterator it = p.entrySet().iterator(); it.hasNext();)
        {
            java.util.Map.Entry entry = (java.util.Map.Entry)it.next();
            Object key = entry.getKey();
            Object value = entry.getValue();
            if(value instanceof ValueList)
                addProperties(key, (ValueList)value);
            else
                addPropertyLogic(key, value);
        }

    }

    private void addProperties(Object key, ValueList values)
    {
        ValueList list = getValueList(key);
        if(list == null)
            put(key, values.clone());
        else
            list.addAll(values);
    }

    private void addPropertyLogic(Object key, Object value)
    {
        ValueList list = getValueList(key);
        if(list == null)
            put(key, value);
        else
            list.add(value);
    }

    private ValueList getValueList(Object key)
    {
        Object old = super.get(key);
        ValueList list;
        if(old instanceof ValueList)
            list = (ValueList)old;
        else
        if(old != null)
        {
            list = new ValueList();
            list.add(old);
            put(key, list);
        } else
        {
            list = null;
        }
        return list;
    }

    public void addProperty(String name, String value)
    {
        addPropertyLogic(name, value);
    }

    public void addProperty(String name, ConfigMap value)
    {
        addPropertyLogic(name, value);
    }

    public Set propertyNames()
    {
        return keySet();
    }

    public void allowProperty(String name)
    {
        accessedKeys.add(name);
    }

    public Object get(Object name)
    {
        accessedKeys.add(name);
        return super.get(name);
    }

    private Object getSinglePropertyOrFail(Object name)
    {
        Object result = get(name);
        if(result instanceof ValueList)
        {
            ConfigurationException exception = new ConfigurationException();
            exception.setMessage(10169, new Object[] {
                name
            });
            throw exception;
        } else
        {
            return result;
        }
    }

    public String getProperty(String name)
    {
        return getPropertyAsString(name, null);
    }

    public ConfigMap getPropertyAsMap(String name, ConfigMap defaultValue)
    {
        Object prop = getSinglePropertyOrFail(name);
        if(prop instanceof ConfigMap)
            return (ConfigMap)prop;
        else
            return defaultValue;
    }

    public String getPropertyAsString(String name, String defaultValue)
    {
        Object prop = getSinglePropertyOrFail(name);
        if(prop instanceof String)
            return (String)prop;
        else
            return defaultValue;
    }

    public List getPropertyAsList(String name, List defaultValue)
    {
        Object prop = get(name);
        if(prop != null)
        {
            if(prop instanceof List)
            {
                return (List)prop;
            } else
            {
                List list = new ArrayList();
                list.add(prop);
                return list;
            }
        } else
        {
            return defaultValue;
        }
    }

    public boolean getPropertyAsBoolean(String name, boolean defaultValue)
    {
        Object prop = getSinglePropertyOrFail(name);
        if(prop instanceof String)
            return Boolean.valueOf((String)prop).booleanValue();
        else
            return defaultValue;
    }

    public int getPropertyAsInt(String name, int defaultValue)
    {
        Object prop = getSinglePropertyOrFail(name);
        if(prop instanceof String)
            try
            {
                return Integer.parseInt((String)prop);
            }
            catch(NumberFormatException ex) { }
        return defaultValue;
    }

    public long getPropertyAsLong(String name, long defaultValue)
    {
        Object prop = getSinglePropertyOrFail(name);
        if(prop instanceof String)
            try
            {
                return Long.parseLong((String)prop);
            }
            catch(NumberFormatException ex) { }
        return defaultValue;
    }

    public List findAllUnusedProperties()
    {
        List result = new ArrayList();
        findUnusedProperties("", true, result);
        return result;
    }

    public void findUnusedProperties(String parentPath, boolean recurse, Collection result)
    {
label0:
        do
        {
            java.util.Map.Entry entry;
            String currentPath;
label1:
            do
            {
                for(Iterator itr = entrySet().iterator(); itr.hasNext(); result.add(currentPath))
                {
                    entry = (java.util.Map.Entry)itr.next();
                    Object key = entry.getKey();
                    currentPath = parentPath + '/' + String.valueOf(key);
                    if(accessedKeys.contains(key))
                        continue label1;
                }

                break label0;
            } while(!recurse);
            Object value = entry.getValue();
            List values = (value instanceof List) ? (List)value : Collections.singletonList(value);
            int i = 0;
            while(i < values.size()) 
            {
                Object child = values.get(i);
                if(child instanceof ConfigMap)
                    ((ConfigMap)child).findUnusedProperties(currentPath, recurse, result);
                i++;
            }
        } while(true);
    }

    private static final long serialVersionUID = 0x10f5177eL;
    private static final int UNEXPECTED_MULTIPLE_VALUES = 10169;
    private HashSet accessedKeys;
}
