// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ServicesDependencies.java

package flex.messaging.config;

import flex.messaging.LocalizedException;
import java.io.File;
import java.io.PrintStream;
import java.util.*;

// Referenced classes of package flex.messaging.config:
//            ClientConfiguration, LocalFileResolver, ConfigurationParser, ChannelSettings, 
//            ServiceSettings, DestinationSettings, ConfigMap, ServicesConfiguration

public class ServicesDependencies
{

    public ServicesDependencies(String path, String parserClass, String contextRoot)
    {
        xmlInit = "";
        imports = new StringBuffer();
        references = new StringBuffer();
        ClientConfiguration config = getClientConfiguration(path, parserClass);
        if(config != null)
        {
            Map importMap = new HashMap();
            lazyAssociations = new HashMap();
            configPaths = config.getConfigPaths();
            xmlInit = codegenXmlInit(config, contextRoot, importMap);
            codegenServiceImportsAndReferences(importMap, imports, references);
            channelClasses = listChannelClasses(config);
        }
    }

    public Set getLazyAssociations(String destination)
    {
        if(lazyAssociations == null)
            lazyAssociations = new HashMap();
        return (Set)lazyAssociations.get(destination);
    }

    public void addLazyAssociation(String destination, String associationProp)
    {
        Set la = getLazyAssociations(destination);
        if(la == null)
        {
            la = new HashSet();
            lazyAssociations.put(destination, la);
        }
        la.add(associationProp);
    }

    public String getServerConfigXmlInit()
    {
        return xmlInit;
    }

    public String getImports()
    {
        return imports.toString();
    }

    public String getReferences()
    {
        return references.toString();
    }

    public List getChannelClasses()
    {
        return channelClasses;
    }

    public void addChannelClass(String className)
    {
        channelClasses.add(className);
    }

    public void addConfigPath(String path, long modified)
    {
        configPaths.put(path, new Long(modified));
    }

    public Map getConfigPaths()
    {
        return configPaths;
    }

    public static ClientConfiguration getClientConfiguration(String path, String parserClass)
    {
        ClientConfiguration config = new ClientConfiguration();
        ConfigurationParser parser = getConfigurationParser(parserClass);
        if(parser == null)
        {
            LocalizedException lme = new LocalizedException();
            lme.setMessage(10138);
            throw lme;
        } else
        {
            LocalFileResolver local = new LocalFileResolver();
            parser.parse(path, local, config);
            config.addConfigPath(path, (new File(path)).lastModified());
            return config;
        }
    }

    static ConfigurationParser getConfigurationParser(String className)
    {
        ConfigurationParser parser = null;
        Class parserClass = null;
        if(className != null)
            try
            {
                parserClass = Class.forName(className);
                parser = (ConfigurationParser)parserClass.newInstance();
            }
            catch(Throwable t)
            {
                if(traceConfig)
                    System.out.println("Could not load services configuration parser as: " + className);
            }
        if(parser == null)
            try
            {
                className = "flex.messaging.config.XPathClientConfigurationParser";
                parserClass = Class.forName(className);
                Class.forName("javax.xml.xpath.XPathExpressionException");
                parser = (ConfigurationParser)parserClass.newInstance();
            }
            catch(Throwable t)
            {
                if(traceConfig)
                    System.out.println("Could not load configuration parser as: " + className);
            }
        if(parser == null)
            try
            {
                className = "flex.messaging.config.ApacheXPathClientConfigurationParser";
                parserClass = Class.forName(className);
                parser = (ConfigurationParser)parserClass.newInstance();
            }
            catch(Throwable t)
            {
                if(traceConfig)
                    System.out.println("Could not load configuration parser as: " + className);
            }
        if(traceConfig && parser != null)
            System.out.println("Services Configuration Parser: " + parser.getClass().getName());
        return parser;
    }

    private static List listChannelClasses(ServicesConfiguration config)
    {
        List channelList = new ArrayList();
        String clientType;
        for(Iterator it = config.getAllChannelSettings().values().iterator(); it.hasNext(); channelList.add(clientType))
        {
            ChannelSettings settings = (ChannelSettings)it.next();
            clientType = settings.getClientType();
        }

        return channelList;
    }

    private String codegenXmlInit(ServicesConfiguration config, String contextRoot, Map serviceImportMap)
    {
        StringBuffer e4x = new StringBuffer();
        e4x.append("<services>\n");
        String serviceType;
        for(Iterator servIter = config.getAllServiceSettings().entrySet().iterator(); servIter.hasNext(); e4x.append("\t</" + serviceType + ">\n"))
        {
            java.util.Map.Entry entry = (java.util.Map.Entry)servIter.next();
            serviceType = (String)entry.getKey();
            e4x.append("\t<" + serviceType);
            String messageTypes = ((ServiceSettings)entry.getValue()).getMessageTypesString();
            if(messageTypes != null)
            {
                e4x.append(" messageTypes=\"");
                e4x.append(messageTypes);
                e4x.append("\"");
            }
            e4x.append(">\n");
            for(Iterator destIter = ((ServiceSettings)entry.getValue()).getDestinationSettings().values().iterator(); destIter.hasNext(); e4x.append("\t\t</destination>\n"))
            {
                DestinationSettings dest = (DestinationSettings)destIter.next();
                String destination = dest.getId();
                e4x.append("\t\t<destination id=\"" + destination + "\">\n");
                ConfigMap metadata = dest.getProperties().getPropertyAsMap("metadata", null);
                boolean closePropTag = false;
                if(metadata != null)
                {
                    e4x.append("\t\t\t<properties>\n\t\t\t\t<metadata>\n");
                    closePropTag = true;
                    List identities = metadata.getPropertyAsList("identity", null);
                    if(identities != null)
                    {
                        Iterator it = identities.iterator();
                        do
                        {
                            if(!it.hasNext())
                                break;
                            Object o = it.next();
                            String identityName = null;
                            if(o instanceof String)
                                identityName = (String)o;
                            else
                            if(o instanceof ConfigMap)
                                identityName = ((ConfigMap)o).getPropertyAsString("property", null);
                            if(identityName != null)
                            {
                                e4x.append("\t\t\t\t\t<identity property=\"");
                                e4x.append(identityName);
                                e4x.append("\"/>\n");
                            }
                        } while(true);
                    }
                    codegenServiceAssociations(metadata, e4x, destination, "one-to-many");
                    codegenServiceAssociations(metadata, e4x, destination, "many-to-many");
                    codegenServiceAssociations(metadata, e4x, destination, "one-to-one");
                    codegenServiceAssociations(metadata, e4x, destination, "many-to-one");
                    e4x.append("\t\t\t\t</metadata>\n");
                }
                ConfigMap network = dest.getProperties().getPropertyAsMap("network", null);
                ConfigMap clusterInfo = null;
                ConfigMap pagingInfo = null;
                ConfigMap reconnectInfo = null;
                if(network != null)
                {
                    if(metadata == null)
                    {
                        e4x.append("\t\t\t<properties>\n");
                        closePropTag = true;
                    }
                    e4x.append("\t\t\t\t<network>\n");
                    pagingInfo = network.getPropertyAsMap("paging", null);
                    if(pagingInfo != null)
                    {
                        String enabled = pagingInfo.getPropertyAsString("enabled", "false");
                        e4x.append("\t\t\t\t\t<paging enabled=\"");
                        e4x.append(enabled);
                        e4x.append("\"");
                        String size = pagingInfo.getPropertyAsString("pageSize", null);
                        if(size != null)
                        {
                            e4x.append(" pageSize=\"");
                            e4x.append(size);
                            e4x.append("\"");
                        }
                        e4x.append("/>\n");
                    }
                    reconnectInfo = network.getPropertyAsMap("reconnect", null);
                    if(reconnectInfo != null)
                    {
                        String fetchOption = reconnectInfo.getPropertyAsString("fetch", "IDENTITY");
                        e4x.append("\t\t\t\t\t<reconnect fetch=\"");
                        e4x.append(fetchOption.toUpperCase());
                        e4x.append("\" onlyIfChanged=\"");
                        String onlyIfChanged = reconnectInfo.getPropertyAsString("onlyIfChanged", "false");
                        e4x.append(onlyIfChanged);
                        e4x.append("\" />\n");
                    }
                    clusterInfo = network.getPropertyAsMap("cluster", null);
                    if(clusterInfo != null)
                    {
                        String clusterId = clusterInfo.getPropertyAsString("ref", null);
                        e4x.append("\t\t\t\t\t<cluster ref=\"");
                        e4x.append(clusterId);
                        e4x.append("\"/>\n");
                    }
                    e4x.append("\t\t\t\t</network>\n");
                }
                String useTransactions = dest.getProperties().getPropertyAsString("use-transactions", "true");
                if(useTransactions.equalsIgnoreCase("false"))
                {
                    if(!closePropTag)
                    {
                        e4x.append("\t\t\t<properties>\n");
                        closePropTag = true;
                    }
                    e4x.append("\t\t\t\t<use-transactions>false</use-transactions>\n");
                }
                String autoSyncEnabled = dest.getProperties().getPropertyAsString("auto-sync-enabled", "true");
                if(autoSyncEnabled.equalsIgnoreCase("false"))
                {
                    if(!closePropTag)
                    {
                        e4x.append("\t\t\t<properties>\n");
                        closePropTag = true;
                    }
                    e4x.append("\t\t\t\t<auto-sync-enabled>false</auto-sync-enabled>\n");
                }
                if(closePropTag)
                    e4x.append("\t\t\t</properties>\n");
                e4x.append("\t\t\t<channels>\n");
                for(Iterator chanIter = dest.getChannelSettings().iterator(); chanIter.hasNext(); e4x.append("\t\t\t\t<channel ref=\"" + ((ChannelSettings)chanIter.next()).getId() + "\"/>\n"));
                e4x.append("\t\t\t</channels>\n");
            }

        }

        e4x.append("\t<channels>\n");
        for(Iterator chanIter = config.getAllChannelSettings().values().iterator(); chanIter.hasNext(); e4x.append("\t\t</channel>\n"))
        {
            ChannelSettings chan = (ChannelSettings)chanIter.next();
            String channelType = chan.getClientType();
            serviceImportMap.put(channelType, channelType);
            e4x.append("\t\t<channel id=\"" + chan.getId() + "\" type=\"" + channelType + "\">\n");
            e4x.append("\t\t\t<endpoint uri=\"" + chan.getClientParsedUri(contextRoot) + "\"/>\n");
            e4x.append("\t\t\t<properties>\n");
            Iterator nameIter = chan.getProperties().propertyNames().iterator();
            do
            {
                if(!nameIter.hasNext())
                    break;
                String name = (String)nameIter.next();
                if(!channel_excludes.contains(name))
                    e4x.append("\t\t\t\t<" + name + ">" + chan.getProperty(name) + "</" + name + ">\n");
            } while(true);
            e4x.append("\t\t\t</properties>\n");
        }

        e4x.append("\t</channels>\n");
        e4x.append("</services>");
        return "\nServerConfig.xml =\n" + e4x.toString() + ";\n";
    }

    public void codegenServiceAssociations(ConfigMap metadata, StringBuffer e4x, String destination, String relation)
    {
        List references = metadata.getPropertyAsList(relation, null);
        if(references != null)
        {
            Iterator it = references.iterator();
            do
            {
                if(!it.hasNext())
                    break;
                Object ref = it.next();
                if(ref instanceof ConfigMap)
                {
                    ConfigMap refMap = (ConfigMap)ref;
                    String name = refMap.getPropertyAsString("property", null);
                    String associatedDestination = refMap.getPropertyAsString("destination", null);
                    String lazy = refMap.getPropertyAsString("lazy", null);
                    e4x.append("\t\t\t\t\t<");
                    e4x.append(relation);
                    if(lazy != null)
                    {
                        e4x.append(" lazy=\"");
                        e4x.append(lazy);
                        e4x.append("\"");
                        if(Boolean.valueOf(lazy.toLowerCase().trim()).booleanValue())
                            addLazyAssociation(destination, name);
                    }
                    e4x.append(" property=\"");
                    e4x.append(name);
                    e4x.append("\" destination=\"");
                    e4x.append(associatedDestination);
                    e4x.append("\"/>\n");
                }
            } while(true);
        }
    }

    public static void codegenServiceImportsAndReferences(Map map, StringBuffer imports, StringBuffer references)
    {
        imports.append("import mx.messaging.config.ServerConfig;\n");
        references.append("   // static references for configured channels\n");
        String type;
        for(Iterator chanIter = map.values().iterator(); chanIter.hasNext(); references.append(type.substring(type.lastIndexOf(".") + 1) + ";\n"))
        {
            type = (String)chanIter.next();
            imports.append("import ");
            imports.append(type);
            imports.append(";\n");
            references.append("   private static var ");
            references.append(type.replace('.', '_'));
            references.append("_ref:");
        }

    }

    private String xmlInit;
    private StringBuffer imports;
    private StringBuffer references;
    private List channelClasses;
    private Map configPaths;
    private Map lazyAssociations;
    private static final List channel_excludes;
    public static final boolean traceConfig = System.getProperty("trace.config") != null;

    static 
    {
        channel_excludes = new ArrayList();
        channel_excludes.add("redirect-url");
    }
}
