// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AbstractTarget.java

package flex.messaging.log;

import flex.messaging.LocalizedException;
import flex.messaging.config.TargetSettings;
import flex.messaging.util.UUIDUtils;
import java.util.ArrayList;
import java.util.List;

// Referenced classes of package flex.messaging.log:
//            Target, Log, Logger

public abstract class AbstractTarget
    implements Target
{

    public AbstractTarget(TargetSettings settings)
    {
        id = UUIDUtils.createUUID(false);
        filters = settings.getFilters();
        if(filters == null)
        {
            filters = new ArrayList();
            filters.add("*");
        } else
        if(filters.size() == 0)
            filters.add("*");
        level = Log.readLevel(settings.getLevel());
    }

    public void addLogger(Logger logger)
    {
        if(logger != null)
        {
            loggerCount++;
            logger.addTarget(this);
        }
    }

    public void removeLogger(Logger logger)
    {
        if(logger != null)
        {
            loggerCount--;
            logger.removeTarget(this);
        }
    }

    public List getFilters()
    {
        return filters;
    }

    public short getLevel()
    {
        return level;
    }

    public void setFilters(List value)
    {
        if(value != null && value.size() > 0)
        {
            for(int i = 0; i < value.size(); i++)
            {
                String filter = (String)value.get(i);
                if(Log.hasIllegalCharacters(filter))
                {
                    LocalizedException ex = new LocalizedException();
                    ex.setMessage(10016, new Object[] {
                        filter, "[]~$^&\\/(){}<>+=`!#%?,:;'\"@"
                    });
                    throw ex;
                }
                int index = filter.indexOf("*");
                if(index >= 0 && index != filter.length() - 1)
                {
                    LocalizedException ex = new LocalizedException();
                    ex.setMessage(10017, new Object[] {
                        filter
                    });
                    throw ex;
                }
            }

        } else
        {
            value = new ArrayList();
            value.add("*");
        }
        if(loggerCount > 0)
        {
            Log.removeTarget(this);
            filters = value;
            Log.addTarget(this);
        } else
        {
            filters = value;
        }
    }

    public void setLevel(short value)
    {
        Log.removeTarget(this);
        level = value;
        Log.addTarget(this);
    }

    private static final int INVALID_FILTER_CHARS = 10016;
    private static final int INVALID_FILTER_STAR = 10017;
    protected String id;
    protected List filters;
    protected short level;
    protected int loggerCount;
}
