// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Log.java

package flex.messaging.log;

import flex.messaging.LocalizedException;
import flex.messaging.config.ConfigMap;
import flex.messaging.util.BasicPrettyPrinter;
import flex.messaging.util.PrettyPrinter;
import java.util.*;

// Referenced classes of package flex.messaging.log:
//            Logger, Target

public class Log
{

    private Log()
    {
        targetLevel = 2000;
        loggers = new HashMap();
        targets = new ArrayList();
    }

    public static synchronized Log createLog()
    {
        if(log == null)
            log = new Log();
        return log;
    }

    public static void init(ConfigMap properties)
    {
        String prettyPrinterClass = properties.getPropertyAsString("pretty-printer", null);
        if(prettyPrinterClass != null)
            try
            {
                Class c = Class.forName(prettyPrinterClass);
                prettyPrinter = (PrettyPrinter)c.newInstance();
            }
            catch(Throwable t) { }
    }

    static short getTargetLevel()
    {
        return log != null ? log.targetLevel : 2000;
    }

    public static short readLevel(String l)
    {
        short lvl = 8;
        if(l != null && l.length() > 0)
        {
            l = l.trim().toLowerCase();
            char c = l.charAt(0);
            switch(c)
            {
            case 110: // 'n'
                lvl = 2000;
                break;

            case 101: // 'e'
                lvl = 8;
                break;

            case 119: // 'w'
                lvl = 6;
                break;

            case 105: // 'i'
                lvl = 4;
                break;

            case 100: // 'd'
                lvl = 2;
                break;

            case 97: // 'a'
                lvl = 0;
                break;

            default:
                lvl = 8;
                break;
            }
        }
        return lvl;
    }

    public static boolean isFatal()
    {
        return log != null ? log.targetLevel <= 1000 : false;
    }

    public static boolean isError()
    {
        return log != null ? log.targetLevel <= 8 : false;
    }

    public static boolean isWarn()
    {
        return log != null ? log.targetLevel <= 6 : false;
    }

    public static boolean isInfo()
    {
        return log != null ? log.targetLevel <= 4 : false;
    }

    public static boolean isDebug()
    {
        return log != null ? log.targetLevel <= 2 : false;
    }

    public static PrettyPrinter getPrettyPrinter()
    {
        if(prettyPrinter == null)
            prettyPrinter = new BasicPrettyPrinter();
        return (PrettyPrinter)prettyPrinter.clone();
    }

    public static void addTarget(Target target)
    {
        if(log != null)
            if(target != null)
            {
                List filters = target.getFilters();
                Iterator it = log.loggers.keySet().iterator();
                do
                {
                    if(!it.hasNext())
                        break;
                    String key = (String)it.next();
                    if(categoryMatchInFilterList(key, filters))
                        target.addLogger((Logger)log.loggers.get(key));
                } while(true);
                log.targets.add(target);
                short targetLevel = target.getLevel();
                if(log.targetLevel == 2000)
                    log.targetLevel = targetLevel;
                else
                if(targetLevel < log.targetLevel)
                    log.targetLevel = targetLevel;
            } else
            {
                LocalizedException ex = new LocalizedException();
                ex.setMessage(10013);
                throw ex;
            }
    }

    public static void removeTarget(Target target)
    {
        if(log != null)
            if(target != null)
            {
                List filters = target.getFilters();
                Iterator it = log.loggers.keySet().iterator();
                do
                {
                    if(!it.hasNext())
                        break;
                    String key = (String)it.next();
                    if(categoryMatchInFilterList(key, filters))
                        target.removeLogger((Logger)log.loggers.get(key));
                } while(true);
                log.targets.remove(target);
                resetTargetLevel();
            } else
            {
                LocalizedException ex = new LocalizedException();
                ex.setMessage(10013);
                throw ex;
            }
    }

    public static Logger getLogger(String category)
    {
        if(log != null)
            return getLogger(log, category);
        else
            return new Logger(category);
    }

    public static Logger getLogger(Log log, String category)
    {
        checkCategory(category);
        Logger result = (Logger)log.loggers.get(category);
        if(result == null)
        {
            result = new Logger(category);
            log.loggers.put(category, result);
            for(int i = 0; i < log.targets.size(); i++)
            {
                Target target = (Target)log.targets.get(i);
                if(categoryMatchInFilterList(category, target.getFilters()))
                    target.addLogger(result);
            }

        }
        return result;
    }

    private static boolean categoryMatchInFilterList(String category, List filters)
    {
        int index = -1;
        for(int i = 0; i < filters.size(); i++)
        {
            String filter = (String)filters.get(i);
            index = filter.indexOf("*");
            if(index == 0)
                return true;
            if(index < 0)
            {
                if(category.equals(filter))
                    return true;
                continue;
            }
            if(category.length() >= index && category.substring(0, index).equals(filter.substring(0, index)))
                return true;
        }

        return false;
    }

    private static void checkCategory(String category)
    {
        if(category == null || category.length() == 0)
        {
            LocalizedException ex = new LocalizedException();
            ex.setMessage(10014);
            throw ex;
        }
        if(hasIllegalCharacters(category) || category.indexOf("*") != -1)
        {
            LocalizedException ex = new LocalizedException();
            ex.setMessage(10015, new Object[] {
                "[]~$^&\\/(){}<>+=`!#%?,:;'\"@"
            });
            throw ex;
        } else
        {
            return;
        }
    }

    private static void resetTargetLevel()
    {
        if(log != null)
        {
            short maxTargetLevel = 2000;
            for(int i = 0; i < log.targets.size(); i++)
            {
                short targetLevel = ((Target)log.targets.get(i)).getLevel();
                if(maxTargetLevel == 2000 || targetLevel < maxTargetLevel)
                    maxTargetLevel = targetLevel;
            }

            log.targetLevel = maxTargetLevel;
        }
    }

    public static boolean hasIllegalCharacters(String value)
    {
        char chars[] = value.toCharArray();
        for(int i = 0; i < chars.length; i++)
        {
            char c = chars[i];
            if("[]~$^&\\/(){}<>+=`!#%?,:;'\"@".indexOf(c) != -1)
                return true;
        }

        return false;
    }

    public static void flush()
    {
        if(log != null)
        {
            log.loggers.clear();
            log.targets.clear();
            log.targetLevel = 2000;
        }
    }

    public static final String INVALID_CHARS = "[]~$^&\\/(){}<>+=`!#%?,:;'\"@";
    private static final int INVALID_TARGET = 10013;
    private static final int INVALID_CATEGORY = 10014;
    private static final int INVALID_CATEGORY_CHARS = 10015;
    private static Log log;
    private short targetLevel;
    private Map loggers;
    private List targets;
    private static PrettyPrinter prettyPrinter;
}
