// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Logger.java

package flex.messaging.log;

import flex.messaging.util.PrettyPrinter;
import flex.messaging.util.StringUtils;
import java.util.ArrayList;
import java.util.List;

// Referenced classes of package flex.messaging.log:
//            LogEvent, Target, Log

public class Logger
{

    public Logger(String category)
    {
        this.category = category;
        targets = new ArrayList();
    }

    public String getCategory()
    {
        return category;
    }

    public void setCategory(String category)
    {
        this.category = category;
    }

    void addTarget(Target target)
    {
        if(!targets.contains(target))
            targets.add(target);
    }

    void removeTarget(Target target)
    {
        targets.remove(target);
    }

    public void debug(String message)
    {
        log((short)2, message, null, null);
    }

    public void debug(String message, Throwable t)
    {
        log((short)2, message, null, t);
    }

    public void debug(String message, Object parameters[])
    {
        log((short)2, message, parameters, null);
    }

    public void debug(String message, Object parameters[], Throwable t)
    {
        log((short)2, message, parameters, t);
    }

    public void info(String message)
    {
        log((short)4, message, null, null);
    }

    public void info(String message, Throwable t)
    {
        log((short)4, message, null, t);
    }

    public void info(String message, Object parameters[])
    {
        log((short)4, message, parameters, null);
    }

    public void info(String message, Object parameters[], Throwable t)
    {
        log((short)4, message, parameters, t);
    }

    public void warn(String message)
    {
        log((short)6, message, null, null);
    }

    public void warn(String message, Throwable t)
    {
        log((short)6, message, null, t);
    }

    public void warn(String message, Object parameters[])
    {
        log((short)6, message, parameters, null);
    }

    public void warn(String message, Object parameters[], Throwable t)
    {
        log((short)6, message, parameters, t);
    }

    public void error(String message)
    {
        log((short)8, message, null, null);
    }

    public void error(String message, Throwable t)
    {
        log((short)8, message, null, t);
    }

    public void error(String message, Object parameters[])
    {
        log((short)8, message, parameters, null);
    }

    public void error(String message, Object parameters[], Throwable t)
    {
        log((short)8, message, parameters, t);
    }

    public void fatal(String message)
    {
        log((short)1000, message, null, null);
    }

    public void fatal(String message, Throwable t)
    {
        log((short)1000, message, null, t);
    }

    public void fatal(String message, Object parameters[])
    {
        log((short)1000, message, parameters, null);
    }

    public void fatal(String message, Object parameters[], Throwable t)
    {
        log((short)1000, message, parameters, t);
    }

    public void log(short level, String message, Object parameters[], Throwable t)
    {
        log(level, message, parameters, t, true);
    }

    public void log(short level, String message, Object parameters[], Throwable t, boolean verifyLevel)
    {
        if(targets.size() > 0 && (!verifyLevel || level >= Log.getTargetLevel()))
        {
            if(parameters != null)
            {
                PrettyPrinter prettyPrinter = Log.getPrettyPrinter();
                for(int i = 0; i < parameters.length; i++)
                {
                    String replacement = parameters[i] == null ? "null" : prettyPrinter.prettify(parameters[i]);
                    message = StringUtils.substitute(message, "{" + i + "}", replacement);
                }

            }
            LogEvent event = new LogEvent(this, message, level, t);
            for(int i = 0; i < targets.size(); i++)
            {
                Target tgt = (Target)targets.get(i);
                if(!verifyLevel || level >= tgt.getLevel())
                    tgt.logEvent(event);
            }

        }
    }

    private String category;
    private List targets;
}
