// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   StringUtils.java

package flex.messaging.util;

import java.io.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

public class StringUtils
{

    public StringUtils()
    {
    }

    public static String substitute(String str, String from, String to)
    {
        if(from == null || from.equals("") || to == null)
            return str;
        int index = str.indexOf(from);
        if(index == -1)
            return str;
        StringBuffer buf = new StringBuffer(str.length());
        int lastIndex = 0;
        for(; index != -1; index = str.indexOf(from, lastIndex))
        {
            buf.append(str.substring(lastIndex, index));
            buf.append(to);
            lastIndex = index + from.length();
        }

        buf.append(str.substring(lastIndex));
        return buf.toString();
    }

    public static boolean findMatchWithWildcard(char src[], char pat[])
    {
        if(src == null || pat == null)
            return false;
        if(pat.length == 0)
            return false;
        if(src.length == 0)
            return pat.length == 0 || pat.length == 1 && (pat[0] == '*' || pat[0] == '?');
        boolean star = false;
        int srcLen = src.length;
        int patLen = pat.length;
        int srcIdx = 0;
        int patIdx = 0;
        for(; srcIdx < srcLen; srcIdx++)
        {
            if(patIdx == patLen)
                if(patLen < srcLen - srcIdx)
                    patIdx = 0;
                else
                    return false;
            char s = src[srcIdx];
            char m = pat[patIdx];
            switch(m)
            {
            case 42: // '*'
                if(patIdx == pat.length - 1)
                    return true;
                star = true;
                patIdx++;
                break;

            case 63: // '?'
                patIdx++;
                break;

            default:
                if(s != m)
                {
                    if(star)
                        break;
                    if(patLen < srcLen - srcIdx)
                        patIdx = 0;
                    else
                        return false;
                } else
                {
                    star = false;
                    patIdx++;
                }
                break;
            }
        }

        if(patIdx < patLen)
        {
            for(; patIdx < patLen; patLen++)
                if(pat[patIdx] != '*')
                    return false;

            return true;
        } else
        {
            return !star;
        }
    }

    public static String prettifyXML(String xml)
    {
        String result = xml;
        try
        {
            StringReader reader = new StringReader(xml);
            StringWriter writer = new StringWriter();
            Transformer transformer = TransformerFactory.newInstance().newTransformer();
            transformer.setOutputProperty("method", "xml");
            transformer.setOutputProperty("indent", "yes");
            transformer.transform(new StreamSource(reader), new StreamResult(writer));
            writer.close();
            result = writer.toString();
        }
        catch(TransformerFactoryConfigurationError error) { }
        catch(TransformerException error) { }
        catch(IOException error) { }
        return result;
    }

    public static String prettifyString(String string)
    {
        String result = string;
        if(string.startsWith("<?xml"))
            result = prettifyXML(string);
        return result;
    }

    public static boolean isEmpty(String string)
    {
        return string == null || string.length() == 0;
    }

    public static final String NEWLINE = System.getProperty("line.separator");

}
