// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   UUIDUtils.java

package flex.messaging.util;

import java.security.SecureRandom;

public class UUIDUtils
{

    private static native long getHostID();

    private UUIDUtils()
    {
    }

    public static String createUUID(boolean useBackwardCompatibleFormat)
    {
        StringBuffer s = new StringBuffer(36);
        appendHexString(uniqueTOD(), false, 11, s);
        if(hostid != null)
            s.append(hostid);
        else
            s.append("0123456789ABCDEF".charAt(_rand.nextInt(16) | 8));
        appendRandomHexChars(32 - s.length(), s);
        s.insert(8, "-");
        s.insert(13, "-");
        s.insert(18, "-");
        if(!useBackwardCompatibleFormat)
            s.insert(23, "-");
        return s.toString();
    }

    private static void appendRandomHexChars(int n, StringBuffer result)
    {
        int bitsPerDigit = 4;
        int bitsPerInt = 32;
        int digitsPerInt = bitsPerInt / bitsPerDigit;
        while(n > 0) 
        {
            int digitsToUse = Math.min(n, digitsPerInt);
            n -= digitsToUse;
            appendHexString(_rand.nextInt(), true, digitsToUse, result);
        }
    }

    private static void appendHexString(long value, boolean prependZeroes, int nLeastSignificantDigits, StringBuffer result)
    {
        int bitsPerDigit = 4;
        long mask = (1L << bitsPerDigit) - 1L;
        value &= (1L << bitsPerDigit * nLeastSignificantDigits) - 1L;
        int i = 0;
        long reorderedValue = 0L;
        if(value == 0L)
            i++;
        else
            do
            {
                reorderedValue = reorderedValue << bitsPerDigit | value & mask;
                value >>>= bitsPerDigit;
                i++;
            } while(value != 0L);
        if(prependZeroes)
        {
            for(int j = nLeastSignificantDigits - i; j > 0; j--)
                result.append('0');

        }
        for(; i > 0; i--)
        {
            result.append("0123456789ABCDEF".charAt((int)(reorderedValue & mask)));
            reorderedValue >>>= bitsPerDigit;
        }

    }

    private static synchronized long uniqueTOD()
    {
        long currentTOD = System.currentTimeMillis();
        if(currentTOD < lastUsedTOD)
            lastUsedTOD = currentTOD;
        if(currentTOD == lastUsedTOD)
        {
            numIdsThisMilli++;
            if(numIdsThisMilli >= 10000)
            {
                for(; currentTOD == lastUsedTOD; currentTOD = System.currentTimeMillis())
                    try
                    {
                        Thread.sleep(1L);
                    }
                    catch(Exception interrupt) { }

                lastUsedTOD = currentTOD;
                numIdsThisMilli = 0;
            }
        } else
        {
            lastUsedTOD = currentTOD;
            numIdsThisMilli = 0;
        }
        return lastUsedTOD * 10000L + (long)numIdsThisMilli;
    }

    private static SecureRandom _rand = new SecureRandom();
    private static final int MAX_IDS_PER_MILLI = 10000;
    private static long lastUsedTOD = 0L;
    private static int numIdsThisMilli = 0;
    private static final String alphaNum = "0123456789ABCDEF";
    private static String hostid = null;

    static 
    {
        try
        {
            System.loadLibrary("NeoUUID");
            long lHostid = getHostID();
            if(lHostid > 0L)
            {
                String rawHostid = Long.toHexString(lHostid).toUpperCase();
                if(rawHostid.length() > 12)
                    hostid = rawHostid.substring(rawHostid.length() - 12);
                else
                    hostid = rawHostid;
            }
        }
        catch(Throwable ex) { }
    }
}
