// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   JRunLoginCommand.java

package flex.messaging.security;

import flex.messaging.FlexContext;
import flex.messaging.util.PropertyStringResourceLoader;
import java.security.Principal;
import java.util.*;
import javax.management.*;
import javax.servlet.ServletConfig;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import jrun.security.JRunSecurityException;
import jrun.servlet.JRunServletContext;
import jrun.servlet.WebApplication;
import jrun.servlet.security.*;
import jrun.servlet.session.Session;
import jrunx.kernel.JRun;

// Referenced classes of package flex.messaging.security:
//            AppServerLoginCommand, SecurityException

public class JRunLoginCommand extends AppServerLoginCommand
{

    public JRunLoginCommand()
    {
    }

    public void start(ServletConfig servletConfig)
    {
        try
        {
            Class.forName("jrun.servlet.security.AuthenticatedUser");
            Class.forName("jrun.servlet.security.WebAppSecurityService");
            Class.forName("jrun.servlet.JRunServletContext");
        }
        catch(Throwable t)
        {
            SecurityException se = new SecurityException(new PropertyStringResourceLoader("flex.messaging.vendors"));
            se.setMessage(20050);
            throw se;
        }
        if(JRun.server != null)
            try
            {
                javax.servlet.ServletContext servletContext = servletConfig.getServletContext();
                String webAppName = ((JRunServletContext)servletContext).getWebApplication().getName();
                Set serviceMBeans = null;
                ObjectInstance mbean = null;
                ObjectName serviceName = new ObjectName("ServletEngineService." + webAppName + ":service=WebAppSecurityService");
                serviceMBeans = JRun.server.queryMBeans(serviceName, null);
                if(serviceMBeans != null)
                {
                    Iterator iterator = serviceMBeans.iterator();
                    if(iterator.hasNext())
                        mbean = (ObjectInstance)iterator.next();
                }
                if(mbean != null)
                {
                    Object securityService = JRun.server.invoke(mbean.getObjectName(), "getWebAppSecurity", null, null);
                    if(securityService instanceof WebAppSecurityService)
                        appSecurity = (WebAppSecurityService)securityService;
                }
                serviceName = new ObjectName("ServletEngineService:service=ServletUsersService");
                serviceMBeans = JRun.server.queryMBeans(serviceName, null);
                if(serviceMBeans != null)
                {
                    Iterator iterator = serviceMBeans.iterator();
                    if(iterator.hasNext())
                        mbean = (ObjectInstance)iterator.next();
                }
                if(mbean != null)
                {
                    Object usersService = JRun.server.invoke(mbean.getObjectName(), "getServletUsers", null, null);
                    if(usersService instanceof ServletUsers)
                        this.usersService = (ServletUsers)usersService;
                }
            }
            catch(MalformedObjectNameException ex)
            {
                SecurityException se = new SecurityException(new PropertyStringResourceLoader("flex.messaging.vendors"));
                se.setMessage(20051);
                se.setRootCause(ex);
                throw se;
            }
            catch(InstanceNotFoundException ex)
            {
                SecurityException se = new SecurityException(new PropertyStringResourceLoader("flex.messaging.vendors"));
                se.setMessage(20051);
                se.setRootCause(ex);
                throw se;
            }
            catch(MBeanException ex)
            {
                Exception e = ex.getTargetException();
                SecurityException se = new SecurityException(new PropertyStringResourceLoader("flex.messaging.vendors"));
                se.setMessage(20051);
                se.setRootCause(e);
                throw se;
            }
            catch(ReflectionException ex)
            {
                SecurityException se = new SecurityException(new PropertyStringResourceLoader("flex.messaging.vendors"));
                se.setMessage(20051);
                se.setRootCause(ex);
                throw se;
            }
            catch(NullPointerException npe)
            {
                SecurityException se = new SecurityException(new PropertyStringResourceLoader("flex.messaging.vendors"));
                se.setMessage(20051);
                se.setRootCause(npe);
                throw se;
            }
    }

    public Principal doAuthentication(String username, Object credentials)
        throws SecurityException
    {
        if(appSecurity == null)
            start(FlexContext.getServletConfig());
        try
        {
            AuthenticatedUser user = null;
            String password = extractPassword(credentials);
            if(password != null)
            {
                HttpServletRequest request = FlexContext.getHttpRequest();
                if(request != null)
                {
                    user = appSecurity.authenticate(username, password, request.getSession(true));
                } else
                {
                    javax.servlet.ServletContext servletContext = FlexContext.getServletConfig().getServletContext();
                    WebApplication webApp = ((JRunServletContext)servletContext).getWebApplication();
                    HttpSession tempSession = webApp.getSessionService().createSession("temp");
                    user = appSecurity.authenticate(username, password, tempSession);
                    tempSession.invalidate();
                }
                return user.getPrincipal();
            }
        }
        catch(Exception ex)
        {
            SecurityException se;
            if(ex instanceof SecurityException)
                se = (SecurityException)ex;
            else
            if(ex instanceof MBeanException)
            {
                ex = ((MBeanException)ex).getTargetException();
                se = new SecurityException();
                se.setMessage(10060);
                se.setRootCause(ex);
            } else
            if(ex instanceof JRunSecurityException)
            {
                se = new SecurityException();
                se.setMessage(10060);
                se.setRootCause(ex);
            } else
            {
                se = new SecurityException();
                se.setMessage(10061);
            }
            se.setCode("Client.Authentication");
            throw se;
        }
        return null;
    }

    public boolean doAuthorization(Principal principal, List roles)
        throws SecurityException
    {
        if(appSecurity == null)
            start(FlexContext.getServletConfig());
        boolean authorized = false;
        HttpServletRequest request = FlexContext.getHttpRequest();
        if(request != null)
        {
            authorized = doAuthorization(principal, roles, request);
        } else
        {
            int i = 0;
            do
            {
                if(i >= roles.size())
                    break;
                String role = (String)roles.get(i);
                if(appSecurity.isPrincipalInRole(principal, role))
                {
                    authorized = true;
                    break;
                }
                i++;
            } while(true);
        }
        return authorized;
    }

    public boolean logout(Principal principal)
        throws SecurityException
    {
        try
        {
            javax.servlet.ServletContext servletContext = FlexContext.getServletConfig().getServletContext();
            WebApplication webApp = ((JRunServletContext)servletContext).getWebApplication();
            HttpServletRequest request = FlexContext.getHttpRequest();
            HttpSession session = request.getSession();
            String sessionId = session.getId();
            AuthenticatedUser currentUser = usersService.getUser(sessionId, webApp);
            currentUser.logoff();
            return true;
        }
        catch(NullPointerException npe)
        {
            return false;
        }
    }

    public void stop()
    {
        usersService = null;
        appSecurity = null;
    }

    private WebAppSecurityService appSecurity;
    private ServletUsers usersService;
    private static final int AUTH_FAILED = 10060;
    private static final int SEC_MANAGER_REQ_FOR_AUTH = 10061;
    private static final int NO_SEC_MANAGER = 20050;
    private static final int NO_SEC_SRVC_OR_USERS = 20051;
}
